BeginPackage["Biokmod`Optdesign`"]

(* Version 1.0 *)

Optdes::usage=
"Optdes[R[t,],t,{{b1,b10},...,{bp,bp0}},t0,pho,sig, n, opts] being b1,...,bp the unknown parameters 
and b10,..., bp0 their initial values, t0 is the point were is takes the first measured;  sig is the 
standard deviation of the measurements and n is the number of the points(additional at t0) where we want 
take the next measurements, pho is the correlation between measurements, it is recomended takes pho = 1 ";


Begin["`Private`"]

Optdes[r_,t_,params_List,t0_,\[Rho]_?NumericQ,sig_,n_,opts___]:=
  Module[{\[Beta],initial,grad,s,vars,v,g,t1,d,tt,i,j,k,dd,ddd,X,
      ff,\[CapitalGamma],\[CapitalSigma],m,deter,bb},{\[Beta],initial}=
      Transpose[params];grad[s_,vars_List]:=Function[{v},D[s,v]]/@vars;
    g[t1_]=grad[r,\[Beta]]/.Thread[\[Beta]\[Rule]initial]/.t\[Rule]t1;
    tt=Table[Subscript[t,i],{i,0,n}];
    dd=Table[Subscript[d,i],{i,n}];Subscript[d,0]=t0;
    ddd=FoldList[Plus,Subscript[d,0],dd];
    X=g[ddd];
    ff[i_,j_]:=
      Which[i\[Equal]j,1,i<j,E^((-\[Rho])*Sum[Subscript[d,k],{k,i,j-1}]),i>j,
        E^((-\[Rho])*Sum[Subscript[d,k],{k,j,i-1}])];
    \[CapitalGamma]=Array[ff,{n+1,n+1}];\[CapitalSigma]=
      sig^2*\[CapitalGamma];
    m=X.Inverse[\[CapitalSigma]].Transpose[X];
    deter[(x_)?(VectorQ[#1,NumberQ]&)]:=Det[m/.Thread[dd\[Rule]x]];
    bb=NMaximize[{deter[dd],Thread[dd>1]},dd,opts];
    {bb[[1]],Thread[tt\[Rule]ddd/.Last[bb]]}]

Optdes[r_,t_,params_List,t0_,"NoCorrelation",sig_,n_,opts___]:=
  Module[{\[Beta],initial,grad,s,vars,v,g,t1,d,tt,i,j,k,dd,ddd,X,
      ff,\[CapitalGamma],\[CapitalSigma],m,deter,bb},{\[Beta],initial}=
      Transpose[params];grad[s_,vars_List]:=Function[{v},D[s,v]]/@vars;
    g[t1_]=grad[r,\[Beta]]/.Thread[\[Beta]\[Rule]initial]/.t\[Rule]t1;
    tt=Table[Subscript[t,i],{i,0,n}];
    dd=Table[Subscript[d,i],{i,n}];Subscript[d,0]=t0;
    ddd=FoldList[Plus,Subscript[d,0],dd];
    X=g[ddd];
    \[CapitalSigma]=sig^2*IdentityMatrix[n+1];
    m=X.Inverse[\[CapitalSigma]].Transpose[X];
    deter[(x_)?(VectorQ[#1,NumberQ]&)]:=Det[m/.Thread[dd\[Rule]x]];
    bb=NMaximize[{deter[dd],Thread[dd>1]},dd,opts];
    {bb[[1]],Thread[tt\[Rule]ddd/.Last[bb]]}]


End[]

Protect[Optdes];

Print["Optdesign, 1.0   2007-04-09"]

EndPackage[]



















































































































































































































































































































































































