(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   2527535,      48484]
NotebookOptionsPosition[   2500486,      47695]
NotebookOutlinePosition[   2503385,      47792]
CellTagsIndexPosition[   2503185,      47783]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
SysModel applied for solving compartmental and physiological models \
\>", "Chapter"],

Cell[TextData[{
 StyleBox["Author",
  FontWeight->"Bold"],
 ": Guillermo Sanchez:  ",
 StyleBox["guillermo@usal.es,",
  FontColor->RGBColor[0, 0, 1]],
 ButtonBox[" http://diarium.usal.es/guillermo",
  BaseStyle->"Hyperlink",
  ButtonData->{" http://diarium.usal.es/guillermo", None}]
}], "Text",
 CellChangeTimes->{{3.399280888499512*^9, 3.399280930930561*^9}, {
  3.3992810608042903`*^9, 3.3992810807608027`*^9}, {3.5823514768804874`*^9, 
  3.582351509863126*^9}}],

Cell["Last update:\t 2015-09-03 ", "Commentary",
 CellChangeTimes->{{3.39928025384801*^9, 3.399280259603493*^9}, {
  3.4228525171714554`*^9, 3.4228525382666454`*^9}, {3.422936332120079*^9, 
  3.422936340401223*^9}, {3.442218589593443*^9, 3.4422185944372244`*^9}, {
  3.479816247027495*^9, 3.4798162579804096`*^9}, {3.513395822423673*^9, 
  3.513395880159526*^9}, {3.582349675699993*^9, 3.5823496772351465`*^9}, {
  3.582350393286317*^9, 3.582350431357124*^9}, {3.592201984724801*^9, 
  3.5922020091022387`*^9}, {3.642760905538348*^9, 3.6427609227728596`*^9}, {
  3.650269774583865*^9, 3.6502697820526304`*^9}, {3.650598460353492*^9, 
  3.650598472041073*^9}}],

Cell[CellGroupData[{

Cell[BoxData["$Version"], "Input",
 CellLabel->"In[1]:="],

Cell[BoxData[
 FormBox["\<\"10.2.0 for Microsoft Windows (64-bit) (July 28, 2015)\"\>", 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280634116539*^9, 3.479966504699038*^9, 
  3.4799667130650377`*^9, 3.479967298410038*^9, 3.479968218225038*^9, 
  3.513396415876365*^9, 3.582349692809704*^9, 3.582351337415581*^9, 
  3.642760934991647*^9, 3.650269788771336*^9},
 CellLabel->"Out[1]="]
}, Open  ]],

Cell[CellGroupData[{

Cell["Introduction ", "SubsectionIcon"],

Cell[TextData[{
 "Here is introduced the compartmental analysis and it is shown how",
 StyleBox[" SysModel", "Input"],
 " can be applied for solving compartmental model ."
}], "Text",
 CellChangeTimes->{3.4799684408220377`*^9}],

Cell["We will need download these packages", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Biokmod`SysModel`\>\"", "]"}]], "Input",
 CellLabel->"In[2]:="],

Cell[BoxData[
 FormBox["\<\"SysModel, version 1.5.1   2013-11-12\"\>", 
  TraditionalForm]], "Print",
 CellChangeTimes->{3.6427609350697727`*^9, 3.65026978883384*^9},
 CellLabel->"During evaluation of In[2]:="]
}, Open  ]],

Cell["Help about SysModel can be obtained as usual", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\"\<Biokmod`SysModel`*\>\""}]], "Input",
 CellLabel->"In[3]:="],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Biokmod`SysModel`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Biokmod`SysModel`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["AcuteInput",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "AcuteInput", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["IsotopeChainData",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "IsotopeChainData", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["MultiExpInput",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "MultiExpInput", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["qMultiple",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "qMultiple", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["SystemNDSolve",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "SystemNDSolve", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"]},
        {
         ButtonBox["Catenary",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "Catenary", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["IsotopeChainPlot",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "IsotopeChainPlot", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["ParametricSystemNDSolve",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "ParametricSystemNDSolve", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["ShowODE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "ShowODE", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], ""},
        {
         ButtonBox["CoefMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "CoefMatrix", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["IsotopeDecayModes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "IsotopeDecayModes", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["qConstant",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "qConstant", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["SystemDSolve",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "SystemDSolve", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], ""},
        {
         ButtonBox["CompartMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "CompartMatrix", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["matrixExp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "matrixExp", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["qContinuous",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "qContinuous", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], 
         ButtonBox["SystemLTSolve",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-f444e7d7-bd98-4046-806c-1480e5f44602", {
            "SystemLTSolve", "Biokmod`SysModel`"}},
          ButtonNote->"Biokmod`SysModel`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.19]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6502697910525913`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Overview of Compartmental Analysis", "SubsectionIcon"],

Cell["\<\
Compartmental analysis has applications in clinical medicine, \
pharmacokinetics, internal dosimetry, nuclear medicine, ecosystem studies and \
chemical reaction kinetics.  It can be described as the analysis of a system \
in terms of compartments which separate the system into a finite number of \
component parts which are called compartments. Compartments interact through \
the exchange of species. Species may be a chemical substance, hormone, \
individuals in a population and so on.  A compartmental system is usually \
represented by a flow diagram or a block diagram. \
\>", "Text"],

Cell[TextData[{
 "We adopt the convention of  representing compartments with circles or \
rectangles. The flow into or out of the compartments is represented by \
arrows.  The ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["i", "th"], TraditionalForm]]],
 " compartment  of a system of ",
 StyleBox["n ",
  FontSlant->"Italic"],
 "compartments is Labeled ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " and the size (amount or content) of the component in compartment  ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " as ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["x", "i"],
     TraditionalForm], 
    FormBox[
     RowBox[{"(", 
      FormBox["t",
       TraditionalForm], ")"}],
     TraditionalForm]}], TraditionalForm]]],
 ". The exchange between compartments, or between a compartment and the \
environment is labeled ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ij"], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " represents the flow from ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 ". We can often write ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "i"], TraditionalForm]]],
 "  if compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " is not ambiguous with ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 ". The environment is usually represented by \"0\" (zero), so ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "i0"], TraditionalForm]]],
 " is the fractional excretion coefficient from the ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "-th compartment to the outside environment.  The  input from the \
environment into the ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 "-th compartment is called ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "j"], "(", "t", ")"}], TraditionalForm]]],
 ". Environment represents the processes that are outside the system. With \
regards to the environment, we only need to know the flow, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "j"], "(", "t", ")"}], TraditionalForm]]],
 ",  into the system from the outside. The ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ij"], TraditionalForm]]],
 " are called fractional transfer rate coefficients and they may be a \
function of different variables or constants. "
}], "Text",
 CellChangeTimes->{3.6505977437905717`*^9}],

Cell[TextData[{
 "The model of figure 1 consist in two compartments. There is an input",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["b", "i"],
      TraditionalForm], "(", "t", ")"}], " "}], TraditionalForm]]],
 " to compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " and an exchange of flow between compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 ", with transfer coefficients ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ij"], TraditionalForm]]],
 " from compartment ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 "  and  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ji"], TraditionalForm]]],
 "  from compartment ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 " to ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 ". The model has an output of system from competent ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " with a transfer coefficient ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "i0"], TraditionalForm]]],
 "."
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.12963 0.21164 0.333333 0.21164 [
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.12963 .65079 m
.12963 .43915 L
s
% Start of user PostScript
0 1.5 0 0.5 MAarrowhead1
% End of user PostScript
gsave
.21429 .54497 -77.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.12963 .33333 .10582 0 365.73 arc
s
gsave
.12963 .31217 -77.4375 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.12963 .3545 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.12963 .22751 m
.12963 .01587 L
s
% Start of user PostScript
0 -0.5 0 -1.5 MAarrowhead2
% End of user PostScript
gsave
.21429 .12169 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(i0) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.23545 .37566 m
.76455 .37566 L
s
% Start of user PostScript
0.5 0.2 3. 0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .41799 -70.625 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.625 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ij) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.76455 .29101 m
.23545 .29101 L
s
% Start of user PostScript
3. -0.2 0.5 -0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .24868 -70.625 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.625 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ji) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.87037 .33333 .10582 0 365.73 arc
s
gsave
.87037 .31217 -77.4375 -10.3125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.625 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(j) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.87037 .3545 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(j) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
 ImageSize->{288, 192},
 ImageMargins->{{0.6666666666666666, 0.}, {0., 
  4.}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztWltvG0UUnvgSO74kdkOahLSN7SRQkhaQ2rQUEG3FTX3gJ0Bq0lAbAQ1N
KpBA2h9U0vKeFh4RQvwH/gFI8IqWmW/jzTeze3a3biIFyQ+7OfOdy5y5nT1z
nI+6u72tL7u7/c1u68P73e1ef3On9cG9+xrKjyk11lNK/dVQmv5e5f9Qi77n
9z1fqax/X9WvvFKebhvsjQQsB61rpnXR8/OZWwUVWrng+cXMrXG0rkZba55f
slpltK6ktVY9f8JqVdBaj7aeYVZG2P8IW8DezNtSL7hSZ/RTCmjDMo+Rm3Hl
pnEmcrCZy6hjOisc0MaRHLmToDLgT6TLarJISC5lsJZD+tVK6j442OdEkaCP
dvxEaWrppGyEEXZ8WBhKq6CVWkb0ruD9D6J8Fe8Vw+xgb5wmOw+wh78BPoM3
ts0i4Hl8Tx6Q+NdA5sHF5j0LnRbeOySo/35BLOziBZDLJLWtn+LhQTYqIS/w
1YQH9SLBK4A/o2iQd4x8Dt7LpDNv8DnAqwTf8ezwEEQWLdQnofNAYGGW4DXA
d+i47tjckDazbU05L2M3MYRsEX2RaESiGQJeJ/o2j2qbGK8RjcgURIrLBG/Q
eMIVvEQC04Z1ioB1oj8h+iuiuQejq5oEXCH6Y/R3T+A2XdWrRP8u4A2j1CDg
GtG/CfiUUZoi4C2ifyX6zSSlt4n+RcAnjdIkAe/Yk62n40eBWzeqdQKu287o
8/9Y4EZUbxBdReL2WODWjGqNgJtElzy/PqSqPn5NW/Wm7RPiWAi8S/TPyjo0
zKok6ekuG0rtEfJekiozxz2/ZqvO4iCvugYqBMxBpGzPl3Wmabgl2/y83Xmq
hUjnkoEJojmzmIKzkgtFwcKMg1vM5iBm5+yskI3lI/FwmuifMlgr2LQmC8IQ
Iw6a2OSkizy/ZpPxd0ay+1QyWRDcdD9gPBye0bLrcBAg6o6Pccss+Tc9mD8N
jDsuxa1PBneKgmoW157YeM6OF0M5Za1ALYM/bG3f2Yi8O6T9m83Fsu1iuJWr
h70gbZOM7Av6FXuERXvXJbqx7GxD3vunha6XhAnlTjltKrmdrjjMOKV9x8k4
+bmkTm4Jxm6NlAK6hbTeXYtMqrwgnSQDHezGTgYzbXeX8nleEvp7bmMs+OQo
jT3NIHO8xtqI7zxb/CUNFp+5+DJyJHmf6Icw1hS4EdWO3RObKdnfrrYgmZiJ
PUQmVha4ifnfD8j/CsOopqWcUpa7hyy3KHCrKap1e1VvEI3cWsro91AjqGVV
vU70I9wjGgIX9wjp9vJoUFOI5UJ1qNvSUPeyoW6A0l2zjxPQFbgNV5XvsFzg
2BBkcM+V7thbkZT2NtGRm3b0in+XaM5WuvF3fanKsOGUY+NMbhIdKT4kVERi
arZ5lHxCoUgxhNOFC0R/OqDTCjScP7yCXrcSSzN3bfmQNo6Yq5I2cN5etsNR
7RLjJYiaApcpj3Fo13CPvM9jADn7Kw29M4A5zvaI/pboFiTPGqVzGN0CQn9Q
MPsOdFC0XzQibcCzeP9JtOnJODiOmKK/6X/jXQNivpZmQnRQ/hdvFCWP+Eeu
3MElSQXmBr9aBdnrwXwNuhkGH8y5U85fz8Jf45VOFXB+Hbl8NAKrnnyhlGQK
tsylrDInqRg+wo4OO5VYrdLPpKvBlRqpxKSfuqtXCQ50AVtMyXfraDVHPzXX
WjWsCBUOTqnleFKtRTAXG//Ljs04h7PYC8+x6+QzGHQqYM/tmolsyvW0mGnq
rVQtbt4cG8Jm4PQpbdudpEMzwo4P8zP+k40a+w+zRvmI\
\>"],ImageRangeCache->{{{135.938, 566.438}, {646.875, 360.375}} -> {-2.11129, \
2.38729, 0.0164924, 0.0164924}}],

Cell["Figure 1. A compartmental model.", "Text",
 CellTags->"fig 2"],

Cell[TextData[{
 "The compartmental system is represented mathematically in terms of \
quantities such as the concentration or amount of a compound presents in the \
system. In the fig. 2 ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox["x", "i"], "(", "t", ")"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "j"], "(", "t", ")"}], TraditionalForm]]],
 "  represent the quantities in compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["j", TraditionalForm]]],
 " at time ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 " since the input",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    SubscriptBox["b", "i"]}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", "t", ")"}], TraditionalForm]]],
 " started. These quantities are called the state variables of the system and \
their evolution in the time are usually differential equations. So the system \
of the figure 2 can be described as it follow:"
}], "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "i"], "'"}], 
     RowBox[{"(", "t", ")"}]}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       SubscriptBox["k", "i0"]}], " ", 
      RowBox[{
       SubscriptBox["x", "i"], "(", "t", ")"}]}], "-", 
     RowBox[{
      SubscriptBox["k", "ij"], " ", 
      RowBox[{
       SubscriptBox["x", "i"], "(", "t", ")"}]}], "+", 
     RowBox[{
      SubscriptBox["k", "ji"], " ", 
      RowBox[{
       SubscriptBox["x", "j"], "(", "t", ")"}]}], "+", 
     RowBox[{"b", " ", 
      RowBox[{"(", "t", ")"}]}]}]}], TraditionalForm]], "DisplayFormula"],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "j"], "'"}], 
     RowBox[{"(", "t", ")"}]}], "=", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "ij"], " ", 
      RowBox[{
       SubscriptBox["x", "i"], "(", "t", ")"}]}], "-", 
     RowBox[{
      SubscriptBox["k", "ji"], " ", 
      RowBox[{
       SubscriptBox["x", "j"], "(", "t", ")"}]}]}]}], TraditionalForm]], 
  "DisplayFormula"]
}], "Text"],

Cell["or in matrix notation", "Text"],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", GridBox[{
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "i"], "'"}], 
        RowBox[{"(", "t", ")"}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "j"], "'"}], 
        RowBox[{"(", "t", ")"}]}]}
     }], ")"}], " ", "=", 
   RowBox[{
    FormBox[
     RowBox[{"(", GridBox[{
        {
         RowBox[{
          RowBox[{"-", 
           SubscriptBox["k", "i0"]}], "-", 
          SubscriptBox["k", "ij"], " "}], 
         SubscriptBox["k", "ji"]},
        {
         SubscriptBox["k", "ij"], 
         RowBox[{"-", 
          SubscriptBox["k", "ji"]}]}
       }], ")"}],
     TraditionalForm], "+", 
    FormBox[
     RowBox[{"(", GridBox[{
        {
         RowBox[{"b", "(", "t", ")"}]},
        {"0"}
       }], ")"}],
     TraditionalForm]}]}], TraditionalForm]], "DisplayFormula"]], "Text"],

Cell["\<\
These models are System of Ordinary Differential Equation with Constant \
Coefficients (SODECC). \
\>", "Text"],

Cell[TextData[{
 "On many occasions we are interested in models where the inputs ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "t", ")"}], TraditionalForm]]],
 " are acute in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0"}], TraditionalForm]]],
 ", this is  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "0", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   FormBox[
    SubscriptBox["b", "i"],
    TraditionalForm], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "0", ")"}], TraditionalForm]]],
 " = 0 for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "\[NotEqual]", "0"}], TraditionalForm]]],
 ".  Another frequent situations are the ones  where the inputs ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "t", ")"}], TraditionalForm]]],
 " are continuous, this is  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "t", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   FormBox[
    SubscriptBox["b", "i"],
    TraditionalForm], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "\[GreaterEqual]", "0"}], TraditionalForm]]],
 " or  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["b", "i"],
     TraditionalForm], "(", "t", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   FormBox[
    SubscriptBox["b", "i"],
    TraditionalForm], TraditionalForm]]],
 " for  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "\[LessEqual]", "t", " ", "<", "T"}], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{3.650597750587408*^9}],

Cell[TextData[{
 ButtonBox["Figure 2",
  ButtonData:>"fig 2"],
 " shows a more complex compartmental model"
}], "Text"],

Cell[BoxData[
 GraphicsBox[{ArrowBox[{{0, 1.5}, {0, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(1\\)]\\)(t)\"\>", \
{-0.4, 1}, {0, -1}], CircleBox[{0, 0}, 0.5], 
   InsetBox["\<\"1\"\>", {0, 0}, {0, 0}], ArrowBox[{{0, -0.5}, {0, -1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(10\\)]\\)\"\>", \
{-0.3, -1}, {0, -1}], ArrowBox[{{0.5, 0.2}, {3, 0.2}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(12\\)]\\)\"\>", \
{1.75, 0.4}, {0, 0}], ArrowBox[{{3, -0.2}, {0.5, -0.2}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(21\\)]\\)\"\>", \
{1.75, -0.4}, {0, 0}], CircleBox[{3.5, 0}, 0.5], 
   InsetBox["\<\"2\"\>", {3.5, 0}, {0, 0}], 
   ArrowBox[{{3.5, 1.5}, {3.5, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(2\\)]\\)(t)\"\>", \
{3.9, 1}, {0, -1}], ArrowBox[{{3.5, -0.5}, {3.5, -1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(20\\)]\\)\"\>", {3.2, -1}, \
{0, -1}], ArrowBox[{{1.75, 4.5}, {1.75, 3.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(3\\)]\\)(t)\"\>", \
{1.3, 4}, {0, -1}], CircleBox[{1.75, 3}, 0.5], 
   InsetBox["\<\"3\"\>", {1.75, 3}, {0, 0}], 
   ArrowBox[{{0.1, 0.5}, {1.35, 2.7}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(13\\)]\\)\"\>", \
{0.5, 1.7}, {0, 0}], ArrowBox[{{1.65, 2.5}, {0.4, 0.35}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(31\\)]\\)\"\>", \
{1.25, 1.3}, {0, 0}], ArrowBox[{{2.15, 2.7}, {3.4, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(23\\)]\\)\"\>", \
{2.25, 1.3}, {0, 0}], ArrowBox[{{3.1, 0.35}, {1.85, 2.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(32\\)]\\)\"\>", {3, 1.7}, \
{0, 0}], ArrowBox[{{1.75, 2.5}, {1.75, 1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(30\\)]\\)\"\>", \
{1.6, 1.8}, {0, -1}], InsetBox["\<\"\[Lambda]\"\>", {2.6, 3.}, {0, -1}], 
   ArrowBox[{{2.25, 3}, {3.25, 3}}], 
   InsetBox["\<\"\[Lambda]\"\>", {-0.8, 0}, {0, -1}], 
   ArrowBox[{{-0.5, 0.}, {-1.5, 0.}}], 
   InsetBox["\<\"\[Lambda]\"\>", {4.4, 0}, {0, -1}], 
   ArrowBox[{{4., 0.}, {5., 0.}}]},
  AspectRatio->Automatic]], "Text",
 CellChangeTimes->{{3.3981418723165197`*^9, 3.398141901285084*^9}, 
   3.398141959737835*^9, 3.3981428994902678`*^9, 3.398149916236801*^9, 
   3.398150024205551*^9, 3.398150141346176*^9}],

Cell["\<\
Figure 2. The general multi-input multi-output (MIMO) three-compartment model.\
\>", "NumberedFigureCaption",
 CellTags->"fig 2"],

Cell["This model is represented by the following system of ODEs ", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      OverscriptBox["x", "."], "1"], "(", "t", ")"}], " ", "="}], 
   TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "1"], "(", "t", ")"}], " ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "10"], " ", "+", " ", 
       SubscriptBox["k", "12"], " ", "+", " ", 
       SubscriptBox["k", "13"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "21"], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "31"], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], " "}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      OverscriptBox["x", "."], "2"], "(", "t", ")"}], " ", "="}], 
   TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "2"], "(", "t", ")"}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "12"], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "20"], " ", "+", " ", 
       SubscriptBox["k", "21"], " ", "+", " ", 
       SubscriptBox["k", "23"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "32"], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      OverscriptBox["x", "."], "3"], "(", "t", ")"}], " ", "="}], 
   TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "3"], " ", 
     RowBox[{"(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "13"], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "23"], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "30"], " ", "+", " ", 
       SubscriptBox["k", "31"], " ", "+", " ", 
       SubscriptBox["k", "32"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], " "}]}], TraditionalForm]]]
}], "Text",
 TextAlignment->Left,
 TextJustification->0],

Cell["in matrix notation ", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      OverscriptBox[
       StyleBox["x",
        FontWeight->"Bold",
        FontSlant->"Plain"], "."],
      FontWeight->"Bold",
      FontSlant->"Plain"], "(", "t", ")"}], " ", "=", 
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["A",
        FontSlant->"Plain"], " ", 
       StyleBox["x",
        FontSlant->"Plain"]}],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], "+", " ", 
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}]}]}], ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], TraditionalForm]], "Text",
 TextAlignment->Left,
 TextJustification->0],

Cell["with", "Text"],

Cell[TextData[{
 StyleBox["x",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "2"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "3"], "(", "t", ")"}]}], "}"}], "T"]}], 
   TraditionalForm]]],
 " \n\n",
 StyleBox["b",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], " ", "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["b", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["b", "2"], "(", "t", ")"}], ",", 
       RowBox[{
        SubscriptBox["b", "3"], "(", "t", ")"}]}], "}"}], "T"], " "}], 
   TraditionalForm]]]
}], "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[TextData[{
 "where  ",
 StyleBox["A",
  FontWeight->"Bold"],
 " is given by"
}], "DisplayFormula",
 TextAlignment->Left,
 TextJustification->1],

Cell[BoxData[
 RowBox[{"A", "=", " ", 
  RowBox[{"(", GridBox[{
     {
      SubscriptBox["a", "11"], 
      SubscriptBox["a", "12"], 
      SubscriptBox["a", "13"]},
     {
      SubscriptBox["a", "21"], 
      SubscriptBox["a", "22"], 
      SubscriptBox["a", "23"]},
     {
      SubscriptBox["a", "31"], 
      SubscriptBox["a", "32"], 
      SubscriptBox["a", "33"]}
    }], ")"}]}]], "Text",
 TextAlignment->Left,
 TextJustification->0],

Cell["with", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["a", "11"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "10"], " ", "+", " ", 
      SubscriptBox["k", "12"], " ", "+", " ", 
      SubscriptBox["k", "13"]}], ")"}]}]}], " ", ";", 
  RowBox[{
   SubscriptBox["a", "12"], " ", "=", " ", 
   SubscriptBox["k", "21"]}], ";", 
  RowBox[{
   SubscriptBox["a", "13"], "=", " ", 
   SubscriptBox["k", "31"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["a", "21"], "=", 
   SubscriptBox["k", "12"]}], ";", 
  RowBox[{
   SubscriptBox["a", "22"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "20"], " ", "+", " ", 
      SubscriptBox["k", "21"], " ", "+", " ", 
      SubscriptBox["k", "23"]}], ")"}]}]}], "  ", ";", " ", 
  RowBox[{
   SubscriptBox["a", "23"], "=", 
   SubscriptBox["k", "32"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["a", "31"], "=", 
   SubscriptBox["k", "13"]}], ";", " ", 
  RowBox[{
   SubscriptBox["a", "32"], "=", " ", 
   SubscriptBox["k", "23"]}], ";", " ", 
  RowBox[{
   SubscriptBox["a", "33"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "30"], " ", "+", " ", 
      SubscriptBox["k", "31"], " ", "+", " ", 
      SubscriptBox["k", "32"]}], ")"}]}]}], ";"}]}], "Text",
 TextAlignment->Left,
 TextJustification->0],

Cell["\<\
If we suppose that the substance introduced into the system is a radioactive \
isotope we mush considered the radioactive decay, it is given by a constant \
rate represented by \[Lambda]. This constant is specific for each isotope. \
The decay constant can be interpreted by an equal flow going out of the \
system in each compartment. If we assume a radioactive decay in our example:\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["a", "11"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "10"], " ", "+", " ", 
      SubscriptBox["k", "12"], " ", "+", " ", 
      SubscriptBox["k", "13"], "+", " ", "\[Lambda]"}], ")"}]}]}], " ", ";", 
  RowBox[{
   SubscriptBox["a", "12"], " ", "=", " ", 
   SubscriptBox["k", "21"]}], ";", 
  RowBox[{
   SubscriptBox["a", "13"], "=", " ", 
   SubscriptBox["k", "31"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["a", "21"], "=", 
   SubscriptBox["k", "12"]}], ";", 
  RowBox[{
   SubscriptBox["a", "22"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "20"], " ", "+", " ", 
      SubscriptBox["k", "21"], " ", "+", " ", 
      SubscriptBox["k", "23"], "+", " ", "\[Lambda]"}], ")"}]}]}], "  ", ";", 
  " ", 
  RowBox[{
   SubscriptBox["a", "23"], "=", 
   SubscriptBox["k", "32"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["a", "31"], "=", 
   SubscriptBox["k", "13"]}], ";", " ", 
  RowBox[{
   SubscriptBox["a", "32"], "=", " ", 
   SubscriptBox["k", "23"]}], ";", " ", 
  RowBox[{
   SubscriptBox["a", "33"], "=", 
   RowBox[{"-", " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["k", "30"], " ", "+", " ", 
      SubscriptBox["k", "31"], " ", "+", " ", 
      SubscriptBox["k", "32"], "+", " ", "\[Lambda]"}], ")"}]}]}], 
  ";"}]}], "Text",
 TextAlignment->Left,
 TextJustification->0],

Cell[TextData[{
 "In some circumstances, a physiological model better a compartmental model \
is required, for example, when blood flow or other physiological parameter is \
measured. In those circumstances the transfer rate constants are associated \
with physiologically meaningful values that correspond to the measured \
physiological parameter or may be a function of them. However, if the \
physiological parameters are constants, a compartmental model and a \
physiological model are mathematically equivalent. But the form of the A \
matrix for the compartmental model compared with that for the physiological \
model will be different. For these cases we will directly give the values  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "ij"], TraditionalForm]]],
 " to the A matrix instead of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ij"], TraditionalForm]]],
 "."
}], "Text"],

Cell[TextData[{
 "The patterns that we have seen can be expanded to systems of ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " compartments or ",
 Cell[BoxData[
  FormBox["n", TraditionalForm]]],
 " state variables (in the case of physiological models). The equation for \
any compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " is given by"
}], "Text"],

Cell[BoxData[{
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      OverscriptBox[
       StyleBox["x",
        FontWeight->"Bold",
        FontSlant->"Plain"], "."],
      FontWeight->"Bold",
      FontSlant->"Plain"], "(", "t", ")"}], " ", "=", 
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["A",
        FontSlant->"Plain"], " ", 
       StyleBox["x",
        FontSlant->"Plain"]}],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], "+", " ", 
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}]}]}], ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], 
  TraditionalForm], "\[IndentingNewLine]", 
 FormBox[
  RowBox[{
   RowBox[{
    StyleBox["x",
     FontWeight->"Bold",
     FontSlant->"Plain"], "(", "0", ")"}], " ", "=", " ", 
   SubscriptBox[
    StyleBox["x",
     FontWeight->"Bold",
     FontSlant->"Plain"], "0"]}], TraditionalForm]}], "NumberedEquation",
 TextAlignment->Left,
 TextJustification->0,
 CellTags->"eq 1"],

Cell["where:", "Text",
 TextAlignment->Left,
 TextJustification->1],

Cell[TextData[{
 "x",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "2"], "(", "t", ")"}], ",", " ", "...", ",", 
       RowBox[{
        SubscriptBox["x", "n"], "(", "t", ")"}]}], "}"}], "T"]}], 
   TraditionalForm]]],
 " is a column vector and ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    SubscriptBox["x", "i"]}], TraditionalForm]]],
 "(t) denote the amount or content of species in compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " at time ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 ". "
}], "Text"],

Cell[TextData[{
 StyleBox["A",
  FontWeight->"Bold"],
 " is a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"n", "\[Cross]", "n"}], TraditionalForm]]],
 " is usually known as the compartmental matrix or system matrix. "
}], "Text"],

Cell[TextData[{
 StyleBox["b",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], " ", "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["b", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["b", "2"], "(", "t", ")"}], ",", "...", ",", 
       RowBox[{
        SubscriptBox["b", "n"], "(", "t", ")"}]}], "}"}], "T"], " "}], 
   TraditionalForm]]],
 "is a column vector where {",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "i"], "(", "t", ")"}], TraditionalForm]]],
 "} is the input rate into compartment ",
 Cell[BoxData[
  FormBox[
   RowBox[{"i", " "}], TraditionalForm]]],
 "from outside system. "
}], "Text"],

Cell[TextData[{
 StyleBox["x",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "0", ")"}], " "}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        FormBox[
         SubscriptBox["x", "1"],
         TraditionalForm], "(", "0", ")"}], ",", " ", 
       RowBox[{
        FormBox[
         SubscriptBox["x", "2"],
         TraditionalForm], "(", "0", ")"}], ",", "  ", "...", ",", " ", 
       RowBox[{
        FormBox[
         SubscriptBox["x", "n"],
         TraditionalForm], "(", "0", ")"}]}], "}"}], 
     FormBox[
      SuperscriptBox["", "T"],
      TraditionalForm]}]}], TraditionalForm]]],
 "are the initial conditions, so ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["x", "i"], "(", "0", ")"}], ","}], TraditionalForm]]],
 " represents the amount or content of species in compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " at time ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", "t"}], TraditionalForm]]],
 " = 0. "
}], "Text"],

Cell["\<\
SysModel.m provides a few functions to construct and solve Compartmental and \
Physiological models. Most of the examples are made using clearance rates, \
but also has been included some example of non linear models. The last \
example involved partial differential equations, it is solved using Laplace \
transform\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["One-compartmental Systems", "SubsectionIcon"],

Cell[CellGroupData[{

Cell["Easy one compartmental models", "SubsubsectionIcon"],

Cell["\<\
The easiest example of compartmental model is the decay of a single \
radioactive isotope.\
\>", "Text"],

Cell[BoxData[
 StyleBox[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .4 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.214286 0.380952 0.2 0.380952 [
[ 0 0 0 0 ]
[ 1 .4 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .4 L
0 .4 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
newpath
.21429 .2 .19048 0 365.73 arc
s
.40476 .2 m
.97619 .2 L
s
% Start of user PostScript
0.5 0 2. 0 MAarrowhead1
% End of user PostScript
gsave
.21429 .2 -75 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(x) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.000 12.750 moveto
(H) show
75.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.000 12.750 moveto
(L) show
87.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.69048 .2 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Picture",
   ImageSize->{260, 103.75},
   ImageMargins->{{0, 0}, {0, 17.3125}},
   ImageRegion->{{0, 1}, {0, 1}},ImageCache->GraphicsData["CompressedBitmap", 
   "\<\
eJy1l9lrE1EUxk8yTaqttjVucWtCrVvV2pZCVFSK1FZERURsxQXTNpqK1RKj
vgiDf4x/hE/u+wZuoKIWFwRBEARfx3vONfDNxLkTJ81DT7/8vnvvbHc5Z0+2
mM9NZIvjo9n0YCE7mR8fPZceOFtQyIoQRXYQ0eUWUvoSWVOUcmxnwHaIvP+3
2k6C6DfLjO3EiRISfzLotR2LqFXiDwbdItslfmfQKbJD4jcG62wnStQl8SuD
tSoo01bXox7BnxmvEZkBc4rxKsGbJQpYIXKbxA8M2qFLH+h3bLZJu36JAtIi
d0p8wyAFXXaBfs1mK4DdoF+xuQzAXtAv2VwKYB/oF2wuAbAf9HM2FwM4IPcp
eBHgIdDP2EwCOAT6aaC5EMBh0E/YXADgiNecD+AY6MdszgNwHPSjQHMugBHQ
D9lMABgD/YDNOQBOgL4faLYAyIO+F2g2AzgF+m6g2QTgNOg7bM4GMGEyz4C+
HWjOAjAJ+lZ1ZiOAAuib1ZkNAIqgb0yfeR709erMmQAu1Ma8CPpadeYMAJtA
14PuAX1FNqKkt+tG0Hi9bnfXuF7zrq7rZcSoxDrgdXJ0IOlyD9agl6RrsE7u
+FdTDAxL/cW0Zkt++4zbpGe5a9wNcntxz4AlHXMPdlW/8/AD4N0068VR+VNW
MGaj3pIq+gyKxIyfoV5v1b7TIer+pn5Tw9JH0H9PSOMUP1h6KAVGTEtsGN/o
WFBL0WoS5QIaWsFNQly19Cx+u9Aw6Jyp4ZC8nZPeJtO4xdboQKjR8RX+PDWa
xgPeaBrzhvC5Svj8yJh2GU1jNmfMA43pJSamR01mWdZqzHeNmbIxAfdJ2o2J
vrFEMBYXxrIkBaCsoEl7y582aNEPWszlALaDfmvruksN0ifxPYOVIrdI/Mhg
tUjczQV3AOiVJp9sXRdaUiiq+MX+VylZVmyWlaMZkUmJUrCqwjFJ9Iul41Pv
UuQPvyLppw==\
\>"],ImageRangeCache->{{{92.625, 351.625}, {303.375, 200.625}} -> {-1.51992, 
   1.5252, 0.0102191, 0.0102191}}],
  TextAlignment->Center]], "NumberedFigure"],

Cell[TextData[{
 "Let ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " be the number of isotope present in a sample at time ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 "  and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " the number present at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 ". The number of atoms decaying per unit of time is directly proportional \
present at time ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 ", being  ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " the constant of proportionality. Then ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "(", "t", ")"}], TraditionalForm]]],
 " is given by the first order linear differential equation"
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   FractionBox[
    RowBox[{"\[DifferentialD]", "x"}], 
    RowBox[{"\[DifferentialD]", "t"}]], "=", " ", 
   RowBox[{
    RowBox[{"-", " ", "k"}], " ", "x", " ", 
    RowBox[{"(", "t", ")"}]}]}], TraditionalForm]], "NumberedEquation"],

Cell[TextData[{
 "Eq.(2) can be evaluated using ",
 StyleBox["DSolve ", "DisplayMath",
  FontFamily->"Courier New"],
 "which gives the solution in analytical form. Initial conditions x",
 StyleBox["[0]", "MR"],
 " ",
 StyleBox["==", "MR"],
 " ",
 StyleBox["x0 ", "MR"],
 "can have been added."
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1", " ", "=", " ", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", "k"}], " ", 
        RowBox[{"x", "[", "t", "]"}]}]}], ",", 
      RowBox[{
       RowBox[{"x", "[", "0", "]"}], "\[Equal]", "x0"}]}], "}"}], ",", 
    RowBox[{"x", "[", "t", "]"}], ",", "t"}], "]"}]}]], "Input",
 CellLabel->"In[4]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "(", "t", ")"}], "\[Rule]", 
     RowBox[{"x0", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "k"}], " ", "t"}]]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280635790008*^9, 3.479966506879038*^9, 
  3.479966719011038*^9, 3.479967304177038*^9, 3.479968220107038*^9, 
  3.513396417985794*^9, 3.5823496950659294`*^9, 3.582350033177737*^9, 
  3.582351339425742*^9, 3.6427609357260265`*^9, 3.6502697912869673`*^9},
 CellLabel->"Out[4]="]
}, Open  ]],

Cell[TextData[{
 "If  we know the values of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 ", for instant",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"k", " ", "=", " ", "0.1"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{"x", " "}], "0"], "=", " ", "100"}], TraditionalForm]]],
 " with appropriated units, we can replace them in the previous expression to \
obtain ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", "(", "t", ")"}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{3.650597759071735*^9}],

Cell[TextData[{
 StyleBox["%", "MR"],
 " gives the last result generated in the before output and ",
 StyleBox["expr",
  FontSlant->"Italic"],
 " /.  ",
 StyleBox["rules", "TI"],
 " gives a rule of replacement  to be applied on expression ",
 StyleBox["expr", "TI"],
 ". "
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"k", "\[Rule]", "0.1"}], ",", " ", 
    RowBox[{"x0", "\[Rule]", " ", "100"}]}], "}"}]}]], "Input",
 CellLabel->"In[5]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "(", "t", ")"}], "\[Rule]", 
     RowBox[{"100", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1`"}], " ", "t"}]]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280635930767*^9, 3.4799665070580378`*^9, 
  3.479966719727038*^9, 3.479967304262038*^9, 3.479968220140038*^9, 
  3.5133964180326705`*^9, 3.5823496951079335`*^9, 3.5823500333307524`*^9, 
  3.5823513394682455`*^9, 3.642760935757278*^9, 3.6502697913182163`*^9},
 CellLabel->"Out[5]="]
}, Open  ]],

Cell[TextData[{
 "In many occasions it is better build a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " are parameters. They can be replaced with their values when ever it is \
necessary."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "[", " ", 
   RowBox[{"t_", ",", " ", "x0_", ",", " ", "k_"}], "]"}], "=", 
  RowBox[{
   RowBox[{"x", "[", "t", "]"}], "/.", 
   RowBox[{"eq1", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellLabel->"In[6]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"x0", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "k"}], " ", "t"}]]}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806359620466`*^9, 3.479966507169038*^9, 
  3.479966719785038*^9, 3.479967304576038*^9, 3.479968220179038*^9, 
  3.5133964180795465`*^9, 3.582349695210944*^9, 3.582350033389758*^9, 
  3.582351339510749*^9, 3.6427609357885284`*^9, 3.6502697913807173`*^9},
 CellLabel->"Out[6]="]
}, Open  ]],

Cell[TextData[{
 "Now we can replace k and x",
 Cell[BoxData[
  FormBox[
   SubscriptBox["", "0"], TraditionalForm]]],
 " with their values or ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"k", " ", "=", " ", "0.1"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{"x", " "}], "0"], "=", " ", "100"}], TraditionalForm]]],
 " "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "[", 
  RowBox[{"t", ",", "0.1", ",", "100"}], "]"}]], "Input",
 CellLabel->"In[7]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"0.1`", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "100"}], " ", "t"}]]}], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280635977687*^9, 3.479966507277038*^9, 3.479966719846038*^9, 
   3.479967304676038*^9, 3.479968220210038*^9, 3.513396418110797*^9, 
   3.582349695277951*^9, {3.5823500161210318`*^9, 3.582350033442764*^9}, 
   3.582351339549502*^9, 3.6427609358041525`*^9, 3.6502697913963437`*^9},
 CellLabel->"Out[7]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples of exponential decay", "SubsubsectionIcon"],

Cell[TextData[{
 "Example 1.- Cobalt 60 is a radioactive isotope whose half-life is 5.3 year. \
It is used in medicine as a radiation source to kill cancer cells using \
gamma-emissions from cobalt 60. As it is radioactive its activity decreases \
with the time and the source must be changed periodically according to the \
expression above obtained ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"x", "(", "t", ")"}], " ", "=", " ", 
    RowBox[{
     SubscriptBox["x", "0"], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "k"}], " ", "t"}]]}]}], TraditionalForm]]],
 ", where",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", "k"}], TraditionalForm]]],
 " is called the disintegration constant or transformation constant."
}], "Text"],

Cell[TextData[{
 "We are interested in evaluate the disintegration constant of ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["", "60"], TraditionalForm]]],
 "Co. A half-life (",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 ") of 5.3 year means that the radioactivity decrease to the half every 5.3 \
year, this is: if the activity is ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0", " "}], TraditionalForm]]],
 "after  a time ",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 " the activity will be ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "0"], "/", "2"}], TraditionalForm]]],
 ".  Therefore we can calculate ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " doing ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"x", "(", "t", ")"}], " ", "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["x", "0"], "/", "2"}], "  ", "and", " ", "t"}], "=", " ", 
     "T"}]}], TraditionalForm]]],
 "  in expression  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"x", "(", "t", ")"}], " ", "=", " ", 
    RowBox[{
     SubscriptBox["x", "0"], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "k"}], " ", "t"}]]}]}], TraditionalForm]]],
 ". "
}], "Text"],

Cell[TextData[{
 "We use the function",
 StyleBox[" x[t, x0, k] ", "DisplayMath"],
 "before defined"
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq", "=", " ", 
  RowBox[{"Solve", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", " ", 
      RowBox[{"T", ",", " ", "x0", ",", " ", "k"}], "]"}], " ", "\[Equal]", 
     " ", 
     RowBox[{"x0", "/", "2"}]}], " ", ",", " ", "k", ",", "Reals"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.5823500106774874`*^9},
 CellLabel->"In[8]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"k", "\[Rule]", 
     FractionBox[
      RowBox[{"log", "(", "2", ")"}], "T"]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806364781637`*^9, 3.479966507828038*^9, 3.479966720094038*^9, 
   3.4799673051560383`*^9, 3.479968220541038*^9, 3.513396418376429*^9, 
   3.582349695477971*^9, {3.5823500169251122`*^9, 3.582350033773797*^9}, {
   3.5823500651339326`*^9, 3.5823500901174307`*^9}, 3.5823513398095226`*^9, 
   3.6427609364447837`*^9, 3.650269791896344*^9},
 CellLabel->"Out[8]="]
}, Open  ]],

Cell[TextData[{
 "This solution is applicable not only to the cobalt 60. It is a general \
relationship between ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 "."
}], "Text"],

Cell[TextData[{
 "We replace ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " with its solution. We call it ",
 StyleBox["TransConst ", "DisplayMath"],
 "in order to be used later. "
}], "Text"],

Cell["\<\
We use %%[[1]] to indicate to extract the result from two outputs before\
\>", "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TransConst", " ", "=", " ", 
  RowBox[{"k", "/.", 
   RowBox[{"eq", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5823500836977887`*^9, 3.582350098923311*^9}},
 CellLabel->"In[9]:="],

Cell[BoxData[
 FormBox[
  FractionBox[
   RowBox[{"log", "(", "2", ")"}], "T"], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280636540723*^9, 3.479966508034038*^9, 3.479966720489038*^9, 
   3.479967305445038*^9, 3.4799682205910378`*^9, 3.5133964184233055`*^9, 
   3.5823496955889816`*^9, {3.582350058526272*^9, 3.5823500994753666`*^9}, 
   3.582351339847026*^9, 3.64276093671041*^9, 3.6502697919275937`*^9},
 CellLabel->"Out[9]="]
}, Open  ]],

Cell[TextData[{
 "As ",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 " is 5.3 year for Cobalt 60, and calling k = kCo60 "
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kCo60", " ", "=", " ", 
  RowBox[{"TransConst", "/.", 
   RowBox[{"T", "\[Rule]", "5.3"}]}]}]], "Input",
 CellLabel->"In[10]:="],

Cell[BoxData[
 FormBox["0.1307824868981029`", TraditionalForm]], "Output",
 CellChangeTimes->{3.399280636556363*^9, 3.4799665081450377`*^9, 
  3.4799667205710382`*^9, 3.4799673055580378`*^9, 3.479968220628038*^9, 
  3.5133964184701815`*^9, 3.582349695643987*^9, 3.58235010835375*^9, 
  3.5823513398845286`*^9, 3.642760936741661*^9, 3.6502697919432187`*^9},
 CellLabel->"Out[10]="]
}, Open  ]],

Cell[TextData[{
 "We can evaluate how the ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["", "60"], TraditionalForm]]],
 "Co as function of time  decrease. So if we have 10 g of  ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["", "60"], TraditionalForm]]],
 "Co in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0"}], TraditionalForm]]],
 ", it will decrease as it follows."
}], "Text"],

Cell["\<\
We replace x0 with its value and using Plot we represent the evolution of \
Cobalt 60 in the time.\
\>", "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"x", "[", 
    RowBox[{"t", ",", "10", ",", "kCo60"}], "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[11]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVkH8803kcx8caYZIfQ8OMCa2arW911SM+b3W1XLii0u9S7Ag5P65fnF9p
mlDZxVmFyknX0UXXRU47P87PrRJXunYrync3YszyYzs798fr8frv+Xw9Xi5H
YoPCDQkEQsBc/u/rKUeMOGFXfazKbEf0egYU7x1eF0I/jYp7xuXvtQzoC8iO
p9MF6M3b/Dsdkww4yd2zgEQvQkGRMU3fjzJgczPsn3S+gzx8H5KRnAGVGSvP
qpxrUQWB9LSmgQHvQqtsPzq3o5FWuXx9CgOStkcdHnLuQ/YHaHVNelcwmb7a
Hs1SIsw72D9uygXiGlNzhuPVaPS2oC/RwgVYZcLnD6qmUbBfXG3qajp8CIxw
lK8hAEva2lpWRYNCKt/pxmEiEP3Lg35nOMHa+Ef3iF1GkJzamMnOc4Cml1e3
xXqYwmID0WdnKFTg5Mz62PuZw7XXzGzvNnvgDq6Ts0MWwreR829VxNkBvvzh
polhS7BQVp/J22ALSToBVn/GGmq4nUNcTwoYWyoidzApEC0srZeQbIAkIXHN
frOF/k3bCnvmWYNWWhmdHzfHZSV+91RnCR9CqhbRaFSw8t08kGNsCb7nj8e0
VTqAVNT6VMRaCFdmH5lsPOQEFk9eSrTFC2CfY5P/GzUNfLN7a1bYmANZvHTY
dScdaF71zT0pZhC+6qZmzzIXcNskuxVsZAonU04F0TUuoHi56vLG2vlwTil8
IZW6QlN8f6fqiDH4My0qyCIGbGs387RYaQS5lavF/qFuEN1LCTSgkqAj+JYu
ce1i+CmT+Lx7kghiSWzOMqI7yHfReqmThlB9LB26ZO7wboIcGDFqALStaM3x
Bx7Qd05rfWKGABv1+8+WJHtCVml3XrsLAcL+fDL+aOcS4DHprwz5s8gnPeOX
UDoTOgQ3KRKtDuXHjj0m40zYfdsEfszRov60HwZLGpbCwefbRVKrGTQUXhvW
mLUMdtQnFwiap5AqxspYErocXsuLCsxjJlGVX6eOt5wFJTK23tX7ExqMYK8m
alhwfgOW4eqqQdS7r4VZEi8wsXMUm+nV6Ozh+JuSrWzovTGVmvnvOJrULcrd
WsuGXafKismaMeT5uLCow40DKZ1TIzy9Cq062vKlpYADs1QzS6q7ComvUey7
NBxIUz4pScwdQZ5iSnbgvhUwb3qx2svwIwogDTt1N6wAdt0hJ9v8IaT6631T
OxODmfBBZZCdEsVey7UWXMRgWoT97NOmQF0GbqNfXMYg6m3C9txGBWJ+VddB
FmLw6l2Sr6xegd5z8PRLBRhk5twjp99XoN2toCq8jsGO88B9JVKgDePqrvK7
GHhYO5i2xCiQ7Za9/OZWDNIc+6qv2ChQQqUqlN+OwYmUsCJzCwV6ZpXlvaVz
bk/R+ha+iQJdkNVMdEoxsPGoGEqexREhwfzoi14M+pI+jzqlwJHyuhj1D8z5
kGDibj2OuMQQh7IPGERnzJLX/IqjsoiPn8JxDPYNOPJa7uPoEEat+keJgVsU
q2+gHEc9bQmOY2Nz/PWiOq/LOOKwTKeq1RjISgOetVzAUZ6w9EWiBoNjNQfd
DvBx5HdQkj01hcHbyG/4F5NwVN50lFc3g0G3ViFknsDRvCUzvsm6uT/sCv7+
42scheZdcvKZxUAlw3hhUThqULtP6/UY1KWdZhJ5OPoPnGo+4A==
      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 20}, {0., 9.999999466193945}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806370411997`*^9, 3.479966508305038*^9, 
  3.479966720951038*^9, 3.479967306160038*^9, 3.479968220684038*^9, 
  3.5133964185326834`*^9, 3.582349695781001*^9, 3.5823501132528925`*^9, 
  3.582351339997038*^9, 3.64276093683541*^9, 3.650269792052597*^9},
 CellLabel->"Out[11]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example of iodine ", "SubsubsectionIcon"],

Cell["\<\
5 MBq of I-131 (Half-life 8.07 days) is needed for a diagnostic test.They are \
3 days between shipment of radioiodine and its use in the test. How many MBq \
must be shipped?\
\>", "Text",
 CellChangeTimes->{3.65059778768089*^9}],

Cell[TextData[{
 "The equation to resolve is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", " ", "=", " ", 
    RowBox[{
     SubscriptBox["x", "0"], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "k"}], " ", "t"}]]}]}], TraditionalForm]]],
 " where ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox["x",
     TraditionalForm], " ", "=", " ", "5"}], TraditionalForm]]],
 " MBq and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "3", " "}], TraditionalForm]]],
 "days, ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " is disintegration or transformation constant of I-131 and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 " is the variable to be calculated."
}], "Text",
 CellChangeTimes->{{3.6505978169307766`*^9, 3.6505978479149747`*^9}}],

Cell["The transformation constant of I-131 is ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"kI131", " ", "=", 
  RowBox[{"TransConst", "/.", 
   RowBox[{"T", "\[Rule]", "8.07"}]}]}]], "Input",
 CellLabel->"In[12]:="],

Cell[BoxData[
 FormBox["0.08589184393555703`", TraditionalForm]], "Output",
 CellChangeTimes->{3.399280637150679*^9, 3.479966508483038*^9, 
  3.479966721135038*^9, 3.4799673062480383`*^9, 3.479968220705038*^9, 
  3.5133964185639343`*^9, 3.5823496958170047`*^9, 3.5823501215898094`*^9, 
  3.582351340078294*^9, 3.642760936851036*^9, 3.6502697923025937`*^9},
 CellLabel->"Out[12]="]
}, Open  ]],

Cell[TextData[{
 "We replace",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", "t"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox["x", TraditionalForm]]],
 " with their values. "
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Solve", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", " ", 
      RowBox[{"3", " ", ",", " ", "x0", ",", "kI131"}], " ", "]"}], " ", 
     "\[Equal]", "  ", "5"}], " ", ",", " ", "x0"}], "]"}]}]], "Input",
 CellLabel->"In[13]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"x0", "\[Rule]", "6.469594574862883`"}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280637181959*^9, 3.479966508890038*^9, 
  3.479966721283038*^9, 3.479967307089038*^9, 3.4799682207410383`*^9, 
  3.513396418688937*^9, 3.5823496965670795`*^9, 3.5823501217535725`*^9, 
  3.582351340115797*^9, 3.642760936882286*^9, 3.650269792333844*^9},
 CellLabel->"Out[13]="]
}, Open  ]],

Cell["Therefore should be shipped 6.47 MBq ", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Example of irradiation of a cell population", "SubsubsectionIcon"],

Cell[TextData[{
 "In a experiment where a cell population is irradiated the survival of cells \
is given by eq.(1) with ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]]],
 " = 1 ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    StyleBox["days",
     FontSlant->"Plain"], 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ", and we are interested in calculating ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 " for a specific value ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "1"], TraditionalForm]]],
 " = 20% of initial population ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "0"], TraditionalForm]]],
 ". "
}], "Text"],

Cell[TextData[{
 "We use ",
 StyleBox["Solve", "Input",
  FontFamily->"Courier New",
  FontWeight->"Plain"],
 StyleBox[" ",
  FontFamily->"Courier New"],
 "to obtain ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.5823502919381833`*^9, 3.5823503001380033`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "/.", 
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "[", 
        RowBox[{"t", ",", "100", ",", "1"}], " ", "]"}], "\[Equal]", " ", 
       "20"}], ",", "t", ",", "Reals"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{
  3.582350182008191*^9, {3.5823502326922593`*^9, 3.5823502711161013`*^9}, {
   3.5823503034333324`*^9, 3.582350334556445*^9}},
 CellLabel->"In[14]:="],

Cell[BoxData[
 FormBox["1.6094379124341003`", TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280637228879*^9, 3.4799665091630383`*^9, 3.4799667214650383`*^9, 
   3.479967308082038*^9, 3.479968220834038*^9, 3.513396418720188*^9, 
   3.582349696702093*^9, 3.58235018559655*^9, 3.582350237439734*^9, 
   3.582350272129203*^9, {3.5823503039613857`*^9, 3.582350335102499*^9}, 
   3.5823513402395573`*^9, 3.6427609370385375`*^9, 3.650269792458869*^9},
 CellLabel->"Out[14]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Isolated organ", "SubsubsectionIcon"],

Cell[TextData[{
 "The following figure represents an isolated organ of constant volume with a \
liquid, with a dissolved drug,  flowing through the organ with a constant \
inflow and outflow rates ",
 StyleBox["v.",
  FontSlant->"Italic"],
 " "
}], "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .25 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.238095 0.125 0.238095 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
newpath
.5 .125 .11905 0 365.73 arc
s
.02381 .125 m
.38095 .125 L
s
% Start of user PostScript
0 0 1.5 0 MAarrowhead1
% End of user PostScript
gsave
.20238 .125 -72.375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
75.750 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
81.750 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.61905 .125 m
.97619 .125 L
s
% Start of user PostScript
2.5 0 4. 0 MAarrowhead2
% End of user PostScript
gsave
.5 .125 -75 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.000 12.750 moveto
(H) show
75.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.000 12.750 moveto
(L) show
87.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.79762 .125 -72.375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(v) show
75.750 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(c) show
81.750 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
 ImageSize->{288, 72},
 ImageMargins->{{0.75, 0}, {0, 0.5}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzFV9tqE1EU3ZkkbW1T0ryIja0WJIoUEU3rvZdQtIjE4qtvoQgJIkotCCIO
4ou9362ttTexCuo/+Sfj2Uti1iTOJfNiHnYWa52zzsk+e87sFEvT5UdPStOV
yVLf+FTpWbky+bzvztMpQ8VjIrGyiDzsEoNfSfyXnHZsp2I7IvXfP2wnLfJT
4TfbSYikbScJLHJkO5bICcQjJQ4xosd24iKfldiHdgbxQIldwHOIe0rsAPYj
flLiowlmum02IBcIb6u4TcRFwlsqbhFxifAHFTexwiAiiPc04irhDRU3iLhO
eF3FdSJuEl5TcY2IIcKrgeIK9lZABLFMI8YILwWKS0TcJrwYKC4SMU54IVBc
IOIu4flAcZ6Ie4TnAsU5IoqEZ5sS7xOeCRRniZhoSpwh4gHhd/9LfIEHNU30
WcKthE8RfoxZWTV4iee9g8Qc4WOEe90GrSLH1eA1LpMWErOwZCaO9ZLE9LjN
UiIZNXuLqRaJ3YQtt6WLT/7BaiIJ74W6RDp1jPlhb0ROktjmsVCL28zMag/e
aUizf+2sMZ9qnKj+PMudx5Dm1fw2nnYWR4N0iq7DayV9z6xaAI0lmKs7Dy7D
uiqqliEXeZgKRvGPIh0diNg5Plc8npcBjOtEBgq16SlELqe8r0HKI/vDajlS
S587zVYI/7zX5LHQ1gOEJ+p4b+thD7e2htR4+ee9HVylO6rLDeHYLcS/F4w5
OKNfo7l8bV+mKe3uitW8uMbe8PDABV7ENm4R3dxLJ/qLLvrLNfoLPXoTEb1x
WSGiQHg5UFzF2YwgohHz7dJ8Rd/mz7dt3CRikLBO0q7T7C2PiH7Vt5n1bYN3
iOgnrJO0izYrnEfcVWIPMIe4r8QBrrFexEMlvkDrrjXyX6FlENHqf7edDP4M
NP5DkNhvKenCOQ==\
\>"],ImageRangeCache->{{{192.563, 623.063}, {820.688, 714.188}} -> {-2.02073, \
6.51636, 0.0147889, 0.0147889}}],

Cell[TextData[{
 "Let ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "t", ")"}], TraditionalForm]]],
 " be concentration of the a drug in the organ. Let",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"b", "(", "t", ")"}]}], TraditionalForm]]],
 " be the drug concentration in the liquid flowing into the organ. We assume \
a uniform and instantaneous mixing in the organ. The liquid enters with a ",
 StyleBox["v",
  FontSlant->"Italic"],
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"b", "(", "t", ")"}]}], TraditionalForm]]],
 "  rate and leave with a ",
 Cell[BoxData[
  FormBox[
   RowBox[{"v", " ", "x"}], TraditionalForm]]],
 " rate.  We can describe the process as follows: In the instant t the \
concentration is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "t", ")"}], TraditionalForm]]],
 ", a later instant dt the variation of concentration in the organ will be: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "+", " ", 
    StyleBox["dc",
     FontSlant->"Italic"], " "}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[" ", TraditionalForm]]],
 " =  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"V", " ", 
    FormBox["c",
     TraditionalForm]}], TraditionalForm]]],
 " (drug in the organ in t) +",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"c", " ", "v", " ", 
     StyleBox["dt",
      FontSlant->"Italic"]}]}], TraditionalForm]]],
 " (drug flowing organ) - ",
 Cell[BoxData[
  FormBox[
   RowBox[{"q", " ", "v", " ", 
    StyleBox["dt",
     FontSlant->"Italic"]}], TraditionalForm]]],
 " (drug outflowing of the organ). Hence "
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{"V", "  ", 
     RowBox[{"c", "'"}], 
     RowBox[{"(", "t", ")"}]}], "=", " ", 
    RowBox[{"\[Nu]", "[", 
     RowBox[{
      RowBox[{"b", "(", "t", ")"}], "-", 
      RowBox[{"c", "(", "t", ")"}]}], "]"}]}]}], 
  TraditionalForm]], "NumberedEquation"],

Cell[TextData[{
 "Let's consider the case for which the flowing concentration ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     RowBox[{"b", "(", "t", ")"}],
     TraditionalForm], " ", "=", " ", "b"}], TraditionalForm]]],
 " constant for and interval ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", 
    FormBox[
     RowBox[{"t", "<", "T"}],
     TraditionalForm]}], TraditionalForm]]],
 " , and  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     RowBox[{"b", "(", "t", ")"}],
     TraditionalForm], " ", "=", "0"}], TraditionalForm]]],
 " since  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", ">", "T"}], TraditionalForm]]],
 ",   "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq2", " ", "=", " ", 
   RowBox[{
    RowBox[{"V", "  ", 
     RowBox[{
      RowBox[{"c", "'"}], "[", "t", "]"}]}], "==", " ", 
    RowBox[{"\[Nu]", 
     RowBox[{"(", 
      RowBox[{"b", "-", 
       RowBox[{"c", "[", "t", "]"}]}], ")"}]}]}]}], ";"}]], "Input",
 CellLabel->"In[15]:="],

Cell[TextData[{
 "Let ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "0", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "0"], TraditionalForm]]],
 " be the concentration drug in the organ at ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox["t",
     TraditionalForm], " ", "=", " ", "0"}], TraditionalForm]]],
 ".  "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"eq2", ",", " ", 
     RowBox[{
      RowBox[{"c", "[", "0", "]"}], "\[Equal]", "c0"}]}], "}"}], ",", " ", 
   RowBox[{"c", "[", "t", "]"}], ",", " ", "t"}], "]"}]], "Input",
 CellLabel->"In[16]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[Nu]", " ", "t"}], "V"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{"\[Nu]", " ", "t"}], "V"]]}], "-", "b", "+", "c0"}], 
       ")"}]}]}], "}"}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806373852777`*^9, 3.479966509725038*^9, 
  3.479966721661038*^9, 3.479967308271038*^9, 3.479968220909038*^9, 
  3.5133964187826896`*^9, 3.5823496967741003`*^9, 3.582350359431932*^9, 
  3.582351340310813*^9, 3.6427609370854125`*^9, 3.650269792521346*^9},
 CellLabel->"Out[16]="]
}, Open  ]],

Cell["We simplify c(t) and define  c1[t] in order to be used later", "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c1", "[", "t_", "]"}], "=", 
  RowBox[{
   RowBox[{"c", "[", "t", "]"}], "/.", 
   RowBox[{
    RowBox[{"FullSimplify", "[", "%", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellLabel->"In[17]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c0", "-", "b"}], ")"}], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[Nu]", " ", "t"}], "V"]}]]}], "+", "b"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806386677494`*^9, 3.479966510055038*^9, 
  3.479966721935038*^9, 3.479967308773038*^9, 3.479968221179038*^9, 
  3.5133964191108227`*^9, 3.582349697126136*^9, 3.582350359666956*^9, 
  3.582351340614587*^9, 3.6427609371947885`*^9, 3.650269792615095*^9},
 CellLabel->"Out[17]="]
}, Open  ]],

Cell[TextData[{
 "If we know ",
 Cell[BoxData[
  FormBox["V", TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "0"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", ","}], TraditionalForm]]],
 " we can replace them with their values in the above function, even plot the \
evolution of c(t). As example  we suppose that ",
 Cell[BoxData[
  FormBox["V", TraditionalForm]]],
 " = 5 L, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "0"], TraditionalForm]]],
 " = 0, \[Nu] = 0.2 L/s, ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]]],
 " = 5 g/L"
}], "Text"],

Cell[TextData[{
 "We plot ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "t", ")"}], TraditionalForm]]],
 ". We also use",
 StyleBox[" Timing", "InlineInput"],
 StyleBox[" ", "DisplayMath"],
 "that gives the time used in the computation."
}], "Caption"],

Cell[TextData[{
 "Using ",
 StyleBox["Evaluate", "InlineInput"],
 " the time of computation is reduced, but cannot always we can apply this \
criterion (see apart. 1.9.1 of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Book)."
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", " ", "[", 
     RowBox[{
      RowBox[{"c1", "[", "t", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"V", "\[Rule]", "5"}], ",", " ", 
        RowBox[{"c0", "\[Rule]", "0"}], ",", " ", 
        RowBox[{"\[Nu]", "\[Rule]", " ", "0.2"}], ",", " ", 
        RowBox[{"b", "\[Rule]", "5"}]}], "}"}]}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "100"}], "}"}]}], "]"}], "//", 
  "Timing"}]], "Input",
 CellLabel->"In[18]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"0.`", ",", 
    GraphicsBox[{{}, {}, 
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
       Opacity[1.], LineBox[CompressedData["
1:eJwVz3s01AkUB/AR6YVm5peatdaOR4XmtFMrifT7CqlFnjU/RQ3JjKiE3mql
TtFalEpMTJORTVvTrq1YehjZsO1hbYlZG9q8ejDeMzTZ3/5xz72fc88993wt
I/YG7pzGYDB86fq/W2XqCgssqtbQ4wg/UrLGa1/xrN1iKcngtqbsND9MBnTy
Mm3FCpKRx9a4ctLIzbkDAYbiRyQj3TLVnZlLUqP+X4+KGkiGhsw/wbhBhhTq
yd+L2snkXc7XVnWWkVsmQkJ7RQMkXp9r8SusJVULTzt1i6ZIvqx8T7ddC1l0
VO+TfhgTZVH1fz5d1Esal0oVxX4ctDiHmve5D5JX1n2ctsyYi0ZGn1vd+ChZ
EJHy73wvG3gMzf2n4+YE6SrriaxzssXQO7vW6PufyNqM6xKDb3kw1650yxbq
QRUVfr6I4oPTnxr1bLk+pAu2L1b4Lkd4W3VFfbUBVNJZC3SxDoietJyXFWyI
HeXWgmViR8xwOctwvDUD+UdjERPihCuyoMvZXTPhaxpxqi/RGQMbpjNtLGbD
G085G2NXg+TdLx61n4NHa1tnjH+/BicPFpTtWWmEoTGjxqZAIMUkeJfczhg8
050e+T5uKDGqP63RGsNSSnSnbV2Lyi8jVnvVm+DBoFYRTbljkf3+7phjczHv
jmNxzC4P9KZdNjPjMFGtnJ0Qd9ATGUW5inIxE2YF80Xi+HVoc29wYN1mgtd1
KDUlxQuqos6ekGEmukbYTZnJ62Hpb3igfykLY5SHWnp4A+rta1+/j2RBafvM
penMNwhv3uKgzmNhRdV3ivGT3njxtmNWZB0LO2pk/uRFH/S5j7rXjLPw9gu/
39JkvggYtP1LYskGh3SIfCrZCKf0MU2OJxt6z/Z+tfimH7QCXW5WNBu1WftY
rsH+2Falrf82lY3KrgOjokZ/KPWzf0yTs5ERt1htLQjA9aV8Ye5jNkrbh4+3
Pg/AiZvOjypa2Lh3KsaGGxaIXIXF6pdqNoxNpsKEbYF4HnrE9fx0Allur/Ss
QoKw/cl8660cAuoScWViRxCSLveE2ywhINeYzKnaFozU4dJQHxcCK5KEcQU9
wcgZu1UW601g+IaO1O3ehDpVmFgTQsCg8l7hpnebsN77oenRKHqv/7kFmbAZ
vdU+8sl4+p4v4VkNbYbRh4SJimMECg1FRaf3CBCYLxEfOUNggP3KIWlUAGaJ
na3zOQKZ+vuomAQK6y6Z5FzJJeAx7UNJ/n4KiXU16Y9paxjRuoaDFIQtf+9/
Q1v4SXjNIYnCiKejFS+PwHKt/3vdKXrP5775lXZzPz856xKFBoWM2SwhYKFS
F98tpyCzabbXLyDQ1BI70VNBQTD5+sJC2mde9vqYPaRgIG8d8qKtft4xeFxJ
4ULkxbPptJUNjS7rf6dwkfvAzlRKIKrmToOqjYJeTpK9zVUCZk94Vsbt9L+f
uS88aTcof0gkOylYqwYTRLSdHl/9TN5F5+teklFCe3ZF1o7d/XS+9vgVfBmB
h+VG96RqCnk+wycCaCeUpc5sGqIQ9KJKGU+77W7yLcdxCrqiEMu7tLN++Tgl
1lLI5i4hm2l7lh4KlExSmGm+NWCc9sRPI/I/dBRMb38QcK4RuH0nbnxqisL0
d92Bq2j/B45TLYQ=
        "]]}},
     AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
     Axes->{True, True},
     AxesLabel->{None, None},
     AxesOrigin->{0, 0},
     DisplayFunction->Identity,
     Frame->{{False, False}, {False, False}},
     FrameLabel->{{None, None}, {None, None}},
     FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
     GridLines->{None, None},
     GridLinesStyle->Directive[
       GrayLevel[0.5, 0.4]],
     Method->{
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None},
     PlotRange->{{0, 100}, {0., 4.908421798080558}},
     PlotRangeClipping->True,
     PlotRangePadding->{{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.05], 
        Scaled[0.05]}},
     Ticks->{Automatic, Automatic}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806387459493`*^9, 3.479966510194038*^9, 
  3.479966721986038*^9, 3.4799673088290377`*^9, 3.479968221213038*^9, 
  3.5133964191733246`*^9, 3.5823496971851416`*^9, 3.582350359718961*^9, 
  3.5823513406633406`*^9, 3.642760937226056*^9, 3.650269792646346*^9},
 CellLabel->"Out[18]="]
}, Open  ]],

Cell[TextData[{
 "Suppose that the flow of the drug into the organ is cut in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "T"}], TraditionalForm]]],
 ".  Since that moment ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "=", " ", "0"}], TraditionalForm]]],
 " but the liquid continue flowing with the same constant rates ",
 StyleBox["v.",
  FontSlant->"Italic"],
 " The process will be given by equation where ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t1", " ", "=", " ", 
    RowBox[{"t", " ", "-", " ", "T", " "}]}], TraditionalForm]]]
}], "Text"],

Cell[TextData[{
 "We do ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", " ", "=", " ", "0"}], TraditionalForm]]],
 " in eq2"
}], "Caption"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"V", "  ", 
    RowBox[{
     RowBox[{"c", "'"}], "[", "t1", "]"}]}], "==", " ", 
   RowBox[{
    RowBox[{"-", "\[Nu]"}], " ", 
    RowBox[{"c", "[", "t1", "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[19]:="],

Cell["\<\
The concentration in t1 = 0 (or t = T) will be with an initial concentration \
c[0] = c1\
\>", "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"%", ",", " ", 
     RowBox[{
      RowBox[{"c", "[", "0", "]"}], "\[Equal]", "c1"}]}], "}"}], ",", " ", 
   RowBox[{"c", "[", "t1", "]"}], ",", " ", "t1"}], "]"}]], "Input",
 CellLabel->"In[20]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "(", "t1", ")"}], "\[Rule]", 
     RowBox[{"c1", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[Nu]", " ", "t1"}], "V"]}]]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806387928686`*^9, 3.479966510393038*^9, 
  3.4799667221050377`*^9, 3.479967308878038*^9, 3.4799682212700377`*^9, 
  3.5133964192202005`*^9, 3.5823496972761507`*^9, 3.582350359801969*^9, 
  3.5823513407133446`*^9, 3.6427609372572947`*^9, 3.650269792708846*^9},
 CellLabel->"Out[20]="]
}, Open  ]],

Cell[TextData[{
 "Replacing",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{Cell["t1"], " ", "=", " ", 
     RowBox[{"t", "-", "T", " "}]}]}], TraditionalForm]]],
 "and  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c1", "=", " ", 
    RowBox[{"c1", "[", "T", "]"}]}], TraditionalForm]]],
 " is obtained the concentration ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "t", ")"}], TraditionalForm]]],
 " in the organ  when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "\[GreaterEqual]", "T"}], TraditionalForm]]]
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c2", "[", 
   RowBox[{"t_", ",", "T_"}], "]"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "t1", "]"}], "/.", 
    RowBox[{"%", "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t1", "\[Rule]", " ", 
      RowBox[{"t", "-", "T"}]}], ",", " ", 
     RowBox[{"c1", "\[Rule]", " ", 
      RowBox[{"c1", "[", "T", "]"}]}]}], "}"}]}]}]], "Input",
 CellLabel->"In[21]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"\[Nu]", " ", 
       RowBox[{"(", 
        RowBox[{"t", "-", "T"}], ")"}]}], "V"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c0", "-", "b"}], ")"}], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[Nu]", " ", "T"}], "V"]}]]}], "+", "b"}], ")"}]}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806388241487`*^9, 3.479966510512038*^9, 
  3.479966722562038*^9, 3.479967309016038*^9, 3.479968221319038*^9, 
  3.5133964192670765`*^9, 3.5823496973401566`*^9, 3.582350359860975*^9, 
  3.5823513407595987`*^9, 3.64276093728854*^9, 3.650269792740096*^9},
 CellLabel->"Out[21]="]
}, Open  ]],

Cell[TextData[{
 "Now we can build a joint function with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"c", "(", "t", ")"}], " ", "=", " ", 
    RowBox[{"c1", "(", "t", ")"}]}], TraditionalForm]]],
 " when ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"0", " ", "\[LessEqual]", "t", "<", "T"}]}], TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"c", "(", "t", ")"}], " ", "=", " ", 
    RowBox[{"c2", "(", "t", ")"}]}], TraditionalForm]]],
 " when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "\[GreaterEqual]", "T"}], TraditionalForm]]],
 " "
}], "Text"],

Cell[TextData[{
 "Remember that ",
 StyleBox["f[",
  FontFamily->"Courier New"],
 StyleBox["pattern",
  FontFamily->"Times New Roman",
  FontSlant->"Italic"],
 StyleBox["/;condition", "MR",
  FontFamily->"Times New Roman",
  FontSlant->"Italic"],
 StyleBox["]:= ", "MR"],
 StyleBox["expr", "MR",
  FontFamily->"Times New Roman",
  FontSlant->"Italic"],
 " indicates that the ",
 StyleBox["expr", "MR",
  FontFamily->"Times New Roman",
  FontSlant->"Italic"],
 " is evaluated only when  ",
 StyleBox["condition", "MR",
  FontFamily->"Times New Roman",
  FontSlant->"Italic"],
 " is satisfied "
}], "Caption"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"T_", "/;", 
      RowBox[{"t", "<", "T"}]}]}], "]"}], ":=", 
   RowBox[{"c1", "[", "t", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "[", 
   RowBox[{"t_", ",", 
    RowBox[{"T_", "/;", 
     RowBox[{"t", "\[GreaterEqual]", "T"}]}]}], "]"}], ":=", " ", 
  RowBox[{"c2", "[", 
   RowBox[{"t", ",", "T"}], "]"}]}]}], "Input",
 CellLabel->"In[22]:="],

Cell[TextData[{
 "If ",
 Cell[BoxData[
  FormBox[
   RowBox[{"T", " ", "=", " ", "50"}], TraditionalForm]]],
 " the plot of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"c", "(", "t", ")"}], TraditionalForm]]],
 " is"
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"t", ",", "50"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"V", "\[Rule]", "5"}], ",", " ", 
      RowBox[{"c0", "\[Rule]", "0"}], ",", " ", 
      RowBox[{"\[Nu]", "\[Rule]", " ", "0.2"}], ",", " ", 
      RowBox[{"b", "\[Rule]", "5"}]}], "}"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", "100"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[24]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVkHk41Xkbxs+RJKHzEzGUbJMWU9ay5Xsr5vyOIUviJ9UI5YSK0qLV9ioR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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 100}, {0., 4.32270864545797}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806388867083`*^9, 3.479966510736038*^9, 
  3.479966723764038*^9, 3.479967309118038*^9, 3.4799682213810377`*^9, 
  3.5133964193295784`*^9, 3.582349697443167*^9, 3.5823503599479837`*^9, 
  3.582351340838355*^9, 3.64276093735104*^9, 3.650269792802595*^9},
 CellLabel->"Out[24]="]
}, Open  ]],

Cell[TextData[{
 "We consider a bit more complicated situation: In eq.(2) we suppose that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "=", " ", 
    RowBox[{"A", " ", 
     RowBox[{"Exp", "(", 
      RowBox[{
       RowBox[{"-", "k"}], " ", "T"}], ")"}]}]}], TraditionalForm]]],
 " when  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", " ", "\[LessEqual]", " ", "t", " ", "<", " ", "T"}], 
   TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "=", " ", "0"}], TraditionalForm]]],
 " when",
 StyleBox[" t ",
  FontSlant->"Italic"],
 "\[GreaterEqual]",
 StyleBox[" T",
  FontSlant->"Italic"],
 " ."
}], "Text"],

Cell["\<\
The method is the same as we followed in the previous example. We have \
supposed that A= 1, k = 0.05\
\>", "Caption"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"V", "  ", 
         RowBox[{
          RowBox[{"c", "'"}], "[", "t", "]"}]}], "==", " ", 
        RowBox[{"\[Nu]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"A", " ", 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "k"}], " ", "t"}], "]"}]}], "-", 
           RowBox[{"c", "[", "t", "]"}]}], ")"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"c", "[", "0", "]"}], "\[Equal]", "c0"}]}], "}"}], ",", " ", 
     RowBox[{"c", "[", "t", "]"}], ",", " ", "t"}], "]"}], "//", 
   "FullSimplify"}], ";"}]], "Input",
 CellLabel->"In[25]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c3", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"c", "[", "t", "]"}], "/.", 
    RowBox[{"%", "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[26]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "  ", 
        RowBox[{
         RowBox[{"c", "'"}], "[", "t1", "]"}]}], "==", " ", 
       RowBox[{
        RowBox[{"-", "\[Nu]"}], " ", 
        RowBox[{"c", "[", "t1", "]"}]}]}], ",", " ", 
      RowBox[{
       RowBox[{"c", "[", "0", "]"}], "\[Equal]", "c1"}]}], "}"}], ",", " ", 
    RowBox[{"c", "[", "t1", "]"}], ",", " ", "t1"}], "]"}], ";"}]], "Input",
 CellLabel->"In[27]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c4", "[", 
    RowBox[{"t_", ",", "T_"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"c", "[", "t1", "]"}], "/.", 
     RowBox[{"%", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t1", "\[Rule]", " ", 
       RowBox[{"t", "-", "T"}]}], ",", " ", 
      RowBox[{"c1", "\[Rule]", " ", 
       RowBox[{"c3", "[", "T", "]"}]}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[28]:="],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"T_", "/;", 
      RowBox[{"t", "<", "T"}]}]}], "]"}], ":=", 
   RowBox[{"c3", "[", "t", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "[", 
   RowBox[{"t_", ",", 
    RowBox[{"T_", "/;", 
     RowBox[{"t", "\[GreaterEqual]", "T"}]}]}], "]"}], ":=", " ", 
  RowBox[{"c4", "[", 
   RowBox[{"t", ",", "T"}], "]"}]}]}], "Input",
 CellLabel->"In[29]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"t", ",", "30"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A", "\[Rule]", " ", "1"}], ",", " ", 
      RowBox[{"k", "\[Rule]", " ", "0.05"}], ",", 
      RowBox[{"V", "\[Rule]", "5"}], ",", " ", 
      RowBox[{"c0", "\[Rule]", "0"}], ",", " ", 
      RowBox[{"\[Nu]", "\[Rule]", " ", "0.2"}], ",", " ", 
      RowBox[{"b", "\[Rule]", "5"}]}], "}"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", "100"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[31]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1nk8lN0XAHCkslWimOxEChXDDIaZc0ilLC+yjEKUIiFJpUgqFa9CkYSi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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 100}, {0., 0.32767999998354336`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806398094625`*^9, 3.4799665116820383`*^9, 
  3.479966725311038*^9, 3.479967310155038*^9, 3.479968221878038*^9, 
  3.513396420313979*^9, 3.5823496983822613`*^9, 3.582350360750064*^9, 
  3.5823513417934313`*^9, 3.6427609378354187`*^9, 3.650269793255721*^9},
 CellLabel->"Out[31]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{
  "x1", ",", "x2", ",", "eq", ",", " ", "x", ",", " ", "eq1", ",", "eq2", ",",
    "c", ",", "c1", ",", "c2", ",", "c3", ",", "c4", ",", " ", "kI131"}], " ",
   "]"}]], "Input",
 CellLabel->"In[32]:="]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Two  Compartmental Systems ", "SubsectionIcon"],

Cell[TextData[{
 "To avoid conflict with variables with ",
 Cell[BoxData[
  ButtonBox[Cell["Quit"],
   BaseStyle->Dynamic[
     If[
      CurrentValue["MouseOver"], {
      "Link", FontColor -> RGBColor[0.854902, 0.396078, 0.145098]}, {"Link"}]],
   ButtonData->"paclet:ref/Quit"]]],
 " the session and them starting a new session. The package mush be charged \
again"
}], "Text",
 CellChangeTimes->{{3.5823504799882517`*^9, 3.58235057198186*^9}, {
  3.650597888211619*^9, 3.650597946945653*^9}}],

Cell[CellGroupData[{

Cell["A easy example of a two compartmental model", "SubsubsectionIcon"],

Cell["\<\
This Figure is represented an easy example of a two compartmental system \
(Anderson 1983). It shows the ingestion and metabolism of a drug. We have \
modeled with two compartments. It is supposed that the drug is taken orally \
flowing to the GI tract (Compartment 1) , then it is absorbed into the blood \
(Compartment 2) and finally eliminated. \
\>", "Text"],

Cell[BoxData[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .75 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.142857 0.238095 0.375 0.238095 [
[ 0 0 0 0 ]
[ 1 .75 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .75 L
0 .75 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.14286 .73214 m
.14286 .49405 L
s
% Start of user PostScript
0 1.5 0 0.5 MAarrowhead1
% End of user PostScript
gsave
.2381 .6131 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.000 12.750 moveto
(H) show
81.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.000 12.750 moveto
(L) show
93.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.14286 .375 .11905 0 365.73 arc
s
gsave
.14286 .375 -96 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GI) show
81.000 12.750 moveto
(Tract) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
111.000 12.750 moveto
(H) show
117.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
123.000 12.750 moveto
(L) show
129.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.2619 .375 m
.7381 .375 L
s
% Start of user PostScript
0.5 0 2.5 0 MAarrowhead2
% End of user PostScript
gsave
.5 .47024 -111 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Flow) show
93.000 12.750 moveto
(from) show
123.000 12.750 moveto
(1) show
135.000 12.750 moveto
(to) show
153.000 12.750 moveto
(2) show
159.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.85714 .375 .11905 0 365.73 arc
s
gsave
.85714 .375 -90 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Blood) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
99.000 12.750 moveto
(H) show
105.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
111.000 12.750 moveto
(L) show
117.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.85714 .25595 m
.85714 .01786 L
s
% Start of user PostScript
3. -0.5 3. -1.5 MAarrowhead2
% End of user PostScript
gsave
.71429 .1369 -96 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Elimination) show
129.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Text",
  ImageSize->{309.75, 232.25},
  ImageMargins->{{0, 0}, {0, 15.8125}},
  ImageRegion->{{0, 1}, {0, 1}},ImageCache->GraphicsData["CompressedBitmap", 
  "\<\
eJztW1tvHDUUdsYzm71kkzRpk5SmzZKWa1PRXFtFAQq0SVso9+tjVCG1DwhU
+og0D/BH+BGgCiFUIVShCqqKB4QED33gAUEleEHiATHYZ9beb7xzZmc22yUS
G2m9nz/72MceH4/P8ebC9tVLb7+zffXyxe3G1pXt9y5dvvh+Y/PdK4qSQ0IM
fag+8+NC4Q+EvCPmojD6KIyE6OL7WfUthQgVFGsZ3PkwUtSJwrlzYRQI20r+
3NkwGhZitXBuK4wqQqwUzm2GUU2I5dRc3jkacAOu59xvYVQSQpJxxKkINK//
1Lenvnyd1xKq0CPriyn918zLZl5S1jet+YZpCZRdBe6qJIgJqhNABcSqJ+E3
MWWwwGDpNAZCYeSJtnK3A8RYT0LZcNoI0gp7oj2nUaWnmquKPdXcrqfUvnei
r8zU1GstX0r9pI6eSA7HLzCpuIy8DkqmTmpsCRKUbA05NhoPLMk31hMQliTi
W3lTrVrEnI4CPuwKxhtBrAWqXQd8EPB+t4HdtKsNuP8ftxhGdSoZJrCkuQWy
nzpZzj+U1ok5pgsfJmKKiD8NVukjuvBBMoQ5Sv8g+ztE+CFdeITgYUrvAn5A
F86beir9BbC2ONEgeJTSnwHfrwvjHh6j9A7gOV2ItrcI+CeGn9VCs0AsA/4R
8BLgA1roPur0BNA/ELNGKVWZIbhO6feA9aYgpkFyA/B3DD/lCj0O+DbDk9AU
EE8CvsXw+7TQPiCeAvwt4FOA92qhvUA8A/gmDfs0pVRxEgrPAP4a8CbgPVpo
ginMFNoDxFnANxh+3BU6B/grhiehcSDQ7L5k+LG8Qs8BHtVCY0BcAHwd8POA
610LjQLxAuAvAL8IeEQL1ZnC3EIvAf4c8MuAa10LjQDxCuDPAL8KuNq1UA2I
1wBfY/g+C+Gp6HVGCPlKT4TeAPwpw3cvhGfTNxkh5Ms9EXoL8CfdCH1MW+NE
XtHTgIeditBkKWnAG4zUWFZXuI1XmAZUV9Wk1AYjNZrVVQBucdW4AfZgbw/z
Hh0/bGUr7pnKlikldRxNnvNrpr71wn2TYndaQ+vVBMkm6lnDcd0mp2+LpSPD
uVBpPiDmS047zCxMmLE19c/r6CfcQZuJHa1qimppw8ucL8l0jnzWvKUqixYR
MALOZF2LrWZn84JtlhlpfDAdZ8auCmfVczMSmEBUanc5p+LerRtufiSjZO6V
g405c+O1K+qsY673nFPkbDAjtJ2UwqJz07KpTv3veFaawSAbd5S4A2JEk9Mg
YzaqyTHUMtYMt/2GkfuCKL6tZG3D5ZCJ2s04w0Lrwwact6Dzws0aMnpylTD5
9FPXS6dXp42Dlekq5kjGsmOOC84JpGped57xZPEQ7GxDmWeIe3sQ69/hsn8H
5l3uOfTPheqfW7hjrzW3EFoyetzXGb7NE88thFaJUYTM6EJXIYk8EZPzgMfy
CrWFWXCL2gJ8g+G7Dx1N0qaH4ambgNEH082zEbNvAD8NeNIVOgX4FsNT9AwD
ek8Avs3wFNDrKnSI78F1E2uVdKixXpN9q8X3liXR8sR8e/WJ101lKq6Zo6xP
+75ijlMH6DpqnRNXKCcBHwecdW9WiXEYnydiFdwDQhpuu9KzGdzSXdeHe9eW
nHoYT8ZR6RnXsWVLrAHGyPV/O2ROOk27FWY0FAY/QA99FWg7M87N4O4bJJ6f
VmgccUqXCgcJLprhyezB5Lnc9VNdGIsdKys6GJw6fBzx5coh3eYc0MfSqrff
5ab8tqFk9ogUzwMvp5uzUUvqaDeWOqMvKkZaN4DAu921kD+d454zT/rj6WXC
kTzJ9KDnS99ZeXRb5lFFe3s8S83iBXODmHWoP68bsJdmKv2VqsQXa/qEr2mf
2lL6/G6wTxdz1IikjV/V/gvO8Y/qwgXSpUrOwt+UxnhBFy6R+6aUqhGg32Dh
VVdEvzCjyy5p7xkL5FbNDDZXjWmvV/yKa+Og+FafKixnmHVEv27rbx1843Bv
KfU5U7Ru2roYcAOuWw4jF8PJuvvdurh9VpJ1Z9y6U84bB8NVsi2yoz7TbgvT
bUFCN1iDNuh3bi3VrrgAUKn/7XUYbWHN9PlYJANqQa5pTzxknGRngTAPHV/e
nZbUbjKFATfgkIsK/muBGPoXrtny4w==\
\>"],ImageRangeCache->{{{134.625, 443.375}, {293.875, 
  62.625}} -> {-2.43669, -0.721954, 0.0136218, 0.0136218}}]], "Text",
 TextAlignment->Center,
 TextJustification->0],

Cell[TextData[{
 "We resolve the model of  fig. 1. Let",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["x", "1"],
      TraditionalForm], "(", "t", ")"}]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["x", "2"],
     TraditionalForm], "(", "t", ")"}], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "\[GreaterEqual]", "0"}], TraditionalForm]]],
 ", is the mass of the drug in compartment 1 and 2, respectively.  Then we \
can describe the process as follow"
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{" ", 
   RowBox[{
    FractionBox[
     RowBox[{"\[DifferentialD]", 
      SubscriptBox["x", "1"]}], 
     RowBox[{"\[DifferentialD]", "t"}]], "=", " ", 
    RowBox[{
     RowBox[{"b", "(", "t", ")"}], " ", "-", " ", 
     RowBox[{
     "drug", " ", "distribution", " ", "rate", " ", "from", " ", "1", " ", 
      "to", " ", "2"}]}]}]}], TraditionalForm]], "NumberedEquation"],

Cell[BoxData[
 FormBox[
  RowBox[{" ", 
   RowBox[{
    FractionBox[
     RowBox[{"\[DifferentialD]", 
      SubscriptBox["x", "2"]}], 
     RowBox[{"\[DifferentialD]", "t"}]], "=", " ", 
    RowBox[{
     RowBox[{"inflow", " ", "rate"}], " ", "-", " ", 
     RowBox[{"outflow", " ", "rate", " ", 
      RowBox[{"(", "elimination", ")"}]}]}]}]}], 
  TraditionalForm]], "NumberedEquation"],

Cell[TextData[{
 "The previous equations are commonly called ",
 StyleBox["mass balance equation",
  FontWeight->"Bold"],
 ".  If it is assumed that rate of transference from each compartment ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]]],
 " is proportional to the mass (or concentration) in this compartment, then \
(3) and (4) become"
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   FractionBox[
    RowBox[{"\[DifferentialD]", 
     SubscriptBox["x", "1"]}], 
    RowBox[{"\[DifferentialD]", "t"}]], "=", " ", 
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "-", 
    RowBox[{
     SubscriptBox["k", "12"], " ", 
     SubscriptBox["x", "1"]}]}]}], TraditionalForm]], "NumberedEquation"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"\[DifferentialD]", 
      SubscriptBox["x", "2"]}], 
     RowBox[{"\[DifferentialD]", "t"}]], "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "12"], " ", 
      SubscriptBox["x", "1"]}], " ", "-", " ", 
     RowBox[{
      SubscriptBox["k", "20"], " ", 
      SubscriptBox["x", "1"]}]}]}], "\[IndentingNewLine]"}], 
  TraditionalForm]], "NumberedEquation"],

Cell[TextData[{
 "where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "20"], TraditionalForm]]],
 "  are the constants  (>0) of  proportionality  from 1 to 2 and from 2 to \
environment (elimination). This process is a simple case of first-order \
kinetics. \nBoth ordinary differential equations (ODE) with appropriate \
initial conditions ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "1"], TraditionalForm]]],
 "(0) and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    RowBox[{"x", " "}], "2"], TraditionalForm]]],
 "(0) constitute the compartmental metabolic model. In matrix-vector format \
the system of ordinary differential equation (SODE)  model is "
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", GridBox[{
       {
        RowBox[{
         RowBox[{
          SubscriptBox["x", "1"], "'"}], 
         RowBox[{"(", "t", ")"}]}]},
       {
        RowBox[{
         RowBox[{
          SubscriptBox["x", "2"], "'"}], 
         RowBox[{"(", "t", ")"}]}]}
      }], ")"}], " ", "=", 
    RowBox[{
     FormBox[
      RowBox[{"(", GridBox[{
         {
          RowBox[{
           RowBox[{"-", 
            SubscriptBox["k", "12"]}], " "}], "0"},
         {
          SubscriptBox["k", "12"], 
          SubscriptBox["k", "20"]}
        }], ")"}],
      TraditionalForm], "+", 
     FormBox[
      RowBox[{"(", GridBox[{
         {
          RowBox[{"b", "(", "t", ")"}]},
         {"0"}
        }], ")"}],
      TraditionalForm]}]}], "\n"}], TraditionalForm]], "NumberedEquation"],

Cell[TextData[{
 "This system can be solved with ",
 StyleBox["DSolve", "DisplayMath"],
 " or using SystemDSolve. Here is assumed  k12= 0.3, and k20 = 0.05 and b(t) \
= {0, 0}, an as initial condition is taken {1,0}. The solution is plotted ."
}], "MathCaption"],

Cell["The first step is build the compartmental matrix", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"model1", " ", "=", " ", 
  RowBox[{"CompartMatrix", "[", 
   RowBox[{"2", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", " ", "0.3"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", " ", "0.05"}], "}"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[33]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "0.3`"}], "0.`"},
     {"0.3`", 
      RowBox[{"-", "0.05`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280639840742*^9, 3.479966511827038*^9, 
  3.479966725702038*^9, 3.479967310278038*^9, 3.479968221901038*^9, 
  3.5133964203452296`*^9, 3.582349698418265*^9, 3.5823504405720453`*^9, 
  3.5823507113702765`*^9, 3.5823513418496857`*^9, 3.5922021417799554`*^9, 
  3.642760937866669*^9, 3.650269793302596*^9},
 CellLabel->"Out[33]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", " ", 
   RowBox[{
    RowBox[{"x1", "[", "t_", "]"}], ",", 
    RowBox[{"x2", "[", "t_", "]"}]}], "}"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "[", "t", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "2"], "[", "t", "]"}]}], "}"}], "/.", 
   RowBox[{"SystemDSolve", "[", 
    RowBox[{"model1", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", "t", ",", "t", ",", " ", "x"}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[34]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1.`", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "0.3`"}], " ", "t"}]]}], ",", 
    RowBox[{
     RowBox[{"1.2`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.05`"}], " ", "t"}]]}], "-", 
     RowBox[{"1.2`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.3`"}], " ", "t"}]]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806400909805`*^9, 3.4799665118810377`*^9, 
  3.479966725856038*^9, 3.479967310353038*^9, 3.479968221957038*^9, 
  3.513396420407731*^9, 3.582349698479271*^9, 3.582350440841072*^9, 
  3.5823507114472847`*^9, 3.5823513418971896`*^9, 3.5922021418267565`*^9, 
  3.6427609378822947`*^9, 3.650269793333846*^9},
 CellLabel->"Out[34]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], ",", 
     RowBox[{"x2", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "100"}], "}"}], ",", 
   RowBox[{"PlotRange", "->", "All"}], ",", "\[IndentingNewLine]", " ", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Dashed"}], "}"}]}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<days\>\"", ",", " ", "\"\<r\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<x1\>\"", ",", "\"\<x2\>\"", ",", " ", "\"\<x3\>\""}], 
       "}"}], ",", "Right", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.479966598041038*^9, {3.5922022552083683`*^9, 3.592202304277275*^9}, {
   3.5922023587277713`*^9, 3.592202377120525*^9}},
 CellLabel->"In[35]:="],

Cell[BoxData[
 FormBox[
  TemplateBox[{GraphicsBox[{{{}, {}, {
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         RGBColor[1, 0, 0]], 
        LineBox[CompressedData["
1:eJwVV3c41t8bNouiJCRKsvcm63POY29eXl4iGQ0jm0p2SMOsZERWilCUEfpS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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6], 
         Dashing[{Small, Small}]], 
        LineBox[CompressedData["
1:eJwVlXc81e0bx4myIuvYji1KySpZ15WMhp1xkFEJJWUlIh2nEo9EGh7zZEQ0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         "]]}}}, {
     DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {
        FormBox["\"days\"", TraditionalForm], 
        FormBox["\"r\"", TraditionalForm]}, AxesOrigin -> {0, 0}, 
      DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None}, 
      PlotRange -> {All, All}, PlotRangeClipping -> True, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
     FrameBox[
      FormBox[
       TemplateBox[{"\"x1\"", "\"x2\"", "\"x3\""}, "LineLegend", 
        DisplayFunction -> (FormBox[
          StyleBox[
           StyleBox[
            PaneBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6], 
                    Dashing[{Small, Small}]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6], 
                    Dashing[{Small, Small}]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
              "Grid"], Alignment -> Left, AppearanceElements -> None, 
             ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
             "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
           FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
           False], TraditionalForm]& ), 
        InterpretationFunction :> (RowBox[{"LineLegend", "[", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[1, 0, 0], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"Small", ",", "Small"}], "}"}], "]"}]}], "]"}]}], 
               "}"}], ",", 
             RowBox[{"{", 
               RowBox[{#, ",", #2, ",", #3}], "}"}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"{", "}"}]}], ",", 
             RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
        Editable -> True], TraditionalForm], RoundingRadius -> 5, 
      StripOnInput -> False], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806410450144`*^9, 3.4799665122150383`*^9, 3.479966605684038*^9, 
   3.479966726471038*^9, 3.479967312022038*^9, 3.479968222358038*^9, 
   3.5133964215952616`*^9, 3.5823497001584387`*^9, 3.5823504410640945`*^9, 
   3.5823507133474746`*^9, 3.582351343622328*^9, 3.5922021429811783`*^9, {
   3.5922022592067685`*^9, 3.592202305012348*^9}, {3.5922023669179287`*^9, 
   3.5922023778225384`*^9}, 3.642760938038598*^9, 3.6502697934432206`*^9},
 CellLabel->"Out[35]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"model1", ",", "x1", ",", "x2"}], "]"}]], "Input",
 CellLabel->"In[36]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Two inputs model ", "SubsubsectionIcon"],

Cell[TextData[{
 "Below it is  shown a compartmental model with two inputs in compartment 1. \
One input represents a continuous flow  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "1"], "(", "t", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", "t", "<", "T"}], TraditionalForm]]],
 " and the other one consist in a single input  (bolus) ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "2"], TraditionalForm]]],
 "(t) =",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "0"], TraditionalForm]]],
 " in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 " that it is equivalent to take as initial condition ",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(0) = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "0"], TraditionalForm]]],
 ". "
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .62222 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.12963 0.21164 0.332275 0.21164 [
[ 0 0 0 0 ]
[ 1 .62222 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .62222 L
0 .62222 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .60741 m
.06614 .41693 L
s
% Start of user PostScript
-0.5 1.3 -0.3 0.4 MAarrowhead1
% End of user PostScript
gsave
.10847 .50159 -80.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
75.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
79.875 12.750 moveto
(H) show
85.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
91.875 12.750 moveto
(L) show
97.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.12963 .33228 .10582 0 365.73 arc
s
gsave
.12963 .33228 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.12963 .22646 m
.12963 .01481 L
s
% Start of user PostScript
0 -0.5 0 -1.5 MAarrowhead2
% End of user PostScript
gsave
.06614 .12063 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.23545 .3746 m
.76455 .3746 L
s
% Start of user PostScript
0.5 0.2 3. 0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .41693 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.76455 .28995 m
.23545 .28995 L
s
% Start of user PostScript
3. -0.2 0.5 -0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .24762 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.87037 .33228 .10582 0 365.73 arc
s
gsave
.87037 .33228 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.23545 .60741 m
.19312 .41693 L
s
% Start of user PostScript
0.5 1.3 0.3 0.4 MAarrowhead1
% End of user PostScript
gsave
.29894 .50159 -77.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
 ImageSize->{288, 179.188},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztWk1vHEUQbe/MenfttbHXjpMYjNdfwTE2CIg/ghAECAk55CcAcmwnNihK
SMIBCTT/h8SBO0I5IcSX+AnAgRsJB44chu43O+PXPVOz4/UaBymWZra6Xr2a
np7q6uqWL6/f2d66vn5nZ2O9efHW+s3tnY3bzQs3bmmV16NUz7ZS6tchpeXP
lPebmgyDcCcIlWr3+4K+eUoFum10azm6ElhnTWspCL3CLV8lXhaDsJzT6kVr
tV3r+SCsWK0qWivtWgtBWLNafWgtp1v7GJUnusdcN4YoKxEymGH1FOK7hNg1
tpUIN5C5DJ7iDOmb39Ipfx8kr4WXi3O8fVnvdcvDe/lt3p47pX9P5Jno36fF
AZx4jD78E93R6eaDcFCpf3A/bRSzWAcGcf+b5DkDNiGOIcof4j4GzZQBJ+3A
00F2GyYmtJWKAvZ6KvieNeAE1E3cPybQI/kjsgEpesYsmVx1ckOsZ/lDkqdh
/4xxNk7qOaivBU7SyPK2DdPnSHPSmJ+AeoHUmzRxfZL5Da+RPA8PcDYGcQn3
zSTB+HGCiboaWST0MUM8RooXYXKF3+kmwVHVANYoqV8m+QPuNb5kAr1E8ojr
4xWS3yf5hmDTMA5GSHGG5PfQT+75MsnDhtogxQrJP5O8SrLJl2DGijWSfyT5
LMkmnVuZ9lWSvxf0IPFC8BrJ3wl6swpYS8HrJH8r6AfySA3E0Fd51AFSnLNB
vbB9KaB1Q62T4k2Sq0FYt6mM9udR9XwZakPtJ8XbJD+wEwFDfXk8TRpW6n5R
6nmS9eQcUGpXQHOpVdS2udQ+UlywR0EX3vcEtJZHjQqCjqjf5JFqpLgokFhf
7QrpXZK/FvT/B1KVFNOojKcFahMor4MV18Gs7Uxyo8rxoqK64HCK5LmDOpsW
7DtyNiPIFfdrzRRwJj0w5WwKeXdWcOMOPz86FUVF+pV+XHci+HCnckeZpquk
L5AOhzuk9tqLZ4oqpf67OPKQ0NxV4y4WnEpRKi9k97DM+QIKqrsoJ3XnA7t4
Lbya72I1782jSuXHLmqIPgGtt6FW7OIrRZXqpfuYSKMCinqpo6KuI1JHNSeT
uIr9IY80jHnAxfBP0LAD1M5Srf4LyakqXdohbGIxQ0jib0Owa7hOeKtiNlKc
S68SltqrpHdJ6wW2kZsk0+Yp2qvxRtvacknbyK3sDRwf75yGyVasEQ6ltm1G
Ih836HHs1efJxRbe0U8dPbGbU0DHWw5K9pDMxJpob7r3pp9Axcv+eGt8vPis
ixeuPQ9x1zz44OWxdXDQ8lGODwJKkD07VD4ldDL+yn7LtZUrT8KmAg9XIH+O
Ox+dpT1UMZSjYNVgH51y6Ov3OF340SsiSssREeQ6UlEZJ951dvoHVGXAp7KY
I5gcrvZPaJfiqdgbfwJzLTq2GpgUDeOh5w+sL5yPNPjjssHCQYiZgL7M4CNP
8Cw+HLJnkxGlQw7Z6yZZwvSF4x5eFkqO/WIB/mgbThwCUvLU10QcIlmZNws/
E6Q//EFxPsdZboOvBOkIOCjOFeDqAfG1IB0n7XBp0e4EH0CK4LTHMkfCMLJX
VbD8y3XMwcolHdf+I7b7TMds/8h9SJTq92oC38YS2Y9XM6tKoEdYXrzCXh4G
zrSswJVxwBOL38fFPKFTfYmnJKcUdZPVKzFxuE6zXtzpV9pXK8v3FvDVtnOJ
XKxvHEM1x5U4ckU7VrIHtrb//jgeqkU7MphFMquVvX0qYfr68vOZ2J9LlB8b
hKmlh6ZEZrLgkRoswH3kPjwa/IatSeRjdjedXXkqL0n7N32h/OWt4RuHjJ+z
cVTz0ob4KPC3bNyMtHhIcBj4eRs3QWXlnHeOAJfOq/Q18l/gPBMv2XijG3hY
8D+NVM+/7D8wtA==\
\>"],ImageRangeCache->{{{191.438, 621.938}, {656.063, 388.782}} -> {-2.72345, \
2.70647, 0.0164996, 0.0164996}}],

Cell["This process can be mathematically represented by", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "="}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      SubscriptBox["b", "1"], "(", "t", ")"}], " ", "-", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["k", "10"], "+", " ", 
        SubscriptBox["k", "12"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", "t", ")"}]}]}]}], TraditionalForm]]],
 "  \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "12"], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "-", "  ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", "t", ")"}], " "}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "(", "0", ")"}], " ", "=", " ", 
    FormBox[
     SubscriptBox["b", "0"],
     TraditionalForm], " "}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 "(t) = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", "t", "<", "T"}], TraditionalForm]]],
 " and  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     FormBox[
      SubscriptBox["b", "1"],
      TraditionalForm], "(", "t", ")"}], " ", "=", " ", "0"}], 
   TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "\[GreaterEqual]", "T"}], TraditionalForm]]]
}], "NumberedEquation"],

Cell[TextData[{
 "Coefficients: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 "=2 ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["h", 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "21"], TraditionalForm]]],
 "=1 ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["h", 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "10"], TraditionalForm]]],
 " =0,5 ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["h", 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ", \nSingle input: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "0"], TraditionalForm]]],
 " = 100 mg\nConstant input: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 "=10 mg/h until ",
 Cell[BoxData[
  FormBox[
   RowBox[{"T", "=", "10"}], TraditionalForm]]],
 " h)"
}], "Text"],

Cell["The first step is build the compartmental matrix", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"model2", " ", "=", 
   RowBox[{"CompartMatrix", "[", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "1"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0.5"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[37]:="],

Cell[TextData[{
 "Here is the retention for ",
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", "t", "<", "T"}], TraditionalForm]]],
 " "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowODE", "[", 
   RowBox[{"model2", ",", " ", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", "0"}], "}"}], ",", " ", "t", ",", " ", "x1"}], "]"}], 
  "//", "TableForm"}]], "Input",
 CellLabel->"In[38]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x1", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"2.5`", " ", 
           RowBox[{
            SubscriptBox["x1", "1"], "(", "t", ")"}]}]}], "+", 
         RowBox[{"1.`", " ", 
          RowBox[{
           SubscriptBox["x1", "2"], "(", "t", ")"}]}], "+", "10"}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x1", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"2.`", " ", 
          RowBox[{
           SubscriptBox["x1", "1"], "(", "t", ")"}]}], "-", 
         RowBox[{"1.`", " ", 
          RowBox[{
           SubscriptBox["x1", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x1", "1"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x1", "2"], "(", "0", ")"}], "\[LongEqual]", "0"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641138854*^9, 3.479966512416038*^9, 
  3.479966726566038*^9, 3.479967312713038*^9, 3.479968222883038*^9, 
  3.513396421689014*^9, 3.5823497003004527`*^9, 3.5823504411191*^9, 
  3.582350753511491*^9, 3.5823513437210855`*^9, 3.5922024057776766`*^9, 
  3.6427609381010466`*^9, 3.650269793521346*^9},
 CellLabel->"Out[38]//TableForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"sol1", "[", "t1_", "]"}], "=", 
  RowBox[{"SystemDSolve", "[", 
   RowBox[{"model2", ",", " ", 
    RowBox[{"{", 
     RowBox[{"100", ",", " ", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"10", ",", " ", "0"}], "}"}], ",", " ", "t", ",", " ", "t1", ",",
     " ", "x1"}], "]"}]}]], "Input",
 CellLabel->"In[39]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x1", "1"], "(", "t1", ")"}], "\[Rule]", 
     RowBox[{"20.`", "\[VeryThinSpace]", "+", 
      RowBox[{"71.23475237772121`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "3.350781059358212`"}], " ", "t1"}]]}], "+", 
      RowBox[{"8.765247622278793`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "0.14921894064178787`"}], " ", "t1"}]]}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x1", "2"], "(", "t1", ")"}], "\[Rule]", 
     RowBox[{"40.`", "\[VeryThinSpace]", "-", 
      RowBox[{"60.60517809103758`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "3.350781059358212`"}], " ", "t1"}]]}], "+", 
      RowBox[{"20.605178091037594`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "0.14921894064178787`"}], " ", "t1"}]]}]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806411701336`*^9, 3.479966512508038*^9, 
  3.479966726606038*^9, 3.4799673132150383`*^9, 3.479968223043038*^9, 
  3.513396421767141*^9, 3.5823497003554583`*^9, 3.582350441151103*^9, 
  3.582350753569496*^9, 3.58235134377234*^9, 3.592202405825681*^9, 
  3.642760938132306*^9, 3.650269793552596*^9},
 CellLabel->"Out[39]="]
}, Open  ]],

Cell[TextData[{
 "Here is the retention for ",
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "\[GreaterEqual]", "T"}], TraditionalForm]]],
 ". "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowODE", "[", 
   RowBox[{"model2", ",", " ", 
    RowBox[{"{", 
     RowBox[{
     "\"\<\!\(\*SubscriptBox[\(x1\), \(1\)]\)(T)\>\"", ",", 
      "\"\<\!\(\*SubscriptBox[\(x1\), \(2\)]\)(T)\>\""}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}], ",", " ", "t", ",", "  ", "x2"}], "]"}], 
  "//", "TableForm"}]], "Input",
 CellLabel->"In[40]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x2", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"1.`", " ", 
          RowBox[{
           SubscriptBox["x2", "2"], "(", "t", ")"}]}], "-", 
         RowBox[{"2.5`", " ", 
          RowBox[{
           SubscriptBox["x2", "1"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x2", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"2.`", " ", 
          RowBox[{
           SubscriptBox["x2", "1"], "(", "t", ")"}]}], "-", 
         RowBox[{"1.`", " ", 
          RowBox[{
           SubscriptBox["x2", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x2", "1"], "(", "0", ")"}], 
        "\[LongEqual]", "\<\"\\!\\(\\*SubscriptBox[\\(x1\\), \\(1\\)]\\)(T)\"\
\>"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x2", "2"], "(", "0", ")"}], 
        "\[LongEqual]", "\<\"\\!\\(\\*SubscriptBox[\\(x1\\), \\(2\\)]\\)(T)\"\
\>"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806412170534`*^9, 3.479966512625038*^9, 
  3.479966726647038*^9, 3.479967313384038*^9, 3.479968223088038*^9, 
  3.5133964218452682`*^9, 3.5823497004264655`*^9, 3.582350441182106*^9, 
  3.5823507536305027`*^9, 3.582351343824844*^9, 3.5922024058626847`*^9, 
  3.6427609381635466`*^9, 3.650269793599472*^9},
 CellLabel->"Out[40]//TableForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"sol2", "[", "t_", "]"}], "=", 
  RowBox[{"AcuteInput", "[", 
   RowBox[{"model2", ",", " ", 
    RowBox[{"Map", "[", 
     RowBox[{"Last", ",", 
      RowBox[{"sol1", "[", "10", "]"}]}], "]"}], ",", " ", "t", ",", " ", 
    "x2"}], "]"}]}]], "Input",
 CellLabel->"In[41]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x2", "1"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      RowBox[{"44.63368756504546`", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"0.41009557612504777`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.7616456795963341`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "3.350781059358212`"}], " ", "t"}]]}]}], ")"}]}], 
         "-", 
         RowBox[{"0.7979346259081334`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.39144500518664405`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "0.14921894064178787`"}], " ", "t"}]]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{"21.97112680766245`", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.964044912881356`"}], " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.7616456795963341`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "3.350781059358212`"}], " ", "t"}]]}]}], ")"}]}], 
         "-", 
         RowBox[{"0.6788676663287205`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.39144500518664405`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "0.14921894064178787`"}], " ", "t"}]]}]}], 
           ")"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x2", "2"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      RowBox[{"44.63368756504546`", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"0.41009557612504777`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "+", 
            RowBox[{"0.6479937181425747`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "3.350781059358212`"}], " ", "t"}]]}]}], ")"}]}], 
         "-", 
         RowBox[{"0.7979346259081334`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.9202015039731399`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "0.14921894064178787`"}], " ", "t"}]]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{"21.97112680766245`", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.964044912881356`"}], " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "+", 
            RowBox[{"0.6479937181425747`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "3.350781059358212`"}], " ", "t"}]]}]}], ")"}]}], 
         "-", 
         RowBox[{"0.6788676663287205`", " ", 
          RowBox[{"(", 
           RowBox[{"0.`", "\[VeryThinSpace]", "-", 
            RowBox[{"0.9202015039731399`", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{
               RowBox[{"-", "0.14921894064178787`"}], " ", "t"}]]}]}], 
           ")"}]}]}], ")"}]}]}]}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641248333*^9, 3.479966512718038*^9, 
  3.4799667266820383`*^9, 3.4799673134580383`*^9, 3.479968223125038*^9, 
  3.5133964219077697`*^9, 3.58234970047047*^9, 3.5823504418291707`*^9, 
  3.582350753676507*^9, 3.582351343864847*^9, 3.5922024058996887`*^9, 
  3.642760938179171*^9, 3.650269793646346*^9},
 CellLabel->"Out[41]="]
}, Open  ]],

Cell[TextData[{
 "We build a compound function that represents the retention divided in two \
intervals: one of them  when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", "t", "<", "T"}], TraditionalForm]]],
 " and the other one ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "\[GreaterEqual]", "T"}], TraditionalForm]]],
 ". "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", 
    RowBox[{"t_", ",", "T_"}], "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"t", "<", "T"}], ",", " ", 
       RowBox[{"sol1", "[", "t", "]"}], ",", 
       RowBox[{"sol2", "[", 
        RowBox[{"t", "-", "T"}], "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[42]:="],

Cell["Here is the retention in compartment 1 and 2 f", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"x", "[", 
         RowBox[{"t", ",", "10"}], "]"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", " ", "0", ",", "20"}], "}"}]}], "]"}], "//", "Chop"}],
   "//", "TableForm"}]], "Input",
 CellLabel->"In[43]:="],

Cell[BoxData[
 FormBox[
  InterpretationBox[GridBox[{
     {"0", GridBox[{
        {"100.`", "0"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"1", GridBox[{
        {"30.04748740180291`", "55.624265254097295`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"2", GridBox[{
        {"26.591153461188703`", "55.214072072025616`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"3", GridBox[{
        {"25.605149069937774`", "53.166652270311886`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"4", GridBox[{
        {"24.82563003431588`", "51.343655214496785`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"5", GridBox[{
        {"24.156614718849134`", "49.77127907606098`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"6", GridBox[{
        {"23.580423760684024`", "48.41679193774216`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"7", GridBox[{
        {"23.08410711085121`", "47.250060566379645`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"8", GridBox[{
        {"22.656589730781175`", "46.24506082108562`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"9", GridBox[{
        {"22.28833459856918`", "45.37937363177226`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"10", GridBox[{
        {"21.971126807662447`", "44.63368756504546`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"11", GridBox[{
        {"17.11476764848863`", "39.987125259165055`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"12", GridBox[{
        {"14.678848382540341`", "34.49813661856249`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"13", GridBox[{
        {"12.641848430665972`", "29.717915580323762`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"14", GridBox[{
        {"10.889363745888792`", "25.598499445778035`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"15", GridBox[{
        {"9.379882886388717`", "22.05005065683906`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"16", GridBox[{
        {"8.079648143368281`", "18.99348380868588`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"17", GridBox[{
        {"6.959651378857702`", "16.360616640698403`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"18", GridBox[{
        {"5.994908005670204`", "14.092716192308426`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"19", GridBox[{
        {"5.163896873671434`", "12.139190963105333`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]},
     {"20", GridBox[{
        {"4.448080086752382`", "10.456462418445913`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.1]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[2.0999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   TableForm[{{0, {{100., 0}}}, {
     1, {{30.04748740180291, 55.624265254097295`}}}, {
     2, {{26.591153461188703`, 55.214072072025616`}}}, {
     3, {{25.605149069937774`, 53.166652270311886`}}}, {
     4, {{24.82563003431588, 51.343655214496785`}}}, {
     5, {{24.156614718849134`, 49.77127907606098}}}, {
     6, {{23.580423760684024`, 48.41679193774216}}}, {
     7, {{23.08410711085121, 47.250060566379645`}}}, {
     8, {{22.656589730781175`, 46.24506082108562}}}, {
     9, {{22.28833459856918, 45.37937363177226}}}, {
     10, {{21.971126807662447`, 44.63368756504546}}}, {
     11, {{17.11476764848863, 39.987125259165055`}}}, {
     12, {{14.678848382540341`, 34.49813661856249}}}, {
     13, {{12.641848430665972`, 29.717915580323762`}}}, {
     14, {{10.889363745888792`, 25.598499445778035`}}}, {
     15, {{9.379882886388717, 22.05005065683906}}}, {
     16, {{8.079648143368281, 18.99348380868588}}}, {
     17, {{6.959651378857702, 16.360616640698403`}}}, {
     18, {{5.994908005670204, 14.092716192308426`}}}, {
     19, {{5.163896873671434, 12.139190963105333`}}}, {
     20, {{4.448080086752382, 10.456462418445913`}}}}]], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641295253*^9, 3.479966512942038*^9, 
  3.479966726736038*^9, 3.479967314515038*^9, 3.479968223188038*^9, 
  3.513396421970271*^9, 3.5823497005494776`*^9, 3.582350442591247*^9, 
  3.5823507537135105`*^9, 3.5823513439311028`*^9, 3.592202405962695*^9, 
  3.642760938226065*^9, 3.650269793708847*^9},
 CellLabel->"Out[43]//TableForm="]
}, Open  ]],

Cell["Here is the retention in compartment 2", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", 
     RowBox[{"t", ",", "10"}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "12"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[44]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV13k0Ve0XB3AzUWYqme/l8pYxTd7y7Gs4dzhXZEoRZQ4pKhl6ZWigJDKV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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 28.},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 12}, {29.071239905874, 56.19467064603366}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806413578124`*^9, 3.479966513135038*^9, 
  3.479966726793038*^9, 3.4799673145910378`*^9, 3.479968223246038*^9, 
  3.5133964220640235`*^9, 3.582349700810504*^9, 3.5823504435265846`*^9, 
  3.5823507537565155`*^9, 3.5823513441561203`*^9, 3.5922024060447035`*^9, 
  3.64276093825732*^9, 3.650269793755721*^9},
 CellLabel->"Out[44]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{
  "model2", ",", " ", "sol1", ",", " ", "sol2", ",", "x1", ",", "x2", ",", 
   " ", "x"}], "]"}]], "Input",
 CellLabel->"In[45]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["The General Two-compartmental System ", "SubsubsectionIcon"],

Cell["The figure shows a general two compartmental model.", "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.12963 0.21164 0.333333 0.21164 [
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.12963 .65079 m
.12963 .43915 L
s
% Start of user PostScript
0 1.5 0 0.5 MAarrowhead1
% End of user PostScript
gsave
.04497 .54497 -80.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
75.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
79.875 12.750 moveto
(H) show
85.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
91.875 12.750 moveto
(L) show
97.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.12963 .33333 .10582 0 365.73 arc
s
gsave
.12963 .33333 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.12963 .22751 m
.12963 .01587 L
s
% Start of user PostScript
0 -0.5 0 -1.5 MAarrowhead2
% End of user PostScript
gsave
.06614 .12169 -71.5 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
73.375 14.250 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
( ) show
75.125 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(o) show
80.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.23545 .37566 m
.76455 .37566 L
s
% Start of user PostScript
0.5 0.2 3. 0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .41799 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.76455 .29101 m
.23545 .29101 L
s
% Start of user PostScript
3. -0.2 0.5 -0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .24868 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.87037 .33333 .10582 0 365.73 arc
s
gsave
.87037 .33333 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.87037 .65079 m
.87037 .43915 L
s
% Start of user PostScript
3.5 1.5 3.5 0.5 MAarrowhead1
% End of user PostScript
gsave
.78571 .54497 -77.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.87037 .22751 m
.87037 .01587 L
s
% Start of user PostScript
3.5 -0.5 3.5 -1.5 MAarrowhead2
% End of user PostScript
gsave
.80688 .12169 -71.5 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
73.375 14.250 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
( ) show
75.125 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(o) show
80.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Text",
 CellChangeTimes->{3.6502699051622076`*^9},
 ImageSize->{288, 192},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztWktvHEUQbs/se9f2bh4QEwdv/IDEjgkSL/EQIoIQOPATICyxk3V4JCQ+
IIG0P8gYuCOUI4oQHMkRTiAuBAmu0dL9zc7k656p3ocNu4eNlJnar+qrru6e
rq6e8Tut3fb2x63dnSut5qVbrZvtnSu3m2/euKWhcEapmbZS6q+60vIXKvxV
LXU73Z1OV6lB70/pS6hUR/82WIl+bg6oD1RPo4XzBtOKMMbCyMUwWA5YAQKw
c51uPsbyKmpXwArAchCGwjY63WKMFWECrAQsgDAUtt7plmOsDBNgFWAVCTiE
2Zjqp/qJ1R/DYs0jVcyR8k8kgEIKB+kRAnLmf09Ws7aHRM5LRnA3h1YCtKhC
g/gov5F1MEggaGOetaEdmtPF39k05zVNXANQtvlxx2fKRtkjGTsLEaBu6VHb
QYh5ynSf7uJJqUOLvvD1fUGIWt8fE6n6vpjF0/dT2bP9eGpGlyZtaUz1U/04
9UktUoWs1CqKowqu/yBvV3FdM8plLCLOJ/eBHMd1xZgsIYcsoIz7A9cFIE2j
PAW7Jq6fUiqOlv6HpDVL1+SXABElzX1CMifY6yRHQZpUYSWTNcBXhcTOchs2
TxJi8pU6AXid4K2OkMTZ2zWSz8AFvHHe3QC8FSNO+uZ+XrVZiWymxJoXnvdW
ktZ7waI5jmuTZJPyrbz/NMnvc49vkuI8yceM8igaeZbgy9wnpT6CwTNkcNSo
jhDwHMnvCU8Bt2C4qkHA8yS/i/ZuCNqGS32B5B8FvG5IdQJeJPkHATf7mbWp
vUzyXQGfc0mvkPy9gIPElcSr9mDr4fhG0JrSxqpvXrP96uTwtaCt+ahVHIu8
1BoBF0gudrqzNvWC7Vim6hXU6EOtEvA6yXfsNMGqist7g2RNqiu1L2i9VF0P
1/pQKwRctLtStKmsLfuoUU3opZYJuETydwJeGh/pLZK/FfDRSbyLvi2QGC+O
j7SMzXtZoDahXfU5WLWdSW5UPt5a1CE4PE3y2kGdLQv2IzlbEeSRnEk2WbMY
2sM61PCXhaA9w+80dzgLbAKThpQO7wi4N4fuYdwaPqqU9PeQuWcFrXe/2MN+
URqUylvYl9il8oLWS+23MUp78T724rygxV4sFQ/7qADKgtZbd+zjmFPzUaVC
6StUOw1BO9uHGti1dIo6Uk3HJedLJN8V8HmXNHCdOlJFLFXgPwk4am+p7t/C
FoUDEf59QLpU7Z8+dJhTDufG7exTh3TeuTzAcXGL5NQxyHMm63903CY5dUTj
A+Q5kpMBUtEyKz7sPTA+96WOkCcIOIu+b6PvOcgc5zXbMpFNWOaEq83POF1J
+rtLiidgag7q1uvEFcBt6ou+3wbIBQF4i4B5M2uT/BnJTViat4XmBUOIJnVU
1wF/Dvkk8CVjcjp+Qaqv90k2LZkAC8go+un6G9caELNrmgHRKfkBrnirMobv
aQG959bK5PhvFlH8fS1aGj20i69qFrQ5rF08WYHdX/OzEM9+L77/g7DBT10G
I1O3nmKGNtNKKBPBXHcMfGTWnc0i8yp/QHLg2G0cmDzul59T/VT/X+rL2BeK
BLPM1egvSN0lwbLuOuaivEAy18ZV232mY7afdxsJoj0kqbycD5qJnIsrhATh
89HPjpec4CVMfXtMfQONPliaMJIsWbQ9iImOI7qXuGFr9uQmq1yfqCyiGFtW
r524LEfWdlZwlFmzP1hoSh08NN/ADRpZYMdXGj4kx0N5xEAelhT2wgqweqXn
+p5NrHXo60q+/4OcqXT/0iBrKfNUzHumQljOfDaTklG0ZI8IlqlkNO4sO9VP
9ZOs7w74N5lq5l8/gx7V\
\>"],ImageRangeCache->{{{191.438, 621.938}, {918.375, 631.875}} -> {-2.7215, \
5.37241, 0.0164924, 0.0164924}}],

Cell["The compartmental matrix is:", "Text",
 CellChangeTimes->{{3.650597960523704*^9, 3.650597976211115*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"model3", " ", "=", 
  RowBox[{"CompartMatrix", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", " ", "k12"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", " ", "k21"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", " ", "k10"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", " ", "k20"}], "}"}]}], "}"}]}], "]"}], 
  " "}]], "Input",
 CellLabel->"In[46]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "k10"}], "-", "k12"}], "k21"},
     {"k12", 
      RowBox[{
       RowBox[{"-", "k20"}], "-", "k21"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806413890924`*^9, 3.479966513261038*^9, 
  3.479966726842038*^9, 3.479967314621038*^9, 3.479968223277038*^9, 
  3.5133964221109*^9, 3.5823497008655095`*^9, 3.582350443669096*^9, 
  3.5823507693990793`*^9, 3.582351344199874*^9, 3.642760938288547*^9, 
  3.650269793786972*^9},
 CellLabel->"Out[46]="]
}, Open  ]],

Cell["And here the SODE ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ShowODE", "[", 
   RowBox[{"model3", ",", " ", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b1", ",", "b2"}], "}"}], ",", " ", "t", ",", " ", "x"}], "]"}], 
  "//", "TableForm"}]], "Input",
 CellLabel->"In[47]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{"b1", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k10"}], "-", "k12"}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{"k21", " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{"b2", "+", 
         RowBox[{"k12", " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k20"}], "-", "k21"}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "1"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "2"], "(", "0", ")"}], "\[LongEqual]", "0"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641420372*^9, 3.4799665133730383`*^9, 
  3.4799667268800383`*^9, 3.4799673148620377`*^9, 3.479968223312038*^9, 
  3.513396422189027*^9, 3.5823497009235153`*^9, 3.5823504437128496`*^9, 
  3.582350769432082*^9, 3.5823513442373767`*^9, 3.6427609383041863`*^9, 
  3.650269793818222*^9},
 CellLabel->"Out[47]//TableForm="]
}, Open  ]],

Cell["In matrix notation can be represented as", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], 
       StyleBox["'",
        FontWeight->"Plain"]}],
      FontSlant->"Plain"], 
     RowBox[{"(", "t", ")"}]}], " ", "=", 
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["A",
        FontSlant->"Plain"], " ", 
       StyleBox["x",
        FontSlant->"Plain"]}],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], "+", " ", 
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}]}]}], ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], 
  TraditionalForm]], "EquationNumber"],

Cell["where", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold",
        FontSlant->"Plain"], "'"}], 
      RowBox[{"(", "t", ")"}]}], " ", "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox[
          OverscriptBox["x", "."], "1"]},
        {
         SubscriptBox[
          OverscriptBox["x", "."], "2"]}
       }], ")"}]}], " ", ";", " ", 
    RowBox[{
     StyleBox["A",
      FontWeight->"Bold",
      FontSlant->"Plain"], 
     StyleBox[" ",
      FontWeight->"Bold"], "=", "  ", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["a", "11"], 
         SubscriptBox["a", "12"]},
        {
         SubscriptBox["a", "21"], 
         SubscriptBox["a", "22"]}
       }], ")"}]}], ";", 
    RowBox[{
     StyleBox["x",
      FontWeight->"Bold",
      FontSlant->"Plain"], 
     StyleBox[" ",
      FontWeight->"Bold"], "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["x", "1"]},
        {
         SubscriptBox["x", "2"]}
       }], ")"}]}], 
    StyleBox[" ",
     FontWeight->"Bold"], ";", "  ", 
    RowBox[{
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}], " ", "=", 
     RowBox[{"(", GridBox[{
        {
         SubscriptBox["b", "1"]},
        {
         SubscriptBox["b", "2"]}
       }], ")"}]}]}], " ", ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], TraditionalForm]], "Text"],

Cell[TextData[{
 "with  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", "11"], " ", "=", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "10"], "+", 
       SubscriptBox["k", "12"]}], ")"}]}], " "}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", 
     RowBox[{"12", " "}]], "=", " ", 
    SubscriptBox["k", "21"]}], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", 
     RowBox[{"21", " "}]], "=", " ", 
    SubscriptBox["k", "12"]}], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["a", "22"], "=", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "20"], "+", 
       SubscriptBox["k", "21"]}], ")"}]}], " "}], TraditionalForm]]]
}], "Text"],

Cell[TextData[{
 "The previous equation can be applied to a particular case substituting ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "ij"], TraditionalForm]]],
 " and the initial conditions ",
 Cell[BoxData[
  SubscriptBox["X1", "0"]]],
 " and ",
 Cell[BoxData[
  SubscriptBox["X2", "0"]]],
 " for their respective values, i.e.: Let's take ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", 
     RowBox[{"10", " "}]], "=", " ", "0.05"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", "20"], "=", "0.3"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox["k", "12"], " ", "=", " ", "0.4"}]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", "21"], "=", " ", "0.3"}], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["X1", "0"], "=", "1"}]]],
 ", ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["X2", "0"], "=", "1"}]]],
 "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t1_", "]"}], ",", " ", 
     RowBox[{"x2", "[", "t1_", "]"}]}], "}"}], "=", " ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "1"], "[", "t1", "]"}], ",", 
      RowBox[{
       SubscriptBox["x", "2"], "[", "t1", "]"}]}], "}"}], "/.", 
    RowBox[{"SystemDSolve", "[", 
     RowBox[{
      RowBox[{"model3", "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"k10", "\[Rule]", "0.05"}], ",", " ", 
         RowBox[{"k20", "\[Rule]", "0.03"}], ",", 
         RowBox[{"k12", "\[Rule]", "0.04"}], ",", 
         RowBox[{"k21", "\[Rule]", "0.02"}]}], " ", "}"}]}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", " ", "1"}], "}"}], ",", " ", "t", ",", " ", "t1", 
      ",", " ", "x"}], "]"}]}]}]}]], "Input",
 CellLabel->"In[48]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"18.918918918918916`", "\[VeryThinSpace]", "-", 
     RowBox[{"4.778241060624656`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.10464101615137755`"}], " ", "t1"}]]}], "-", 
     RowBox[{"14.140677858294259`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03535898384862246`"}], " ", "t1"}]]}]}], ",", 
    RowBox[{"35.13513513513513`", "\[VeryThinSpace]", "+", 
     RowBox[{"3.4979152271890475`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.10464101615137755`"}], " ", "t1"}]]}], "-", 
     RowBox[{"38.63305036232418`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03535898384862246`"}], " ", "t1"}]]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641467292*^9, 3.479966513523038*^9, 
  3.4799667269250383`*^9, 3.4799673149330378`*^9, 3.479968223365038*^9, 
  3.5133964223140297`*^9, 3.582349700977521*^9, 3.5823504439216166`*^9, 
  3.5823507694800873`*^9, 3.5823513442961316`*^9, 3.6427609383354235`*^9, 
  3.650269793865097*^9},
 CellLabel->"Out[48]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], ",", 
     RowBox[{"x2", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", "100"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[49]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVzXs0lHkYB/Bx6Y6jpFA6Glm2psy81NpV3i9LqNwml5+iZqlm3LZxqVjR
rHVcjrNoT7qsNUNY1arRCluURuvSqqacLFnRTdh1mZRcMs2+/fGc7/mc73me
Z23YYf5BbRaL5cXMp2TnqUulaxROLJYk71O6x1YsihHJaFaxf9D9/TLa7zkn
z0Ykp1mpPuGjgXI68Ny433xRIy2RSCZkbo00mfS1mxQqacltY47QUkkHl2qV
jQj76eIvk4Lb+vvoPbPBIUPCcdpwdWxK9N4xuscqw+G1UEMPBSiOngtV0+XJ
Wh91Qg1R5XtbdzBHD/rVMnmFjwmQrJNUN2aEX7bPafP0LSDVChl50GkCaVja
yxXu65AQqnDqyDbHtpLBA3cdbDA6cE03u84Cbbm/Fuqe4ODi3YiiD2fZ6Dn0
zU/lhAtvccYjgdM6yFbut5Z7Udik3d/VJ7NCj2zRSnW0PSQxySYVM58h/Lpl
EE+0BTnODlFnzG1QlByNqGAHGFYbCPnsz+FlHJY+nPAVnBPu8ucs12MnWk28
o7dCWzz0z17NejS6PFkw9aMTzBLP9jd0b8DEe72HHXwgJqfbTF7IAcf4oGvR
Lmc8YJ1m17hsxFqZ0evsvS4If/a8x394I26+mZFHkK+R0KueL0nchOVVWyqi
Il3RrrWsRrzAFneaFseLj7nhjkzrxsksW5hJVwhFcdtx+fx01/CULTgDiVlp
ae6II3NftNhxMfBuWUeexAOrWsWC2XAu3hNXlSzJE5EbUwz68rhosrnn2JG5
A+crRTXaDVxsVuTIp37YifQH7lV2L7gIby7xpQt2wbT5UeaphTz8a+7Tkl3i
BePh5Zy4DTyY0PYHWgu9oWvq8b7ckwete4dtrX/zgXmbdYGhiIe2/Nil2/x9
EfBUvjImjYeGgaOTwoe+8AxLa5b8zEOu2FplGeSHM7kzwvbfeajuf5v65LEf
+CQxqLeVh9r0qHUWoXzc6nzJMX7Kg76BJlTQy4dR0YWbKeM85Dv3abGDd2Oe
Y7SeL4uC6pKoIeHZbgyxV5/yWEqhbNpgiWKfP3RGc/drW1DYfFwglg76o7Fh
QUjXJgpvL6ppdUwAXIW8o2QrBd2G2tKA/wLgWY8BQw+m11m1ho4PxNspTd+L
3cw+t5DDnghEfYSBq9U+CqXzheUZ3wahsqC2NUNIYXxZn/3xySBkSbxvaMQU
8nRiSVQ8gdnJkTqHJAqu2qOXio4QZBtetQphPM2KUCuPEbS7HM46wVjwUXDe
/jjB04zXnBbG1IzviDqdoERhMcH/jsLfY1xJ/mmCJSuaxJHJFNb0qCpqrhMc
EYgDT6ZQ6OiOnh2sJ4hx0omsZpzZNbTL7BaBePZDXCdj1eNnb1KbmPs7OAdN
Uyk0KR86erQTlLe8+quY8aHmKmVPL8Gr7ALp5RMUzP7ksPX7CRyily5WMlY2
XUignxPMVVpHqRg73C42LRsgULhxDewkFBbX54fHjBEkpep11zG+dV2vVqYi
uDKvVtXNOP6PrIUdEwSFbUaaGca9NZLLW6aYf73Tc47fU8i/NqcRzRDsOZcx
EsLYrTqRX/iBoEHY+SiF8ezVd2X31QQGyUOVUsZXqsRTGg1B4Lw7KY2M/wdO
WTCb
      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV0ms01HkYB/BBdEFbitTuzpFqDWfchpDB/6uQ1n2Qn6QlmZkWRVQqtRZb
Oto4ndMVM01DKlsjYdfmOq3YUy0rFZNCLbq6FeM2Zv+9eM73+ZznPM+rZ/XO
vbxYTQaD4UfXlzTNVUlFzEY3upV8yc1JJQsThGKKwfKR2AjEVFAfO5cllFGM
3vP+t2Jl1NaLw0E6wnqKMXdsQjemniLjgXbjglaKUeXDfBvZSoVLNYo+CHoo
xtRRx9TgHmrbdPj2N4JhqoEz/eSC6zClWHfcaUCgpqBdMzmrr6aKj2jMaUUu
AXbd3VHb+xX074hlJQHGSD23qFzquwIFXrOatvomyF6el9nnzIRoZ8Zro81r
kfa89oVLhSlcJYO7/nZiQXNI3HXq9Tq0nL6aP+8nNs74sbg3WOZQ8KPPFBMb
8GdaIlqs2RCv+MFM5sdBVUKtZXuXFRTihStU8fZ4FVhjMd5ig5jqNWG2QgeA
syWDNW2LwiPxiAt3gmHiz4svLbODn+HOrLcpzuBrMwcnbO3hg2Zj/3gXxIx5
b7Rkr0f9xq75yl/dYBF50LzT3AFjE3pt7TxA1JXFMjJwBNsw1qPQ1x1mzWd/
yel2xGrxsoGTERtxKbn8gei6E2pHp2S7ySYsKbb8znH7BiwvcyiJ+9EDnZV9
xdIlzrgnX5SceNATV6KspiMrnbFKZCQQ7vPCvieG20o9uGD3p2ZnZGxG3T7d
DQeecNH/2aA9N90b/5VYpEcEu2CCeIyID22Bf73hcul9F8hZD7ntJ77HlFzb
xJLrivWNOTJlpg8qLHNLUy67IqZJEkid9YVr0msXiY4b3n0bcP+kxA8Llt4O
ao5xgzFlv6s53x+d5SesKircoPFwr7VZaQB+u2BgtFuHQkte0lLXkEB0mHR3
RftRqOk/MC5oC0RlU/QQ7zSF04lmI2vCgnD4ar7z51YKd3o+HevqCIJtwDda
h+cBVVlxa00ieZiKMNq0YTWgv1gdGdXNg7+51oy1M5Dn/lLDNDwYsR+tOdpB
wMgNYU1KbzD4jhL7ZUKgaHKxbuOOENzb+9LKOA1YnxaVKBoMgaojWOiZB3y6
rqJUCaHgpT8avXoFmFdTJQ19H4qjBcrHBeX0XOtrJpW8FewchfXvcnrfJp9t
OrYVzz91HCpvA6Q6guLje8JAeTG90l4AwwYv7dPGwzD/+f5B/jsgVyuJxCUT
LLQpe184DnhofrxRuJ9AsSeM+of2JGO3qvUgQVaDOnOOdtRc1BX7NIItHH7v
jgn6DacCP6iyCIix3gBTCTwdsknPO0egzGpiFUwCTMVISWU1Qera0dKcGaC9
M3568C5ByP7LrD9pn3j2xndVHcGrx6/OvaE90tE7ekxOIMrneHvOAvLWNq73
A4KldkfmVLT5TWWtim6C6XdnauPngFV/sU31ewj+Lc0OvUS7VX4theojMIsm
Pc20nRouryzqJ3CzO99iqgYW3c2LSRgiaBzSG3tGu65ar0o8QtDw1HelNsMd
yX9kL2gfIxiTnuRwaHdXpt90UBLIfHW5p2jnVcyqhVP0vQ5iUU3b804qL3+G
QPdihe4A7enbn4seqQjqPpr2GGi441ZZolKtJri55loRRft/NowxVQ==
      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 100}, {0., 34.00975473604135}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806414985714`*^9, 3.479966513615038*^9, 
  3.479966726970038*^9, 3.479967315014038*^9, 3.4799682234130383`*^9, 
  3.5133964223921566`*^9, 3.5823497010355263`*^9, 3.5823504439653697`*^9, 
  3.5823507695330925`*^9, 3.5823513443486357`*^9, 3.6427609383666725`*^9, 
  3.650269793896347*^9},
 CellLabel->"Out[49]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"model3", ",", "x1", ",", "x2"}], "]"}], ";"}]], "Input",
 CellLabel->"In[50]:="]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tricompartmental Systems", "SubsectionIcon"],

Cell["\<\
The analysis of model given above in the two variable cases can be \
immediately generalizes to a system of with 3 or more compartments. In this \
section we show two models applied to represent drug administration process.  \
Other one is applied for people that intake lead in pollution environment. \
Finally it is presented the general tricompartmental model.          \
\>", "Text",
 CellChangeTimes->{{3.650597997320309*^9, 3.6505980092578025`*^9}}],

Cell[CellGroupData[{

Cell["One input and first order abortion ", "SubsubsectionIcon"],

Cell[TextData[{
 "This figure show a tricompartmental model. In ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0"}], TraditionalForm]]],
 " is assumed that one amount ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is present in compartment 1 and 0 in the other compartments. A continuous \
liberation from a to 1 happen until that the initial amount ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " is completely removed from a.\n"
}], "Text",
 CellChangeTimes->{3.6505980216171045`*^9}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .25 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0833333 0.119048 0.184524 0.119048 [
[ 0 0 0 0 ]
[ 1 .25 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .25 L
0 .25 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
newpath
.08333 .18452 .05952 0 365.73 arc
s
gsave
.08333 .18452 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.29167 .23214 -68.4375 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
73.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.14286 .18452 m
.44048 .18452 L
s
% Start of user PostScript
0.5 0 3. 0 MAarrowhead1
% End of user PostScript
newpath
.5 .18452 .05952 0 365.73 arc
s
gsave
.5 .18452 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .125 m
.5 .00595 L
s
% Start of user PostScript
3.5 -0.5 3.5 -1.5 MAarrowhead1
% End of user PostScript
gsave
.46429 .06548 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.91667 .18452 .05952 0 365.73 arc
s
gsave
.91667 .18452 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.55952 .20833 m
.85714 .20833 L
s
% Start of user PostScript
4. 0.2 6.5 0.2 MAarrowhead1
% End of user PostScript
gsave
.70833 .23214 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.85714 .16071 m
.55952 .16071 L
s
% Start of user PostScript
6.5 -0.2 4. -0.2 MAarrowhead1
% End of user PostScript
gsave
.70833 .1369 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Text",
 CellChangeTimes->{{3.6502699201935472`*^9, 3.65026992867794*^9}},
 TextAlignment->Center,
 TextJustification->0,
 ImageSize->{288, 72},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzFWEtPFEEQLnZmd2FhdmcAYZWN4vuqsi4PUYgajAePPOS2IcYFRRGJiYmm
48Gjib9AL959/SH/ydhdwyxfT0/vzG5MJKGn+Krrq+6a6ppqHrWPOk/220e7
O+3ZB4ftg87uzuvZtZeHEnKGiIY6RLTtk5TfkfOHzoUi3BUhUfL5Ww4OkZB/
0698gBycCM4Wf4qwSJFZpvhDhGUGcojfRTjCgE0cYF//AvjG2ykAXExO+SLC
Ak+RKDkKkb9dC4mVkhZf5eAeA2xRjv44trVYxHRuTgMn/9ST1RR4M26v/eJa
5LNq1ctnkB6sif/zMrOBBmfkJxEOE92HNxptdZW1DQXURShjVubxI4/DPK4C
owPyMsyvK4IpDkSNxw88+jzOp2UTMi2B4ZTST8YhleN7HiOklcyymAGzeQGM
J9XEcRanYcpbkE+B3MQ8SJPls2WwqYzQ0qIO8huefhqQuW4eu3EeR1uT4xmY
5ytaHwBUHlnwGxihO6CYAbmmlDUAGiAfWvDr+hlZtkxTZ0c7QGdBPrDg0cvC
Jd5mZBYQTxF7AKDyhY5H2VTieBb0OJwHeSwvJRpVuIBv96IcA+ACyM9Bvgiy
rEce0WOLdrQfym5KBRmEowBcAnkP5Msi3Ce6qm8+t+nJWnyirYROI6wAcAXk
jgWX8RrTKVE7MghlhevgQJQbfJ7xOGHEPNZuWrRZxGU92mj6NC+lrxd9LFTr
HMiSPrnIFTPVj6k1vNWEXtfGdXe+3nmMW+SEUyqefPGz3ad9FCTJs+hzkOUO
44Pzh1PiWjT2F8AnbiKHN1sA+tkY+pd1pJiDHpeAywx6LcHnTz3SyAytcJvQ
l8NJy/KzDkNJL4NRXiPZetx0DJY7CXcJKjQNjIV5xsIm8rqylaQN/tDYrJgy
byUGSk8/70YtHoAy0M+0QdnX51C+pD04Q7iEvj6EsbzJNce1aJmy3w5gi6vm
iEU7UFOxxaW+2ovS1lMt8qmcA+QcyE0uUrx//mkYuYmzvQxHUmxatLLJ107a
Tcs8doHFbIZPWhPuCNht476wzbyWdaeYM1zE/XSizVYL7XbMLvTi2I5qbbXt
4oGhwYafHWP5mE64jxN/hf3W03ZhuSS3jNsFO8P3G92cFjhSqwbeiiOeuCLP
GzMVp1ZtA4aXMDLIjxvW7m33DA51BVODywenAJeL6K6xwqoqqxZ11V2wUmFV
sfD0jn9NhFWiW4A85DkqarTDlp95fCXgn0409BcJMduH\
\>"],ImageRangeCache->{{{135.938, 566.438}, {198.938, 92.4375}} -> {-3.42488, \
0.272717, 0.0295777, 0.0295777}}],

Cell[TextData[{
 "The kinetics of amount",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["x", "i"],
      TraditionalForm], "(", "t", ")"}]}], TraditionalForm]]],
 " will be given by the differential equations"
}], "Text"],

Cell[TextData[{
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "a"]]],
 "(t) = - ",
 Cell[BoxData[
  SubscriptBox["k", "a"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "a"]]],
 "(t)\n",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "1"]]],
 "(t) = ",
 Cell[BoxData[
  SubscriptBox["k", "a"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "a"]]],
 "(t) - (",
 Cell[BoxData[
  SubscriptBox["k", "10"]]],
 "+ ",
 Cell[BoxData[
  SubscriptBox["k", "12"]]],
 ") ",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(t)  + ",
 Cell[BoxData[
  SubscriptBox["k", "21"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "2"]]],
 "(t)  \n",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "2"]]],
 "(t) = ",
 Cell[BoxData[
  SubscriptBox["k", "12"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(t)  -  ",
 Cell[BoxData[
  SubscriptBox["k", "21"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "2"]]],
 "(t) \n"
}], "NumberedEquation"],

Cell[TextData[{
 "We will add the initial conditions: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     RowBox[{
      SubscriptBox["x", "a"], "(", "0", ")"}],
     TraditionalForm], " ", "=", " ", "d"}], TraditionalForm]]],
 " corresponds to an instantaneous \"release\"  ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 ". In the rest of the compartments we suppose that the concentration is null \
in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 ", that is ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     RowBox[{
      SubscriptBox["x", "1"], "(", "0", ")"}],
     TraditionalForm], " ", "=", " ", "0"}], TraditionalForm]]],
 "; ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     RowBox[{
      SubscriptBox["x", "2"], "(", "0", ")"}],
     TraditionalForm], " ", "=", " ", "0"}], TraditionalForm]]],
 ";  "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"model1", "=", " ", 
  RowBox[{"CompartMatrix", "[", 
   RowBox[{"3", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", " ", "ka"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", " ", "k21"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "k10"}], "}"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[51]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "k10"}], "-", "k12"}], "k21", "ka"},
     {"k12", 
      RowBox[{"-", "k21"}], "0"},
     {"0", "0", 
      RowBox[{"-", "ka"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641529851*^9, 3.479966513744038*^9, 
  3.479966727021038*^9, 3.479967315214038*^9, 3.479968223438038*^9, 
  3.5133964224390335`*^9, 3.5823497010835314`*^9, 3.582350789615101*^9, 
  3.582351344386139*^9, 3.592202504761574*^9, 3.592202717875883*^9, 
  3.59220275784788*^9, 3.592203071569105*^9, 3.6427609383979235`*^9, 
  3.650269793927597*^9},
 CellLabel->"Out[51]="]
}, Open  ]],

Cell["The equations are written as", "Text",
 CellChangeTimes->{3.6505980268358245`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{"ShowODE", "[", 
    RowBox[{"model1", ",", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", " ", "t", ",", " ", 
     "x"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5922030613150797`*^9, 3.5922030676357117`*^9}},
 CellLabel->"In[52]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "//", "TableForm"}], "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[53]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k10"}], "-", "k12"}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{"k21", " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}], "+", 
         RowBox[{"ka", " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"k12", " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "-", 
         RowBox[{"k21", " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "3"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"-", "ka"}], " ", 
         RowBox[{
          SubscriptBox["x", "3"], "(", "t", ")"}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "1"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "2"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "3"], "(", "0", ")"}], "\[LongEqual]", "d"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280641576771*^9, 3.479966513976038*^9, 
  3.479966727073038*^9, 3.4799673153290377`*^9, 3.479968223497038*^9, 
  3.51339642251716*^9, 3.5823497011795406`*^9, 3.5823507897451134`*^9, 
  3.582351344451144*^9, 3.5922025048995876`*^9, 3.5922027180278983`*^9, 
  3.5922027580288982`*^9, 3.592203071738122*^9, 3.6427609384291954`*^9, 
  3.650269794005722*^9},
 CellLabel->"Out[53]//TraditionalForm="]
}, Open  ]],

Cell["And here the solution is ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "[", "t_", "]"}], ",", 
      RowBox[{"x2", "[", "t_", "]"}], ",", 
      RowBox[{"xa", "[", "t_", "]"}]}], "}"}], "}"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "1"], "[", "t", "]"}], ",", 
      RowBox[{
       SubscriptBox["x", "2"], "[", "t", "]"}], ",", 
      RowBox[{
       SubscriptBox["x", "3"], "[", "t", "]"}]}], "}"}], "/.", 
    RowBox[{"DSolve", "[", 
     RowBox[{"eq1", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SubscriptBox["x", "1"], "[", "t", "]"}], ",", 
        RowBox[{
         SubscriptBox["x", "2"], "[", "t", "]"}], ",", 
        RowBox[{
         SubscriptBox["x", "3"], "[", "t", "]"}]}], "}"}], ",", "t"}], 
     "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[54]:="],

Cell[TextData[{
 "The solution is valid for any value of transfer coefficients. We apply for  \
the following values ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["k", "a"],
     TraditionalForm], "=", "2"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["k", "12"],
     TraditionalForm], " ", "=", " ", "2"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["k", "21"],
     TraditionalForm], "=", "1"}], TraditionalForm]]],
 ",",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["k", "10"],
      TraditionalForm], " ", "=", " ", "0.5"}]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", " ", "=", " ", "100"}], TraditionalForm]]]
}], "Text"],

Cell[TextData[{
 "Here is plot the concentration xa[t],  x1[t] and x2[t] for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "\[LessEqual]", "t", "\[LessEqual]", "10"}], TraditionalForm]]]
}], "Caption",
 CellChangeTimes->{{3.5922031107210197`*^9, 3.592203111450093*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xa", "[", "t", "]"}], ",", 
       RowBox[{"x1", "[", "t", "]"}], ",", 
       RowBox[{"x2", "[", "t", "]"}]}], "}"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"d", "\[Rule]", " ", "100"}], ",", 
       RowBox[{"ka", "\[Rule]", "2"}], ",", 
       RowBox[{"k10", "\[Rule]", "0.5"}], ",", 
       RowBox[{"k12", "\[Rule]", "2"}], ",", " ", 
       RowBox[{"k21", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"PlotRange", "->", "All"}], ",", "\[IndentingNewLine]", " ", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Green", ",", " ", "Dashed"}], "}"}]}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<days\>\"", ",", " ", "\"\<r\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<xa\>\"", ",", "\"\<x1\>\"", ",", " ", "\"\<x2\>\""}], 
       "}"}], ",", "Right", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.479966624969038*^9, 3.5922024952776256`*^9, {3.5922025352016177`*^9, 
   3.5922025357606735`*^9}, {3.5922025765117483`*^9, 
   3.5922026098490815`*^9}, {3.592202664661562*^9, 3.5922026778648825`*^9}, 
   3.5922031052954774`*^9},
 CellLabel->"In[55]:="],

Cell[BoxData[
 FormBox[
  TemplateBox[{GraphicsBox[{{{}, {}, {
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         RGBColor[1, 0, 0]], 
        LineBox[CompressedData["
1:eJwVV3c4198Xt/fe2+fjg4qSlVC9z0mhUraGZJPsJFlJEdkjo2VFUoSKMvoi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         "]]}, {
        Directive[
         Opacity[1.], 
         AbsoluteThickness[1.6], 
         RGBColor[0, 1, 0]], 
        LineBox[CompressedData["
1:eJwVlnk4Vdsbx0WUiltEHMpwSsbMc7zvzlVKg0KGuklmJYVuRCIlyqzQRKmM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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6], 
         Dashing[{Small, Small}]], 
        LineBox[CompressedData["
1:eJwV1Xc8VY8bB3BXqUSKIsnsalHXiLKfx7onUUYbyYisiCRNREZIVkpIUklZ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         "]]}}}, {
     DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {
        FormBox["\"days\"", TraditionalForm], 
        FormBox["\"r\"", TraditionalForm]}, AxesOrigin -> {0, 0}, 
      DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None}, 
      PlotRange -> {All, All}, PlotRangeClipping -> True, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
     FrameBox[
      FormBox[
       TemplateBox[{"\"xa\"", "\"x1\"", "\"x2\""}, "LineLegend", 
        DisplayFunction -> (FormBox[
          StyleBox[
           StyleBox[
            PaneBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[1, 0, 0]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 1, 0]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0, 1, 0]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6], 
                    Dashing[{Small, Small}]], {
                    LineBox[{{0, 10}, {40, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6], 
                    Dashing[{Small, Small}]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {40, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
              "Grid"], Alignment -> Left, AppearanceElements -> None, 
             ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
             "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
           FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
           False], TraditionalForm]& ), 
        InterpretationFunction :> (RowBox[{"LineLegend", "[", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[1, 0, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0.6666666666666666, 0., 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[1, 0, 0]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[1, 0, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[1, 0, 0], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0, 1, 0], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> RGBColor[0., 0.6666666666666666, 0.], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0, 1, 0]"], Appearance -> None, BaseStyle -> {},
                     BaselinePosition -> Baseline, DefaultBaseStyle -> {}, 
                    ButtonFunction :> With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0, 1, 0]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0, 1, 0], Editable -> False, Selectable -> 
                    False]}], "]"}], ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"Small", ",", "Small"}], "}"}], "]"}]}], "]"}]}], 
               "}"}], ",", 
             RowBox[{"{", 
               RowBox[{#, ",", #2, ",", #3}], "}"}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"{", "}"}]}], ",", 
             RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
        Editable -> True], TraditionalForm], RoundingRadius -> 5, 
      StripOnInput -> False], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280644407593*^9, 3.479966520845038*^9, 3.4799667349060383`*^9, 
   3.479967320049038*^9, 3.479968228698038*^9, 3.5133964267985196`*^9, 
   3.5823497094863715`*^9, 3.582350797788918*^9, 3.5823513548969793`*^9, {
   3.5922025114822454`*^9, 3.5922025374338408`*^9}, {3.592202578338931*^9, 
   3.592202610865183*^9}, {3.592202666811777*^9, 3.5922026784899445`*^9}, 
   3.592202722774373*^9, {3.592203085209469*^9, 3.592203106233571*^9}, 
   3.642760939085438*^9, 3.6502697946307764`*^9},
 CellLabel->"Out[55]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"xa", ",", "x1", ",", "x2", ",", "model1", ",", "eq1"}], " ", 
   "]"}], ";"}]], "Input",
 CellLabel->"In[56]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Order-zero input and first-order abortion ", "SubsubsectionIcon"],

Cell[TextData[{
 "Other usual model in drug administration consist in a order-cero input to a \
constant rate and an absorption through a first order process. This process \
can be represented by a tricompartmental system as above section with we add \
and input  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "a"], "(", "t", ")"}], TraditionalForm]]],
 "  to the compartment as it show in the figure 8"
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .375 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0833333 0.119048 0.1875 0.119048 [
[ 0 0 0 0 ]
[ 1 .375 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .375 L
0 .375 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.08333 .36607 m
.08333 .24702 L
s
% Start of user PostScript
0 1.5 0 0.5 MAarrowhead1
% End of user PostScript
gsave
.04762 .30655 -68.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(F) show
73.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.14286 .30655 -77.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.08333 .1875 .05952 0 365.73 arc
s
gsave
.08333 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.29167 .22321 -68.4375 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(a) show
73.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.14286 .1875 m
.44048 .1875 L
s
% Start of user PostScript
0.5 0 3. 0 MAarrowhead2
% End of user PostScript
newpath
.5 .1875 .05952 0 365.73 arc
s
gsave
.5 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .12798 m
.5 .00893 L
s
% Start of user PostScript
3.5 -0.5 3.5 -1.5 MAarrowhead2
% End of user PostScript
gsave
.46429 .06845 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.91667 .1875 .05952 0 365.73 arc
s
gsave
.91667 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.55952 .21131 m
.85714 .21131 L
s
% Start of user PostScript
4. 0.2 6.5 0.2 MAarrowhead2
% End of user PostScript
gsave
.70833 .23512 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.85714 .16369 m
.55952 .16369 L
s
% Start of user PostScript
6.5 -0.2 4. -0.2 MAarrowhead2
% End of user PostScript
gsave
.70833 .13988 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
 ImageSize->{288, 108},
 ImageMargins->{{0, 0}, {0, 0.5}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzFWVtPE0EUHna3La0tvdDKTaReeRTkLgQJKugDr3LxiRATMIgIJPpA3Bhj
eDL+A3kxvnr7Q/6TdeZsW74zu7PdVlQTp2e/c5vLOWfO6Mrm0fbT55tHO1ub
1eWDzf3tna3D6tKLAwnZHUJ0bAshTgpC0sfC/iWGPNfbcT0hTL8/5WAL4cpv
8SMeIAfbh5uT310vIXy1VshvrpciIAb51fXSBJjINpbYBvCZZm8BnNBFvsgh
5QPqU/0VSV3ok+tZZEeiwq7JNcyGaZzKwakBpNHUxymYc2Iq2GTb8hWMS2Rz
KUT5lb9dRr78LYZvTPc/OczmwIDrJYX4SOMSHJa/sgXCBxXQ43oO7agcT4Be
BIs20HMg06cMVGjdXTS+A3omLFDQ0h0Q7lH8biJLNLpAT+sBVLeA0TwNChUl
WAJmmeDjADKJBx5Gy99JkrwIiLLMzr8H6NcGfIw2wjlbCpmd4tL+Cnhk9hH8
KoCM4a4sBNjKhMgDPAD0IYkMAjLKQ38uIKCSgWUEMl8CfRnoEaDnDTI5ZTgH
wBDQ+wa8SLvZT7NciDKcBeAK0HsGPEuF+wkgVc4V4gIA14DeNeAyV7JCbABy
lebdljEZ8gVuDLkZZTIDwA2gn3F8T4ibbaqehbCcyzrwrsc1uAM0ziJBe7Vm
4KbbMZmhE400mQZgGOjHFGV5AzdH3DUDt7OJ4RQ/e+RuxzVZ4IW9yD1k+UVZ
oAagZPCTJ253lLe8y2tXibsr8O6iZKA1pyJxdrc3dx9W+OW6doWq503dYVUt
R7kKbpVcXxGuse4Y3vA02l0Y+s8J1s7E2V+TTNiCHb790mFGkGArDtFCMcqh
lgxJXqj9uC4bnLQUNZoji9+tpjUFEz84JXLVajFaDST+H9e31UCmxzapl3Uw
WeBNUOzCPkGRNMq5YVeN6eKbpI0eM3DXKA9tAzfS8C3oRzHNRs2uZMqlolyZ
mgtlEhtW6XfcILpOeYZzrpJ8ZFd0u07L6J81yGxQVmGwB3ojUzfnt6qzBtUJ
Ko7UydKfQZpvOcqRqQ0dx31Cf5eAHol8cNashClSx4ob0B+m5Pe7/lsEtfUz
DC3R4wE1cqq9DbQ+/26Ai5NxDK4mgO4lLeWFVa0KTyOLP+IqfN52+NN6imvU
XrT6hSfhNwFkCnfMCrzFpwJxQpbL9aIsx7dAz/ADWgSWeoupwaELSo7vgcYw
WiYkRQHbq5RkBHQK8YHGebK1QgWZXsIYtvLvwxpm0T9GPVJfg7RtMb8sCFcJ
LytSRUrCXxQtrO6mHby+ORaf9oM4/AHtqKIFbC5w/3wE+l1+jceRcbjMvbgy
hqP961iJggL7kXQ9JBtIiusN6+nWybVtrp3m2uqaVdeSXzEdfk9bWLaxl8Qt
s8lFgptVNzyVci2/0y5/EtjaN3YlVvQ5NVw0kh7dpSKU05qTOp0Md+Bf/4lz
tXk2Ufho7Ei7RqH8qQYhiaXa9ruPhquE+czwasL1FrVvLRAhlPAS1R5+YdH7
v7ItLuYZ/q9BdPwGHsA0WQ==\
\>"],ImageRangeCache->{{{191.438, 621.938}, {613.313, 452.813}} -> {-4.48178, \
7.31202, 0.0294395, 0.0294395}}],

Cell["We can represent the above model as ", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["b", "a"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{"-", " ", 
     SubscriptBox["k", "F"]}]}], TraditionalForm]]],
 " \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "a"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", 
    RowBox[{
     SubscriptBox["k", "F"], " ", "-", " ", 
     RowBox[{
      SubscriptBox["k", "a"], " ", 
      RowBox[{
       SubscriptBox["x", "a"], "(", "t", ")"}]}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "a"], " ", 
      RowBox[{
       SubscriptBox["x", "a"], "(", "t", ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["k", "10"], "+", " ", 
        SubscriptBox["k", "12"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "21"], "(", "t", ")"}], " "}]}]}], TraditionalForm]]],
 " \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "-", "  ", 
     RowBox[{
      SubscriptBox["k", "12"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", "t", ")"}], " "}]}]}], TraditionalForm]]]
}], "NumberedEquation"],

Cell[TextData[{
 "Zero-order mean that the input is given by a constant rate ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "a"], "(", "t", ")"}], "'"}], TraditionalForm]]],
 " = -",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "F"], TraditionalForm]]],
 ", and therefore a constant input ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "F"], TraditionalForm]]],
 " to compartment a.   The total release amount is called ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " that is equivalent to taken as initial condition ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "a"], "(", "0", ")"}], " ", "=", " ", "d"}], 
   TraditionalForm]]],
 "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["b", "a"], "[", "t_", "]"}], " ", "=", 
  RowBox[{
   RowBox[{
    SubscriptBox["b", "a"], "[", "t", "]"}], "/.", 
   RowBox[{
    RowBox[{"DSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            SubscriptBox["b", "a"], "'"}], "[", "t", "]"}], "+", 
          SubscriptBox["k", "F"]}], " ", "==", "0"}], ",", 
        RowBox[{
         RowBox[{
          SubscriptBox["b", "a"], "[", "0", "]"}], "\[Equal]", "d"}]}], "}"}],
       ",", 
      RowBox[{
       SubscriptBox["b", "a"], "[", "t", "]"}], ",", " ", "t"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], " "}]}]], "Input",
 CellLabel->"In[57]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"d", "-", 
   RowBox[{"t", " ", 
    SubscriptBox["k", "F"]}]}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806444701524`*^9, 3.479966521485038*^9, 
  3.479966735062038*^9, 3.4799673201380377`*^9, 3.479968228875038*^9, 
  3.513396426876647*^9, 3.5823497096563883`*^9, 3.582350797927932*^9, 
  3.5823513550194893`*^9, 3.5922027230263977`*^9, 3.642760939116687*^9, 
  3.65026979470885*^9},
 CellLabel->"Out[57]="],

Cell[BoxData[
 RowBox[{"d", "-", 
  RowBox[{"t", " ", 
   SubscriptBox["k", "F"]}]}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellLabel->"Out[58]="]
}, Open  ]],

Cell[TextData[{
 "We suppose that ",
 Cell[BoxData[
  FormBox[
   RowBox[{"d", "=", "100"}], TraditionalForm]]],
 " and  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["k", "F"], "=", "0.1", " "}], TraditionalForm]]],
 " and plot ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["b", "a"], "[", "t", "]"}]]]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{
      RowBox[{
       SubscriptBox["b", "a"], "[", "t", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "\[Rule]", " ", "100"}], ",", 
        RowBox[{
         SubscriptBox["k", "F"], "->", "0.1"}]}], "}"}]}], " ", "]"}], ",", 
    " ", 
    RowBox[{"{", 
     RowBox[{"t", ",", " ", "0", ",", "1200"}], "}"}]}], "]"}], 
  " "}]], "Input",
 CellLabel->"In[58]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVznk41HkAx/ExS9uiiFobadW2sTq2MYmcn0jGlSHGpHSJyJ3RNgyPcpUx
0/ghFZGrrFDu3N+SNNslrUL1qLaEEvU4mlWs/ePzvP/8vFYcCHH1odNoNKe5
/d8qzteJkTKZRU5Qw8TsLBdT6eYdLuKnlj38rqnCb1zMFO8PWC5+Z7kocVhm
N80FvSq8WV48ZZmQozmTNsmF/HXBwJToewQ9jJynN8JFgolc1CeRBswYphrs
Pi7ao6xtPop00TfeaHyxmguf7IMlH0RG0BA0R8GfC/5m+rcEIQtu11IGuto9
YH+7rq3Z1BXtCn93bV7ngff+kfFSdS6y9TyVczM5+Jhm7Z5/eA8Mw0r1ORPu
+Hi9TClT/wDknx3965WXO35838Sz3uuDjMMLnFvr3cDSpHZ9ifeDsOO1TtZP
bggpWNiYyAtArc0GnsOJHegIEedHFQSjaMiu1KnfFYp3PeV+fRAKafkzn1W2
rqjZ7RKqan0ELltKA2UVLpCdtvvl6tNwZMtYXB1VFxiHZlAmLhFY9tirXYvP
hsrn1zb84aO4URi9vqvEGQFH1I3NBMegatEc6O+/HTdzMwfef+bj7tKRsj/N
nVARrN27/VQUlLfUXBd9cUDW8GRSjnw06kqCbmtK7aE9vysyLzcGg3tbLjjE
2kFNjcVJXxqLf66mqPDNWUibZDs96I4Fy8oh3lnVFi+veA68yjsOpk7+TanU
BleMxC8C9p3ASQx9N3J2K+qsmONGWnEoni7rVw62hmR5b+mLt3FwpCsldP5m
hXedxW2y/Hh4OnDXmU8DP7jxBaMhCXjTGmWR5WuJYE6jm+7mRFxcbuVR89oM
Lr/rCrvHE7GBPhSxItkEsz1p3l4kCZ0Cots9Y4Q1O/XP74o5CQiO9fflGOIc
12Asy/gUWBVr7vXaM/FYz3Swhp6M3dEqjjq3NkD4MMhiW2syYrMvF4Q9WgsV
27xN14RC+AWmdjNqdKGaMZMisU8BbZuZ+pnRlXA/cJ9epSACe0ljRG/cMvjQ
Lmhe7RRh7N/WRUVeavjMOyNZIRaDvBMlh0nl4NQgKQ7adRq0sOlLOz51t/Is
Z0aj1SSARvi9r2/nEbkFUpPYUAnGHI9H5vYuJuNW6ZyQJxLQKudZrVT6maw+
yMs7Z5iKQTkFfrntKiLbuuDrGyoVxZaqh3o/6RED8SVd7S+pYDs3rI+QW09K
brqdkHAoFJe4RGzyYpDKGwxs4lJ4rthz/sYhBqknC2ee7aQwP2APcTzCIHda
7vB1vSj4rQlQ8k5ikLcNZmEt3hR0SuPzTlcwiE7Vqn0fQilkl9XdH1QwIGcK
xs1ZQgqSa9qrs8oNSE7+o+mRFApEtdBhdb0BKcorr08TUxgL1Q+raDMg1bl+
hv2pFNgMo6aOHgPyKOv52qNn5/4r2a7jdCZRTr+lVVhEIbYqLsbJg0kWp+X1
2l2mUK2uWNizn0m0qJjM0WIKL8MlUu9AJtGXGKubllLAxguLI48zCSulVLGr
kgKtprbk0hUmYQtP3fmjmsLGJeadjFom8Uj2TdSupbAvom2iiTCJ70kdun/9
nNewE4+7mSQo6VvrwsY5bwbHd89LJuEl9kVXN1FYNvlcODTMJIKEOlPPljk/
x7uCN8EkcfHpstlWCoLaoSezs0zyH4HDTds=
      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 1200}, {-19.999997551020428`, 99.99999755102041}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806445014324`*^9, 3.479966521743038*^9, 
  3.479966735110038*^9, 3.479967320173038*^9, 3.4799682289320383`*^9, 
  3.513396426954774*^9, 3.582349709722395*^9, 3.582350797979937*^9, 
  3.582351355065743*^9, 3.5922027230804033`*^9, 3.642760939147931*^9, 
  3.6502697947401114`*^9},
 CellLabel->"Out[58]="]
}, Open  ]],

Cell[TextData[{
 "We will observe that from a certain value of t  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "a"], "(", "t", ")"}], TraditionalForm]]],
 " takes negative values.  This means the all ",
 Cell[BoxData[
  FormBox["d", TraditionalForm]]],
 " amount has been already transferred to ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]]],
 " when  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["b", "a"], "(", "t", ")"}], TraditionalForm]]],
 " = 0.  We solve this equation to find ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 " that we will call ",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 ". "
}], "Text"],

Cell[TextData[{
 "We used Solve to find ",
 Cell[BoxData[
  FormBox["T", TraditionalForm]]],
 ".  "
}], "Caption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"d", "-", 
     RowBox[{"T", " ", 
      SubscriptBox["k", "F"]}]}], "==", " ", "0"}], ",", " ", "T"}], 
  "]"}]], "Input",
 CellLabel->"In[59]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"T", "\[Rule]", 
     FractionBox["d", 
      SubscriptBox["k", "F"]]}], "}"}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280644517072*^9, 3.479966523949038*^9, 
  3.4799667351490383`*^9, 3.479967320193038*^9, 3.479968228975038*^9, 
  3.5133964269860244`*^9, 3.5823497097724*^9, 3.582350798018941*^9, 
  3.5823513550932455`*^9, 3.5922027231004057`*^9, 3.64276093917918*^9, 
  3.650269794771349*^9},
 CellLabel->"Out[59]="]
}, Open  ]],

Cell["Therefore we should be consider two period:  ", "Text"],

Cell[TextData[{
 "First period:  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"0", "<", "t", "\[LessEqual]", "T", " "}], TraditionalForm]]],
 "with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"T", " ", "=", " ", 
    RowBox[{"d", "/", 
     SubscriptBox["k", "F"]}]}], TraditionalForm]]]
}], "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "a"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", "  ", 
    RowBox[{
     SubscriptBox["k", "F"], "-", " ", 
     RowBox[{
      SubscriptBox["k", "a"], " ", 
      RowBox[{
       SubscriptBox["x", "a"], "(", "t", ")"}]}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "a"], " ", 
      RowBox[{
       SubscriptBox["x", "a"], "(", "t", ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["k", "10"], "+", " ", 
        SubscriptBox["k", "12"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", "t", ")"}], " "}]}]}], TraditionalForm]]],
 " \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "12"], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "-", "  ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", "t", ")"}], " "}]}]}], TraditionalForm]]]
}], "NumberedEquation"],

Cell[TextData[{
 "\tInitial condition: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "a"], "(", "0", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "0", ")"}], TraditionalForm]]],
 " =",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "2"], "(", "0", ")"}], TraditionalForm]]],
 " = 0"
}], "Text"],

Cell[TextData[{
 "Second period: ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", ">", "T"}], TraditionalForm]]],
 ". We call ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "'"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "-", "T"}], TraditionalForm]]],
 " "
}], "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "a"], "'"}], 
     RowBox[{"(", 
      RowBox[{"t", "'"}], ")"}]}], " ", "=", 
    RowBox[{
     RowBox[{"-", " ", 
      SubscriptBox["k", "a"]}], " ", 
     RowBox[{
      SubscriptBox["x", "a"], "(", 
      RowBox[{"t", "'"}], ")"}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "'"}], 
     RowBox[{"(", 
      RowBox[{"t", "'"}], ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "a"], " ", 
      RowBox[{
       SubscriptBox["x", "a"], "(", 
       RowBox[{"t", "'"}], ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["k", "10"], "+", " ", 
        SubscriptBox["k", "12"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", 
       RowBox[{"t", "'"}], ")"}]}], "  ", "+", " ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", 
       RowBox[{"t", "'"}], ")"}], " "}]}]}], TraditionalForm]]],
 " \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "'"}], 
     RowBox[{"(", 
      RowBox[{"t", "'"}], ")"}]}], " ", "=", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["k", "12"], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", 
       RowBox[{"t", "'"}], ")"}]}], "  ", "-", "  ", 
     RowBox[{
      SubscriptBox["k", "21"], " ", 
      RowBox[{
       SubscriptBox["x", "2"], "(", 
       RowBox[{"t", "'"}], ")"}], " "}]}]}], TraditionalForm]]]
}], "NumberedEquation"],

Cell[TextData[{
 "Initial condition: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "a"], "(", "0", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "a"], "(", "T", ")"}], TraditionalForm]]],
 ";  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "0", ")"}], TraditionalForm]]],
 " =",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "T", ")"}], TraditionalForm]]],
 "; ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "2"], "(", "0", ")"}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "2"], "(", "T", ")"}], TraditionalForm]]],
 ", where  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "a"], "(", "T", ")"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "T", ")"}], TraditionalForm]]],
 ", y ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "2"], "(", "T", ")"}], TraditionalForm]]],
 " is given by eq. 13 when ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "T"}], TraditionalForm]]],
 ". "
}], "Text"],

Cell[TextData[{
 "Now, we give the values of transfer coefficients. In our example they are  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "F"], TraditionalForm]]],
 "=0.1, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "a"], TraditionalForm]]],
 "= 2, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "10"], TraditionalForm]]],
 "=0.5, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 "= 2, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "21"], TraditionalForm]]],
 "= 1"
}], "Text"],

Cell[TextData[{
 "We use k with /: (TagSet) to  make easier clear all coefficient values \
later. We will can delete its writing ",
 StyleBox["Clear[k]", "DisplayMath"],
 " in place of write every ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "i"], TraditionalForm]]],
 " . Also we write ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["k", "F"], "=", 
   RowBox[{"1", "/", "10"}]}]]],
 " and ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["k", "10"], "=", 
   RowBox[{"1", "/", "2"}]}]]],
 " using rational coefficients better than ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["k", "F"], "=", "0.1"}]]],
 " and ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["k", "10"], "=", "0.5"}]]],
 " because with rational coefficients the computation is made using infinite \
precision. "
}], "Caption"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"k", "/:", 
    SubscriptBox["k", "F"], "=", 
    RowBox[{"1", "/", "10"}]}], ";", 
   RowBox[{"k", "/:", 
    SubscriptBox["k", "a"], "=", "2"}], ";", 
   RowBox[{"k", "/:", 
    SubscriptBox["k", "10"], "=", 
    RowBox[{"1", "/", "2"}]}], " ", ";", 
   RowBox[{"k", "/:", 
    SubscriptBox["k", "21"], "=", "1"}], ";", " ", 
   RowBox[{"k", "/:", 
    SubscriptBox["k", "12"], "=", "2"}], ";"}], " "}]], "Input",
 CellLabel->"In[60]:="],

Cell["Here is the solution to eq13  ", "MathCaption"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["x", "a"], "'"}], "[", "t", "]"}], "==", "  ", 
      RowBox[{
       SubscriptBox["k", "F"], "-", " ", 
       RowBox[{
        SubscriptBox["k", "a"], " ", 
        RowBox[{
         SubscriptBox["x", "a"], "[", "t", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"x1", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        SubscriptBox["k", "a"], " ", 
        RowBox[{
         SubscriptBox["x", "a"], "[", "t", "]"}]}], "-", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["k", "10"], "+", 
          SubscriptBox["k", "12"]}], ")"}], " ", 
        RowBox[{"x1", "[", "t", "]"}]}], "+", 
       RowBox[{
        SubscriptBox["k", "21"], " ", 
        RowBox[{"x2", "[", "t", "]"}]}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"x2", "'"}], "[", "t", "]"}], "==", 
      RowBox[{
       RowBox[{
        SubscriptBox["k", "12"], " ", 
        RowBox[{"x1", "[", "t", "]"}]}], "-", 
       RowBox[{
        SubscriptBox["k", "21"], " ", 
        RowBox[{"x2", "[", "t", "]"}]}]}]}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[61]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x1a", "[", "t_", "]"}], ",", 
    RowBox[{"x11", "[", "t_", "]"}], ",", 
    RowBox[{"x12", "[", "t_", "]"}]}], "}"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "a"], "[", "t", "]"}], ",", 
      RowBox[{"x1", "[", "t", "]"}], ",", 
      RowBox[{"x2", "[", "t", "]"}]}], "}"}], "/.", 
    RowBox[{
     RowBox[{"DSolve", "[", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{"eq1", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["x", "a"], "[", "0", "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"x1", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
           RowBox[{
            RowBox[{"x2", "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}]}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          SubscriptBox["x", "a"], "[", "t", "]"}], ",", 
         RowBox[{"x1", "[", "t", "]"}], ",", 
         RowBox[{"x2", "[", "t", "]"}]}], "}"}], " ", ",", " ", "t"}], "]"}], 
     "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "//", "FullSimplify"}]}]], "Input",
 CellLabel->"In[62]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     FractionBox["1", "10"], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", "t"}]], " ", 
     RowBox[{"sinh", "(", "t", ")"}]}], ",", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "4"]}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"2", " ", 
           SqrtBox["41"]}]}], ")"}], " ", "t"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"9", " ", 
            SqrtBox["41"]}], "-", "41"}], ")"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             SqrtBox["41"], "-", "6"}], ")"}], " ", "t"}]]}], "-", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"41", "+", 
           RowBox[{"9", " ", 
            SqrtBox["41"]}]}], ")"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           FractionBox["3", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             SqrtBox["41"], "-", "2"}], ")"}], " ", "t"}]]}], "-", 
        RowBox[{"82", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              SqrtBox["41"]}], "-", "7"}], ")"}], " ", "t"}]]}], "+", 
        RowBox[{"410", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              SqrtBox["41"], " ", "t"}], "+", "t"}], ")"}]}]]}]}], ")"}]}], 
     "2050"], ",", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"41", " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "2"}], " ", "t"}]]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"123", "+", 
           RowBox[{"17", " ", 
            SqrtBox["41"]}]}], ")"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             SqrtBox["41"], "-", "7"}], ")"}], " ", "t"}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"17", " ", 
            SqrtBox["41"]}], "-", "123"}], ")"}], " ", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", "4"]}], " ", 
           RowBox[{"(", 
            RowBox[{"7", "+", 
             SqrtBox["41"]}], ")"}], " ", "t"}]]}], "+", "205"}], ")"}]}], 
     "1025"]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806524621415`*^9, 3.4799665339140377`*^9, 
  3.4799667387410383`*^9, 3.4799673235320377`*^9, 3.479968232670038*^9, 
  3.513396433189308*^9, 3.582349719465369*^9, 3.5823508072058597`*^9, 
  3.5823513646265078`*^9, 3.5922027329203873`*^9, 3.6427609417260747`*^9, 
  3.6502697972713547`*^9},
 CellLabel->"Out[62]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1a", "[", "t", "]"}], ",", 
     RowBox[{"x11", "[", "t", "]"}], ",", 
     RowBox[{"x12", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "50"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellLabel->"In[63]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJxF1nc0V/8fB3B77/HxMbMlIhlJ8n5FUUlG+pgJJTIKkRaZUTbZQrIuMqKi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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVz3s01AkbB3CGCkuhQpFbKpVsGrnG85DLr9NlZeVSuUQyQu6Z6CDrbbPl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      "]]}, 
    {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwt0gk01PsXAHBbimTrkeKJoaI3efZ6tvu1//6WR6qxlPdsMWVfm/DkL6/4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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{All, All},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280652571621*^9, 3.479966534076038*^9, 
  3.479966739086038*^9, 3.479967323870038*^9, 3.4799682327490377`*^9, 
  3.5133964333455625`*^9, 3.582349719605383*^9, 3.5823508073868775`*^9, 
  3.582351364819023*^9, 3.592202733089404*^9, 3.64276094183545*^9, 
  3.6502697974119797`*^9},
 CellLabel->"Out[63]="]
}, Open  ]],

Cell[TextData[{
 "Here is the solution to eq14. We have to bear in mind that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"xa", "[", "0", "]"}], "=", " ", 
   SubscriptBox["x", "a"]}]]],
 ", ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"x1", "[", "0", "]"}], "=", " ", 
   SubscriptBox["x", "1"]}]]],
 " and ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"x2", "[", "0", "]"}], "=", " ", 
   SubscriptBox["x", "2"]}]]],
 " correspond to the retention in the compartment a, 1 and 2  estimated with \
eq13 for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "T"}], TraditionalForm]]],
 ", that is ",
 Cell[BoxData[
  RowBox[{" ", 
   SubscriptBox["x", "a"]}]]],
 " =  ",
 StyleBox["x1a[T]", "DisplayMath"],
 ", ",
 Cell[BoxData[
  RowBox[{" ", 
   SubscriptBox["x", "1"]}]]],
 " =  ",
 StyleBox["x11[T]", "DisplayMath"],
 "and",
 Cell[BoxData[
  RowBox[{" ", 
   SubscriptBox["x", "2"]}]]],
 " =  ",
 StyleBox["x12[T]", "DisplayMath"],
 ". Also, we know that ",
 Cell[BoxData[
  RowBox[{"T", "=", 
   FractionBox["d", 
    SubscriptBox["k", "F"]]}]]],
 "for this reason we make the replacement ",
 Cell[BoxData[
  RowBox[{"T", "\[Rule]", 
   FractionBox["d", 
    SubscriptBox["k", "F"]]}]]]
}], "Caption"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq2", "=", 
   RowBox[{"DSolve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["x", "a"], "'"}], "[", "t", "]"}], "==", " ", 
        RowBox[{
         RowBox[{"-", " ", 
          SubscriptBox["k", "a"]}], " ", 
         RowBox[{
          SubscriptBox["x", "a"], "[", "t", "]"}]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"x1", "'"}], "[", "t", "]"}], "\[Equal]", 
        RowBox[{
         RowBox[{
          SubscriptBox["k", "a"], " ", 
          RowBox[{
           SubscriptBox["x", "a"], "[", "t", "]"}]}], "-", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["k", "10"], "+", 
            SubscriptBox["k", "12"]}], ")"}], " ", 
          RowBox[{"x1", "[", "t", "]"}]}], "+", 
         RowBox[{
          SubscriptBox["k", "21"], " ", 
          RowBox[{"x2", "[", "t", "]"}]}]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"x2", "'"}], "[", "t", "]"}], "==", 
        RowBox[{
         RowBox[{
          SubscriptBox["k", "12"], " ", 
          RowBox[{"x1", "[", "t", "]"}]}], "-", 
         RowBox[{
          SubscriptBox["k", "21"], " ", 
          RowBox[{"x2", "[", "t", "]"}]}]}]}], ",", 
       RowBox[{
        RowBox[{
         SubscriptBox["x", "a"], "[", "0", "]"}], "\[Equal]", 
        SubscriptBox["X", "a"]}], ",", 
       RowBox[{
        RowBox[{"x1", "[", "0", "]"}], "\[Equal]", "X1"}], ",", 
       RowBox[{
        RowBox[{"x2", "[", "0", "]"}], "\[Equal]", "X2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "a"], "[", "t", "]"}], ",", 
       RowBox[{"x1", "[", "t", "]"}], ",", 
       RowBox[{"x2", "[", "t", "]"}]}], "}"}], " ", ",", " ", "t"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[64]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x2a", "[", 
      RowBox[{"t_", ",", "d_"}], "]"}], ",", 
     RowBox[{"x21", "[", 
      RowBox[{"t_", ",", "d_"}], "]"}], ",", 
     RowBox[{"x22", "[", 
      RowBox[{"t_", ",", "d_"}], "]"}]}], "}"}], " ", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SubscriptBox["x", "a"], "[", "t", "]"}], ",", 
        RowBox[{"x1", "[", "t", "]"}], ",", 
        RowBox[{"x2", "[", "t", "]"}]}], "}"}], "/.", 
      RowBox[{"eq2", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], " ", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["X", "a"], "\[Rule]", " ", 
        RowBox[{"x1a", "[", "T", "]"}]}], ",", 
       RowBox[{"X1", "\[Rule]", " ", 
        RowBox[{"x11", "[", "T", "]"}]}], ",", 
       RowBox[{"X2", "\[Rule]", " ", 
        RowBox[{"x12", "[", "T", "]"}]}]}], "}"}]}], "/.", 
    RowBox[{"T", "\[Rule]", " ", 
     FractionBox["d", 
      SubscriptBox["k", "F"]]}]}]}], " ", ";"}]], "Input",
 CellLabel->"In[65]:="],

Cell[TextData[{
 "Now we will build a compound function that represent the retention for both \
intervals: one for ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"0", "<", "t", "\[LessEqual]", "T"}]}], TraditionalForm]]],
 " where the input is constant and the other for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", ">", "T"}], TraditionalForm]]],
 " when there isn't any input. We apply ",
 StyleBox["If", "DisplayMath"],
 " whose syntax is ",
 StyleBox["If[", "MR"],
 StyleBox["condition", "TI"],
 StyleBox[",", "MR"],
 " ",
 StyleBox["A", "TI"],
 StyleBox[",", "MR"],
 " ",
 StyleBox["B", "TI"],
 StyleBox["]", "MR"],
 " gives ",
 StyleBox["A", "TI"],
 " if ",
 StyleBox["condition", "TI"],
 " evaluates to ",
 StyleBox["True", "MR"],
 ", and ",
 StyleBox["B", "TI"],
 " if it evaluates to ",
 StyleBox["False", "MR"],
 ". In our case A correspond to the solutions for the first interval given by \
eq13 (",
 StyleBox["condition", "TI"],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "\[LessEqual]", "T"}], TraditionalForm]]],
 "), and B the solutions for the second interval given by eq14 (",
 StyleBox["condition", "TI"],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", ">", "T"}], TraditionalForm]]],
 ")."
}], "Text"],

Cell[TextData[{
 StyleBox["xa[t, d], x1[t,d]", "DisplayMath"],
 "  and ",
 StyleBox["x2[t,d]", "DisplayMath"],
 ", represent the retentions in compartment a, 1 and 2. We live d as function \
variable better than T because T is a function of d.  "
}], "Caption"],

Cell[BoxData[
 RowBox[{
  RowBox[{"xa", "[", 
   RowBox[{"t_", ",", "d_"}], "]"}], ":=", " ", 
  RowBox[{"If", "[", " ", 
   RowBox[{
    RowBox[{"t", "\[LessEqual]", 
     FractionBox["d", 
      SubscriptBox["k", "F"]]}], ",", 
    RowBox[{"x1a", "[", "t", "]"}], ",", " ", 
    RowBox[{"x2a", "[", 
     RowBox[{
      RowBox[{"t", "-", 
       FractionBox["d", 
        SubscriptBox["k", "F"]]}], ",", "d"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[66]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"x1", "[", 
   RowBox[{"t_", ",", "d_"}], "]"}], ":=", " ", 
  RowBox[{"If", "[", " ", 
   RowBox[{
    RowBox[{"t", "\[LessEqual]", 
     FractionBox["d", 
      SubscriptBox["k", "F"]]}], ",", 
    RowBox[{"x11", "[", "t", "]"}], ",", " ", 
    RowBox[{"x21", "[", 
     RowBox[{
      RowBox[{"t", "-", 
       FractionBox["d", 
        SubscriptBox["k", "F"]]}], ",", "d"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[67]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"x2", "[", 
   RowBox[{"t_", ",", "d_"}], "]"}], ":=", " ", 
  RowBox[{"If", "[", " ", 
   RowBox[{
    RowBox[{"t", "\[LessEqual]", 
     FractionBox["d", 
      SubscriptBox["k", "F"]]}], ",", 
    RowBox[{"x12", "[", "t", "]"}], ",", " ", 
    RowBox[{"x22", "[", 
     RowBox[{
      RowBox[{"t", "-", 
       FractionBox["d", 
        SubscriptBox["k", "F"]]}], ",", "d"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[68]:="],

Cell["Here is plot the retention. We have suppose d = 10", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"xa", "[", 
      RowBox[{"t", ",", "10"}], "]"}], ",", 
     RowBox[{"x1", "[", 
      RowBox[{"t", ",", "10"}], "]"}], ",", 
     RowBox[{"x2", "[", 
      RowBox[{"t", ",", "10"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "200"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", "All"}]}], "]"}]], "Input",
 CellLabel->"In[69]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJxF12k4VW/UMHDzTOZ5ngllTs7e90qiQZEoZyBJHGOmSiqElD8iY5IhhCMh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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwd13c81e8XAHBEyQpfJCRbpGRm9XmOvbP3uua9RHaEEKFhJTMzITNkhBLJ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      "]]}, 
    {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwt13c8le/7AHA7QiFJUR8ZDUl2Vs99kT2y9x6Hk1GSZBRCIjMRsmVEyohC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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{All, All},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806535725746`*^9, 3.479966534927038*^9, 
  3.479966739694038*^9, 3.4799673246640377`*^9, 3.4799682333330383`*^9, 
  3.51339643403308*^9, 3.582349720441467*^9, 3.5823508080479436`*^9, 
  3.5823513656090865`*^9, 3.592202733886484*^9, 3.642760942147952*^9, 
  3.6502697977088556`*^9},
 CellLabel->"Out[69]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{
   "xa", ",", "x1", ",", "x2", ",", "model1", ",", "eq1", ",", " ", "eq2"}], 
   " ", "]"}], ";"}]], "Input",
 CellLabel->"In[70]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["One input and two outputs ", "SubsubsectionIcon"],

Cell["\<\
The lead is one of typical pollutant in some industrial environment. It can \
be intaken to the human body specially through inhalation. The intaken lead \
goes to blood, to the tissues and to the bone. Part of it is eliminated by \
urine excretion. We can represent the temporal evolution in the human body \
using a system of tree compartment: (1) blood, (2) tissues, (3) bones. The \
flow diagram is shown in the figure\
\>", "Text",
 CellChangeTimes->{3.6505980630857544`*^9}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .375 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0833333 0.119048 0.1875 0.119048 [
[ 0 0 0 0 ]
[ 1 .375 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .375 L
0 .375 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
newpath
.08333 .1875 .05952 0 365.73 arc
s
gsave
.08333 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.14286 .21131 m
.44048 .21131 L
s
% Start of user PostScript
0.5 0.2 3. 0.2 MAarrowhead1
% End of user PostScript
gsave
.29167 .23512 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.44048 .16369 m
.14286 .16369 L
s
% Start of user PostScript
3. -0.2 0.5 -0.2 MAarrowhead1
% End of user PostScript
gsave
.29167 .13988 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.5 .1875 .05952 0 365.73 arc
s
gsave
.5 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .36607 m
.5 .24702 L
s
% Start of user PostScript
3.5 1.5 3.5 0.5 MAarrowhead2
% End of user PostScript
gsave
.45238 .30655 -77.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
73.875 12.750 moveto
(H) show
79.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(t) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
85.875 12.750 moveto
(L) show
91.875 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .12798 m
.5 .00893 L
s
% Start of user PostScript
3.5 -0.5 3.5 -1.5 MAarrowhead1
% End of user PostScript
gsave
.46429 .06845 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.91667 .1875 .05952 0 365.73 arc
s
gsave
.91667 .1875 -66 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.55952 .21131 m
.85714 .21131 L
s
% Start of user PostScript
4. 0.2 6.5 0.2 MAarrowhead1
% End of user PostScript
gsave
.70833 .23512 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(13) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.85714 .16369 m
.55952 .16369 L
s
% Start of user PostScript
6.5 -0.2 4. -0.2 MAarrowhead1
% End of user PostScript
gsave
.70833 .13988 -70.625 -10.25 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(31) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.08333 .12798 m
.08333 .00893 L
s
% Start of user PostScript
0 -0.5 0 -1.5 MAarrowhead1
% End of user PostScript
gsave
.04762 .06845 -70.625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.5 translate 1 -1 scale
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.250 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
78.250 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "NumberedFigure",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 ImageSize->{288, 108},
 ImageMargins->{{191.75, 0}, {0, 6}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzNWUtTE0EQbrIJSYDA5iVCAkTkcUV5RNCiKMuCE1cRPKUoq8IBtZCjsgfL
8uAL8GD5JwSDP8h/ss70Zjc9uzuzs0AorWK28/VrHj090+Nm47D5Yr9xuLfb
qG0cNF4393bf1NZfHTDI6AHoaQLARxMY/RaMvzBhW/aeZQPIvuOsMQAs9htO
Cd3SYSYAvvvhMctmv0+xvdAGkgAnHaBq2SmAY2xbMqAX4FscoGLZaYCv2P5u
AxmAL3GAUcvOAnzG9rwN9AF8UgBXmuAbZ5q4CAaBU4R+j7OZkHBdAx7gCbKY
7CX4B/aXdmjOC/DRUBbDK4H9wQ6BwuK7OMJovo81yTaAGqoOHcUR9sy7vg1C
y/p0RPCkpgPDEQ3Mtm9ZjtwlTYjygaUTpsS0JMM3w9S8oQIMSkblY4mq7JsP
0/PhJDCKgdUv+gX/u811eWYFk9k6bj9cRPy35qJO7KdcZIwLDGNS7cX2CV/u
TkTBqiZvhCNltD+I7TLZZzTeKL0skff2Jc0uK0R4mPOLSBawfUDjThbqdZUC
HdgKESxzpECslBBeIvGaCtmFdaWGEUaz7xJK3iII9ywE9jCh592d7duvi1Hy
7tBRsy5KOyMXd+8IwvN0ztbisrk9GCJwldBz4vZ/hBrjcQRynEXTxliYNvuu
EjrUg0IGneQIMEHoPM7uKPZs7QoyA9zJAAHuiEwWas+1uTW/4X4C3CU028YD
ADva3EkcQ8DkFA0uU1RR8agznuuFhD9t2S8BZrGdiRAUPGzH4Ll0NswoOQnZ
PDwjyIw2N2DYx0yLqrPa3IzlnHWhzBxGnExVzVUabsbEA8aG8BwqSlRN5Bbk
XEaWIswLSV3mqCChm5q2Ao5p4ixdwSl1klc5zEuUuuZQx5iOTB5ziHIVZX3q
2th0wyYYgbECpk8U9pl6isiQZFwFpaRka8gy2hamFprCZ7S5ylS5hckwfSlu
lGFTvDapuVOExhPDd17tkwvntPhTqUqPLJZB86JXfS4apuf9pKiaA1zB+NyA
YXpV2MbXh35tbg33qvICtIMlhanN1b6+1UlV4Nz/Kt7dPEx+0al+XPlxpTB6
phuoQui5sKqEXrXvE7p6HYp8DoRZGiX0PUujzJlH11WZmiFRWwioYVd8tQcT
WXCRdukTZmxRqUV7bii1uHch35XFHhvEWLCWitBS1Wxl76FAyN0Fr2ISloGW
U8tq8USgWqsHTkF0W3KrJmrTif7HeixeR/ImiSmCtQ+Jjw0lnsYddNtynikz
WOszi5sinW4/IFwQ/VYo0Oq82EaS/Pk05YwIR9XqFnjuWxevy2fd5Z5Z4uWA
Ru2v6xGIXpHrAH5glNDjhx7oCb/4T4lg1jeaP7w9xiDrvGDRIdInTgMDJ0Un
HPVPUN+geMbXOeozGWZAkJaaob3SMMEHE8tEQhx8Nr57/prs3AS8RJWSzJln
zn+DTcsXieZnZQDcTFRGA7bkf7ig5x88yejn\
\>"],ImageRangeCache->{{{305.063, 735.563}, {364.5, 204}} -> {-6.71182, \
2.42875, 0.0294395, 0.0294395}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"model", " ", "=", 
  RowBox[{"CompartMatrix", "[", 
   RowBox[{"3", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "k21"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "k13"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "k31"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", " ", "k10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", "k20"}], "}"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[71]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "k10"}], "-", "k12", "-", "k13"}], "k21", "k31"},
     {"k12", 
      RowBox[{
       RowBox[{"-", "k20"}], "-", "k21"}], "0"},
     {"k13", "0", 
      RowBox[{"-", "k31"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806536351337`*^9, 3.479966536695038*^9, 
  3.479966739727038*^9, 3.4799673250060377`*^9, 3.479968233367038*^9, 
  3.513396434064331*^9, 3.5823497204894714`*^9, 3.582350808102949*^9, 
  3.5823513656478395`*^9, 3.5922027339224873`*^9, 3.592203582508194*^9, 
  3.592203720630005*^9, 3.642760942179203*^9, 3.6502697977401056`*^9},
 CellLabel->"Out[71]="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "k10"}], "-", "k12", "-", "k13"}], ",", "k21", ",", 
     "k31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k12", ",", 
     RowBox[{
      RowBox[{"-", "k20"}], "-", "k21"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k13", ",", "0", ",", 
     RowBox[{"-", "k31"}]}], "}"}]}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellLabel->"Out[72]="]
}, Open  ]],

Cell["It can be represented by the system of differential equation", "Text",
 CellChangeTimes->{3.6505980656326323`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{"ShowODE", "[", 
    RowBox[{"model", ",", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"b", "[", "t", "]"}], ",", "0", ",", "0"}], "}"}], ",", " ", 
     "t", ",", " ", "x"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[72]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "//", "TableForm"}], "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[73]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"b", "(", "t", ")"}], "+", 
         RowBox[{
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k10"}], "-", "k12", "-", "k13"}], ")"}]}], "+", 
         RowBox[{"k21", " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}], "+", 
         RowBox[{"k31", " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"k12", " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "k20"}], "-", "k21"}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "3"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         RowBox[{"k13", " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "-", 
         RowBox[{"k31", " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "1"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "2"], "(", "0", ")"}], "\[LongEqual]", "0"}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "3"], "(", "0", ")"}], "\[LongEqual]", "0"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806536664133`*^9, 3.479966536812038*^9, 
  3.479966740275038*^9, 3.479967325679038*^9, 3.479968233416038*^9, 
  3.513396434158083*^9, 3.5823497206304855`*^9, 3.582350808192958*^9, 
  3.5823513657816*^9, 3.5922027340735025`*^9, 3.592203582642207*^9, 
  3.5922037207690187`*^9, 3.6427609422260785`*^9, 3.6502697978026056`*^9},
 CellLabel->"Out[73]//TraditionalForm="]
}, Open  ]],

Cell[TextData[{
 "We will use the habitual agreement calling the lead amount in compartment \
1, 2, y 3,  in the time ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]]],
 ",  by  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "(", "t", ")"}], ","}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "2"], "(", "t", ")"}], TraditionalForm]]],
 " and",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox["x", "3"], "(", "t", ")"}]}], TraditionalForm]]],
 ".  We call ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 "the lead intake from outside of system in compartment 1. "
}], "Text",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell["In matrix notation  the previous equation is transformed in ", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], 
       StyleBox["'",
        FontWeight->"Plain"]}],
      FontSlant->"Plain"], 
     RowBox[{"(", "t", ")"}]}], " ", "=", 
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["A",
        FontSlant->"Plain"], " ", 
       StyleBox["x",
        FontSlant->"Plain"]}],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], "+", " ", 
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}]}]}], ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], 
  TraditionalForm]], "DisplayFormula"],

Cell["with", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], 
       StyleBox["'",
        FontWeight->"Plain"]}],
      FontSlant->"Plain"], 
     RowBox[{"(", "t", ")"}]}], " ", "=", 
    RowBox[{"(", GridBox[{
       {
        RowBox[{
         SubscriptBox["x", "1"], "'"}]},
       {
        RowBox[{
         SubscriptBox["x", "2"], "'"}]},
       {
        RowBox[{
         SubscriptBox["x", "3"], "'"}]}
      }], ")"}]}], ";", " ", 
   RowBox[{
    StyleBox["A",
     FontWeight->"Bold",
     FontSlant->"Plain"], "=", 
    RowBox[{"(", GridBox[{
       {
        SubscriptBox["a", "11"], 
        SubscriptBox["a", "12"], 
        SubscriptBox["a", "13"]},
       {
        SubscriptBox["a", "21"], 
        SubscriptBox["a", "22"], "0"},
       {
        SubscriptBox["a", "31"], "0", 
        SubscriptBox["a", "33"]}
      }], ")"}]}], ";", 
   StyleBox[" ",
    FontWeight->"Bold"], 
   RowBox[{
    StyleBox["x",
     FontWeight->"Bold",
     FontSlant->"Plain"], "=", 
    RowBox[{"(", GridBox[{
       {
        SubscriptBox["x", "1"]},
       {
        SubscriptBox["x", "2"]},
       {
        SubscriptBox["x", "3"]}
      }], ")"}]}], ";", 
   RowBox[{
    RowBox[{
     StyleBox["b",
      FontWeight->"Bold",
      FontSlant->"Plain"], "(", "t", ")"}], "=", " ", 
    RowBox[{"(", GridBox[{
       {
        RowBox[{
         SubscriptBox["b", "1"], "(", "t", ")"}]},
       {"0"},
       {"0"}
      }], ")"}]}]}], TraditionalForm]], "DisplayFormula"],

Cell[TextData[{
 "where the coefficients ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "ij"], TraditionalForm]]],
 " of matrix ",
 StyleBox["A",
  FontWeight->"Bold"],
 " are:"
}], "Text",
 CellChangeTimes->{3.650598075148263*^9}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SubscriptBox["a", "11"], "=", " ", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "10"], "+", 
       SubscriptBox["k", "12"], "+", 
       SubscriptBox["k", "13"]}], ")"}]}]}], ",", " ", 
   RowBox[{
    SubscriptBox["a", "12"], "=", 
    SubscriptBox["k", "21"]}], ",", " ", 
   RowBox[{
    SubscriptBox["a", "13"], "=", 
    SubscriptBox["k", "31"]}], ",", "  ", 
   RowBox[{
    SubscriptBox["a", "21"], "=", 
    SubscriptBox["k", "12"]}], ",", " ", 
   RowBox[{
    SubscriptBox["a", "22"], "=", " ", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "20"], "+", 
       SubscriptBox["k", "21"]}], ")"}]}]}], ",", " ", 
   RowBox[{
    SubscriptBox["a", "31"], "=", 
    SubscriptBox["k", "13"]}], ",", " ", 
   RowBox[{
    SubscriptBox["a", "33"], "=", 
    RowBox[{"-", 
     SubscriptBox["k", "31"]}]}]}], TraditionalForm]], "DisplayFormula"],

Cell[TextData[{
 "To resolve the previous system we must know the form of input ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    StyleBox["b",
     FontWeight->"Bold",
     FontSlant->"Plain"], "(", "t", ")"}], TraditionalForm]]],
 ", also of the initial conditions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     StyleBox[
      FormBox["x",
       TraditionalForm],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], 
     RowBox[{"(", "0", ")"}]}], "=", " ", 
    SubscriptBox[
     StyleBox["x",
      FontWeight->"Bold"], "0"]}], TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{3.650598078210765*^9}],

Cell[TextData[{
 "In the model of figure we consider a single intake ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "0"], TraditionalForm]]],
 " in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0"}], TraditionalForm]]],
 " , so ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "=", " ", 
    FormBox[
     SubscriptBox["b", "0"],
     TraditionalForm]}], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", " ", "=", " ", "0"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"b", "(", "t", ")"}], " ", "=", " ", "0"}], TraditionalForm]]],
 " for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", ">", "0"}], TraditionalForm]]],
 ". This is equivalent to assume as initial",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      FormBox[
       SubscriptBox["x", "1"],
       TraditionalForm], "(", "0", ")"}], " ", "=", " ", 
     FormBox[
      SubscriptBox["b", "0"],
      TraditionalForm]}]}], TraditionalForm]]],
 ",  and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     FormBox[
      SubscriptBox[
       RowBox[{"x", " "}], "2"],
      TraditionalForm], 
     RowBox[{"(", "0", ")"}]}], " ", "=", " ", "0"}], TraditionalForm]]],
 ". If we try to use DSolve without giving values to ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "ij"], TraditionalForm]]],
 " we will see that no solution is obtain. In real problems the most usual \
thing is that transfer coefficient values are known. "
}], "Text"],

Cell[TextData[{
 "In this example we will use the values given by 1992 (Bo92), in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["days", 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ", obtained empirically from a person exposure to an environment highly \
contaminated intaken 49.3 \[Mu]g of lead every day  "
}], "Text",
 Evaluatable->False,
 CellChangeTimes->{3.650598081210767*^9},
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["k", "21"], " ", "=", " ", "0.0124"}], ";", 
   RowBox[{
    SubscriptBox["k", "12"], "=", "0.0111"}], ";", 
   RowBox[{
    SubscriptBox["k", "13"], "=", "0.0039"}], ";", 
   RowBox[{
    SubscriptBox["k", "31"], " ", "=", " ", "0.000035"}], ";", 
   RowBox[{
    SubscriptBox["k", "10"], " ", "=", " ", "0.0211"}], ";", 
   RowBox[{
    SubscriptBox["k", "20"], "=", " ", "0.0162"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Initial", " ", 
    RowBox[{"conditions", ":", " ", "b1"}]}], "=", "49.3"}], " ", 
  RowBox[{"(*", 
   RowBox[{"\[Mu]g", "/", "day"}], "*)"}], ",", " ", 
  RowBox[{
   RowBox[{"b2", " ", "=", "0"}], ";", " ", 
   RowBox[{"b3", "=", "0"}], ";"}]}]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"model1", "=", 
   RowBox[{"model", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k21", " ", "->", " ", "0.0124"}], ",", 
      RowBox[{"k12", "->", "0.0111"}], ",", 
      RowBox[{"k13", "->", "0.0039"}], ",", "  ", 
      RowBox[{"k31", " ", "->", " ", "0.000035"}], ",", " ", 
      RowBox[{"k10", " ", "->", " ", "0.0211"}], ",", " ", 
      RowBox[{"k20", "\[Rule]", "  ", "0.0162"}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[74]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x1", "[", "t1_", "]"}], ",", 
    RowBox[{"x2", "[", "t1_", "]"}], ",", 
    RowBox[{"x3", "[", "t1_", "]"}]}], "}"}], "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "[", "t1", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "2"], "[", "t1", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "3"], "[", "t1", "]"}]}], "}"}], "/.", 
   RowBox[{"SystemDSolve", "[", 
    RowBox[{"model1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"49.3", ",", "0", ",", "0"}], "}"}], ",", " ", "t", ",", " ", 
     "t1", ",", " ", "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[75]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"1800.0970278827494`", "\[VeryThinSpace]", "-", 
     RowBox[{"719.8848754012307`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.04466875163472881`"}], " ", "t1"}]]}], "-", 
     RowBox[{"855.3144589765814`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.020035616138806753`"}], " ", "t1"}]]}], "-", 
     RowBox[{"224.89769350493737`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.000030632226464431417`"}], " ", "t1"}]]}]}], ",", 
    RowBox[{"698.6390562761717`", "\[VeryThinSpace]", "+", 
     RowBox[{"497.28331724809294`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.04466875163472881`"}], " ", "t1"}]]}], "-", 
     RowBox[{"1108.5433171274606`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.020035616138806753`"}], " ", "t1"}]]}], "-", 
     RowBox[{"87.37905639680405`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.000030632226464431417`"}], " ", "t1"}]]}]}], ",", 
    RowBox[{"200582.24024979194`", "\[VeryThinSpace]", "+", 
     RowBox[{"62.90197241408426`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.04466875163472881`"}], " ", "t1"}]]}], "+", 
     RowBox[{"166.78118148252585`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.020035616138806753`"}], " ", "t1"}]]}], "-", 
     RowBox[{"200811.92340368856`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.000030632226464431417`"}], " ", "t1"}]]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806537289734`*^9, 3.4799665369060383`*^9, 
  3.4799667417810383`*^9, 3.479967326409038*^9, 3.479968233467038*^9, 
  3.513396434267461*^9, 3.582349720700493*^9, 3.582350808321971*^9, 
  3.5823513658753576`*^9, 3.5922027342915244`*^9, 3.5922035827032137`*^9, 
  3.592203720833025*^9, 3.6427609422573285`*^9, 3.6502697978495164`*^9},
 CellLabel->"Out[75]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], ",", 
     RowBox[{"x2", "[", "t", "]"}], ",", 
     RowBox[{"x3", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", " ", "400"}], "}"}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<days\>\"", ",", " ", "\"\<r\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "\"\<blood\>\"", ",", "\"\<tissues\>\"", ",", "\"\<bones\>\""}], "}"}],
       ",", "Right", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
   "PlotLabel", "\[Rule]", "\"\<Lead model:input = 49.3 \[Mu]g/day\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.479966661427038*^9, {3.5922032274376907`*^9, 3.5922032295369005`*^9}, {
   3.5922035513640795`*^9, 3.5922035603219757`*^9}, 3.592203708993841*^9},
 CellLabel->"In[76]:="],

Cell[BoxData[
 FormBox[
  TemplateBox[{GraphicsBox[{{{}, {}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwVz3s01In7B3BKu8kl3TQ/UiKRrNwbhXm7xGxRTGMa90nJuI/7WMJiyboN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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwV0As01IkeB/D/MEV5v4dBXhU1aTyydlX/r47SLUV6zZDyzHjGGPzDMmYc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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwd0Qk41HkYB/CfKzmTcltrhpY2yTXS+X+zKpWVXM1UahwZuc+MSJOobIZR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         "]]}}}, {
     DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {
        FormBox["\"days\"", TraditionalForm], 
        FormBox["\"r\"", TraditionalForm]}, AxesOrigin -> {0, 0}, 
      DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None}, PlotLabel -> 
      FormBox["\"Lead model:input = 49.3 \[Mu]g/day\"", TraditionalForm], 
      PlotRange -> {{0, 400}, {-2.9103830456733704`*^-11, 2215.885579370719}},
       PlotRangeClipping -> True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
     FrameBox[
      FormBox[
       TemplateBox[{"\"blood\"", "\"tissues\"", "\"bones\""}, "LineLegend", 
        DisplayFunction -> (FormBox[
          StyleBox[
           StyleBox[
            PaneBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
              "Grid"], Alignment -> Left, AppearanceElements -> None, 
             ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
             "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
           FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
           False], TraditionalForm]& ), 
        InterpretationFunction :> (RowBox[{"LineLegend", "[", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                 ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                 ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                   "]"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{#, ",", #2, ",", #3}], "}"}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"{", "}"}]}], ",", 
             RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
        Editable -> True], TraditionalForm], RoundingRadius -> 5, 
      StripOnInput -> False], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806545735283`*^9, 3.479966542640038*^9, 
  3.479966748312038*^9, 3.479967339811038*^9, 3.479968233930038*^9, 
  3.5133964357362485`*^9, 3.582349722604683*^9, 3.582350809995138*^9, 
  3.582351367552992*^9, 3.592202736295725*^9, 3.5922035828232255`*^9, 
  3.59220372098504*^9, 3.642760942335474*^9, 3.650269797927605*^9},
 CellLabel->"Out[76]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{
   "b1", ",", "k", ",", "a", ",", "x1", ",", "x2", ",", "x3", ",", " ", "eq1",
     ",", " ", "model"}], "]"}], ";"}]], "Input",
 CellLabel->"In[77]:="]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["General tricompartimental model ", "SubsectionIcon"],

Cell["\<\
The figure represent the general tricompartmental model with one input in \
each compartment \
\>", "Text"],

Cell[BoxData[
 GraphicsBox[{ArrowBox[{{0, 1.5}, {0, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(1\\)]\\)(t)\"\>", \
{-0.4, 1}, {0, -1}], CircleBox[{0, 0}, 0.5], 
   InsetBox["\<\"1\"\>", {0, 0}, {0, 0}], ArrowBox[{{0, -0.5}, {0, -1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(10\\)]\\)\"\>", \
{-0.3, -1}, {0, -1}], ArrowBox[{{0.5, 0.2}, {3, 0.2}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(12\\)]\\)\"\>", \
{1.75, 0.4}, {0, 0}], ArrowBox[{{3, -0.2}, {0.5, -0.2}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(21\\)]\\)\"\>", \
{1.75, -0.4}, {0, 0}], CircleBox[{3.5, 0}, 0.5], 
   InsetBox["\<\"2\"\>", {3.5, 0}, {0, 0}], 
   ArrowBox[{{3.5, 1.5}, {3.5, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(2\\)]\\)(t)\"\>", \
{3.9, 1}, {0, -1}], ArrowBox[{{3.5, -0.5}, {3.5, -1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(20\\)]\\)\"\>", {3.2, -1}, \
{0, -1}], ArrowBox[{{1.75, 4.5}, {1.75, 3.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(b\\), \\(3\\)]\\)(t)\"\>", \
{1.3, 4}, {0, -1}], CircleBox[{1.75, 3}, 0.5], 
   InsetBox["\<\"3\"\>", {1.75, 3}, {0, 0}], 
   ArrowBox[{{0.1, 0.5}, {1.35, 2.7}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(13\\)]\\)\"\>", \
{0.5, 1.7}, {0, 0}], ArrowBox[{{1.65, 2.5}, {0.4, 0.35}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(31\\)]\\)\"\>", \
{1.25, 1.3}, {0, 0}], ArrowBox[{{2.15, 2.7}, {3.4, 0.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(23\\)]\\)\"\>", \
{2.25, 1.3}, {0, 0}], ArrowBox[{{3.1, 0.35}, {1.85, 2.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(32\\)]\\)\"\>", {3, 1.7}, \
{0, 0}], ArrowBox[{{1.75, 2.5}, {1.75, 1.5}}], 
   InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(k\\), \\(30\\)]\\)\"\>", \
{1.6, 1.8}, {0, -1}], InsetBox["\<\"\[Lambda]\"\>", {2.6, 3.}, {0, -1}], 
   ArrowBox[{{2.25, 3}, {3.25, 3}}], 
   InsetBox["\<\"\[Lambda]\"\>", {-0.8, 0}, {0, -1}], 
   ArrowBox[{{-0.5, 0.}, {-1.5, 0.}}], 
   InsetBox["\<\"\[Lambda]\"\>", {4.4, 0}, {0, -1}], 
   ArrowBox[{{4., 0.}, {5., 0.}}]},
  AspectRatio->Automatic]], "Text",
 CellChangeTimes->{{3.3981418723165197`*^9, 3.398141901285084*^9}, 
   3.398141959737835*^9, 3.3981428994902678`*^9, 3.398149916236801*^9, 
   3.398150024205551*^9, 3.398150141346176*^9}],

Cell["This model is represented by the follow ODE System ", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "="}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "1"], "(", "t", ")"}], " ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "10"], " ", "+", " ", 
       SubscriptBox["k", "12"], " ", "+", " ", 
       SubscriptBox["k", "13"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "21"], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "31"], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], " "}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "="}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "2"], "(", "t", ")"}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "12"], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "20"], " ", "+", " ", 
       SubscriptBox["k", "21"], " ", "+", " ", 
       SubscriptBox["k", "23"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "32"], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}]}]}], TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "3"], "'"}], 
     RowBox[{"(", "t", ")"}]}], " ", "="}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "3"], " ", 
     RowBox[{"(", "t", ")"}]}], " ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "13"], " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}], "  ", "+", " ", 
    RowBox[{
     SubscriptBox["k", "23"], " ", 
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["k", "30"], " ", "+", " ", 
       SubscriptBox["k", "31"], " ", "+", " ", 
       SubscriptBox["k", "32"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], " "}]}], TraditionalForm]]]
}], "NumberedEquation"],

Cell["in matrix notation ", "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["x",
        FontWeight->"Bold"], 
       StyleBox["'",
        FontWeight->"Plain"]}],
      FontSlant->"Plain"], 
     RowBox[{"(", "t", ")"}]}], " ", "=", 
    RowBox[{
     StyleBox[
      RowBox[{
       StyleBox["A",
        FontSlant->"Plain"], " ", 
       StyleBox["x",
        FontSlant->"Plain"]}],
      FontWeight->"Bold"], 
     StyleBox[" ",
      FontWeight->"Bold"], "+", " ", 
     RowBox[{
      StyleBox["b",
       FontWeight->"Bold",
       FontSlant->"Plain"], "(", "t", ")"}]}]}], ",", " ", 
   RowBox[{"t", "\[GreaterEqual]", "0"}]}], 
  TraditionalForm]], "DisplayFormula",
 TextAlignment->Left,
 TextJustification->0],

Cell["with", "Text"],

Cell[TextData[{
 StyleBox["x",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "2"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "1"], "(", "t", ")"}]}], "}"}], "T"]}], 
   TraditionalForm]]],
 " \n\n",
 StyleBox["B",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"(", "t", ")"}], " ", "=", " ", 
    SuperscriptBox[
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["b", "1"], "(", "t", ")"}], ",", " ", 
       RowBox[{
        SubscriptBox["b", "2"], "(", "t", ")"}], ",", 
       RowBox[{
        SubscriptBox["b", "3"], "(", "t", ")"}]}], "}"}], "T"], " "}], 
   TraditionalForm]]],
 "\n\nwhere  ",
 StyleBox["A",
  FontWeight->"Bold"],
 " is "
}], "DisplayFormula",
 TextAlignment->Left,
 TextJustification->1],

Cell[BoxData[
 RowBox[{
  RowBox[{"model", " ", "=", 
   RowBox[{"CompartMatrix", "[", 
    RowBox[{"3", ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", 
         SubscriptBox["k", "12"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", 
         SubscriptBox["k", "21"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3", ",", 
         SubscriptBox["k", "13"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "1", ",", 
         SubscriptBox["k", "31"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", 
         SubscriptBox["k", "32"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3", ",", 
         SubscriptBox["k", "23"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3", ",", 
         SubscriptBox["k", "33"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", " ", 
         SubscriptBox["k", "10"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "0", ",", 
         SubscriptBox["k", "20"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "0", ",", 
         SubscriptBox["k", "30"]}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[78]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"model", "//", "MatrixForm"}]], "Input",
 CellLabel->"In[79]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       RowBox[{
        RowBox[{"-", 
         SubscriptBox["k", "10"]}], "-", 
        SubscriptBox["k", "12"], "-", 
        SubscriptBox["k", "13"]}], 
       SubscriptBox["k", "21"], 
       SubscriptBox["k", "31"]},
      {
       SubscriptBox["k", "12"], 
       RowBox[{
        RowBox[{"-", 
         SubscriptBox["k", "20"]}], "-", 
        SubscriptBox["k", "21"], "-", 
        SubscriptBox["k", "23"]}], 
       SubscriptBox["k", "32"]},
      {
       SubscriptBox["k", "13"], 
       SubscriptBox["k", "23"], 
       RowBox[{
        RowBox[{"-", 
         SubscriptBox["k", "30"]}], "-", 
        SubscriptBox["k", "31"], "-", 
        SubscriptBox["k", "32"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806546517277`*^9, 3.479966542712038*^9, 
  3.479966748577038*^9, 3.479967340357038*^9, 3.479968233994038*^9, 
  3.513396435814376*^9, 3.582349722714694*^9, 3.5823508251946583`*^9, 
  3.582351367641749*^9, 3.592203770706459*^9, 3.5922038227775006`*^9, 
  3.592203903539116*^9, 3.6427609423667135`*^9, 3.6502697979901056`*^9},
 CellLabel->"Out[79]//MatrixForm="]
}, Open  ]],

Cell["It assumed as initial condition:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ic", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["x", "10"], ",", " ", 
     SubscriptBox["x", "20"], ",", " ", 
     SubscriptBox["x", "30"]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[80]:="],

Cell["and as input", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"input", "=", 
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["b", "1"], ",", " ", 
     SubscriptBox["b", "2"], ",", " ", 
     SubscriptBox["b", "3"]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[81]:="],

Cell["It can be represented by the system of differential equation", "Text",
 CellChangeTimes->{3.650598090601398*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "=", 
   RowBox[{"ShowODE", "[", 
    RowBox[{
    "model", ",", " ", "ic", ",", "input", ",", " ", "t", ",", " ", "x"}], 
    "]"}]}], ";"}]], "Input",
 CellLabel->"In[82]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"eq1", "//", "TableForm"}], "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[83]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "1"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         SubscriptBox["b", "1"], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SubscriptBox["k", "10"]}], "-", 
            SubscriptBox["k", "12"], "-", 
            SubscriptBox["k", "13"]}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{
          SubscriptBox["k", "21"], " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}], "+", 
         RowBox[{
          SubscriptBox["k", "31"], " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "2"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         SubscriptBox["b", "2"], "+", 
         RowBox[{
          SubscriptBox["k", "12"], " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SubscriptBox["k", "20"]}], "-", 
            SubscriptBox["k", "21"], "-", 
            SubscriptBox["k", "23"]}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}], "+", 
         RowBox[{
          SubscriptBox["k", "32"], " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SuperscriptBox[
          SubscriptBox["x", "3"], "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}], "\[LongEqual]", 
        RowBox[{
         SubscriptBox["b", "3"], "+", 
         RowBox[{
          SubscriptBox["k", "13"], " ", 
          RowBox[{
           SubscriptBox["x", "1"], "(", "t", ")"}]}], "+", 
         RowBox[{
          SubscriptBox["k", "23"], " ", 
          RowBox[{
           SubscriptBox["x", "2"], "(", "t", ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SubscriptBox["k", "30"]}], "-", 
            SubscriptBox["k", "31"], "-", 
            SubscriptBox["k", "32"]}], ")"}], " ", 
          RowBox[{
           SubscriptBox["x", "3"], "(", "t", ")"}]}]}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "1"], "(", "0", ")"}], "\[LongEqual]", 
        SubscriptBox["x", "10"]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "2"], "(", "0", ")"}], "\[LongEqual]", 
        SubscriptBox["x", "20"]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["x", "3"], "(", "0", ")"}], "\[LongEqual]", 
        SubscriptBox["x", "30"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806546986475`*^9, 3.479966542816038*^9, 
  3.479966748773038*^9, 3.479967340525038*^9, 3.4799682340650377`*^9, 
  3.5133964359393787`*^9, 3.5823497228387065`*^9, 3.5823508252906675`*^9, 
  3.5823513677692595`*^9, 3.5922037708164616`*^9, 3.592203822867502*^9, 
  3.592203903649118*^9, 3.642760942429205*^9, 3.6502697980682325`*^9},
 CellLabel->"Out[83]//TraditionalForm="]
}, Open  ]],

Cell[TextData[{
 "We consider ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "1"], "(", "t", ")"}], " ", "=", " ", 
    RowBox[{"2", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "0.1"}], " ", "t"}], "]"}]}]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["b", "2"], "(", "t", ")"}], "=", "2"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      SubscriptBox["b", "3"], "(", "t", ")"}], " ", "=", 
     RowBox[{"0.2", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "t"}], "]"}]}]}]}], TraditionalForm]]],
 " that is equivalent to take as initial conditions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "(", "0", ")"}], " ", "=", "1"}], ","}], 
   TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "(", "0", ")"}], "=", "2"}], " ", ","}], 
   TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["x", "3"], "(", "0", ")"}], " ", "=", " ", "3"}], 
   TraditionalForm]]],
 ". Also we give values for constant coefficients.  "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"k", "/:", 
   SubscriptBox["k", "10"], "=", "0.1"}], ";", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "20"], "=", "0.2"}], ";", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "30"], "=", "0.5"}], ";", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "12"], "=", "1"}], ";", " ", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "13"], "=", "2"}], ";", " ", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "21"], "=", "1.4"}], ";", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "23"], "=", "1.1"}], ";", ";", " ", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "31"], "=", "1.1"}], ";", 
  RowBox[{"k", "/:", 
   SubscriptBox["k", "32"], "=", "0.8"}], ";"}]], "Input",
 CellLabel->"In[84]:="],

Cell["Here is the solution", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x1", "[", "t1_", "]"}], ",", 
    RowBox[{"x2", "[", "t1_", "]"}], ",", 
    RowBox[{"x3", "[", "t1_", "]"}]}], "}"}], "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "[", "t1", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "2"], "[", "t1", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "3"], "[", "t1", "]"}]}], "}"}], "/.", 
   RowBox[{"SystemDSolve", "[", 
    RowBox[{"model", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "0.1"}], " ", "t"}], "]"}]}], ",", "2", ",", 
       RowBox[{"0.2", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", " ", "t"}], "]"}]}]}], " ", "}"}], ",", " ", "t", ",", 
     " ", "t1", ",", " ", "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[85]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"0.9837287922772097`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "4.3463116825637025`"}], " ", "t1"}]]}]}], "+", 
     RowBox[{"0.0040819898850336656`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "3.5553585022284833`"}], " ", "t1"}]]}], "-", 
     RowBox[{"3.5011517944290627`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.29832981520781576`"}], " ", "t1"}]]}], "+", 
     RowBox[{"3.5051546391752653`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1`"}], " ", "t1"}]]}], "+", 
     RowBox[{"0.022469245583020155`", " ", 
      RowBox[{"sin", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "-", 
     RowBox[{"0.007002463178325062`", " ", 
      RowBox[{"cos", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "+", "1.9826464208242986`"}], ",", 
    RowBox[{
     RowBox[{"0.14657583091457463`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "4.3463116825637025`"}], " ", "t1"}]]}], "+", 
     RowBox[{"0.016767611041367925`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "3.5553585022284833`"}], " ", "t1"}]]}], "-", 
     RowBox[{"3.109790354459104`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.29832981520781576`"}], " ", "t1"}]]}], "+", 
     RowBox[{"2.6804123711340284`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1`"}], " ", "t1"}]]}], "+", 
     RowBox[{"0.01848858504802925`", " ", 
      RowBox[{"sin", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "-", 
     RowBox[{"0.007284330648223921`", " ", 
      RowBox[{"cos", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "+", "2.273318872017357`"}], ",", 
    RowBox[{
     RowBox[{"0.9280241118263294`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "4.3463116825637025`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.023030385689159827`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "3.5553585022284833`"}], " ", "t1"}]]}], "-", 
     RowBox[{"4.959423726037103`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.29832981520781576`"}], " ", "t1"}]]}], "+", 
     RowBox[{"4.329896907216505`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1`"}], " ", "t1"}]]}], "+", 
     RowBox[{"0.0525232441788833`", " ", 
      RowBox[{"sin", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "+", 
     RowBox[{"0.030389925655223724`", " ", 
      RowBox[{"cos", "(", 
       RowBox[{"2.`", " ", "t1"}], ")"}]}], "+", "2.6941431670282046`"}]}], 
   "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280658608622*^9, 3.479966544942038*^9, 
  3.479966751213038*^9, 3.479967342732038*^9, 3.479968236337038*^9, 
  3.513396437595671*^9, 3.582349731089532*^9, 3.582350833473486*^9, 
  3.5823513762799397`*^9, 3.5922037791166277`*^9, 3.5922038308176613`*^9, 
  3.5922039112292695`*^9, 3.6427609430385847`*^9, 3.6502697987557325`*^9},
 CellLabel->"Out[85]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], ",", 
     RowBox[{"x2", "[", "t", "]"}], ",", 
     RowBox[{"x3", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "100"}], "}"}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<days\>\"", ",", " ", "\"\<r\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<x1\>\"", ",", "\"\<x2\>\"", ",", "\"\<x3\>\""}], "}"}], 
      ",", "Right", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.479966670842038*^9, {3.592203740153957*^9, 3.5922037559161634`*^9}, {
   3.592203804897143*^9, 3.5922038054271536`*^9}, {3.592203843087907*^9, 
   3.5922039583602123`*^9}},
 CellLabel->"In[86]:="],

Cell[BoxData[
 FormBox[
  TemplateBox[{GraphicsBox[{{{}, {}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwUl3c8lu8Xx59hPhHZs8wyyt7r+dgSZZSUlERJCCmSVdKUtBCSFDIjhVRI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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwUl3c8lf0bxzmH4xwN2TLKyt4r+3zOMZOkyExpkISEUFmhUiGplChSCNEQ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         "]]}, {
        Directive[
         Opacity[1.], 
         RGBColor[0.560181, 0.691569, 0.194885], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJwUV3c81W8bljrTwbG37L33duGQpJJfyWhIiqykREOEtCRJKoRkK5JRSUJa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         "]]}}}, {
     DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {
        FormBox["\"days\"", TraditionalForm], 
        FormBox["\"r\"", TraditionalForm]}, AxesOrigin -> {0, 0.9}, 
      DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
        AbsolutePointSize[6], "ScalingFunctions" -> None}, 
      PlotRange -> {{0, 100}, {1.0000102040425238`, 4.2971560897929155`}}, 
      PlotRangeClipping -> True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
     FrameBox[
      FormBox[
       TemplateBox[{"\"x1\"", "\"x2\"", "\"x3\""}, "LineLegend", 
        DisplayFunction -> (FormBox[
          StyleBox[
           StyleBox[
            PaneBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                   AutoDelete -> False, 
                   GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
               GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}},
                AutoDelete -> False, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
              "Grid"], Alignment -> Left, AppearanceElements -> None, 
             ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
             "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
           FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
           False], TraditionalForm]& ), 
        InterpretationFunction :> (RowBox[{"LineLegend", "[", 
           RowBox[{
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                 ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                 ",", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                   "]"}]}], "}"}], ",", 
             RowBox[{"{", 
               RowBox[{#, ",", #2, ",", #3}], "}"}], ",", 
             RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
             RowBox[{"LabelStyle", "\[Rule]", 
               RowBox[{"{", "}"}]}], ",", 
             RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
        Editable -> True], TraditionalForm], RoundingRadius -> 5, 
      StripOnInput -> False], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806599692936`*^9, 3.479966545636038*^9, 3.479966759852038*^9, 
   3.479967345166038*^9, 3.4799682370970383`*^9, 3.5133964394863443`*^9, 
   3.5823497331977425`*^9, 3.582350835694708*^9, 3.5823513785376205`*^9, {
   3.5922037802866507`*^9, 3.5922039595802364`*^9}, 3.6427609433042116`*^9, 
   3.6502697990213575`*^9},
 CellLabel->"Out[86]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{
  "model", ",", "k", ",", "input", ",", " ", "ic", ",", "x1", ",", "x2", ",", 
   "x3", ",", "eq1"}], "]"}]], "Input",
 CellLabel->"In[87]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Large compartimental models ", "SubsectionIcon"],

Cell["\<\
Here is shown the metabolic uranium model as appeared in ICRP 78\
\>", "Text",
 CellChangeTimes->{3.6505972051424904`*^9}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .74965 
%%ImageSize: 720 540 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
2.35272e-017 0.00139082 -0.00139082 0.00139082 [
[ 0 0 0 0 ]
[ 1 .74965 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .74965 L
0 .74965 L
closepath
clip
newpath
% Start of gray image
p
0 -0.00139 translate
1.00139 .75104 scale
720 string
720 540 8 [720 0 0 540 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  Mimage
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFFF8FFF9FFFFF1FFFFFFF4FDFFFFFEFFFFFCFF
FFFDFFFDFFFAF7FFFEFFF9F0FFFBFFFFFFFAFFFFEDFFFEFFFFFFFFF6FFF8FFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFF9FFF5FFFFFFFBFBFEFFF4FFF8FFFFF1
FFFDFEFFFDFFF5FFF9FFFBFEF6FFECFFFAF5FFF7FFF7FBFFF6FFFFFAFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFF6FFF9FFFFF7FFE6F7FBFDFFEAFFFFFCFFFCEEF4FFFF
FAFFF4FFFFFFF1F7FFF8FFFFFFFEEBFAF1FFF6D9FFFFFAFFFEEEF5F8FAFFFFF5FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFF3F7FFFDF9F5FFFFFFF4FFFCFFF1FDFF
FFF9FFDDFAFAFFFCEEFBF4FFFFE3FFFFFEFFFDFFF7FFFFF1FFFFF3FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBF3FFFBFFFFF9FFFBFFFFFFFFFBFBEEF8FCFBFFFFFFFFF1
FFFFFFFFF4F7FFFFFCF8FFF7FFFDFFFFFFFCFFFFFFFCFFF3FFFDFFFFFBF9FBFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFAF3FFFBF7FFFFFFFBFFFCF6FFFBF6FFFCFF
F0FFFFFFF9FFFFFFFFFAFFF5F8FFFFF6FAF1FFFBFFF5FFFFFFFBF1FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFEDFCFFFFFCFCFFFFEDFAFFF8FFFFF9FFFDF9FEF6FBFF
FDFFFEFFFAFFFFF1FEFFF6FFF8FFFFE7FFF6FEFDEEFDF6FFFFF9ECEDFCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFF09F9FEFFFFFCF7F30000FF01FBFFF00006
15E9FAF30900FFE8F6FF000006FFEBFFFF0B000AF1FFF5FFFFFFFCFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFCBF2FFF8B3FFFFFFBAC3D2C7F7FDF9C1FDFBFFB6C3D7ABFF
FBF9C5ECFFF7C5C5C6C1F9FFF4C9FAFFFFBAD3B6C5FFFFEBB9FFFFF5FFFFF6FAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFF00FFFFF0FCFFFF02FFFF0000FFEF0FFCFE
FB00FF00FDFF00FFF60AF8FFF100FFFF00FEFDEE02FFFDF8FEFFF6FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3BCDFFFF42FFFFFF3F3B3D38FCFFFF3CFFFFFC5A25403FF6
FFF74CF7FFFD30443549F8FAFF00FFF5F84F314843E5FFFF49E9FFFFFFF2FCFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F20CFFFFFFFFF5FF00FAFBFF0BFDFE00FDFF
FFFEFF00FEFFF3F7FF00F1FFFFFFFEF9F8FFFDFF00F7FFFFFBFFFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3FD1FDEEFDF0FFF7FFFFFFFDFBFFFBFFF3FFEBF7FFFFFFFF
E1FFFAFFF2FDFFF9FFF5FEFFFFF605FFFFFFFFF7FFFFFCFAF4FFB7FFFFFFFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FF00F2F5FFE8FFFBFF00050000FEFF000700
1004F10BFFFDFFFFEB0016000009FDFFFD000001FFFFF0FCFCFFFFF1FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF44ABFFFFFFFF00FEFDF7FFFF00FC0CF8FBFF00070100FFFD
0DF1FFF50BFFEE090000FFFDF5FF00FFF4FFFF000B00F7FFFFC433FAFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF500010C00FFF9FFFAF6FFFA09FBFA03FFFE
FF00FA02FAFFF7F8FF08EEFFFF00EBFF04FFFEFAFFF5FFF8FFF6F8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF42C1F6FEFFED01FAFFF9FF09F6FD05F6FF00FFF8FF04F2FF
0CF6FAFF00FB00FFFCFF00FFFFFC00FFFFF705F5FFFF00FFFFD51DFBFEFFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF60EF7FFFFF8FFFF00FFF1FF09F7FF00FFFB
FF00F40EFEFE00FEFE00FEFEFA0CFBF202FFEBFF0DF1FFFAFFF0FFF6FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FFFDFFFFF711FFF0FF00FFFFF600FFF305FCFFFF00FFEC
00FFFFFF00FF0FFAFFFEFFF7F008FD00FDFFF1FFF5FF0DF4FDE122FFF6EFFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FF00F9F0FEFFFDE9FF000000F2FFF2FF0000
08FFFFFF0500FFFBFBFF000502F3FFFFFF001300F1FFFBFFFFEFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9DFFF0005FF00FFE7FFFF00FFFF00F9FCF700F1FF
00FEFFE910FF0004000508E5FF0EF103F7FFF20A0000FEFFFFE358F9FDFFFFF6FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFF05F4FFFFF2FFFFFFFFFFFFFBFFFFFFF7FF
FFF6FBF1F8F5FFFFFFFFF5F8FEFFFBF7FFF2FDFCFFF3FFFFFFFFFEF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF4FFFBFDFFFF07FD00FEFFFFF7FB00FFEE00FFFFFF08F5FF
01FEFFFF00F215FFFFFF00FFF503FE02FEFA1BE5FFFFF0F7F8FFFFFFF4FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFF3000000000BFBFFF9F5FDFBFAFFFAFFF7FB
FBFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFF9F5FFFBEBFFFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3DC1FEF5FFF800FFFF00FFF6FFF918FFFF00FFFB0003FEF8
0402FFE603FF00FBFFED07FF01F1FFF80BFD00FFFFFC00FFFFFAFFF5F8FFF2F2FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFF8F7FFF4FAFFFEFDFAFBFFEAFFFF
F0F2FCFBF7FFF9FFFFF9FFF7FFFCFFEDFFF1FFFCFFFFFBFDFFFCFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFF1FA15FEFFED03FFFFF800F5F0FF0400FF00FFFD
00F60800FFFEEF050200FFE709FFF3FD00F6FF000000FBF4FFF2BCFFFFFCFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEF5FFFFF1FFFFF3FFFAEFF7FFFFFFFFFFFFF2
FFFFFEF8FFFCF8FFFFF8FCFFE9FFF6FFFFFFF8FFF0FFF2FFFFFAFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFBFFFC00FEFFFFFD00FFFFFCFFFFEAFFF6FF00FEF6
FFFCFFF3FFF9FFFAFFFFFFFFFDE1FFFFFFFFFEF6F4FFFFFFFDD86FF0FCFFF7EEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FEFFFFFFF7FFF9FFEFFFFFFFF1FFEFF6FFF2FF
FFFFEFFFFFFBFFEEEEFFFBFFFFEEFFF6F9FFFFFEFDFFFFFAF6F9FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEF4FFFFF6FF09FAF8FEFFF70EF300F7F7FFFBF8FF05FCFF
FDFAFFFDFFFFF8FFFBFEFBFFF3FFFFFBF9FFF8FDFFFDFFF8FEFFE2FFF7FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFFF1FFFCFFFBF7FFFFFEFFFFFFFFFA
FEF9FFF1FDFEFDFFFFFDFEFDF8FCFFFFF5FFFAFFFFF3FFFFFBFFFFF4FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF41C0FFF6FDFFF9FFFFFFFFFFFFFFFFFFFFFFFEFBFCFDFEFF
FBFFFFFFFDF9FBFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFEFFEDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDF9FFFFFFFFFFFCFBFFFFFEFFFFFF
FFFFFEFDFEFFF8FFF3FFFFFDFEFBFFF6FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF34C1FFFFFFFFF8FEFFFFFFFFFFFFFFFFEBFFFFFFFFFFFFFC
FFF9F1F7FFFFFFF3FFFCF8FEFDF4F3FCFFFFFFFFFFFFFFFFF9FFCCFAFDEFFFF6FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FDFFFCEFFFFFEEFBFFFFFBFEFFFFF4FEFEFEFF
FFFFFFFFF6F5FFF0FFF9F4FFFFFFFFFFFFFEF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4DBDF7EFFBFFFFFFFFFFFFFFFFFFFFFFFFFFF0F8FFFFF9FF
FDFFFFFFFEFBFFFFF1FFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFD11CFFFEFFF3FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFEF8FFFFFFFAF8FFFFFABE84725F4538
42638BA6FEFFFBFCF7FFFFF6FFF2F9F7F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3EB4FFFFFFF8F6FFFFFFFFFFFFFFFFFFECFFFFF1FAFEF8FF
FDFBFBFEFFFFF9F3FFFEF8F9FFFFFBEDFFFFFFFFFFFFFFFFFFE016FFFBFCFFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFCF6FFFFEEEFFFFFF7B44C123A84899DB8C7
BC9A70540C418EFFFFF6F7FFFFFFFFFDF8FFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF5FFFFFCFAFFFFFFFFFFFFFFFFFFFFFAFEFFFFF9FF
FFFFFFFDFEFFFFFFFFF7FBFFFFFBFBFFFFFFFFFFFFFFFFFFFAE62AFEF3FBFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDFAF8FFFFFF984054A9EAFDFBFFFFFFFB
FBFEFFFFFCB46B0F8CFCFCFFF2FEFFFFFCFAFEF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAFFFEF9FDFDFDFFFFFFFFFFFFFFFFFFF8F4FDFFECB7805F
3E42423E4871AFDFFFFFFFF3F1FFFFFCFFFFFFFFFFFFFFFFFFE04FFFF8FFF9FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF5FFFFCC206BC3F6FFFFFFFFF4F9FFFF
FFFFFBF7FFFFFFFA6615B8F7FFFFEDF7FFF9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEFFFFFFF5FFFFFFFFFFFFFFFFFFF1AB450F458C96
BEBFC2C4B4884D212C8BECFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFF8FFF5FFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFF4FFFFAA3BDCF3FFFDFBFFFFFAFFFFFCF9
FAFDFFFFFBF9FBFBFFF05A70F1FFFFFAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF49A8FDFFFBFBFFFEFFFFFFFFFFFFFFFF8D354CBFF8FCFFFF
FFFFFCFCFEFFFFFFD8662D7BE4FFFFFDFFFFFFFFFFFFFFFFFFEDFFFFFFFFF4FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFF4FFFE7552ECFEFFFFFFFFFCFDFFFFFFFFFF
FFFEFEFDFFFFFFF9FFFEEE8A53E2FFFAFFF9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDF9FFFFFDFBFFFEFFFCFFF3FFFCFAFFF7FFFFFFFFF4FFFBFFF1FFF9
FFFAFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFF9FFFEFFF9FF
FCFFF7FFFEF5FFF2FFFFFFFFF0FFFFF6FFFDFFF0FFFAFBFBF6FFFFFDFFFFF7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF5FBFFF5FDFFFEFFFFFFFEFFFFCF216CC9FFFFF6FBFFFD
FFFFFFFFFFFFFFFFFDFFE9753299FFFFFBFFFFF2FFF6FAFFFDFEB6FFFFF6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFF7684FFFFFDFFFF00FFFFF1FFFC00F9FF
FFFFFE00FFFAFF07FFFCFFFEB451FEFBFFF8FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFBFCFDFFF7FDFDF5FFFFFFFFF7FEFFFFEEFBFFFEFFFFFAFFFFFF
F6FCF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFAFFF3FFF8
FFFDFFFFFFFDDEFFF8FBFFF0FFFEF0FFEFFFFFFFECFFFFFDFFFFF8F9FAEEFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFCF9FFFCEFFFF69332F0F7FFFFFEFFFFFFF5
FFFFFFFFFFFFFFFFF7FFFFFFE56560F1FFFCF2FFFFFFFFF1FEE960FFFAFEF9F1FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF7FF9468FFF9FDF8FFFC06FFEAFFFCFF00FFFF
F2FF00FFF1FFFDF8FDFFF1FFFD9963FFF4FFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FFFFFFFCFFE7FFFAFFF7FFFDEFFFF9FFEDFFFFECFFF9F9FFFFF6F2
FFFFF8FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFFFCFBFFFE
FCFFF6FFFDFBFFF5FCFFE9FFFCFFFCE5FFFFF3FDFFF5F9FFF0FFF7FFFCFFFFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEDFEFAF5FFFFFEFEF6FFFFFA7271F2F0FFFFF5F7FFFFFBFF
FFFFFFFFFFFFFFFFF9FFF5F0FFF59C4EEAFDFFFAEDFFFFF8FFFAF6FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFC342ECFFFFFFFFFBFF00F0FFFDFCFB00FFF5
FFF300FBFFF6FAFFFFFFFFFEFFF57486FFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFCFAF9FFFFFFFFF0FFF3FFFFFFFDEFFFF8FFFFFCFCFFFEFFFFFB
FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFECFFFFEEFF
FFF8F6FFF8FDF2FFFEEBFFFFF8F8FFFFFFFFFDF9F6FFF5FCFFFFF8FDFFF9F8FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF51C0FFFFFFFBF6FFF0FFFF6287FFFFFFF6FEFFFFFFF3F3FF
FFFFFFFFFFFFFFFFFFEDFFFFF0FFFAB152F2FDFFFFFFE0FFFAFFFFEAFFF4FFE9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFED2AE6F1FFFFFCF6FFFC00000002FFFF030005
000F0AF7FEF8FFFFFCF8F2FDF5FFF53ACBFAFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCF9FFFFF4FFE2F3F8FFFFFEF4FFFDF9FBFEF1FFFBFCFFFFFBFDFF
F8FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFEFFFF9FFFFFD
F5FFFFEEFDFEFFFEFFFFF2F9FFF4FFFBFFEFFFFFFAF7FFFFF0FCFFEAFCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF31BDFFFEFFFFF6FFFFF98F7DEFFFFAFFFFFFFFFBFFFFFDFF
FFFFFFFFFFFFFFFFFDFFFFF9FDFFFFFF9459F5FFFEF1FFFBFFE4D2FFF2FFE6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC926EF5FFFFEAFFFFFFFD00FFF4FFFAF60BFBF1
FFFE00FFF9FFF5FDFAFDFFFFFFF4FFB14EFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFCFFFFFFFEFFFFFFFFF7FFFFFFFAFFFFFEFFFFFFFFFFF4FFEDFFF6
FFF6FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFCF2F2
FDFFF7F7FFFFF3F0FFECFFFFFEF5FFFEFFFBFDF8FFFFF8F5FFF9FFFFF4FFF7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF46C1FDF3FFFFFCFFFFBD39FFF2FDFFF3F6FEFAF5FEFFFFFF
FFFFFFFFFFFFFFFFF4FFFDFFFFF1E8FFFF857BF4FDFAF6FFFFE915FFFFFEFFECFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF38E3FFF7FFFFFCF5FCEB13EAFCFFFFFF00FFF2
FFFFF500FFFAFF0BF2FFF1F2FFF8FAFF4BB2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFAF9F3FFDBFFF2FCFFEDFFFEECFFF5FDECFFE7FCFFFFFEFFFFFA
FFFEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6000B000000FFFF
FF05F8FEF70002FF00FEFF00001100FFFFFB050D0000FFFFFF060000FFEDFF00FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF45B6FFFFFFF6F7FFFC0FEDFAFFFFFBFFFDFFFFFFFFFCF6FC
FFFFFFFFFFFFFFFFFFFFFCFBFFFFFFF3FFFF1CEFF0FFFFF6FADD28F6F9F6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8179FFF7FFFAF9FFFDFFFF0005090004EC0A0009
0000FFFF040100F5FBFDF8FFF3FFFFF4B746FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFAFFFFFC060003FFF4FFF606FFFBFF02FFF806FFF8FF02F8FEFF
000208FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFAFF00FF
FD00FFFF00FEF90301FD00FCFFF409FFFB07F5FBFF00FFFC00FFFFFF03F1FF04FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFDF7FFFFFAFD778DFFFEFBF4FFFBFFFDF4FAFFFFFDFF
FFFFFFFFFFFFFFFFFFFBFFFFFCF9FFFFFFFFC72DFFF5FFFFFFD321FFFFFFFDFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3ABDFFFAFDFFFEFCFFFBFBFDFFFEFFFDFFFBF9FF
FFFFF5FFF4FFFFFFFFF8FFF7FFFFF5FFF423F3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFFF6FFF900FFFEFF00FFFFF500FFF9FF00FFF900FFF1FF04F0FF03
EEFFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07F6FFFBFF00FF
FF00EEFF01FFF9FC09F60CFFFEFF03FAFD00FFFFFF02FFFF07F5EFFFF6FBFF03F7FFFCF8
FFF3F8FFFFFFFFFFFFFFFFFFFFFBFAFFF4FFFEE22AFBFFFAFEFCFFFEFFFFFFFFFFFFFFFF
FBFFFFFDFCEFFFFFFFFFFFFFFFFFFFFFFFF5FF50B7F6FDFFFFEB52FFF9FFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFF8FFFFFFD031F1FFFBFFFFFEFFFFFFF6FFFAF3FFF3FCFFFEFF
EBF7FFF8FDFFF6FFFFFFFFFDFFFBFFF5FE738BFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDF9FFFC03FAF9FFF9FF00F9FF07EFFFFF00F4FF08F7FFF000FFEB00
FFF7FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD00FFFFFFF204F9
FF11FCF1FF00000600F700FFF6FE03FEFF08FCF9FD00F6FF000F1B0002FFEC00FFFEFAFF
FFFEFFEEFFFFFFFFFFFFFFFFF9FFFFFEFFFBF58078FFFFFDFFFFFDFEFFFFFFFFFFFFFFFF
FFFFECFFFFFFFFF0FFFFFFFFFFFFFFFFF8FFFEB943FDFFFBF9FFFEFFFAF6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFFFEFDF9F69D64FFFFFEFFFCFFFEF6FFFAF8FFFCF6FFFFEAFFF0
FFFFFCFFEEFFFCFFFFFFFCFFFEFBFFFBFF946AFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF5F1FF00FFFFF4FCFF00F8FF00FFF5FF00FFFF00FFFEFF0DF6FF00
00000009FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE010005000009F8
F600F7FFFFFFFAFF00FF00FDFFFF00FFF409E9FFFF00FFFF0FEAEFFF00F5FF00FFDFFFF8
F9FAFFFFFFFFFFFFFFFFFFFF41B6FAFEFFFFFA2BD2FFFCFEFFFFF9FFFFFFFFFFFFFFFFFF
FFF6FFEDFFF9FFFFFFFFFFFFFFFFFFFFF5FFFDFF13DDFFFAFFFCFFF1FDFFFBF3FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9FFFFFEFFFA7889FFFEFDFCFDFFFEFFFFFFF3FFFFEFFFFBFFFFFF
DFFAFCF9FFFFFBEEFFFFF8FFFDFEFFFBFFC13BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFBFF05FDFBFBFFDE05FFFC06FFFFF20BFFE60AFFF8FA00ECFF0C
FFFBF703FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF04FFEBFFFD00FF
FF00FCFF00FEFFF000FF0AE8FF0015FAFF00FFFF000CFFEC00FFFFFF00F4FF0600FFFCFC
FFFFFDEFFFFFFFFFFFFFFFFFFBFFFFEDFFFED21BFFFFFBFCFFFFFAFFFFFFFFFFFFFFFFFF
F3FFF5FFFFFFEFF9FFFFFFFFFFFFFFFFFFFFFFFD6393FFFFFDF7B5FFFBFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8FEFFFBFFFF61A0F8F7FFFCFFFFFAFDFAFEFEFFFFFFF6FFFFF0FB
FFFFF4FFF3F0FFFFFFF9F4FFFFFFFEF5FFE815FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF4FFFFF600FFEEFFF7FF09FBFF0200F6FF00EFFF0303F9FF0BFEFF00
F1FFFF00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00F2FFFCFF00FF
F507FFFCFE000000FFFFFC0B04F700FBF9F80006FB00ECFFFA060000FFFFFF00FF00FBFF
FFF5FFFFFFFFFFFFFFFFFFFFFFF7FCFFFEEA9C80FFF7FFFCFBFFFEFFFFFFFFFFFFFFFFFF
FFF9FFFFFFF6FFFFFFFFFFFFFFFFFFFFFFF5FFF2B44FFFFFFFDF6AF5FAFFF7ECFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFDFFF5FFFB42BFFFFFFFFDFFFFF8FDFFF3FFFFF3FEFFFBF2FFF9
F9FFFFF8FFFCFDFFFCFFFFFEFFFFFCF7FFFD01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF0FF0FEAFFFEFFFA04FFED04FF00FE11FFFC0DEE0900F9F9F1FF
000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF09FFFDFFFF00F9
FF02EBF5FFF6FFFFFFF2FFECFFFF00FFFDFFFEF8FF05F6F6F9FFEFFFFFFFFDF9FBF3FFF8
FCFBFFF9FFFFFFFFFFFFFFFFFAF7F9FFFDFF667EFFF9FFFFFCFCFFFDFFFFFFFFFFFFFFFF
FCF1FFF8FFFDFCFDFFFFFFFFFFFFFFFFFDF9FFFFC62DFFFAFCFFF7FFFFF9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFEFEFFFBFFFA3CC5FFFFFFF8FFFFFFFFFEFFFFDAFFFD0203000903
F50B0004E7FFF6FFF7FFFFFAFBFFFFFFFFFC03FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFDFFFF00FFFFEDF9FF00FFF6FFE9FFFCFAFFF4F5FFFAFFFFFFFFFF
FFFAFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7000F000000FCFF
F409FFFFF2FFF0FFFAFFFFFFF8F401FFFFFBFCF6FA0CF2FFFFFAFFE6FFFEFDFFFFFCFFFC
FDFFF2FFFFFFFFFFFFFFFFFF4CC1FEFDF8FF5FACFFFCFFFFFFF7FFFBFFFFFFFFFFFFFFFF
FF00060000FFFFFFFFFFFFFFFFFFFFFFF8FFFFFFDF14FFFAFFFAFFF2FFFFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FFFCFFFFFFFF54ADF6FDFCF9FFFCFFF3FFF7FFFFFFFCFF00FFFBFF
00FDF1FF15E9FFFFF9F8F0FFFBFEFFFFFFEC15FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9FFF204FFFCFFFEFF05FFFEFEFBFFFE00FFFAFFFFF8FFFAFFFBF8
FFFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFAFFFFF4
FFF5FFFFFDFFFFFFFEFCFCF3FFFFFBFDFCFFFEFFF4FFFAFFFCFFF9FEFEFCFFF6FCFCFAFF
F8FFFFFEFFFFFFFFFFFFFFFF3DBEF8FFFFED42BCFFFBFBFCFFF4FFFBFFFFFFFFFFFFFFFF
00FEFEFFFF00FFFCFFFFFFFFFFFFFFFFFFFFF9EDFF00FAFFFFEBCDFFFCFFF5FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFF9FEF9FAFF649DF4FFFFFFFFF5FFFFF2FFFFF4FEFFFAF908FCFE
04FAFFF200FFFBF5FFFFF1FFFFFEFEFEF9DC27FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFF
FFFFFFFFFCFFFBFDFFFFF8FF46B5FFF8FAFF49B9FFFDFBF8FFF5FFF9FFFFFFFFFFFFFFFF
07F3FFF4FF00FFFFFFFFFFFFFFFFFFFFF7FFFDFBFF00FFFFFFDC17FFFFFFF4FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFFFF7FFFFFFFEF6FFF9FFFAFAFCFFF3FFFFFBFFFFF4FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFCFFFAFFF8827DFFFEF1FFFFFCFDFFFEFFFDF9FFFFFFFCFF00FE
09F6FEFF06F9FFFFF6FFFFFFFCFFFFFFF7BE40FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFEFEFFFFFCF1FDFFFDFB41B9F6FFFFFB4CAFFDFDFFFBFFF8FFF9FFFFFFFFFFFFFFFF
00FBFCFFFC00FFFCFFFFFFFFFFFFFFFFFEFDFDFFE316FFF6FBE02FF4FFF6FFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF3FFFFFFF9F4FFFFF1FFFFFAFFF6FFFDFFFFFAF6F9FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF5FFFBFEFFBD34FFF1FFFCF7F7FFFBFFFCFEFFFFFAFFFFFAFB00
00FFF8FF00FCFBFFFFF5FBFFFFFFFFF6FF7F7DFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE
FEFEFEFEFFE6FFFFF1EEFFFFFFFFFDD197F38690FEFAFFFCFAFDFFFCFFFFFFFFFFFFFFFF
00FFFFFFFE01EDFFFFFFFFFFFFFFFFFFFFF7FDFFCE31FFFBFFD619FEFFFFFBFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFEFAF2FFFFFFF0FFF2F4FFFFFFFFF0FFF2FFFFFAFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF2FFFFFAFFF52BCFFFF4FFFFF9FFFFFFF3FBFFFFFFF5F4FFFF00
07FFE5FF01FFFFF1FFFFFFF6FFF7FFF0FF24DAFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFFF8FFFFF6FFFFFAF4F9BC711F56FD9367FFF8FFFAF9FFFEFFFFFFFFFFFFFFFFFF
FF00020007FFFFFFFFFFFFFFFFFFFFFFFFFCFEFDB551EFFFFFE859FFFFFFF1FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF4FFFFFFF8FBF6F7FFFFFFF8FFF4FFF3FFFFFBFDFFFCFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFF7FFFFFAFFFF6598FFF8FEFCFFF3F5FEFFFFEBFFEF0FF7FCFF01
00FFFFFC00EEFFFFFCF6FFFDFFFDF7FFD41BFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDF6F9FFEFB02B198DE4FDFFBF38FFFFFBFCFFFFF9FFFFFFFFFFFFFFFFFF
00FFFFFFFA00FEF6FFFFFFFFFFFFFFFFFCFFFFFF6C8FF1FFFDFFEDFFFFFCFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF3F6F9FFF0FFFFFFDFFFFFF7FAFAFFF9F5FFFBEBFFFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFEFDFFFFFCFBC739FFF7FFF4FEFFF5FFEDFCFFEEF5FE0E0000FF
FF000B00FFFFF4FAFFFFFDFEFFFCFFFF6F7CFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFF
FFFFFFFFF8F8F5FFF05A0C5326CBFFF8FFFDFB2AD6FFFCFFFFFFF7FFFFFFFFFFFFFFFFFF
00FCF5FFFF00FFFDFFFFFFFFFFFFFFFFF7FFFFFF26D9FFF6F7FFF2FFFCFFFEFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFDFFFFFFF7F6FFFDF7FFF3FCF9FFFCFFFFF3FFFFFFFFFEF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFFFFF7FEFFFFFCFF47A3FFFFFDF6FFFFFCF5FFF5FFFFF9FDFFFEFA
EBFFF7FFFDEDFFFFFBFAF8FFFEFFF9D525FFEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFF
FFFEFBF9FFFFB83F1674E3FFFFFFF1FEFFE9FF687EFFFFFFFFFCFBFFFFFFFFFFFFFFFFFF
00FFFEF9FF00FAFFFFFFFFFFFFFFFFFFFAFFFAC13CFFFFF8FBF195FFFAFFF1FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFEEFFFAFEFFF8FFFFF8FFFDFFFFFDF7F1FFFBFFFFEFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFBFBFFFFFFF9E621FEF5FFFFF5FEF6FFFFFFF3FAF7ECFFFEFC
FFF2FFFFFFFFFFF7F6FFFFFAFFEDFF4BB4F9FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFF
FFFAF5F27A2732A8FBFFFDFCFFF8FFFBFFFEFFD231FDFFFDFFF9FFFFFFFFFFFFFFFFFFFF
FF00000700FFFEF9FFFFFFFFFFFFFFFFFFFFF57786FFF1FFFEF583FAFFF9FFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF000700FBFFFCF5FD00FFFBF5FFF9FF0DF1FFFAFFF0FFF6FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF6FFFFFCFCFBFFFFFF8C73FFFCFFFFFFFFFCEEFFFFF9FFFFFDFFFF
F1FFF8FFF8FFF7FCFFF7FFFCF7FFAF49FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FFFFFEFCFFFFFAFFFBFAFFFFFFFDFDFFFFFDFFFFFFFFFCFFF8F8FF
FFF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF7FEFFFC
FEFFFFF7FEFAFFFBFFFCFFFFFEFFFFFDFFFFF3F2FFFFFEFEFFFFF5FFFFC561FFF7FFFDFE
F7CB531574C5FFFFF1F6FFFFFEFFFDF7FFFFFAFD788BFEFBFFFFF3FFFEFFFFFFFEF8FAFF
FFFFFFFFFFFFFFFFFBFCFFFFFEFCFFFFFEFECC32FAF5FFF9FFF7FFFFFFFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDF9FFFFFFFEFFFCFF
F3FEF6FFFFFD05FFF1FFF1FC04FBFAF4FAFFFFFFFD00FFFFFFFBFFEEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF52A0FFE8FFFFFDF5F7FCFEFDFDFFFFFFFF
FDFBF8F7FFFFFAFFFFFFFAFFFFDA39F2EDFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF8F6FEFFFFFFF9FFFFF5F0FAFFFFFFFFFDFCFEFFFFFFEEFFFFF8
FFFFFDF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF2F4FFFFFFFFFD
FBFFFAFFF3FFE9FFFDFFFDF7FFFDF5FFFFF1FFFFEEF9FFFCFCFFFAFFD72A14D9FFF3F2B0
2230A1F8FDFFFFFFFFFFFFF845B6FFFFFFF6F7FFE535DCFFFFF7FFFCF7FFFDFCFFFFFEFA
FFFFFFFFFFFFFFFFFEFFFFF9FBFFFFF2FEFF33B7FFFFF7F9F4FFFCFFFFFFFCF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFCFEFFFFFAFFFFE4FEF6
FFFFF5FDFFF901FFFBEBFF01FDFFFFFFFFF2FFF9FDFF00F7F2FFFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFEEF74FB8FFFFF1FDFFFFFFFEFCFDFEFEFDFE
FFFFFFFFF5FFFFFBF9FAFFFFE824ECFFFFFFF5FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFFFFFFFFAF5F5FEFFFFFFFFFFFBF8F9FCFFFFFEFBF9F9FFFFFBFF
FFF9FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFF9F7FF
FFFAF9FFFFFDFFFFBA8E73593D51777A86E6EFF6FFFFFFF8FFF0F8FF160000A1E95E0D5A
B3FFFFF2FFFBF4FBFFFEFEFF46C1FDF3FFFFFCFFFCA165FFF3FFFDFBFFFFFFF6FFFFFFFD
FFFFFFFFFFFFFFFFFFF1FBFFF9F0F9FFFF965D1500152F51727457DAF3FFFAFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FBFFFFFFF50A000FFD
ECF5FFFBF8FF00FFFAFFFF02FFF10000FFFFFFF8FFF500FFF9F7FFEEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFF2309DEEFFFCF6F6FBFFFFFFFCFFFFFF
FFFDF5F0FFF9FFFFFAFFFFBA30E0FFE9F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCFBFAF9FBFEFFFFFBFFFFFFFFFFFFFFFCF9FFFF
F5F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF3F8FFFFFF
FFFFFFF7ED9D670B41718CA6C5AF868478182770C2F9F3FFFAFFF8330E0600000B94EAFF
FFFDF7FFF8FAFFFFFFF2F6FF31BDFFFEFFFFF6FFFFFE6E92FFFBFFFAFCFFFFFBFDFCFCFF
FFFFFFFFFFFFFFFFFFF1FEFFF3FFFFFFC04AFABF000F0200000000E5FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FEFFFFEBFFEF0FF7F9FD0E
00FFFFFFFBFB00F5FFFB00FFFFFF00FF00FFF6FFF3FFFF00FFFDFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FEFFFFE5607AF5FFFFFFFDF8FBFEFFFEFBF9
FCFFFFFFFAFFFCF9FFF19D3CDDE3FFFFF8FAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBF5F9FFFFFCF9FFFFFFFFDF9F73684745465372A2D6F7FFFAFEFF
FFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFCFAFFFFFFF7
F7FFFFA4285F90F2FFF6FFFFF0FCFFFFFFFFD18F4045C3FFFFFF4C0107000700C1FFFDFA
F4FFFFFCFFFFFFFEFEFFFFFF51C0FFFFFFFBF6FFFFF5FF4A9CFEFFFDF6F9FBFFFFFDF7FF
FFFFFFFFFFFFFFFFFAFFFFFFFFFFE8CC2FFAFFFD4500000F050A13FFF9FDFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFEDFCFFEEF5FE00FFFFED
0DF8F2FDFFFF06FFFFFF00FEF0FFFC00FFFAFFF0FFF4FF00FFFFE3FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFEFFAFFFFFF83319BF5FFFBFFFFFCFFFFFFFF
FFFDFAF9FFFFFEFAC24C5EFDFFFFFBF7FFF8FFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FEFFFFFFFFFFFFFEDB7C1915629794B7B9B6A6865C351D60E1FFEE
FFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFCF5FFFF
FFC51253ECFDFFFEF1FFFFFEFFFFEFFAF4F9FFFFFFBE4435DC7E00050000050058E9FFFF
FFFAF2FFF6FCFCF7FBFFFFFDEDFEFAF5FFFFFEFEF7FFFBF15E7FF8FEFFFFFAFDFFFFFAFF
FFFFFFFFFFFFFFFFFFFCFFFAFDFFB93BDEFFE9FFEF010000000617FFFFFBFCFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF5FFF5FFFFF912E6FFFF
EB15FFFFFD0000FFFBEF00FFFFFCF502FFFCF7FFFFFCF600FFEFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFDF9FDFFD962308CF1FFF4FCFFFDFCFB
FCFFFFFFFCFAB54236B3FFFAEAFFFCFFF8FBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFFFBFCFFFBEC554374DEFFFCEEFFFFFFFFFFFDF6EFEA942968EE
F8F6FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8EFFFFFF3FEFFED
8D40D9FFFDFBFFFAFFFDFFFFF6FDFFFFFFFFFEFFEFFFFFC0272954310208000800EAFFF2
FEFFF6F8FDFFFFFFFFFDFBF9FFFFFFFFFEFCFCF9F7FFF0FFF58A41FFF0FFFFF8FBFFFFFF
FFFFFFFFFFFFFFFFEFFFFFFFFD764CE7FFF0FFF0FF960008034438B9EEFFFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF6FFFFFFF3FAF700FFFAF7
FA01FFFEFFF7FFF9FDFF12EFFDFFFA0CF3FBFFEEFCFAFF04F9FCFFF7FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFFEF7FFF5FFFFD167203A8ECEE4F4FFFF
FFE2BBA2590949D7FFFCFFF6FFFFFFEBFFFFFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFBF8FFFFEB821CAFE3FFFFF7FFFFFFFAFAFCFFFFFFFFFCFEFF8F2C
74F0FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFF9FFE261
70F7FFFEF3FFFFFFFAFEFCFCFFFFFDFFFEFFFEFEFFFFF3FFF43B88FFF9F7FFBABBF5EDFF
FDF6FFFFFFFCF7FAFFFFFFFFFFF5FBFFF5FDFFFEFBFFFEFFFCFFA91E99DEFFFFFBFFFFFC
FFFFFFFFFFFFFFFFFFF4FFA92B79FFFFFFFFF5FFF5F430007BFF8C2B5EE4FFFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCEEFFFFF9FFF90B00FF
FF00FFFFFFFFF6FFFFF800FFFFF8FFFF00FFE6FFFFF7FF00FFFFF1FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFEFFFFFFF9FFFDFFFFFFF0C074361A0C0000
001D425BA7F2FFF3FFFFF5FFFCEDFFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF4FFFAF8FFFEFFFDFDFFFFEA3D8EF2FDFFFBFEFFECFFFAFEFFFCFFFEFEFBFEFDFDF6FF
8141E6FCFAFFF1FFFFF7FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFBFDFFF64EB0
FFFFFFFFFFFFFFFFFA08F4FFFEFF00FF00FFFEFBFFF6FFFFFBFF5491FFFFF4FFF8FEFFFD
E3F7FFFFFEFEFEFEFEFDFCFC48B7FFFFFCFDFEFFFDFFFFFAFCFFFDF2703A7CF0FFF7FFFF
FEFFFFFCFFF9FFFBF6A0424BD6FFFDFFFFF3FCFFFCFFB425F9FEFFE85B299AFBFAFFFFFF
FFFFFFF9FDF9FAFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FF00
07FBFFFFFAFFFFFFF9FA07F7FDF9FD000200FFFFFDFFF600FFFFF6FDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFFF4F8FFFFFFFFFFF7FFFAFBFFF9
FBFDFFFCFFFAFFFAFFF8FFFFFFFFFFFFF6F8FFFFFEFFFBF8FFFFFEFFFFFFFFFAFEFFFFFF
FDFEFBFFF4FFFEFFFFFEF9FFFDFCFFF9FDFDFFFAFFF9FFFFFBFFFFFDFFFFF8FDFFF9F2FF
F8FBFFFFF8FFFFFFFFFFF7FFFAFBFFF9FBFDFFFCFFFAFFFAFFF8FFFFFFFFFFFFF6F8FFFF
FEFFFBF8FFFFFEFFFFF6FAFEFFF0FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF4FFFFFFFDEFFFFFFFF8E323CBFAFFFFF6FFFFE9FFF4FCFCFFFEFFFBFFFFF8FFFFFFE1
FFBE25E0FFFAFFE2F8FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFF7FF6497FC
FFFFFFFFFFFFFFFFFF00FFFFFFF506FE00EEF5FFFFFFFDF9FFFDFF54A8FFF5EDFFFF9F21
7FFFEAFFFFFFFFFFFFFFFFFFF3FFFFF7FCFFFFFCFFFFFFFDFFFFFFFAFFD072222A83C1BB
F3FEEDFAD0BF7A590C64C0FBFFFAEAFFFCF6FFFFF8FFFFDCEFFF81F7FFA23F48F2F0FFFD
F8FCF5FFFFFFFFFDF7F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF405FFFE
FBFFF8F6FFF1FDFFFFFFF10EFCFFF7FF00FEFEFFFFEB0EFFFEFCF9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F4FBFFFFF6FFFFFFFFF5F3FFFFFFFFFDFFEFFF
FFFFE4FFFFFFFFF4FFFFFFF4FBF6FAFFFFFFFFF5FFEFFFFFF9FFFFEEF5FDFFFFFFF8F6F5
F8FFFDFFFFFFECFFEDFFFCF9FFFFF2FFFBFFFFF0FFFFFFF4FDF7FFFFF2FAFFFFF8C664F1
FFF9FFF5FFFFF5F3FFFFFFFFFDFFEFFFFFFFE4FFFFFFFFF4FFFFFFF4FBF6FAFFFFFFFFF5
FFEFFFFFF9FFFFEEFBFCFFFFFEF6FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFDFFFFF7FFF8FFDF16DEFFF8FFF9FF00F0FFF2FF0BFF00FFFAFF00F9FF00FFFFFF
F9FFE32EBDFBEAFFFFF7FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FF7D7EF4FF
FFFFFFFFFFFFFFFFFF00FEFEF4FD00F90DFFFFFBEFFFFFFBFFEAFFFC40C0FFFF811D0000
7EFFFFFFFEFDFCFCFCFEFFFFFFFBF7FCFFFDFAFCFFFFFDFFFFFCFBFCF5FFFFF5D383423E
13040D002C488CA2F8FEF5FCFFFFFCFFFFFEFFFFF5F8FFFFFFDF95FFF6FFF56A0E96F3FF
FFFFFFFEF2F9FBFBFFFFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FF
FFEDFDFFFFFFFCFEE8EFFF00FFFFF9FB00FFFCFFFFFF07F5FFFDFAFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFF1FFFFE9FFFFFFFFFEF9FAFCF7FDFFF8
FCFFFFFBFFFAFFFFFFF4FEFFFFFFFFFFFFFEFFFFFFFFFFF8F9FAFEFFFFFAF3FFFFFFFFFF
FFFEF5FAF0FEFFFFFFFFFFFBF5F9FFFFFFFDFEFEFFFFFFFFFFFBFEFFFFFFFFF4FD3008F5
F1FFFFFFFFFFFFFFFEF9FAFCF7FDFFF8FCFFFFFBFFFAFFFFFFF4FEFFFFFFFFFFFFFEFFFF
FFFFFFF8F9FAFEFFFAFFFFF7FAFFFAFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEFFCFFFFFDF6F72BEFFBFCFFF4FFFF01FFFFFFF300FD05FAFFFE0FFFF801FFF6FF
FFFFFDED4AE7FFEFFFFFFEF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF7C932FDFFF4
FFFFFFFFFFFFFFFFFE041000130000FE00FDFFFFFEFEFFF9FFFFFFFFC32C8110010A0008
87EAFFF2FDFEFFFFFFFFFFFFFFFFFFFFFCF4FFFFFDF6F6FFFFFFFFFFFFFFEFF4FFFCF4FF
EEFCFFFFF7FEFCFFFFFFFFFFEAF8FBFFFFFEFBFFFFFFF7F6FDFFFCF2FFFEFEFFD73D27C1
FFF3FFFBFFFFFCF8FDFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FF00F8
FFFFF3FFEFFFF8FFFFFFFFFF00FFFFFFFFF8FFF6FE00FBFBFFF9FFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFAF8FFFBEBFFFBF9F6FFFFFFFFF8FFEAFFFD
FFF8FFF0FFFAFCFFFFF9FCFFFAFEFCF8FBFBFEFFF7FFF6F4FFFFF4FFF7FFFFFEEEFAFDFF
FFF3FFFFF4FBFFF9FFEEFFFFFAFFFFF5F6FFFFF7F9FAFCFDFEFFFFF7FDECFEFFB500047A
FFFFE6FFFBF9F6FFFFFFFFF8FFEAFFFDFFF8FFF0FFFAFCFFFFF9FCFFFAFEFCF8FBFBFEFF
F7FFF6F4FFFFF4FFFFF7F7F7FDFFFCF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8FFFFFDFFFFFEF7FF3DC2F7FFF8EEFFFFFF00FFF5FFFF02FF00FFFF00EDFFFF00FDF7FF
F0F6FFF0CD39FCFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFF44B1FFF9FF
FFFFFFFFFFFFFFFFFF00EBFFFFFC05FF04FFEEFFFFF3FDFFFBFAF5F8E01800000C000000
0D1E454A49433C3C475B717F285B8FADBEC3BCB3FFFFFFFFFFF7F7FEFFFFFFFFFBFFFFF3
FFFFFAFFFFFFFEFEFCFAF5FFF8FFFFFBF5FFFFFDFFFFFFFFFFFBFFFCFFFFF2FCF9FFAC19
71FFF1FFFCFCFFFFFDF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0013FF
F6F6FFF1FFFFF6F6FFEAFDFFFF00FFE4FFFFF8FF00FFFBFFEEF0FFEFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFEF8FDFFFFF3FFFFFEFFF3EDFFFDF3FFFFFC
F6FFFDFFFFFFFBFBFFFFFFF0FBFFFAFDFFFFFAFAFDFEFFFFF0EEFEFFFFFAF5FFFFFFF4FF
FCFFFFF7FFFEFBFFFFFFFFF5FEFFF8FFFFFEF8FFFFF9F5FFF3FFFEF2FFFEFFF92D000000
E7FFFFFAFFFFFEFFF3EDFFFDF3FFFFFCF6FFFDFFFFFFFBFBFFFFFFF0FBFFFAFDFFFFFAFA
FDFEFFFFF0EEFEFFFFF9FFFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFCFFFDF4FFFF8365FFFFEFFFFFFAF9FF01FFF7F8FF08FF1200020000FFF305FDFFFF
F4FFFFFFF89D6AF7FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDB941FFF5FDFF
FFFFFFFFFFFFFFFFFF00FFFDFFFF00F500FFFEF8FFF4FFFFFFFFFFFBFCCE220600001500
7ED4BBBAAFB8C4C7BCA58A781A5A6C50484A424200000B213647586572719EC3BFD2FBFF
FFF6FFEFFFEFFFFFFDFFFFFFFBFFFFF9FBFFFFF7F5F8F9FEFFF18DF0FBFFFFFBFFFFF9ED
4818CCF2FFFEFEFFFFFFFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDFFE5FF
FFFFFFFCFEFDFFF6FFFFFFEEFFF8F4FFFFF7F5F4FFF4F6FFFFFFF3FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFFFEFFFFFFFAFEFBFFFFFBFFFBFFF6FFF3
FEF8FFF8F3F9FBFFF6F5F7FFF9FFFFF9FFFBF9FFF9FFFDFFFFFFFFFFFBFFF7FFF0FFFFFF
FFFAFFFFFFFCFFF5FCF4FFFFF2FFFBFCFFFFF8FFFFFFFAFFFFF1FFFFF9FBFFA20D000E0F
74FAE8FFFAFEFBFFFFFBFFFBFFF6FFF3FEF8FFF8F3F9FBFFF6F5F7FFF9FFFFF9FFFBF9FF
F9FFFDFFFFFFFFFFF5FFFFF3F8FFF0F2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFAFFF8FFFFD424FAFFFFF8EEFFF5FFFF00FFFFFFFF00EE00FFFEFDFF00FF03F5FEFF
FFFCEEFFFFFA19E6FFF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF844B7F9FFFFF3
FFFFFFFFFFFFFFFFFA0000000000FFFF0CE9FFFDF7FFFFF7F9FFF0F9FFFD67836C00000B
A2FFFFFBFFFFFFF8F7FBFFFF49C4FEF2F9FBF5FFFFFFF7E1CAB9ACA38E877B5634382B00
1A3A4F8685B0BEE1FFFFFCF9FFFFFFFFFEFEFEFFFFFFFFFDFFD520FFFCE3FFFFFFF2FFFF
FFB01B58E4FCFFFAF5FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3
FFF4FEFFF9FFFFFCF3FFF2FFF9FFFFF9FFFBFFFDFFFFFFEAF6E8FFF2FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFF3FCFF8869FBFF9807000267EDFF916FF1FF
B400010062FFFF8E6FFCFF9B05000569F4FFA74EFFFF931000005FF2FF9774F9FF9C0A00
0A5FF7FD977BE2FFA20D000A6FF7F9AC5EF1FF9704002247FFFF855FFFFD8E0C00090001
009A6BF8FF9807000267EDFF916FF1FFB400010062FFFF8E6FFCFF9B05000569F4FFA74E
FFFF931000005FF2FF8C73FCFF940DE8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFAFFEE60A8FBFFF8FFFFFFFFFAFF00FFF6FFF60FFF09F4FFFBEE16F100FFFFF4
FBFFFFF8FFF7C047FFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7EF18FEFFFBFBFF
FFFFFFFFFFFFFFFFFFFFF7FFFAFFFFF4F0FFFCFFF7FFF1FFFFF1FFF7FBFFC038F5EC5B00
A3F7F9FFF9FBFEFFFFFFFDFB3AC3FFF9FFFFF1FFF6FFFFFFFDFFFFFFF4FFF8C07B482000
030004071D1E323B000E354B7782A8C5FFFAFEFFFBF9FEFFF8EE1CFFFFFFFFF5FAFFFEF9
F8FFEF7B1691FDFFFBFEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF
FFFFFFFAFDFFF8F6FFF8FFFFFFEEFFFFFAFFF2FFF8FFF2FFFFFFF9FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFFFFFFFFBFEF9FFFEF3FFF4FFFBFFFE
FFF5FFFFFCFFF6FFF8FFF8FFF6FFFFF7FFFEF7FFFEFFFDFCFFFFFEFFFDFFF2FFF5FFF6FF
FDF7FFFFFFF8FFFFFFF5FFFDF7FFFBFCFDFFFAFFF9FFF8FFF8FFFFF7FFF1BD000500020A
007BFFFCFBFEF9FFFEF3FFF4FFFBFFFEFFF5FFFFFCFFF6FFF8FFF8FFF6FFFFF7FFFEF7FF
FEFFFDFCFFFFFEFFFBFFEEFDFFFC22DCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFDFFFEFBE91AFFFFFFFFFFFFFFFFFFFE00FFFEFFFF00F70D00000D01FEFF0DF1FFFA
FFF0FFF6FFFEFA2ADEFFFFFBF7FFFFF1FDFBFFF5FFFFFFFFFFFFFFFFFF8F78F8FFFAF4FF
FFFFFFFFFFFFFFFFFFF3FFFFFCFFFFF6FDFFF3FFFFFDF6FFFFFEFFFFFBFFF131DBFFF7D9
D1F6FAFFFFFFFFFFFFFFFFFFFBFFFFF8FFFFFEFEFFF9F9FFEFFFF2FFDF610F3A8AB6DCFF
FAFEFAE7C997521A5BB6DEBAA27E6342150E41666FADC0F2FFE011FFFEFFFFFEFFFFFFFF
FBFBFFFFC7323AD0FFF6FFFFFCF9FFFFFCFFFFF5FFFFFEFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF7FCFFFFFFFFF7FBFFFFFFFFFAFFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFF9FFFFFBFFFFFFFFFFFFFFFFFFFDFFFF
FDFFF9FDFAFDFFFFFDFBFBFCFFFDFCFFFFFCFBFDFFF5F6FFFFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFDFCFFFFFFFFFBFFFBFFEE8A3A3D281941
4152F7FEFFFBFFFAF9FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8FFF8FFFF19DDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFBFF9C63FFFFFFFFFFFFFFFFFFFFF1FFFFE9FFFFFFFCEBFFF2FFFFFFF1FFFBFF
FFEFFFFFF4FFFD7878FFFFFFFFEAEDFFEEFFFFFEFEFEFEFEFEFEFEFEF852A6FAFFFFFFF2
FFFFFFFFFFFFFFFFF9FFFFFFF6F8FFFFFFFDFFEDFFFAFFF4FEFFFCFFFEFFFF6498F5FFFA
FBFFFDFBFFFFFFFFFFFFFFFFFCFFFFFFFFFFFDFFFCFFFFFCFFEEFF5E2699F7FFF5FFFFF3
FFFFFFFFFFFFFFF2A4373CCFFFFFF6FFF8FFB1B4886044190B2F3F8AA8DAF4FFFCF8F6F9
FFFFFBF5FFFF8E187AFEFDF8FFFFF5F8FFFEF9FFFCFEFFFFFFFEFCFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFCFAF7F4FDFFFFFEFBFDFEFBFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF4F3FF3BFCFFFFFFFFFFFFFFFFFFFEF8F9F7
FFF6FFFFFFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF7FEFFFAFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFAF5FFF0F9FFFFFFF4FEFFA159FF
FFF3FFF8FFF4FEFFFFFCFBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCFBFAF9FD8DF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFFFFFEFAFF41C0FFFFFFFFFFFFFFFFFCFFF5FFFBFFFFF6FBFEFFF5FFFFFCFFFFF3FFFF
FFFFFEF8FCFFEFD339FFFFF6F1FFF06CFFF8FFF1FFFFFFFFFFFFFFFFFF21E7FFF9FBFFFF
FFFFFFFFFFFFFFFFFFFFEDFFF9FFEAFFFFEBFBFFE9FFF3FFFEFFFDFCFDFEFF8972FFFFFF
FFFFFFFAFFFFFFFFFFFFFFFFFFFFFDF4FDFFF9F2EBFFF3FFFDA01A9BFFFCFAFEFFFFFFFE
F6FBFAF2F2FDFFFFFFFFC03452FFFFF6FFEAFFFFF0FFF7FFFFB5B982682A083B5C83BAE8
FFFFFFFFF8F1FFE54F2CC0FFFFFFFFFFFFF8FBFFF9FBFCFBFAFCFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF7FFFFFFFDFFFBFFFCFBFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFDFF00F8FFFFFFFFFFFFFFFFFFFFF8FFFF
FAFFFDEDF8FEFFFFF4DCC3B2FFFFFCFAFEFFFDF4F7F8FDFFFFFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF8FBFFFFFFFFF3FFFFFBF4FFFFFAF7A95BFF
F7FFFFFFFDFFFCFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF8FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFFFFFBFEF215F9FFFFFFFFFFFFFFFFFAF2FFEAF8FFF7FFFFF7FFFBFBFDFFFFF9F5FFFB
EBFFFFFBFFFFFFF41FDBFFFCE66A0D00FFEDF6FFFDFDFDFDFDFDFDFDF500F7FFFFF6FFFF
FFFFFFFFFFFFFFFFFFF9FFF6FFFCFDFFF7ECFFFFF8FFF8FFFAFFFFFCFFF7F8A060FFFFF6
FDF5FFFFFFFFFFFFFFFFFFFF4EB0FBFFFDFFFFFFFFF7FFFA7B58FBF9FCFEFFFFFCFAFFFF
FEFFFFFFFFFFFDF8FBF5F7FAA321ECFFEEFFFFF0FFFFFCFAEFFFFFFDFAFFF7D1AE8C531E
09235B88C1F4FFFAFFA1255CE5F7FEFFFCFFFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFDFFFAF0FFFFFFFFFFFFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEFFFFEFB00F1FFFFFFFFFFFFFFFFFFFFECFFFF
E2FFF5FFD58D32000626404900001557A9E7FFFFFDFFFFF6FFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFFFFFDFEFFFFF5F1F9FEFCFEFFE67E4BE1
FFFFFAF7FEFFFFF7FFFFEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFFAFFF9FFFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFBFFFAFFD824FFFFFFFFFFFFFFFFFFFFFFEEF6FFF6FBFFF2FFFFFFFFFFF9F6FFFFFBFD
FFFCFCFFF6FFFFFB42BECB800D000104FFFDFCF3FFFFFFFFFFFFFFFFF414F9FEFFFCFEFA
FFFFFFFFFFFFFFFFFFF2FFFFE9FFFFF2FFFFFFFCFFFFF9FFF8FFFFFDFFFFFFBF3DFFFCFA
FFF8FFFFFFFFFFFFFFFFFFFFF0FFFFFBFDFFF8EEF6FFF03E8AF9FFFFFFFFFFF9FAFFFFEF
FCFEFEFCFDFFFFFFFAFFFFFFF2D024DAFFFFF2F4FFFFFFF4FFEC91F8FBFFFFFFF7FBFFFF
FFDFAD873C18195A7EC0E1641EBAF7F7F8FFF0FFF6F6F8FEFFFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFE7B9BEC9BFC7C3F4FFFFFEFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFDFF0DFFFFFFFFFFFFFFFFFFFFFFFFFFF4
F6FF91133074C9FDFFF8F5FAFFF5E2B4500B4ABFFFEFF1FFFFFEFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FEFFFFFFF6F4F8FFFFFFF1AF510F0024221F22
00004D99D8F4FFEBF8FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFF9FFF7F6A5E2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF8FDFDFFBB48FBFFFFFFFFFFFFFFFFFAF0FFFFE8FFFFF8FDFFF6FFFBF5FFFFF0FFF2FF
FFFAFBFFFFF8F8FF4C54250000000200BFBEC9C6C1C1C1C1C1C1C1C1B727FFFDFAFAFFFF
FFFFFFFFFFFFFFFFED09F6FFFFF9130000F8F2FAFFFFFFF8FFFFFFF8FFFFFFC53BFDFEFE
FFFCFFFCFFFFFFFFFFFFFFFFFEFFFDFFFFFFFFFFF2FF45AFFFFFF2F0F9F8FFFFFFF9FFFF
FFFFFEFBFDFFFFFFFFF9F6FFFFFEF32CD8FFFFFFF2FFF4FFFFE3A2F3FFFFFEF9FFFFF8F8
FEFFFEF9FFE8F0C273421B24470040F1FCFFFFFFFFFFFFFBFCFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFE932F323E3D3D07D8FAFFF9FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDA9FFFDFFFFFFFFFFFFFFFFFAFEEEFD
B7067CD6F6F9FEFFFFFFFFFFF3FFFFF9FFFFAE3C49C8FFFFF7FAFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFBB471444A9FAFFEBFFFFFE
FEFFBC682B12A4FFFBFBFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFBFDFEFF98F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFEFFFFA55CFCFFFFFFFFFFFFFFFFFFFFFCFFFAF8FFFFFFFFFCF1FFFFF5F7FDFFFFFA
F6F9FFFFFFFFFEFD370B01000C02000D34433F313E3E3E3E3E3E3E3E7A00EDFFFFFDFFFC
FFFFFFFFFFFFFFFFFF00FFE9FB09E5FFFF00FFFFF2FFF8FFFFFCFFF9FCFDF6AD59FFFFFA
FFFCFFFCFFFFFFFFFFFFFFFFFFFFFBF5FFFFFAF9FB6494FFEAFFFFFFFFFFFFF4F8FFFFF4
FBFBFCFFFFFFFFFFFFF6FFFFFCFAF9D437F6FFF1FFFFEEFFF9FEFBFFF9F7FBFFF6FDFFFF
FFFDFFFFF5FFFDF7F9FFFFC8AB861A00167CB1ECF3FAFFFFFFFCFCFDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF38683F1FFFFEC54C2F7FFF7FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF6FFFFF0FFFAF1FFFFFFFFFFFFFFFFFFFFEF4A
67E1F6FFFFFFFFF9F4F5FBFFFFF4F0FEFFFBFBFFAA4483FFFFFEFFEDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF8FFFFEAC62865AFFFFFF9FEFFFFFFF9F9
FFFFF3FFFFF25D1A8CFDFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFDFFFFFA9B5FFFFFFFFFFFFFFFFFFFF6FFF8FFFBFF00FDF2FFFB08FFF2FFFFFFF3FFFF
FBFFFFF4F7FFFFF58587782300040000FFFDF6FFFFFFFFFFFFFFFFFFFF23E2F6FFF9FEFF
FFFFFFFFFFFFFFFFFF00FFFFFA0BFFFCFA0DF3FCFFFBFBFFFFF5FFFFFFFFF49D66FFFFFC
FFFFFFFEFFFFFFFFFFFFFFFF44B2FFFFFBFFFFFE9D61FFFFFDFFFDFAFDFEFFFFFFFFFEFF
FFFFFFFFFFFDFDFFFFFFF9FEFFFFEBFFBC3CFFFFFAFFFCFFFFFFF7FFFDFFFFFBFFFFFAFA
FEFFFFFDFEFFFFFDFFFFF8FFFBFFFFD831242E193769B0E7FFFFFEFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7485FFF5FFFD40BBFBFFF8FFFFFAFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFBFFF0FFFFFFFFFFFFFFFFFFFFF9CF36B0
FFF8FFF9FEFEFFFFFFFFFFFCF8FFFFFDFBFFFFF5FBFE7450EDFFDEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFE68C34C9F6FEFFFCFDFFF3F9FEFFEE
FFFFFDFFFFFCF1EB6246ECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFFFFFFF7F5FFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFFFEFFA849FFFFFFFFFFFFFEF7FFFAFFFEF5FFF707FFFFF0FF08FFF4FFF6FFFFFFFF
FFFFFFFFFDFFFDFF6995FFF292130001FFF5FFF3FFFFFFFFFFFFFFFFFE36CBFFFFEBFFF9
FFF2FFFFF4FEFFFAF010FDFAFF01F7FFFF00F7FFF2FFFFF9FFF5FFFBFFF7FF8182F8FFFA
FFFCFFFDFFFFFFFFFFFFFFFF43BEFFFEFFFEF3F028ECFFFFFDF5FFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC59ABFFFBFFF8FFFFE299F2FBFFFCFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF5FFF0F4FF8B2374CE8D4915256AABEAFCFEFAFCFFFEFBFF
FFFCFDFFFFFDFDFFFCFFFFFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF9F8FF43F9FFFFFAF8FFFDF2FFFFB332E9FE
F0FFF7FFFFFAFCFFFCFBFFFFFFF9FFFEF9FFFFFDF8FFFF993CF0F2FFFFF0FFFFF9FFF8FF
FFFFFFFFFFFFFFFFF6FFFFFFFFFFFFFFFAFFF9FBEF3E8FFFFFFFF1FFFFFFF2FFFDFFFBFE
FFECFFFAFBFCFFE7FFC32FCCFFFEF7FFFEFEFAFFFFFBF9FF0000FE00FFFFF2FF0000FE02
FFF6FF0000FFFF0000FFFCFBFFFF92E1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEEFFFFF1CF3FFDFFFCFCF9FEFFFFFFFFF5F3FFF6FF04F3FEFFFF00FDF8FEFFFFFFFFFF
FFFFFFFFFCFFFFF642C4F3FFFCFD9325EEF6F5FFFFFFFFFFFFFFFFFFFF8280FEF4FFF1FF
F3FFF7FFFFFFFCFFFF00FFFFFF00110000FFFFFFFFF6FFFFFFF7FFF5FFFCFF39BDFFFEFB
FFF5FFFFFFFFFFFFFFFFFFFF37CBEEFFFFFFFF6490FFFAFFFFFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD131F4FDFFFFF7FFD83BFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFAFFFFFFFFD25E0FC6FFFCE19150143875CFFFFFFFFFFB
FFFFFFFFFFFFFFFFFFFFFCFDFFFFFCF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFF9FBFFAEFFFFEFFFFAFFFEFFF6BE3BFFFFFF
FFFFF1FF00FFFFF4FF08FB00FFFFF6FFFF00FFFBFFFFEFFFB44BFFF4FFFFFBEFFFFEFEFA
FFFFFFFFFFFFFFFFFFFFFEFAFAFDFDFBFEF7FFF324CAFEF4FDF2FFFFDFFCFFF4FFF6FFFF
E9FFF4FCFFF0FFFFEAFED443A5FFFBF7FAFFFFF8F9FFFFFF00FDFF04FFF3FF0CF6FF0000
FDFF00FFFF00FF00FFF6FDFFF9FF1BF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF3FFFFECEC1DF9FFFFFFFFFEFFFFFCFFF2FFFFF9FF00FFFFF9F1FF00FFF9F8FFFFFFFF
FFFFFFFFFFFEFFF227E0F7FFFCFFFFEDFFFFFFECFFFFFFFFFFFFFFFFFFC246ECFFFFF8FC
FFFEFFFFDAFFFD02FF00FFF8F406FAFFFFF5FFFAECFFF9FEF2FFF3FFF5FFEE14F5FFFAFF
FFF2FFFFFFFFFFFFFFFFFFFF46C6F7FFF6F3D541EDFFF8FEFFFFFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5D8DFFFBFFFFFFDD06FFFEF1FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFF5F9FFF9BB0B5EEFFBFFFFFFB7812F124FA9E6FF
FAF7FBFFFFFFFCFDF5FAFFFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFEFFFFFBE7DE53D3FFE3FF
FBFEFFFF00FFF0FFFE00FF01FEFFF9FCF101FFFFFFF8FFFDFF9E53FFF7FFFFF9FFF8FCFB
FFFFFFFFFFFFFFFFFFFEFBFDFFFFFFFFFEFFF12CD5FFFAFFFFFFECFF1AFEF9FFF9FF00F0
FFF2FF0BF9FFF0FFFFF5FFE346D2FFFFFFF5F1FFFFFFEBF909F8FF00FEFFF900FEFFFF00
F8FF00FFFBF4FF06F8FFF1F9FDFF10DBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFFCFEFFFB1DE4FDFCFFFFFFF5FFFFECFFE8FDFDFF00F9F1FFFFF302F7FEFFFFFFFFFF
FFFFFFFFFFF5FAEE25F1FFF9FFFFF7FFFEFCF7FFFFFFFFFFFFFFFFFFFCF72AEAF9FDFFFC
FDFFF3FFFFF3FEFF0011FFFEFD0CFFF1FF00FFF8FFFFFFFFFBFEFFF5FFFFA656FFFFFAFF
FFF7FFFDFFFFFFFFFFFFFFFFFFEDF7FDFDFF7782FFFFFFFFFFFDF7FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FCE527FFF7F8FFFFE32EFFFCF5FFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFFBF5FFFCF5FFFFFF6C1791FFFFF3FFFFFFEBA4502625
82DDFFFFE8FCFFFDFFFFFDFCFEFEF9F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFE2FFFDFFFBFAFBF5FC4AB5FFFCFFF9
F9FFF9FF00FDFCFFF700FF00FFFAFFFFF804FFFFFFF7FFF3F3FF668EFFF2FFFFF7FEF8FF
FFFFFFFFFFFFFFFFFFFCFEFFFFFFFEFFFBFA51C9F9FCFFFFFBFFF8FF00FFFAFFFFFF01FF
FFFFF300FCFFFBF7FFFFFFFFD541D8F4F2FFFFFFF3F7FFFF00FFF40AF5FFF5FF0A00000B
FEF810FCF6FFFF00FFF8FBFDFFFF19E7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8FFFCFBFFFF6A91FFFCF2FFFFF3FFFFFFECFFFF00F707FFFFFFF6FFFC00FFF2FFFFFFFF
FFFFFFFFFFFAFFA053FFFFF7F3FFFCEFFFFFECFDFFFFFFFFFFFFFFFFFDFE7D85FDFBFFFE
FDFAFEFEFFFFFFF6FD00EEFFFFEC080600F6FFFFF0FFF7FFFFE7FFFDF6FF3BCAFBFCFFFF
FDFEFFFAFFFFFFFFFFFFFFFFFFF9FFFFFFF725DFFDF6FFFFFDFEFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFB38C8FFFFF9FFE895F2FFFFFFF5FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFFFFFEEDFFF4FFD63D38CDFFFFF0F9FEFBFFFAB5
691F167DE8FFFCFBF8FFFFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFB5BFAFCF9FDF9F9FF9D64FFECFFFFEF
FFF6FFF900FDFCFFF700FF00FFFAFFFFF804FFFFFAFFF0FFFFFFF922E2FFF4FFF4FFFCFF
FFFFFFFFFFFFFFFFFFFFFFFFFEF9FAFFFE7F80FEFBFEFEFFFCFFFFFC0EFFFFFEFFFF00FF
F5FFFF02FFF8FFFEF8FFFCECFFCD36F4FFFFFEFFFFFFF9FA09F1FF00FFF8FFEEFFF4FF00
FFEF06F3FFFFF30CFAF0FFFFEEF799E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFBFFFEF8FFC52DFFFFF3FBFFFAFFFBFBF3FFFFFF0800FAFFE8FFF1FF04F8FFFFFFFFFF
FFFFFFFFFFF3FF25C0FFFFFFFFF1FFFCF6FEFFFEFFFFFFFFFFFFFFFFFFF3F620EDFCFFFF
FFFFFFF3FFFFEFFFFFFFFDFAFFF9F8FFFFFFFFF9FFFFF4F4FFFDFFFFFCA453FCFCFFFFFE
F7FFFFFEFFFFFFFFFFFFFFFFE9FFFFEFFBCD38FEFFFEFFF7FFFFFFFDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF88473FFF9FFFFFFFEFDFBFFFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFF8EEFDFFFBFFF8E8FE8C137EF4FFFFF9FFF8ECFF
FFFFD46D172183E1FFFEF8F7FBFEFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFF00FFFFFFFFFFFFEF1CFEEDFFF8E8FF
FFF6FFFB00FFF0FFFE00FF01FEFFF9FCF101FFFFFCFFFFFAFFF5FF9660FFF2FFFFF9FDFF
FFFFFFFFFFFFFFFFFFFFFFFDFBFFFFFFCA33F9EBFFFFF8FDFFFFECFA00FFF0FFF9FF01FF
F7F8FF08FBFFF7FFFFEAFAFFF5FE6EACF7FFF0FFF8FFE8FF00FFF30A00FFF608FFFFFD00
E7FF00FFF401FB00FFFDFEF2FDFFE6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FEFFF7FBF63BC3FFFFFBFFFEFFF7FFFFF1FFECF70CFDF8FF0009000008ECFFFFFFFF
FFFFFFFFFFF2D231FFFBFFFFFEF9FFFFFFF4F3F9FFFFFFFFFFFFFFFFFEFFFF7E7DFFEEFF
F6FFFAF8FFFCF6FFFDDBFFF8FFFFFFFCF6FFF5FCFFE6FFFFFBFFFFEAFD3DD6F6FFFFFFFB
FBFFFFFFFFFFFFFFFFFFFFFF43C5EEFFFF856DFFFFFFFFF4FFFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFC134FFF6FFFFFFF7FFFBF6FBFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FFFCF6FFFFFFF7F5FFFFFFFBFFE94629B9FFF3F7FFFFFF
FDF5F7FFFFD06B183981D9FFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFF00FFFFF3FFFFF37892F2FFF1FFFFFF
FAFFF2FD00FFFFF4FF08FB00FFFFF6FFFF00FFFBFFF4FFFFF5F2FFFE31C0FFFFFFF6FFFF
FFFFFFFFFFFFFFFFFBFFFFFAFFFFFFF54CBEFCFFFFE6FFFFFBFFFAFF0BFFFCFBFFFF00FF
FFFFFF00FDFFFAFFFBF9FFE2FFFFD11FF7ECFFFFFFEDFF0A0009FF00FF00FFFF000001FB
FFF9FF0006FF000905F7FFFFFFFAFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFF6FFFFF2FF9F60F1FFFBFFFAFFFFFAF9FDF8FFF9FFFFFEFFFFF1FFF9FEFFFFFFFFFF
FFFFFFFFFCFF4BB3FAFFFBFFFFFFFEF3FFFEFFFFFFFFFFFFFFFFFFFFFAFFFEFD36CEFEFC
FFFFF6FFFAF3FFF3FFF8FFFFF9FBFFFCFFFBFFFFF2FFFDF5FBFFF7FF956BFFFFFFFBFCFC
FFFFF6FFFFFFFFFFFFFFFFFFFDFFF7FFFB5EA0FFF9FFFDF7FFF5FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFAE919FDFFF2FFE398F8FFFFFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFEFFFCFAFFFFFFF2FCFFFDFDF6FFB31859FDFFF2FFF3
FFFFFFFCFBFFFFFFB866213CA3FAFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFDFCFF09FFF4FFF1FFFE10F5F6FFFFFDF5FF
FEF9FFFCFFFAFCFFFCFBFFFFFFF9FFFEF9FFFFFDF9FFFFF1FFFFFFFE8B74FFFBF3FFFFFA
FFFFFFFFFFFFFFFFFBFFFFFAFEFFEAC747FFF7FDF9FFFFF8FDFFFBFF00F5FFF9FAFF00FF
F6FFF60FFDFFFFF6FAFFFFFFFFF0FF8D6FFFFBFEFFFFF9F20AFFF7FFF6FFFFF6FFFFFEFE
F0FFFFF9FFF7FF00F8FFFDFFFFF792EEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF52B2FDFFF9FFF7FFFFFEFCFCFBFBFEFFFFFFFFFFFFFFFFFFF7FFFFF8
FFFBFFFAF9D43DF3FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF6DC41E0FA
FFF8FCFFFFFDFEFEFFFEFCFBFCFEFFFFFFFDFBFEFFFFFEFEFFDFFFA548FFFFFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFBFF48BAF8FFFFFFFFFFFFFFFFFDFFFEFAFFF9FFFC
070005FFFFF2FFFBFFFFFFFFFFFFFFFFF9FFF4FF06ECFFFFFFF28CFFFCFCFFFDFFFFFBFA
FBFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEE621BA1FFF7FE
FDFFF9FFFDFBFFF8F4FFF59932227ADCFFF8FCFFFBFBFFFDFDFCFFFFF2FFFFFBFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF8FFFCC2FAFFFEFFFFBB45FEFFFCFFFFFFFF
FFFFFFFFFFFFFFFDFDFFF8FFFFFFF9FFFAFFFFFFFFFFFFFFFFFFFFFFDE2FF6F8FFFFF0FF
FFFFF2FAFAF9BDAAFFFEFDFDFFF9FE6CA9F0FFFAFFFFFAFCF4FFFFFBFFFFF3FFFFFFFFF7
FFEFFFFFFFFFFFFFFFFFFFFFFBFFFFDE22F8FFFFFFEEFFFF00FDFFFDFFFFFFFFFFFFFFFF
F6FFF0FFFAFFF10DFFFCFFFCFEFB9EE4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFD32DF7FFFAFEFDF8FFFFFFFFFFFFFAF5FFFFFFFFFFFFFFFFFFFBF6FF
FFFFEEFFF22CD0FFFCFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFE21CF9
FFFFFFFFF9FAFFFBF4FDFFFFFFFDFFFFFAFEFFFFFFFEFFFFFFFFBB40FDF7FEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFF3CB7FFFFFFFFFFFFFFFFFFFFFBFAFFF3FFFD00
F7FFFF00F4FFFFF0FFFFFFFFFFFFFFFFFAFFF7F026F2FEFAFFF8FCFFFFF5FAFCFFFDFFFF
FFFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFB83C51DCFF
FBF2FFFBFCFFEEFFFFFEFBFFFFCE661245B8FFF9F9FFFFF7FEFFF8F9FFFEECFFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FBFFFFF8FEFFFFFFFCF9778AFFFFFAFFFFFFFF
FFFFFFFFFFFEFFFFF1FFFFFFF3FFFDFFF3FFF6F9FFFFFFFFFFFFFFFFFF27D1FFF6F9FFFE
FCFFFFFFFFFA85012C83F3FFF9FFF10BE3FFFFFCFFFFF6FFFFFFF9F6FAFFFFFDFFF4F9FF
FFFFF3FEFFFFFFFFFFFFFFFFFDFFFFF048C5FEFFFFF8FFFDFAFFF2FFFFFFFFFFFFFFFFFF
FFFFEFFFFFFBFFF1FFF9FFFFFEFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFB73EFFFFFFFFFFF9FAFBFBFDFFFFFFFFFFFFFFFFFFFFFFEBFCFFFF
FEF8FFFF5AACFFF4FFFBFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1ECFFC43F
C8FFFFF0FFFFFFFFFFFFF6F3FAFFFDF9FFFFFBFBFDFDFAF7F69D3AF1FFFFFEFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3BC9FFF5EE44C7FCFFFFFFFFFFFFFFFFF7FFF6FFF9F1FFF3
FFFFE9FF08FFECFFFFFFFFFFFFFFFFFFFFF5FFFF0098DBFFF6F3FFFBF6FFF6FFFFFFFFFA
F5F5FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF871148A
FFFFF6FAFFFFFFF7F8FAFCFFFFFEFAF792331A92FFF9E5FFFAF8FDFFFDFFFFFDFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFEFFFF2FFFFFEFD2BD7FEFFFDFFFFFFFF
FFFFFFFFFEF7FFFFFFF5FFF6FFF7F3F3FFF7FBFFFFFFFFFFFFFFFFFFFF5E9EFAFFFFFFF4
FDF9FFFFF2FFA50300011060DAFFB850FFFFFAF9FFFCF5FFFFFBFAFFFFF2FFF0FFFFFFF2
FAFEFFFFFFFFFFFFFFFFFFFFFFFEFDFF827CFBFFFFFFFAEAFFF8FFFFFFFFFFFFFFFFFFFF
F8FEFFFFFFFFF3FFFFFAFFFFF8FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFF8879F9E6FFF7FEFFFFFFFDFBFFFFFFFFFFFFFFFFFFFFFFF5FFF9
EFFFFF6D81FBFFFFF9FBFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFF6FFFFF9F8C8
3EA2F8FFF7F9FFFFF2FCFFFFFFFEFFFFFFFEFDFCFEFFFFFF8758F1FFF1FCF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF40C0F4FFFF56ACF6FFFFFFFFFFFFFFFFFBFFFDF6FFFFFBFF
FFE7FFFE00FFFFFFFFFFFFFFFFFFFFFFF9FFFFFB065C20248CC3A0FFFFF5FFF9FAFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF5FFFFFFCB3F
30CEFFFFFFECF7FFFFFFFEFEFEFFFFFEFFF5C5481099FFEFFFF9FFFFFDFFFFF2FFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEAFFFCF6FF43FFFCFAFFFF0BF9F5FAFFFFFFFFFF
FFFFFFFFFFFFE9FFEFFBFCFFEFFFFFFEFCFFFCFCFFFFFFFFFFFFFFFFEC8A79FCF2FFFFFF
FFFBF9EFC9B7750009040400014A6080FFFBF3FAFFFFF8FFFFFCFCFFFDFBFFFFF7F6FBF8
FFFFFFF4FFFFFFFFFFFFFFFFFFFFFBFFB93DFFFCF4FFFFFFEBFAFFF3FFFFFFFFFFFFFFFF
FBFFFFEBFBFFF5F9FFFBFFFEFCF69AE3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFF6C4BFFFFFBF7FDFFFEFEFFFFFAFFFFFFFFFFFFFFFFEFFFFAFE
FFFB5D81FFF3FFFDFFFCFCFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFE2FFFFFF
EF5B56D2FFFFFFFFFFFFFDFBFAF9F9F9FAFFFFFCFFF7A13B77FFFFF7FFF7FFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF44BCF2FFFF6E89FEFFFFFFFFFFFFFFFFFDFCFFFFFFFBEDF7
000515FF03F7F9FCFFFFFFFFFFFFFFFFFFF1F8EB1CFFFFBD751E0363C1FFF0FFFFFFFCFA
FFFFFCF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEFFF7EDFFFFFB
9C1671F4FCFFFFF3F0FAFFFFF9F5FCFFFFFFFFFFCE37189AE9FFFBF3FFFAF6FFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFBBF7FFFBFFFB0EF8FCFBFFFFFFFFFF
FFFFFFFFFFFCFFFFFFFEFFFBFFFAFDF5F9FFF7FFFFFFFFFFFFFFFFFFFEA76AF253382900
020702102F4A440000000000197D5EA2FEFFFFFFFFFFFBFAFBFFFFEBFBFFF5F9FFFFF0FF
F9F6F3FFFFFFFFFFFFFFFFFFFFFFFAFFDE18FFF8FFFDFFFFFFFFFAFDFFFFFFFFFFFFFFFF
FFFCFCFFFDFBFFFFFEFBFFFAFFFF23DFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCF8FFF9C619CEFEFFFFFAF3F9FFFFFDFFFFFFFFFFFFFFFFFFF8F8FF
DC28A1FEFFFFFBEEFFF8FFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEF4FFEAFDEF
FEFFA7304AC2FFF8FFFEFEFFFFFFFFFFFFF2FCF8A1435EC0FFF4FBFBFFFFFAFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF43C1FFFEF09468FFFFFFFFFFFFFFFFFFFDFFFFFFEAFFFF03
FCFFE80005FFFFFFFFFFFFFFFFFFFFFFF5FFFFAB47FFFEFFFBE1257E300F6AA6F1FFFFFF
F8FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF8FFFDEDFFFE
FFE15922A8FFFCFFFFFFFAFFFFFFFFFAF9F8FFFFFFFFC152199AFFFFFFFFFFF1FFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF6FFFDFEFFFFFAFFF8EC13F4FFFFFFFFFFFFFF
FFFFFFFFFFFAFFFEE3FFFFF7FFF3FFFFF9FFFEFFFFFFFFFFFFFFFFFFFFA740F6A2C2DCFD
F2FFFAF6FFFAA60807050569E6FF47A7FCFFFFFCFAFFFFFCF8FEFFFFFFFFF3FFFDFFF6F7
FFFFFFFDFFFFFFFFFFFFFFFFFFFFFCFCF109FFFAFFFBFBEFFFFFF1FFFFFFFFFFFFFFFFFF
FFFBFAFFFFF2FFF0FFFFFFF7FFFF00E7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEF9FFEBD73E6FDEF3FFFFFFFFFFFDFFFFFFFFFFFFFFFFFBFFE66B
2BDBEEFFFCE5FFFFEFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECFCFFFFFFFFFAFF
F5FFFFF9C53A0B6CB1D3F9FFFFF3F4FBD498442059C0FEFFFFFFFFFFF4FCF9FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFFCB34F5FFFFFFFFFFFFFFFFFFFFE7F8FFF9F901
FFF5FFFF00FAFFFAFFFFFFFFFFFFFFFFFFF3F86E9AFCFFFFFDDE22FFFEEA98440349A1DF
FEFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFFF1FF
ECFFF9B43E45D9FFFFFFFCF9F8F9FDFFFFF9FCFEF8FFFFFFD83A27B5FFF9F7FFFFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FEFFF6FFF9FDFFF6F20FFAFFFFFEFFFFFFFF
FFFFFFFFFFFFD6FE1DFFEFFFFD01000FF0F7FFE2FFFFFFFFFFFFFFFFFEA954FFFFFFE9FF
FBFFFCF5FFFFC608004FCAFFF0FC47C1FAFBFEFCF7FEFFFFFFFFEFFFFFFBFFF1FFF8FFFE
FAFFEEFFFFFFFFFFFFFFFFFFFFFFFFFCFA05FFFFF4FFFFFFF2FFFFFDFFFFFFFFFFFFFFFF
FFFFF9F6FAFFFFFDFFFFF9FEFCFD36E8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFF9FEFFF5F2932677D2FEFFFCFEFFFFFFFFFFFFFFFFFFD95D2C8D
FEF8FFF9FFFFFFF3FFFDFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF6FEFCFFF4
FFF5FEFFF2FFEB994F280305202B13002B6BB9EDFFFFFFFAFFFAFFFDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFCFFF6FFFF29D2FFFFFFFFFFFFFFFFFFF2FFFFF7FAFF00
FFFFF9FA01FFF8FFFFFFFFFFFFFFFFFFFDFFFF20E2FFF9FFFFF284FFFFFCFFFFF7B25117
2F84D8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFCFBFDFFFD
FFFFF8F8F9741E9BFDFFFFFFFFFFFEFCFDFFFFFDFFFFFAFCF9FFA1305DE4FFF4FFFFFFFF
FFFFFFFFFF7E7FFFFDFFFF3EBFFFFDFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFBFAFF3CFFFFFFFAFF09FFEEFDFFFFFFFFFF
FFFFFFFFFBFFFFFF00F4FFF90DF2FFFA03FFF7FFFFFFFFFFFFFFFFFFFB9472FFF2FFFFFC
FFFBFFFFF7F8E22BBBFBFFFFFDFF2DC7FFFDFFFFFFFDFFFCF6FFF0FFFAFFF10DF5FCFFFB
000700FFFFFFFFFFFFFFFFFFFFFBFFFFFE03F3FFFFFFFFF2FFF3FFFBFFFFFFFFFFFFFFFF
F4FFFFFBFFFFF3FFF5FFF4FFF6FC8DEBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB8A2A2E6FACD9F8FFFFF8F2DEAC67332991F1FF
FAFBFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFDEEE1E3F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFF99074F5FFFFFCFFF7FEFFF6FFF0FFFAFFF10D
FFFDFFFF01FFF8FFFFFFEFFFFFF5FFFAFCFFB846F8FDFAC07F5931B0FFF8FEFBFCF8FFFC
C66E302073BAFBFFFCFCFFFFFBFCFCFEFFFFFFFFFFFFFEFBFEFFFFFDFFFCFAFCFEFEFFFF
FFFAFFFFF6FFC73C35D3FFFFFEF6FFFEFDFFFBF5FFFDF4FFFFFDFFF663179EFFFAFFFFFA
FCFAFDFFFA8973F7FFFFF442B7FFEFFBFDFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFA00FFFFFAFFFE1EDAFFEAFFFFFFFFFF
FFFFFFFFFEF5FFFF00FFF5FF01FFFBFF00F5FFFEFFFEFFFDF8FFFFFAFA8383F9FFFFFFF6
FFFFFFFFFFFFFFFFFDFFFFF2FFFF5A9CFDF7FFFFF5FFFFFFF9FFF4FFFEFFFD05F5FFFF02
F3FFF900FFFFFFFFFFFFFFFFFCFEFFF4E41EFFFFFAFFFCF0FFFB040002FFF4F8FF04FEFF
FFFFFFFFFFFFFFFFFEFFFFFFF7F5FFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F9F6DDA0541E0A0000030D26599ACAF7FFFFFA
FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAF9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF43C6F4FFFFFFD33DEFF2EFFFFAF0FFFFFFFFEFFFFFFBFFF1
04000700F2FFF5FCF0FFFFF8FFFFFFF6FFFB4660441A00000C0008F7FFFFFFF6FFFFFEFC
FFFFEFDB8A381152B8F1FFFFFFFFFFFFFBF8FAFEFBFAFDFFFFFAF9FCFFFFFFFFFFFDFDFF
FEF3FFFFF8FFFFF0A50F86F0F5FFF3FFF1FBFFFFFFFFFFFBFEF7FFE9FFC42050E1FFFFFB
FFFFFFEDFF807EFFF5FAFF42C7FBFFFFFFF9F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFEC1CF2F7FFFDFF44B6FBFFFFFFFFFFFF
FFFFFFFFFFFCFFF700F8FFFC00FFF0FF00FFE8FCFEFEFFFFFFFFFEFCFF48B4FFFFF6FFFF
FFFFFFFFFFFFFFFFFFFBFFFFFFF37791FFFFF2F9FFF9F8FFF9F7FFFAFCFDF200FDFFF0FF
FFFEF80EFFFFFFFFFFFFFFFFFFF4FAFFBF34FFF6FFF4FFFFFD00F9FFF900FFFBFD00FFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9EFF1FEFFFFFFFFFFFFFBF6FBFFFFFFFAFF
FFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFEFFFFFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEEFFF5FDF5FEFF866BFFFFF3FEFFF6FFF8FEFFFFFFFFF3FF
FFFAFFFFF5F1FFFFFFF3FFFFEFF8F6FFF9BF429F00001B07000810FFFFF7FAFEEAFDFFFF
FFFFFFFFFAFFEC9F3F18478AE1EDFBFFFFFFFFFFFFFFFFFFFFFDFBFFFDFFFFFFFFFCFDFE
FFF9FCFFF5F1FFFFE9F33D25CEFFF9F5FFF7F9FFFCF8FEFFFFFFFAFFEEFFFF5A40C1FBFF
F6FDFCFFF8798AFFFEFFFF38B9FFEBFFFCF9FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDFFFFFBFF00FFFFFCF4FF9561FFFCFCFFFFFFFF
FFFFFFFFFFFADBFF08F0FFECFF000900FFFCFFFFFCFFFEFFFFFDF8FFF523E6FFFFF2FFFF
FFFFFFFFFFFFFFFFFFFBFDFFFFF4AA5CFEFFFFF5FFF7FEFFFFFFF4FAFFF0FF07FFF3FFFF
02060000FFFFFFFFFFFFFFFFFFFFFAFFA75FFAFEFDFFFFF800FFFEFCFFFF00FFFF07FFFF
FFFFFFFFFFFFFFFFFFFFFBFDFEFF98F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFF9FFF8F1F3FDFFFFFFFBF8FCFF
FCF4FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFDFAFCFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFCF4FFF824DEFFFFFCFAFFF3FBFFFFEBFBFFF5F9
F6FFF8E7FFFFFFEFFFFBFFF8FFFFFDF8FF3AC2FFBA0000000E021DACE0FFFFFFFFFFF5F6
FBFCFCFEFEFFFFF8FFF8B463124087CAF4FFFEF7FEF7F2F3F9FEFFFFFBFEFFFDFDFFFFFC
FFFFFFFCFFFFFCF2FFFFFFB51753FBFBFFFFFFF9FFFFF8FFF8FFF9F9FEF8FFFF8E23D2F7
FFF9FFFFFF837AEEF6FEF845BBFFFFFCFCFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FDFFBAFAFFFCFFFFEC1EFFF9FFFFFFFFFF
FFFFFFFFFFFF17FE00FFECFF00FFFFF900FBFFF3FDFFFAFEFFF7FBFFB44EFAFCFFFDFFFF
FFFFFFFFFFFFFFFFFFFFFCFEFFFFDD22FCF9FFFFEDFFFFFFFAFFF4FFF5FFFF00F7FFF500
FFFFFF07FFFFFFFFFFFFFFFFF5FFFBF65FABF3FFFEFAFFEE0AF4FFFEFFFF00FCFF00FFFA
FFFFFFFFFFFFFFFFFBFFF9FFF7F6A5E2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FAFFFFFCFAFFFFFEFFFFFFFFFDF9F7FFFFFFFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBF3FDEFFFFFF7FFBE41FFFEF7F6FFFFFFFCFCFFFDFBFFFF
FFFCFBFFF8FFFDFFF6FFFBFDFFFCF8FF886BFFFFF4C5100C0000905C172C8FC5FDFAFDFF
FFFFFFFFF9FDFFFFFFFFFDFBFFBF65282B6AC1FDFAFFFFFFFCFCFCF7FFFFFEFAFDFFFFFA
F2FFFFF9FFFFFFFFFFEEFAFFF4741BAFFEFFF9FFFFFFF6FFFFE6FFFFFFFFE1FFFFB31FD0
FDFFF1FFFA7685FFFFFFFE46B2EDFFF5FFFBEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE6FDFFF8FBFFFFF7FEFFEFFF3CB6FFFFFFFFFFFF
FFFFFFFFF7F0FC0010F8FFFF03FFF5F908FFFFFFFDFFF9FCFFFBFFFF53ABFBFDFFFFFFFE
FFFFFFFFFFFFFFFFFEFFFCFFFFFFFF36C9FCF2FFFCFFFAFCFFFAFFFFF900FF10FFEDFF09
FBF6FF00FFFFFFFFFFFFFFFFFDFFFDF80EF3FFFFFFFFF1FF02FFF5FF000D02FEFA13FFF8
FFFFFFFFFFFFFFFFFBFFFAFFF9FFFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFCF8FEFFFEFAF6F8FFFFF3FBFFFF
FFFFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFFFFFDFCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF40CBFFFFFFF9F8FFFFAA50FFFFFFEFFFFFFBFAFFFFF2FFF0
FFF7FFF7F8F4F2FFFFFFF9FFFCF9F9AD46FFFEE9FFEEDD000325EEFFFFD07C2F165BAEE3
FBFFFCF2FFFCF6FAFCFAFDFFFDFFFFFCD48E410D5D9CE1FFFFFFFFFFFFFFFFFDFEFFFFF9
FCFFFFFAFAF6F6FFFCFFFFFFFAF9C92C43DBFFF2F5FAF4FFF9FFFAFCF7FEFFF6FEFDB31A
D3FCE17C8B3A88FFF3FDF53E6C8D71FAFFF8F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF8F7FFFBFFF1FFB956F6FBFFFFFFFF
FFFFFFFFFFFFF9FF03FAFBFFFA040804F5FFF1FFFBFFF9FEFFFFFFD035F1FFFFFCFFFBFE
FFFFFFFFFFFFFFFFFFFDFCFFFEF4FF9658FFF9FFFFFFFFFAFFFFEAFFFFFA0B00F8FFF300
FFF7FF04FFFFFFFFFFFFFFFFFFFFFFA150FDFFFBF6FDFFFF00FFFAFAF9F1FFFAFF00EAFF
FFFFFFFFFFFFFFFFFFFFF8FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFFFFFDF7FCFFFFFDFCFFFFFFFBF4FFFFFFFD
F7FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFDFFFFFFFDFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3ACAF8FFFFFBFFFBFAFB9071FFFAF2FFFFFFF9F6FAFFFFFD
F9FFFFFBFFFFFFF5FEFBFEFBFDFFC743FFF8F8FFF1FFF8DB205F93FFFFF6EAFFE8A8521F
3380D5FFFEFFFFF7FDFFFFF3FCFDFFFFFFFFF6EEA051173998E4FBF5F0FEFFFFFDFFFFFC
FFF8F9FFFFFFFFFFFFFFF9F7FFFFF4F58A2273FFFFFFFFE7FFF0FFFFF4E9FCFFF0FFE89F
25EDEE03728BCDFFF2FFFFB97B472FFFF6FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFF3F5FF45FFFFFFFFFFFBF651ACFCFFFFFFFF
FFFFFFFFF8FEFFF3FFFFFFFFF9FFEFFFFFFFF4FFFAFFFBFFFEFFEC7694FFFFFFFDFCFCFD
FFFFFFFFFFFFFFFFFFFEFFFFFCF3FFE83DD6FFFBF8FBFFFCF6FFFDF4FFFFEC01FFFFF9FF
030F00FCFFFFFFFFFFFFFFFFFBFFE945D9F1FCFFFCFFEEFF13FCFFFFFFFF06FFFC00FFF7
FFFFFFFFFFFFFFFFFFFCFBFAF9FD8DF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFAFF
FFFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFDFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3FC2FFFCF6FDFFFCFEFFFA6A5CEFFFF9F4FFFFFBFFFFF3FF
FEFFF3FFF2FFFDFFF7FFFDFEFF7D3EECF8FBFFFFF9FFFEFCDFAE21FFEEFFFFF9FFF9FEFE
CD742D135DA5EFFFFCF6FDFFFFFFFFFEFDFDFEFFFFFFF4BD5A173780DAF3FFFFFBFEFFFF
FEFFFFFFF6FBFFFBFCFDFFFFF9FCFEFFFFCB4E40C4FEEDFFFEFFFFFBFFFFFFFBFFEFFFFC
6D63FF9860F1FFF6FFFDFAFFFD3DCFFFFCFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFFFBBDFDFFFEF9F8C8B1683EF5FFFFFFFF
FFFFFFFFFFFEFBFFFFF2FFFEFFFFFFFFF9F3FFF4FBFFFCFFFCFFCF28FFF9FFF9FFFDFFFA
FFFFFFFFFFFFFFFFFCFFFFF7FBFFFFFF8E65FFFFFFFFFBFFFFE7FFFFEBFFFFFFFFF4FFFF
F5F4FFFFFFFFFFFFFFFFFFFFFDFFAD47FFFBFDFFFFEEFFFFF100FFF7FF00F9FFFC00FFFA
FFFFFFFFFFFFFFFFFFF8FFF8FFFF19DDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFF9FCFFFFFAF8
FFFFFDFBFFFBFBFFFFFBFBFFFFFEFFFFFDFFFFFAFCF9FFFFFCFDFFFFFEFDFCFEFFFFFFFF
F8FFFFFFFFFCF9FFFDFFFEFBFFFDFDFFFFFDFDFFFBFEFFFDFFF9FCFFFFFFFFF8FFFFFFFF
FEFCFDFEFFFFFDFCFFFFF9FCFFFFFAF8FFFFFDFBFFFFFFFFFFFFFFFFFBFDFFFFF8FAFFFF
FCF9FFFFFCFDFFFFFEFDFCFEFFFFFFFFF8FFFFFFFFFCF9FFFDFFFEFBFFFDFDFFFFFDFDFF
FBFEFFFDFFF9FCFFFFFFFFF843B1FFFFF6FCFFFEF9FFFFFEB13BC1FFFFF7FFFFF6FFFFFB
FBFFFFFFFDFAFFF8FFF0FFEA4A73FFFEFFFDF8FFFFFFFFF8FFDA12FFF9FFF9FFFFFFFDFC
FFFFF4E3A247082E8AD3FAFFFAF8FEFFFFFAFAFFFFFFFEFFFFFBBA73233166B6F2FFFFFF
F9FFFFFFFFFFFFFBFFFFFFFAFAFFFFFDFBFFF0A70A7EFFF8FFFFF3F8FFFFFFFFFFF9FEFF
FC16CDFE5AACF7FDFFFFF5FF6D91FAFFF7FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFF1FFFDC07D504500020000559763FFEBFFF7
FFFFFFFDFFF7FBFFFBFFFFFAFFFDF9FBFFFFFFF7FFFFFFFFF8EF34E0FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD33D4FFF5FFFFF5FFFFFFFFFFFDFDFFFFFFFEFE
FFFFFFFEFFFFF4FCFFF9FCFFFFE624F3F7FAFFFFFAFFFAFFFFFC060003FFF4FFF606FFFB
FFFFFFFFFFFFFFFFFFF5FFFAFFFC1FE0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFDFDFCFFFFF1FFFFFF
FDF8FBFFF6FFFFF6F6FFFFF6FAFBFFFFFAFCFFFFFFFFFCFDFDFFFFFBFFFDFFFFFFF6F7FF
FCFFFBF9FEFFFFFFFBFFFFFFFFFFF8FAFAF8FFFFFFFFFFFBFFFFFFFEF9FBFFFCFFF7F6FF
FFFFFDFFFBFFFFFDFDFCFFFFF1FFFFFFFDF8FBFFFFFFFFFFFFFFFFFFFFFBF8FDFFFFFFF1
FFFFFCFDFDFFFFFBFFFDFFFFFFF6F7FFFCFFFBF9FEFFFFFFFBFFFFFFFFFFF8FAFAF8FFFF
FFFFFFFBFFFFFFFEF9FBFFFCFFFFFAFDFFFFFCFFFFEFFFFAEFF92058C8FFE9F9FFF5FFFF
FFF9F9F5FFFFF4FFFBE0821DABFFFEFBFEFFFFFFF4EAFFFFFBDB2FFFF4FFFAFAF7FDFFFF
FDFDFEFEEFFFFFC767262B4EB9EEFFF5EEFFFFF5FFFFFEF4F8FFFFFBF5D18A3F2452A9EA
FFFFFCFFFFFDFCFFF0F7FFFFFFFFFDFFFFFFFFF0F74B1DB9FCFFFFFFFBFFF4FEFFFFF7FF
FF9552FFE82AF8F5FFF1FFC952EEFFF1FEEFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFFFDE0E020004080013F4DD8389FFF9FF
F6FFFAF3FBF5FFFFFFF4F7FFFAFFFFFFF8F5FDFFFEEFFBF5FF3FB3FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECA39F7FCFFEDFFF8FFFFF7F9FFFFFEFEFEFEFF
FFFFFFFFF4FFFFFBF0FFF1FFFC689FF4FFFBFFFFFFFFFAF9F3FFDBFFF2FCFFEDFFFEECFF
FFFFFFFFFFFFFFFFFFF8FFFFFFFE27DDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFDFAF9FFFFF7F8
FFFFFFFFFFFDFDFFFFFDFDFFFFFFFEFCFCFDFDFBF9FAFDFEFDFFFFFFFCFFFFF2F4FFFFFC
FFFEF7F9FFFFFAEFFFFFFFFFFCFBFFFFFFFFFBFCFFFFFFFFEFFAFFFFF9F7FEFFFCFFFFF4
F2FFFFFCFFFFFFFDFEFDFAF9FFFFF7F8FFFFFFFFFFFCFCFFFFFCFCFFFFFFFFFFF8F7FFFF
F9FAFDFEFDFFFFFFFCFFFFF2F4FFFFFCFFFEF7F9FFFFFAEFFFFFFFFFFCFBFFFFFFFFFBFC
FFFFFFFFEFFAFFFFF9F7FEFFEBFFFFFDFCFFFDFEF6FEF4FFFFF2FFAB2866BCF1FFFFF3F1
FBFFFDFFFDFFFC9F6F2880F3F9F8F7FFFFFDEEF8FFFFFFF9FFED88FEFAFBFFFFFFFFF5F7
FFFFFFFFFFFFF9F8FFFBD3A544203493E8FEFBFFF9FFFFFFFFFFFEFAFFFFFFF7E0AB5611
3391E7FDFCFFFFFDFFFFF0F6FFFFFFFFFBFFF4FFFFFFBD2665D5FFFFF7F6FFFAF6FFFFF6
FFFF17DDFFBC39FFFAFFEE26D7FFFDFAFFFFFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFED4AA401000000007DF1FFFF47A8FDF9
FDFFFFFFFFFFFCF5FFFFFFFFFFFFFEEFF9FFFFF3FFFFFCF85CA1FFF4FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFB444FFF5FFF8FFFFFFFFFEF0F5FFFCFEFFFF
FFFFFEFEFCFFFFFEFFFFFFF57D90F3FFFFFFFEFEFCFCFFFFFFFEFFFFFFFFF7FFFFFFFAFF
FFFFFFFFFFFFFFFFFFFBFFFFFFFA90EAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F9FFFFFFFFFFFFFFFDFFFF
FFFBF9F4FFFEFEFFFFFEFEFFF9FDFFFFFFFFFDFCFFFFFFFFFFFFF9F8FFFBFDFFFFFCF8FD
FBFFFFFFFFFFFFFFFFF7F3F7FFFFFFFAFAFFFFFFF7F3F7FFFFFFFFFFFFFFFFFBFDF8FCFF
FFFDFBFFF8F9FFFFFFFFFFFFFFFDFFFFFFFBF9F4FBFFFFFBFBFFFFFBF4F9FBFFFFFFFDFF
FFFFFFFFFFFFF9F8FFFBFDFFFFFCF8FDFBFFFFFFFFFFFFFFFFF7F3F7FFFFFFFAFAFFFFFF
F7F3F7FFFFFFFFFFFFFFFFFBFFFFFFF9FFFFFFFCFCFFFFF6F1F8FFFEFCAF4900387C85C2
C7B2B1937D4B17549AE3F1FFFFFFFFFAF8FFFFFFFFFBFFFEF6FFF6FFFFEEFFFCF4F9FFFF
FFF8F8FFF2FFFFFCF8FFFFF9FFF1BE70251A62B5FBFDFFFFFFFEFFFFF7F3F9FFFFF8F7FF
C65E0E287BC0ECFFF5F7FEFFFFF8F8FDF9FFFCF6FFFFFEEC742C93FDFFFFF8FFFFF8FBFF
FEFE41A9FFFF7990FAFA67A0FFE5FFFFECFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF4FFF1F81BF62700070013FFF8FFF9F6547BFB
FCF8EBFFEBFFFFFFFFFEF7FFFEF5FCFFFFF6F4FFF4FEE230ABFBFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAD4CF4FFFFFAFEF9F4FFFFFFF4FFFFFFFF
FEFDFDFFFFEDFFFFEFF1FC815BFFFFFFFCFFF7FFFFFCF9FFFFF4FFE2F3F8FFFFFEF4FFFD
FFFFFFFFFFFFFFFFFFFDFFFEFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEEF3FFFFFFF6F9FF
FCFFFFFFFFFEFEFFFFFEFEFFFAFFFBF9FFF9F8FFFFFFF3EEFEFFFFFFFBFCFDFAF7F9FFFF
FFFBFAF8F4FFFFF9FFFFFFFFFCFDFFF2F2FFFDFCFFFFFFFFF9FFFFF4F8FAFBFFFFFFF9F7
FAFDFCFBFFFFFFFEEEF3FFFFFFF6F9FFFCFFFFFFFFF2F2FFFFF2F2FFFFFFFFFCFFF9F6FF
FFFFF3EEFEFFFFFFFBFCFDFAF7F9FFFFFFFBFAF8F4FFFFF9FFFFFFFFFCFDFFF2F2FFFDFC
FFFFFFFFF9FFFFF4F8FAFBFF56B0F8FFFFFFFFFEFFF9FDFFFFFCFFF7FDF8FFFFB77D843E
34444B727EAAFFF2FCFFFFF7FFEEFFFBFFFFF6F5FEF7FDFFFFFFFFFEFFFFFFF7FFFFFFFF
FEFCFEFFFFFFFFFEFDFFFFFCF6FFFFFFFBE69943023C93DBFAFCFDFFFFFFFFFFFFFBFAFF
F9FFFFDA77252F68B0F3FFFCF0FFFFFCF8E05BFFF0FFFFFFEDCB3941D3FFFFF9FDF6FFFF
F1FFA184FFFBF432E2A35EFEF3FFFFFBFAFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00225D0D030D9AFFF8FCFEF1FF8B36
E7FFFFF3FFFFF8FCFFFDF3FFFFFFFFF6F7FFFFFFFFA826E2E7FFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFBF9B150C2FFFFFFFFFFFFFEFCFEFFFFFFFF
FEFFFFFFEFFFF8FCFFFF5B75ECFFFFF6FDFFF9FFFFFFFCFAF9FFFFFFFFF0FFF3FFFFFFFD
FFFFFFFFFFFFFFFFFDFFFDFDFDFCFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDD5C0C0C7E5FBF2DEE7FFFF
DCBCBBB7E1FAFAE1E1FAFAE1C8C6BFD8FFFFE4DEF2FBE5C7C0C0D5FDFFE8E3FDFFE4BEAE
BCD9FFFFE2E3FEFFDEBEB4C3DCFFFFE7E7FFFFDCC3B4BEDEFFFEE3E2FFFFD9BCAEBEE4FF
FDE3E8FFFDD5C0C0C7E5FBF2DEE7FFFFDCBCBBB7E4FFFFE4E4FFFFE4B7BBBCDCFFFFE7DE
F2FBE5C7C0C0D5FDFFE8E3FDFFE4BEAEBCD9FFFFE2E3FEFFDEBEB4C3DCFFFFE7E7FFFFDC
C3B4BEDEFFFEE3E2FFFFD9BCB6C0C4BEB1ABCCFFF5BEB4ABCEC6AEC4ABCCF6FBC5A8BFC8
C3C7BC9DDBFFE5C6A4B9C1ABCCC1A1D4FFF3BFB2C5C3C0BDBF8A84F4FFECADC4B7CFEBFB
FFFFFFFFFCF7F8FFFFFFFFFFFFFCF9FBFBFAFFFFFBBD6627225BB3F5F8FFFBF1F5FFFFF9
FBFFF7F1FFFFD389401B3CABF9F8F0FFFF720076FFFAFFF8FFFAFF8A197DF2FFFFFFFFFF
F8FFB48DBBC6BD8F301FFAFFFFFFE7EFFFFCF3FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFA7D0EAAF7BC0023EDF9FFF6FFFFFFFBC6
1964DBFFF7FFFFF2FAFFFFFBF3FFFFFCFFFFE4AD2754EFFFFFFFF9F1FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFDFDF7C149ABFDFAF7F5F5F8FFFFFFFEFCFD
FFFFFFFFFFFFFFFCD22AA8FFFFF2FCFFFFFDFDFFF9FFFFFFFCFFE7FFFAFFF7FFFDEFFFF9
FFFFFFFFFFFFFFFFFBFFFBFEFEFF89F1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB9E4E324CA4F7FF83B2FBF9
994C3F40B4FFFFB4B4FFFFB4626D7CB5F9EEB295FFF7A44C324E9EFBED9EA2FFFF984649
509DF8F6AEA5E1FF994F2B54A5F0EAA7A7EAF0A5542B4F99FFE1A5AEF6F89D50494698FF
FFA29EEDFB9E4E324CA4F7FF83B2FBF9994C3F409AFFFF9A9AFFFF9A403F4C99F9FBB283
FFF7A44C324E9EFBED9EA2FFFF984649509DF8F6AEA5E1FF994F2B54A5F0EAA7A7EAF0A5
542B4F99FFE1A5AEF6F89D50464282DFD27B8CF8FF87314F2595CCD18095FFF48351363A
89D0C58B92EAFE924541478FC5D47E90FFF18B3F304489CBC88D8FFFF5A23C484A9FF6FF
FFF5FAFFFFFFFFFFFAF6FBFFFBFFFFFFFFFFFFF4FAFDFFF7D89845084C9DEEFFF9F4FCFF
FFFFFFFFFFF9FCFFFAF1AF440D3B9BDEFC37090051FFF8FFEBFFEDFDEF4D2EC6E79F4F3F
240B0041453E424F2D00001E3D6895E2FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFC83E5AABF0FFF467BAFFF2FFFFFAFFF5FFFF
F3942951A1DBFFFFF1FDFFFEFFFAFFFFCD754B53D0FFF1F3FFEDFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFCFFE9EC5633A8FFFFFBFFFFF0FFFCFBFE
FFFFFDF7FDFAC3572DE3EDFFECFFF1FFFFFFFDFFFFFFFBFCFDFFF7FDFDF5FFFFFFFFF7FE
FFFFFFFFFFFFFFFFFFFDFFFBFFFF8EF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFFF6FCFFF3FFF4FCFF
F8F8FFF8FFFEFEFFFFFEFEFFFFFFF3F7FFFFF4FFF3FFFCF6FFFFF4FFFFFDF6FDFFFFFEFF
FDF7FFFFF3FFFFF8FFF6FFFFF3FFFFF6F6FFFFF3FFFFF6FFF8FFFFF3FFFFF7FDFFFEFFFF
FDF6FDFFFFF4FFFFF6FCFFF3FFF4FCFFF8F8FFF8FFFEFEFFFFFEFEFFF8FFF8F8FFFCF4FF
F3FFFCF6FFFFF4FFFFFDF6FDFFFFFEFFFDF7FFFFF3FFFFF8FFF6FFFFF3FFFFF6F6FFFFF3
FFFFF6FFF8FFFFF3FFFFF7FDFFFFFAF8FFFFFFFFFFFAFFF9FFF3FFFBF8FFF9FFFFF1FFFF
FCFFFFFAFFFFFFFCF7FFF9F7FFF5FFF6F1FFFCFDFFFEF8FFFFFEFFFEFFF9FFFDF7FFFFF7
FAFFFFF2FDFFFDFAFFFFFFFAFFFCF9FFFFFCFDFFFEFFFFFFFFFFFDF4AE611B2574C7F4FF
FAFFFFFBFDFFFFFCFFFAFEFFF8B95D192C0100150044FBF7FFFCFBFFFFB84C1C1570A1BF
E1F4FFF8FDFAF8FFF1F5FFDCB99C6F1D1F7BC2FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE802992F6FFFFFFFFE5F7FFFEFEFFFCFCFFF9FB
FFFFF3AC5C222561838D9EAD8476491D2F80D3FBFCFBFFFFFFFFFDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDEEFFFAFFFFFBC9592676DAFBFCFFFFFFFCFF
FFFFF4E8973F36A4FFF2FFFFFFFFFFFAFFFFFDFCFDF9FFFFFDFBFFFEFFFCFFF3FFFCFAFF
FFFFFFFFFFFFFFFFFFFAFFF6FEFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF71FFFFEFFFFEFFF5FFFFFFFF
FFFFFFFFFFFFFFF7F611FAFFFE05FFFBFFFCFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFCFFFFFFFFFFFFFFFFFFFCF8FFFFFDFC
FEFFFFFFFFFFFFFFFFFFFFFFFEFCFBFCFEFFFEFCFFFFFEFEFFFFFEFCFFFCFFFEFDFFFAFF
FBFFFFF5F8FFFFF2FEFFFAFAFFFFFBFBFCFEFFFFFFFEFDFCFFFFFFFFFFFEFFFFFFFFFEFF
FFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFDFEFFFFFFFF
FFFBF4FBFFFFFFFFFFFFFFFBFDFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF8FF
FCFDFFFCFFFCFCFFFFFFFEFFF7FFFFFBF9FFFFFDFFF7FFFFF9F8FFFFFFFDFFD9913B124B
9AD7FFF7F8FFFAFFFFFAFBF9FFFCFFF980010008000649EFF9EBAD4D173A92D5FEFFFFFF
FFFDFBFBFFFDFEFFFFFFFFFDFEF8FFFFDB87391458A0FCFFF3FFFFFFFFFFFFF8FAFFF9FF
FFFFFFFFFFF9F8FFFBF5FEFFFFFFFED52D53ECF4FFFFF1FFFFFFFFFFFFFFFDFFFFFFFCF6
FFFFFDFFFFF3CCAA8075515C7E88BBE1FFF6FEFFFFFDFFFFFDFDFFFFFFFDFFFFFDFFFFFD
FEFEFFFFFFFDFFFFFFFFF8FFFFFFF9FFF9FFFCFFFFF9FDFFFDFFDE71341E507A7D9BAA89
8353341E64B4FFFDFFF7FFFFFFFFFCF6FFFFFDFFFFFFFCFDFFFFFAFFFFFBFFFAFFF6FFFF
FFFDFFFFFDFDFFFFFFFDFFF1FEFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FF0FFFFFFF0FFFFFFFFFFFF
FFFFFFFFFFEEFFFFFB00FFF5FF00F4FCFFFFFCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAF9FAFFFFFFF7FFFFFFF8F8FFFFFFF4FFFFFD
FDFFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFF
FFF8F7FFFFFBF9FFFFF7FFFFFFFCFFFBFFFFFBF9FBFFFFFFFCFEFFFEFBFAFBFDFEFEFEFD
FCFBFCFDFAFBFCFDFDFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFDFFFFFFFDFCFC
F6FFFFFFFFFFFFFAFBFEFFFEFFFFFFFCFFFDF5F7FFFFFFF9FFFDF5F6FCFFFBF5E499FEF8
FFFBFCFEFFFFFFFAF9FFFFFCFFFBF6FFFFFFFCFEFFFFF8F7FFFFFFEBFFEEF7FFFAFFF3B6
5824226DCDF1FFF0FBFFFEFFE6F7FFFF47001000000000518A4543A7FBFFF7FFFFFFFEF4
F7FFFFFFFFFFFCF9F7F8FAFDFFFFFFFEFFFFF9EEAA591992FFF6FBFFFEF6F5FDFFFFFFE4
FFF6FFFFFAFFFFF1FFFFFFF6F9FB9018AEF4FFFAFF4DFFF5FFFEF8FCFFFFF8FCF8FFFFFF
FFFAFBF8FFFFFFFDFAFFFFFAFFFCFDFDFFFFFFFEFFFFFFFFFFFFFFFDFFFFFCFFFFFFFBF6
FCFFFFFFFEFFFFFEFBFFFEFFF8FDFFFFFFFFFDFBFDFFFFFFFFFCFCFDFFE1AE8A895E527D
7BA4D6FFFFFFFFFBFFF6F8FFF8FFFFFFFFFAFBF8FEFFFFF9FFFFFFF7FFFFFFFAFFFFFFF8
FFFFFFFFFFFFFFFDFFF9F9FFFFFF89F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F7FFFFFCFEF8FFFFFFFFFF
FFFFFFFFFFF9FFE0FF0DF3FFFE0DFFEFFFF3FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFEF8FBFFFFF3FFFFFFFCFFFFFFFFFEF5FC
FFFDFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFEFFFFFFFFFDFDFEFEFCFBFEF8FFFBFBFFF9FF
FCFFFFF6F6FFFFFCF6FFFEE7F6FFFCFFF2F8FFFFFFFCF9F8FFFFFEFFFFFFFFFFFFFFFFFF
FEFFFFFFFFFEE7D1C2BEC0C3BEBEBEBEBEBEBEBEBEBEBEBEBEBEBEBEBFC0BFBCB9BABFC4
C0BDB8B5B9BFC1BFC6C1BFC6D4E5F9FFFCFFFFFFFFFBFCFFF8FFFFFFFFFFFFFFE695FFF9
FFF7F4FFF2FCFEFAFFFFFFF5FFFAF7FFFFFDFAFEF5FFFFFFFFFBFEFFFFFFF0F8FFFFFFF1
FFFFCC823B0356A4DAFFF9FFFFFBFFDC0C00001535634B0A6DD1FFFFEAFDFFF5FFF9FEFF
FFF4F7FFFCFFFFFFFFFEFFFFF8FFFFF7FCFFFFF8F9FFE864309FFFFCFFFDFFFFF9FBFFFF
FFFFFBFBFFF1F2FFE5FFEFFFE43131E8F9F9FFFFFDB5F8FFF8FFFFF7FAFFFFFFFFFFF5FF
FDF9FFFDFFF0FFFFF9FAFFFFFFFCF7FFFEFDFBFFF8FFFEF7FDFAFAFFF8FFFFFAFFFCFCFF
FFFFF7FFF4F7F4FFFFF7FFFFFFFCFFF9FEF3FFFFF9FFFFF9FFFFFFFFFFFFF8FAF4FEFEFF
F7FFFFF7FCFFFBFDFFFFFFFCFFFFF5FFFDF9FFFDFFF8FFFFFEEFFFFFFFFAF7FFFFFCF8FF
F8FFFEF7FDFAFAFFFFFFFEF9FFF11BDCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FAFFFFF9FFFFFFFFFF
FFFFFFFFFCFFF6FFFD00FFF5EE06EEFFFFFFF9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFFFCF3FFFEF7F9FFFFFCF8EEFFFFFF
F8FEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFEFCFDFEFEFDFDFFFFFFFFFFFFF9FFFDFFFFFDFF
FDF7FBFFFFFEFCFFFFF7FFFFFAFFFFF1FFEFCBBFC3BA9B7D7483886E452C3140443E3321
0D00000000071B2F3C403D3A414141414141414141414141414141413A3D424544403B37
463D3E4A4B403B403D3B3D3F3014000001010000000522393E403E393A4C6B838975778C
B8D2C8C6CEF1FFFFF5F1FDFFF5FFFFFFF7FCFFFFFFFFF1F9FFFAF1FFEEFFFFFFFFF1F6FF
F7FFFCF9FFF09123261D73A9FFFFE7EF83BBD9FF983066EDFCF8FCFFFFFEFFFFFFFFFFF5
F7FFFFF6FAFCFEFDFBFBFDFFFFF5F5FFFFFAF5FEFEEFFFFFCC633194FBFFFCFFF6FFE8F0
FEFDFFFFFFFFFFEBFFF5FF8C0B8DFFFEFFFDECFFFCFFC08C7D7AAFFFFFC1B8F8FFCE827D
82ABFFFAD2BEFBFFD185777EA0FDFFCBB3FFFFCA7F8281B1FFFFCDA8FFFFC98A7881B1F7
FFCDB1FFFFD8837584AFFFFACCB6F0FFD1847C7DAFFFF6D5A4F5FFD3817A8AAEFBFFD49F
F7FFCE887D7DA6FFFFCBB9F9FFCE827D82ABFFFAC7B8F7FEDA7F807CADFFFFCCB3FCFFD2
7F8281B1FFFFCDA8FEFBD5787D8420DDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF75FFFDFEFFFFF6FFFFFFFFFF
FFFFFFFFFDFFEDFFFF02F5FEFF10FEF0FFE8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFDFFFFFFFFFFFFFFFBFFFFFFF8FBFFFFFCF2FA
FFFFFEFEFFFFFFFFFFFFFFFFF8FAFDFFFFFFFFFFFFFFFFFEFEFCF9F7FFFFFFFEFDFFF7FA
FAFFFFD0B7B8A179916D3939512C00070013333E3C466380897A758EB8D1CCBDB9BFCADC
F0FFFFFFFBFAF8F9FCFFFFFFFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFFFFFBF9FDFFFFFF
F9FDFFFFF9F8FFFFFFFFFCFDFAF5FBFFFCFCFFFFFFF8DBC4BFBDBFC4C2B19279788A8776
3A2E353F310A0000122D383C4A62777E8AA3B7BFBBFFFFFFFAFFFFFEFFF2FFF8ECFFFFF4
F7FDFFFFF1FF7E0C9CDA8038154DA1E7FCFFC7106FD4F6FFFFFFFFF9FAFFFEF4F1FFFFFE
FEFFFFFFFFEAC7ABA1A7B4BEFFFFFFFAF7FFFFFFFBFFF9FFFFF7DB6829CFFDFFF5F3FFFF
FEFFFAF9FFFCF9FFFFEA3F3BDDFFF0FFFFFFFAFBFCF8CD797D7AAFFFFFC1B8F8FFCE827D
82ABFFFAC4B1EFFACD867D86B2FFFFC9AEFFFFD07F8281B1FFFFCDA8FFFFC98A7881B1F7
FFCDB1FFFFD8837584AFFFFACCB6F0FFD1847C7DAFFFF6D5C0FFFFC87B7A8DB1FFFAC8B1
FFFFB9858A89AFFFF9C0B5FFFFCE827D82ABFFFAC7B8F7FEDA7F807CADFFFFCCB3FCFFD2
7F8281B1FFFFCDA8F9FBD2837A8AA3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF03FDFEFCFFFAFCFFFFFFFFFF
FFFFFFFFF9FFFFFFFE0002FFFF00FFFBFFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFDEDD6C6BB927787ABC9E1F4FFFFFFFF
FFF9FCFFFFFFFFFFFFFFFFFFFFFFFFFEFDFBF7F4FDFDFDFFFFFFFFFFD4C0B3947A674941
1C00012B44455D85708ABCC9B2C7F5FFFFFFFFFFFFFFFDF9FDFFFFFFFBF9FBFFFFFEFDFF
FFFFFCF7FDFFFFFFFFFFF5EEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F9FCFFFFFFFCF7
FFFFFFF2F9FFFFF6F0F7FFFFFFFFFFFFFFFEF9FBFFFFFFFFFFFFFBFAFFFFFDF9EB8EFFFF
FAFFFFF9FFFDFFFFF7D3C0C1AC98877F7057464333000012373647728182B7CEE3FFF7FF
FFFFF2F2FFE60F0005CCFFFFE1AB7C0E22513AEAF6FFFFFDF4F8FDFFFEFEFFFFFEFFFFFC
FFF9B86C14223B54615E4D3F002E8AE2FFF9F7FFFEFFFBF8FFFFF6FCDB33A2F2FFF5E6FF
FFFFFAFEFFFAF6F9981F84FFF9FEFFFBFBF0FFF8F8FFFEFEF8FFFFF7FAFFFFFFFFFFF5FF
FDF9FFFDFFF6FFFFF9F8FEFFF9F8F5FDFAFFFFFFF8FFFEF7FDFAFAFFF8FFFFFAFFFCFCFF
FFFFF7FFF4F7F4FFFFF7FFFFFFFCFFF9FEF3FFFFF9FFFFF9F4FFFFFFFFFCF2FCFFFFF9FF
F4FFFFFFF1FCFAFFFFFFFCFFFFFFF5FFFDF9FFFDFFF8FFFFFEEFFFFFFFFAF7FFFFFCF8FF
F8FFFEF7FDFAFAFFFBFFF9FFF1EFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFEF9FFFFFFFFFFFFFFFF
FFFFFFFFFFF8FDF9FD02F80003FDFFFFEEFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFCCB7A3A2C394269897C4F2C2A3878C9FFFF
F1FDFFF6FFFFFFFFFFFFFFFFFFFBF9FEFFFFFFFFC6B69A77522F130344455D7291B1B9C6
FFFCF8FDFFFFFFF9BBC199728CBBCCCDF6FDFFFFFAFAFFFFFEFCFBFCFEFFFEFDFCFBFCFD
FEFEFDFDFFFCF7F3F5FCFFFFFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFDFBFFFFFFEFD6C1B6
7F8A9FBBD9EFFBFEFFFFFFF9F2F4F9FDF4FDFFFFFBF7FBFFF4FDFFFFFDFAFEFFC337FFFF
FAFEFDF8FFFFFCFDFCF7FBFFFFFEF9FFFFFFFDFFFAFFFFE5C9CCB78983784E2B21090C47
467EA1B5F09200100420E2FFFFF5E9FF4D3DF7FFFBF5FFFAFFFFFDF6F9FFFFFCFFF0FBFF
BA474290F0F3F7FCFFFFFFFEFFD1682766E3FFF1FFE2FFFFFBFFF9FFF8F06264FDFFFFF9
FFECFFFFF4FFDE563BC6FFFFF6F7FFFBFFFFF9FFF3FBFFFFFFFEF8FCFFFFF8FCF8FFFFFF
FFFAFBF8F8FAFFFEFCFFFEF7FFFFFFFFFFFFFFF3FFFFFFFFFFFFFFFDFFFFFCFFFFFFFBF6
FCFFFFFFFEFFFFFEFBFFFEFFF8FDFFFFFFFFFDFBFDFFFFFFFFFDF8FCFFFFFFFFFDF8FAFF
F4FFFFF4FFFCF2F9FFFBF6FFF8FFFFFFFFFAFBF8FEFFFFF9FFFFFFF7FFFFFFFAFFFFFFF8
FFFFFFFFFFFFFFFDFFFFF7FFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF04FAFFFFFCFFFBFCFFFFFFFF
FFFFFFFFFDFFFFF9FFFFFDFFF5FFFFFCFFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA43E3783D5FBFFFFFFF9F2FFFFF3CD853736A7
FFFFF8FFFFFFFFFFFFFFFFFFFFF0C79A6F42190049566F92B9DCF5FFFFFAFFFCFFFFFCFE
FCFFFFFEDB9849123D436686774D3533245AA6E5FFFFFEF7FFFFFFFFFFFFFFFFFFFFFFFF
FDFDFFFFFFFFFFFFFFFFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE5A45C29213A54
846B5D5129124A9FE2F4FFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFEFDFEFFFFFEBA47FFF5
FFFFF8FFF8FEFFFFFFFFFFFFF8FFFFFCFAFFFFFEFFF2FAFFFFFAFFFFFCFFF9FFFFFFFBBE
C085864723000A0000003DF2FFFFDC3BADF3FCFFFFFFF5FFFFF7F9FFFFFAF8FFF0FFDA57
43B5FFFAFCFFFFFFFFFCFDFFFFF3FFFF92236DFFF7FFFDFEFFF8FFF7F3FFF79040D2FFFD
F3FFF3F1FF8D2281FEFFFEF7FFFFF3FFFFFCFCFFFDFFFFF5FFFFFFFFFFFFFDFFFFFFFCF6
FFFFFDFFFFFFFCFFF9FFF4FFFFF9FFF8FFF5FFFFFFFDFFFFFDFDFFFFFFFDFFFFFDFFFFFD
FEFEFFFFFFFDFFFFFFFFF8FFFFFFF9FFF9FFFCFFFFF9FDFFF8FFFFF7FFF5FEFFFFFFFFF4
FFF2F8FFF8FFFFF2FFFAFFFEFFFFFCF6FFFFFDFFFFFFFCFDFFFFFAFFFFFBFFFAFFF6FFFF
FFFDFFFFFDFDFFFFFFFDFFE9FFFDF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7DFFFEFCFFFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFFFFFDFFF8FFC22B6DC4FCFFFFFEFFFFFFFFFFFFFFFFFFFFFEC54B
49C1FDFFFDFBFFEEFFBF7E501425436C9AC6E8FBFFFFFFFFFFFFFFFFFEF9FFFDFFFDFFFD
FFFFD75F255FC0F4FFFFFFFFFFFFFFFFEDA1453080E7FFF4FAFFFFF9FFF9F1FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF6FFFCF2FFF0773C42A3F1F7F4FF
FDFFFFFEFFF0AD671771D9F7FFFCF8FEFFF4FFFFFBFFFCFFFFFFFFFFFFFFFFFFBE47F8FF
FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8FFF9FFA10B000A00100063FFAD40C5FFFFFFFFFFFFFFFFFFFAFBFFEEFFFEF5FED444A6
FDFFFFFEFFFFFFFFFFFFFFFFFAFFFFFEFFEB9C48E3FFFFFFF6FFF5FFFFF8FFFFCA2EB5FC
FFF0FFEB3B30D9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFCFFF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFBFFFDFF8845D4E9FFFFFFF7FAFFFFFFFFFFFFFFFFFFF7FFFEFF
B03999FFFFFF86610A287FB0ECEFF3F8FEFFFFFFFFFFFFFFFFFFFFFFFFEAF9FFF2FCFFF7
E8571E8FFFFFF3FCFFFFFFFFFFFFFFFFF8FFFFE7752979FFFFFFFEFFECFFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFFBFFF37E2284D7FFFFF4FFFFF8
F8FEFDF9FFFFFFF7FF962469D8FFFFFFFFFFF1FFF2FFFFFBFFFFFFFFFFFFFFFFDB9CFDFF
FFFFF6FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFA45000000050008005D4DDCFFFFFFFFFFFFFFFFFFFEFFEBFAFFF8FFFFC11BDBF5
FFFBE8FFFFFFFFFFFFFFFFFFFBFFFEFCFFFFE0B251FBEEFDFFF6FDFFFEFFFFF4EBFF34A0
F9FFC7118FECFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFCFFF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8F7F5F55D69F5FFFFFFFEFBFBFFFFFFFFFFFFFFFFFFFFFFE0FFF9
FFFF7D4A980056A9E6FFFFF2FFFFFFFFFFFDFAF7FFFFFFFFFFFFFFFFFBFFFFEDFFFFFFC1
2DA7FFFFF7F8FFFFFFFFFFFFFFFFFFFFFFFFFCFDFFE58E37E7F6F7FFFFF8FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECFEED4D6CECFEFFFFFFFEF9FCFF
FFFFFFF9F5FAFFFFFDF8F6993FB6FAF5EBFFFDFDFBFFF9FEFFFFFFFFFFFFFFFFFFFEFFFD
FCFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEF8FFBCC6C6BDDCFFFEC556FAFFFCFFFFFFFFFFFFFFFFF3FFFFFFE9FDFFCD37F9F0FC
FFFFFFF7FFFFFFFFFFFFFFFFFFFFFEFAFFFFFFFDBE35FEFFE2FFFFFAFFF1F4FFFFF3F855
B5FEDED5EEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7DFFFEFCFFFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF3FFF33BA9FFFFFAFBFEFFFFFFFDF8FFFFFFFFFFFFFFFFE9FFF9FA
FFFEF4910CDEFFFFFAFDF5FFF8FAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFEFAF4FFFFFF9749
F1F5F5F2F9FFFFFFFFFFFFFFFFFFFFFFF8FFFDF4FFFFF4C528C5FFF9FFFFF8FCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFBE28BAFFFFFFFFF8FBFFFFFDFC
FFFEFFFFFFFFF8F5F9FFFFFCE8408CFDFFFBFFF0FFFFF0FFFFFFFFFFFFFFFFFFFDFCFFFA
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F6FDFFF6FFF8F8FFFEFFD344E4FBFFFFFFFFFFFFFFFFFFFFFFF7F5F3FFFCF63DD3F3FFFF
EFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFEFBF9FDFFFFB554EAFFFFECFFFCFFFFEDFFF9FFE5
3FCEFFF2FFFDE9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7DFFFEFCFFFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8F45ABCF9F8F7FFFFFFFFFFFFFDFCFFFFFFFFFFFFFFFFFFFCFFFD
FAFFF7FF983DFCEFFFFFFDFDFFFFFFFDFCFCFCFDFFFFFFFFFFFFFFFFFFFFFFEAF1814BFA
F9FEFFFFFFFDFDFFFFFFFFFFFFFFFFFFFCFFFFFFFFF9FFFFF52F9CFFF6F6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9B847E8F5FFEBF4FFFFFFFEFFFFF6
FFFCFAFFFFFFFFFFFFFFE4FFFAFC7382FFF7FAFFF7FCFEFFFFFFFFFFFFFFFFFFCBB6F7FB
FFFFFCF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFECFFFFFFF5FFFFFFDF34D6FFFFFFF3FFFFFFFFFFFFFFFFFAFAFFFFFFFD5A99FFFFFFEF
FFF5FFF1FFFFFFFFFFFFFFFFFEFDFFFFFFFAFAFFFFFF698FFFFFF8FFFDFFF4FFF2FCFFFF
E92CE9FEFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFCFFF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFEFFF8371F4FFEFFFFCFCFCFBFAFDFFFFFFFFFFFFFFFFFFFFF6FAFFFD
FFFFFAF0FF8782FFFBFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFF4FFAC67FFF4
FFF9F8FFFFF9F6FFFFFFFFFFFFFFFFFFFFFFFDF2F4FFFFF6F8F353E5FFF8FEF6FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE225F9FFEEFFFFFFFAF2FAFEF9FBFF
FFFFFFFCF6F3F9FFF8FFFFFFF6FAFC6782FFFFFFF3FFFFFFFFFFFFFFFFFFFFFFDFB0FFFD
FFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFF1FCFFFDF5FFE54ECDFFF2FFF7FFFFFFFFFFFFFFFFFFFFFFF5FEFBD83AF6FFF6F9FF
FAFFEDFFFFFFFFFFFFFFFFFFFFFDFDFFFFFEFDFFF6FFDE3DE1F5FFFAFFF0FFFCFEFFF9F6
F8D94AE5F3FFFFEAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFCFFF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFAF65FEFEFFFAFBFFFFFFFFFFFFFEFEFFFFFFFFFFFFFFFFFFFFF3FD
FFFDFFFFF7FF4BAEFFFFF6FEFEFEFDFBFAFAFAF9FFFFFFFFFFFFFFFFFDFFFFAB45E7FBFD
FAFFFFF5F9FFFFF7FFFFFFFFFFFFFFFFF6F4FFFFFFF9FBFFFFEEDC32D0FFFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEB26FEF0F7FFF3FFF0FFFFFFFBFFFFFF
F5FEFFFFFFFFFFFFFFF9FDEAFFFFFAFB59BCFFFBFFFFF9FFFFFFFFFFFFFFFFFFFFE4FFFF
F3FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
E4FFFFFFFFFFFFF749B7F6FFFFFFECFFFFFFFFFFFFFFFFFFF3FFFFF5FF23D3FFF5FFFFF8
FFFFFBFFFFFFFFFFFFFFFFFFFFFFFDFEFFFDFDFEFFFCFE9063FFFFFFFFFFFDFFF5FFFCFD
FFFABB38FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7DFFFEFCFFFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFB2CCFFFFBFEFDFFFFFEFCFCFEFFFFFFFFFFFFFFFFFFFFFFFAFAFFFD
FCFFFCFFFFFFE522F9FAFFFCFFFFFFFFFFFFFFFDFFFFFFFFFFFFFFFFFFF4F727E6FFF5FF
FFFEFFFFFEF8FAFFFFFFFFFFFFFFFFFFFFFFFCF9FBFEFEFBFFF9FFA45EF7F7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF51ACF0FFF7FFFBFFFFFFF5F8FFFFFFFC
FEFFFEFAFDFFFFF8F8FFFFFFFFF9F7FFE824E1FFFFF9FFFCFFFFFFFFFFFFFFFFFEFEFFFF
F5FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF3FFFEFBF6FF688CFFFFF4F6FFFFFBFFFFFFFFFFFFFFFFFFEBFFFFE037E8FFFFFFFAFF
FFFCFFF6FFFFFFFFFFFFFFFFFFFFFEFDFFFFFFFFFEFFFDED20EFFFF9FCFFFCF5FFF4FBFF
F6FFFF8C6FFBF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF8FFF4FFFFF7FFFFFFFF
FFFFFFFFFFFDFEFCFFFF000A06FFF8FFF7FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F7FFFFFBFFFEFBFF876DFFFCFFFDFFF9F4FFFFFBFFFFF3FFFAFFFFF6FFF2FFFFFFF3FFFF
FBFFFFF4FFFFFF6489FFFFF1F6FFFEF8FFF7FFF8FFFCFCFFFFFFFEFFFFF8639EF8FFF2FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFF858B3FAFEFFFFFDFD
FDFFFFFFFFF9FFFFFCF7FFFCFEFBF6FAFFFFF1B952F2FFFCFFF0FFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF09A75F3FFFFF7FCFEFEFEFEFEFEFEFED99BFFFF
FFFFFCFFFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEF4FFF6FFFFFFFE
F3FEFFFCFFF7CB40FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFCFF857DFDFFFFFFFFFF
FFFFFFFFFBFFFFF9FAFFFFFFFFFFFFFFFFFFFFFFFAFFFFFB52AEFFFBFFFFFFFFFFFFFFFF
FFF5FFFE2ED6FFFFFFFEFDFAFFF7FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F5FFFFFFFCFFFFFFFEFFFFFFF9F4FFFFFFFFFFFFF5FBFFFBFFFAFFFBFFFFF9FFFFFDFFFC
FFFFF7FFFFF7FFF9FFFCFFFFFFF6FBFFFFFDFFFFFFF6FFFFFFEAFFFFFFF5FFFBFFFFF4FA
FCFFFAF9FFFFFFFAFCF5FFFCFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF06FFF0F6FFFFF5FFFFFFFFFF
FFFFFFFFFFFFFFF8FB00FFF3FA00FFFAF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFCFCFFFAFFEF20F4FFF0FFFFF5FFFFFFF9F6FAFFFFFDF8FFFFFCFFFFF9F4FDFFFFFA
F6F9FFFFF3FFF1FF05FFFBFFFCFFFCFFFFFFF8FFFFFFFFFFFFFFFFFFF8DB3EF0F4FCFFFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF7FCE620FFF9FFFFFFFF
FFFFFEFDFCFFFFF4FAFFEFFFF7FFF8FFFEFFFF3ABBFFFFFDFFF9FFF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEA42D0FDE9FFFFFFFFFFFFFFFFFFFFC051F6F7
F3F9F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE4FFFDFFF8FF
FFFFFCFEF4FF41B0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFAFF45B9FFFCFFFFFFFF
FFFFFFFFFFFF000B04000000FFFFFFFFFFFFFFFFFFF3FFF98878FDFFFFFFFFFFFFFFFFFF
FFFFFCFDB54AFFF4FFFEFFF9FFFAFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAF0FDFFFAF9FFFFFAF6FFFFFFFFF2FAFCF0FFF9FFFFFCFFF6FFECFDF5FCFFF5FFF2FF
FFF2FFFFFBFFFFFEEBFFFFFDFFF9FFF7FFEFFFFFFFFFF4FFFCFFFFFBF6FFFBFFF9F1FFFF
FDFFFFF9FFF1FFFFFFFDFFFFE2FEFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00EDFFFFFFF9F4FFFFFFFFFF
FFFFFFFFEBFFFFFFFF0CEAFFFF07FDFFFFFFF4FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFDFFFFF6FFAA3DFFF5FFFBFDFEFFFFFBFAFFFFF2FFF0FFF9FBF6FFFFF8FFF0FFF2FF
FFFAFBFFFFF8FFF2569FFFF5FFEFFFFFF2FFFDF6F3FDFFFBFAFFFFFFFF628DFFFFFDFFFC
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFF5718DFFFFFEF9F6
F6FAFFFFFFEFFFFFFFE98BFFFFF7FFEDFDFFB243FFFFF7FCFFFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFEA855FFFEFEE9FCFCFCFCFCFCFCFCC431FFFF
FFFFFFFFFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCF0F8FFC0FFFAFFFA
FFF1F0FFFF9B58F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFDFB13ECFFFCFFFFFFFF
FFFFFFFFEFFFF802FFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFCB846FCFFFFFFFFFFFFFFFFFF
FFF9FFFFFE51A5FFFFF9FFFBFBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F3FFFFFFFFFCFAF8FFF8FFFFECF7FFFFFFFBFFFCFFF3FCFFEEFFFFFFFFFFECFFFAFFFFF4
FFFFECFFFBF9FFFFFFFCFEFFF6FFFFFFF8FFFDF8FFF8FBFFFFF5F4FCFFFFFFFFFFFFFAFA
FAFFF0F9FFFFEFFFF8ECF3FDFFFFF6FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCAFFFFF2F5FFFFF7FFFFFFFF
FFFFFFFFFFFEFFF5EA07FFEEFC00FFF0F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFFFFFFF8FF4FB8F2FAFFFBFBFFF8FFFCFCFFFDFBFFFFFCFBFFFDFFF3F8FDFFFFFBFD
FFFCFCFFF2FFF9FCBB5EEEFFFFFFF6F1FFFAFFFFFFFFFFFFFFFEFCFBF913F8F2FFFFF3FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF3FFF0FBC14BFFF9FEFFFF
FFFFFFFBFFFDFCF8FFD90D1FAFFFFCFFF9FF5BA9FFF5FBFFFFFBFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE4FF11F5FFFFFFFFFFFFFFFFFFFFFFBF43FAFF
F8FFF5FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB0457C9F8FF
F3FFFFFBEE33E5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFF10DF9FFFFFFFFFFFF
FFFFFFFFFFFFFFEF00FBEFFFFFFFFFFFFFFFFFFFFCFFFCFFC931FDFEFFFFFFFFFFFFFFFF
FFF9FFFFFDCE40F4FFF6FFFEFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFEF1F8FFFFFAF5FFFDF0FFFFE9FFF8FFFFFCF4FFFEFDFFEBFFFFF0F4FFF8FFDCFFFF
EAFFFFF8F8FFF9FFEEFFF7F6FFF9FDFFFFFFFFFFF1FFFFFFEEFFFCFFF7FFEDFFFFFFFFF8
FFEEFFFFEAF7FFF0FCFFFFF3FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3FFFFEEFCFFFFFFFFFF
FFFFFFFFF5FEF7FFFF00FAFFFC01FEFFF6FFEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFCFFFFFFFFF117EBFFFFF1FFFDFBFFFBFFFFEBFBFFF5F9EEFFFFF4FFFCFFF8F9F5FFFB
EBFFFFFBFCF9FFFDFF0AFEF7FFF4FFFFA432D6FFFFF8F6FFFFFEFCFFB04FFFFFFAFFFBFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFE722E4FFFDF9F6
F6F9FDFFF4FFFFFFF1B50700003FD6F5FFE904FFFFF4FFFFFCFDF9FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF56ADF5FFFEFCFCFCFCFCFCFCFCDE9FFEFF
FAFFFAFFFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCF7F6FF00000254D1
FFFFFBF38986E2FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE8FFEF0FFDFFFFFFFFFFFF
FFFFFFFFFFFAF6FFFE00FFF9FFFFFFFFFFFFFFFFFCFFF9FFD823FDFDFFFFFFFFFFFFFFFF
FBFFF6FBFFFB827FFFFFFCFDFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFFFFFFF4F3FEFFFAFFFCF7FEF7FFFFF4FFFCFFFEFEFFFEFFEEFFFAFFF9FEF7FFFFFF
FFFAFFFBFFFDF9FAFFF8FFFFFDFFF7F6E6FFF6FFFFFAFFECFFFFF8FCFFF9FFF7F1FEF6FF
FFFAF1FFF9FFEDFFFFF0F6FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF7FFFFF8FFFFFFFFFF
FFFFFFFFFDFFFFF5FA08FAFFFF07EFFAFFFCF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFF9FEFFE21CFAFFF7FDFFFAFCFEF8FEFFFFFFFFF3FFFFFFF2FFFFFFFBFFFFF3FFFF
FFFFFEF8FFFFF2FFFA12F3F9F8EB870C0300EDFCFFFFFEFFFFFFFFFF649AFFFFF3FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE5FFFFEBE82600324745454A
576A7D898B7C83BCC68D0D0000000462D5B168F6FFF9FFFFFCFFFFF9FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDFFF6A565F4FFFDFFFFFFFFFFFFFFFFFFF1FFFF
F6FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF040C000400
55B8FFEA1EFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFF707FFFFFBFFFFFFFF
FFFFFFFFFFFFFBF7F7FB0AF2FFFFFFFFFFFFFFFFFFFAFBFFE11FFDFFFFFFFFFFFFFFFFFF
FFFFF6FFFFF8ED2DE2FFFAF9FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFFEFFFFFFFFFFEAFFFFFFFFFFFDF8FFFFEBF3FAFAFFFCFFFAFDFFF9FBFFF1FFFFFA
FFFFF0FFF8FDFFFFFFFCF7FDF8FFFCFFFFFFF7FFFFFFFFFCFFFFEBFFFFFFFFFFFFFFFFFB
FCFFFFECF9FFF4FFFDFFFFFFFFF4FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF48E6FFFAFAFBFFFFFFFFFFFF
FFFFFFFFFFFFF1FBFFEB0C0200F6FFFFF0F7FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFDFEFEFCC83DFFFAEBFFFFF8FFF9FFFFEFFFFFFBFFF1F6EDFFEFFEFFF4FFF1FFFBFF
FFEFFFFFEEFFFFFFFE3DBBD8681000051100ECFFF9FFFFFCF6FBFDF939BEFFF5FEFFFBFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFFF7F5BB7BBBFBD
AF9A83747E846C4642300000031C0003086178FFFDFDF6F8FFFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFE014610000010101010101010105000900
00000000010101010101010101010101010101010101010101010101000302000D09000F
0507747C83FBF6FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFC0FF4FFFAFFFFFFFF
FFFFFFFFF8FDFFFFFAFFEA13FFFFFFFFFFFFFFFFFFFBFCFCC63DFEFFFFFFFFFFFFFFFFFF
FFFAFFFFF8FFFF6F86FFFEFAFFFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFBFBFFFAA547FDFFAC0C00003EFEFFB048FFF7D20200002EFFF6BE4CFBF6CA000000
45F7FFC640F7FDCB00140238FFE8CC42F7F8C30002002EFFF1C050F1F3D000000C30FAFF
B542FDFECC000C003BE7FFF2FFFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFAFFF8FBFFF2FFFFFFFF
FFFFFFFFFFFBFFFEFCFFFFF8FDFFEFFDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF7FBFFFFF2AE52FCFBFFF6FFFDFFFFF6FFF0FFFAFFF10DFFF0FF0A000003000DF1FFFA
FFF0FFF6FFF5FFFDFF5D450402000B000000947B85ADC3BCC6EAFFFD21E5F3FFFFFCFAFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFF5F9A161FFFFFFFD
FCFDFEFEFFFCFFFBFF9B00070000206EDE639CFFFBFFF9FFFFF9FEFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF7E614FFF3FFFEFEFEFEFEFEFEFED4B9F6F6
FFFEFFFBFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFEFFFFF80900070400
2EAAFB21D9FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB25D8FFFFFFFFFFFF
FFFFFFFFFFF0FAFFF1FFFF00FFFFFFFFFFFFFFFFF6FFFAFF9C69FFFAFFFFFFFFFFFFFFFF
FEFCFFEEFFF7FCDD2FFBFFFFFFFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFEFFFFFFFFFFF1FFFFFCFFF5FFFBFFFDFCFFFBEEFFFFFFF2FEFFF4FFFFF8FFFFFB
FDFFFBFDFFFCFFFAFFF9FFFCF7FFFEF1FFFFFAFFFCFFFFEFFFFFEDFFFFF2FFFAFFFFF7FE
FFF5FFFAFEFFEDFFFFFFF3FBFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F8FFFFF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFBFFF8FF9364FFFFFDFFFFFBFFF9F5FFFFFCFFF7FD03FDFFFDFC00FBFFFDF8FFF7FC
FFF7FFFCFFFFFFFFFF6195A01B03000501137F81734332473B11113800FFFCFFFBFEFFF9
F4FFFFFBFFFFF3FFF900FFFFF7F3FE05FFFFFFFFFFFFFFFFFFFCFFFFEFFFB24CFDFEFFFF
FFFDF1FFFCFFFFF2FFA40002158AF9FFFF44AEFFFFFFFFFFFFFFFFFFFFFFF8F6FFF005FD
FFFDFF0C000011FAFFFFFFFFFFFFFFFFFFF3FFFA03EDFFFFF6FFFFF8FDFEFFF7D6B3F2FF
FEFFFFFFFDFFFFFFFFFFFDFBFFFEFCFDFFFFFEFAFEFEFEFEFEFEFEFEFFFDFF00080026B2
FFF3B84AFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFF7385FFFCFFF9FFFF
FDFFFFFBFFF6FFFDFFEFFF00FFFCF9FEFFFDFDFFF7FFFFFB679AFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF41B6FFFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F6FFF1FEFFCEF0F7FFFFFFFFFFFFFFFFFFFFFCFFFFFDF6FFFDFAFFFFFEFAFFFFFCFFFFFF
FFFFFFFFFFFDFCFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF88DBFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFF4FFFFFCF9FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFAFFF9FFA658FFFDFDFFFFFCFFFDFFECFEF9F1FFFF03FCF9FFF2FF00F7FDFFFFFFF7
F6FFFFFAFFFEFFFAFD53B8F1E57D0A00011CF8FFFFFFFCFEFCF8FBFF03FFF6FFFFFEFFFE
FFFFF9F6FAFFFFFDFF00F3FFFFF8FF00FFFFFFFFFFFFFFFFFFF5F2F9FFFFB43DFFFFFFF8
F6FFFFEBFFEFFCFFFD943C9AFFF6FFF6FC47B9FFFFFFFFFFFFFFFFFFF2FFFFFFF2FF04FE
FBFC00F5FFF9FF00FFFFFFFFFFFFFFFFFFF0FFFF1EEFF6F1FFFAFCFFF6FEFFFFFFEBFFFF
FAFEFCFFFEFDFBFAFCFFFFFFFFFFFDFBFCFFFFFFFFFFFFFFFFFFFFFFFFFCFB0020BCFFFB
FBFF5C9DFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCF2D436E8FFF3FFFFF9
FBFFF2FFF9FB00F4FFFFFF03FFFBFCFFFFFFFFFFFFF9FFF022EEF7FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF8677FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFBFFF864A3F7FFFFFFFFFFFFFFFFF5FEFFFAE8FEFFFFFFFFF9F1FFFFFEF9FFFDF4F4
FBFFFEF9F5FFFFFEF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF2B7DFFEF8FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3CFFFFFFFCFAFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFCFFFAFEC23FFFF7FDFFFBFFFDFFF7FFFFF8FFF0FF03FFF8F6FFF5FD07FFFDEDFFFF
FBFAF8FFFCFAFFFFFF38C6FFFFFFE5570031FFFDF4FEFFF8FAFFFFFC0BF8F4FFFFFFFCFF
FFFBFAFFFFF2FFF0F800FFFFECFFF404FFFFFFFFFFFFFFFFF8FFFFF1FFF7BF52F3FFF8FF
FFBCCDFFF5FFFFF4FDFBE8FFFFEDFFFFFF48B1FAFFFFFFFFFFFFFFFFFFFFF3F3FFFF00FF
FAFF00FFFAFFFF00FFFFFFFFFFFFFFFFFFFFFFF711F2FFFFFFFCF3FFFFFFE0FFFFF3FFFF
FBFEFBFFFFFFFFFFFFFDF6F1FAFFFFFFFFFBFCFEFCFCFCFCFCFCFCFCF3FFFFB5FFFFEBF3
FAFC1DE8FFFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFF5FFF824EDF7FFF3EBFF
FDF4FFFFFFFFFF000B0300FAFDFCFFFFFFFEFEFFFFFAFFAB4BFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFD831FBF6FFFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF6FFFFFF57A4FFFFFFFFFFFFFFFFFFFFFCFFFFFFFFF9F5F2F6FFFFFBF9FFFFF8FFFFFF
FFFFFFFFFFFEFBFFFFFEFAFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FFFAFEFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFEFFEFFF6FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FFFFFAFEDC22FFF9FEFFF8FFFAFFFFEFFFFDEAFFFF00E8FFFFF7FFFFF100FFFFF4FA
FFFFFDFEFEFEFBFFFF22D4F5FFFFFAFFC668F6FDFFFFFFFFFFFEFBFE1BE4FBFFFEFFFBFF
FFFCFCFFFDFBFFFFFF00FFFDF2FFFB04FFFFFFFFFFFFFFFFFCFFFFF5FFFD9B50FFFFF8C5
3E0095FFFFFFF6FAFFFFFFFFFFFFFFFFF655A4FFFFFFFFFFFFFFFFFFFFFFF9FFFFFE00FE
FCFF00EAFFFFED00FFFFFFFFFFFFFFFFFFFFFBEB16FEFAF0FBFFFCB581FDFFFDDDA1FFFF
FFFFFFFFFDFBF8F7F9FFFFFFFDFFFFFFFFFDFCFCFFFFFFFFFFFFFFFFFFF5FFF6FFF3FFFF
FFC03AF8FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFAFCFFFF9D41FFECFFFFFF
FFFEFCF9ECFFF4FEF7F8FFFDFEFFFFFFFDFAFBFDFBF7FF2ED5F5FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF21DBF8FFF6FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF3FD68A1F5FFFFFFFFFFFFFFFFEDFFFBEEFDFCF7FFFFF9FEF4B66D3D1F00000000
0936719CDCFFFFFBFFFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFEFFFFF8FFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFBFFFFFAFFF022E9FFFEFFF8FFF9FFF7FFFFFFFDFFF609FCFFFFFBFCF5FFFF00EEFFFF
FCF6FFFDFFFFF6FFE427FAFFFFF0FFF8FEFFFDFFFFF6F6FFFFF6F5FF3DBCFFFFFAFFFEFD
FBFFFFEBFBFFF5F9FF00F9FFFFE3FF00FFFFFFFFFFFFFFFFFFFAFFFCFFFF8196FDBE4602
000399FFFFF8F6FFFFEBF5FCF9FFF9F2FF8985F9FFFFFFFFFFFFFFFFF2FFFAFFEBF715F4
FFFF02FFF4FFFF0FFFFFFFFFFFFFFFFFFFFCF8D72AFFFFFFFFBD4A0658FFF6FFB145F5F7
FFFFFEF9FFFFFFFFFFFEFCFAFFFDF8F6FAFFFFFFFCFCFCFCFCFCFCFCE9FFFFFAF7FBFFFB
FF8779F3FFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFA34B5FFF9FFFD
FEFFF9FFFFF8FFFDFFFFF5F8FFFFFFFDFBFDFFFFF8FF8371F6FFFFF3FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF53A7FEFFF6FDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFCFFFF90B1FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F7FCE067134B9ABDDBFFFFFFFF
F4C78C611652B6F7FAF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFE9FD9FEF7FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F8FFFFF4FFFFF4FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFDFFFFF9FFFC55A7FFFFFFF9FFFBFFFFFFE8FFFFEFF500FFFFEFFFFFFFF5F501FFFFF1
FFFFFFF6F8FFFEFF9C57FFFFFFFFF6FAFAFFF3FFFFFFFFFFFFFFFFFF7A82FFFFF8FFFFFD
F8FEFFFFFFFFF3FFF700FFFFFCFFFA01FFFFFFFFFFFFFFFFFCFFFFF8F7FF4F6B45020006
000084B6B2C6C9BDB5C7D7C1BBC7BFBCCC784CFFFFFFFFFFFFFFFFFFFFFFF2EEFFF505FF
FFEF10FFFBFFF300FFFFFFFFFFFFFFFFF9FFFF9660FFF2C9480000095BF8FFFFC148FFFC
FFFFFFFDFCFEFFFFFFFFFEFCFFFFFFFFFFFFFBF4FFFFFFFFFFFFFFFFFFF3F7FFD2B4D3E1
FA62A6FCF9FCFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF9FFF2FFE53DE6FFE7FA
FFEEFFFFF8FFFCFFF6F8F5FFFFFFFEFCFFFFFFFFFFDE39DAFFFFE7FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFA9B6BFEFFFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFF8FFFFEFFAFFFFFFFFFFFFFFFFFFFEF3FFFFE9FDFFE75B3487F2F3F3FFFFFFFFF8F7
FCFFFFFCFFA53F55CEFFFEF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFA48BEFCF8FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC4F8F2FBFFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFCFFFFFAFFFFAC53FCFEFFFAFFFEFFEDFFFFF6FF00FF00F8FCFFFAFAFFF4FF00FCFBFF
FFF5FBFFF8FFFFFF4DAEFEF9FAF7FFFFFFFFEDFFFDFFFFF9F8FDFDF8C444F5FFFCFDFFFF
FFFFEFFFFFFBFFF1FF03FFF7FFFAFF00FFFFFFFFFFFFFFFFFCFCFFFAFFEF1A2502000600
000031414A3D3B38373E3B35413F3B353C4B1FF8FFFFFFFFFFFFFFFFFFFDFFFFF9FF00FF
FFFF00ECFFF2FF02FFFFFFFFFFFFFFFFFEFFF946BFCF5E000009100251BC956D6010837D
807F817E8A7B624B3E3B4045373B4144423B312A0101010101010101000D00013633499F
FD30D0FFFAFDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFEF2FFFFF5A648FFFFF4
FFF6FCFCFAFFF6F8FFFFFFF2FFFFFDFCFFFFFEF4F42EDCFFF2F3FFF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCCB34F1FEFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF7FAFFFFEFFFFFFFFFFFFFFFFFFCFFFFF5FFFFA12796FEFFF8FFFFF0FFF2FCFFFF
FEF9FCFFFFF5FFBA3868F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF35C3FEFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFCFFFBFCFFF017F5FEFFFAFFFFFFFFF9FFFCFFFF0006FFFBFF00FFFBFCFE06F9FFFF
F6FFFFFFFFFCFBF813FDFDFFFFFDFFFEFCF2FFFDFFFDFDFFFFFEFEFFF71CE6FFFFF9FFFF
F6FFF0FFFAFFF10DEF0EFCF8FF01FA03FFFFFFFFFFFFFFFFFFF7FFFFFBA354FD9D220C00
020C94FFFCF8FFFFFFFFFFFFFFF7FFFFFBFF4AA3FFFFFFFFFFFFFFFFFFF3FEFF00FA04FF
FBFF00FFFBFFF901FFFFFFFFFFFFFFFFFFF1F320E05100000D00010014496B8E6E527F7E
7C81808077859AB0BEC3C1BEC5C3BFBABAC2CFD9FEFEFEFEFEFEFEFEFFF8FFFDFFFFFFFA
FF00F6FEFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F1FFFFA046E5FF
E3FFFFFFF9FFFFFDFFF6FEFFFFFFFDFCFFFFF3E233CDFFFFFFFCFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFDB12E2F6FFFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF4FFFFF2D7F2FEFFFFFFFFFFFFFFFFF9FFF5FFFC7455F3FFF0F6FFFCF9FFFFFFFFFFFE
FFFFFFFFF0FFF0F3FF8545E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFD3AC9F9FFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFFFAFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFBFBF8FF0000FFFFF6FFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF8C74FDFFFFFAFFF3FCFFFAFFFFFFEC09FDFFFEF50B030004FEFFFFF9
F9FFFFFFFFFFFF6A93F4FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA728FFFFFF8EFFF
FFFCFAFCFEFEFFFF0003F8FFF9F40D00FAFFFFFFFEFFFFFFFFFFFFFFFA4AB2FFF9FEA227
0000B2F2FFFFFFFFFFFFFFFFFFFCF1FFFFF2C83FFFFEFFFFFBFFF4FFFFEEFFFEFF0001FD
FCFF00FFFFFEFE00FFFEFFFFFCFFF6FFFAFF8F6CFFFED2520400000D59FBFFFFFEFEFFFF
F5FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFDF5FFFBFF
D624FEFFFFFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9AF41D5
FCFEFDFFFFFFFFFAFDFFFCFFF5FCFFFFFFFBAD3BE2F3FFFFFCFDFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFB9B0C22000801423D4B5F74889FB7C7C5EFFFFFF9FDFFFFFFFFFDFA
FAFDFFFFFFFEFBFBFFFFFFFAFFFFFFFBFAFCFCFBFAFFFEFEFFFFFBFFFBF8FAFFFFFFFEFF
FFF7FFFFFF8CA3FFFFFBFFEEFFFFFFF4F2FFE8FF3D8CFFFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFBFFFFFEFEB740DEF1FFFDF8FFFFF7FBFFFFF3F7FFF5FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFE9FE3FFFDFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF43E3FEFFFFF3FFFEFFFFFFFF
FFFFFFFFFCFFF3FFFFFFF202FFECF8FFFCFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF929DFFFFFFAFFFFFFFFFAF7FAFAFFE5FFF6FAFFF2FFFFFCFFF6F6FF
FFFBF3F5FAFFD81BFFFFDAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4ED26F1FFF6FFF2
FFFFFFFFFFFDFDFFFC06FFF0FFFFF509FFFFFFFBFBFDFDFCF2FFF7F8D83AFFF6FFFFFFF3
9D2798FFFFFFFFFFFFFFFFFFF5FFFFF7FAFFE74CCBECF2FFFCFFFEFAF8F8FFF4FFFF00FF
FFFFFF00000600FFFBFFF9FFFFFBFFFBFFD922EEF5FFEEF9DB6E02015FFFFFF6FFE4FFFF
F3FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFF4FF
C834FDFFFDFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD034
66D7FFF0FFF2F5FFFFFFF6FFFFFFFDFFCC4B55E4F4FEFFFFFCFDFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF91FDAFFF4FFC0C1B19B877460493A371500001E414A43837787B0
C7C8D8F5FCFFFFFFFEFEFFFFFBFEFFFFFFFFFFFFFAFFFFF9F9FFFFFAFFFFFFFDF9F9FDFF
FFF5FFFFF5F6FFF2FBF2D7FFFFF0FFFFFFEBFF3FB6FAFCFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFCFFFFF9FFFFD847F3F5F2FFFAF2FFFDF6FFFFFFFFF1F3FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFFF8FFFCFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBBFFFFF2FFFFFFF2FFFFFFFF
FFFFFFFFFBFFFFEFF6FFFC03FAFFFFEFF8FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6B84AFFF4FFF3FFFAFFFDFFFFECF9FFF9FFFFF5FFF1F9FFFBFFFFFF
FEFFFFFFFFF650B8FAF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEE8676FFFFFFFF
FDFFFFFFFFFCFDFEFFFBFFFFF7FFECFAFFFEFCFFFFFFFFFFFFF4F4FF34B3FFFBFEFFFAFF
FFF1F3EEFFFFFFFFFFFFFFFFF5FFFFFBF9FFFFBF35FBFFEAFCF5FFFFFFF5F7FFF0F8FFE7
FDFCFDFFF8FFF1FCFCFEFFF0FFFCFDFAFF926CFBFFFAFFFFEAFFDF7364F8FFFDDFB0FFFD
FFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FAFFF7EBFFFFFF
B44BFDFFFAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFF3
9E1F6DBDFFFFFFFFF1F6FFFFDAEEAC3834ABFFFFFFFFFFFFFCFEFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFF2DD4F5FDFFFCFFFCF8FDFFFFFFFBFFFFFFFFF0CCB8B97E8B7D57
413E2B0D000F25374960747F91B0C1BFD3FBFFF7FFF4F8FFF8F0F8FBF0FFFFFFFFFFFFFD
FAFFF8F8FFFFFFFFFFC9016FECFFF5F0F5FF698FFBFFFFFAFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF9FFFFEFF4FFFFB534FBFFF7F5FFF9FFFFFCFFF4FAFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFFF8FFFCFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7E8FFFEFDFFF7FFFFFFFFFF
FFFFFFFFF9FFECFFF9FEFF00FFF4FAFFFAF3FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDF38083FFFFF8FFFFFFFAF7FFFFF1FDF8FFFAFCFFFFFAFFFDFFFFFD
FFFFFFF7FC8870FCFFF9FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF435D8FAF7FF
FBFEFFFDFDFFFFFCFEFFF7F5FFFFFFFFFDFAFDFFFFFFFEFFFFF0FFA742FFF6FFF6FDFEFF
F6FFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFF1FFFF50ABFFF3FFFFFFF5F5FFFFF0FFFBFFFF
FFFFF6FFFFFFF9FFFDFFF7FFEDFFF2FFDE16FFF7FFF2F8FAFFFDFCFFFAFFEEFFCBB6F7FB
FFFFFCF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEAFEFFFFFFFCFA
A45DFEFFF8FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF2
EDC762470731618487868161160A4FC7FFFCF4F9FFFFFDFBFDFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF94AB8E9FFEAFFFCFEFFFFFDFBFCFDFFFAF9FFFAF1FCFFFCFDFFFF
FFFFFFFFFFF5E2CDBCAB97857F52404D3907001A452D4A79818FAFBBC2D8EAF0F9FFFFFF
FFFFF8FFFFC7DDFFF4CF00002399FFFFFF925DFFFFEEF9FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFAF1FCFFFFFFFFFCFF8F62F9FFFFECFFFEFFF4FFFFFFD806FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFE9FE3FFFDFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FDFFF2FFFFFFFFFF
FFFFFFFFFDFFFFF4F7F8FF00FCF8FFF9FFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFC6099FFFFF6FFFBFFFDF9FFFFFFFFFFF3FFF8FFFAF7FCFFFFFE
F8F8FFFF9263FFFFF8FEFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFCB42F8F7FF
FFFFFEFAFDFFFFFAF5FCFEFFF1FBFBFAFFFFFFFFFFFAFAFDFFFFD235F7FFF8FFFFFDF0FF
F9FFF0FFFFFFFFFFFFFFFFFFF9FFFAFAFFFFFDF3FA3FC2FFFFFDFCFEF1FFF4FFFFF8F4FE
F9EFFFFFFFF5FFF3FFF8FFF7F9FFFFE73CD8FFEFFFFFFFFFF1FFFFFFFBFFFFFCFDFCFFFA
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF2F8FEFD
A060FFFFF9FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F4FF
EB290FD7FEC5847D7970899433BDF9ECFFFFFBFFFDFBFAFDFFFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF5F63BBBFFFFFDF6FEFFFFFFFCFCFEFFFEFDFFFFFFFFFBF5FFFFFFFF
FFFEFDFDFFFFFFFCFEFFF9F0FFFFFDF6F5FCFFFED0C8C3A277766E434038210A0C25383A
46858374B1507DE2FCC3070004003CC0DB35F2F8FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFDFFFFFFFFFDFFFF4DB8F6FFFFFAEEFFFFFFF6FFFF0BFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFE9FE3FFFDFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF30FFFFFFFFF4F4FFFFFFFFFF
FFFFFFFFF7FFF7FFFBFEFF0BFEFFEEFEFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFCFF3B9CFCFFFFF7FFFFF6FCF6F5F7F4FFFFF4F6FFFFF9FFFFFB
FFFFE6AE61FFFFFDFFF0FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFB34EF2FE
FFFFFFFDFEFFFFF9FFF4FFFDFFFFFFF5FFFFFFFAFBFFFFFFFCDA2EE9FFFFFFFBECFFFFFF
F0FFFFFFFFFFFFFFFFFFFFFFF7FFFFF7FFFFFFF6F9E24AD4FEFAFFFFFFFBFFE9FFFDF9FF
FFFFF9FFEDFFF6FFFFE9F2FFFFE6FF4FAFF7FDFFFAFCF0FFFFFFF5F4F8FFFFFBFFFEFFFD
FCFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFEDFDF9FDFFFF
A955FFFCFEFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFE8F6
62000543EAFFFAFFFFFFFFFF3EC4FFFFFEFFF6FDFFFEFEFFFFFFFCFDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFF43BBFEECFFFFFFFDFAFDFFFFFFFDFBFFFFFEF4F8FFFFF2FFFFF3
F4FFFFFCF0FAFFFEFCFFFFFFFFFBFCFFFFFCF9FFF6FAFFFFF7FFFFF8FBFFFFFEF8EBD1B8
D48E7F7A830A372F1200000C040007052E90FFFFF3FFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFF7F4F9FAF4F6FAE62BF4FDFEFFFFFFF3FEFFFFFF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFFF8FFFCFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF05FFEFEAFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9FBF9FF000000FFFFFFFFF3F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9FCEEFF635FFFFCFDF3FFF7FFFFFFFFFBFDFCFFFFFFF9FFFEF9FD
FFE49141EEFFF2F6FFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFCF2FF9261EA
F0FEFFFFFDFFFFFCF5FFFFEAFFFCEFFFFFFFFFFAFFFFFFECE230D3FFFDFFF3FFFFFFF9FF
FFF9F9FFFFFFFFFFFFFFFFFFFFFCFFFFFBF9FFFFFAFEC937DAFFF5FCFAFFFFFFFAFFFEFE
F0FFFFFFFFECFFFFFBFFFDF3F6FF48A0F7FFFFE8FFF7FFEFFEFFFFFFFFF4FBFFDB9CFDFF
FFFFF6FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE76AC8FFFFFBF8
B743FFF9FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FCFF99
000C000072F6FFF6F0F1FFFC43B3FFFFEDFFFFFAFFFFFFFFFFFCFBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF736C3FFFFFEFEFEFEFFFFFFFFFCF7FEFDFAFBFFFFFFFAFFFAF8FF
FFF1F1FFFFFFFFFFFCFBFCFDEEFFFFF6F6FFFFEFFFF9FAFFFFF9F9FFFFFFFCFBFEFFFFFF
F4FAFEFFFB60A6FFF48908000403110915D7FFFFFEF8FFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF4FFFFFFFFFFFFFFFFFFFF6796F6FFFFFEFDFFFFF9F4F90BFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFFF8FFFCFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00F3FFFFEFFFF5FFFFFFFFFF
FFFFFFFFFFFCFFFCFFFCFD0DFFFFF0FFFEFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEF8FFF5F79F36C0FFFFFFFCFFFCFBFAFFF7FDFDFFF4FFFFF6FFFF
AC5084FFFFF9FFFFFBFAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFFCFCB338
DAF3FFFFFBFEFFFFFFFFFFFDFFFFFDFCFCFFFFFCFFFFE4BA2CD8FFFFFBFEFFFBFFFFFAFF
FFFFFFF8FFFFFFFFFFFFFFFFFFF8FDFFFFFFFEF4FFFFFFD634A7FFF9FEFFFCFBF8FBFFFF
FFFFEFFCFDFFFFFBFFFEFFFFCA40A2FFFFFEFCFEFFFAFFFFFFFAF5FDFFFBFFFFBE47F8FF
FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFF1E0034BBFFFF
C236FFF7FFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCC505
0502060000B1F4FFFFFBFFFF3FC3FDF6FFFFF3FFFFFDFDFFFEF9FCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FF26D9FFF6FFFBD9EAFDFFFDF9FEFFFFFFFFFFFFFEFFFFFEFFFFFF
FFFFFFFFFEFCFAFAFFFFFFF9FFFCFBFFFFFCFDFFFFFFFEFAFFFEFCFFFCFBFFFFFFFEFBFD
F9FFF4FCFF89ABFFFF86000000408F719AFCFFFFF7FFFFF5FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF9FAFFFEF8FFFBFFF5E527FFFFF6FFFAFEFCFFFFFA00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFE9FE3FFFDFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FEFFFBFDFFFCFDFFFFFFFF
FFFFFFFFF7FFF6FDFFF3FE05FFF3FFFFFBFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFCFFFFF0D73357B7FFFFF3FEFFFFFAFFF9FBFFFCFFFFFFB442
48BFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFF3E2
368EE7FFFFFDFFFFFFFEFFFDFEFFFFFFFEFBFFFFF2D8754DFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFE5675BE4FFFFFFFFFFFFF9FF
F8FFFFFFF1FFFDFFFFFFF57F28D2FFFEFEFAFFFFFFFFF9FCFEFFFFFCFFFFFBFFC543FDFF
FCFFF6FFFFFFFFFDFCFEFFFFFFFFFBFBFFFFFFFDFDFDFDFDFDFDFDFDFEFF2203000045B7
D42EF7FFFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFAFAFFF9FFF6FEFFEFAD84
794D3F7E8387FFEFFFFDFFFD3BC9FAFFFFF6FDFFFFFFFFFFFFFFFFFFFEF6FFF9FFFAFAFC
FFFFFFFFFFFFFFFFFCF926DAFFFF923C03DCFFFAF7FDFFFCFCFFFFFFFBF3F8FFFFFDFAFC
FFFFFEFBFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFFFF9FDFFFFFFFFFFFEF9
FCFFF5FFFFF9FFFFF6670A6CD5F5FF1EF2F5FAFFFFFFFFFEFFFFFFFFFFFFFFFFFFF6FFFC
F7FFFAFFFFFFFFFFFFFFFFFFFFFFFFF725DFF5FFFFF1FFFFF5FBFF0000FBFFFDF5FFFFFF
FFFFFFFFFFFFFFFFFD3AC9F9FFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBEFFFFFFFBFCFFFAFFFFFFFF
FFFFFFFFFFFFFFF8FFFFFBFEFDFFFFFAF6F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFFFFDFFFFFCEEFFB744237AD5F5FEFBFFE7FFFFEAFBC865293EB5
FFFCF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFEF4
FF6D2889F8FFFAFFF7FFF9FFFFF8FFF6F9FFEDDD8D27A0FCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FEFFFFF89F2369DDFFFBFCF6FEFB
FFFFE8FFFFF7FAFFF4871E87FFFFF8FFFFF9FFF8F9FFFEFFFFF7F8FFFFF9FAFFB83AFFF5
FAFFFFF6F7FCFFFFFFFFF6F1FFFDFDFFFFF9DCC4C1C1C1C1C1C1C1C18383030F08000000
1E0EFEFCFFF3FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFAFFFFF1FFFFFBF5FF
F57B79FFFDFFFFF8FF766C812F4D8A7FA9FFF7FAFFFFFFFFFFFFFFFFFFF1FFFFFAFFF6FF
FFFFFFFFFFFFFFFFFFEC08E86317100300F6FFF4FFFFF7FEFCFEFAF8FFFFFFF5FFFFFFFF
FFFFFFFEFFFEFEFFFFFFFEFCF3FFFFF2F1FFFFEEFCF5F6FFFFFCFEFFFEFFFFFCF7F9FFFF
FDFFFFEEFFFFFFF3FFC5DEFFFFFFBA35F9FBFEFFFFFFFFFDFFFFFFFFFFFFFFFFFBFEFFFF
FFFFFFF9FFFFFFFFFFFFFFFFFFFAFEFF7C89FFF9FFF0F8F9FFFFE915FF00FFFFFFF3FFFB
FFFFFFFFFFFFFFFFFF35C3FEFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFCFFFFF4FEFFFFFFFFFF
FFFFFFFFFFFFF8FFFEFFFBFEF0FFF2FFFFFAFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFFFDFCFFFFFFFFFFF2CC8B2D09303F3E875C3232083D92DAFFFF
F9FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFFFF
F6FFDF722B4FACEDFFF9FFF8F7FFF5FFF07E591979F7F8FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF8FBFFFBA0193799D3FFFFF9
FFF8FFFDFDFF99582172EFEAF7F7FFFFFFFFFFFEFCFFFCFFFFFFFFFFF5FFFFF4DF95FCCD
BFADA28987755B443A3E4B5419110400000723393E3E3E3E3E3E3E3E7A78080100060E00
3B22D4FFFFFDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F2FFF0FFFDFFFF
FF7D7CFFFFFFF0F9F686000D0000001DD3F7FFFCFFFFFFFFFFFFFFFFF0FFF2F4FFFFFFFF
FFFFFFFFFFFFFFFFFF8710000000000017E9FFFCFFF5F0FFFFFEFBFFFBE9EFFFFBFDFEFF
FEFFFFFFFFFFFFFFFFFFFFFEFFF7F7FFFFFBFCFFFFFFFFFEFDFFFFFFFFFEFDFFFFFFFFFA
FFFBFFFFFFC4E7FFFFF2FFFFF2FA9180FFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFBF4FF
EAFDFFFDFFFFFFFFFFFFFFFFFFF6FEFFC045FFFAFAFFFFF7FFF6FFE7FCF8FFEFFFFAFFF7
FFFFFFFFFFFFFFFFFA48BEFCF8FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFBEBFFFFF7FFFFFFFFFF
FFFFFFFFEEFFFFFFF5FFFFF7FFFFFBFDFFFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFFFFFBF8FCFFFFFBF4FFFFFFFFF6D3C5BA7EA4C9D1FFF7FDF8F5FA
FFFFFDF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFDFFFF
FFFFFEFCE2A2521B123A4269684037100E7AABFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF9F4FFFFFBFCF1FFC26A1B053A3C
60724C3B140F6BA4DEFFFFE8FFFBFBF9EFF2FFFFF7E5C0B3857F7D603B403E1602101930
435365757C8AA0B5C0C1BAB4D7EAFDFFFBF6FBFFFFFFFFFFFFFFFFFFFFFF2700020021AE
F151ACFCFFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFF4FFF8FFFFFFFDFEFCED
FC8587F8FFFAFFFFFFFF5A00001700A2FFFAFBFFFFFFFFFFFFFFFFFFFFFFFFF8FFF4FFF3
FFFFFFFFFFFFFFFFF176020005170000000349452E83878096B1C5CFEDFFFFF8FFFFFFFF
FEFCFDFFFCFBF9FAFCFFFFFFFCFCFBFAFAFCFEFFFEFBFAFBFCFBFDFFFFFEFFFFFFFFFBF9
FEF0FFFFF396B8F7FFFFF7F8FAFA6E91FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF4FFF8FFFFFFFFFFFFFFFFFDFCFFF9CE35FAFFFEFFFFFCFFFDFCFFFFFFFFFDFBFFF5FF
FFFFFFFFFFFFFFFFFE9FD9FEF7FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3CEBFFFFFFFBEEFFFFFFFFFF
FFFFFFFFFFFAFFF3FFFFEAFFF9F5FFFBEBFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFCFCFEFEFCFFF3FAFEF6FFFFF6FEF1FFFFFFFFF2FFFFFFFFFF
FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFDFAFBFD
FAFFFFF9FFFFFFF7EBC3BB9495BDC5EDFFF9FCFFF5FAE7FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF2FFFFFAFFF4FEF6FFFEB9C9
968BBDCEE9FFF1FFFAFFFDCDB8A08283634328090A2A4767937A94BEC1C9E3ECFEF0FBFF
FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF7FEFEFEFEFEFEFEFEFAF41C1327A3FFF3
FF748DF4FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAF7FFFFDFFFFFFBFFFF
FF747BFFFFFFFCEFFFFBDD27000079FFFFFFF6FFFFFFFFFFFFFFFFFFFFDFFFFFF7FAFAFF
FFFFFFFFFFFFFFFFFF758D860005000337FFB9C6CC7180735F4B3C2E0C00042F3542586F
879FB4C1CBEAFFFFFCEEF3FFFFFFFFFFFFFFFFFFFFF7F9FFFFFCFBFFF5FAFFFFF9F6FFFF
FFFFFFFFFFF9FFFFF7FFFDFFFFFE4AA7FFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFD030000
00FFF3FFFFFFFFFFFFFFFFFFF8FFFFFADD1FFBFFFFF4F9FFFFFFF0F3F0F9FAF3FFF9FFF6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC5FFF5FFF2FFFFF8FFFFFFFF
FFFFFFFFFFF9F9F8FFFFFFFFFFF3FFFFFFFFFEF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFDFFFFFFFFFDFFFFFCFFFFF5E8FFFFFFFFFBF9FDFCFFFFF6F2FC
FFFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFFFEFEFF
FFF8F9FFFFF8F7FFF6FFF7FFFFFAFFFBFFFFFFEFFFFFFFF8FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF4FFFFFFF4FFFFFFFAFFFFF8FFEC
FFFFE0B8A37C6F333C0025403C8C7689B6C3E8FBFFFFF8F5FFECF5FFFDF7FFFFEC9AFFFF
F3FFFDF7FBFCFEFEFEFDFBFAFCFAF9FCFFFFFFFDFEFEFEFEFEFEFEFEFEFF4489F2FFF8FF
F7B43EFFF1FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF9FCF3FFF7FFFAFFFF
F6858CF5FEFFFFF7FFFDFFC70D34FBF6FCFDFFFDFFFFFFFFFFFFFFFFF7FFF3FCF9FFFCFF
FFFFFFFFFFFFFFFFF439CAF7E93B100042F9FAF0FFFFFFFFFFFFFFF7FFFFF6CEC6BCAA8F
7258453C3B140000284D53487C7284AEC8CCDFFDF8FFFFFAF8FFFFF1FFFFFEFFFFFFF5F1
F6FFF3F4FDFFFFF7FFF7FFF0F5FF3BD2FEFEFEFEFEFFFFFFFFFFFFFFFFFFFFFF00FFFCFF
F200FAFFFFFFFFFFFFFFFFFFF9FFF4FFFE00FFFAFFF8FFFFEEFBFFFFFFFFFDFFFBFCF3FF
FFFFFFFFFFFFFFFFF6FFFAFEFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FCF6FFF2FFFFFCFFFFFFFF
FFFFFFFFF2FFFFFFF9FFFFEFF1FFFBFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFE7FBFFFFFEEEFEF8FFFFFCFFF9F4FFFFFF
FBFFFCEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFFFFFFFFFF
FFFFFFFFFCFAFFFFFFF7FFF5F5FFF8FFFCFFFFFFFFEEFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFFEDF8FFFFFFFFFFEBB5AD8C4D59
17032C447286A4D0EDFFFBFCFFFFFFFFFFFDFFFAFAFFFDFFFDFFFFFCFBFFFFFAD699FFF7
FCFFFFFFFFFFFFFFFFFFFEFEFFFFFFFFF7F6FFFFFFFFFFFFFFFFFFFFF4FFEEFFFFFDF5FF
FDFB12FFF3FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FDFFFFFDFFF8FFFEFFFEF7
FFE4E7FFFDFEFFFFF8FFECFF8BECFFFFFCFFF8FDFFFFFFFFFFFFFFFFFFF8FFFDFFFFFDF7
FFFFFFFFFFFFFFFFFA00FFFFEFFFA7275CFEFFFFF9F9F3FBFDF6FBFFFFF7F5FFFBFBFCFF
FFFFFFFFF7FFFFF6D8BEB2B2808A784D332E1C00002234324B7A8B7CBBB3BCD9F5FFFFFF
FFFFFFFFFFCEE3FFFFFFFFFAFFFF3FB7FEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FDFFEF
FF0FEFFFFFFFFFFFFFFFFFFFFDFFF6FFFD00FFFBFFFCFFFFFFFCFFEEF8FFF9E5FFFFFFFD
FFFFFFFFFFFFFFFFF2B7DFFEF8FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFBFFFFEFFFFFFFFFFF
FFFFFFFFFFFFFFEFFFF208040DF1FFFAFFF0FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFBFCFFFFF5FFFFF8F7FFFEFFFFFFFAF8FFFFFDFFFAF5FF
FFFCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF9FEFFFDFDFF
F9FBFEFFFFFFFDFDFFFFFFFFFFFEFFFBFFFDFAFFFAFFF8FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBCA28C42310A1B516181B2B3
F0FBFFF8FFF9FFFCFFFAFFFFFEFFFEFAFFFBFFFFFFFFF8FBFCFFFDFBFFFFFBFFFAFFFFFD
FFF7FDFFFFFFFEFEFFFFFFFFF9FAFEFFFFFFFEFAFFFFFFFFFFFFFFFFFFEDFFFEFCF8FFFF
FDFF3DAFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF5FBFF00FDF9FFFFFF
FFFFF9FEFDFFF5FFFFF0FFF0F8FFECFFFFF9FFFFFFFFFFFFFFFFFFFFFD00FFFBF5FFF9FF
FFFFFFFFFFFFFFFF966AFCF6FFFFF0F4C7FAF1FFF9FFFFF5FEFFFFFCFAFEFFFFFFFFFEFE
FFFFFCF9FFFFFFFEFDFDFFFFFCFDFFFFFFFFFFFFFFDDCACAB183738349443A2303001236
4242687D853F77BCCCFFF1FFFFF25FA6FFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFF08F8FFFF
ED09FBFFFFFFFFFFFFFFFFFFFFFCFFFBDD28F3FFFDFFFFFFFFF6FFFDFFF6FFFFFAF3FEFF
FFFFFFFFFFFFFFFFFF88DBFFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF42FDFFF9FEFFFDFBFFFFFFFF
FFFFFFFFF5FFFFFFFE00FFFFFF00FFF8FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFDFFFFFEF9F9FEFFFAFBFCFD
FDFFFFFFFEFFFFFAFFFFFFFBFFFFFEFFF7D9A9835C371314376795B1E2F3FFFFFCFDFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF3
FFFFFEF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFFFEF7FAFFFFF2FFFFFFFFF3FD
FFCE6C6BF7FFFFFFFFFFFFFFFFFFFFFFF9FFFEF7FFFFFAFFFFFDFFF3FF0BF5FBFEFAFFFF
FFFFFEFFFFFDFFFFF7FFF3FFFFFFF9F7F4FFFFF9FFFEFEFCFAFFFFFCFBF50BFFF3FFFDFF
FBFFFEFFFDFCFFFC52ACFFFDFFFFF3FFF9FDFFFFFEF8FAFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFEE6CA
BECA7E81891A2244310000004143688EF7FFFBFAFFFFECFFFFFFFFFFFFFFFFFF0107F7FF
F903F9FCFFFFFFFFFFFFFFFFFDFFF4FFBF3EFDFFFCFFF7FFFCF7FFF8FAFFF4FDFFFFEEFF
FFFFFFFFFFFFFFFFF9FFFAFFFEF4FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00F1F4FDFFFFFCFFFFFFFFFF
FFFFFFFFFFFFFCFEF424EDF8FDFFF2F8F2FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFCFFFFFFFDFFFFFAFCFFFFFFFAFFFFFFFF
FFFFFCF6FEF2FCFFF8F5F4E4A37D45180F2E6188AECBF4FFFFFAF7FDF4FEFFFFFCFDFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDDA0FDF9
FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFAFFFFFFFFFDEDFF692F45141701
01016015FFFDFCF9FFFFFFFFFFFFFFFFF7FFF7FD06F5FFFDFDFAFFFF00F6FFFF0AFFF4FF
FFFD00FEFB0600EE00FF030000F6FF00FFFE00FFF800FFFF0200E404FFFFF600FFFFFAFD
FFFFFAFFFFFEF9EE17FFF9FFEFFCFFF9FDFDFBF9FEFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCFFFFFFF6
F4FFFFFFF85FA0FFFFFFFFFAC0AD9B67FFFBFFFDFAFFFAFFFFFFFFFFFFFFFFFF00FF0100
09FFEDFFFFFFFFFFFFFFFFFFFEFDFFF3BD48FCFFFAFFFFF6F7FFFFFFF8F0FFFFECFFFFFF
FFFFFFFFFFFFFFFFFFEFFAFFFFF9FEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF02FFFFFFF9FCFDFFFFFFFFFF
FFFFFFFFEFFFF3F7FF000E02000EFFF2FFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFAF7FEFFF7FEFFFFFCFBFFFFFFFBF5F7
FEFFFFFFFFFBC79A7B41151C5B86C2F1FFFFF8F3F8FBFEFDF7F6FFFFFFFFFFFFFCFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC941FEFF
FCFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8FAFCFAF7FFCC00070A0001
0D0FFF5B8EFFFFFFFFFFFFFFFFFFFFFFFCF9FFFF00FFF9FCFBFFFFF208FFFEF700FFFFF0
FFF20AF900FFFF020C00FEFFF70FF200FFFC01FFFF01FF04ECFF1406F7FEFF08F2FFFFFB
FFFDFEFEFFFEFF9073F3FBFFFFFCFFFFFFFFFFFCFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFAFFFFFF
FFFAFFFBFE93B6F2FFEFF8FFEFFFE227FFF5FFFFFBFFFFFCFFFFFFFFFFFFFFFF03FFF7FF
ECFFFFE7FFFFFFFFFFFFFFFFF8FFFFFB6894FFFFFFF8FAFBFFFFEDFDFFFFFFEFFFFFF0FF
FFFFFFFFFFFFFFFFFEA6E1F7FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00EAFEFFFFFFFDF3FFFFFFFF
FFFFFFFFFFFFF9FFFE00FFFFFF00FFFCEEFCFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF5F8FFFFFFFFFFFEFCFFFFFFFEF4FEFFFFFF
E2B37E5C170D38708FC6FFFFFFFDF8F5F7FDFFFFFFFEF9FFFFFFFDF1FFFFFDFBFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF29FEFF
FFFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FF5F07000000
00C6FBDB24F7F1FDFFFFFFFFFFFFFFFFFFF7FFF114FFEAFFFFF8FAFF00FEFFFF00FFF7FF
FFFF00FF06F5FFFF03FFFFF007F9FA09FCF700FDFF07F300FFF9FF00FFFFFE00FFFAF8FF
FCFFFFF6FFFDF126A3838B7D7E73789FF9FFFFFFFFFDFDFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFBFCFDFB
F2F9FDF7F9FFFEFFFFF9FFFAFDFFF827D3FFF6FFFFFFFDFFFFFFFFFFFFFFFFFF06FFF3FF
FFF2F9FFFFFFFFFFFFFFFFFFFFFBFDFF10EDFCFFFEFDFFFFFAF4FFFF000805FFF2FFFFEF
FFFFFFFFFFFFFFFFFB52C1F7FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0FFFFF4FBF9FFFFFFFFFFFF
FFFFFFFFE9FBFFF9FA05FFF6FF01FFFFFFF7FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFDF6F2F6FFFFB991572A
234880AAECFFFEF4FFFFF1FCFFFFFFFFFFFFFCF4FFFFFCF8F8FCFFFFFDFBFAFDFFFFFFFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBC58F6FB
FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F4FFFFFFF9F7FFF2F38500060C00
5EF3FFF96AB8F3FFFFFFFFFFFFFFFFFFFDFDFFFB00FFFFFFFFF8FAFF00FEFFFF08000B00
F5FD00F2FF00040000FB000AFFF7FF00FFFF0CFAFF07FFFF00020009FFFFFE00FFFAF8FF
FEFFFFFAFFFB9445010D0000000C0C94FFF8F9FFFFF9FBFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFFFFFE
FFFFFFFDF9FFFEF8F1F9FFFFFFF5FF896BFFFBFDFFFFF6FFFFFFFFFFFFFFFFFF00FCFFFF
FF00FFFFFFFFFFFFFFFFFFFFFFEFFFBF39FFF2FFFDFFF6FCFFFFEE00FCFDF800FFF7F6FF
FFFFFFFFFFFFFFFFFF30B5FFFFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2F3F6FFFDFCFFFFFFFFFF
FFFFFFFFFFFCFCFFF9FF000803FBFCF1FEFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F7FBFEFFFEFCFAF7FEFDE7B46F2E064A70A9DB
F8FFFFFFFAF7FFFFF4FFFFF4FBFFFFFFFDFDFFFFF3FCFFFFFFFFFCF9FFFEFEFFFFFFFCFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD8B2FAF9
FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFCFAFAFFFFF6D83F2B7A000021
F7FFFFF2E31BF3F7FFFFFFFFFFFFFFFFF9FFFFFF00FFFFF2FBFFFFF208FFFEF700FFFFF9
00FF00FF03FEFFFF1200F6F9FF00FF0C00EC00FFFF00FF00FFFFFC00F7FEFF08F2FFFFFB
FFFDFBFFFFD746CE5D00001000001AF7FFFFFAFEFFFEFCFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFFFF
FFE8FEFFFFD2DFFFFEFFF4FFFFFFFEDD34E0FFFFFCFFF9FFFFFFFFFFFFFFFFFFFF020000
00FDFFF7FFFFFFFFFFFFFFFFFEF9FF4CAEFFFFFDF6FFFFFFF1FFFF01FFFFFFF6FFF2FFFF
FFFFFFFFFFFFFFFFFF4DBCFFFBFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFFBFFF9FFFFFFFFFFFF
FFFFFFFFFDFCFFF4FEFFFAFAFEFBFFFFFFF4FAF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FCFFFFEAD07D4C1A1A509AD2ECFFFFFFFF
FFFFFEFFFEFFFFF5FFFFFCFFFBFFFFFFFAF7FAFFFFFFFCF7FBFFFFFFFFFFFFFFFFFCFBFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF5FFFF
FFFFFAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFFFFFF9E26406A3FDF8300E9F
F7FFFBFCFF8C63FFFFFFFFFFFFFFFFFFFFFBF7EB0DF5FAFFFDFAFFFF00F6FFFF00FFDEFF
07FC00F4F6000002ECFF000500FFFC00FF14040000FFFFFD000500FFFFFFF600FFFFFAFD
FFF7FFFFEF8282FFFE310700030856FEF0FFFFFFFDFFFFF9FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFCFCFCFC
FFFEFFFFE799B4F7FEFFFFFFFAF6FFFF817FF7FFF9FFFFFEFFFFFFFFFFFFFFFFFFEFFFFF
FBFFEDFFFFFFFFFFFFFFFFFFF4FFB658F0FFFFF4FFFBF5FFFFFBFC000000090BF1FFFFF9
FFFFFFFFFFFFFFFFF7A2DAFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF43F0FFFFF9FFFFF4FFFFFFFF
FFFFFFFFFFFCFDF8FFFAFFFFFFFFF6FCFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFCE7D3D282D82B0E8FFFFFAFDFFFFFFFEFE
FFFFFFFFFEF7FEFFFFF9FCFFFFFEFDFFFFFFFFFFFAFFFFFDFAFEFFFFFFFDFDFFFEF9FCFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFF
F5FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFDF8FFF08A1976E9FFFFF9BD54FF
FFFCFFF8FCF13DCDFFFFFFFFFFFFFFFFFCFBFFFF00FFF9FFFFFDFFF3FF0BF5FB05F0FFFF
00F909FFFBFFFDF1FFFCFFF9FFFBFDFFFDE2FFF6FFF9F2FFEEFFFFF9FBF50BFFF3FFFDFF
FFF6FFF6D532FEF5F8E01D0000163924A5E1FFFFF4FFFFFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFFFFFFFFFFFF
FCFFE9FFFFFFF8FFFFF4FFF2FFFBFFF7F92BD7FFFFFCFFFEFFFFFFFFFFFFFFFFFAFFFFF1
FFF7FFFAFFFFFFFFFFFFFFFFFFF238CEF9FFF0FFFFFFFFF6FFFFF906FFFFFF00FFFFFCFF
FFFFFFFFFFFFFFFFFFFAFFFEFEFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC5F9FFFDFFFCFFFBFFFFFFFF
FFFFFFFFF4FFFFFBFFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFEFEFEFB
FFFDFBFFFFF8F8FFFDFDFEFFFFF8EADF8C521C236AC0F7FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE490FFFE
FFFFFFFEFFFFFFFFFFFFFFFFFFFCFBFBFFFFFFFDFFF8FFFFAB2F53D2FFFDFFFFFFF7F8FF
FFFAFFF6FFFFA556FFFCFCFFF3FFF1FFFFF902FF00FEFFF9FFF9FFF5FBFF00FD05001200
F4FC00FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF809FFF5FDFFF7FF
FEFFF8FB4AB8FFFCFFF7BC0A0077FFB63E3279E7FFFCFBFFFAFFFDFAFFFFF7FFFFFDFDFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFEFFFFFCFBFFFFFFFFFFFFFFFFFFFDBD45F9FFECFFFDFEFEFFFFF4FEFFFEFFFFFFF8
F9FFFFFCF7FFFFFDFFFAFDFEFF7C85FAFFF7FFFAF6FFF0FFFAFFF10DFEF6FF00F9FFFFFB
FFFFFFFFFFFFFFFFFFFBF9FCFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF8FFFFFFEFFAFFFFFFFFFF
FFFFFFFFFFFFF9F6FAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF8FBFFFFFEF9
F1FDFFFBFBFFFFFFFFFFFCD89C5C2B1277A9E7FFFFFCF3F2FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD8BAF6F9
FEFFFDFDFFFFFFFFFFFFFFFFEBFFFFFFFFFCFFFFF7FFD64826A9FFFFFFFEF9F8FDFFFFFF
FFFDFFFFEAFFFF4C9AF8FFFFF7FDFFF2FEFFFF0008FFFBFFF7FDFFFFFDFFF8FFF4EFF8FC
FFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFF1FCFFF8
F7FFFF9C5FFBF9FCFFF9FF991BE6E6FFF9CB571E75E0FFFFFFECFCFFFFFEFFFFFFFFFFFD
F5F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFF9F6FFDEEFF8FFFFFFFFFFFFFFFFF6FFAF55FFFFFFFFFEFBFEFFFFFFFFF8F6FBFFFF
FFFFFFFDFFFFFFFCF9FFF3FF9752FFFFDCFFEFFFFFFFEFFFFFFBFFF1040000FFFCEAFFFB
FFFFFFFFFFFFFFFFFE9DE6FFF7FFFAFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFDFFFFF8FFFFFFFF
FFFFFFFFFFFBFAFFFFF2FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF8FFFFF7FBFF
FFFFFFFFFAFFFFFAC37C2F1F56A8E6FFFFFDF9F9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FBFEFF
FCFFFBFFFFFFFFFFFFFFFFFFFFEAFFFEF2FFFBEDF1861C77FDFFFFF9F5FFFFFFFFFBF7F2
FFF0FFFFFCFFC12D44E6F4F5FFFAFFF9EFFFFFF711FCF7FFFFFCFFF9FCF3FFF7FFFFFFFE
FEF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFAF8FF
FFEEE244D4FFF6FFFCFFFFF9A3FFFBFFFFFFFED25F155DD9FBFFFFF3F4FCFAF5EEF8FEFE
FFFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF5FFFFFB5A9AFFFFFFFFFFFFFFFFFFFFFFF17E7FEAFFEFFFFFFEFFFFF8F2FDFFFFFFFF
FDF8F8FBFFEFFFFFFBF3FFAB56FFF3F5FFEDFFFFF8FEFFFFFFFFF3FFFFFFFCFCFFFFFFF9
FFFFFFFFFFFFFFFFFD99E6FFEFFFF7FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF49F1FFFFF7FFFFF7FFFFFFFF
FFFFFFFFFFFCFCFFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCFEFFFFF3
FFEDEAFEFDC05D143878C9FBFFFBFAFFFFFFFFFFFFFCF8F5FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFF
F8FFFCFFFFFFFFFFFFFFFFFFFEFFFAFFFFF8FEC20C4FE7FFF7FFF9FDFFFFFFFEFCFFFFFF
FDFFFEF8EC5808B3C63CF5F8FFFFF6FFFFF9FEFFF0FFECFFFFFAFAF7FFFFDFFFFFE9F8FA
FFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFDFEFFF8FFF5
FFED45CEF6FFF9FFFFFFECFFFFF6FFF4FBF1FFFFFFE589134FC5FFFFFFFFFEFFFFFFFEFC
FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFEFF56A2FBFFFFFFFFFFFFFFFFF6FFFFEE7562ECFFF9FFFBEAFBFFFFFFFFFDFDFF
FFFCFFFFF7FFFCFAFFFF7954E5FDFFF9EEFFFFF5FBFFFFEBFBFFF5F9F6FFFFFFFBFFE7FF
FFFFFFFFFFFFFFFFFDFFFAFCFCFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF5FFFFFAFCFFFFFFFFFF
FFFFFFFFFBFFFFEBFBFFF5F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FCFFFEF6F3FCFF
FBF3B0420B3D9FE2F2F7FCFEFDFDFFFFF9FFFFFFFBF8FDFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE596FFFF
F4FDFCFFFFFFFFFFFFFFFFFFE8FFFFF2FFCE322AD4FFF5F9FFFBFFFFFFFAF3FCFFFFFBFB
EBFFF682146FFFF3FFAC4CFFF7E9FFF9FFFBFFE5FFFFFFF9F3FFF4FFF8FFFFFFFCFFFFFF
FBF6FFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFF9FFF7FF
E25CB5FAFFFEFBFFFFFFFBFFF7FFEDFFFFFFF4EAFFFFEDEB892534B5FFFFFBFDFAF9FEFF
FCF2F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFFFFF4FF64ADF4FFFFFFFFFFFFFFFFFFFFF5FFFFB127CEF8FFFFFFFFF8EEFBFFFFFFFF
FFFEFBFDFFFEF2FDE24780FBFFFFF7F8FFF9F4FFFFFCFCFFFDFBFFFFFFFEFFF5FFF5FFF3
FFFFFFFFFFFFFFFFFDFFF9F9FFF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF4FFF8FFFFFFFFFFFFFF
FFFFFFFFF8FEFFFFFFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFF9FFFFEC9F
401F45B7FFFBEFFFFFFFFFFFFFFDFAF9FFFAF4F8FFFFFFF8FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF43FCFF
FCFFFBFFFFFFFFFFFFFFFFFFFFFBF3EC6B1490FFFFE2FFFFF7FFFAFFFDFDFFFFFFFFFFFF
FFB12848E0FFEBFFFFFF9B5BF9FFFFFDEBFFF6FFFDE2FFFAFFFFFFFFF4F2FFF0ECFFF9F2
FFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE5FFFAFFFFFAF5
6D9AF7FFFBF2FFFFFFFBFFFFF7FFECFFF3FFFFFFFFFFFFFFFFF7A32F2CA5FCF9FFFFFDFF
FFFFFAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFF7EB6FEFFFFFFFFFFFFFFFFFEFFFFF8FFF4E22E5CC1FFFFF5FFFFFFFDFDF9F6
F9FFFFFFFDFAEA8120ADFDFDFBFFF5FFFFF9FFFDFFFBFAFFFFF2FFF0FFF5F7F2FFFFE7FF
FFFFFFFFFFFFFFFFFCA1DBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00F2FFFFF6F8FFFFFFFFFFFF
FFFFFFFFFFFFEFFFFFFBFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F8FAB0422147
B7EEFFF5E8FCFFFFFFFFFCFAFAFDFFFFFBFFFFFFFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBB3CFFFF
FFFFFAFFFFFFFFFFFFFFFFFFFFFA8B186DF2FDF6FDFFFBF7FFF4FEFFFFFFFFFAFCFFFBE6
3F2AAEFEF5FFFFFCFFEFFF7582FFFDFDFFFBFDFEF4FFFFFAFFF6FFFAFFFFF1FFFFEFFFFE
FFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9FF71
7FF8FFFFF0FFF0FFFDFFFFF5FFF7FFF9FFEDF7FFF4F8FFF7FFFEF8F6B63D3097F0FCFFFB
FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFCF4FFFBFFFAFFFFFFFFFFFFFFFFFFFFEAFFECFEFFFA9B4641A9FBFEF2F8FFFFFFFD
FFFFFFF4C95B227FFFFFFFFFFFFEF6FFFBFBFFF1FFFFF9F6FAFFFFFDFFFFFFFFF9FBFFF1
FFFFFFFFFFFFFFFFFE42C5FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBEFEFCF5FFFFF6FFFFFFFFFF
FFFFFFFFF6FFF0FFFAFFF10DFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9D3751E309AEBFA
FDFBFEFFFFFFFBF8FEFEFFFFFFFFFFFFFDFDFEFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBE4CFAFD
F8FFF7FFFFFFFFFFFFFFFFFFB43041D0FFF7FFFFFFF7FDFBFFFFFFF7FDFFFDFAFFF0850F
83EBFFFFFFF7FFFFFFFFF7FF6981FAFFFFFFFCFFFFFAFAFFFCFAFAFFF9FFF6FEFAFCFFFE
FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFCFCFE856C
FFFFFCF8FFFFFFF5FBFFFFFFFFF7FFFEFBFFFFFAFFFFFAFFFDFFFFFDF9F9B74F1C88EDFF
FAFBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFBF6FFFFFDFBFFFFFFFFFFFFFFFFFFFFF3FFF7FFFFF8FFFFF5B94F0F3B7C89AFBEBFAB
967945133BA4F9FFF6FEFAFFFEFFFFF8FCFFF8FFF4FFFFFBFFFFF3FFFFF8FFFCFFF0FEFF
FFFFFFFFFFFFFFFFFF3CC3FEFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFF0FFFFFFFFFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFCFFFFFDFDFFF5F7FBFFFFF2FFEE9D282764CFFFFDF6FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDCA2FEF6
FDFFFFF8FBFFF5FFFFFFDE51249FFFFFF9FFFFF7FFFFFFFEFFFFF3FEFFF7FFFFA52A54D8
FFFFFFFFFFFFFFFFFFF1FFFFEC7F4CF4FFFFFBFFFDFCFFF1F7FFFFFDFAFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFEAFFFEFF446FFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD05F1868
E7FFF3FFFCFFFFFFFEFAFDFFFFFFF9F9FFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFBFBFFC9EAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF6FFFFFCC47E7B35103D42
7F86A1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FDFFF7F6FFFCFFFFFFFBFFF7FAFF
FFFFFFFFFFFFFFFFFF42B5FFFFFCFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFFFFFFF8FBFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FEFFF5FFFFFFF2F6F479163BB8E9FFFFF8FEFFF7
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFF
FFFDFDFFFFEEFFFDE67B0589F4FEFFFCFAFFFFFEEFFFF7F6FCF7FFFFFFFFD0482BADFFFF
FFFFFFFFFFFFFFFFF5FFFFFCFCFAB52BC9FFFFFBFFF5F6FFFFFFF6FEFFFFFEFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFEF5FFFFFCF6F9FFF4CB30BCFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F7DD6A
0F67EBFEFFF7FAFFFFFFFFEEFEF0FFFFE9FCFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDF4FDFFEF95BAF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FDFFFDFD9775FBFE
F8FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDF3FFFFFFFFFEEAFFF4FFFFFFF4
FFFFFFFFFFFFFFFFFF9AD9FFF8FDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF46E3F8FFF6F8FFFFFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFFFEFCFAFEF7CF5A0559E2FFF5FFFFFFF6FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFF
EDFAFFF0F9FFF7AA1F4EFDF5FFFCFAFFFFFCF8FCFFEDFFFFF4FFFFF1FD861779FFFFFFF8
FFFFFFFFFFFFFFFFFFFFF0FFFFF6FFE02D76F9FFEEFFFFFEF5FEFFFAFAFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFEFFFFFFFFF9F8A935DEEDFFF9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FF
EE5D105CD0FCFFFAFFF8F6FFFFF0F0FFFFFBFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBF5FEFFFCFFFFA34EFFFF
FFEFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF9FFFEF2F912FEF9FFFFF3FAFF
FFFFFFFFFFFFFFFFFFF8FFFFF6FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBBFFFFFFF2FFFFF9FFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFEAFFFFE8FFFFC43F1B8DF5FFF6F4FFF2ECFAFFFFFDFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCDADFFF7
FFFFF5FFFFD74032C0FEF4FFF4FFFFFEF8FBFFFFF8FDF4FFFDF6FCAF0750EBFFF2FBF6FE
FFFFFFFFFFFFFFFFF2FFFEF6FFF89224022668FFFFE5FBFFFBFFFFFFFBFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7FFFEF6F8FAFF5764E5FFFFFFFB
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFF
F9FFF0921A50BFFFFFFFFFF2F0FFFFF5FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFFF4F1FAFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFF9FDFA9A68FBFF
EEFFF9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFFF7FEFFFF00FFFAFFF6FFFFF5
FFFFFFFFFFFFFFFFFFF2FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAF7FFFFEFF7FFFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAFFFFF8FFFFC03714A2F1F2FFFFFAFFFEFFFFFFFEFFFFF9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEC9AF8FB
F9FDFDE767208BEFFFFFF6FFFFFFFFF7F9FFFFFAFFFFFFF4FFDE4124C6FFFDF3FFF9FFFF
FFFFFFFFFFFFFFFFFFFFFFD76819040305DD932398FFF9FFFFF9F4FFFFFDFAFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FCFFFFFFFFF3AC2801B8FFEFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFEE
F8FFFAF9FF961E2AA9F7FCFFFFFAF4FAFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF1F7FFFFD7E9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECFFFFF9FEFFFFF9A251F7FA
FFF9F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FEFFFEFEFF00FF01FFFFFBF0FFFF
FFFFFFFFFFFFFFFFF4ABE0EEFFFCFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBF9FFFFFFFAFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFD2520BAAFFF6FFFFFFFCFFF6F4FFFFFAF8FFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF7FFFF
FFFFAA1265DAFFFFFFF0FFFFF4F5FAFFFFFFFDF8FFF6F7EE62088BFFFCE4FFFFF5FFFFF8
FFFFFFFFFFFFFFFFFFD347070500060011FFFFE6591EA5F9F6FFFFFAF8FFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF7FF932F4DDCDD0EB9FFFDF6FD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFAFF
FFFFFAFFFEFEFCB2392B9FFFFEFFFCFAFFFCEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFE96198F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FBFDF5FFA75EFFF7
FFFDFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE4FFF3FFFFE818FB00FEF8F5FFFCFF
FFFFFFFFFFFFFFFFFFA6E3F5FFFBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3DF4FFFFF8FFFFF7FFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF6F86D0A96FFF3F3FFFEF7FDFFFFFDFFFEF8FFFFFFFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FA
BC2C2EE1FFFFF9FCFFFFFFFFFFFFFFFFFBF5FDFFF7FFA1286FE8F6FFFFFFF7F8FFFBFFFE
FFFFFFFFFFFFFFFFFCED62000000000B68FFF5F6FFD86538BCE8FFFFFCFFFFF4FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F5FFB72452E5FFFFFCB215D0FBFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE
EEFEFFF5FFFFFFFFF8B44D0E8CEDFFF5F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFF1F5FF6CABF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF3FFFFF48A000000030A00
0EEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEAFFE0FFFF00FB02FFFDFEFFF9F5
FFFFFFFFFFFFFFFFFFE5FEFFFFFDFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFAFFF2FFFFFFFFFFFFFF
FFFFFFFFFFFEFFFFFDFFFC01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFAE2564E5F8FFFDFFFFFFFFFEF9F9FFF9FFFFFDFCFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD3AAE15F
2BA2FFF2F9FCFFFFFCFFFFFCFAFDFDFBFDFFFFFCC63C35BDFFFBFFFFFFF3FDFFFFFFFAFF
FFFFFFFFFFFFFFFFFBFFFF700009000096FFFBFFF8FFF0D4444886E6FFF8F1FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF096304ED4FFFCFDF9FFFFB41EC3FFFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFCFE
FFFFFCFFFDFFFFFCFEFFF9D64E1B70F4FFFAFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFAFDFF4EA3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFF5FFCC1A0102000100
9DFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFFFFFFFF00FFFDFB00FFFFFFFFFF
FFFFFFFFFFFFFFFFF3FFFFFBF7FBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01FFF6FEFCF5FFFBFFFFFFFF
FFFFFFFFFEFFFDFFFEFFFFFFFAF8FFFFF8FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FFFFFFFEFFFFFFFFFFFFF8FCFFFFF8FAFCFEFFFFFEFBFAFFF8FAFF
FFFBFAFFFBFCFFFFFBFFFFFF791AA9FFEAFFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFF8FFFFF0FFFFFEFFFDFEFFFFFDFCFBFFFFFFFFFBFAFFFAFFFDF7FFFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF6FCFFFFFFFEFEFFFFFFFDF9FCFF
FBFFFFF8F5FFFFF5FFF6FFFDF8FFFAFFFFFCFFFFFBF8FFFFFDFEFFFAFEFFFFFFB91C1280
EAFFFEFEFFF7FDFFFDF9FFFCFEFFF4FFFFFFE76E2191F5FFFBFFFFFDFFFFFFFFFFFFFFFF
FDFFFFF3FFFFEFFFFDFFF0B22102000ADFF4FFFFFAEFFFFE65565615298FC0FFFAFFFFFF
FBFBFBFFFCFFF3FFFCFFFFFAFDFFF7F7FFCA74330E1FB4FFF9FCF7FFFFF5FFFF9923E2F8
F8FFFEFFFFF9FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFD9621964E2FFFAFDFFFFFBFFFEF9FFFFFFFEFFFFFFFFFF
FFF5FFFFF38FB8FAFFFFFFFFFFFFFFFFFFFBFFFFFCFFFFFFFFF2FCFFFDFF6C0201000011
FCFFFDFAFFF6FFFFF9FAFFFDFFFFFFFFFFFFFFFFFFF9FFF5FBFF00FDFFFA00FFFAFAFFEC
FFFFFFFFFFFFFFFFFD99DDFAFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00F4FFFEFFFFF7FDFFFFFFFF
FFFFFFFFFFFCF7FFFFF4F3FEFFFFFAF6FFECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFBF8FAFCFCF3F2FCFFFFFAF7FFFFFFFFFDFCFEFFFFFFFFFFF1
F4FFFFF7FFFAFDFFFFF3E23248F0FFF6FFFFF4FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFBF5FFFFFFFDF7FFFDFFFFF6FDFFFFFFFFF6F1FAFFFFFFFFFFFFFFFFF6F7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFEF6F8FFFFF9F9FFFFF7
FEFDF8FFFFFFF5FFEFFFFFFFFFF9FFF3FBFFFCF4FFFFFCF6FFFFFFFFFFFFF0A71C20D0FF
FFF8FFFFFFFDF3F6FFFFFFFFFEF7FFF1EDA01567EFFFFFFAF8FFFFFFFFFFFFFFFFFFFFFF
FAFEF7FFF9F8FFFFFFFCE21EC3CA0A1BFCFFF1F1F5FFF28D33DDFFFCD87A35146699D6F8
FFFFC5BAFDF6F8FFF7F9FFFFFFAEAF71152E9BC4F904003A99FFE9FFF3FBF9FFFF8B1DE9
FFFFF9FEE3FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FAFFDE711855DBFFF1FDFFF5FFFFF8FDFFFFF6F7FFFDED
FBFFF4FBFFFFFFFFFFFFFFFFFFFFFFFFFBFFFCF5FFFFF9F3F9FFFFE8FFFFDE0C03100094
F6F8FFFFFFFEF9F7F9FFFFFEFFFFFFFFFFFFFFFFF7FDFFFFFDFFF8FFFBFFF8FFFAFCFFFF
FFFFFFFFFFFFFFFFFD55C6FCFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCBFFFAFEFFFFECFFFFFFFFFF
FFFFFFFFFCFFFFDBFFFFFFFDE7FCFFFFFCFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFCFDFFFFFFFFFFFFF7FFFFFFFFFFFFFFFFFEFEFEFDFDFDF9FFFF
FFF9F8FFFFFFFCF6FFD12485EDFFECFFFFEAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF7F4FDFDFFEFFFFFF9FFFBEEFFF7F0FFFFFAF7FFF8FFF6F6FAFAFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFECFFECFFFDFFFFFFFEF9FAFFFAD7B3
B28285A6AEC3ECFFFFFFEEF0FFFFEEFFFFF5FFFFFFF4FDFFFFEFF5FFFFD5522E7E4DFAFF
FFF9FFF7EFFFFFF8FEFFF4F7FCFEFECE302EE0FFFFFEFDFFFFFFFCFCFFFFFFFFFFFFFFFF
FFFFFAFFF6FEFFF5FBEA0DA7FFECE87EFAFFF2FFFFFEBB21CBFFF8FFFFF6FFE39F643100
273D0F1B838390866E51322007005190EAFAE6FFF23800000B0683C7FFFFFEFFECFF8424
EBFFFFFFFFDFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF48F184DC2FFFEFFFFF6FDFAF9FFFFFFFAFFFF
F7FFFFFDF5F4FBFBFFFFFFFFFFFFFFFFFFF8FFFFFAECFCFFF9FFF2FFF5FFFF6D00001AFE
FBFFFFF5FFFBFFFFFFEEE7FFFFFFFFFFFFFFFFFFFFFCFFF9FCF3FFF7FFFAFFFCFFFFFAF5
FFFFFFFFFFFFFFFFFF2AB8FFFFFBFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFFE5FFFFFAFFFFFFFF
FFFFFFFFF5FFFFFFFAF4FDFFFFFFECFFFFF2FCF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFAFDFFFFFFFFFFF3FFFFFEF5F9FFFEFFFFFFFFFFFFFFFFFFF9F8FE
FFFFFEFFFEFBFFF3D017B0F6FFFCFFFDF9FFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEF5F8FFFFFDFFFFF6CBB59C7D92BCBED4FFF7E6FFFFFFFFFFFFFFFFF9FFFFF6FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF9F6FFFFFBE9B66221274F
517975594B3028478CEEF7FFF9FFFFFFFFFFFEF5FCFFFFF5F5FFFFFB701B89E6ED92F3FB
FFFAFFFFFFF9FEFFFDFFFFFFFFED5323A9FFFEF6FAFAFFFFFDF5FBFFFFFFFFFFFFFFFFFF
FFF9FFF4FEFFF3FFE92E87FFF1FFFFFFFFF5FFFFF3DE11B5FFF4FDFFFBFFFFFFFBFFF1FF
E2980702558B7A7088B4CEE0FF39C3FDF7FFFFF2FF8306050000000E6CFBFFFFFFFFEA7F
35E6FDF9FCFFECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFF8EEF6F68F2C37BBFFF3EFFFFFFFFCF3FBFFFFEB
FFF3F9FDFFD3EDFFFFFFFFFFFFFFFFFFF7FFFFFFFFFFFFEDFFE4FDFFFFFDFFDF100085FF
EFFFF9F4F4FFF9EDFEFFFFFFFFFFFFFFFFFFFFFFFFFAFAF7FFFFDFFFFFFFE2FFFFF7FFFF
FFFFFFFFFFFFFFFFFC4CBFFFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9FFFFFFFFFCFFFFFFFF
FFFFFFFFFFDFFFFFFCFBFFFDFBFCFFE9FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFEFFFFFFFBFBFFFFFFFAFAFFFFE3BD91887F8297BCE3FCFFFFFFFF
FFFFFDFAFAFFFBDA1BAEFFFFEEFDFFF6FFFFECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFF6FAFFD7A04F0A354C64846E45422B2A5BABE3FBFCEEF2FFFFFFFDFBFCF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFEFFFFEFFFCEF822B45A3EBFFFB
FFF5FFFFFFFFF0A86C0E6BDFF3FFFBFEFDFFFAF4FFFAEEFFFFFDA11A53EBFFFFFFEFFFFF
FFFFFFFFFBF5F9FFFFFFFFF77E1971E2FFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEEFFF4FFFAFFF84B66FFFFFFFBF2FFFBFFF5FFF41B97FFFFFEFFF9FFFFD9FFFDF9FFFF
F34107025DFFFFFDFEFFFCF7EC33DDFFFFFCEBF9FFBC02000A010A50FFFFFCFFFFF7FFFF
5B47ECFEF7FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFCFFF8F5FFFFFAFFFBA92C29B3FFF2F8F9FFFFFFFBFFFF
FBF8FFFFEB8EB7F3FFFFFFFFFFFFFFFFF8FFFCEEFFFFF5FFFFFFFFFEB4C380933610A4CC
E6FFFFFFFAFFFFFFFFFEF9FFFFFFFFFFFFFFFFFFF3FFF4FFF8FFFFFFFFFBFFF3FFFEFFFF
FFFFFFFFFFFFFFFFF5A8DAFFF2FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF44F5FFF6FFFFFFFCFFFFFFFF
FFFFFFFFF5FFEFFBFFFBFFF8FFF7F9FFECFDFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEFFFFFDFEFFFFFFFEFFF6BF6725203A70777E7A6747250F60B4F5F8
F1FFFFFFFDFFE41BB7FCFFF9FFF5F2FFFFFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFFE4661D6CADFFF3F9FFF2FDFFF9FFD2A05A2F80F0FFFFFFF4F9FFFCF8FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6EFFFF6F1FF801F7FE9FFFFF1F5FF
F4FFFFF4FFFCF6FFFFFBAD1870D5FFFFFFF0FFFFFFFFFFF2C14628C0FFF2F9F5FFFFFFF2
FBFFFFFCFFFFFFFCEFFFC02D55D1FFFFFCEAFFFFF2F8FEFFFFFFFFF5FFFFFFFFFFFFFFFF
FAFFFFF9FFFFFC5B51F6F8FFFDFFFFFDF8FDFFFB4173FFF8FFFFFAF0FBFFFFFEFFF3FFF5
CC090A0003C4FFFFFCFEF9FFFF23D8F7FEFFFFFFFBFF1001000061FFF3FFFEFFFDFFFFFA
FF6153F9FFFBF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF8F8FDFBFFFCF9FBB42C249DFBF9FEFFFEF5FBFF
FFFFF1FEFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFF2FFFFF3DC9A4C05484876726E4B582F
172978CDFEFFF7F4FDFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFF4F2FFF0FFF5FFEDFFFFFDF5
FFFFFFFFFFFFFFFFFFF7FEFFF0FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB7FFFFF8FFF6FAFFFFFFFFFF
FFFFFFFFFFFEFFF8FBF2070800F8FFFEFFFBFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFFFBFFFFFFF0FD95373E91E0FFFFFDFEFFFFFFFDFAF79D4134A2
FFFFF0FCFFF05F73FFFFEAFFEDFFFFFBFFF7F8FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFE45D129DFFF3FFF8FFFFFEFFFFF9FFF6FFFDFFF0672274EDFFFFFAFFFFF7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFFFFEBFF278CF9FDF7EEF7FFFFFF
FFF9FFFFFAFCFFFFFCFFE9FDA52DCAF9FFFFFFF8F6FFE0781298FFFFF8FFFEFFD3B4F6FB
FFFAF9FFF7FFF4FCF24E14B7FFFDF7F9FFFFFFF4FFFFFFFEF7F6FEFFFFFFFFFFFFFFFFFF
F9FFFFF8FFF49339F7FFFFFFF9F6FFFBFFF7FE534CFFF6FFFBFDFFFFF1F6FFF3F0FFF7FD
350000090065F5FFFFF9FEFFFF19EBFFF7F3FFFBFAFF4A0D006F29CAFAFFF2FFFFF4FFFE
F8F95346FEFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF4FFFFFFFFFFFFFFFDFDFFFFFFFFCA421C89ECFFFFFFFFF5
FBFFFFFFFBF6FDFFFFFFFFFFFFFFFFFFF8F7FFFFFEFFD975246CA9F6FFE9FFFFFFF9F1FF
FFCE7B394AA9FFFFFDFFFFF8FFFFFFFFFFFFFFFFFFF6FFFAFFFFF1FFF8FFF6FFFFF1FFFF
FFFFFFFFFFFFFFFFFFEAFFFFF9FFF7FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFFFFBFBFFF4FFFFFFFF
FFFFFFFFFEFEFFFFF807F9FDFF08F7FFFFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFFFBFFFFE8C11A70D2FFFFFFFFFFFDFEFFFFFFFEFCFBF8FFCE4F
38A3FDFFFFAA2DFFFCF5FFF7FFFDFAFEFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
CC20A0FFF2FFFFFAFFFDFFFFF8FAFFFFFFFEFFFAF9FFEC804BD4FFF9FEFFF8FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFEC530CAFBF8FEFFFFFFF9FAFF
FCFFFFFBFDFFFEFEF0FFFFFEFFE04796EDFFF5FAFF861868F0F7FCFFFEFCFFFEE19AFFF9
FFFFF9F9F9FFF980197AFDFCFFFFFFFFF9FDFEFFFFF8F9FFFFFFFFFFFFFFFFFFFFFFFFFF
FFF3FFFCFCBB1DD9F8FFF8FFFFFCFFFAFFF9943CF6FFFCFCFFFEF8FEFFFFFAFFFFF7FFAE
0C000D000002D5F5FFFCFDFFFA20E7FDFFFAFFFCFFF7A603BEFA9531F3F8FFF4FFF8F6FF
FFFFEC4E5EFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F8FFFAF3FFFDFFFAF8FFF9F9FFE159166FE1FFFDFF
FFF6FDF7FFD2EDFEFFFFFFFFFFFFFFFFF9FFEFF9FF6F1B95FAFAF9FFF2FFFFF5FAFFFFF9
FAFFFFF8BB4A45C1FFFFF3FFFFFFFFFFFFFFFFFFFCFAFAFFF9FFF6FEFFFEF2F8FFFEFFF6
FFFFFFFFFFFFFFFFF6A6E4F7FFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFDFFFFF6FEFFFFFFFFFF
FFFFFFFFFFF4F8FFF700FFF4F8FFFFF8FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF7F9FEFF724FE8F4FFFFFFFCFFFFFFFFFFFFFFFFFFFFF9FFFFFF
D45D65FEFE4DA9FFFFEDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFEFFF8E
4BD4FFF9FEFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC43DC7F2FFFFF6FFFFFFFFFF
FFFFFFFFFFF6FEFFFCFFFFFFF7FFF8FFF7FFFFF7FDFFFEBF32EDFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9FFFAF5FFE76A8FF7FFC82A41D6F8FFFFF1FCF8FFF7FBFEFFFFFF
FFFEF5FFFF9F3250D5FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFFFFFC
F3FFFFFFBD14D1FFFFF3FFF9F8FFFDFFFFB516D7FFFFF8FEFFFFFFFFFFFFFFFFF8FFFD2E
00040000000063E9FFF8FFFFFF00FFFEFFF7FFFFFCFDE3CDEFFFE48B39EEF8FFFFF4FFF7
FFECFFFE2D6BFFF7FFFCFFFFFDFBFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FBE4771A5CD8FF
F6FFE7FFFF639EFDFFF0FFF9F8FFEFFFFFFDFFD04C8AF3FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFAB244A3FFFFF5FEFFF6FAFFFFF6FFF9FFF3FEFFFFF7FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6A6E4F7FFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FF3FFF4F9F9FFFCFFFFFFFF
FFFFFFFFEEFFFFFFF20A00041000FFFFF9FFFFEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF8FFF8FFF04196F3F7FDFFFFFEFBFCFFFFFFFFFFFFFFFFFFFEFFF9F3
FFF29543E309F6F3FDFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2F3FF8068
EDFFFFFAFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD938D0F8F0FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFEFFFFFDEDFFFAF4F5FFFFFCD135FDE1FFF0FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF5FFFFEFF9FFE94CAF5B23A8FCFFFFFAFEFDFFFFFCF5FFFFFFFDEC
FFFFFFEB5539A9FFF1ECFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFFFDFFFDFA
FFFFEEE726B6F7FAFFFFFCF9FFEBFFFFC309C8FFFAF7F6FFFFFFFFFFFFFFFFFFFFFFFFFF
FFF16C97FFF5FFFFFBFAFFF8FF00FFFEFFF8FFFFFFFFFFFFFFFFFFF86658FFF6FFFFF3FF
FFF4FFF1F43282FFFDFEFFFEF6FFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0EEF375185B
D2FFFFFFFF5A9AFFFCFEF8FFFFFFFEFFFEEEC64CB9FEFFF9FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFAFFFFE4567AFCFDF8F5FFFFFFF9FFFFFAFFFFFFEDF4FFE9FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEAFFFFF9FFF7FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFF8FFF5FFFFFFFF
FFFFFFFFFFFAFAFFFF00FFFFF600FFFFFBF5FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF1FFFA28BAFFFFFFFFFFFFFDFCFEFFFFFFFFFFFFFFFFFFFBFFFFFD
F7FFFDB43748FCFFF9E7FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF1FFFFFFA157FF
FFFFF4F9FFFCF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEE536D9F8FFF0FFFFFFFF
FFFFFFFFFEFFFFFFFFFBF9FFFBFDFAFFFFFFF7FCFEF232D5FBFFF8FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF6FFFFFDF8FFFFFD55B0F1FFFFE7FFFFFEFFF6FEF1FBF8EC85FFFF
FFF683007AECFFF4FFFFEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFF7FBFFFFFF
FFFAEE3A86FCFFFDEDFFFFF3FEFFF7DF2E9AFFF1FFFBFFF4FFFFFFFFFFFFFFFFFCFFE6FF
FFFF57A7F4F7FFFBF5FFFFFAF806FFFFFFF9FFFEFFFAFBFFFFF8FEFFF34A57FFFBFFFFFB
FFFDFFFDFFF40E95FDFFF1FFF4FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6E8FFFFECFFF982
1C46BEF7F65FA7F4FFF7F8FFF7FAFFFAFFC92DD6FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF1FFFCFFF77768FFFFF4FFFFFFF6FFFBFFF1FBFFFFFFFA17FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF7FEFFF0FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFAFCFFFCFFFCFFFFFFFF
FFFFFFFFF5FFFBE8FF00F8FDFF03FEF2FFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEF942BEFFFFFAFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF
F1EFFFFF8224F9FFFBFFFAFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FBBC49FCFF
F2FFFFFFFDFBFCF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFE149DDFFF5FFFFFFFF
FFFFFFFFF7FFF9FEFFFBFDFFF1FFFFF5F0FFFBFFFF43B1FFFFFCF4FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFCFFFFFBF2FED316F9FFF6FFFFFEFFFDFCFFFFFFFFC15BF1FF
AE0F5BF1FFFCFAFEF9FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F8FFFEFCFE
F7FF4370FFFCFDFFFFF4FFFEF9FDEF3F7AFCFFFBFBFFFFFAFFFFFFFFFFFFFFFFFFFFFFF4
FBF761A0FFFFFFFFFFF9F7FFEF0EFFFFFFFBFFFEFFFFFDFAFFFFFEF2FFE94777FFFFEEFF
FEFFF6FFFFFCF31E92F5FFFFFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF8FFFFF9FF
FF8E3638AE8FBCFFFBFFFFF9F2FFFFF3D13BE2FFFCF4FFF6FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFE6FFFFFF6E7EF9FFF6F6FFFBFFFAFFF3FFFFFDFDFF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF5A8DAFFF2FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF18F0FFFEEFFFFFFEFFFFFFFF
FFFFFFFFFFFAFFFFF8FF000500FFEDFFF3FFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FE4FB8FCFDF4FFFFFDFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFCFEFF
FFFEFBF6FF9D60EEFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFEEA18F2FFE8
FFFFFFFFF9FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFA566E4FFFFFFFFFF
FFFFFFFFFCFFFAFFFFFFFFFCFFFFFEFFFFFFF8FCA253FFF6FFFFFCF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF8FFFFF5F8FFFEFEFFFF956EE7FFFFFAF8FFFDFCFFFDF6FFA146DC44
22B2FFF4FDF2FCFFFFFDFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF6FFFFF8FCFA
FF7147F6FFFFF7FFFFFAFDF8FFE96456FFF3FFFDFFF7FDFFFFFFFFFFFFFFFFFFFEEAFFFF
FFFF6A97FFFAF2F9FFF9F9FFE617FEFFFFFDFFFDF8FFFFFFFDFFFFFCF0FFEB2A99FEFFF8
FBFFFFFEFFFFFFCE22B0EFFFFFF6F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9FFFFF9FAFEFCFD
FFF9F7B0462092FFFDFDF8FFFFFBFFF83DD7FFFAF8FFF0FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF5FFF9F1F6FF5394FFFDF2FFFFFAFFFFFFFFFDFEF4FF0BFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFC4CBFFFFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB5FFFFFFF8FFFAFFFFFFFFFF
FFFFFFFFF9F8FFF2FFFDFFF8F8FFFFFEFFF1FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9462FFF6FFFDFFFEFEFFFFFFFFFEFCFFFFFFFFFFFFFFFFFBFFFFF8
FEFFFFFFFFE766A4EEFDF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDEFFF7895F9FFFF
FFF6F6FAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF8FDFD4AC4F6FFFFFFFF
FFFFFFFFFFFFF9FFFFFEFFD8E6F9FFFDFAFAFFF53ADCEFFFFCF5FFF1FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFFFEFFFDFCFFFFEEFC2FE6FCF8FBFFFFEB79F5FCFFE7D00E1C8A
FFFFFAFDFCFFFFFBF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFDF9FFFF
8228FFF2FFFCFFFFF5FFF1FCFF7F3EF3FBFFFAF7FFF1FFF9FFFFFFFFFFFFFFFFFFF7FFFF
F4FE629EF9FFFFFFFFFFFBFADD20FEFFFDFEFFFCFAFBFBFBFAF9FEFFFEFFEDE71DACFFF8
FFF1FFFFFBF3FFFFC312B5FAFEFEFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAFFFFFAFBFF
F1FFFCF9FFC2581F8DF0FDF5F6FFF04AA3F7FFFFFBF6FFFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF5F7F9FFFAFFFFEC3FD7FFFBFDFFFBFFFFFFFBF8FFFFF600FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF2AB8FFFFFBFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEAFDFFFCF7FFFFFFFFFF
FFFFFFFFFFFFF8FFFFF5F3FCFFFCFFF6FAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF72CE9EDFFFEFFFBFFFFFFFFFFFEFEFEFFFFFFFFFFFFFFFFFFFCFAFF
FFFFFAF2F6FFDC31FAFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC432FBFFEBFB
FFFFFFFFFFF6F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFDFFFDFFD928F6FFFFFFFF
FFFFFFFFFEFFF8FFF8FCFFAD1686E6FFFFF7FF9565F5FFFFF7F8FDFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8F7FFFFFFFAF6F8FFFF9B55FFF0FFFFE67C01B1FFFCA90248EAFD
EDFEFFFFFFF7EBFBFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FDF6FFFFAA
2ED5FFFFEFFFFFFEFFFEFFFFA21CEBFBFFE9FDFFF0FFF6FFFFFFFFFFFFFFFFFFF6FFFFFF
F6FF5AABFFFFFFF7F6FEFFFED726FDFFFCFFFFFCFFFFF9FFFFFFFFFFFFFFFFFCCF16BCFF
FAFFF2F7FFFFF0F4FFDA12B7FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F9FFFFFFFFFB
FFFFFCFFFEDBE0D6671280F3EBFCCF46FFFFFFFDFEFBFFF1FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF1FFF1FFFFF6FF836EFFFFF9FFFFFFFDFBFFF8FFFEFE10FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFD55C6FCFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFEFBFFFBFFFCFFFFFFFF
FFFFFFFFF8FFF9FFFFF1FFFFFCFFF2FFFFFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF7688FCFFF7FDFFFEFEFFFFFFFEFEFFFFFFFFFFFFFFFFFFFFFFF7FFFF
F6FBFFFDFDFEFF8175FDFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFC6098FFF9FFFF
FAFFFDF7FFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFBFF639FFFFFFFFF
FFFFFFFFFEFFFAFFF9FFFF970000137DE5FFFD50AFFFFFF3FFFFFFF9FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFCF7FFFFFFFFFFF3F21FEFFFEFFBDC000431C23932CEFBFCFF
FFFFFDFFF7FFFFFEF5FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFAFFFFFFC718
C8FFF3FFFFFEFFFEFCF9FFC70DD8F7FFFFFFFFF9FFFFF9FEFFFFFFFFFFFFFFFFFEFDFFEE
FFF545B4FFF9FEFFFFFCFEFCD329FDFFFCFFFFFBF8FFFFFFFFFFFFFBFFFFF4FAFFB721CA
FFFBFFFDFFFBFDFFFFEEBE17CFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFBFAFF
FCFFFFFFF78EB5FEF6E56E04EAFF1FCFFEFCFEFDFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF1FFF2FFFFF9FF1EDAFDFFFFFFFCFFF6FFFEF8FFF900FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFD99DDFAFBFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF41FDFFFFFFF4FFF8FFFFFFFF
FFFFFFFFFFF3FFFFF0FFF5FFFFF6FFFFFAF3FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFFFFFAFAFFEF13F2FEFFFDFFFFFFFDFFFFFFFFF6FFFDFFFDFFF2FFF3FFFEFFF3FFFF
FBFFFFF4FFF9FDF70FF7FCFFFFF6F9FFFDFCFAFFFEFFFFFFF9F7FDFFFFF40EF9FCFFF8FF
FFFFFFFFFFFFFFFFF8FFFDFCFFF7FEFFFCFDFAFFFFFFFFFAFFF9FFFFFFF9D22FFFEFFFFA
FEFFF6FFF8FFFFFFFDFFF1A1000208000F7EDD18FFFFFFFFFFFFFFFFFCFFF7FFFCF7FFF8
FCFEFFFFEFFFE7FFFFFFFAFDFFFFFFF9FFFCFFF73FC0FFF8FD18000900099CF8F5FFF5F9
FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFFFFFFEFFFFF6FFFFDA20B0
FAFFF7FFFFF6FFFFFFF6F31AAAFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFF
FAFC42C0FFFFFFFFFFFFFFFFC33DFFF7FFFCFCFFFFFFFFFFFFFFFFFFFFFBFFFCF6FFB81A
D9FFF9FFFFF9FDFEFDFFF5BD0BD6FFF6FCFFF7F9FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEFFFFFFFFBFDFFFFFAFFF5FFB94CFCFFFFFFFFFFFFFFFFFDFFFFFFFFF6FFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFB24CF5FFF5F9FFFFF0FFFFF3FFFF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF3FFFFFBF7FBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB0FBFFF6FFF9FFFFFFFFFFFF
FFFFFFFFFEFFFFFBFFE1FFFAF8FFF9E5FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFFFAFFFFAA53FBFEFFFAFFFEFFFFFCFFFFFFFCFFEEF5FFFFFFFBFFFFF9FDFFFFFA
F6F9FFFFFDFFFFFF4DA6FBF7FEFFF2FFF8FFFFF8FBF7F4FAFFFFFFF7FEA954FEFFFFFCFF
FFFFFFFFFFFFFFFFFFF7FFFFF0FFFFFDFFFFF7FCFCFBF8FFFFFDFFFDFDFFE03BD8130011
000004000A00000000061600090400000E001F49FFFFFFFFFFFFFFFFFAFFFFF6F7FFFFFF
FFF7FFEAFFFFFFFFF5FFFFFFF8F9FFFFFCF8FFFFA156EEFF790A0600080FE6FFE99AFFFC
FFFCFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEFFFFFFFFFFFDFAFFF7F7348DFE
FBFEFFFDFEFFE7FDFFFF188CFFF3FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFF
FBFF43BDFFFFFFFFFFFFFFFFBF40FFF8FFFCFDFFFFFFFFFFFFFFFFFFFCF9FFFFFBFFEF9E
31EBFDFEFEFFF7FFFFF1FFFF9827E0FFF9EBFFFFFCFFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFFFEF3FBFFFFF1FCFFFFFFFF4BA8FFFFFFFFFFFFFFFFFFFFFCFFFFFFFCFFEEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAF221F4F8FFFFFAFBF8FFECFFF3F7FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFE5FEFFFFFDFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFFFFFFEFFFFFFFF
FFFFFFFFFFF8FCFFF9FFF1FFFFFFFDFFFBFCF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFEFFFEFBFFFB51ABFFFEFFF6FFFCFFFFF8FFFFEEFBFFFFFFF2F4F8F7FFF7FFF0FFF2FF
FFFAFBFFFCFAF8FDAD52FFFFF5FFFFE9FFACF8FFFFFFFFFFFDFCFFFFFF4FACFDFFFFFFFD
FFFFFFFFFFFFFFFFEAFFF7FCFFFFE8FFFBE9FFFFFFFFFDF6FDFFFFF7FBFFF2579FFFFFF8
FFFFF7FFFEF9FFFFFBFCF2AB07000F01005E7672FFFFFFFFFFFFFFFFFFF8FAFBFFFFEDFD
FFFDFFFFF6EFFFF5FFFBF3F9FFFFFEF9FFFFFCEED631FFD10000010003025FF3ED88FFFE
FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFEFFFFFFFFFEFEFFFFFFF24E67FFFF
F8FBFFF4FAF9FFF4FF4F69FFF9FFF4F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFD
FDFF43BAFFFFFFFFFFFFFFFFB747FFF9FFFDFDFFFFFFFFFFFFFFFFFFFFFBFFFFFDFFFFFD
7E26FFF9FAFBFFFDF5FFF9FFFA9C24CDFFFFFFFFF5F2FFF7FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFAFFFFCFE3FFFAFFFBFFEF11FFFDFFFFFFFFFFFFFFFFFFF8FFFFEEFBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFF4DA9FFF4FFF3FFF8FCFFFAFFFF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFA6E3F5FFFBF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE6FFFFFBFFFFFCFAFFFFFFFF
FFFFFFFFF2FFFFFAFDEFF8FAF0F9FAF3FFF9FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFFFEFCFFEF1DECFFFFFFF6FFF9FFFFF4F9FFFFFFF0F3FFFDFFF8FFFBFCFFFFFFFBFD
FFFCFCFFFFFFFFFFF916ECF8FFFCFFA31416FFFEF8FAFDFDFAF8FFFFFF1CE5F4FDFFFFFF
FFFFFFFFFFFFFFFFFFFFF1FFFFEAFFFFFFFCFFFEEAFFFFFCFCFFFFFAFDFFFD7E77FFFFF0
FCFFFFFBFFFFFFFFF8FFFC9500010952EAFF53ADFFFFFFFFFFFFFFFFFEFDFFFFFAF4FFFF
FFFEFFF1FFFFFFFDF5F9FBFFFDFAF3FFFBFFFBF7DE29F23F0A180000030000BCFFF2FFFF
F9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFDFFFFF6FF6C3BFFFFF2
FFFEFCFBFFFFE5FF6447F1FFF1FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFA
FEFF41B9FFFFFFFFFFFFFFFFAE50FFFAFFFDFDFFFFFFFFFFFFFFFFFFFFFFF9FDFFFCFBFF
FF6250FFF9FFFFF5FCFFEEFBFFFF7342E8FFFEE4FFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEF2FFFA6EA5FFFFFFFCFFAE46FFF8FFFFFFFFFFFFFFFFFFF4F9FFFFFFF0F3FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFEB249FFEDFFFDFCF9FFFCFFF4F8F2FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF4ABE0EEFFFCFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF56F8F8FDFDFFFBFFFFFFFFFF
FFFFFFFFFFFFFAF9FFFFFFFCFFFFFFFDFBFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FDFFFCFFDD1EFFFAFFFFF9FFF8FFFEFFFFFCFFFDFCFFEFFFFFFFE7F8FFF6F9F5FFFB
EBFFFFFBF6FAF9EFF81CE3FFFF8E1A060835F6FEFFFAFAFFFFFFFBF3FB13F6F3FFFFFAFF
FFFFFFFFFFFFFFFFFDF4FFEAFFFFFDF5FFEEFCFFFBFCF8FFFDFEFFFFFFFDFFA45EEDFDFF
FEF5FFF5FDFCF7F2EDFFFDA8126CD6F7FFFE40B3FFFFFFFFFFFFFFFFFDFFF6FCFFFFEE00
FFF4FFFB03070006FBFFFFF8FCFFFBFFFFFCFFFFF00ADF749EB5B8D8FFECFFFFFFFFFEFF
F8FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFD8836F9EFFFFD
FDFFFFFFFFFEFF8236E4F6FFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF8
FFFF3DBDFFFFFFFFFFFFFFFFA459FFFCFFFEFEFFFFFFFFFFFFFFFFFFFEFFFAFBFFFFFAFF
F6FF3E65FFFFFDFCFFF5FCFFFCEEFF7734F7F7FFFBFFF4FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDF9FCFF549FF9FFFFFBFF7E85FBFCFFFFFFFFFFFFFFFFFEFFFFFCFFFDFCFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFDE120FDFFF9FFFAFDFFF0FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF2FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFBFFF8FFFBFFFFFFFFFF
FFFFFFFFFFF3F1FFF7F5FDFFFCF8FFEFFFFAFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFAFFFCFFC23CFFF7FFFFFEFFFBFFFAFFFFF7FFF6FFE7FFFFF1F5FFFFFAFFFFF3FFFF
FFFFFEF8FDFFFFF4FF5BB5A025111800001DFFFDFFFFFAFBFAF7FBFFEF17F8FCFFFFF6FC
FFFFFFFFFFFFFFFFFF01E5FFFEFCFFFFF210FFEEFFFFF6FFFEFEFFFFFFF7FFB946FFF6E7
FFFFFBFFFFFFFFFFFFFAF3CED7EEFFFFFFF53EC5FFFFFFFFFFFFFFFFF6FFFFFFF1FFFF01
EBFFFF00FFFEFFF500DAFFFFFDFFFCF7FFFFFFF9FF00F6FFFFFFFDF4FFFFFFF4E098FFFF
FDFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCFDFFFFFFFFFFAC11ECF5FFF6FF
FDFDFFFFEEFFD01BD0FFFFFFF5FFF7F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF9
FFFF38C5FFFFFFFFFFFFFFFF9A61FFFDFFFFFEFFFFFFFFFFFFFFFFFFF7FFFFFDFFFFFFFF
FAFDF73F81F2FFFFFCFCFFF6FEFFF0FF5B48FFFAFDF5FFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFFFFFF55A3FFFFFFFBFF6D93F2FFFFFFFFFFFFFFFFFFFAFFFFF7FFF6FFE7FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFEA0FFDFFFFF7FFFFF2FFFFF0FFEEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF8FFFFF6FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFFFFFFFCFCFEFFFFFFFF
FFFFFFFFF0FFFFFFF315FEF0FF00FFFFFFF3FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFAFFF9FFA658FFFCFDFFFFFDFFFDFFF0F8F9FFFFE915FCF5FFF200070004F1FFFBFF
FFEFFFFFF4FFFEFFFA4A3C07000000150A0014000000020200001C3CEE11FBFFFFFFFCFB
FFFFFFFFFFFFFFFFFA00FFF8FFF2FFF6FF00F9FFFFFFF8FCFDFFFEFDFFFAFFBB38FAFFFF
FFF9F6FFFBFFF8FFFFF7FFFFFFFFFCF2FFFF51B8FFFFFFFFFFFFFFFFFFFBF5FFFFFBFC00
FFF8FFFCF3FCFCFF0EFFFFF3F6FFFFFFF4FFFFF2FF04F3FFF2FFFFFEFFFFDDFFC43CFFFF
FFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFFFDF7D41ACFF7F6FFFFF9
FFFBEBFFF4E015B6FFFFFEF4FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA
FFF933CEFFFFFFFFFFFFFFFF9368FFFFFEFFFFFFFFFFFFFFFFFFFFFFFCFFFFFEFAFDFFFE
FFF7FCFE1DA5F8FDFFFBFFFAFFFFFFFFFF5F34FFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9F6FAFFFF82B7FFFEFCFFFF54A4FBFFFFFFFFFFFFFFFFFFFFF0F8F9FFFFE915FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFCFD08FAF8FFF5FAEBFFFFEDFFFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9AD9FFF8FDFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF08F2FFF9FFFEFFFBFFFFFFFF
FFFFFFFFFFFFF4FFF600FFFF00FBFFFDF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFCFFF7FF9365FFFFFBFFFFFBFFFCFFF1FFFFF5FBFF00FFF8FF01FFFFFDFF0DF1FFFA
FFF0FFF6FFFFF1FFFA6E9BBD450012000022FDFFFFFBFCFFFFF8FBFFF508FFFFF6FFFFFF
FFFFFFFFFFFFFFFFFF00FBFFF3080003000206F4FBFFFFFEFCFFFEF6FFFFFFB548FFFFF9
F9FFFFFCFBFFFBF5FFFFFFFBFEFCFAFFFFFA639CFFFFFFFFFFFFFFFFFFFFFFF6FFFFF906
F8FFF8F8FFFFFBFF00FFF7FFFFF4FAFFFDFFF9FFE313FFFDFFFCFCF4FFF1FFF5BD3DFFFC
FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFF4E820A5FFFFFEF9FAFF
F8FFFCFBF52C8FFFFEFFFEFFEEFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB
FFF530D4FFFFFFFFFFFFFFFF8F6BFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFBFDFFFFFFFFFA
FBFFEDFFDD23BEFBFDFFF6FFF1FAF9FFFFFF4B60FFF3FFFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFEF5FFF6FFFCFFF7FFFD32C9FFFBFFFFFFFFFFFFFFFFFFF1FFFFF5FBFF00FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF7FF1ADCFEF7FFFFFFF7FFFFFEFEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF42B5FFFFFCFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBCFFF7FEFCF9FFFDFFFFFFFF
FFFFFFFFFBFAFEFFEF08FFF909F8FFFFF9FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FDFFFFF2B258FDF7FFFFF2FFFFFFFFF7FAFDFFF9FF00FEFFEFFFFFF2FAFF08FFFFFF
F1FFFFFDFFF9FFF5FF5EA3FEFFBC4602011AFFFBFFFFFFFFFFFFFFFFFF22DAFFF9FFFEFB
FFFFFCEEFFFFF9FFFF00FFFCFFFC00FFFE0BF9FFFFFBFFFFFFF8FFFFF9F6FFA05CFFF7F9
FEFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFF97E80FFF6FFFFF1FFFFFCFEFFFBFFF5FDFF00
FDFFF1FFFFFCEFFF02FDFFF4FFFBFEFEFFEDFCFFBC48F1FFFFFFFFFFFFFFFFFFBE47F8FF
FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFBFFFFF12F7DFFEFFFFFF6F8FF
FFFCFFF1436DF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF7FF
FEFB20E2FFFFFFFFFFFFFFFF7F81FDFCFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCFEFFFFCE16C4F3FFF9FFFFFFF4FFF9FFF1406EFBFEFFFFFFFFEEFFFDFBFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFFFAFEFFF5FFFFFDFFFC6199FFFDFFFFFFFFFFFFFFFFF7FFF6FDFFF3FE05FFF5FFF5
FFFFF6FFFFFFFFFFFFFFFFFFFBFFFB00FFFFF3FFF9FFF3FEFFFFF7FFFCFEFFF6FFF7FEFF
FFFFFFFFFFFFFFFFFF3CC3FEFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FAFEFFFFFFF3FFFFFFFFFF
FFFFFFFFFFFFFDF5FF00000EF0FFECF5FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFDFFFFFFFBC83EFFFFEEFDFFF5FFFFFFFFFDFFF7FFFD03F4FFFFF0FFFFFFFF00FFF4F6
FFFFF1FFFFEDFFFFFF37CDF5FBF9FAC04625FAFFFFFFFFFFFFFFFFFFFF1CE1F5FFFAFFFF
FEF6FFFFFFF3FAF7FF10FEFEF9FC01FFFF00FFFFEAFFFEFDF8FFF7FDFFFFFF817DEAFFFF
B4C9FFF2FFFFFFFFFFFFFFFFF9F2FFFBF4FFAC56F6FFEDFFFFF3FBFFFFF2FFF4FFFFFE0F
F8F7FFF3FF001600FEFFEEFFF3FFFFF9FEFFFFF88A71FFFFFFFFFFFFFFFFFFFFDB9CFDFF
FFFFF6FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFE8FFFFF74A7AFFE0FFFFF9FFFFF6
FFF1FF714AF8FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF9FF
FBFE23DEFFFFFFFFFFFFFFFF7B85FDFDFFFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFFFDF0FFAE1FDCFEFFFFFBF9FAFFFFFFFFF52A7DFEF8FFEFFBFFFFFFF0F8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEF9FFFBFADFE5FFFFFCFFFB738CFFFBFFFFFFFFFFFFFFFFFFFFFFF8FFFFFBFE00FFFEFC
F4FFFFFDFFFFFFFFFFFFFFFFFFFFE213FDFEFFFCFAFFFFFFEDF4FFE9FFF6FFFFF7FDFFF5
FFFFFFFFFFFFFFFFFE42C5FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F4FFFFF1FFFFFFFFFF
FFFFFFFFF3FFFDFAFF01FD00FFFDFFFFFFFFFEFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFFFBFEFFE11CFEFFFDF9FFF6FFFFF7F5FFF6FFF8FC00FFFFF911FDF0FFFD17FFFFFB
FAF8FFF6FFFAF8FFFB12E6FFFFFFF9FDECD0FFF4FFFFFFFFFFFFFFFFFA6998FAFFFFF3FF
FFFCF5FFF5FFFFF9F20EE6FFFFEFFF00FF0CFFF2FFF6FBF9FFFBFFEEFCFFEC4AADFFBB29
0099FFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFE415F4F6F9FFFCFFF7FFF3FAFBFFF6FFFC00
FFFFEFFFF8FFEBFF0BF3FFFFFEFFEEFFF8FFFFFD3DB9FFFDFFFFFFFFFFFFFFFFFFFEFFFD
FCFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF2FF6A4DEAFCFDFFF5FFF5FCFF
FAFF8524FEF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFF
F8FF26D9FFFFFFFFFFFFFFFF748BFDFEFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFDFFFFFAFFAD33C3FAFFFFF7FFFAF9F5FFF7F43B76FFF2FFFFFFFFEBFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEFFFFFEC94AFFBFFFCFFFA9768FFFDFFFFFFFFFFFFFFFFFFFFF8FFFEFFFBFE00FEFFFF
F8F7FFFEFFFFFFFFFFFFFFFFFFFDCC35FEF8FFFAFFF1FBFFFFFFFA1700000B00FFF3FFFF
FFFFFFFFFFFFFFFFFCA1DBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF42F0FFFFFFF6F5FFFFFFFFFF
FFFFFFFFFFF9FFFFF917F1FF0BFCF2F9F4FFE7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFBFFFFFFFFF31BEDFCFFFFF2FFFFFEFFFFFFFFF6FAFF00FDF5FF0000100A00ECFFF5FF
FFEFFFFEFDFFFEFAEC19F4FFF0FFFDFFFFFCF9FFFFFFFFFFFFFFFFFFFCBB42FCFFEEFFF9
F5FFEDFCFFEEF5FEFE04FFFFE6FFFF04FA00FFF0FFFFF7FFFBFFFAFFFFECFF219D370000
0DA1F8FCFEFEFEFEFEFEFEFEFBFFFFFFEBEDFF57BCEFFFFFF1FFFBFBFEFFFFFFF707FF0D
FBF7FFFFF5FFFFF400FFF5FEFFFDFFFFFFFDFFE921F9FEFAFFFFFFFFFFFFFFFFFDFCFFFA
FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFD9230E4FFF7FFFBFFFEFCFFEE
FFB618E0FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFF
F6FF25D8FFFFFFFFFFFFFFFF6A94FDFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFFFEBFFFBF7FF873FECFFFAEDFFFCFFFAFFF6FFEF208DFFFFFAECFFFDF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFBF6FFFFFFF7FDFFFCFDC839FDFFFFFFFFFFFFFFFFFFEEFFFFFFF5FFFFF7F800FFFF
F9FFF5FEFFFFFFFFFFFFFFFFFFF7A16AFFF9F7FFFFF3FFFFFDFDFF00FEFFF3FFF2FFF6FE
FFFFFFFFFFFFFFFFFDFFF9F9FFF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB9FFFBF9FEFFFFFDFFFFFFFF
FFFFFFFFFEFFFFF9FA00FFF9F00DFFFFFAFFFFE8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFAFFFFFFF9FF5AA9FCF2FFFFFFF9FDFFEBFFF7FFFFEF01FFFCFE00F9FBECFFFFFFFDF6
FFFFF9FFFFFAFFEDAD5DFFF6FFF5F9FFF7FEFEF8FFFFFFFFFFFFFFFFFFED19F3FBFBFFF0
F5FEFFFFEBFFEF0FFE00FAFCFFF9FBFF070CFAFFF5FFFFFFFFEDFFFBF3FF710011000006
0077B6C2C0C0C0C0C0C0C0C0C2C1B5B8CEC9FFA34DFFF7F8FFF8FFFAF8FFF8F8FFFF0000
FFFFFD00FEFFF3FF07FFFFF5FCFAFFFFFFFBFF7F6FFFFBFEFFFFFFFFFFFFFFFFCBB6F7FB
FFFFFCF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFFEB122DBF7FFFFF1FFFDF9FFFFFF
C513D8FAF9FFF0FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFF
F8FF1EDEFFFFFFFFFFFFFFFF609DFDFFFDFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF7FFF6FEFFF6FAFF7E46FBFFFFEFFFFFFFFFFFFFF5D73794FFFBFFF8FDFFF1FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFFF8FFFFE5F0FFFCFFFBFFF425DDFFFFFFFFFFFFFFFFFFFFFAFFF3FFFFEAFFFF18F0FD
FAF6F1FFFFFFFFFFFFFFFFFFFEFF45B3FFFFF2FFFFFFFFFDFEF4FF0BFFFFFBF6FFFFF6FE
FFFFFFFFFFFFFFFFFDFFFAFCFCFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBFEFFF4FFFBFFFFFFFFFF
FFFFFFFFFFFFDFFFFF00FFF8FFE6FFFFFCFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEFDFEFFF7FFB636FFFAFEFFFAFEFCF7FFFCFAFF06FD0AF4FCFFFF0AFFFFFFF7FDFFFF
F5FFFFFAFFFDFCFF38BDFCFEF8FCFFFFF8F9FCFFFFFFFFFFFFFFFFFFFFFF6388FFFFF2FF
FFFFF3FBFFFFFFF50015F0FFFAFFF8FF0000FFFFFFF3FFFAFCFFF7FDFBE00C04000A0000
003A32453D3D3D3D3D3D3D3D414940364D5CE7FF3EC3FFFFFFFAFFFFFFE7FFFFF5EFFF05
FFFFF3FF04000900FBF5F7FFFCF9FFFEFFFFF025E3FBFFFFFFFFFFFFFFFFFFFFDFB0FFFD
FFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFC619BEFFFFF2F2FBFFF4FFFDFFDD
32ACF9F6FFEAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFF
FDFF12EAFFFFFFFFFFFFFFFF57A6FEFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FCFFFCF5FFFFFAF15F43FFFFFDFBFFF1F8FFFFFFFCD221B3FFF6FFEEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F4FFF3FFFFE9F2FFFDFFFDFFFF54A1FFFFFFFFFFFFFFFFFFFFF9F9F8FFFFFFFFE8FF0EFF
FFFFFFF4FFFFFFFFFFFFFFFFFFFC0BF2FAFFFFFFFFFFFBF8FFFFF600FAF6FFFFF9F6FFFF
FFFFFFFFFFFFFFFFFD99E6FFEFFFF7FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FEF7FFF8FBFFFFFFFF
FFFFFFFFFFFFFFF1FB02FFFFF1FFFFFFFEF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFEFDFFFAFFF227E3FFF4FDF8FFFEFFFFFFFFFCFF0000FFFFF3FD02EAFFFAFFFFEFFF
FEF1FFFFF4FFFDE826F9F1FFFBFFFEEEFFFFF0FDFFFFFFFFFFFFFFFFFDF8EB26FFEEF7FF
FBFFFCFEFFFFFAFFF102FFFBFAFFECFFFF00F6FFF7FFFBFFFAF7FFFEFFB748A42A0B0011
0091FFFFFFFFFFFFFFFFFFFFFFFAFFFFFFF0FFFFAA51F9FFEDFFFCFFF5FFF6FFFFFFFFEB
F9FFFFFFFCFFFEFFFDFFFFE7FFFFFBF8FBFC8B6BFFF7FFFFFFFFFFFFFFFFFFFFFFE4FFFF
F3FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAE51EA7FFFCFFFFFFF7FEFFFAFCE545
78EFFFFFF3FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFC
FFFF05F7FFFFFFFFFFFFFFFF50ACFEFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F7FFFAF5FFFFFBE3FFFFFF4D61F5FFFFFFFFF9FFF4FFFFFFC412AFFFF7FFFFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFFF76390FEFFFEFFFBFFB659EAFFFFFFFFFFFFFFFFF2FFFFFFF9FFFFEFFFEF00FF
F4FBF4FFFFFFFFFFFFFFFFFFFBA453FFF8FFFFFDFDFBFFF8FFFEFE10FFF3FFFFF4FBFFFB
FFFFFFFFFFFFFFFFFE9DE6FFF7FFFAFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FF9FFFBFFFFFAFFFFFFFFFF
FFFFFFFFFCF9F7FFFFF3FDFFFFFFEBFFFFF6FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F5FFFFFFFFFCF8FF877BFDFBFFFFFAFFFCFBFFF3FFFCFF03FFF5FFFF0006050000F7FFF7
FFFBFFFAFFF9FF6A89FFFDFBFEFAFFFEFDFBFFF5FFFFFFFFFFFFFFFFFFF8FF707CFFFFF4
FFFEFFFDF9FFFFFFFFFDFCFFFFFFFFF4F7FFF7FFFCFFFFF3FFFFFBFFFF37C3FFFFAF2D00
00A2FFFAFEFEFEFEFEFEFEFEFFF1FFFBFDFEFFFCFF3BBBF5FFFFF5FFFFFCFFF6FFFCF1FF
FFF8FFFFF5FFFEFEFFF9FFFFFDE6FFFDFEE91CFCFEFFFBFCFFFFFFFFFFFFFFFFFEFEFFFF
F5FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2D8AFFFFFAF7FFFBF9FFFCFEFF5E55
FFFFF8FFF7FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF9
FFFC00FFFFFFFFFFFFFFFFFF4CB0FEFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEFFFFFFFF1FFFFF3FFFFF3407FFFFBF9FFFFFAFFFBF8FBFDDD11CBF9FFFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFFF3FF5B9BFFFFF9FFF7F8FF26D8FFFFFFFFFFFFFFFFFFFFFFEFFFF2080400050006
FDFFFFFFFFFFFFFFFFFFFFFFF33FCEFFFEFAFEFFFFF6FFFEF8FFF900FFFFFCFAFFFFFDFC
FFFFFFFFFFFFFFFFFFFBF9FCFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFF8FFF4FFFFF7FFFFFFFF
FFFFFFFFFFFFFFF9FFFFF9FFFFF9FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF33BCCFFFCF3FFFCFFFBFFFFF5FFFFFAFFFFFFFFFFFFFFFFFEFEF8FF
FFFFF5FFFFF9DD34ECFFECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF424E6FFF5
FBFFFBFFFFF7FFFAFEFFFFFFFEFEFFFFFFFFFAFDFFFFF9FFF4FFF7FFAB5CFFF7FEFFFF9F
4096FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFC39C9FFF8FEFFF9FEFFFFFDFFFFFD
FCFFFFFBFFFFFAFFFFFEFFF5FFFFFAFFEF33D5FBFFFFFDFFFFFFFFFFFFFFFFFFD698FFFF
FFFEFAFFFFFFFFFFFFFFFFFFF4FFFEFFFFFFFFFF3C77F2FFFCFFF1FFFDF9FFFFFC842BFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFE
FBFF00FFFFFFFFFFFFFFFFFF3DC4FDFCFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFAFEEC2C9EFFFEFFF8FFFEF9FFFFFEFFBA11C5FFFCFFFFF4FBFF
FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8FFF5FCFF5B9DFFFEFFFFFFFCFFD225FCF9FFFFFFF8FFFFFEFFFFFFFEFEFFFFFFFFFFFF
FFFFFFFFFFF1FFFAEEFFFCFF966AF7FFF8FFF6FFFFFAF4FFFFF7FF00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFAFFFEFEFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF06FFF0F6FFFFF5FFFFFFFFFF
FFFFFFFFF9EAFFFFF4FDFFFAFAFFFDF4FFFFEAF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFB142FFFFFBF6F7FFFEFFFFFFFAFDFFFFFFFFFFFFFFFFFFFFFEFFFB
FFEEFFFAFFEC48B5FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFC847EDFF
FFFEFFEFFDFFF0FFFFFFFFFFFFFEFEFEF3FFFFFFF4FFFFFAFFF3FFBD43F3FAFFFFF8FFFF
F1F0FFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE63FE8EFFFF1FFFCFDFFFFFCFCFF
FFFFFBFDFFFFF7F1F2FFF6FFFBFCF8F760BEFFEFFFFFFBFFFFFFFFFFFFFFFFFFC758FCFE
FAFFFEFFFFFFFFFFFFFFFFFFFFFFF7F7FFFFF66750E6FFFFFFF0FFFFFFFFF9FFAC25E7F6
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFE
FDFF00FFFFFFFFFFFFFFFFFF39C7FDFCFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFFFFF1F511A9FFFFF3EDFFFEFFFBFFF6FEB923DDF9F6FFFEFFFF
F6F7FFEEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF683ACFFFEFFF7FFFCFFF28695FFFFF3FAFFFFF9FFFFFFFFFFFEFEFEFFFFFFFF
FFFFFFFFFFFFEFFFFFEBFFE11AF4FFFCFFF5FFF7FFFFFFF6F3FFFF0EFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF7A2DAFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00EDFFFFFFF9F4FFFFFFFFFF
FFFFFFFFFFFFFBF8FFFAFFFDFDFFFAFFF8FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF7FF8568FFFFFFFFF3FFFDF7FFFFFFFEFFFFFFFFFFFFFFFFEFFFFFFF
F4FFF2F8FF7586FFF5FFF8F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF5FFBB42E9
FFF7FFFFFEFFFDF9FEFEFFFFFFFFFEFCFFF7EFFFFFFEFAFEF9FFF13FD5FFFFFAFFFFF8FF
FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFDFFCD32DAFCFFFFFCF7FCFFFCFEFF
FBFCFFFEF4F9FFFFFFF0FFFAF6FFFF5287FFFFFFFBFEFFFBFFFFFFFFFFFFFFFFBE2CFEFF
FAFFFCFFFFFFFFFFFFFFFFFFFFF1FFFFF5F99F31E1FFFFF6FFFFF9F7F4FFFFBE1FCDF0FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFDFE
FFFF00FFFFFFFFFFFFFFFFFF32CEFDFEFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFDFDFAFFECF8E921B9FEFFFFFFF8F3FBF3FFFFF19F31CAFFF5FFFAFF
F4FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF7F5F3FFFFFFF7FEFFF4FFFFFBFFE742B8FFFFF0FFF3FCFEFEFFFFFFFFFEFCFFFFFFFF
FFFFFFFFFCFAFAFFEBFFFF38C7FFEBFEFFFDF8FFF7FCFFFDFFFFDA00FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF4DBCFFFBFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCAFFFFF2F5FFFFF7FFFFFFFF
FFFFFFFFF4FFFFFBFFFFEDF7F7EDFFFFFBFFFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF7FFF065A6F9F8F4FEFFFFFCFFFFFCFEFFFFFFFFFFFFFFFFFFFEFFF4
FFFFF6FF8E71EBFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFF5FFFFF2AA68
FAF8F1FFFBEAFFF8FFFDFDFEFFFFFFFFFFFFFEFEFFFFF8FFFFBD3DD4F4FFF1FFEDFFFFF5
FBFEFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBEFFFD43EABF0FFFFFFFFFFFFFFFB
FFFBFFFFFFFFFFEDFFFFFEFFFFC230A6FFF4F6FFEEFFFFFCFFFFFFFFFFFFFFFFC246FDFF
FBFFF7FFFFFFFFFFFFFFFFFFFBF4FFFDFFAF1BD2FFF1FFFFF7FEFFFFFEF8E024ADF8FFF7
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFE
FFFE05FCFFFFFFFFFFFFFFFF29D6FDFFFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFCEFFFFFF0B122DCF6FFFFFFFFFFFEF8FAFFF1A713EDFFFDFFE3
FFF9F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F7FFFFF7F8FBFDF2FDFFFAFFFFF5FFFFED34D0F9FFFDF4FFFFFDFDFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFF6FFF250ADFFEAFFFFEBFFF9FFFFFBFFFCF8FFFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF30B5FFFFFFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F3FFFFEEFCFFFFFFFFFF
FFFFFFFFFFF0FFFFECFFF9FFFFF9FFECFFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFE9FFF54C8DFFFFFFFFF8FBFFF9F5FFFFFFFFFFFFFFFFFFFDFFFAFF
FDEDFF9463EFFFFFFFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFAFFFFA2
2AD1FFFBFEFAFFFFFFFFFFFEFFFFFFFFEDFFFFF5FCFEFFFFA840D2F6FFF2FDFFFFFDFDFF
FFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFFDD508BDBF5FFFEF3F5FFFF
FFF8FEFFF6FBFFFCFBFFFEED9941D9FFFFF9FFFCF8FFF4FFFFFFFFFFFFFFFFFFDC9DFBFF
F7FFF8FFFFFFFFFFFFFFFFFFFDFFEEFFCE15B4FFFCF9FEFFF8F6FFF0FFE93692F8FEFFFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFE
FFF70DFCFFFFFFFFFFFFFFFF1FDFFEFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFAFFFFFAF8FF9728E2FFFFFFF9FFFFF8F6FFFFF58638E8F8FFFF
EEFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFF2FFFFCFE5FFFEFFFDFFFFF9FAFFFAF537C9F6EFFFF6FFFFFFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFBFFF65B9EFFF0F9FFFBFBFFFFFDFFF3FAFDFFFBF9F5FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFB52C1F7FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF7FFFFF8FFFFFFFFFF
FFFFFFFFFFFFF4FDFFFC00080800FCFFFDF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFF0FFF76E66F6F2FFFFF7F7FFFFFFFFFFFFFFFFFFFFFFFFFBFBF8
FFFF546BE0FFFFFDF4FFF0F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF5FFFEFFF2FF
E4486DECFFFFF2F7FFFFFFFFFDFCFEFFFFF1FFFFEDFFDC5151F7FFFFFAF7FFFBFFF4F6FF
F6F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFE8FFFFFF773080DBFFFFFFFDFF
FFFEFFFFFEFFFFFFFFED7F3565F6FAFBEFFFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFF2FFFF
F7FFF9FFFFFFFFFFFFFFFFFFFFEAFFD315B0FFFEFFFFFFFAFFFFEFFFF55167FFF3FFFCFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFEFE
FFEF14FDFFFFFFFFFFFFFFFF15E8FEFFFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FFFFE6FFFFFEFFFF8234F6FFFAF2FFFFFBFFFFF9FFFF6C2FFFEFFF
FFFAF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F1FFFFFCF18DB2F7FFFFFDF9FFFFFEFFFFF2CB4698FFF7F4FFFFFFFFFDFCFEFFFFFFFFFF
FFFFFFFFF9FFFFDB2C9FFFFAFFFFFAF7FFF6FEFFF9FEFFFFF9F3FBFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFEA6E1F7FFFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF48E6FFFAFAFBFFFFFFFFFFFF
FFFFFFFFF5FFFFF7FB00FFEFEFFF00FBF7FFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FFFFF8FEFF9135C1E6FFFFFFFFFFEFFFFFFFFFFFFFFFFFFFF1FFFF
A325B4F8FFF6F1FFFCF9FFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBFFFFF7FFFFFC
F4ED8A237CFDFFFFF7FDFFFFFEFBFCFFEBFFF9FFEE5924A5FFFCFFEBFFFFF7FFEFFFFFFF
FDFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F5FFFAFFFFFFEB852B3891E2FDF9
FFFEF9FFFFFACEAF501C85DEF5F5FFFFFFFFF7FFFCFBFFFFFFFFFFFFFFFFFFFFFFF4FFFF
FEFDFDFCFFFFFFFFFFFFFFFFFAFCF13087FFFFF2F8EEFFFBF9FFEDFF7C47F2FFFFEDFFF2
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFE
FCE81AFFFFFFFFFFFFFFFFFF0EEFFEFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF4EEFFF9FCF5FFF3FF8231F9FFFFFFFDFEFFF5FFEEFFFF6D31FFFB
F7FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFDFFFFFFFFFFFEFFFEFDFFFFFFFFFAFFF6684EEEFCF7FDFFFFFEFBFCFFFFFFFFFF
FFFFFFFFFFEC8C3AD2FFFFF2ECF2FFFDFAFFFFFFFFFFF9F8FFFFFFF5FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFFAFFFFF9FEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFAFFF8FBFFF2FFFFFFFF
FFFFFFFFFFFFF9FEFF07F5FFFFF507FFFEF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFBFFFFFFFAFFD241499CFFFFF4F8FFFFFFFFFFFFFFFFFFFBFFAB30
47DBFFFFF3FFFFFFFBFFEAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF9FDFCFFFFFF
FFFDF9F37B104B9BE8F4FFFFFFFCFFFFFFCF852F1E92FFFFFCFFFCFFFFF2FFF9FFFFFCF4
FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEF6FFFFFCFBFFFFEFC46C1B143B
3E636B4F301A2A54ACF1F6FFFFFFF5FFFDFEFEFFFBFFF3FFFFFFFFFFFFFFFFFFD4B9F6F5
FFFEFFFAFFFFFFFFFFFFFFFFFDFF3E6DFAFFFCFFFFFFF8FFF5FFFF951EE8FFFFF9FFEFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFE
FAE31DFFFFFFFFFFFFFFFFFF0AF2FEFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAFFFFFFFBFEFFF3FBFFF86D4AFAFFF0FCFFFFFFFCFFF7FCF76B41FC
FFF4FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFEFFFFFEBFFF9FFFFF9FFFFFEFCFBFFFFFEF7FFFFA02562E8F4FFFFFFFCFFFFFFFFFFFF
FFFFFFFF842F66F8FFF8F2FFFFFFECFEFFFFF7FFF9FFFFFFFDFAFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF9FFFAFFFEF4FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F8FFFFF8FFFFFFFF
FFFFFFFFFFFEFFF3FFF5FFFCFCFF00FFFAFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB5512E5DAEEDFFFDFFFEF1FEFFE9B15B2D4EC5
FFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFCFDFFF5B0681117263A47463627002977C9FCFFFFFCFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFDFFFEE6CA
B7A69EAFCCE6F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFB3F1FE
FFFFFDFFFFFFF5FFFDFDF9F7FF8137ECFFFFFFFCFFEFFFF0FFFFA821E2F3FFFFFCFDFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FE
FEE51BFFFEFFF6FDFFFBFFFF00FFFFFAFFFFFBFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FEFF3F6AFFF8FFF6FBFFF7FFFFFCF9FE4D5D
FFFFFFFCFFFFFCFDFFF9F4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFF9FDFCDEFAF5FFFDFAFCFFFFFEFCFFFBFFFFF4FFF5AA262472CCFFFFFBFFFDFFF8FD
E39C520C66F1FFF2F9FBFDFFFFFEFDFAFFFDFCF7FCFFFCFCFFFFFCFFFBFFFFFAFFFFF5FF
FDFFFFFCFFFDFDFFFF9DE3F3FFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFF4FFFFFCF9FFFFFFFFFF
FFFFFFFFFFFFFFFDFFFF00000003FFFFFBFEFFE4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFE0994F1B0346323F5637000F4C9FDEFFF8
F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFFFAFFFFFFF6FFF2D6C2BDC3CBD0FFFFFFFFFFFBFAFEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCFFFFFFF6
FFFAF4F7FCFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFF
F9F2FDFDFFFCF7FFFFECFFFF8812FCFFFEEAFFFEF1FFFCFFF6D129BFF4FEFFFFFCFDFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFF9FF
FEE31DFFFCFFF8FFFFFAFDF903FFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF0FC2E7EFFF5FFFFEEFFFFFFFFFFFFF852
48FCFFFFEBFFFFFFFFFEFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF5FFFFFC548FFFF4FFFFFFF7FFFCFFFFF4FFFFFFF9FFF1FFDE902F002B3B3F4537290F
1859AEFAFFF4F4FFFFF9FFF4FCFFFFFFFAFFFFFFFFFFFAFAFFFFFCFFFFF8FFFFFFFFFEF8
F9FFFFF7F4FFFFF4FE9FD4FFFCFAFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3CFFFFFFFCFAFFFEFFFFFFFF
FFFFFFFFFFF6F7F8FF03FFFDF5FFF2FFF2F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8F7F9FAF8F6B6BFBEBBCCEEFFFFFFFEFFFF
FFFBF7FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFFFFFBF2F5FFFFFFFFFEFBFCFDFDFDF3F3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFAFFFFFF
FDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFF
FFF8FFFFF7FFFFEFFFFFFCA514F9F1FCFFF6FDFFFFF4FFFFE6328BFFFFFFFFFFFCFEFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFBFF
FFDE22FDFBFFFAFFFFFAFAEC10FFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF407A0FFFFEEFFFEF6FFF6FFF0FFE8
4681FFF7FFFFF1F2FFEFFCFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F7FFFFEBFF67A5FCF7FDFFFFFEFFFFFFF2FFFFF2F2FFFFFEFEF2FFFFF4DCBEC3BEBBE0EE
FFFFFDFFFCFCFFFFE8EEFFF8FCFBFAFEFDFCFBFFFFFFFEF8FEFDFBFFFFEEFCFCEFFFFFFF
FFFAF3FCFFF8F7FFFFFFFFFFFDFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF07FFEFFEFFF6FFFFFFFFFFFF
FFFFFFFFFDFFFFFFF600FFFEFFED00FFFFFFFDF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF9FFFFFFF2F5FFFFFEFFF9F8FE
FFFBFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFBFFFFFFFDF8F8F7FAFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFBFCFDFB
FCFDFEFDFAF9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD59EF4FF
FFF9FFFBFBFFF2FEFFFDCD24C3F3FFFFF1FFF2FFFFF1FCFF4F6BFFF4FFFFFDFBFDFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFCFF
FFD729FDFDFFFBFFFFFCFCE41CFFFFFEFFFEFEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFDFFE823ACFCFCFFFFF7FFFBF7FFFCFF
EF2587FFF7FFFFFFF4FFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF4FF5BA3FFFFF9FEF8FFF2FCFFFFFFF0FFFFFFECFFFFFDFFF4FFFFFFFFFFFBFCF8
F8FDFBFFFEFCF3FFFFFFF9FFFFFDFFFAFFFBFFFCF5FEFCFBFFFFFDFEFAF7FFFFFFFFF9F8
F7FFFFF3FFFFFFF6F8FFFFF9FFFFF9FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00FFFEFFFFF8FFFCFFFFFFFF
FFFFFFFFFBFCF6F7FF00FFFFF8FF00FFE5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FBFFFEFAFAFFFFFCF9FFFFFFF5F9FFF7FFFFFD
F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9F6FEFFFFFFFFFFFFFFFCF8F7FAFCFCFCFAF8F9FDFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFFFFFFFE
FFFFFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD049FFF9
FBFFFAFEFFFFF9FFFFE91D9CFFF3FFF5FFFDFCFFFBFFFF7340FCFFFDFDFBFAFDFFFFFFFE
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFDFF
FFD030FDFFFFFCFFFDFFFFDF21FFFEFFFFFDFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFFF9FCFFF7C61AD7FFF6FFFFE1FFFFFCFFF5
F1F61599FFFBF4FFEFFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFEF8FFFD81B8F6FEFFFFFFF9FFFEFDEAFFFFF5FFFFFEFFFAF9FDFFFFFFE6FFF9FFFAFF
FFF2FFFBFFFFFFF0F7FDFFF6F4FEFFFFF8FBFDFFFAFFFFFBFFFFFFFFFDFFFAEDFFFFF0FF
FFFFF8FFFFFAF3FFFF97E0FDF8F3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF01F8FFFFF4FFFFF4FFFFFFFF
FFFFFFFFF8FFFFFCFEFF00010013F4FFFFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFCFFFFFFF6FFFFFEFAFFFFFDF0FFF7F1FF
FFFFFAF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFDFAF7F5F8FDFBFFFFFFFFFFFFFFF9FFFFFFFFFFFEF8FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFBFEFFFFFF
F6F8FAFBFFFFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC128FFFF
FFFFFCFFFEFBFFF6F22C83FFF4FFFFFFF5FFFFF5FFFD922FE7FDFFFFFFFEFEFFFFFFFCFD
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFF
FDC838FEFFFFFDFFFBFFFFD726FBFAFFFFFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE9FFFFFAFBFFFFB203DDFFF9FCFFF3FFFFF4FC
FFFFDC2D9EFFEBFFFDF7FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFF9FFFFFCFFD677EFFDD6363F4075FFF7D37CF2FFD33D434468FFEEC990FDFFCA452E
4B80F0FFC881EEFFDC3E3F4175FFFFBC79FFFFC146373D88F1FFBE69FFFFCD5D2F367DFF
FFB375FFFFD544334B26C5FFFFFFF7FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC4F8F2FBFFFDFFFFFFFFFFFF
FFFFFFFFFFF7FFF2FFF0FFFCFFF6FFE8FFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFFFFEFBFEFFFDF8FDFFFFF8FEFFF3FFFFFF
FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F8FFFFFFFFFFFFFFFFFFFCF7F6FAFFFFFFFFFFF8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFCFCFCFC
FFFFFFFFFFFFFCF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB955F4FF
FBFFFBF6FFE1FFFF3866FFFEFFFAF8FFFFEBFFFFF9B727D3FFFEFAFEFFFFFFFFFFFCFBFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFEFF
FBC23EFFFFFFFFFFFAFFFFCA32FEFAFFFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF5FFFFFFFEEFFFAF14E3FFFBFDFFF6FFFEF9
FFF7FFD118B4FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFBFFFFFFFEF8E7CBFFFFFBADD0BAC2FFEBEEC7FFF7F2BCB6C7CCFFFEF2BAFFFDF4BBB9
BFC8FDFFF4BCFFFBF3B3C6B8C7FFF5FFCAFFF5FFBCC1BFCCF0FFF2DFF9F8DEBBC4CCCBF5
FFF8CFFFE9F8C1CBB1CAFFF1FFFCF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFDFFFFFFFF
FFFFFFFFFEFAFFFFFFFFF9FFFFF3FFFFFBFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFDFFFFFFF9FDFFFFF4FFFFFDFE
FFFFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFFFFDFDFFFFFEFDFDFFFFFFFFFFFEFCFFFFFFFFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFFFFFFFFFFFF
F9FEFEF9F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5C4FCFF
F8FBFFFFF6FFFF6758EBFFF7FEFDFFFFF0FFFFFDDF11C0FFEFFFFFFFFFFDFDFFFEF9FCFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF
FABF41FFFEFEFFFFFAFFFBC041FFFDFFFBF8FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFFFFFAF0FFFEFBFF942AE4FFE8FFFFF8FBFF
F5FFFFFFCE19B2FEFFFFF8FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF8FFF3FFFFFAFFFFFCFBFCFFFFFFFFFFFFFFFFFCFDFEFFFCFFFFE9FFFFFAFFFBFFFEFF
FFFBFFFDFAFFFFF3F9FFF7FFFFFEFEFFFFFDFDFDFFFFFFF9FFFFFDF4FFFFFFFEF9FCF9FF
FFFFFEFBFFFFF9F8FFFFFFFFFFFFFDF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FCFFF2FFFFFDFFF6FDF6
FFF6FFFFFFFEFFF5FFFAFFF5FDFFF9FFF1FFFFF7F6FFFAFFFFF6FFFFFFFFFFF8FFFAFFF6
FDFFF6FFFFFFF3FDFDF9FFF9FFF8FFF8FFF9FDFFF7F9FFFCFEFEFEFFF2FFFFF5FFFFFFEB
FFF6FFFFFFFFF9F7FFFFFAFFFFF6FDF6FFF6FFFFFFFEFFF5FFFAFFF5FDFFF9FFF1FFFFF7
F6FFFAFFFFF6FFFFFFFFFFF8FFFAFFF6FDFFF6FFFFFFF3FDFDF9FFF9FFF8FFF8FFF9FDFF
F7F9FFFCFEFEFEFFF2FFFFF5FFF3FFFCF6FFFDFFFFFFEFFFFFF2FFF3FFFFFAF8FEF7F4FF
FFFFF4FFFFFCFDFFFDFFFBFFF7FFF7FFFFF4FFFDFFFFFAFFFDFFEAFFFFFFFFFEFFF1FFF4
FFFFF7FFFFFA9824EDFFF8FFFCFFF7FEFFFEF9EF1AAFFCFFF4FFFFFDFBFFFDFFFFFFFCFA
FDF8FFFFFFF7FFFFFFFFFAFFFCFFFBFFFFFEFFFFFFF8FFFBFFFAFFFAFBFFF9FFFDFEFFFF
F9BA41F5FFF3FFFFF9FFFFC33CFFFFF2FFFFFCFCFFFFF5FFFFFAFFFAFCF9FFFCFEFDFFFD
F7FCFFFFF8FFFFFFFBFFFDFFFFFFFCFAFDF8FFFFFFF7FFFFEEFFFF7548F1FEFFFEFEF4FF
FFF8FBFFFFC423D0F3FFF8FBFFF7FFFBFFFFF8FFFFFFFFF9FFFDFFFFFFFEFFFFFFF5F8FF
FFFFF5FFFFFAFFFAFCF9FFFCFEFDFFFDF7FCFFFFF8FFFFFFFFFFFBFFF7FFFCFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FFEFEFCFFF9FFFFFFFBFFFF
FFFFFFF4F3FDFFFFFBFFFFFFF1FFFFF2FAFFFEFFFFFFFFF8F6FDFEFFFFFCF3FDFFFBF2FF
FFF5F5FDFFF9FFFFFFFBF6FFFFFEFEFFF4FFF6FCFFFDFEFEFEFFF6EDFEFDFDFFF0FFFFFF
FCFFFFFCF6F3FFFFFDFFFFFFFFFBFFFFFFFFFFF4F3FDFFFFFBFFFFFFF1FFFFF2FAFFFEFF
FFFFFFF8F6FDFEFFFFFCF3FDFFFBF2FFFFF5F5FDFFF9FFFFFFFBF6FFFFFEFEFFF4FFF6FC
FFFDFEFEFEFFF6EDFEFDFDFFF8FEFFFFFDFCFCF6EBFFFFEFF1FFEFFFF3FFF6FFFFFFFBF4
FFFFFFFFF6FAFFFFF3FFFEFDF5EFFFF6FFFEFDFFFFF8FDFFF8FFFFFCF5FFF8FFF8FFFEFF
FFF6FFF6FABD14E9FAFCFFFDFFFBFFF6FEFFFF4481FBFFF6FFFFEEFEFFF7FFFFEBF4FFFD
FFFFFEFBEDFFFFFAF8FFFFFFF5FFFFFEEEFFFFEDFFFFFFFFFCF9FFFEFFFFFFFFFFF1EDFF
FFC642FFFEFFFFFFFBFFF1B646F7FFFFF6F1FFFFFCFFFFF1FFFFE6FFFFF5F7FBFFFBFFFF
FEFFF9F3FFFFF2FFFFF7FFFFEBF4FFFDFFFFFEFBEDFFFFFAFFE4FFF76057F7FFFFFAFFF0
FFFFFFE4FFF5A80FDCF3FFFFF9FFF9F1FAFFF2FFFFF6F5FAFFF6F6FFF6F8FFF4FFFFFFF5
FCFFFFF1FFFFE6FFFFF5F7FBFFFBFFFFFEFFF9F3FFFFF2FFFFFFFEF5FEFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFACFFFEFFFDF9FFF2FFFFFFFE
EFFDFFFEFFFFFFFDFFFEFDF8FFFFF8F6FFFFE6FFF8F9FFFFFFFFFAFAFFEEFFFFE8FFFFEC
FFFFFFFFEEFEFFF6F8FFFFF9F8F9FFFFFDFFFFEAFFFFE3FFF9FFFFFFFFFEE9FFFFF0F1FF
FFFFFFFFFFEDFFFFF0FFFFF3FFFFFFFEEFFDFFFEFFFFFFFDFFFEFDF8FFFFF8F6FFFFE6FF
F8F9FFFFFFFFFAFAFFEEFFFFE8FFFFECFFFFFFFFEEFEFFF6F8FFFFF9F8F9FFFFFDFFFFEA
FFFFE3FFF9FFFFFFFFFEE9FFFFEFFFF5FAFFFFFFFFFBFEFFFFFDFFFDFFFFFFFFF4FAFCFF
F4FFFFF6FAFFFFFCFFFFF6F4FFFFE1FFFFECFFF8FCFFFEE5FFE2FDFFF6FCFFFFE063FAFF
F7FFF2FFC80CCDF9FDFFE9FFFFF3FFFFFFF26448F0FFFFF9FFFAFFFFFDFFEDFFFFFFFFF3
FCF7FDFFFFFFFFFFFFF5F4FEFFFFFFFFFFF8F6FFFFFFFBF9FFFFFFFFFFFDFFFDFBFFFFFF
FABA3DF9F8FFFFE4FFFFFFBB60E9FFF4FFFCFFF6FFFCF7FCFFFFFFFEFFF8FFFFF8FFFFEC
FFF4FEFFFFFDFEFEFDFFEDFFFFFFFFF3FCF7FDFFFFFFFFFFF9FFF9FFF24669FCF5FFF2FD
FFE0FFFFFFFFFEBF19D6FFF0FFF8FFFEFFFFF6FEFFFFFFFFFDFFFFFDFFFFF5FFFCFDFBFF
FFFCF7FCFFFFFFFEFFF8FFFFF8FFFFECFFF4FEFFFFFDFEFEFCECFEFFFFF5FDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F7F9FFFFF3FFF7FFFFFF
F7FFFFF9F6F8F3FFF8FDF8FFFFE3FFFCF1FCFFFDFFFCFFFCF6FFF3FFFFF7FEFFFDFFECFF
FDECFFFFFFFCFFF6FFFEF9FFFFFFF4FFFEF3FFFFF4FFFFEAFFE7FFFFFFF1FFFAFBFCFFFF
EEFBFFFAF0F8FFF3FFFFE8FFF7FFFFFFF7FFFFF9F6F8F3FFF8FDF8FFFFE3FFFCF1FCFFFD
FFFCFFFCF6FFF3FFFFF7FEFFFDFFECFFFDECFFFFFFFCFFF6FFFEF9FFFFFFF4FFFEF3FFFF
F4FFFFEAFFE7FFFFFFF1FFFAFEFFFFFFF6FFFBF6F5FFFFF2FFFDFFFCF4E8FFF8FFF5FFFA
FFFDF6F1FFFFEFFFFCFFFFF8FFF1FFFFFBFFF7FFF5FFFFFFFFFFFFF8F8FFF8F8F1CEFFFF
FFFFFDEB30A6F6FFF9FFF1FFFFFFF6FFF68741F7FFFFFBFFEBFFFFF6FFEBFFFEECFFF0FF
F8FFFBFFE6FFFAFFFFFFFDFFF5F9F1FFFBFDFFF0FFFFFFFFFFF6FFFBFAFFF5FFFAFFE6FF
FFC039FFFFFFFFFFFFFEE99E62F8FFFFFAF2F3FFFFFBFFF9FFFFEDFFFAFFF8E7FFF4F3FF
FFFFFFFFE0FFFFF9FFEBFFFEECFFF0FFF8FFFBFFE6FFFAFFFFFBFFFAFFFE427DFBFFFDFF
FFFFFFFBFFE7FFFF972AD1FFF9F8F0FDEFFFFFFFFFF2FFFDFFECFCFFF3F9FFF7FFFFFFF8
FFFBFFF9FFFFEDFFFAFFF8E7FFF4F3FFFFFFFFFFE0FFFFF9FFFFFFF5F9FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF93B120000B4F8FC3FB7FFE9
4D000012C7FFFF40BBFCFF35000A00CEFEFF49B3FFFA23080003DEF5EF39C9FCFF1F0204
00C6F2F53FCCE8FF3E041100CBFFFF3BC9FFF847000008C8FFF94AB9F1FF2E000100C9EA
FF4BB7FFFD4A0E0008A1FFFF3FB7FFE94D000012C7FFFF40BBFCFF35000A00CEFEFF49B3
FFFA23080003DEF5EF39C9FCFF1F020400C6F2F53FCCE8FF3E041100CBFFFF3BC9FFF847
000008C8FFF94AB9F1FF2E00000AAEF5FF3CB3FFFE46001100BFEFFF49C4FFF73F0A0008
BDFFFF36C6FFFC4C000000D0F2FF49B0FFFF48000309A3FFEE45C0FFFF33110000BEFFF2
F9FFEE2776FFF6FFFFF4FFF1E2FFFFE5BC1EDEFFFEFFF5FFFFF7F1FFF1FFFBF6FFFFF1FF
FFF8FFFFFFF8FDFFFBFEFFFBFFFFFFFFFFEBFFFFE6F9FFFFF8F6FFFCFCFFFFFFFFF5FFFB
F4A064F6FFFDF7F3F9FFFF975FFFFDFFF5FFFFFFFDFAFDFFF6F0FFF6F2FFFFFFF9FEFFF6
FFFEFDFFFFFEF8FFF1FFFBF6FFFFF1FFFFF8FFFFFFF8FDFFFDFFF4FFECFEDC23A7FDF2FF
E6FCFFF6F9FDFFFAFE903CE3FFFF48AEFFFFFFEEFEFAFEFFFEFFFFFFFFFFF5FFF9FFF7FF
FDFAFDFFF6F0FFF6F2FFFFFFF9FEFFF6FFFEFDFFFFFEF8FFF7FFF3F4FFFFEFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFDFFF3FFFFFFFEFF
F9FFFFF3FFF1EFFFFFF8F7FFFFF3FFFAF7FFFAFFFFFFFFFFFEF6F9FDFFFFFFF2FFFFFAFF
FFFDFFFFFEFFFFF7F8FBFFFFFFFFFFFFFAFFFCFFFFFFFFECF9F4F8FFFFFEFFFFFFF5FFFF
FDF7FFFDFFF7FFF8FFFFFBFFFFFFFEFFF9FFFFF3FFF1EFFFFFF8F7FFFFF3FFFAF7FFFAFF
FFFFFFFFFEF6F9FDFFFFFFF2FFFFFAFFFFFDFFFFFEFFFFF7F8FBFFFFFFFFFFFFFAFFFCFF
FFFFFFECF9F4F8FFFFFEFFFFFCF2FFFFFFFFFFFFFFE0FFFEFFFAFFF4FDFBFFFFFFFFFFFF
FFECFFFEE7FBFFF1FFFFFFFFFDFBFCFFF9F9FFFFE9FFFFFCFFFEFCF8F5FFFFF9FFFFEDFF
FFFF5D56FFFFFEFFF6FFF4FCFFEFFFD006D3F7FCFEFFF2FEEAFFFFFFFFFFF4FFFFFDFFFF
FFFDF9FFFEFFFBFEFFFEF0FFF8FFF2F7FFECFFF5FFFFFDFFFFFCFFFFFFFFF5FFFFF2FFFF
F59F67FFF6FFFFFF7F2E402B094B6C7FFFEBFFF5FFFFFAF6FEFFFFFFFFFFFEFFFFF4FFF1
F9FFFAFFEFFFFFF5FFFFF4FFFFFDFFFFFFFDF9FFFEFFFBFEECFFFFFFFFFFFFE803C1FFE9
FFFFECFFFFFFEEF5FFFF792EE028036AFCFAFFFFFFFDFFFBFCFAFFE7FFFBF8FDFFFFFEF8
FFFFFAF6FEFFFFFFFFFFFEFFFFF4FFF1F9FFFAFFEFFFFFF5FFF2FFFFF7FDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDECFFF5F5FFFFF7F9FFFF
FDF8FFFFFFFFFFFFF8FFFFFFFCF8FFFFFFFAFFF2FBEEFFF9F8FFF3FFF9F8FCFFF2FFFEED
FEF8FFFBFEEBFDFFFFFFFCFFF7FCF7FFFFF7FFFEEDFCFCFFFFFDFFFFFEF3FFFFFAFFFBFF
F8FFFFFDFAFFFDF9FFFFF5FEF7F9FFFFFDF8FFFFFFFFFFFFF8FFFFFFFCF8FFFFFFFAFFF2
FBEEFFF9F8FFF3FFF9F8FCFFF2FFFEEDFEF8FFFBFEEBFDFFFFFFFCFFF7FCF7FFFFF7FFFE
EDFCFCFFFFFDFFFFFEF3FFFFFFF4FFEBFCF5FFF825E3FFFF0F031400DFF2FF1ED9FFFF12
000D00EEFFFE2BE7FCFE23000707DEFDFF1BD1F8FF1C000000EBFDFF1CE2F3FF14040600
E45E3B24D6FFFD2E000000EEFFFF1516B8EE44000200EFFFFF2ACCFFFF09130005D1FFF3
1FE7FFEF1028000DE1F4FF28D5FFFF1C001500EBFFF120DCFFFF0B000000EFF6F81CDFFF
FF07080002E0FBFB1B08000209000106DEFFF326DDFFFD27000B00E8FFEA23E4FFFE0D0C
0C00EEF4F72BC5FFFF09130005D1FFF31FE7FFEF1028000DEFFFF513E5F0FF14040902E3
F3FF0CE9FFF522060000D28000110032FF14000300E9FFEE1FE5F8FF29001C00DCFFF52E
DDFFFD27000B00E8FFEA23E4FFFE0D0C0C00EEF4F72BC5FFFF1E0056F3E6FFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFFFFFFFBFBFFF7FFF9
FFF7FFFAFFFAFFFCFFFAFEFEFFFFF5FDFCFFFFFFFFFFFCFFFFFFFFFAFBFFFFF7FFF6FFFF
FFFFF9FFFFFFFBFFFEFCFFF7FFFFFFFCFCFFF6FFFFFAFFFCF9FFFAFEFDFFFDFCFFFFFFF5
FFFDFEFFFFFFFEFFFFFBFFFEFFF7FFF9FFF7FFFAFFFAFFFCFFFAFEFEFFFFF5FDFCFFFFFF
FFFFFCFFFFFFFFFAFBFFFFF7FFF6FFFFFFFFF9FFFFFFFBFFFEFCFFF7FFFFFFFCFCFFF6FF
FFFAFFFCF9FFFAFEFDFFFDFCF4FFF5FFFB21E9FDFBFFF7FFFFFFF8FFFFFFFDFCFFFBF7FF
FFF0FFEFFFFFFAFBFFFEFFFFF6FFFBFFF5FFFDFFFDFBFFF9FDFFFCFBFFF6FFF4FFF4FFFF
8F2AF7F9FFFFFFEAFFF7FBFCFEF63596F9FFEEFFFFFCFFFFFFF9FFF8FEFFFFFEFFFCFFFF
FFFDFFFFFFF5FCFCFFF9FFFAFFF7FEFDFFF5FFFFEEFFFEFEFBFFFFFFFFFAFFFFFFFDFFFC
FF995EFFFBFFFFFFF728000000001FF2FEFFFEFBF9FFF7FFFFF3FFFFFDFFF3FFFAF8FFFE
FDF4FFFFFFFCFFFDFEFFFFFEFFFCFFFFFFFDFFFFFFF5FCFCF6FFFDFFFFFBFFFFFBB118D9
FFFEFFF8FEFFFFEDFFFFE43105000000C8FFFBFEFFF6FEFFFAFCFFFFFBFDFFFEFFFFFFFD
F9FFF7FFFFF3FFFFFDFFF3FFFAF8FFFEFDF4FFFFFFFCFFFDFAFFBE43FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFEEFFFF17E5FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFDFCFFF9F7FFFFFCFFFEFBFFFFFBFFFFFFFCFCFFFFFFFFF6FFAF
1DE0F8FFFFF7FFFFFBFFF5FFFA4A69F2FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF7FFFFFFFCFFFCFF
FF985DFFFFFFF0FFFF8D0800000096FDFFFFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5B21B
D9FFFEFEFCFCFFFFFFE90E0800000A0080FEFFF5FFFFFDFDFFFFFFFFFFFEFFFFFDFDFFFC
FFFFF5FFF6FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F5D8FAF4FFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FFFFFBE72FCEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFBFBFFFFFFFCF9FFFFFFFFFBF5FFF1F4FDFFFFFAFBFFF3FFCE15
B4FFF9FFFFFFF4FBFCF1FFF56C57F3FFFFFAFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F7FFFFFFFAF6FFFBFBFB
F59E6EE3FFF4FFFAF0FC23000031EDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFF18F
2CEDEFFFFFFEEFFDF2BE4B03001200003AFFECFFFFFFFFFFFFFFFCF8F7FFFCF8FFFFFAFF
F3FEFFF5FFFDFCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF2FFFDFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFEFF16DEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFCFFFFF7F3F9FBF8FFF5EEF8FFFAFEFFFFFBF3FFFFFFFAFBFFEA0FB2
FAF3FFFFFFFEF4DDFFF9FFB31DF2F2F7FBFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFEFFFDFCFFF3FFF8FB
FF9659FFFFFDFFFFFFFA751307A5FFFFF4FEF2EDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFEFFF
7F59FAF5F3FFFCFFFFFAFFE1921F110000F4FFF8F6FBFFFFFFFCFDFFFFF8FBFFF7FFFFF1
FFFCFFFFF5FFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F8FFFCFFF8FFFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFFEFEF1FFFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFDFFFFFEFFFFFFFFFFFFFFFCFFFFECF7E5DBE5F5FDFFFFEF1F8DF5
FFFCFFFDFFFDE70099FFC802D6F7FFF6FFF6F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFFF5F8FFFEFEFFFBFFFF
F7BAA5F6FAFFC6C7FFFFEA0228FFFBF9F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFF8FF
F16357FFFEFEFFFFFFF6FFFFF9FFB9672B85FFFFD1944514080A0500003065A1E8FCF7FF
FFECF2FCFFF4FFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC46AFEFCF6FCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF7FBFFFFFFFFF2FEF8FFFFC27B4112001D2C16001147763F6AFFFF
FFFFFFFCFFF7960E00532FCEFFEDFFFFFEFFFEF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFBF2FFEFFFFF
DFA86126010638281000382D79F0F6F2FFFCFBF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF9FFF4
FBF34969FFF8F1FFFFFFFFFFF9FFFFFFF7E672192C69B8E9F5F3F8FFF9D0A4580E33A7F0
FFFFFAFFECFFFFF7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF9FED5FDFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF4F7F3FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF9FFFFF1F8FFFFF8F270083E88B3F1FBFFFFFEFFF2BC84310383E4
F6F5FFFAFFFB6E020C002CE9EAFFF3FFEFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FFFFFDF8FFFFFFFFAE36
145AACD4F5EDFFFFF9FFD495510D52C4FFFFEDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F6FF
FFFFF23781FFFFF4FEF9F7FFFAEDFFE279137FE6FFFFFFFFFFFFFFFFFDFFFCFFFFCF6124
84FFF6FFFFF3F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F9FFFFF5FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFF1BDBF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF8F8FFFFF6FFFFE574267DFFFBF2FFFFFCFFFFFDF8FAFCFAFFEF7B36
80F2FFFEFDFF240002060229F3DBFFFFFFEEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFEFF9FFE9A0364DD2
FFFBFFFEFFFFEEFFFFF4FEFFFFFBB24B33C9FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFF1FC
FFF3FFF627A0FDFDFFFFFBFFFFFFC03188EBFFF9F9FAFBFAF9FAFEFFFFF6FCFFFBFCFAE6
7B1CFFE6FDFFFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6FAFFFFFFFCFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFCFFFDFDFEB2368CECFFF8FFFFF7FFFFFDFAFEFFFFFFFFFFF9FDEB
7A3CC0FFF8E20303000700092EFBF7EFFFFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFAF5FFE76A59D1FFF7
FFFFFDFFF0FFFFF2FFFFFFFEFBFFF8F6D0327FFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF9FFFF
FFFAFFF2D81BBDFFEFFBFFF9FD9033E5FFF7FFFAFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCFF
FBC330BDFFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFCD67FFFFFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFEFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6FFFDF9FF9339F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFE2
FFD628AFFF95050005003CB0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFEFDD83DA0FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAFEFCFFFFF49938EDFDFFFFFFFBFFFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFC81CCFFFFFFBFF4098EAFFFAFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFCEA41AAF9FFFBFFFEFDFCFFF2FFFFFFFFFFFFFFFFFFFFFFFCAD4EEDFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFFFFDFAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF6FFF84E89F8FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF5F7FF
F9FFFF577958120C50D9FFF3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFCE35CAFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF8FCFFE8C533EBF3F8F8F5FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFCFFB018DFFFF479A9DCFFFFFAFBFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFFAF847C5E0FFFDF9FFFDFFF9FFFBFFFFFFFFFFFFFFFFEDFFD041FFF3FFF5FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6FF1EE2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF6F9FF8A7AF7F6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEEFF
FFEFFFED6F1D81F4FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFEDE535D3FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FFFFFCF9FFFFFFDF25F9FFFAFFFFF5FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF4FFAB1BF0A167F4FFFFFFFBFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFFFBF336D9FAFFF6FFFDFFFFFFF9FFFFFFFFFFFFFFFFFFFFB12CFFFFFAFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFEFF20D7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFF8E63FFF0FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9
FDFFF6FFF758CCDDFFFFFDFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFCEB40CEFFF9F7FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFCFFFFFFFDF8F6FABD55EAFFFEFCFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF5FFA59753E9FFFCFBFDFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF8F7F9FFE639E9FFFBFFFEFDFFFEFEFFFFFFFFFFFFFFFFFDE8F4E3FBFCFFF7FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFEFFFEFF20D7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFD334F7F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FEFFFF
FCFFFFE5FDE530E5FFFFFEFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF166AAF7F0FFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFFDFEF9F98771FEFAFFF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF5FEFFFF2ACBFFFFFAFAFFFFFDFBFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
F9FFFEFEF7FF9466FFFFFFFEFEFFF9FFFFFFFFFFFFFFFFFFFFFFF5FAF7FFF8FAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F6FF1EE2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF138D2FCFFFFE8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFF4FF
FFE6FDFFFFFFA946FFF2FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBB64FF9FDFFFCFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFDFFFFFFEEFF31E6FAFEFBFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF5FCFFFF856DF7FFFFFEFDFFFFFCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFEFFF6EFFF3CC3FFFCFEFFFDFAFFFFFFFFFFFFFFFFFFF7FFFFFCFBFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFAFFFFFFFFFDFAFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFA555FFF4F8F7FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFFF
F7FFFFF1FFFFF553C7FBFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF732C5FFFFFFF8F7FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FBFFFFFEFAFBFFEDFFFFB137FFECFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFBFFE32EF4FBFEFEFCFDFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFE8FFFEFDFFA362F8FCFEFFFEFFFFFFFFFFFFFFFFFFFFFFFFC183F4FFF6FDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFEFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFF1EF2F3F5FFFFF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FF
FFF3FFFFFBFCFFC32CFFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8E75FFEBFEFFF6FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFFFFFFFFFFFFBFF50A6FFF3FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF1FFF3B44EF9FFFFFDFEFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFECFFFFF7FF15EDFEFEFFFFFFFBFFFFFFFFFFFFFFFFFFFFE9CBFFFCF7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFDFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFF5FEFFFFB54DF5FFFDFFF6FFF4FFFFFFFFFFFFFFFFFBFFFFFEFFFFF9FFFFFFFFFF
FFFFFFFFFFFBFFF830D2FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFCF6FFFEFD27E4FBFFFFFCFDFDFFFFFFFF
FFFFFFFFFFF5FFFFFDFBFFFBFFFFFFFFFFFFFFFFF5FFFCFFAD49FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFCFF4FABFFF7FFFFFFFFFFFFFFFFFFFAFFFFF7FFEFFFF9FDF6FFFFF1FFF9FF
FFFFFFFFFFFFFFFF6D8CFFFFF9FDFFFAFFFFFFFFFFFFFFFFFFEFFAFFF9FDFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFF1BDBF1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FBFFFFFFFEFEFE639AFFFFFBFFF7FFFCFFFFFFFFFFFFFFFFFFFFE5FEFFEDFFFDFFFFFFFF
FFFFFFFFFFF7FFFC7882FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFDFFFFFCFFFFDB3AE6F8FCFFFDFFFFFFFFFFFF
FFFFFFFFF7FFF2FFFFEFFFFFFFFFFFFFFFFFFFFFFFFEFFF5F719FBF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF2F12AE8FFFFFCFFFFFFFFFFFFFFFFFFFFEEFFFCFFF8FFF6FFFFEAFFF1FFF9
FFFFFFFFFFFFFFFFBA47FBFDFFFFFBFFFFFFFFFFFFFFFFFFF8FEFFF4FFFCFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF4F7F3FFF0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FAFFF6FFFCFBFA1BE8FFFCFEFFFBFFFFFFFFFFFFFFFFFFFFF6FFFFFAFFFFF3F9FFFFFFFF
FFFFFFFFFFF7FFFFD227FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFF9FFF89370FBFFFFFFFDFEFCFFFFFFFF
FFFFFFFFFEFAFFFFF6FFFEFDFFFFFFFFFFFFFFFFFFEAFFFDFF4BB0FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFEC033FFFFF8FFFFFFFFFFFFFFFFFFFEF4FFF6EEFFF3FFFFEEF5FFF6FFF3F9
FFFFFFFFFFFFFFFFFA09FBF8FFFFF7FFFFFFFFFFFFFFFFFFFFFFC772FEFDFFF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFF3FFFAFEE71AFFF8FDFFFFFFFCFEFFFFFFFFFFFFFFFFF7FFFCFFF9FBFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF03F4FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFF6FFF556A3FFFFFFFFFDFEFBFFFFFFFF
FFFFFFFFFFF3FFF2FFFCFEFCFFFFFFFFFFFFFFFFFFF6FFFFEA9870FEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF9FFA256FFFFF2FFFFFFFFFFFFFFFFFFFDFFF6FFFFFFF7FFFDFFFFF8F1FFFDFF
FFFFFFFFFFFFFFFFFF09F7FCFDFFFFFDFFFFFFFFFFFFFFFFF5FFC240FFFAFEFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFFEFEF1FFFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFAFDFFFFBF45FFF3FFFFFBFFFDFEFFFFFFFFFFFFFFFFFFE0FFFFFFF7FFF9FFFFFFFF
FFFFFFFFFAFFFFFDFF1BDCFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFFFFFAFFFF3DBEFFF9FFF9FFFFFFFFFFFFFF
FFFFFFFFECFFFDFFFFFAFFFFFFFFFFFFFFFFFFFFF6FFFFFCFFA168F3FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF99B66FFF0FFFEFFFFFFFFFFFFFFFFFAFFFFF4F900070300FFEFFFFFFBFFFB
FFFFFFFFFFFFFFFFFC2ED5FFFFF6FFFBFFFFFFFFFFFFFFFFF8FFB934FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFEFF16DEFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFDFFFCFFFF9865FFFBFFFEF6FEFFFFFFFFFFFFFFFFFFFFFC14000800FEFAFFFFFFFFFF
FFFFFFFFF8FFFFFBFA43C4FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFFFCFFFF24DDFFF9FFF8FEFFFFFFFFFFFF
FFFFFFFFFFFFF5F808F9F6FDFFFFFFFFFFFFFFFFFFF9FFFBFFBB41FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF8827AFDFFFFF8FFFFFFFFFFFFFFFFFFF5FFFF02FFEDFFFF00FBFFFFFFF7FB
FFFFFFFFFFFFFFFFFF43B0FEFFF1FFFFFFFFFFFFFFFFFFFFFFFFAF50F7FFFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FFFFFBE72FCEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEF9FFFFFFFB8E70FFFFFDFDFEFEFFFFFFFFFFFFFFFFFFFF00F9F6FDFF05FFF6FFFFFFFF
FFFFFFFFFDFFFFFBFC52B3FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFBFEFFF8FB0DF6FFFFFFF9FEFEFDFFFFFFFF
FFFFFFFFF2F1FFFF00F8FFFCFFFFFFFFFFFFFFFFFFEEFFFFF9DE1BFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF7B80F1FFFFFCFFFFFFFFFFFFFFFFF5FFF0FCFFFFFFEEF50EF9FAFAF6FFFF
FFFFFFFFFFFFFFFFFF3BBBFBFFFAFBFFFFFFFFFFFFFFFFFFEDFFF4CFFFFBFAFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFEEFFFF17E5FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF7FDFFFEF99871FDFFF2FFFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFEEFD00FDFFFFFFFFFF
FFFFFFFFFFF7FFFDFF4EABFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFF5FDFFFFFF0DF6FAF9FFF8FEFFFFFFFFFFFF
FFFFFFFF050300000A00F6FEFFFFFFFFFFFFFFFFFEFFFDFDFFCC32F9FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEFF9A65FFF1FFFFFFFFFFFFFFFFFFFFFFFCF8FFFEF6F9FFFF00FFFEFFFDFFF8
FFFFFFFFFFFFFFFFF52BE2FBFFFFF5FDFFFFFFFFFFFFFFFFFFFFFCFEFBFFFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFBFF1CDEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCFDFFF3FFFF9B5DFFF9FFFFF5FFF3FFFFFFFFFFFFFFFFFFF9FFFFFFFF00FFFFFFFFFFFF
FFFFFFFFFCFFFCFAFE3CC7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8FFFCFDFFFF2ADCF8FFFDFEFFFDFFFFFFFFFF
FFFFFFFFFE03FFFF00FFFDFFFFFFFFFFFFFFFFFFF6FFF9FFFFB34EFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF2C550F7FFF7FFFFFFFFFFFFFFFFFFFFFFFAFB0FFFF8FFFF00FFFFFFFFF6FF
FFFFFBFFF0FFFFF4FF00FFF4FFF6FFFFFFFFFFFFFFFFFFFFFCFFFFF3FFFFF9FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCF1FFF8FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FDFAFFFCFFFFC237F8FFF9FFFFFCFFFFFFFFFFFFFFFFFFFFFFFFE6FFFA00FFF3FFFFFFFF
FFFFFFFFFFFFFCFFF820D9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFF9FFFEF93EC0FFF6FFFFFFFFFFFFFFFFFF
FFFFFFFFF900FAF70DFBFAFEFFFFFFFFFFFFFFFFFFFFFFF9FFA054FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFC02EFFFCFFF6FFFFFFFFFFFFFFFFFCFFF8FF0007000004F4F7FFEBFFFFF7
FFF6FFFCFFFCEEFFEC0CF7FFFFF6FFF5FFFFFFFFFFFFFFFFFDF8C289F4FAF4F4FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFBFEFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FDFFFCFBED19F6FFF5FFFFF3FFFFFFFFFFFFFFFFFFFFFBFF0D0204F2FFF9FFFFFFFF
FFFFFFFFFFFFF9FFEF1BECFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF8FFFEFA7097F0FFF7FCFFFFF8FFFFFFFF
FFFFFFFFFFF800FF00EFFFEEFFFFFFFFFFFFFFFFFFF8FAFFFB6C92FCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFCF627DFFBFFFFFFFFFFFFFFFFFFFFFFF6FFFB18EFFFFFFBFFFFFFFFF3F7FF
FFFBFFFFFEF6FFF4AA5EF6FFFFF7FFFFFFFFFFFFFFFFFFFFFFFFEABCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDF5FFF7F9EFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF9FFFFFEF8FE35D7F7FBFFFDFCFBFFFFFFFFFFFFFFFFFFF6F9FAF9F50EF9FFFFFFFFFF
FFFFFFFFFDFFF7F3BD4FFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFCF9FFFFFFB547FBFFFCFEFCFFF9FFFFFFFF
FFFFFFFFF0FF00FF0EFFFEFFFFFFFFFFFFFFFFFFFAFFFAFFFF25DFF9FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF2FFFC7686F9FFFCFFFFFFFFFFFFFFFFF6FFF9EDFF00FFFBFCEEF7FEF5FFFBFB
FDFFF8FFF4FFFFF93FC0FFF1FFFFF4FFFFFFFFFFFFFFFFFFF1F5FFFFFEF5FBFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFF2FDCF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFF7FFF9FFFCFC8771FFFFFEFEFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFD00F6FBFFFFFFFF
FFFFFFFFFDFFFBFF56A2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFEFCFFFDFFEB10FFE2FFFFF7F9FFFFFFFFFF
FFFFFFFFFFFFFF0002FFF6FAFFFFFFFFFFFFFFFFF4FFFFE5ED22FEFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF0FFB63EFFFFFCFFFFFFFFFFFFFFFFFFFDFFFFFF00F5FFFFFEFDFFF8FFF7FF
FFFEFFEFFFFFF7FA17E9FFF4FFFFF4FFFFFFFFFFFFFFFFFFFFFFFDEEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFFBF9F3FAFFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FCF7FFF3FFFFF9D822FFFFF5FFFEFAFFFFFFFFFFFFFFFFFF00FFF8E3FF09F7FFFFFFFFFF
FFFFFFFFFFFBFFF91BE5FFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFEFEF7FFFF5C92FFFFF8FCFFFBFFFFFFFF
FFFFFFFFF8FAFF0A06FEFEFFFFFFFFFFFFFFFFFFFFF0FFFF6F86FFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFF5FF30D1ECFFFFFFFFFFFFFFFFFFF3FFEDF2FF070900000EFAF5FFF4FFF8
FEFEFFFCFFF5FF6E81F5FFFFF8FFFFF7FFFFFFFFFFFFFFFFFDFFD36BFFFBFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFFFDFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FEFFFFF8FFFFFDFC5BA9FBFAFFFDFFFFFFFFFFFFFFFFFFFFFF000F0000FFFFF6FFFFFFFF
FFFFFFFFFFF9FA9B6BFFFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFEFFFCFAFFFFD331FFFCF7FFFFF9FFFFFFFF
FFFFFFFFFCFFF9F700FFFFF5FFFFFFFFFFFFFFFFFFECFAF133E4FFF8FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF2FFFFF4D52DFFF8FFFFFFFFFFFFFFFFFEFFFDFFFFE4FFF8FFF9FFF5FFF2FCFF
FCFFFBFFFFF1E82CF2FFFEFFF9F8FFFCFFFFFFFFFFFFFFFFF4FFC63AFFFAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFAFDFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFF9FFFFFDFFFCD12EF6FFF0FFFFFAFFFFFFFFFFFFFFFFF9FFEEFFFFF8FDFFFFFFFFFF
FFFFFFFFFDFEEF26EAFFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFCFFFFFFFFFAF96799FEFFFFF1FFFFFFFFFF
FFFFFFFFFFF8FFFFF9FFF4FFFFFFFFFFFFFFFFFFF8FFFF807EF4FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF8FCFFF4718BFFFFFFFFFFFFFFFFFFFFF3FFFDFEFFFFFFF8FFFFFCFFFFFEF9
FFFCFFFCFDFF53A8FFFFFDF9FFFFF6FFFFFFFFFFFFFFFFFFFFFFB446F8FAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFCFDF9F82EE0FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF6C8BFBFFF7FFFFFFFBFAFDFFFFFFFFFFFFFFFFFFFFFFFFFFF2F7FF
FFF7FDFFFBFF698FFFFCFFF8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBEB25EEFFFFEFFFFFFBF9FF
FFFFFDFFFFFFFFFFFFFFFFFFFFFCFCFFFFFCF0FFF9F3E526F7FFF3FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFEF7FFFFFCEF27E4FFF2FEFFFCFFFDFFFFFBFFFFF5FFFFFBF9FFFFF6FEFDFAFF
FFFFF9FFFFAB53FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF9C042FFFBFFF5FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0DD7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFAEA53C7FBFFF1FFFFFFFFFDFDFFFFF3FFFFFFFFFFFFFFFFF4FFFFF9
FFFFF8F6FFBA45FFEBFFFDFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0A370F8FBFFFFFAFFFFF9
F4F9FFFFFFFFFFFFFFFFFFFFEDFFFFFFEEF8FFF8FFFA47BCFCF5FFFDFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFF5FFFBF8FBFFD333F2FFFFFBFDF3FFF5FFFFFFFFFDFFFFFCFFFFFFFFFFFFF9F8
FCF0FFFFBB3AFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFAF0D8F7FAFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FAFEF9EC46DDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFF4FFE132EEFBFFFCF5F7FFFFFFF5FCFFFFFFFFFFFFFFFFFFFFFFFAFD
FFFFFFFFC242F3F6FFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFF38C7BF6FFF5FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFF7F6F658A0FFFCF3FFF7FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFCFFF6FFF5FFBC36EBF9F7FFFFF5FFF8FBFAFDFFFFFEFFFFF8FAFFFEF7FEFF
FFFEFFCB3DF4F0FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF1FFF4FFFEF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFF04E5F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF3FFC63EE5F4FFFFFFFFF3FAFFFFECFFFFFFFFFFFFFFFFF5FBFEF5
F3FFFDDC55E7EFFFFFF2FFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFE55DA2FFFFFEFCFFFF
FFF4F4FDFFFFFFFFFFFFFFFFF2F7FFF9FFFFF6FF7689F8FFFFFFF6FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFDFFF1FFFFE4FFB23FD0FFFEF3F9FFFFFFFFFDFFFBF2FFFEFAFFFCF7FFFFF1
F0FCAB31D6F5FFF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE5FFFFEBFFFFFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFDFFF7FBFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFF3FFFFB243CBEBFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFAFF
FFFFA932D2E6FFFFF1F5FFF2FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFF8FFFF585AF2FFFFF9FB
FFFFFFFDFFFFFFFFFFFFFFFFFDFFFBFFF6FFEE498DFDFDF8FEFFFFFCFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFDFFFBFFFFFFF8F6FFCE339FFDFFFFFFFEFFFEFCFFFFF9FFFFF9FFFFF9F9FFFB
F67457FFFEFFF8F5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCC72F4F4FFFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEF4FFFFFFF9FDF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFAFBFFF5DB4CA4FDFEFEFDF9F6FBFFFFFFFFFFFFFFFFFFF1FFFEFF
E96B5EEFFFFFFFF3FFFEF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFF3FAFCFF9940DCFFFFFB
EDFAFFFBFFFFFFFFFFFFFFFFFFECFFF6FFBC4AA7FFEEFFFFFFF3FFFEFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFF7FBFFFFECFFFFF1FFFF512898FFEBF6FFFEFCFFFFFBFBF9FFFEECF9FFE18E
268CF6F7FDEBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF8FBD4FFF4FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFBFFF4FFFFFFE06B239AFDFFFEFFFFF9FFFFFFFFFFFFFFFFFFFAF998
2C86FFF3FCFBFFF8FFF5FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE8FFFFF8FFFDD1176FD2FF
FFFFFFFFFFFFFFFFFFFFFFFFF1FFF9D9593CD3FBFEFFEDFFFFF2F1FFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFBFFE4FFFFF5E6FFFBEDFFDD611EA0E6F3FFFFFFFFFFF4FFF7FEFFC0563B6D
E0FFFFFCFFFFEAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F0F8FFFFFFFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FCFF20E5F9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFBF4FFF3FFFFDD65266FD3F6FAFFFFFFFFFFFFFFFFFFBD6D2764
E5FFF1FFFEFFF6FFFEFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFF5FCFFFFFCF7FF8C334F
A8E6FCFFFFFFFFFFFFFFFFFFEE954439A0FEFDFFFFF6FFF8FBFFFFF4FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFAFFFFFEF6FFFFFDF9FFFFFFFFE06F1B335D798CB1C2AD79834E12379CE6FF
FFFFF8FFFDF7FFFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFFFFDF8FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F7FFF9FFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDE87321E4C8181B4C39F88845511418DE0FF
FFFBFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFCAE
4B1F40747CA7BEAC998C65341D63BEF9FFFFFBFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD4A585654843507D8AB5ECFFFFF8FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6C87AF7FFFFF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF8FDFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFEF9E0B1897D4A3D63787AA6EAF9FFFFFC
F6FDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F5FF
FFF5B9847B53425567729BCDF4F9FEFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFBFFFFFFFDFFFFF8FBFFFFFCFAFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FDC343FFF1FFFAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFCFFFDFDF3F7FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFCFEFDFAFEFEFFFFFFFFFFFFFFFFFFFD
FFFFFFF5FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFA
FEFFFFFFFFFEF9FFFFF8F3FDFFFFFFFFFFFFFFF9FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F6F8FEFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC529FFF8FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFCFF23E5FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F7FBFFFFFFFFF8FFFFFDF9F9FFFFFFF8FDFFFB
FBFFFFFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFBFFFF
FEF7FAFFF7FFFFF0F5FFFFFFF7F9FBFCFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF9FDFFFEF5FBFFFFFFFFFEF9
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFABC4AFFF2FBF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FAFFFEFF13D4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F8FFFFFFFFFFF7FCFFFFFCF6FFFFFFFFFF
F9FAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F9
FFFFFFFDF9FFFFFFFFFEF9F6FFFFFFFFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FCFFFFFFFFFFFFFFFFFFFDFBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEAC6FFFFFFFEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFAFFF2F638D6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2FDFFFFFEF4F7FFFDFFFFF2F3FFFFFFF3F8FEFF
FFFFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FCFFFF
FFFDFCFDFFFFFFFFFBFBFFFFF5F6FBFFFFFFFEF6FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFFFFFFFDFDFCFAFBFDFCF9FBFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFFFF8FAFEF7FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF5FEFF03E6FCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF6FAFFFFFFFFFFFFFFFFFFFBF7FAFFFFFCFA
FCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF8
FAFFFFFFF2FDFFFDFDFFFFF8FFFFF9F7FBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFBFBFFFFFFFFFFFFFFFFFCFA
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEE6FFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFBFFFBFFF7FFFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFCFFFFFCF9FAFAFFFFF8F8FFFFFDF8FAFDFF
FFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFCFEFF
FFFFFCFAFFFDF8FFFFFCFBFFFAFFFFFFFDFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFDFFFFFFFAF9FFFFFCFBFFFFFCFEFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAC883FFFAFAFDFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEF2FFFFFEFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFF7FFF8FF06
FBFFFD00FEFF00FFFF00FFFEFD10EBFF07EFFFFC00FFFF00F9FAFFFFFFFC02F7FFF40BFF
FC02FDF7FA0EFF00FFFD00FDFCFFFEFA00FFFA00FEFF00FCFFFB00FFFF00FBFFFF00F9FB
00FFFBFF05FE00FFFDFA0DF9FF00FEFFFF00EDFFFFF8FAFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9E9DBF7FFFFF8FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFF7E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3FAFF00FA
FBFBFFFB00FF04F0F811FDFDFC00FFFF00FFEBEFFFFFF900FFFFF6F8FFEEFFFFFFFA08F6
F901F6FFFF00F000FFFA03FDFFF6FFFF00E6FE03FFEFFFFFF6F70EF9FFFEF6FFF300FFFF
06FFFCFF00FF01FFFFFFF1FFFFFFFFFBEF0AFFF9FDFCFFFBFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFF8F4F8FEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFF2FDFF2FE3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF4FFFFFFFD07FF
FFF6FFFF09F200FFFF00FFFAFF05E9FF0000030F03FEFF00FFF4FFFFF6FFFF000006F1FF
FE00FBFFFE05FF00FFFB00FFFCFFFCF800FFF900F6FFED050000FFF7EEFF0B000CFFF2FA
05EBFFF900FF0000000005FFE6FF000009FEEAF5FFF7F3FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFEF0FFFFFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFBFEEEFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F0FF00FC
FCFFF4FC00FC0FFDE70AFFF2FF00FFF80BF8FFF500FFEA00FAFCFFF4FFF802FBF6FFFFFD
FC00FFFAFF00FF06EFFF00FCFFFCF9FF00FEF207FDF803F1FFFFFFFFFF06FFFAF8FFFFF8
00FFFFFF0BF400FFFFFF0EFFFF00FBFCFBFFFFF8FFFFFEF5FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEC785F5FEFEFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFCFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEDFFF6FFFE01FC
FFFEFCFF00FF01F1FF0000FFF005F0FF00FBFFFF00F2FF000FFFF3FFFFFB00FFFFFD03F8
FF02FFFDFF00FF00FFFB00FFFEFFFFFE05F6FF00FFF901FFFFF600FFFF00FFFFFF00FFFF
02FFEDF000FF05FBFFF400FAFA02FCFFFC00FDFFE9FBFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFBE47FBF9FCFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FDF7F0F6FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FCFFFAEF07FF
E7FFF1F70100000CF500FF0500FFFFFFFF000005FBFFF400F100FBFFE9F9FF000000FFFF
F1FA040000FF040008080000FFFBEF000000FF02F2FAFF010007FEFFFFFF000600F3FFE2
00F5FFFF00F7FF000004FFFFFFFF010003FFFDF6FFFEFFF2FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFB83CFFFFFFF9FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFEFF15E1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0FFF7F0FFFFF600
FFEDFF00FFFF00FFFF07F4F8F9FFFFFCFFF0FFFBFFF5FFF8FFF9FFFBFFF9FFFFFAFFEDF7
FFFFF7F8FAFFFF00FFF900FFF4FDFFF70DFFE5FFFFFFEEFFF5FFFFFFFAFFFEF9FFFFF8FF
FFFFFCF5FEFFECFFFFF6FFEEFAFFFDFEFFF6FFFAFAFFEDFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7B452EDF8FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFF9FFF627DCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFFFFFDEFFFFD
000300FFFFFF00FFFF00FFFFFFFFF0FFF2FFFFF8FFFDFFFFF9FFF9F8FFFBF2FFFFEFFFFF
FBF5FFFFFFFAF5FF000A00F9FFFFF8FF00FCFD0CFBFCFEF9FFF8FFF9FEFFFFF7FFF4FCFF
F4FFFDFFFFFEFBFFFDFEF8FFFFFAFFFFFFFFF7FFFFEBFFF2FFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFFFAC5FFF7FFF6FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFF9FFF627DCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FCFFF4FFFFFBFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFEFF15E1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9FFFFF5FFF9FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF6FDF7F0F6FFFFFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC177FFF7EFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFCFFFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF6F3D3FFFEFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFBFEEEFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1EBFFFFF5FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEFFF2FDFF2FE3F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F4FFFFF0FCFFF4FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFF1FFF7E3FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBC74F9FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFEF2FFFFFEFFF4FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4FFC439FFF7FBFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF5FFFFF6FFFDFDFCFFF3FDFFFBFFFCFFF1FFFFFFFAFDFF
FEF9F7FFFFFFFFFFFBFDFFF8FFFFFFF7FFFFFFFFF6FBFFFAFFF5FFFFF6FFF7FEFAFDFFFF
FEF6FFFCF3FDFFFCFFFFF1FFF9FEFFFFF9FCFFFCFEFEFFF9FFFBFFFEFFF9FFFFF0FFFFFE
FCFFF3FDFFFBFFFCFFF1FFFFFFFAFDFFFEF9F7FFFFFFFFFFFBFDFFF8FFFFFFF7FFFFFFFF
F6FBFFFAFFF5FFFFF6FFF7FEFAFDFFFFFEF6FFFCF3FDFFFCFFFFF1FFF9FEFFFFF9FCFFFC
FEFEFFF9FFFBFFFEFFF9FFFFF0FFFFFEFCFFF3FDFFFBFFFCFFF1FFFFFFFAFDFFFEF9F7FF
FFFFFFFFFBFDFFF8FFFFFFF7FFFFFFFFF6FBFFFAFFF5FFFFF6FFF7FEFAFDFFFFFEF6FFFC
F3FDFFFCFFFFF1FFF9FEFFFFF9FCFFFCFEFEFFF9FFFBFFFEFFF6CB40F6FCFFFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF5FFEFFAFB21E5FFFFFDFFFFFFFFF7FCFCFFFFFBF6FFFFFD
FFFFFFF5FAFFFFF8FFFFFCFFFBF9F9FFFCF9FDFDFFFFF9F3F7F4FFFBFFFFF8FFFFFAEDFE
FFFFFAFFFFFFFCF8F8FFFFFFFFFBFBF5FCFFFFFBFFFAF1FFFFFFF6FFFFF8F7FAFFFEF8FF
FFFDFFFFFFFFF7FCFCFFFFFBF6FFFFFDFFFFFFF5FAFFFFF8FFFFFCFFFBF9F9FFFCF9FDFD
FFFFF9F3F7F4FFFBFFFFF8FFFFFAEDFEFFFFFAFFFFFFFCF8F8FFFFFFFFFBFBF5FCFFFFFB
FFFAF1FFFFFFF6FFFFF8F7FAFFFEF8FFFFFDFFFFFFFFF7FCFCFFFFFBF6FFFFFDFFFFFFF5
FAFFFFF8FFFFFCFFFBF9F9FFFCF9FDFDFFFFF9F3F7F4FFFBFFFFF8FFFFFAEDFEFFFFFAFF
FFFFFCF8F8FFFFFFFFFBFBF5FCFFFFFBFFFAF1FFFFFFF6FFFFFEB33DFFFFF7FAFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFDFFF1FFFF28CBFFFDFCFFFEFBFEFCFFFFFEF5FFFFF7F2FB
F9FFFFFFFFFAFEFFFFFAF5FEFFFFFFFFFEFFFFF5F7F8EEFFFFFFFFF1FFFFF5FFEEFFFFFF
FFFFFFFFF4F3FFFFFFFEFFF7F9FAFFFFFFF0FEFBF4FFFFFAF7FFFFFDEEFFFEFCFFFFFCFF
FDFCFFFEFBFEFCFFFFFEF5FFFFF7F2FBF9FFFFFFFFFAFEFFFFFAF5FEFFFFFFFFFEFFFFF5
F7F8EEFFFFFFFFF1FFFFF5FFEEFFFFFFFFFFFFFFF4F3FFFFFFFEFFF7F9FAFFFFFFF0FEFB
F4FFFFFAF7FFFFFDEEFFFEFCFFFFFCFFFDFCFFFEFBFEFCFFFFFEF5FFFFF7F2FBF9FFFFFF
FFFAFEFFFFFAF5FEFFFFFFFFFEFFFFF5F7F8EEFFFFFFFFF1FFFFF5FFEEFFFFFFFFFFFFFF
F4F3FFFFFFFEFFF7F9FAFFFFFFF0FEFBF4FFFFFAF7FFFFFDFFFFF5CBF4FBFDFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF9FFFFEEFF07E4FFFCFFF5FFFFF5FFFFFFFFFDECFFF7FFFF
FFFFEBFFFFFFEDF6FEFFFFFAFFF4FFF9FDFAF9FEFFFFFFFFF3FFFBFFF0FFF8FFFFFFFFE8
FFF8FFF7FFFFFEFFF9F4FFFEFFF3FEF6FFF9FFFFFFFAFFFCFFF6FFFFFFFFF9FFEDFEFFFF
FCFFF5FFFFF5FFFFFFFFFDECFFF7FFFFFFFFEBFFFFFFEDF6FEFFFFFAFFF4FFF9FDFAF9FE
FFFFFFFFF3FFFBFFF0FFF8FFFFFFFFE8FFF8FFF7FFFFFEFFF9F4FFFEFFF3FEF6FFF9FFFF
FFFAFFFCFFF6FFFFFFFFF9FFEDFEFFFFFCFFF5FFFFF5FFFFFFFFFDECFFF7FFFFFFFFEBFF
FFFFEDF6FEFFFFFAFFF4FFF9FDFAF9FEFFFFFFFFF3FFFBFFF0FFF8FFFFFFFFE8FFF8FFF7
FFFFFEFFF9F4FFFEFFF3FEF6FFF9FFFFFFFAFFFCFFF6FFFFF5FFF3FFFFFFE7FFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF4FFF5EC3ADDF9FDFFFFFFFFFFFDF6FEFFFFFFFFF9FAF6
F7FFFFFFFDFFFFFFFEF5F5F6FFFFFFFBFFFFFAFFFBF2FFF2FFFBFCFFFFFFFFEDFDFAFCF9
FFFBFFFFFBFFF9FAFFFFFCFFFFFAFFF9FEF5FFF6FFFEFBF5FFFEFCF0FDF1F5FFFFFFFFF7
FDFFFFFFFFFFFDF6FEFFFFFFFFF9FAF6F7FFFFFFFDFFFFFFFEF5F5F6FFFFFFFBFFFFFAFF
FBF2FFF2FFFBFCFFFFFFFFEDFDFAFCF9FFFBFFFFFBFFF9FAFFFFFCFFFFFAFFF9FEF5FFF6
FFFEFBF5FFFEFCF0FDF1F5FFFFFFFFF7FDFFFFFFFFFFFDF6FEFFFFFFFFF9FAF6F7FFFFFF
FDFFFFFFFEF5F5F6FFFFFFFBFFFFFAFFFBF2FFF2FFFBFCFFFFFFFFEDFDFAFCF9FFFBFFFF
FBFFF9FAFFFFFCFFFFFAFFF9FEF5FFF6FFFEFBF5FFFEFCF0FFFFFFFFF5F7FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF9FBFFFBF6FEFFFFF3FFF3F2FFF4FFF9F5FAFFECFFFFFF
FFEDFBFAFFEAFEFFFFFFFCFFF6F8F4FFFBFAFBFFFFFFFFF7FFF6FFFBFBEAFFFFFBFFFFFF
EDFFFFF4FBFFFFF8FDFFF2FFFEFBFDFFFEFFFFFFFEFFFDFFFCFFFFFFFFFBFFF7F4FAFFF8
FFF3FFF3F2FFF4FFF9F5FAFFECFFFFFFFFEDFBFAFFEAFEFFFFFFFCFFF6F8F4FFFBFAFBFF
FFFFFFF7FFF6FFFBFBEAFFFFFBFFFFFFEDFFFFF4FBFFFFF8FDFFF2FFFEFBFDFFFEFFFFFF
FEFFFDFFFCFFFFFFFFFBFFF7F4FAFFF8FFF3FFF3F2FFF4FFF9F5FAFFECFFFFFFFFEDFBFA
FFEAFEFFFFFFFCFFF6F8F4FFFBFAFBFFFFFFFFF7FFF6FFFBFBEAFFFFFBFFFFFFEDFFFFF4
FBFFFFF8FDFFF2FFFEFBFDFFFEFFFFFFFEFFFDFFFCFFFFFFF6FFBC6DFFFAFAFCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFF1FFF2FAFFFAFFFFF5FFFFFFFFF6FCFBFFE9FFF7F5FFFFF7
FFFEFFFFF3FFFFF5EFFCFFF4FFFFFFFBFBFFFFEFFDFFEDFFFBFFF5FFFFFBF2FFFFECFFFF
FFF7FFFBFFE3FFFFFBFFFDF5F9FFFFFFECFFFBF5FFF8FDF5FFF8FDF7FFFAFFF6FEFFE8FF
F5FFFFFFFFF6FCFBFFE9FFF7F5FFFFF7FFFEFFFFF3FFFFF5EFFCFFF4FFFFFFFBFBFFFFEF
FDFFEDFFFBFFF5FFFFFBF2FFFFECFFFFFFF7FFFBFFE3FFFFFBFFFDF5F9FFFFFFECFFFBF5
FFF8FDF5FFF8FDF7FFFAFFF6FEFFE8FFF5FFFFFFFFF6FCFBFFE9FFF7F5FFFFF7FFFEFFFF
F3FFFFF5EFFCFFF4FFFFFFFBFBFFFFEFFDFFEDFFFBFFF5FFFFFBF2FFFFECFFFFFFF7FFFB
FFE3FFFFFBFFFDF5F9FFFFFFECFFFBF5FFF8FDF5FFF8FDF7FFFFE8D4FFF8FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF2FC4BBBFFF53A070007CBFBF73FBEFFFF37000C
00B9FFF147C1F5FF43050400CBFFF243C5F5F94B00020BB7FFEB4AB5FAFF41000300C1FF
F250B2FFFA450E0012B3FBFF3EBCFFEE4B0A000FBFFAFF50B1FFFF4206000AC5FFFA4AB2
FFF53A070007CBFBF73FBEFFFF37000C00B9FFF147C1F5FF43050400CBFFF243C5F5F94B
00020BB7FFEB4AB5FAFF41000300C1FFF250B2FFFA450E0012B3FBFF3EBCFFEE4B0A000F
BFFAFF50B1FFFF4206000AC5FFFA4AB2FFF53A070007CBFBF73FBEFFFF37000C00B9FFF1
47C1F5FF43050400CBFFF243C5F5F94B00020BB7FFEB4AB5FAFF41000300C1FFF250B2FF
FA450E0012B3FBFF3EBCFFEE4B0A000FBFFAFF50B1FFFF42000011BEEDFFF9FEFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Text",
 ImageSize->{720, 540},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],ImageRangeCache->{{{0, 1078.5}, {808.5, 0}} -> {-0.00359504, 0.99648, \
1.00001, 1.00001}}],

Cell["The compartments has been numbered as follow: ", "Text"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"Plasma\"\>"},
    {"2", "\<\"RBC\"\>"},
    {"3", "\<\"ST0\"\>"},
    {"4", "\<\"ST1\"\>"},
    {"5", "\<\"ST2\"\>"},
    {"6", "\<\"Liver1\"\>"},
    {"7", "\<\"Liver2\"\>"},
    {"8", "\<\"UrinaryPath\"\>"},
    {"9", "\<\"OtherKidney\"\>"},
    {"10", "\<\"TrabecularSurface\"\>"},
    {"11", "\<\"ExchTrabVol\"\>"},
    {"12", "\<\"NonExchTrabVol\"\>"},
    {"13", "\<\"CorticalSurf\"\>"},
    {"14", "\<\"CorticalVolExch\"\>"},
    {"15", "\<\"CorticalVolNonExch\"\>"},
    {"16", "\<\"Bladder\"\>"},
    {"17", "\<\"Urine\"\>"},
    {"18", "\<\"ULI\"\>"},
    {"19", "\<\"LLI\"\>"},
    {"20", "\<\"FEC\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Text"],

Cell["\<\
Transfer rates are taken from Table A.12.1. (ICRP 78) (For GI compartments \
are applied the trasfer rate included in ICRP 30]).\
\>", "Text"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Plasma to ST0\"\>", "\<\"k[1,3]->\"\>", "10.5`"},
    {"\<\"Plasma to RBC\"\>", "\<\"k[1,2]->\"\>", "0.245`"},
    {"\<\"Plasma to urinary bladder\"\>", "\<\"k[1,16]->\"\>", "15.43`"},
    {"\<\"Plasma to Kidneys (urinary path)\"\>", "\<\"k[1,8]->\"\>", "2.94`"},
    {"\<\"Plasma to other kidney tissue\"\>", "\<\"k[1,9]->\"\>", "0.0122`"},
    {"\<\"Plasma to ULI contents\"\>", "\<\"k[1,18]->\"\>", "0.122`"},
    {"\<\"Plasma to liver 1\"\>", "\<\"k[1,6]->\"\>", "0.367`"},
    {"\<\"Plasma to ST1\"\>", "\<\"k[1,4]->\"\>", "1.63`"},
    {"\<\"Plasma to ST2\"\>", "\<\"k[1,5]->\"\>", "0.0735`"},
    {"\<\"Plasma to trabecular surface\"\>", "\<\"k[1,10]->\"\>", "2.04`"},
    {"\<\"Plasma to cortical surfaces\"\>", "\<\"k[1,13]->\"\>", "1.63`"},
    {"\<\"ST0 to plasma\"\>", "\<\"k[3,1]->\"\>", "8.32`"},
    {"\<\"RBC to Plasma\"\>", "\<\"k[2,1]->\"\>", "0.347`"},
    {"\<\"Kidneys (Urinary path) to urinary bladder\"\>", "\<\"k[8,16]->\"\>",
      "0.099`"},
    {"\<\"Other kidney tissue to plasma\"\>", "\<\"k[9,1]->\"\>", "0.00038`"},
    {"\<\"Liver 1 to plasma\"\>", "\<\"k[6,1]->\"\>", "0.092`"},
    {"\<\"Liver 1 to liver2\"\>", "\<\"k[6,7]->\"\>", "0.00693`"},
    {"\<\"ST1 to plasma\"\>", "\<\"k[4,1]->\"\>", "0.0347`"},
    {"\<\"ST2 to plasma\"\>", "\<\"k[5,1]->\"\>", "0.000019`"},
    {"\<\"Cortical(Bone) surfaces to plasma\"\>", "\<\"k[13,1]->\"\>", 
     "0.0693`"},
    {"\<\"Cortical (Bone) surface to exch cortical volume\"\>", \
"\<\"k[13,14]->\"\>", "0.0693`"},
    {"\<\"Liver 2 to plasma\"\>", "\<\"k[7,1]->\"\>", "0.00019`"},
    {"\<\"Nonexch trab vol to plasma\"\>", "\<\"k[12,1]->\"\>", "0.000493`"},
    {"\<\"Nonexch cort vol to plasma\"\>", "\<\"k[15,1]->\"\>", "0.0000821`"},
    {"\<\"Cortical(Exch bone) vol to cortical (bone) surfaces\"\>", \
"\<\"k[14,13]->\"\>", "0.0173`"},
    {"\<\"Exch trabecular vol to nonexch trabecular vol\"\>", "\<\"k[11,12]->\
\"\>", "0.00578`"},
    {"\<\"Trabecular surface to plasma\"\>", "\<\"k[10,1]->\"\>", "0.0693`"},
    {"\<\"Exch cortical vol to nonexch cortical vol\"\>", \
"\<\"k[14,15]->\"\>", "0.00578`"},
    {"\<\"Exch trabecular vol to trabecular surface\"\>", \
"\<\"k[11,10]->\"\>", "0.0173`"},
    {"\<\"Trabecular surface to Exchan. Trabecular vol.\"\>", "\<\"k[10,11]->\
\"\>", "0.0693`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Text"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Bladder (16) to urine(17)\"\>", "\<\"k[16,17]->\"\>", "12"},
    {"\<\"ULI (18) to LLI(19)\"\>", "\<\"k[18,19]->\"\>", "1.8"},
    {"\<\"LLI (19) to FEC(20)\"\>", "\<\"k[19,20]->\"\>", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Text"],

Cell["The transfer coefficients for uranium are the following     ", "Text"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"uraniumModel", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "10.5`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "0.245`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "16", ",", "15.43`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "8", ",", "2.94`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "9", ",", "0.0122`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "18", ",", "0.122`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "6", ",", "0.367`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "4", ",", "1.63`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "5", ",", "0.0735`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "10", ",", "2.04`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "13", ",", "1.63`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "8.32`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "0.347`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8", ",", "16", ",", "0.099`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"9", ",", "1", ",", "0.00038`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6", ",", "1", ",", "0.092`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"6", ",", "7", ",", "0.00693`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "1", ",", "0.0347`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"5", ",", "1", ",", "0.000019`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13", ",", "1", ",", "0.0693`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"13", ",", "14", ",", "0.0693`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"7", ",", "1", ",", "0.00019`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "12", ",", "0.00578`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12", ",", "1", ",", "0.000493`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15", ",", "1", ",", "0.0000821`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14", ",", "13", ",", "0.0173`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14", ",", "15", ",", "0.00578`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10", ",", "1", ",", "0.0693`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "10", ",", "0.0173`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"10", ",", "11", ",", "0.0693`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16", ",", "17", ",", "12"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"18", ",", "19", ",", "1.8"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"19", ",", "20", ",", "1"}], "}"}]}], "}"}]}], 
   ";"}]}]], "Input",
 CellLabel->"In[88]:="],

Cell["\<\
The instant urine and faecal rate excrection for a single input 1 in \
compartment 1 can be evaluated as follow \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"qAcuteUrine", "[", "t_", "]"}], ",", " ", 
    RowBox[{"qAcuteFaecal", "[", "t_", "]"}]}], "}"}], "=", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "17"], "[", "t", "]"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "20"], "[", "t", "]"}]}], "}"}], "/.", 
     RowBox[{"AcuteInput", "[", 
      RowBox[{
       RowBox[{"CompartMatrix", "[", 
        RowBox[{"20", ",", "uraniumModel"}], "]"}], ",", 
       RowBox[{"PadRight", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "20"}], "]"}], " ", ",", " ", "t", ",",
        "  ", "x"}], "]"}]}], ",", "t"}], "]"}]}]], "Input",
 CellLabel->"In[89]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"6.484613617692128`", " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "37.94948560700169`"}], " ", "t"}]]}]}], "+", 
     RowBox[{"3.953084447283037`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "12.`"}], " ", "t"}]]}], "+", 
     RowBox[{"2.5080052914141464`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "5.378003510238967`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.001947897735365943`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.34363683318187904`"}], " ", "t"}]]}], "+", 
     RowBox[{"2.685122178966668`*^-32", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.14818320752681732`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.0029994770875514773`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1388439316660916`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.0005840636960549809`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.099`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.014921999311430179`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.09727564424805031`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.0021844405683457894`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03219349814880692`"}], " ", "t"}]]}], "-", 
     RowBox[{"2.2634663252126966`*^-33", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.01349679247318258`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.0008737625310680027`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.012583816550724013`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.00001023133768930539`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.0004821932901906764`"}], " ", "t"}]]}], "+", 
     RowBox[{"2.7619776330324106`*^-7", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00037973603767434827`"}], " ", "t"}]]}], "+", 
     RowBox[{"2.525624926913537`*^-7", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00018974063918824892`"}], " ", "t"}]]}], "+", 
     RowBox[{"1.4025513903034087`*^-6", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00008066471443852293`"}], " ", "t"}]]}], "+", 
     RowBox[{"7.541579132873775`*^-8", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00001892428233107539`"}], " ", "t"}]]}]}], ",", 
    RowBox[{
     RowBox[{"0.00014948719483443633`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "37.94948560700169`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.0012619446795849047`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "5.378003510238967`"}], " ", "t"}]]}], "-", 
     RowBox[{"0.013687718817788049`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "1.8`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.01215827777395673`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "1.`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.00003052454682865521`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.34363683318187904`"}], " ", "t"}]]}], "+", 
     RowBox[{"4.411559269348168`*^-34", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.14818320752681732`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.00005601548390795336`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1388439316660916`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.00001147836425659769`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.09727564424805031`"}], " ", "t"}]]}], "+", 
     RowBox[{"0.00001413213895741261`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03219349814880692`"}], " ", "t"}]]}], "-", 
     RowBox[{"2.1477818630572665`*^-35", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.01349679247318258`"}], " ", "t"}]]}], "+", 
     RowBox[{"5.7773644735017105`*^-6", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.012583816550724013`"}], " ", "t"}]]}], "+", 
     RowBox[{"6.794404523969045`*^-8", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.0004821932901906764`"}], " ", "t"}]]}], "+", 
     RowBox[{"1.8341975864348945`*^-9", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00037973603767434827`"}], " ", "t"}]]}], "+", 
     RowBox[{"1.6772871011563853`*^-9", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00018974063918824892`"}], " ", "t"}]]}], "+", 
     RowBox[{"9.314603200838196`*^-9", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00008066471443852293`"}], " ", "t"}]]}], "+", 
     RowBox[{"5.008547281364716`*^-10", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00001892428233107539`"}], " ", "t"}]]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280660188252*^9, 3.479966545714038*^9, 
  3.479966760008038*^9, 3.479967345371038*^9, 3.479968237180038*^9, 
  3.513396439642598*^9, 3.582349733315754*^9, 3.582350846176756*^9, 
  3.5823513786601305`*^9, 3.642760943413587*^9, 3.6502697991776085`*^9},
 CellLabel->"Out[89]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"qAcuteUrine", "[", "t", "]"}], ",", " ", 
     RowBox[{"qAcuteFaecal", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "2", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[90]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVz31UjHkUB/Bn6vRq9TzPr5kySZqe9ZK0dSJWHK60sr1Ik+QMRRFWKO1S
u5ikhrG2102sSoNUtIrobSVXGxNGSWwlxq5Rp7dtcFQU2mf/uOd7Pud8z73n
SiKipZEGFEX58/N/PsJeER/gLFnzVl9JY4bxszhjIwrE4YZdyioaV/k1dXxh
TkFCsDBbUk1jU1t5nlhIQcDptHnSGhrvDu6bNmcmBd+4qA5fvk4j2lq4b1lF
wTOnWtMIpLE03m21RkXBZK3AJ+8ujUdd92WeXCoA5dODgqxOGmc7vRMtPm0A
2jBBg4JiULckvb9RZwgNCgmVyDLom7Vw9LWDEYyGFbh0SRhUfd9ETz9gDJK2
JYflcxg03ZkcB2gCEdtD7t9bxmDoG0n3VjszKL/5R+OaYAY3VzSlzN5rDgWL
FZf2bGFQ/uvpI39VTgBZ24gwZC+Dio/ByhQyEd4H5G+IO8JgfoJrp2OIBfgk
mmwJO8FglKfN1k3HaQB7rfc/hQyyjUMfV8cxkDY/6XZ+FYMjY9H67ZNYqGnq
8nVSMxg0FBppomYh5U2TXN/GoDK1NS42loCkSjcU0MOg+ppszipiCf157dKk
EQb3q4Jjr920BL3msnDAhMWF4gjZsXAhlMdVV82yZjEm5OXtHkYE4qAK49wZ
LMrd+x4Ib4ggt5jdcGk+i9kqw4SroVZQn6bV/LacxS9b0q+2T7CGdVnbHles
YbE21SUjptQafOSWJ8oiWXQeCJ7Q5j8J9uQNXl75A4tC+rVpw+gkmJhYvN8m
mUWjmzllXK4YWpopZWMmizvmXu8w87WB8p2zWlVnWfz92whV3bANbDu7JMqu
nMXhfhumO3syTK15dPwQslgZ5G2Y5WULIa86nS0esnhwhSL/WrctJNVX/3xI
y6LDc5/2c4opMG44fko1wP87PzlL7GYH5x3FW3VjLIbaNX8QtNpBUlG4mpgT
HL6X8jImcSrcX59xZrOYoJ+Bi4cjsYcjb9Lo8zMImutlgYIIe6hcZOOb4U4w
qQ4u5lbbw9f5RpvzvAgmri4L2W0mgU61X0aOlKDHg7blZuESuBrftaMqnOAL
kVeyaZUE3urW3pLHEDSbtsBqqYkDHFt2JXOhnOCgVU/vojAHeFE5FG+ZQnBt
81QSW+YAf+/8N/vlKYJlITlKi3EHmHxsb8HGYoK36h/CrmAOAp+t9Rqp5Pvv
Uv1NCjlIyPRzUzYQvNPk6RpdxIGZNL2kgffcC8OkrZiDGL2eE9wmSIeFtReW
cBCuMyA/8b6jdt60/AoHbr/E66LuEHTP0cQrajl4UndhXUAjQeJpXmDYyoGV
u+yMSEPwoG3d4ajHHJQ+mfk5kPfg8O7vWp9wIPQXylJ53y3p+OpcOwd67VLa
5AHfF12o8dRyII58v+s9b32Pd3NiLweORR2Gnc0E1/85dqW3j4OCFT9KrR8S
vJdXlhU4wEG9xzxVEO9CqbVMoudgiovpAg3vsNruV/iOgwNOEzfeaCGoyT6l
njnMwbJpJ4s+8PbYvfJi+gh/vwQG3R8RFE2vjN44ysGnA33xpbwPUduljWMc
yNr7a/t4v346xd31EwcnnptTM1r5/RUt1ic/c+B83NtzE29NmmJ0fJyDLOOz
Sfm8/wN9LzIc
      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVzH0w1HkcB/Blz8OqXezZlrXW7u/7a0dTSR7q8pAPNVxKaSMyMRI9utbK
tDrlobPhGlJJdRKTomhyFHV56NP14OE2Tq7YCnPpPJSiTro83N7v/njPe14z
73nLopWKWEMWixXI5P9+giMCpmDScHnivl0iPGH8Um1sxILjkR+8fPaIMGhd
u26uGQtsnQe2WMWJsL27psjGigUJ31CZ9UoRtr5Pnu/iwIKiUxbXuWoRopjn
tiOIBX//Vj2IGhFeT3IO1pawYNU7lS6qVITZTsknz/oYgCzOYMOBfhEuWjgh
WHnBELKOWxTrY2xxwDvvbcsAG6JPjma/eG2La/M9psYpI+joli/dGiPGkv3t
5vLDxrCIVsUFjIvR9LsMNaAJpDQm+tzbb4cRH2SDOyUcaLrocS3DUIIxte05
iw6YgURZmxKRK8GUUxcyn9XNAY66X2dsYY+amZCsHD4X8oT+PO9CeyxOdXqx
IJQH03+Wa+9wpbjXV7Rz+2lz0NcqK46tlaJly6eZYLUFsA26XnnlSPHztHJs
j7Ul5KkzG7itUtz0KSLWpNkSuIqLH7mmMszK7VInJPChpTimT7dKhs03w12C
+F/D88sxniUHZXioJCTh5l3Gn4eHiqtl6GETHX5smxVs28FzPDMgw/jQVw+H
LQRgeSgmTCKkMMXtzWOrRgHM7T/jPetHYUEJO/VGxDxIsPNOdVRRSHfm3eiZ
I4TLR1blup+nsCF3yYn460JQs7Sew/coXDwaMqc70Bo+yoMas15TaGU+bvpg
yho2t12YOW1C0OhuYRU5bwPBYV+eG8sJxrnW6zhrRTD/nwcbKlYTvLYmuqRp
UgQ/lrdcS40iOPlWZDFYYAuXSs1yTicRrNvkz85fLQayZq6wPY9g2rea4puD
YijT7h59cJkg1RvQU6qxg8HCDhy6TdBjeUa+jbMEPMILeCu0BCMkHV8MuiQQ
ybu9lN3L/LflvIpPt4cV9WuG9O8IrjNc4r6ALwXPvqyepzMEzcbCNxpESyEg
cPPiDDMaf2iCivO3pcDR8aMOW9OYHlwVquLIIHfWu/MxTaP7424/zjYZUImz
iaqlNPYLVmeY3pKB2CG6brkXjZz5K+b5mFBgPNJaVONP4/t5wyOekRRsudLS
eFJBY1iHPT+hioJN9c7xG7fSWBVamMXTU5CmYNdkxtJ479ffYV8IAU2yV5+j
ktlP5AaalBF40vskakhN46N2XydlOQHWMucGbhKNrlcn+d1XCBgkl/JdGZtH
RvaUVRLopR7+nMb4UfPi7X7VBBRf+dXYHKTRrVCbpGkg4HbWVxvwPY18X7NL
7C4ChZUmcVcP0Zgmbjq69w8C9AG+Ywfj95Oq3V1PCaTsV7+dYNxaqXMs7SHw
4k5YGBxm9oKrv/j2EWija6eeMR4b9u9IHyGgL6vbzk6lcev96eqRNwTGXHa+
dGDcVlSVv3GUwF/L8oPWMy5TCMNlYwR2GcUtPMc4smHwNU4Q6N8QWOmYRqO2
4Kdmh0kCu6ViVjBjd9X6irzPBOSCpKCDjAXyOmXUFLOv7B+4z/gIa4+iZZrA
yr1j8hHG48/t3JxmCZzLzo/lpTP/tZ3Cs/8SuMXvLHZhrD2umdLrCbhalj8N
Y/wfqRUndQ==
      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{2, -10.567046180547209`},
   CoordinatesToolOptions:>{"DisplayFunction" -> ({
       Part[#, 1], 
       Exp[
        Part[#, 2]]}& ), "CopiedValueFunction" -> ({
       Part[#, 1], 
       Exp[
        Part[#, 2]]}& )},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{
      Charting`ScaledTicks[{Log, Exp}], 
      Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{2, 10}, {-10.567046180547209`, -3.64990954788584}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->FrontEndValueCache[{Automatic, 
      Charting`ScaledTicks[{Log, Exp}]}, {Automatic, {{-9.903487552536127, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "5.`", 
           TemplateBox[{"10", 
             RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], TraditionalForm], {0.01, 
        0.}, {
         AbsoluteThickness[0.1]}}, {-9.210340371976182, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "1.`", 
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], TraditionalForm], {0.01, 
        0.}, {
         AbsoluteThickness[0.1]}}, {-7.600902459542082, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "5.`", 
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], TraditionalForm], {0.01, 
        0.}, {
         AbsoluteThickness[0.1]}}, {-6.907755278982137, 
        FormBox["0.001`", TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.298317366548036, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.605170185988091, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-10.819778284410283`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-10.41431317630212, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-10.126631103850338`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-9.721165995742174, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-9.567015315914915, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-9.433483923290392, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-9.315700887634009, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-8.517193191416238, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-8.111728083308073, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7.824046010856292, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7.418580902748128, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7.264430222920869, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7.1308988302963465`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-7.013115794639964, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-6.214608098422191, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.809142990314028, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.521460917862246, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.115995809754082, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.961845129926823, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.710530701645918, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.912023005428146, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.506557897319982, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.995732273553991, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.659260036932778, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.916290731874155, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}}]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806603602905`*^9, 3.4799665458330383`*^9, 
  3.479966760110038*^9, 3.479967345540038*^9, 3.479968237280038*^9, 
  3.513396439861354*^9, 3.58234973347477*^9, 3.5823508463387723`*^9, 
  3.5823513788326445`*^9, 3.6427609434917655`*^9, 3.6502697992557335`*^9},
 CellLabel->"Out[90]="]
}, Open  ]],

Cell["\<\
The same problem asuming a constant intake (chronic) an single input 1 in \
compartment 1 can be evaluated as follow \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"qConstantUrine", "[", "t1_", "]"}], ",", " ", 
    RowBox[{"qConstantFaecal", "[", "t1_", "]"}]}], "}"}], "=", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "17"], "[", "t1", "]"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "20"], "[", "t1", "]"}]}], "}"}], "/.", 
     RowBox[{"SystemDSolve", "[", 
      RowBox[{
       RowBox[{"CompartMatrix", "[", 
        RowBox[{"20", ",", "uraniumModel"}], "]"}], ",", 
       RowBox[{"PadRight", "[", 
        RowBox[{
         RowBox[{"{", "0", "}"}], ",", "20"}], "]"}], " ", ",", 
       RowBox[{"PadRight", "[", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", "20"}], "]"}], ",", " ", "t", ",", " ",
        "t1", ",", " ", "x"}], "]"}]}], ",", " ", "t1"}], "]"}]}]], "Input",
 CellLabel->"In[91]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0.9934025524551214`", "\[VeryThinSpace]", "+", 
     RowBox[{"0.17087487521822203`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "37.94948560700169`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.32942370394025305`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "12.`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.46634504545027816`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "5.378003510238967`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.0056684777278661665`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.34363683318187904`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.021603227822480402`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1388439316660916`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.0058996332934846555`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.099`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.15339913116771015`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.09727564424805031`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.06785347023329753`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03219349814880692`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.06943541552326035`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.012583816550724013`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.021218332767051887`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.0004821932901906764`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.0007273414580158998`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00037973603767434827`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.001331093295415627`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00018974063918824892`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.017387421502277012`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00008066471443852293`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.003985133491952727`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00001892428233107539`"}], " ", "t1"}]]}]}], ",", 
    RowBox[{"0.006597447544884309`", "\[VeryThinSpace]", "-", 
     RowBox[{"3.939109910013007`*^-6", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "37.94948560700169`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00023464928521938267`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "5.378003510238967`"}], " ", "t1"}]]}], "+", 
     RowBox[{"0.007604288232104472`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "1.8`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.01215827777395673`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "1.`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00008882792495209402`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.34363683318187904`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00040344207511111145`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.1388439316660916`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00011799833704856444`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.09727564424805031`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00043897494121608355`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.03219349814880692`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00045911067204562107`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.012583816550724013`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00014090624366179576`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.0004821932901906764`"}], " ", "t1"}]]}], "-", 
     RowBox[{"4.830190986529055`*^-6", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00037973603767434827`"}], " ", "t1"}]]}], "-", 
     RowBox[{"8.83989380626195`*^-6", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00018974063918824892`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.00011547308219800544`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00008066471443852293`"}], " ", "t1"}]]}], "-", 
     RowBox[{"0.000026466246876586845`", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "0.00001892428233107539`"}], " ", "t1"}]]}]}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399280661079726*^9, 3.479966546357038*^9, 
  3.4799667609320383`*^9, 3.479967349731038*^9, 3.479968237740038*^9, 
  3.5133964405488715`*^9, 3.582349742735696*^9, 3.582350846880827*^9, 
  3.5823513793764377`*^9, 3.642760943741716*^9, 3.6502697995526123`*^9},
 CellLabel->"Out[91]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"qConstantUrine", "[", "t", "]"}], ",", " ", 
     RowBox[{"qConstantFaecal", "[", "t", "]"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "2", ",", "100"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[92]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVjXk81AkfxyfZGLbkKLcwcqwjGyXJy9dgHEWD6JdKHtLqSWxhcuWIULuO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      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1Ws4lVkbB/CN7Vw5rWfHto0QEjqohJKbnDKYTehpEg1GSl6HESIROZQI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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{2, -5.917107858249308},
   CoordinatesToolOptions:>{"DisplayFunction" -> ({
       Part[#, 1], 
       Exp[
        Part[#, 2]]}& ), "CopiedValueFunction" -> ({
       Part[#, 1], 
       Exp[
        Part[#, 2]]}& )},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{
      Charting`ScaledTicks[{Log, Exp}], 
      Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{2, 100}, {-5.917107858249308, 0.2781831943329326}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->FrontEndValueCache[{Automatic, 
      Charting`ScaledTicks[{Log, Exp}]}, {Automatic, {{-5.298317366548036, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.605170185988091, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.995732273553991, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.6931471805599453, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3.}]& ], TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {0., 
        FormBox["1", TraditionalForm], {0.01, 0.}, {
         AbsoluteThickness[0.1]}}, {-6.907755278982137, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-6.214608098422191, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.809142990314028, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.521460917862246, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-5.115995809754082, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.961845129926823, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.8283137373023015`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-4.710530701645918, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.912023005428146, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.506557897319982, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-3.2188758248682006`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.8134107167600364`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.659260036932778, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.5257286443082556`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-2.4079456086518722`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-1.2039728043259361`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.916290731874155, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.5108256237659907, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.35667494393873245`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.2231435513142097, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {-0.10536051565782628`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {0.6931471805599453, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.0986122886681098`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.3862943611198906`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.6094379124341003`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.791759469228055, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {1.9459101490553132`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.0794415416798357`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.1972245773362196`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.302585092994046, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.3978952727983707`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.4849066497880004`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.5649493574615367`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.6390573296152584`, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.70805020110221, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}, {2.772588722239781, 
        FormBox[
         InterpretationBox[
          StyleBox[
           
           GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
            Baseline], "CacheGraphics" -> False], 
          Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
         AbsoluteThickness[0.1]}}}}]], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280661361244*^9, 3.479966546536038*^9, 
  3.479966763529038*^9, 3.479967350449038*^9, 3.4799682378620377`*^9, 
  3.513396442470796*^9, 3.5823497429427166`*^9, 3.582350847030842*^9, 
  3.582351379555202*^9, 3.6427609437886004`*^9, 3.650269799599484*^9},
 CellLabel->"Out[92]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{
   "uraniumModel", ",", "qAcuteUrine", ",", " ", "qAcuteFaecal", ",", " ", 
    "qConstantUrine", ",", " ", "qConstantFaecal"}], "]"}], ";"}]], "Input",
 CellLabel->"In[93]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Variable clearances", "SubsectionIcon"],

Cell[TextData[{
 "\n",
 Cell[GraphicsData["Metafile", "\<\
CF5dJ6E]HGAYHf4PEfU^I6mgLb15CDHPAVmbKF5d0@0002gP0@0005P0000400000`000?X000090@00
00000000000F6@00gaX00215CDH00040h2d00;@000090000000000000000000080<005P2003C0000
WP0004H000342P00^0X004M4BD<1002000<00?<eFF000000X0X000402@000dL5000:01D0000001@0
000V1Pl07P3ooooo100D0000EfmbI0h0CFUSLVmcKfId85M_LV@500002`8000001@0000`2c`>>0`d0
003k0P00000000000000000000000@0<100002d1000400000P4100D000090P00008E0000n`;4o`00
00000901000000A0019DJFeULb1>IGLPDVm]HFh0H0040000;@4100<0000N00L0000F1<l3SP<00000
400002H63`0F0?ooool00?ooooooooooU0<00=03000300007P040000;P4000D0000:0P0000050000
2@8000001@000042oooo00L0003l0P4000000000100002d10P090000nP850000003oool08P040000
;@4300@000030@P01`000184c`??0hh3T`<500002`8000001@0000`2aP2j00D0000<0/H0^P040000
104=00@0000^0AP0100000810@0500002@8000001@000042oooo00<0000N00@000040@L05@000?/2
l_l00000002l0P000004000@E6U]IG<PCVEg859_KF5^01D0100002d1100500002`;ooooo1`000245
0@0b01X0I`0700005PC30;L0000000@000040@d01`000?`20@00000000040000;@4500T0003j0PH0
0@000000000R00@0000]0@H01`0001/4:P210040DP0700008@D10340G`1V00L0000K16l0P0160540
2P0002H63`0:0?ooool0000000070000o0800000000000@0000]0@L02@000?X21@000000oooo0280
100002d1200<000090<406h0A`1Z03`0LP0l06h0A`040000;@4600D0000D0RX0KP0500004`9406h0
2P0002H63`0:0?ooool10000000E0000n`;do`0000000901000000@0011DJFeULb1>IGLPDVm]HFh0
M@040000;@4900@0003`0@@01`0002450@1;03X0BP0E0000n`;go`0000000901000000@0011DJFeU
Lb1>IGLPDVm]HFh05@040000;@4400@0003`0@T01`0002450P0a<T00DP0E0000n`;do`0000000901
000000@0011DJFeULb1>IGLPDVm]HFh0M@040000;@4900@0003`0@@01`0002450@1;03X0MP0E0000
n`;go`0000000901000000@0011DJFeULb1>IGLPDVm]HFh05@040000;@4400@0003`0@T01`000245
0P0b<D00OP0E0000n`;do`0000000901000000@0011DJFeULb1>IGLPDVm]HFh0M@040000;@4900@0
003`0@@01`0002450@1403X0WP0E0000n`;go`0000000901000000@0011DJFeULb1>IGLPDVm]HFh0
5@040000;@4400@0003`0@T01`0002450P1YMSh0YP0:00009PH?00X0ooooo`00000000@0000]0@P0
300002@3101S02X0I`0e05l0=@1S02X0100002d11P050000508/06<01@0001<2AP1S00X0000V1Pl0
2P3ooooo0@0000002P0002H63`0:0?ooool0000000040000;@4800`0000T0`@0X01G09D0F`2E05<0
X01G00@0000]0@H01@0001@2E`2000D0000C0UL0W@0:00009PH?00X0ooooo`40000001D0003k0_Co
00000000T0400000100045AYKFEc84iUMb1BKfeQKP1e00@0000]0@T010000?01100700008@D104/0
H`2301D0003k0_Oo00000000T0400000100045AYKFEc84iUMb1BKfeQKP0E00@0000]0@@010000?01
2@0700008@D2034`J@2;00X0000V1Pl02P3ooooo00000000100002d1200<000090<402l0E`0j05<0
>P1K02l0E`040000;@4600D0000D0UL0D@0500004`9G03402P0002H63`0:0?ooool10000000E0000
n`;do`0000000901000000@0011DJFeULb1>IGLPDVm]HFh0M@040000;@4900@0003`0@@01`000245
0@1;0680?@0E0000n`;go`0000000901000000@0011DJFeULb1>IGLPDVm]HFh05@040000;@4400@0
003`0@T01`0002450@0a06H0AP0700008@D106L0IP1;00@0000]0@D01`0001/4K`0a04H00P0E0000
n`;bo`0000000;`2000000@0011DJFeULb1>IGLPDVm]HFh0M@040000;@4900@0003`0@@02@000245
1@12JFaYL`1O00X02P0002H63`0:0?ooool0000000040000;@4700@0000]0@P0300002@3100G09T0
4`2>01/0SP0G09T0100002d11P050000509^01L01@0001<2UP0G00X0000V1Pl02P3ooooo0@000000
100002d11@0700006`C00340U`0200L0000Q1@80AfV`00l02P0002H63`0:0?ooool0000000040000
;@4700@0000]0@P0300002@3101Z06l0IP1j0600M01Z06l0100002d11P050000509`06P01@0001<2
[00a00X0000V1Pl02P3ooooo0@0000005@000?/2m?l00000002@0@000004000@E6U]IG<PCVEg859_
KF5^01D0100002d110040000l04900L0000Q1@40B`2903d05@000?/2mol00000002@0@000004000@
E6U]IG<PCVEg859_KF5^07D0100002d12@040000l04400L0000Q1@40H@2<04H0100002d11@070000
60B401d0N@0B00D0000D0WD07`0500004`:600l02P0002H63`0:0?ooool0000000040000;@4700@0
000]0@P0300002@3102204`0R@1308d0B`2204`0100002d11P050000509508`01@0001<2BP2300X0
000V1Pl02P3ooooo0@0000001`000?`2003oool000040000;@4400@0000]0@P0400002@31P2<04D0
T`140900?`2I0440U@0k09`0>P040000;@460100000U0`H0S01509<0A02@03l0V@1109D0>`2L03X0
400002D31P2<04D0T`140900?`2I0440U@0k09`0>P0400009`7oo`@0003`0@D010000?0120040000
;@4400T0003j0P0000000000000R00@0000]0@D0100002L1ool800009PH?00H0ooooo`40100002L1
ool=0000<PZI0i<30@040000002>0ll3800K00@0000]0@000`000000oooooooooooooooooooooooo
4@0000`0000800002`000100003c00001@4000T0000@0000l`0000D1000:00004000000000000000
2@000100002>0`00c`<00180000<00000@0001P0000<000000000U80001<0@000@000<Coool00000
00000000002@0@00000000A0019D06T0K@1U07<0801>06D0M`0P0580K`1]0640KP0000L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`000000000000071`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L70?l71`L71`L000L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L7n0L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L700000000000000000000000000000000
0@410@410@410@L79@0000`0000100008@0000P0000N00006000000000000000SP<00<l3000Q0000
200001P0000<000000000140000<0000200001l0000H0000T`<008h3003?0`00c`<000X0000@0000
000000000009000040000;X0003600002@000100002j0000aP0001H0000<0000600002H0000L0000
0P0000D00000000000000?ooo`0U000030000080000W0000600000<00001000000000000000U0000
300000<0000Q0000200001@0000<00001`0000X0000@0000oooooooooomB0000C04000@0003boooo
0000000000000000_08000000004000@E01Y06d0I@1c0200CP1U07L0801B06l0K@1Q06h000071`L7
1`L71`L71`L71`Oh1`000?ooool71`L71`L000001`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L700L71`L71`L01`L71`L71`L71`L71`L700071`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L0000000001`L71`00000000000000000000000000
000000410@410@410@471bD0000<0000100005@0001D0000R00002@0002@0000=`000040003II@Y2
M14;@VL0000J00000@0004`000000000000000000000000000000500000b00L71`0001h0000H0000
00000000002g0000``0001@0000<00003@0002H0000L00001@0000H00001000000000000000U0000
300000D0000W0000600000H00001000000000000000U0000300000H0000[00006000058000010000
P@0002T0001D0000E00008L0001o0000S`00098000010000fFD:@W@A2d9V0000G`000040001<0000
000000000000000000000000001@0000<@3oo`L0000[00006000054000160000O`0006l0000V0000
700000L00005000000000000003oool09@0000`0000700009@0000`000040020EP0002`0002<0000
D00009L0001O0000100006h0A`1Z03`0LP0l06h0A`0K0000400006h0000Z00009@0000`000050000
=P000100001^0000A0000580001<0@0020000?Coool0000000000000002@0@00000000@0011D06T0
K@1U07<0801>06D0M`0P0580K`1]0640KP000?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn03oo`00
003ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
ooooooooool00?ooooooooooooooooooooooooooooooZ?4000000?Shn?Shn?Shn?Shn?Shn?Shn?Sh
n?Shn?Shn?Shn?P0000000000000000000000000000000000@410@410@410Ooo9@0000`000080000
:00000`0000400009@0000`000080000E00005@0001R0000CP0006d0001P00000@000=UU2T9d4@]2
BP0003X000010000C0000000000000000000000000000000D00004/0ool90000DP0004`100040000
moooo`00000000000000090100000000100045@0J@1]06D0L`0P04h0I@1g0200DP1_06d0H@1^0000
oooooooooooooooooooooooooooooooooooooooo00000?oooooooooooooooooooooooooooooooooo
oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
ooooool000000000n?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn000n03ooooooooooooooooooooo
ooooooooooooooooooooooooooooooooooooooooooooooooooooooooool000000000000000000000
0000000000010@410@410@41oolU0000300000@0000X0000300000P0000U0000300000@0001D0000
F00006d0001F0000N00006@000010000fFD:@W@A2d9B0000@0000080001<00000000000000000000
00000000001@0000<@0b00@000050000DP0004`100080000m?ooo`00000000000000090100000000
100045@0J@1]06D0L`0P04h0I@1g0200DP1_06d0H@1^0000oooooooooooooooooooooooooooooooo
oooooooo00000?ooooooooooooooooooooooooooooooooooo`000000003hn?Shn?Shn?Shn?Shn?Sh
n?Shn?Shn?Shn?Shn?Sh0?oooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
ooooooooooooooooooooo`00ooooooooooooooooooooooooooooooooooooooooooooo`L71`L71`Oo
1`L71oSo1`L71`L71`0000000000000000000000000000000000000000010@410@410@41oolU0000
300000P0000X0000300000@0000U0000300000P0001D0000E00009`0001>0000Y`00060000010000
fFD:@W@A2d9f0000>P000040001<0000000000000000000000000000001@0000B`3oo`T0001B0000
C04000@0003goooo0000000000000000T04000000004000@E01Y06d0I@1c0200CP1U07L0801B06l0
K@1Q06h0003oooooooooooooooooooooooooooooooooooooool00000oooooooooooooooooooooooo
ooooooooooooooooooooooooooooooooooooooooooooooooooooooooo`L71`L71`L71`Oo1`L71ooo
oooooooooooooooooooooooooooo1`L71`L71`L71ol71`L7n?l71`L71`L7000000000?oooooooooo
ooooooooooooooooooooool71`L7ooooooooooooooooooooooooooooooooooooooooo`0000000000
0000000000000000000000410@410@410@7oobD0000<0000100002P0000<0000200002D0000<0000
100005@0001H0000Y`0005H0002b0000I0000040003II@Y2M14;@Wh0001000000P0004`000000000
000000000000000000000500000b0340100000D0001B0000C04000P0003doooo0000000000000000
T04000000004000@E01Y06d0I@1c0200CP1U07L0801B06l0K@1Q06h000071`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L000001`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`Oho`L71`L71`L0000000001`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L700071`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`00000000000000000000000000000000410@410@41
0@471bD0000<0000200002P0000<0000100002D0000<0000200005@0001D0000d@0004h0003K0000
H0000040003II@Y2M14;@Yh0000j00000@0004`000000000000000000000000000000500001400L7
20000580001<0@0010000?Ooool0000000000000002@0@00000000@0011D06T0K@1U07<0801>06D0
M`0P0580K`1]0640KP0000L71`L71`L71`L71`L71`L71`L71`L71oSo1`L71`000000000000071`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L000L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
000000000000000000000000000000000@410@410@410OSh9@0000`000040000:00000`000080000
9@0000`000040000E00005P0003K0000D`000><0001Q00000@000=UU2T9d4@]2YP0003h000020000
C0000000000000000000000000000000D00006T0MP0200001@0002D0000<00001`0005H0000/0000
OP0003T000280000A`0000@0001S02X0I`0e05l0=@1S02X06`000100001S0000;00002D0000<0000
1@0003H0000@0000H`0004H0000U0000300000L0001F0000;0000<D0001_0000d`0007T000040000
X01G09D0F`2E05<0X01G01/0000@0000P00005L0000U0000300000D0000f0000400009d0001G0000
DP0004`100080000m?ooo`00000000000000090100000000100045@0J@1]06D0L`0P04h0I@1g0200
DP1_06d0H@1^00000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L00000
00000000000000000000000000010@410@410@411`LU0000300000P0000X0000300000@0000U0000
300000P0001D0000E0000:d000240000^00009H000010000fFD:@W@A2d:30000H`000040001<0000
000000000000000000000000001@0000B`071`T0001B0000C04000@0003goooo0000000000000000
T04000000004000@E01Y06d0I@1c0200CP1U07L0801B06l0K@1Q06h000071`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L000001`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`00000000071`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L700071`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L700000000000000000000000000000000000000410@410@41
0@471bD0000<0000100002P0000<0000200002D0000<0000100005@0001H0000^00008`000330000
VP000040003II@Y2M14;@X/0001Y00000P0004`000000000000000000000000000000500000a0300
100000D0000U0000300000L0001F0000;00003l0001_0000C@0007T000040000;`1G03X0D`0j05/0
;`1G01/0000@0000D@0005L0000U0000300000D0000f000040000340001G0000DP0004`100080000
m?ooo`00000000000000090100000000100045@0J@1]06D0L`0P04h0I@1g0200DP1_06d0H@1^0000
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7000000L71`L71`L71`L71`L71`L71`L71`L0o`L7
1`L71`071`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`00000000071`L71`L71`L71`L71`L71`L71`001`L71`L71`L71`Ohn?Shn?Sh
n?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?P000000000000000000000
0000000000010@410@410@411`LU0000300000P0000X0000300000@0000U0000300000P0001D0000
E000054000230000G00009D000010000fFD:@W@A2d8m0000HP000040001<00000000000000000000
00000000001@0000B`3hn0T0001B0000C04000@0003goooo0000000000000000T04000000004000@
E01Y06d0I@1c0200CP1U07L0801B06l0K@1Q06h000071`L0oooooooooooooooooooooooooooooooo
ool00000oooooooooooooooooooooooooooooooooooooooooooooooooooo0000000000L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71oShn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Sh
n?Shn?Shn?Shn?Sh003hn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn?Shn03o1`L0oooooooooooo
ooooooooooooooooooooo`00000000000000000000000000000000410@410@410@7oobD0000<0000
100002P0000<0000200002D0000<0000100005@0001D0000G@0008P0001R0000UP000040003II@Y2
M14;@TH0001V00000@0004`000000000000000000000000000000500000a0?Sh1@0005@0001D0000
I00008P0001X0000UP000040003II@Y2M14;@T/0001V00000@0004`0000000000000000000000000
00000500001W0?oo100002D0000<00001P0002/0000H00000P0004H0000a0000K`000580001<0@00
20000?;oool0000000000000002l0P00000000@0011D06T0K@1U07<0801>06D0M`0P0580K`1]0640
KP000?Sh0?Shn?Shn?Shn?Shn0L0ooooooooooooooooo`00003oooooooooool00?oooooooooooooo
ool0oooooooooooooooooooo0?ooooooooooooooo`3o0000000000L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L70?Shn?Sh0?Shn?Shn03hn?Shn?P0n?Shn?Shn03hn?P0003hn?Shn?P0n?Shn?Sh
0?Shn?Shn?P0n?Shn?Sh0?Shn?Shn03hn?Shn?P0n?Shn?P70?ooooooo`3ooooo0000000000000000
00000000000000000@410@410@410@L79@0000`000080000:00000`0000400009@0000`000080000
E00006`0000>0000O`0002l0002B00000@000=UU2T9d4@]22P0005l000050000C000000000000000
0000000000000000F0000480J@1/06T0L`071`T000040000100000@0000500009@0000`000070000
9@0000`000040020EP0002`0000J0000_@0002D0003;0000100001L0V@0C08h06`2>01L0V@0K0000
400001L0001^00009@0000`000050000=P000100000G0000UP0002D0000<00001P0002/0000H0000
0P0009L0000a0000_`0005@0001H00005@000>T0000W0000o0000040003II@Y2M14;@Pl0002`0000
0P0004`000000000000000000000000000000500001706T02P0000@0000U0000300000L0000U0000
300000@0081F0000;00007l0002D0000S0000:8000040000JP1_06H0NP1P07@0JP1_01/0000@0000
J0000700000U0000300000D0000f000040000340002/0000DP0004`100040000m?ooo`0000000000
0000090100000000100045@0J@1]06D0L`0P04h0I@1g0200DP1_06d0H@1^0000n?Shn?Shn?Sh0000
00000?oooooooooooooooooo00000?oooooooooooooooooooooooooooooooooooooooooooooooooo
oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
ooooooooooooooooooooooooooooooooooooo`00oooooooooooooooooooooooooooooooooooooooo
ooooooooooooooooo`00000000071`L71`L71`L71`L0000000000000000000000000000000010@41
0@410@411`LU0000300000@0000X0000300000P0000U0000300000@0001D0000E0000540002f0000
G0000<P000010000fFD:@W@A2d8m0000R@000040001<0000000000000000000000000000001@0000
B`071`T0001B0000C04000P0003goooo0000000000000000T04000000004000@E01Y06d0I@1c0200
CP1U07L0801B06l0K@1Q06h000071`L71`L71`L71`L71`L71`L71`L71`L71`L71`L000001`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7n?l71`L71`L70000000000L71`L71`L7
00071`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L71`L7
1`L71`00000000000000000000000000000000410@410@410@471bD0000<0000200002P0000<0000
100002D0000<0000200005@0001D0000G@000;X0001Q0000b0000040003II@Y2M14;@TH0002<0000
0@0004`000000000000000000000000000000500001Q00L7100002D0000<00001P0002X0000H0000
4P0007T0000L0000P`0001/0000@00007`0007D0000f0000400000l0002600009@0000`000070000
9@0000`000040020EP0002`0002/0000FP000;X0001V000010000880C02904<0S@1;0880C00K0000
400008`0001500009@0000`000050000=P00010000230000BP0002D0000<00001`0002D0000<0000
0000P5H0000d0000^@0004h0003>0000G00000H0002<04D0T`140900?`2I0440U@0k09`0>P0U0000
300000D0001G0000=0000;T0001>0000cP0005`000060000S01509<0A02@03l0V@1109D0>`2L03X0
E`0003@0002i0000CP000<h0001L00001P0008`0A@2C04@0T00o09T0@@2E03/0W00j0280000<0000
ooooobP0000<00001P0002P0000<00001`0002H0000L00001`0000000000000000000000000U0000
300000L0000U000030000000080R000030000?oooolR000030000?oooomD0000E0000?@0003g0000
nP0000T100010000=V3Q@:c^hD2C0`00V@<00040001<00001000000000000000SP<00<l3001@0000
803ooaX0001;000040000000000500009@0000`0000=0020:00000`000010000:00000`000030000
:00000`000020000:00000`000070000:00000`0000500009@0000`0000=0020:00000`000080000
3P0001@000000000400001@0
\>"], "Graphics",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  ImageSize->{246, 262}]
}], "Text"],

Cell[TextData[{
 "In this model is supposed that the transfer  ",
 Cell[BoxData[
  SubscriptBox["k", 
   RowBox[{"bilis", ",", "gi"}]]]],
 " from Bilis to GI it is a UnitStep function [h[t,8, 2]]"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"h", 
     StyleBox["[",
      FormatType->StandardForm], 
     StyleBox[
      RowBox[{"t_", ",", " ", "a_", ",", " ", "d_"}],
      FormatType->StandardForm], 
     StyleBox["]",
      FormatType->StandardForm]}], 
    StyleBox[" ",
     FormatType->StandardForm], 
    StyleBox[":=",
     FormatType->StandardForm], 
    StyleBox[
     RowBox[{"1", "-", 
      RowBox[{"UnitStep", "[", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{"t", ",", " ", 
          RowBox[{"a", "+", "d"}]}], "]"}], "-", "d"}], "]"}]}],
     FormatType->StandardForm]}], 
   StyleBox[";",
    FormatType->StandardForm]}], 
  StyleBox[" ",
   FormatType->StandardForm]}]], "Input",
 CellLabel->"In[94]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"h", "[", 
    RowBox[{"t", ",", "8", ",", "2"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "110"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "1000"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Exclusions", "\[Rule]", "None"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.399280709782375*^9, {3.592204119200674*^9, 3.5922041510978637`*^9}},
 CellLabel->"In[95]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJxN13c81f//P/5jr0JCQkUhqSjZKSOhSIqIKCMjKSNkj4YohGgYZYVKCJVC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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{All, All},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806614863634`*^9, 3.399280717289527*^9, 3.479966546794038*^9, 
   3.479966769192038*^9, 3.479967350684038*^9, 3.4799682379580383`*^9, 
   3.5133964459865108`*^9, 3.582349743085731*^9, 3.582350847157854*^9, 
   3.5823513797877207`*^9, 3.592204045271282*^9, {3.592204110938848*^9, 
   3.592204151991953*^9}, 3.6427609438511004`*^9, 3.650269799693235*^9},
 CellLabel->"Out[95]="]
}, Open  ]],

Cell[TextData[{
 "The clearance coeffs are",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"k12", "\[Rule]", "2"}], ",", 
    RowBox[{"k21", "\[Rule]", " ", "1"}], ",", 
    RowBox[{"k10", "\[Rule]", " ", "0.5"}], ",", 
    RowBox[{
     SubscriptBox["k", "g"], "\[Rule]", " ", "0.1"}], ",", 
    RowBox[{
     SubscriptBox["k", "a"], "\[Rule]", " ", "2"}], ",", 
    RowBox[{
     SubscriptBox["k", 
      RowBox[{"bilis", ",", "gi"}]], "\[Rule]", " ", 
     RowBox[{"h", "[", 
      RowBox[{"t", ",", "8", ",", "2"}], "]"}]}]}], " ", "}"}]]]
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"matrixhepatic", "=", 
   RowBox[{
    RowBox[{"CompartMatrix", "[", 
     RowBox[{"4", ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", " ", "k12"}], "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "k10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", " ", "k21"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "3", ",", " ", 
          SubscriptBox["k", "g"]}], "}"}], ",", 
        RowBox[{"{", " ", 
         RowBox[{"3", ",", "4", ",", " ", 
          SubscriptBox["k", 
           RowBox[{"bilis", ",", "gi"}]]}], "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"4", ",", "1", ",", " ", 
          SubscriptBox["k", "a"]}], "}"}]}], "}"}]}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k12", "\[Rule]", "2"}], ",", 
      RowBox[{"k21", "\[Rule]", " ", "1"}], ",", 
      RowBox[{"k10", "\[Rule]", " ", "0.5"}], ",", 
      RowBox[{
       SubscriptBox["k", "g"], "\[Rule]", " ", "0.1"}], ",", 
      RowBox[{
       SubscriptBox["k", "a"], "\[Rule]", " ", "2"}], ",", 
      RowBox[{
       SubscriptBox["k", 
        RowBox[{"bilis", ",", "gi"}]], "\[Rule]", " ", 
       RowBox[{"h", "[", 
        RowBox[{"t", ",", "8", ",", "2"}], "]"}]}]}], " ", "}"}]}]}], 
  ";"}]], "Input",
 CellLabel->"In[96]:="],

Cell["Initial condition and input are", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ip", " ", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[97]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"ic2", " ", "=", 
   RowBox[{"{", 
    RowBox[{"200", ",", "0", ",", "0", ",", "0"}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[98]:="],

Cell[TextData[{
 "Then, it can be used  ",
 Cell[BoxData[
  ButtonBox[
   StyleBox["SystemNDSolve",
    FontVariations->{"Underline"->True},
    FontColor->RGBColor[0, 0, 1]],
   Appearance->{Automatic, None},
   ButtonData:>{"Info3257348699-2143584", "Biokmod`SysModel`SystemNDSolve"},
   ButtonFunction:>(Internal`PutInformation[#, LongForm -> False]& ),
   ButtonNote->"Biokmod`SysModel`"]],
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->GrayLevel[0.930022],
  ButtonBoxOptions->{Active->True}],
 "  "
}], "Text"],

Cell[BoxData["\<\"SystemNDSolve[MatrixCoefs, incond, input, {t, tmin,  tmax}, \
t1, x, options]  gives the numeric solution X(t)= {x1(t), ..., xn(t) at time \
t1 of a ODE  system X'(t) = A X(t) + B(t), with initial conditions X(0) = IC \
, where;  MatrixCoefs is the  coeffs matrix A = {{a11,...a1n}, ...,{am1, ..., \
amn}}; incond are IC =  {c1,..,ci,..cn};  B(t) ={b1[t],..., bn[t]};  x is the \
symbol that represents X; options are the  options of NDSolve.  Note:  This \
function apply the Mathematica function NDSolve  for solving the  SODE, it \
should be used when MatrixCoefs included some coeffs that are not  constants \
or when it was not possible obtain the solution of the model using  \
SystemDSolve.\"\>"], "Print",
 CellTags->"Info3257348699-2143584"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol1", "=", 
  RowBox[{"SystemNDSolve", "[", 
   RowBox[{"matrixhepatic", ",", " ", "ic2", ",", "ip", ",", 
    RowBox[{"{", " ", 
     RowBox[{"t", ",", "0", ",", " ", "100"}], "}"}], ",", " ", "t", ",", 
    "  ", "x"}], "]"}]}]], "Input",
 CellLabel->"In[99]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "4"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806617209625`*^9, 3.479966547086038*^9, 
  3.4799667698080378`*^9, 3.4799673509470377`*^9, 3.479968238022038*^9, 
  3.51339644731467*^9, 3.5823497433557577`*^9, 3.5823508473928776`*^9, 
  3.5823513799677353`*^9, 3.592204045495304*^9, 3.6427609441010923`*^9, 
  3.6502697999744854`*^9},
 CellLabel->"Out[99]="]
}, Open  ]],

Cell["We need increase the number of steps ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol2", "=", " ", 
  RowBox[{"SystemNDSolve", "[", 
   RowBox[{"matrixhepatic", ",", " ", "ic2", ",", "ip", ",", 
    RowBox[{"{", " ", 
     RowBox[{"t", ",", "0", ",", " ", "100"}], "}"}], ",", " ", "t", ",", 
    "  ", "x", ",", 
    RowBox[{"MaxSteps", "\[Rule]", "5000"}]}], "]"}]}]], "Input",
 CellLabel->"In[100]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "2"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "3"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "4"], "(", "t", ")"}], "\[Rule]", 
     RowBox[{
      TagBox[
       TemplateBox[{RowBox[{
           StyleBox[
            TagBox["InterpolatingFunction", "SummaryHead"], 
            "NonInterpretableSummary"], 
           StyleBox["[", "NonInterpretableSummary"], 
           DynamicModuleBox[{Typeset`open$$ = False}, 
            PanelBox[
             PaneSelectorBox[{False -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}], True -> GridBox[{{
                   PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                   GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                   GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                 GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False,
                  GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 BaselinePosition -> {1, 1}]}, 
              Dynamic[Typeset`open$$], ImageSize -> Automatic], 
             BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
           StyleBox["]", "NonInterpretableSummary"]}]},
        "CopyTag",
        DisplayFunction->(#& ),
        InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
       False,
       Editable->False,
       SelectWithContents->True,
       Selectable->False], "\[InvisibleApplication]", 
      RowBox[{"(", "t", ")"}]}]}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806617835217`*^9, 3.479966547136038*^9, 
  3.4799667701630383`*^9, 3.4799673513000383`*^9, 3.4799682382150383`*^9, 
  3.5133964474084225`*^9, 3.5823497435107737`*^9, 3.5823508475338917`*^9, 
  3.5823513801364985`*^9, 3.592204045631318*^9, 3.6427609443354692`*^9, 
  3.650269800271361*^9},
 CellLabel->"Out[100]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", " ", 
   RowBox[{
    RowBox[{"x1", "[", "t_", "]"}], ",", 
    RowBox[{"x2", "[", "t_", "]"}], ",", 
    RowBox[{"x3", "[", "t_", "]"}], ",", 
    RowBox[{"x4", "[", "t_", "]"}]}], "}"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{
      SubscriptBox["x", "1"], "[", "t", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "2"], "[", "t", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "3"], "[", "t", "]"}], ",", 
     RowBox[{
      SubscriptBox["x", "4"], "[", "t", "]"}]}], "}"}], "/.", 
   "sol2"}]}]], "Input",
 CellLabel->"In[101]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["InterpolatingFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{9.062702696117906, 11.105075287336728`}, {
                    10.058214718047612`, 9.28145270422917}, {
                    11.367661424535637`, 11.105075287336728`}}], 
                    LineBox[CompressedData["
1:eJwBYQOe/CFib1JlAgAAADUAAAACAAAAgFnBmktTKEBGdZVtzDUmQFojne3E
JitAawWzRIumIECcUT88AGcuQFnjjc/jzBhAs/bLKrj2MEDBY9sGmjMSQNyH
Euv0mzJAnVN+WiBJC0AfWN5E6Dg0QIQECu8f1QZAJV8FBPb4NUAXVTNeoF0P
QG+pxnYImzdA5pnTmYckBkB9KuNONWA5QCVcFx+lDQBApOqEwBgdO0AaL7VI
+Kr3Pw/uwOUAvDxA04GZjizR8T8+KFhwA34+QN9NyrmEJfI/2NJEVwURQEBl
xr8Q9Ej1P/MsCymW9EBAAZ6mtQ/i7D+aJpRHAtRBQGslaE0cIOU/5EHqv3Ck
QkCY3eREQcHfP4/47WpshkNAwjdFa3RO1z/c0L5vallEQMU7t6lbwts/tkhS
wUMoRUAqyP3IgozcP/Jbk0WqCEZAtmmA1zWI0z/QkKEjE9pGQLrgABvBLM0/
EGFdNAm9R0CPMpNJ5mDFP9zQ25Ham0hAokb6tZGEvz9KYidJrmtJQKfPCWsJ
RsQ/Go8gMw9NSkAU91bfOJDCP4zd5nZyH0tAC8xONiNduj+Ly28Hse1LQDiM
eAGzzbM/7FSmynzNTEAEmwdrpCatP+//qedKnk1AYChYMInnpT9URls3poBO
QIB8xjfgUa0/W67Z4ANUT0DTQuJdk42pP/hajWueEVBAJc5VCklKoj9zrASA
AYJQQEKNuncsy5o/v45iweXqUEDhaY+7cRqUP7s+F5yQXFFAPEDfYot0jT9+
Pi0dKcxRQGv3w/rQ7ZQ/Es8py0I0UkDBpZ8L4yWRP1ctfRIjpVJAht1LF2Ym
iD9tHLeGhA5TQOT4ZmNVD4I/SVtSodN1U0DfixRROjh7P9ZnRFXp5VNALdsc
+hYHdD80BR02gE5UQLexzrWCR30/Q3BMsN2/VEDSogNWFfB2Pxgr3dAoL1VA
gavWLphhcD++dlQe9ZZVQNk5Eu+rnmg/FZAiBYgHVkCPxenszxZiPz061xic
cFZAqzpGAX8iWz8WsuLFduJWQDnM+2SBimQ/tXlPGT9SV0DMKgXmCA9ePybS
opmIuldApvcECKskVj9H+EyzmCtYQA9biOHjOlA/Oa/d+SmVWECdSJQx+U9I
Pz4Z5Pj//1hAqCmQ6s4lQj8CCnkN
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.105075287336728`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", "t", ")"}]}], ",", 
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["InterpolatingFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 0.000677963655117006}, {
                    0.3363102471433115, 19.3736236532032}}], 
                    LineBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAATExu7s1vK0ARhbvMpV8zQJxRPzwA
Zy5Ag8oFLDMJLkCz9ssquPYwQKpuR2YTESZA3IcS6/SbMkBmfw9SY4ogQB9Y
3kToODRAjXrXA88cGUAlXwUE9vg1QELxtY9sCR5Ab6nGdgibN0AiVcS0YUAa
QH0q4041YDlAxVW/H+xxE0Ck6oTAGB07QCX9/4ShsQxAD+7A5QC8PEA9uhhE
+ZkFQD4oWHADfj5A/6Fz9mLHAEDY0kRXBRFAQANUgqe7xARA8ywLKZb0QEDv
kxigGEYBQJomlEcC1EFASu87ZgiZ+T/kQeq/cKRCQAWDu/PSP/M/j/jtamyG
Q0D4m9d8vkHsP9zQvm9qWURA2SShic7X5z+2SFLBQyhFQFTRs6DB7ew/8luT
RaoIRkAtyvuIMHDnP9CQoSMT2kZAKnRcZSmt4T8QYV00Cb1HQDK4A58569k/
3NDbkdqbSEA/ANeGLRvTP0piJ0mua0lAEBkmEKoJ0T8ajyAzD01KQPHD2MyD
7dM/jN3mdnIfS0BNQFOqlbnPP4vLbwex7UtAg3Bh/QoAyD/sVKbKfM1MQPmx
KvfKq8E/7/+p50qeTUBka4igl466P1RGWzemgE5AW94NG0KIuD9brtngA1RP
QGW55SiEsLs/+FqNa54RUEB/mnuWnAS2P3OsBIABglBAE20OqtI8sD+/jmLB
5epQQD3pqft5X6g/uz4XnJBcUUBnbwP2FtuhP34+LR0pzFFAP/DI6di4oT8S
zynLQjRSQD/pqDvUCqM/Vy19EiOlUkCJw8113yidP20ct4aEDlNAVFP0yjHk
lT9JW1Kh03VTQLbP84MbgJA/1mdEVenlU0AlF3v+GUiIPzQFHTaATlRAhYjn
E/fiiD9DcEyw3b9UQIyXvH3uCoo/GCvd0CgvVUDzZ9vmpMyDP752VB71llVA
3sXwBSXYfT8VkCIFiAdWQMXzK9xg7nU/PTrXGJxwVkBqxAnj9nJwPxay4sV2
4lZAG2vqVec1cj+1eU8ZP1JXQAoq3dsAf3E/JtKimYi6V0A+WlccWMlqP0f4
TLOYK1hAOtfth/GsYz85r935KZVYQEa/rbnveV0/Phnk+P//WEDGi3mjmABW
PxitfbI=
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 19.3736236532032}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", "t", ")"}]}], ",", 
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["InterpolatingFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    0.000033898182755852206`}, {1.6301768919855668`, 
                    4.695319722474794}, {3.3974736088780224`, 
                    9.196267327299847}, {4.1504417331417125`, 
                    11.134630716153122`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAAfHdk+koWJkBW1DVR7kQmQKF7LwaT
qidAXg1e1fAyEUBaI53txCYrQChazBIIgBVAnFE/PABnLkBCirZRry0aQLP2
yyq49jBAnIRpOw/wHUDchxLr9JsyQKG22mITRSBAH1jeROg4NEAuxR7/qp4b
QCVfBQT2+DVA4fwfqUJU+D9vqcZ2CJs3QB4xKLQGLQBAfSrjTjVgOUCsj3qy
5IQDQKTqhMAYHTtAJGg/hGXsBUAP7sDlALw8QH5ju//VlwdAPihYcAN+PkDO
m+09+7L+P9jSRFcFEUBASItbPUSO4T/zLAsplvRAQNWB79Egyec/miaURwLU
QUAuqaFvpxvsP+RB6r9wpEJAtpzUQakZ7z+P+O1qbIZDQKppizlywfA/3NC+
b2pZREDGhoag/sThP7ZIUsFDKEVAX1UVbwCmyT/yW5NFqghGQLdEE7H+8dA/
0JChIxPaRkDQB1TopbbTPxBhXTQJvUdAy0xXM7fv1T/c0NuR2ptIQDvJcwdI
itc/SmInSa5rSUDeB9Y+J8jFPxqPIDMPTUpA1XsBiskCsz+M3eZ2ch9LQNN/
ktwsIbg/i8tvB7HtS0DHqFf1H9K7P+xUpsp8zUxAeBtz14HNvj/v/6nnSp5N
QKIJgCd4b8A/VEZbN6aATkBqRafDBT2qP1uu2eADVE9Anybe61XOmj/4Wo1r
nhFQQAoN7QNO46A/c6wEgAGCUECddaX/PqWjP7+OYsHl6lBAKlIpoMiNpT+7
PheckFxRQIq3apaIFqc/fj4tHSnMUUAHVVFjYCCPPxLPKctCNFJAlJlRtXhC
gz9XLX0SI6VSQGRgw+KEUYg/bRy3hoQOU0BgKQwohcSLP0lbUqHTdVNAx1vr
E4dOjj/WZ0RV6eVTQCfZIVP9LZA/NAUdNoBOVECpGigK0Al1P0NwTLDdv1RA
Eupl8Ei4az8YK93QKC9VQDJGU+5iOXE/vnZUHvWWVUA0bgwox4hzPxWQIgWI
B1ZAwgXjS8lldT89OtcYnHBWQBn7zm0nsHY/FrLixXbiVkDl6fLaQJZWP7V5
Txk/UldAs4Nl8A86VD8m0qKZiLpXQDZXsHT+bVg/R/hMs5grWECf2BIpkMpb
Pzmv3fkplVhAC8Qht78dXj8+GeT4//9YQEHcmZIn4F8/+MiB8A==
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {0., 11.134630716153122`}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", "t", ")"}]}], ",", 
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["InterpolatingFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{1.694915254237288*^-6, 
                    3.397890646333162*^-11}, {0.14627547757016124`, 
                    0.20472419212881277`}}], 
                    
                    LineBox[{{3.343634782910923, 0.20472419212881277`}, {
                    3.3974736088780224`, 0.13946677698996096`}, {
                    5.047654566075241, 0.005142107082349518}, {
                    6.665465523416349, 0.00020226615860656174`}, {
                    8.420398000579599, 6.047793524938302*^-6}, {
                    8.7223150908162, 0.20472419212881277`}}], 
                    
                    LineBox[{{13.52898443328298, 0.20472419212881277`}, {
                    13.575721192771812`, 0.12237520429393559`}, {
                    15.20117367051062, 0.004740691392723571}, {
                    16.963747668071573`, 0.0001396000919036935}, {
                    18.609205905937287`, 5.195613469307966*^-6}, {
                    18.850108323703097`, 0.20472419212881277`}}], 
                    
                    LineBox[{{23.37331702281787, 0.20472419212881277`}, {
                    23.60559789991515, 0.04596166267916864}, {
                    25.375813417873804`, 0.001332914708027519}, {
                    27.113658935976346`, 0.00004124196160329089}, {
                    28.73438869438365, 1.612707831770198*^-6}, {
                    29.222015841288115`, 0.20472419212881277`}}], 
                    
                    LineBox[{{32.764103007035864`, 0.20472419212881277`}, {
                    33.91083252950366, 0.008924917254677837}, {
                    35.656319568003894`, 0.000271950755981683}, {
                    37.2846908468089, 0.000010470336924209728`}, {
                    39.05018364543604, 3.0752640780213823`*^-7}, {
                    40.28108564106257, 0.20472419212881277`}}], 
                    LineBox[CompressedData["
1:eJwBUQKu/SFib1JlAgAAACQAAAACAAAA7pbkM/WhREC4VvL+ZjTKP7ZIUsFD
KEVAt5RPcOx/sz/yW5NFqghGQJrn2uaxuWI/0JChIxPaRkCUu4l8mLoWPxBh
XTQJvUdAojjcY8D3xD7c0NuR2ptIQGdeH7VBq3Q+SmInSa5rSUCZ017WMi64
PxqPIDMPTUpAjJIdniKmjj+M3eZ2ch9LQMjLpbxlUUI/i8tvB7HtS0Ad21ND
WVz3PuxUpsp8zUxA/uuxgaOipj7v/6nnSp5NQERL8fooyls+VEZbN6aATkCP
n0fG5xagP1uu2eADVE9AoVyew4Aucz/4Wo1rnhFQQKW2o+A8Fyg/c6wEgAGC
UEDno1UivP/WPr+OYsHl6lBAJ4X0p0nFiz67PheckFxRQAw3ozY0QDs+fj4t
HSnMUUBSF0EaJ7SEPxLPKctCNFJA4jkF9NFsUz9XLX0SI6VSQLo8itEwQwI/
bRy3hoQOU0BRsSmTVrO1PklbUqHTdVNAI0welFxxaz7WZ0RV6eVTQAgl9EO/
lhE+NAUdNoBOVECGg5oezVpsP0NwTLDdv1RAQUt7k2LbMj8YK93QKC9VQA1/
SMpyn+I+vnZUHvWWVUC13TNziFeXPhWQIgWIB1ZA2Y/vXZqPRT49OtcYnHBW
QEE4/yUPsfU9FrLixXbiVkA+Wm/vGIFQP7V5Txk/UldA9ODQmyOgDT8m0qKZ
iLpXQEx/cccvNsI+R/hMs5grWECbYLYUOUtxPjmv3fkplVhARoIlore7Iz4+
GeT4//9YQKQOqYLW6Py954cGwg==
                    "]]}}}, {
                   DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 100.}, {-4.2068893044524724`*^-10, 
                    0.20472419212881277`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "100.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("InterpolatingFunction[{{0., 100.}}, <>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", "t", ")"}]}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806618148017`*^9, 3.479966547172038*^9, 
  3.479966770293038*^9, 3.4799673513660383`*^9, 3.479968238252038*^9, 
  3.513396447470924*^9, 3.5823497435387764`*^9, 3.582350847593898*^9, 
  3.5823513802002535`*^9, 3.592204045662321*^9, 3.642760944413596*^9, 
  3.6502698003807354`*^9},
 CellLabel->"Out[101]="]
}, Open  ]],

Cell["Here are ploted the solution ", "Text",
 CellChangeTimes->{{3.6505981194451647`*^9, 3.6505981353670483`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t", "]"}], ",", 
     RowBox[{"x2", "[", "t", "]"}], ",", 
     RowBox[{"x3", "[", "t", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "50"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "1000"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "100"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<days\>\"", ",", "\"\<r\>\""}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<x1\>\"", ",", "\"\<x2\>\"", ",", "\"\<x3\>\""}], "}"}], 
      ",", "Center", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.479966681786038*^9, {3.5922040248332386`*^9, 3.592204060806835*^9}},
 CellLabel->"In[102]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   FormBox[
    GraphicsBox[{{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
        Opacity[1.], LineBox[CompressedData["
1:eJwc13c81e8XAHDKtbn2ntd1rz3vtRqOrYSk7EglmyRJZSSjkhSlYYbsjFKo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         "]]}, 
       {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], 
        Opacity[1.], LineBox[CompressedData["
1:eJwd03k41HsXAHBEJCqSRNJiS0oohThH6aVCMpjvtKiktEhXqUtyQyrdkpbr
UkpUlrHfodTIVU3Zl4kaZMkyzJgZJVu28v7e9zzPec7z+eOc55w/zjLvU26H
ZaSkpIqo/F9VLYiIbWg/bqtxZcFHtV/Dtq2hRSrSqY4QqnYuS866ARrd1Nyr
Ugjs+T55yXxdN7gX49m8lKNQ5TdTp1F/CO4O8uSepARB0BjjwwGlGWimvNzl
QUoUDNW2PZjTpIoR9x0G41PiYWtYzdidgOVodHC3fVxKOqQzI4d5Waa4wMUx
MmgeEwo1rw70DJqilLXFO0YIE/5dPtRTstEMG9VU7RfvyoDl5jmMTxwzjCyv
2JI8lQnhPP3IPxvN8YuJ5ZZMWi5UV73+ZDOyHrdPz07+IpUPYQaLo8sUrXC6
RvRoKOclDCW9yVZuQLTavD+9ueMldMlZjal/RQx83pBXosqG02t4X5Vm2aEo
8dWb6+fYkKjUMr/E1g55p252r7AtAvPqkqc2TDvMUTEzcK95BYVca53c85vR
yyM4p0BcApOrWZKiufa4/+uldis1Diy4xbRfLOeAv2XNupdnzAFBMBtQywHD
jsfQ9LdywCx3xhV3UwdM6r1frnKOA882Gi5x2eeAXe3/sISNHGj113x8pcAB
feq+XPk74R3E2YsV1Q844tE8a5PB5aXQ4uZ1YihzG54+PXSRaVoBfe2Xkjka
Thhr2z5s6lQBiVm8703GTvhCseIY+0gFhKUXxrajE04/TqRVJVRA+eWHckVH
nfBGwzaDfrlKUKdtf/ey0AlT1yXVrv1cCacrWLlNbs7YMuqk/SKiGt7Nun5K
GOqC9iGp7NKGOoifyWSUurvi9pnc7muSOlCeJc4P2uuK6eUXrqTKcEHRMpyh
5+OKObTU3GNaXDjnEBV78owrso+NSw84cWFAX82SfdsV62MfpU7lciFhQ5G/
Q40rSn8Vf1tw7gMImxTu7cBdeCAxMsJRpgGur3qwmKPuhhLRjsD8uQ3wcnsd
ydZ2w+AN848s0W6AxIAw0W1dN7zDTd42vKEB/qB56Gw3c8N3MiXzkk42gGb9
X1t/d3ZDQ9/xxB9NDVBr3GRQHuGGAyb+Ram5H+HJd5HD/j43vPiGPiy7jwcR
v31R3ZBGQ1muvZ3pcR5kjF9dVpRFwz/bTW/u+50HqXztx1YsGv49Odvw+W0e
6BVPyhkX0zBn/es9vqU8CLrEZzXV07CNacipMGkE35I7gXt/0tD6zvjtmzJN
4Oz6UEV3pzv+8E4w0UhvBscozTV7et3xKzeNd7CgGYo5ldZXRe7Ya1sQmvm6
GXq8F03kfnXHj5o1VbbNzVBV8+vWj1F3zKv/5XtY8TN4Hejx3i/vgcc3eyex
/D7Dwupx/7sGHti+bKWKs2kLZDFkBAmHPfBdx/PBcHYrOGXE6D5p8sD3n0ZG
P5a1Qtvuy5YerR5YWrlu0uBTK+QORcnIdnhgWQFrRu23VhiuX8amCzywMipH
TVOvDeQmAqSbRjyQuzbVghXTBoHnt03bqHpiS1js+S6fdpAtfbM6z9ETg+dZ
hSfLd8Cwk31TZpYnsqyO5TUrd4C6wqHvx3M9UeIT/0VFrQNm9W5IMWB5otfL
UZuIpR0gxY/uvlfoiZu98ye8LTvgUkuu8OBbT1QsMA7UPdEBh2hDEeGNnnif
ruObVtsBZjnkqKIUHdmJss7ZsZ0QktK0LX47HQeYpStLEzrh7vW9niVOdNR/
FjXzS3In5DEkAXwXOt6uUno9L6cT0qpOtxjS6Hh0TM08sLQTNvIGHtzfQ0d1
N71F1j86YfeMA1Ir/OgYIPefnnLSBboVmcHc63RMnafwttOrC+ae6BwoiqZj
q1Zl4oRPF/TESyelxNDR0cyFGAd0gfmysIwzd+m4ZL9nVcy1Lgh5LI6ZuE/H
6hdH/vFkd4Eywyi+gElHQ7+roXytbvBf+jyk8z0du9hdChHLu6Gvv8OgqIyO
D2fZ/qWzshsOS2713Kmgo2racMZui24YUbVN2FRDx6nOg01c1244rTu1MPgj
Hbn0TebFl7uh2jEsPq6Ljr9v+S6M/dYNJXzf5MCfdDS74xRoPtoNH2tVrOdP
01HSkTbNneqm9pOo5EkRPPCHl7qSIh8eC7Uu8GcQ3P6yakuELh9A5x+fjYoE
l5ikJvoz+GCYveFetDrBUs097g4cPqyXf7NidDVBy0WlN85U8EFF+0nOf0wI
Zi00ff+ojg9TNzUaYtcSvKMmbzHWwoe4iRcSE3OC++fkL2QO80FdM+8P2kaC
Y9KzWxT1e+ADJ2iKbCZo1Mc+WBvVA0Z8x5FDHgQfCvTuT9zsAeVtOTeueRKc
13urXj+2B2K8FFuy6QRHu45suZjcA/XflJIGGQQ5rap6a9k98HNcvtvPi+Be
7nHhbXEPWCzfOFvPl2BMoeYpD5deyPL7q5H5O8Er40s8Z3r0gumPNOviIIJ/
WK+wKdzTC7lxK23qggn6l6yavehYL4zHVi3+FkLQpWxTWuulXjgvaPZbEkZw
TqPXl0Mve6FeqQo3RRG8Mfp452ldAbxVtQgLiSMYuTHNYsUqAShMal/ziSd4
4Xym9kdTAciGv3JxukfQ71e+eD0I4FFk3XyNBII7Zr6/Os6g+sH4UVIiQUV1
QUlYjACEawuvnUshGLV+1dqYCQHMIuV6m1jUPPL23VJpITzcQ5edpBwQwmCw
5IXAjq4te5FPcPebqxGf1ITwNHVYyvQZQWNn/kctEyFs3rGDpvaC4Aefh8Hp
h4Rg5m+1NK2YoOZfczlvqoUQn1tzV6acuq8wlU5rEMIeM96NR5RnfLaR8JuF
4BAkf8m6gqBEx2+BgkAIfMOOY79VEizJLPd1ke6DfYudLWqrCfpwwpVa1vfB
oa2rA3Z/IJg9OOQxnNgH4b7v09jN1H7v78eppfRB81MrXPuZoEK8XfO6zD44
+VNOKYWyt03M3rOFfeDvzIQbLQQXRhkdGq3rg2eRx/V2tREM1z7425iUCDJM
NPY96yC4ZkCepSEvgmdGukeXdBJsfZsztFFZBBFnc3OuULY4OnUueJEIIh1c
Bty7CIpZcaETpiKYNz5ME3YT9HCs/XPKWwT3AgzminsJymidrV58TAS5p/fN
dRQQzOvXmmNzSgTKY9a0p5QV7x67HRoigretU2m7hdT9bbLxv+6KYGQl7+6/
fQRXnrFOkXovAh7LQHBIQvDnw/QSWQMxiIKc5xh+J2hSIMxlrhbD0LJA/0DK
BysNk1zWiWFCykn2NeX3o+lh8XZi+HyW2eA+SDB6J9POeK8YbH9sUTk7RFBb
OoNDuy2GVyEy4bdGCO5cKMofixOD9+C5MC7l8NVGTx8mikFz5OK/c0cJ9jAy
IgWZYmBtOj92nXI2K2NrSKkYFPWtzoT8IGjjk1n2eFIM8f2WPy3GCZ46Ly50
kJHAibQR/ROUk2+tSpcoSED58EBcImW54swoC3UJZFyr2TVjgmDNgqxtlWsl
0Fjhuu4d5elVEstTGySQOrQmbZCy6WZjIzVbCSzbl3x46STBWP8sRa8dEpgd
fbIsmPK+sqyq74clYMGqWa07Rf1rm6Tobz8JfDMKUnKm/GbIOMv6jATMdJSs
z1LWW5p943KYBLZqaP3JodwflO28KEEC+onTv+g/CYYa5dQhVwIal9cXH/hF
8OjAT79AngR0rk22X6Ds9txZMb1VAjvt2v3jKRtu7ref2ycB/8pXn2so1zOM
2W3S/ZAVwv5qOk2wWOcCXUWhH9rz9aK3UU7vqRq2n9MPEkbbgwOUQwNOmGRp
9sOOpUyVaMqG1zKenjfvB4FoePcXyqo7J+xyLPuhtFfu5iDliQcn4vRt+0Hq
/8HA/wKG/bg6
         "]], LineBox[CompressedData["
1:eJwc13c8lf8XAHBkb7KuPS732uvea+YehUqSnRYNWyk7hYxItpBVSiWSaGgo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         "]]}, 
       {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], 
        Opacity[1.], LineBox[CompressedData["
1:eJwU13c8lV8YAHB772vPa+95rz3OEyVJZESTjAYZDZSKIjNFJFmJomQnv8xC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         "]]}}, InsetBox[
       FrameBox[
        FormBox[
         TemplateBox[{"\"x1\"","\"x2\"","\"x3\""},
          "LineLegend",
          DisplayFunction->(FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]& ),
          Editable->True,
          InterpretationFunction:>(RowBox[{"LineLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                   ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                   ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.560181, 0.691569, 0.194885]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                    "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{#, ",", #2, ",", #3}], "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"\"Column\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", "5"}], "}"}]}], "}"}]}]}], 
             "]"}]& )],
         TraditionalForm],
        RoundingRadius->5,
        StripOnInput->False], Scaled[{0.5, 0.5}], ImageScaled[{0.5, 0.5}],
       BaseStyle->{FontSize -> Larger},
       FormatType->StandardForm]},
     AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
     Axes->{True, True},
     AxesLabel->{
       FormBox["\"days\"", TraditionalForm], 
       FormBox["\"r\"", TraditionalForm]},
     AxesOrigin->{0, 0},
     DisplayFunction->Identity,
     Frame->{{False, False}, {False, False}},
     FrameLabel->{{None, None}, {None, None}},
     FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
     GridLines->{None, None},
     GridLinesStyle->Directive[
       GrayLevel[0.5, 0.4]],
     Method->{
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None},
     PlotRange->{{0., 49.99999994994995}, {0, 100}},
     PlotRangeClipping->True,
     PlotRangePadding->{{
        Scaled[0.02], 
        Scaled[0.02]}, {0, 0}},
     Ticks->{Automatic, Automatic}],
    TraditionalForm],
   InterpretTemplate[Legended[
     Graphics[{{{}, {}, {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         Line[CompressedData["
1:eJwc13c81e8XAHDKtbn2ntd1rz3vtRqOrYSk7EglmyRJZSSjkhSlYYbsjFKo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          "]]}, {
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         Line[CompressedData["
1:eJwd03k41HsXAHBEJCqSRNJiS0oohThH6aVCMpjvtKiktEhXqUtyQyrdkpbr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          "]], 
         Line[CompressedData["
1:eJwc13c8lf8XAHBkb7KuPS732uvea+YehUqSnRYNWyk7hYxItpBVSiWSaGgo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          "]]}, {
         Directive[
          Opacity[1.], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]], 
         Line[CompressedData["
1:eJwU13c8lV8YAHB772vPa+95rz3OEyVJZESTjAYZDZSKIjNFJFmJomQnv8xC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          "]]}}}, {
      DisplayFunction -> Identity, AspectRatio -> GoldenRatio^(-1), 
       Axes -> {True, True}, AxesLabel -> {"days", "r"}, AxesOrigin -> {0, 0},
        DisplayFunction :> Identity, 
       Frame -> {{False, False}, {False, False}}, 
       FrameLabel -> {{None, None}, {None, None}}, 
       FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
       GridLines -> {None, None}, GridLinesStyle -> Directive[
         GrayLevel[0.5, 0.4]], 
       Method -> {
        "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
         AbsolutePointSize[6], "ScalingFunctions" -> None}, 
       PlotRange -> {{0., 49.99999994994995}, {0, 100}}, PlotRangeClipping -> 
       True, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {0, 0}}, Ticks -> {Automatic, Automatic}}], 
     Placed[
      Unevaluated[
       LineLegend[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         Directive[
          Opacity[1.], 
          RGBColor[0.560181, 0.691569, 0.194885], 
          AbsoluteThickness[1.6]]}, {"x1", "x2", "x3"}, LegendMarkers -> None,
         LabelStyle -> {}, LegendLayout -> {"Column", {Automatic, 5}}]], 
      Center, Framed[#, RoundingRadius -> 5]& ]]& ],
   AutoDelete->True,
   Editable->True,
   SelectWithContents->False,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280663112913*^9, 3.4799665477230377`*^9, 3.479966776510038*^9, 
   3.479967353948038*^9, 3.4799682389460382`*^9, 3.5133964490178385`*^9, 
   3.582349745034926*^9, 3.582350849737112*^9, 3.5823513820804043`*^9, {
   3.592204045877342*^9, 3.5922040620279574`*^9}, 3.642760944554221*^9, 
   3.650269800552611*^9},
 CellLabel->"Out[102]="]
}, Open  ]],

Cell["Here are shown the numerical values  ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", ",", " ", 
      RowBox[{"x1", "[", "t", "]"}], ",", " ", 
      RowBox[{"x2", "[", "t", "]"}], ",", " ", 
      RowBox[{"x3", "[", "t", "]"}], ",", " ", 
      RowBox[{"x4", "[", "t", "]"}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"t", ",", " ", "1", ",", " ", "100", ",", " ", "5"}], "}"}]}], 
   "]"}], "//", "TableForm"}]], "Input",
 CellLabel->"In[103]:="],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"1", "48.572021278995734`", "99.9343188749022`", "4.996715943745108`", 
      "1.9361571672334448`"},
     {"6", "18.768399039111213`", "45.507157225411824`", 
      "15.389587586686725`", "0.0007654919448633663`"},
     {"11", "11.927930693962582`", "22.062687562358153`", 
      "8.334748100180732`", "5.041446630027949`"},
     {"16", "5.387964704066789`", "13.06151823734051`", "7.006673217978858`", 
      "0.0009593701329918263`"},
     {"21", "3.9251726422546436`", "6.714806559878852`", 
      "3.3640531856899405`", "2.053491220979815`"},
     {"26", "1.7981803517372446`", "4.358941740841517`", 
      "2.5585132000568764`", "0.0003825078899081232`"},
     {"31", "1.3525812178332997`", "2.2734069679590534`", 
      "1.2053090032925382`", "0.736876075195769`"},
     {"36", "0.6215025182620759`", "1.5065593422260635`", 
      "0.9003931709478138`", "0.0001367651107493121`"},
     {"41", "0.47060588530565606`", "0.7881245366474717`", 
      "0.42262957643199806`", "0.2584551959634324`"},
     {"46", "0.21637252727712097`", "0.5244988664714786`", 
      "0.31460354862138645`", "0.000047938199001270406`"},
     {"51", "0.16405870753856366`", "0.27454836469468163`", 
      "0.14756267372061246`", "0.09024594126773808`"},
     {"56", "0.0754392620353154`", "0.18286882926080844`", 
      "0.1097677059736908`", "0.000016736232880117544`"},
     {"61", "0.057215247660334055`", "0.09573428501464958`", 
      "0.051478316664549904`", "0.03148331954125519`"},
     {"66", "0.026309985306013906`", "0.06377681439334373`", 
      "0.03828786937214574`", "5.838143579859947`*^-6"},
     {"71", "0.019955310874754672`", "0.03338884111215706`", 
      "0.017955529496545407`", "0.010981345233289619`"},
     {"76", "0.009176336019993438`", "0.02224393684624422`", 
      "0.013354359391780365`", "2.035653554292508`*^-6"},
     {"81", "0.006960056160328478`", "0.01164536033319329`", 
      "0.006262640201568266`", "0.0038301400926342853`"},
     {"86", "0.00320053701455219`", "0.007758268926527226`", 
      "0.004657844780903584`", "7.119031204608292`*^-7"},
     {"91", "0.002427556459901678`", "0.004061690922028321`", 
      "0.0021843275142882485`", "0.0013359029756841322`"},
     {"96", "0.0011162989481430948`", "0.0027059665824052275`", 
      "0.0016245698718993246`", "2.486757557027268`*^-7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[2.0999999999999996`]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 CellChangeTimes->{3.3992806631911125`*^9, 3.479966547780038*^9, 
  3.479966776587038*^9, 3.479967354186038*^9, 3.4799682390320377`*^9, 
  3.513396449111591*^9, 3.5823497451129336`*^9, 3.582350849794118*^9, 
  3.5823513821991634`*^9, 3.592204045938349*^9, 3.592204078514606*^9, 
  3.642760944569847*^9, 3.6502698005994864`*^9},
 CellLabel->"Out[103]//TableForm="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Michaelis-Menten ", "SubsectionIcon",
 CellChangeTimes->{3.6505981197889137`*^9, 3.650598164210816*^9}],

Cell[CellGroupData[{

Cell["One compartmental with impulsive input", "SubsubsectionIcon"],

Cell["\<\
The one compartmental  Michaelis-Menten model is given by equation \
\>", "Text",
 CellChangeTimes->{{3.6505981808203*^9, 3.650598181617181*^9}}],

Cell[TextData[{
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "1"]]],
 "(t) = - ",
 Cell[BoxData[
  FractionBox[
   RowBox[{
    SubscriptBox["V", "m"], " ", 
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}]}], 
   RowBox[{
    SubscriptBox["k", "m"], "+", 
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}]}]]]],
 "+ ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["u", "1"], TraditionalForm]]],
 "[t]"
}], "NumberedEquation"],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["b", "1"], " ", 
    RowBox[{
     FormBox[
      SubscriptBox["u", "1"],
      TraditionalForm], "[", "t", "]"}]}], "=", " ", 
   RowBox[{
    SubscriptBox["D", "1"], 
    RowBox[{"\[Delta]", "[", "t", "]"}]}]}]]],
 ", this mean that the initial condition is   ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["x", "1"], "[", "0", "]"}], "=", " ", 
   SubscriptBox["D", "1"]}]]],
 ". Here is the solution when",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["D", "1"], "\[Rule]", " ", "1"}], ",", 
    RowBox[{
     SubscriptBox["k", "m"], " ", "\[Rule]", " ", "1.2"}], ",", " ", 
    RowBox[{
     SubscriptBox["V", "m"], " ", "\[Rule]", " ", "15"}]}], "}"}]]]
}], "Text",
 CellChangeTimes->{{3.6505982149455366`*^9, 3.6505982168830504`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"m", "[", "t_", "]"}], "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}], "/.", 
    RowBox[{"DSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            SubscriptBox["x", "1"], "'"}], "[", "t", "]"}], "+", 
          FractionBox[
           RowBox[{"15", " ", 
            RowBox[{
             SubscriptBox["x", "1"], "[", "t", "]"}]}], 
           RowBox[{"1.2", "+", 
            RowBox[{
             SubscriptBox["x", "1"], "[", "t", "]"}]}]]}], "==", "0"}], ",", 
        " ", 
        RowBox[{
         RowBox[{
          SubscriptBox["x", "1"], "[", "0", "]"}], " ", "\[Equal]", "1"}]}], 
       "}"}], ",", 
      RowBox[{
       SubscriptBox["x", "1"], "[", "t", "]"}], ",", " ", "t"}], "]"}]}], 
   "  ", "//", "Quiet"}]}]], "Input",
 CellChangeTimes->{{3.5823511814512806`*^9, 3.5823511926684017`*^9}, {
  3.5823512299807367`*^9, 3.582351260673192*^9}},
 CellLabel->"In[104]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"1.2`", " ", 
    RowBox[{
     TagBox["W",
      ProductLog], "(", 
     RowBox[{"0.8333333333333334`", " ", 
      RadicalBox[
       SuperscriptBox["2.718281828459045`", 
        RowBox[{"5.`", "\[VeryThinSpace]", "-", 
         RowBox[{"75.`", " ", "t"}]}]], "6"]}], ")"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806638167086`*^9, 3.479966548144038*^9, 3.479966776869038*^9, 
   3.479967354988038*^9, 3.479968239318038*^9, 3.513396449517851*^9, 
   3.582349745910013*^9, 3.582350850775216*^9, {3.5823511842345586`*^9, 
   3.582351193537489*^9}, 3.582351231567114*^9, 3.5823512616920233`*^9, 
   3.5823513825629425`*^9, 3.5922041865424075`*^9, 3.6427609447105055`*^9, 
   3.6502698008026133`*^9},
 CellLabel->"Out[104]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"m", "[", "t", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", "1"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", " ", "All"}]}], "]"}]], "Input",
 CellLabel->"In[105]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVWWc4Fo4XlfyyFUpEVpQZySzeI0lGZEaypRAiO4qMyMpMSUa0UFGKVHZI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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{All, All},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399280663910548*^9, 3.479966548212038*^9, 
  3.479966776931038*^9, 3.479967355139038*^9, 3.479968239383038*^9, 
  3.5133964496116037`*^9, 3.5823497460000224`*^9, 3.5823508509532337`*^9, 
  3.582351382664201*^9, 3.592204186697423*^9, 3.6427609447417245`*^9, 
  3.6502698008494883`*^9},
 CellLabel->"Out[105]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Bicompartmental with impulsive input", "SubsubsectionIcon"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"x1", ",", "x2"}], "]"}]], "Input",
 CellLabel->"In[106]:="],

Cell["\<\
The bicompartmental  Michaeles-Menten model given by equation \
\>", "Text"],

Cell[TextData[{
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "1"]]],
 "(t) =  - ",
 Cell[BoxData[
  SubscriptBox["k", "21"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(t)  + ",
 Cell[BoxData[
  SubscriptBox["k", "12"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "2"]]],
 "(t) -  ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{" ", 
     RowBox[{
      SubscriptBox["k", "1"], " ", 
      RowBox[{
       SubscriptBox["x", "1"], "(", "t", ")"}], " "}]}], 
    RowBox[{
     SubscriptBox["k", "2"], "+", " ", 
     RowBox[{
      SubscriptBox["x", "1"], "(", "t", ")"}]}]], TraditionalForm]]],
 " \n",
 Cell[BoxData[
  SubscriptBox[
   OverscriptBox["x", "."], "2"]]],
 "(t) = ",
 Cell[BoxData[
  SubscriptBox["k", "21"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(t)  -  ",
 Cell[BoxData[
  SubscriptBox["k", "12"]]],
 " ",
 Cell[BoxData[
  SubscriptBox["x", "2"]]],
 "(t) \n",
 Cell[BoxData[
  SubscriptBox["x", "1"]]],
 "(0) = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "0"], TraditionalForm]]],
 " , ",
 Cell[BoxData[
  SubscriptBox["x", "2"]]],
 "(0) = 0"
}], "NumberedEquation"],

Cell["with clearance coeffs: ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["k", "1"], " ", "=", " ", "0.2"}], ";", " ", 
  RowBox[{
   SubscriptBox["k", "2"], " ", "=", " ", "0.3"}], ";", 
  RowBox[{
   SubscriptBox["k", "12"], " ", "=", " ", "0.03"}], ";", 
  RowBox[{
   SubscriptBox["k", "21"], " ", "=", " ", "0.02"}], ";"}]], "Input",
 CellLabel->"In[107]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"x1", "'"}], "[", "t", "]"}], "+", 
    RowBox[{
     SubscriptBox["k", "21"], " ", 
     RowBox[{"x1", "[", "t", "]"}]}], "-", 
    RowBox[{
     SubscriptBox["k", "12"], " ", 
     RowBox[{"x2", "[", "t", "]"}]}], "+", 
    FractionBox[
     RowBox[{
      SubscriptBox["k", "1"], " ", 
      RowBox[{"x1", "[", "t", "]"}]}], 
     RowBox[{
      SubscriptBox["k", "2"], "+", 
      RowBox[{"x1", "[", "t", "]"}]}]]}], "==", "0"}]}]], "Input",
 CellLabel->"In[108]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["x1", "\[Prime]",
      MultilineFunction->None], "(", "t", ")"}], "+", 
    FractionBox[
     RowBox[{"0.2`", " ", 
      RowBox[{"x1", "(", "t", ")"}]}], 
     RowBox[{
      RowBox[{"x1", "(", "t", ")"}], "+", "0.3`"}]], "+", 
    RowBox[{"0.02`", " ", 
     RowBox[{"x1", "(", "t", ")"}]}], "-", 
    RowBox[{"0.03`", " ", 
     RowBox[{"x2", "(", "t", ")"}]}]}], "\[LongEqual]", "0"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399280663957468*^9, 3.4799665482410383`*^9, 3.479966776959038*^9, 
   3.479967355509038*^9, 3.479967466115038*^9, {3.479967504456038*^9, 
   3.479967559417038*^9}, 3.4799676397960377`*^9, 3.479967757743038*^9, 
   3.4799678213220377`*^9, 3.479968239416038*^9, 3.5133964496584797`*^9, 
   3.5823497460640287`*^9, 3.5823508509862375`*^9, 3.582351006594796*^9, 
   3.582351382717955*^9, 3.592204233849138*^9, 3.592204359822734*^9, 
   3.6427609447885985`*^9, 3.650269800911987*^9},
 CellLabel->"Out[108]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq2", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"x2", "'"}], "[", "t", "]"}], "-", 
    RowBox[{
     SubscriptBox["k", "21"], " ", 
     RowBox[{"x1", "[", "t", "]"}]}], "+", 
    RowBox[{
     SubscriptBox["k", "12"], " ", 
     RowBox[{"x2", "[", "t", "]"}]}]}], "==", "0"}]}]], "Input",
 CellLabel->"In[109]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"0.02`", " ", 
      RowBox[{"x1", "(", "t", ")"}]}]}], "+", 
    RowBox[{
     SuperscriptBox["x2", "\[Prime]",
      MultilineFunction->None], "(", "t", ")"}], "+", 
    RowBox[{"0.03`", " ", 
     RowBox[{"x2", "(", "t", ")"}]}]}], "\[LongEqual]", "0"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806639887476`*^9, 3.479966548278038*^9, 3.479966776990038*^9, 
   3.479967355581038*^9, 3.4799674661560383`*^9, {3.4799675045050383`*^9, 
   3.479967559455038*^9}, 3.4799676398330383`*^9, 3.4799677577880383`*^9, 
   3.479967821360038*^9, 3.4799682394540377`*^9, 3.5133964497053556`*^9, 
   3.5823497462510476`*^9, 3.5823508510222406`*^9, 3.582351006646802*^9, 
   3.58235138277921*^9, 3.5922042339121437`*^9, 3.5922043598937407`*^9, 
   3.6427609448042235`*^9, 3.6502698009432373`*^9},
 CellLabel->"Out[109]="]
}, Open  ]],

Cell["It can be solved using NDSolve", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", " ", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"eq1", ",", " ", "eq2", ",", 
      RowBox[{
       RowBox[{"x1", "[", "0", "]"}], " ", "==", " ", "1"}], ",", 
      RowBox[{
       RowBox[{"x2", "[", "0", "]"}], " ", "==", " ", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "[", "t", "]"}], ",", 
      RowBox[{"x2", "[", "t", "]"}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}], "   "}]], "Input",
 CellChangeTimes->{{3.479967989049038*^9, 3.479967989762038*^9}},
 CellLabel->"In[110]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x1", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       TagBox[
        TemplateBox[{RowBox[{
            StyleBox[
             TagBox["InterpolatingFunction", "SummaryHead"], 
             "NonInterpretableSummary"], 
            StyleBox["[", "NonInterpretableSummary"], 
            DynamicModuleBox[{Typeset`open$$ = False}, 
             PanelBox[
              PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj6sTC7w///vP1t+433D
3cQ/1sDC2vUY7z8/lvq2a77VP6svkVYMIe4/UPQI4wkn4D807oTtAjztPzg0
cm9ZVOU/bN6yF81d7D/3vGVz/fHqP2egkbRqb+s/r0FwQdgX8D+4y8QtfJPq
P07J8gTc7vI/80URC/in6T9JHOSKnbj1P5j+h1+rw+g/GA6ZlmZS+D8YNkre
YPHnP1IkE95ZJPs/QnaBVFEQ5z9g2VCrVMb9PyDasd8PQeY/5ax+nYYtAEDI
fKebnXjlP1B/NwP4kwFAly3zukKi5D8lIdIrbeICQIcPcb1B3eM/MFVPcvdM
BEDS0IYzEgvjP+nuA5rgsAVA3GyRADdA4j8MWJqEzfwGQIjdCFs4huE/ZVMT
jc9kCED6IRiKD8DgPygebljVtAlAkmjGtYoK4D8he6tB8CALQKNfv85lk94/
xz0gDGqGDECD5ytxuSDdP9fPdpnn0w1AGSA1GT/O2z8d9K9Eej0PQJeN/7N2
Z9o/53NlWYhHEEAitvXlXyDZP5WgDgED7RBAgwGb7krn1z9eFqk3iKARQBL1
/cxXnNY/3HO0Tw9IEkD1v0fk22/VP3Uasfag/RJA5nqG0oMz1D/lc0kO4q8T
QLAD42eXBtM/CrVSByVWFEDwxqSItfbRP0o/TY9yChVA7dI9SKXZ0D8/sbj4
wbIVQLNdRs/Gsc8/C9a/0sBXFkAOcXtbKczNP/JDuDvKChdAhzAinmrRyz+O
mSGG1bEXQK5/ZHLGC8o/RTh8X+tmGEBxZliFFzXIP7G+RxoDEBlA2UfsVH+R
xj/0965FyrUZQJ2UvqfdCMU/UnoHAJxpGkDZozt/8XPDP2Xk0JtvERtAYXgq
IaQNwj+Tl4vGTccbQG1lhCyVnsA/l/3hYdt5HECnhByb4Za+P1BLqd5qIB1A
K9e6r39DvD8k4mHqBNUdQIqMVMDY5bk/rWCL16B9HkApZwnGB9W3Pw2SUDXs
Ih9AWBtuevzvtT+IDAciQtYfQFIXfmjsBbQ/XDcX+Mw+IEArGMkyYl2yPwKN
oyZ+mSBA+9vSJnKzsD8TvH0Nh/IgQJHpp5KxZK4//l4Q5ZBFIUD6wz8Pc86r
P3emGwSgnyFAsWWEVhw6qT/KYd8TsPMhQIQkn3MCBac/q8Eba8VOIkAx44d8
G9WkP/f6pXoyqCJAKx75sOjgoj8eqOh6oPsiQH8Wz/ZqN6E/0vmjwhNWI0Br
Q8/DgyefP2G/F/uHqiNAzQlTazpgnD8yFFD6//8jQG/CWlQI0pk/zurIGw==

                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 10.}, {0., 0.9999999705345508}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                  GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj6sTC7w///vP1t+433D
3cQ/1sDC2vUY7z8/lvq2a77VP6svkVYMIe4/UPQI4wkn4D807oTtAjztPzg0
cm9ZVOU/bN6yF81d7D/3vGVz/fHqP2egkbRqb+s/r0FwQdgX8D+4y8QtfJPq
P07J8gTc7vI/80URC/in6T9JHOSKnbj1P5j+h1+rw+g/GA6ZlmZS+D8YNkre
YPHnP1IkE95ZJPs/QnaBVFEQ5z9g2VCrVMb9PyDasd8PQeY/5ax+nYYtAEDI
fKebnXjlP1B/NwP4kwFAly3zukKi5D8lIdIrbeICQIcPcb1B3eM/MFVPcvdM
BEDS0IYzEgvjP+nuA5rgsAVA3GyRADdA4j8MWJqEzfwGQIjdCFs4huE/ZVMT
jc9kCED6IRiKD8DgPygebljVtAlAkmjGtYoK4D8he6tB8CALQKNfv85lk94/
xz0gDGqGDECD5ytxuSDdP9fPdpnn0w1AGSA1GT/O2z8d9K9Eej0PQJeN/7N2
Z9o/53NlWYhHEEAitvXlXyDZP5WgDgED7RBAgwGb7krn1z9eFqk3iKARQBL1
/cxXnNY/3HO0Tw9IEkD1v0fk22/VP3Uasfag/RJA5nqG0oMz1D/lc0kO4q8T
QLAD42eXBtM/CrVSByVWFEDwxqSItfbRP0o/TY9yChVA7dI9SKXZ0D8/sbj4
wbIVQLNdRs/Gsc8/C9a/0sBXFkAOcXtbKczNP/JDuDvKChdAhzAinmrRyz+O
mSGG1bEXQK5/ZHLGC8o/RTh8X+tmGEBxZliFFzXIP7G+RxoDEBlA2UfsVH+R
xj/0965FyrUZQJ2UvqfdCMU/UnoHAJxpGkDZozt/8XPDP2Xk0JtvERtAYXgq
IaQNwj+Tl4vGTccbQG1lhCyVnsA/l/3hYdt5HECnhByb4Za+P1BLqd5qIB1A
K9e6r39DvD8k4mHqBNUdQIqMVMDY5bk/rWCL16B9HkApZwnGB9W3Pw2SUDXs
Ih9AWBtuevzvtT+IDAciQtYfQFIXfmjsBbQ/XDcX+Mw+IEArGMkyYl2yPwKN
oyZ+mSBA+9vSJnKzsD8TvH0Nh/IgQJHpp5KxZK4//l4Q5ZBFIUD6wz8Pc86r
P3emGwSgnyFAsWWEVhw6qT/KYd8TsPMhQIQkn3MCBac/q8Eba8VOIkAx44d8
G9WkP/f6pXoyqCJAKx75sOjgoj8eqOh6oPsiQH8Wz/ZqN6E/0vmjwhNWI0Br
Q8/DgyefP2G/F/uHqiNAzQlTazpgnD8yFFD6//8jQG/CWlQI0pk/zurIGw==

                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 10.}, {0., 0.9999999705345508}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                  GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  BaselinePosition -> {1, 1}]}, 
               Dynamic[Typeset`open$$], ImageSize -> Automatic], 
              BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
            StyleBox["]", "NonInterpretableSummary"]}]},
         "CopyTag",
         DisplayFunction->(#& ),
         InterpretationFunction->("InterpolatingFunction[{{0., 10.}}, <>]"& )],
        False,
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"x2", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       TagBox[
        TemplateBox[{RowBox[{
            StyleBox[
             TagBox["InterpolatingFunction", "SummaryHead"], 
             "NonInterpretableSummary"], 
            StyleBox["[", "NonInterpretableSummary"], 
            DynamicModuleBox[{Typeset`open$$ = False}, 
             PanelBox[
              PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4AwIXLUB4tPlt+433D
3cQ/Aa7YAVxEaj8/lvq2a77VPxqWUYOJ4Ho/UPQI4wkn4D/Nzf6wPKCDPzg0
cm9ZVOU/SinCA+96iT/3vGVz/fHqP1BhKB7YmI8/r0FwQdgX8D9Glb7KdYuS
P07J8gTc7vI/t+Lwa6lnlT9JHOSKnbj1P9Kz+6/uGJg/GA6ZlmZS+D8IZux0
4oGaP1IkE95ZJPs/cY+gpf4CnT9g2VCrVMb9PyZLjzXAP58/5ax+nYYtAEDz
2vkIwaygP1B/NwP4kwFAM2eLp27DoT8lIdIrbeICQHImKyltu6I/MFVPcvdM
BEBjpXMvXrujP+nuA5rgsAVAdVYhS9uppD8MWJqEzfwGQI7PnSwZfaU/ZVMT
jc9kCECbezlBRlamPygebljVtAlAx4v/ogIWpz8he6tB8CALQEEy8CMV2qc/
xz0gDGqGDEAvy3eDCY+oP9fPdpnn0w1ApIVf3MgtqT8d9K9Eej0PQATZBTwz
z6k/53NlWYhHEEC/m6dEHlyqP5WgDgED7RBAb5XAwVbdqj9eFqk3iKARQNGB
cuDNX6s/3HO0Tw9IEkD9HogQstCrP3Uasfag/RJA6RVWjrFBrD/lc0kO4q8T
QHupiQF5p6w/CrVSByVWFECrSNS8gf6sP0o/TY9yChVAeBhupZVUrT8/sbj4
wbIVQLAOZ2xsna0/C9a/0sBXFkBE1tCfDt6tP/JDuDvKChdAJ9nOfekcrj+O
mSGG1bEXQAaUdRwDUa4/RTh8X+tmGEDkltXOrYKuP7G+RxoDEBlAXb0b6vSq
rj/0965FyrUZQNmgBHUBza4/UnoHAJxpGkBKqXQbKeyuP2Xk0JtvERtAlxF3
MxoErz+Tl4vGTccbQO8dE3vFGK8/l/3hYdt5HEBp7ounCyivP1BLqd5qIB1A
PC2HqRcyrz8k4mHqBNUdQGAf18GzOK8/rWCL16B9HkCF7IVbHjuvPw2SUDXs
Ih9AmQO4TTY6rz+IDAciQtYfQEwBR/zSNa8/XDcX+Mw+IEBWIeC0xS6vPwKN
oyZ+mSBANEtK8igkrz8TvH0Nh/IgQLaz8C/8Fq8//l4Q5ZBFIUD52wLPcQiv
P3emGwSgnyFA1TdjzG72rj/KYd8TsPMhQGcf0Zuz464/q8Eba8VOIkCOews6
g82uP/f6pXoyqCJAli27R/+1rj8eqOh6oPsiQFPBu8mqnq4/0vmjwhNWI0C4
DpQhA4SuP2G/F/uHqiNA2VQKc/pprj8yFFD6//8jQDs0UUmgTq4/hyS3pw==

                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 10.}, {0., 0.06099791400171121}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                  GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4AwIXLUB4tPlt+433D
3cQ/Aa7YAVxEaj8/lvq2a77VPxqWUYOJ4Ho/UPQI4wkn4D/Nzf6wPKCDPzg0
cm9ZVOU/SinCA+96iT/3vGVz/fHqP1BhKB7YmI8/r0FwQdgX8D9Glb7KdYuS
P07J8gTc7vI/t+Lwa6lnlT9JHOSKnbj1P9Kz+6/uGJg/GA6ZlmZS+D8IZux0
4oGaP1IkE95ZJPs/cY+gpf4CnT9g2VCrVMb9PyZLjzXAP58/5ax+nYYtAEDz
2vkIwaygP1B/NwP4kwFAM2eLp27DoT8lIdIrbeICQHImKyltu6I/MFVPcvdM
BEBjpXMvXrujP+nuA5rgsAVAdVYhS9uppD8MWJqEzfwGQI7PnSwZfaU/ZVMT
jc9kCECbezlBRlamPygebljVtAlAx4v/ogIWpz8he6tB8CALQEEy8CMV2qc/
xz0gDGqGDEAvy3eDCY+oP9fPdpnn0w1ApIVf3MgtqT8d9K9Eej0PQATZBTwz
z6k/53NlWYhHEEC/m6dEHlyqP5WgDgED7RBAb5XAwVbdqj9eFqk3iKARQNGB
cuDNX6s/3HO0Tw9IEkD9HogQstCrP3Uasfag/RJA6RVWjrFBrD/lc0kO4q8T
QHupiQF5p6w/CrVSByVWFECrSNS8gf6sP0o/TY9yChVAeBhupZVUrT8/sbj4
wbIVQLAOZ2xsna0/C9a/0sBXFkBE1tCfDt6tP/JDuDvKChdAJ9nOfekcrj+O
mSGG1bEXQAaUdRwDUa4/RTh8X+tmGEDkltXOrYKuP7G+RxoDEBlAXb0b6vSq
rj/0965FyrUZQNmgBHUBza4/UnoHAJxpGkBKqXQbKeyuP2Xk0JtvERtAlxF3
MxoErz+Tl4vGTccbQO8dE3vFGK8/l/3hYdt5HEBp7ounCyivP1BLqd5qIB1A
PC2HqRcyrz8k4mHqBNUdQGAf18GzOK8/rWCL16B9HkCF7IVbHjuvPw2SUDXs
Ih9AmQO4TTY6rz+IDAciQtYfQEwBR/zSNa8/XDcX+Mw+IEBWIeC0xS6vPwKN
oyZ+mSBANEtK8igkrz8TvH0Nh/IgQLaz8C/8Fq8//l4Q5ZBFIUD52wLPcQiv
P3emGwSgnyFA1TdjzG72rj/KYd8TsPMhQGcf0Zuz464/q8Eba8VOIkCOews6
g82uP/f6pXoyqCJAli27R/+1rj8eqOh6oPsiQFPBu8mqnq4/0vmjwhNWI0C4
DpQhA4SuP2G/F/uHqiNA2VQKc/pprj8yFFD6//8jQDs0UUmgTq4/hyS3pw==

                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0., 10.}, {0., 0.06099791400171121}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                  GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                  False, GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  BaselinePosition -> {1, 1}]}, 
               Dynamic[Typeset`open$$], ImageSize -> Automatic], 
              BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
            StyleBox["]", "NonInterpretableSummary"]}]},
         "CopyTag",
         DisplayFunction->(#& ),
         InterpretationFunction->("InterpolatingFunction[{{0., 10.}}, <>]"& )],
        False,
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806640200276`*^9, 3.479966548311038*^9, 3.479966777025038*^9, 
   3.479967355666038*^9, 3.479967466194038*^9, {3.479967504540038*^9, 
   3.479967559490038*^9}, 3.479967639876038*^9, 3.4799677578410378`*^9, {
   3.4799678121450377`*^9, 3.479967821401038*^9}, {3.479967852305038*^9, 
   3.4799679213810377`*^9}, 3.479967998720038*^9, 3.479968101981038*^9, 
   3.479968239492038*^9, 3.5133964497522326`*^9, 3.5823497463600583`*^9, 
   3.5823508510582447`*^9, 3.5823510066958065`*^9, 3.582351382854216*^9, 
   3.592204233961149*^9, 3.592204359943746*^9, 3.642760944866725*^9, 
   3.6502698010057373`*^9},
 CellLabel->"Out[110]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x1", "[", "t", "]"}], ",", 
       RowBox[{"x2", "[", "t", "]"}]}], "}"}], "/.", "s"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<x1\>\"", ",", "\"\<x2\>\""}], "}"}], ",", "Center", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Framed", "[", 
         RowBox[{"#", ",", 
          RowBox[{"RoundingRadius", "\[Rule]", "5"}]}], "]"}], "&"}], ")"}]}],
      "]"}]}]}], " ", "]"}]], "Input",
 CellChangeTimes->{
  3.479966692629038*^9, 3.479967061162038*^9, {3.479967491719038*^9, 
   3.479967551402038*^9}, {3.479967788471038*^9, 3.479967800861038*^9}, {
   3.4799678629130383`*^9, 3.4799679168540382`*^9}, {3.4799679933660383`*^9, 
   3.4799679946450377`*^9}, {3.479968061545038*^9, 3.479968081077038*^9}, {
   3.4799681328540382`*^9, 3.479968179865038*^9}, {3.592204202327986*^9, 
   3.5922042184806013`*^9}, {3.592204305797332*^9, 3.592204377425494*^9}},
 CellLabel->"In[111]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   FormBox[
    GraphicsBox[{{{}, {}, 
       {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
        Opacity[1.], LineBox[CompressedData["
1:eJwVx3k41AkYwPERSpGoTMgc/NqWiTZPkWzrfaWSHMXqmdTkbJAchedBZCu3
qLCZnRmT0uipp0y7ZeUozTpWNCNXtU1FI7dhHA0qy7Z/fJ/P8zUNjPJiLyGR
SO7f+l9BcuBS6+MXHc52TSsWF5Vw7YjCnkk/AU8trOU3virhjXt2NJ2eAH+U
fae5e1YJcc4+upr0LHBRlQ9ljithbwOyZmlcOJASTjV4r4SyC9tSJmh34DYP
dm+vVoI8QEQeo1VB07uWwpJYJSR6nvQfpTVDCOHKII+Mw/LP/ObwzTJYO2Uj
SxOPwem6X3IU0R+h5SDNAEUK2CwsaC8XDUOxFce7STgK/R6hJj12E/A4bqq5
MnMEOMbplBv+07CzYZtZYMow7IiuvK8umYGVRKm3b/gQ1L/mH4z6/gsc1DY/
0Oo7CNY5Cw6GLv/CJb+SJ6yQAXAesO/ZwiQhLSxBkuHXD4NWFXs+KdRwdpC5
/3JEHyTOZ219fEYdG1mxlPTUj7BMf+iEN0MTLdutcs/m9IKmVNNZ+8lSzJ+u
O1V+Rw5fW8vC809roWFHLGV91QfoZ4qMqNQV6LJpzrta2AOOmZERz8q00ZNK
y2CTuuHqQuVyJ7+V6Gj+KKnd6R0cNal3ezetiyTX8osv7stAR7xJYXZIDw93
VXT4LH0DbJsSlY+lPu4/dkV15vRriEuO96Kr9FGbMxXIUX8FaSMFna2tq3Gc
mx24MbUL3Birbuvw1uDNvcFzY4xOyC2zFbsFrMVVj/SS/u5rh5afb87H7jBA
v2TuNY28NhBLo3Is1cko166wlde1woOw8yh5T0ZBVF5ao4cEqK5gF1m+DlPT
PGe6NVrAaZGVUpxkiGEZYx7mC01w/NXTqcpDRpjN6jc1G2kEh/MX/gygG2Np
zXiEDbkB8qMma3QGjbGxpD/xSHAd9J4rHSiuXY+5v26f4d4Xwyi76nhdhgnq
6p9Taw+qhYmI1cukARR00Z28kRhUAyKX5/PBVlS0WxcncpNUwkDoFlt1FRXZ
nZm3o2MqwPiurCBDSsPg0X+KFSblkOIfXSJ1pWNx4VA8g/oAZueNcl2r6OjF
O7bFbuPvYF7D4bZsMMXqN+0/5kjvgU1Q4wH9LFP87a/I/BWyOyAuMjCUqEyR
lH4v+dTsLTAXG2R7HDVDtbeic5QcIbhrKigdtWY43PbJqepECUy87atvZhAo
N7InQpnXIaood03WZQLdPPu6vHcKQKK2Qbk/j0CxRUiPxEoAjJDqFp0CAuNT
gu3daALosx48f6WQQDuzVy/9lwjgcBNOcAQEdrOPesifFcGuqWnJrbsELn+h
V7qTWQTkfUfSG5oI7Ix5IndO4ENM2URAejOBMWeeWghP8qFtdcZP+54TGEQy
CVzmy4eL7x9+et5KYL37B07vLj6QYlYGdb4kUOYcXz+qw4cRgRh6PxKYf2Eu
YW8JD5zVmeuF/QSuCiP89K7yQBg6NsMeJNChh6Mhz+CB31Zj0fAIgY62PqmF
ETzoehZjMjlJ4A8TNHWvHTyw3rxi7sE0gexrCYWeljy4VHC9M1ZFYFLA2g4m
jQcuvtLsuTkC+4a1bOM1eXCrPii4+guBWnn+h/PnuKBh8cUxaZ7AYj0V+eEo
FwIuXaE4LHx7n8ZIWTcXaqc3fl5cJHCA1cbS6uDCf+1YRuw=
         "]]}, 
       {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], 
        Opacity[1.], LineBox[CompressedData["
1:eJwV13k4VWsXAPCDVOYp4gz7nOMgU4aizO9KN6IMkUpkTFGmuGnSRBlLNMks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         "]]}}, InsetBox[
       FrameBox[
        FormBox[
         TemplateBox[{"\"x1\"","\"x2\""},
          "LineLegend",
          DisplayFunction->(FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
             False], TraditionalForm]& ),
          Editable->True,
          InterpretationFunction:>(RowBox[{"LineLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                   ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, AspectRatio -> 1, Frame -> 
                    True, FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                    "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                 RowBox[{#, ",", #2}], "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", 
                 RowBox[{"{", "}"}]}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"\"Column\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"Automatic", ",", "5"}], "}"}]}], "}"}]}]}], 
             "]"}]& )],
         TraditionalForm],
        RoundingRadius->5,
        StripOnInput->False], Scaled[{0.5, 0.5}], ImageScaled[{0.5, 0.5}],
       BaseStyle->{FontSize -> Larger},
       FormatType->StandardForm]},
     AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
     Axes->{True, True},
     AxesLabel->{None, None},
     AxesOrigin->{0, 0},
     DisplayFunction->Identity,
     Frame->{{False, False}, {False, False}},
     FrameLabel->{{None, None}, {None, None}},
     FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
     GridLines->{None, None},
     GridLinesStyle->Directive[
       GrayLevel[0.5, 0.4]],
     Method->{
      "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
       AbsolutePointSize[6], "ScalingFunctions" -> None},
     PlotRange->{{0, 10}, {0., 0.999999964521194}},
     PlotRangeClipping->True,
     PlotRangePadding->{{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.05], 
        Scaled[0.05]}},
     Ticks->{Automatic, Automatic}],
    TraditionalForm],
   InterpretTemplate[Legended[
     Graphics[{{{}, {}, {
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         Line[CompressedData["
1:eJwVx3k41AkYwPERSpGoTMgc/NqWiTZPkWzrfaWSHMXqmdTkbJAchedBZCu3
qLCZnRmT0uipp0y7ZeUozTpWNCNXtU1FI7dhHA0qy7Z/fJ/P8zUNjPJiLyGR
SO7f+l9BcuBS6+MXHc52TSsWF5Vw7YjCnkk/AU8trOU3virhjXt2NJ2eAH+U
fae5e1YJcc4+upr0LHBRlQ9ljithbwOyZmlcOJASTjV4r4SyC9tSJmh34DYP
dm+vVoI8QEQeo1VB07uWwpJYJSR6nvQfpTVDCOHKII+Mw/LP/ObwzTJYO2Uj
SxOPwem6X3IU0R+h5SDNAEUK2CwsaC8XDUOxFce7STgK/R6hJj12E/A4bqq5
MnMEOMbplBv+07CzYZtZYMow7IiuvK8umYGVRKm3b/gQ1L/mH4z6/gsc1DY/
0Oo7CNY5Cw6GLv/CJb+SJ6yQAXAesO/ZwiQhLSxBkuHXD4NWFXs+KdRwdpC5
/3JEHyTOZ219fEYdG1mxlPTUj7BMf+iEN0MTLdutcs/m9IKmVNNZ+8lSzJ+u
O1V+Rw5fW8vC809roWFHLGV91QfoZ4qMqNQV6LJpzrta2AOOmZERz8q00ZNK
y2CTuuHqQuVyJ7+V6Gj+KKnd6R0cNal3ezetiyTX8osv7stAR7xJYXZIDw93
VXT4LH0DbJsSlY+lPu4/dkV15vRriEuO96Kr9FGbMxXIUX8FaSMFna2tq3Gc
mx24MbUL3Birbuvw1uDNvcFzY4xOyC2zFbsFrMVVj/SS/u5rh5afb87H7jBA
v2TuNY28NhBLo3Is1cko166wlde1woOw8yh5T0ZBVF5ao4cEqK5gF1m+DlPT
PGe6NVrAaZGVUpxkiGEZYx7mC01w/NXTqcpDRpjN6jc1G2kEh/MX/gygG2Np
zXiEDbkB8qMma3QGjbGxpD/xSHAd9J4rHSiuXY+5v26f4d4Xwyi76nhdhgnq
6p9Taw+qhYmI1cukARR00Z28kRhUAyKX5/PBVlS0WxcncpNUwkDoFlt1FRXZ
nZm3o2MqwPiurCBDSsPg0X+KFSblkOIfXSJ1pWNx4VA8g/oAZueNcl2r6OjF
O7bFbuPvYF7D4bZsMMXqN+0/5kjvgU1Q4wH9LFP87a/I/BWyOyAuMjCUqEyR
lH4v+dTsLTAXG2R7HDVDtbeic5QcIbhrKigdtWY43PbJqepECUy87atvZhAo
N7InQpnXIaood03WZQLdPPu6vHcKQKK2Qbk/j0CxRUiPxEoAjJDqFp0CAuNT
gu3daALosx48f6WQQDuzVy/9lwjgcBNOcAQEdrOPesifFcGuqWnJrbsELn+h
V7qTWQTkfUfSG5oI7Ix5IndO4ENM2URAejOBMWeeWghP8qFtdcZP+54TGEQy
CVzmy4eL7x9+et5KYL37B07vLj6QYlYGdb4kUOYcXz+qw4cRgRh6PxKYf2Eu
YW8JD5zVmeuF/QSuCiP89K7yQBg6NsMeJNChh6Mhz+CB31Zj0fAIgY62PqmF
ETzoehZjMjlJ4A8TNHWvHTyw3rxi7sE0gexrCYWeljy4VHC9M1ZFYFLA2g4m
jQcuvtLsuTkC+4a1bOM1eXCrPii4+guBWnn+h/PnuKBh8cUxaZ7AYj0V+eEo
FwIuXaE4LHx7n8ZIWTcXaqc3fl5cJHCA1cbS6uDCf+1YRuw=
          "]]}, {
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]], 
         Line[CompressedData["
1:eJwV13k4VWsXAPCDVOYp4gz7nOMgU4aizO9KN6IMkUpkTFGmuGnSRBlLNMks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          "]]}}}, {
      DisplayFunction -> Identity, AspectRatio -> GoldenRatio^(-1), 
       Axes -> {True, True}, AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
       DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}},
        FrameLabel -> {{None, None}, {None, None}}, 
       FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
       GridLines -> {None, None}, GridLinesStyle -> Directive[
         GrayLevel[0.5, 0.4]], 
       Method -> {
        "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
         AbsolutePointSize[6], "ScalingFunctions" -> None}, 
       PlotRange -> {{0, 10}, {0., 0.999999964521194}}, PlotRangeClipping -> 
       True, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.05], 
          Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], 
     Placed[
      Unevaluated[
       LineLegend[{
         Directive[
          Opacity[1.], 
          RGBColor[0.368417, 0.506779, 0.709798], 
          AbsoluteThickness[1.6]], 
         Directive[
          Opacity[1.], 
          RGBColor[0.880722, 0.611041, 0.142051], 
          AbsoluteThickness[1.6]]}, {"x1", "x2"}, LegendMarkers -> None, 
        LabelStyle -> {}, LegendLayout -> {"Column", {Automatic, 5}}]], 
      Center, Framed[#, RoundingRadius -> 5]& ]]& ],
   AutoDelete->True,
   Editable->True,
   SelectWithContents->False,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.3992806645048647`*^9, 3.479966548580038*^9, 3.479966777257038*^9, 
   3.479967357889038*^9, 3.479967466431038*^9, {3.479967504769038*^9, 
   3.479967559736038*^9}, 3.479967639977038*^9, 3.479967758113038*^9, {
   3.4799677911160383`*^9, 3.479967821636038*^9}, {3.479967852577038*^9, 
   3.479967921669038*^9}, 3.479967999023038*^9, {3.479968092525038*^9, 
   3.4799681023030376`*^9}, {3.4799681382630377`*^9, 3.479968180702038*^9}, 
   3.4799682397670383`*^9, 3.5133964506116295`*^9, 3.582349747366159*^9, 
   3.5823508523193703`*^9, 3.5823510078479214`*^9, 3.5823513839730554`*^9, 
   3.592204234061159*^9, {3.592204360051757*^9, 3.592204378221574*^9}, 
   3.642760944929224*^9, 3.6502698010682373`*^9},
 CellLabel->"Out[111]="]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Roberts-Rowland equation (J. Pharmacokim.Biopharm 14: 227-260 (1986) ) \
\>", "SubsectionIcon",
 CellChangeTimes->{{3.5133969256706657`*^9, 3.5133969294988885`*^9}, 
   3.5134111671654053`*^9, {3.6505976863201003`*^9, 3.650597689679392*^9}}],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.513411226120039*^9, 3.5134112282294683`*^9}},
 CellLabel->"In[112]:="],

Cell["\<\
Here is solved eq. (1) by Roberts-Rowland J. Pharmacokim.Biopharm 14: 227-260 \
(1986) \
\>", "Abstract"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["\[PartialD]", "2"], "c"}], 
     RowBox[{"\[PartialD]", 
      SuperscriptBox["z", "2"]}]], "-", 
    RowBox[{
     FractionBox["1", 
      SubscriptBox["d", "n"]], 
     FractionBox[
      RowBox[{"\[PartialD]", "c"}], 
      RowBox[{"\[PartialD]", "z"}]]}], "-", 
    RowBox[{
     FractionBox[
      SubscriptBox["r", "n"], 
      SubscriptBox["d", "n"]], "c"}]}], "=", 
   RowBox[{
    FractionBox["1", 
     SubscriptBox["d", "n"]], 
    FractionBox[
     RowBox[{"\[PartialD]", "c"}], 
     RowBox[{"\[PartialD]", "z"}]]}]}], ",", 
  RowBox[{
   RowBox[{"where", " ", "c"}], "=", 
   RowBox[{"c", 
    RowBox[{"(", 
     RowBox[{"z", ",", "t"}], ")"}], " "}]}]}]], "NumberedEquation"],

Cell[TextData[{
 "Note: Roberts-Rowland paper use capital letters. (i.e: C in place of c, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["R", "n"], TraditionalForm]]],
 " in place of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "n"], TraditionalForm]]],
 ", etc.) "
}], "Commentary"],

Cell["Here is solved the case with \"mixed\" boundary conditions", "Text"],

Cell[TextData[{
 "Initial condition (IC): t =0, c= 0, 0\[LessEqual]z\[LessEqual]1\nBoundary \
conditions (BC): (The \"mixed\" boundary conditions): For z=0: c \
=\[Delta](z), for z=\[Infinity]: c=0, in other notation: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"c", "(", "0", ")"}], "=", 
    RowBox[{"\[Delta]", "(", "t", ")"}]}], TraditionalForm]]],
 " y ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"c", "(", "\[Infinity]", ")"}], " ", "=", "0"}], 
   TraditionalForm]]],
 "."
}], "Text"],

Cell[TextData[{
 "Eq(17) in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " notation can be wrote "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"z", ",", "t"}], "]"}], ",", "t"}], "]"}], "==", 
  RowBox[{
   RowBox[{
    SubscriptBox["d", "n"], " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"z", ",", "t"}], "]"}], ",", "z", ",", "z"}], "]"}]}], "-", 
   " ", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "z"}], "]"}], "-", 
   RowBox[{
    SubscriptBox["r", "n"], " ", 
    SubscriptBox["d", "n"], 
    RowBox[{"c", "[", 
     RowBox[{"z", ",", "t"}], "]"}], 
    RowBox[{"(", "2", ")"}]}]}]}]], "NumberedEquation"],

Cell["IC: c[z,0]\[Rule]0", "Text"],

Cell["\<\
Here is solved eq.(18) using Laplace Transform. (The right side terms of eq. \
18 are denoted by eq1 and the left by eq2)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1", "=", 
  RowBox[{"LaplaceTransform", "[", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"z", ",", "t"}], "]"}], ",", "t"}], "]"}], ",", " ", "t", ",", 
    "s"}], "]"}]}]], "Input",
 CellLabel->"In[1]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"c", "[", 
    RowBox[{"z", ",", "0"}], "]"}]}], "+", 
  RowBox[{"s", " ", 
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{3.3992806652243*^9, 3.479966549126038*^9, 
  3.479966777379038*^9, 3.479967358403038*^9, 3.479968240192038*^9, 
  3.513585021907697*^9, 3.513585106816121*^9, 3.518530235375618*^9, 
  3.5185310361097417`*^9, 3.5185317734676485`*^9, 3.5922044189816494`*^9, 
  3.5922048572122307`*^9, 3.592205133924183*^9, 3.64276107914904*^9},
 CellLabel->"Out[1]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq2", "=", 
  RowBox[{"LaplaceTransform", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["d", "n"], " ", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"z", ",", "t"}], "]"}], ",", "z", ",", "z"}], "]"}]}], "-", 
     " ", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"z", ",", "t"}], "]"}], ",", "z"}], "]"}], "-", 
     RowBox[{
      SubscriptBox["r", "n"], " ", 
      SubscriptBox["d", "n"], " ", 
      RowBox[{"c", "[", 
       RowBox[{"z", ",", "t"}], "]"}]}]}], ",", " ", "t", ",", "s"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"1", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["c", 
       TagBox[
        RowBox[{"(", 
         RowBox[{"2", ",", "0"}], ")"}],
        Derivative],
       MultilineFunction->None], "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], " ", 
   SubscriptBox["d", "n"]}], "-", 
  RowBox[{
   RowBox[{"LaplaceTransform", "[", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], " ", 
   SubscriptBox["d", "n"], " ", 
   SubscriptBox["r", "n"]}]}]], "Output",
 CellChangeTimes->{3.3992806653024993`*^9, 3.479966549247038*^9, 
  3.479966777445038*^9, 3.479967358626038*^9, 3.479968240330038*^9, 
  3.5135850221577034`*^9, 3.513585107003626*^9, 3.5185302356256227`*^9, 
  3.518531036375372*^9, 3.518531773639527*^9, 3.5922044193206835`*^9, 
  3.5922048575382633`*^9, 3.5922051342049885`*^9, 3.642761079289654*^9},
 CellLabel->"Out[2]="]
}, Open  ]],

Cell["\<\
Now we calculate their Laplace Transforms. The are denoted in capital letters \
(i.e: for c[z,0] the LT is C[z,s] ). BC and IC are applied.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq1LT", " ", "=", " ", 
  RowBox[{"eq1", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"LaplaceTransform", "[", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], 
     "\[Rule]", 
     RowBox[{"C", "[", 
      RowBox[{"z", ",", "s"}], "]"}]}], "}"}]}]}]], "Input",
 CellLabel->"In[3]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"c", "[", 
    RowBox[{"z", ",", "0"}], "]"}]}], "+", 
  RowBox[{"s", " ", 
   RowBox[{"C", "[", 
    RowBox[{"z", ",", "s"}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.3992806653337793`*^9, 3.479966549290038*^9, 
  3.479966777485038*^9, 3.4799673586830378`*^9, 3.479968240369038*^9, 
  3.5135850222358303`*^9, 3.5135851070661273`*^9, 3.518530235703749*^9, 
  3.518531036437873*^9, 3.5185317736707773`*^9, 3.592204419395691*^9, 
  3.592204857633273*^9, 3.5922051342985897`*^9, 3.6427610793052845`*^9},
 CellLabel->"Out[3]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq2LT", " ", "=", " ", 
  RowBox[{"eq2", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"LaplaceTransform", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"1", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], 
      "\[Rule]", 
      RowBox[{
       SuperscriptBox["C", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"1", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"z", ",", "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"LaplaceTransform", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", 
          TagBox[
           RowBox[{"(", 
            RowBox[{"2", ",", "0"}], ")"}],
           Derivative],
          MultilineFunction->None], "[", 
         RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], 
      "\[Rule]", 
      RowBox[{
       SuperscriptBox["C", 
        TagBox[
         RowBox[{"(", 
          RowBox[{"2", ",", "0"}], ")"}],
         Derivative],
        MultilineFunction->None], "[", 
       RowBox[{"z", ",", "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"LaplaceTransform", "[", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"z", ",", "t"}], "]"}], ",", "t", ",", "s"}], "]"}], 
      "\[Rule]", 
      RowBox[{"C", "[", 
       RowBox[{"z", ",", "s"}], "]"}]}]}], "}"}]}]}]], "Input",
 CellLabel->"In[4]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"C", "[", 
     RowBox[{"z", ",", "s"}], "]"}]}], " ", 
   SubscriptBox["d", "n"], " ", 
   SubscriptBox["r", "n"]}], "-", 
  RowBox[{
   SuperscriptBox["C", 
    TagBox[
     RowBox[{"(", 
      RowBox[{"1", ",", "0"}], ")"}],
     Derivative],
    MultilineFunction->None], "[", 
   RowBox[{"z", ",", "s"}], "]"}], "+", 
  RowBox[{
   SubscriptBox["d", "n"], " ", 
   RowBox[{
    SuperscriptBox["C", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"2", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"z", ",", "s"}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.3992806654119787`*^9, 3.479966549353038*^9, 
  3.479966777547038*^9, 3.479967358793038*^9, 3.479968240434038*^9, 
  3.513585022345208*^9, 3.513585107144254*^9, 3.518530235813126*^9, 
  3.51853103654725*^9, 3.5185317737332788`*^9, 3.5922044195617075`*^9, 
  3.592204857822292*^9, 3.5922051344857936`*^9, 3.6427610793521547`*^9},
 CellLabel->"Out[4]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A26", "=", 
  RowBox[{
   RowBox[{"eq1LT", " ", "==", "eq2LT"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "0"}], "]"}], "\[Rule]", "0"}], "}"}]}]}]], "Input",
 CellLabel->"In[5]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"s", " ", 
   RowBox[{"C", "[", 
    RowBox[{"z", ",", "s"}], "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"C", "[", 
      RowBox[{"z", ",", "s"}], "]"}]}], " ", 
    SubscriptBox["d", "n"], " ", 
    SubscriptBox["r", "n"]}], "-", 
   RowBox[{
    SuperscriptBox["C", 
     TagBox[
      RowBox[{"(", 
       RowBox[{"1", ",", "0"}], ")"}],
      Derivative],
     MultilineFunction->None], "[", 
    RowBox[{"z", ",", "s"}], "]"}], "+", 
   RowBox[{
    SubscriptBox["d", "n"], " ", 
    RowBox[{
     SuperscriptBox["C", 
      TagBox[
       RowBox[{"(", 
        RowBox[{"2", ",", "0"}], ")"}],
       Derivative],
      MultilineFunction->None], "[", 
     RowBox[{"z", ",", "s"}], "]"}]}]}]}]], "Output",
 CellChangeTimes->{3.3992806654588985`*^9, 3.479966549386038*^9, 
  3.4799667776310377`*^9, 3.479967360585038*^9, 3.479968240468038*^9, 
  3.5135850223920846`*^9, 3.5135851071755047`*^9, 3.518530235860002*^9, 
  3.518531036609751*^9, 3.518531773764529*^9, 3.592204419603711*^9, 
  3.592204857872297*^9, 3.592205134548195*^9, 3.6427610793677793`*^9},
 CellLabel->"Out[5]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LaplaceTransform", "[", 
  RowBox[{
   RowBox[{"DiracDelta", "[", "z", "]"}], ",", "z", ",", "s"}], 
  "]"}]], "Input",
 CellLabel->"In[6]:="],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.399280665646577*^9, 3.479966549555038*^9, 
  3.479966777698038*^9, 3.479967366305038*^9, 3.479968240573038*^9, 
  3.5135850230952277`*^9, 3.5135851073005085`*^9, 3.5185302375475345`*^9, 
  3.5185310368285055`*^9, 3.5185317739364076`*^9, 3.592204419863737*^9, 
  3.5922048580953193`*^9, 3.5922051347509985`*^9, 3.6427610794459057`*^9},
 CellLabel->"Out[6]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eq26b", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"s", " ", 
        RowBox[{"C", "[", "z", "]"}]}], "==", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"C", "[", "z", "]"}]}], " ", 
         SubscriptBox["d", "n"], " ", 
         SubscriptBox["r", "n"]}], "-", 
        RowBox[{
         RowBox[{"C", "'"}], "[", "z", "]"}], "+", 
        RowBox[{
         SubscriptBox["d", "n"], " ", 
         RowBox[{
          RowBox[{"C", "''"}], "[", "z", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{"C", "[", "0", "]"}], "\[Equal]", "1"}]}], "}"}], ",", 
    RowBox[{"C", "[", "z", "]"}], ",", "z"}], "]"}]}]], "Input",
 CellLabel->"In[7]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"C", "[", "z", "]"}], "\[Rule]", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       FractionBox["1", "2"], " ", "z", " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          SubscriptBox["d", "n"]], "+", 
         FractionBox[
          SqrtBox[
           RowBox[{"1", "+", 
            RowBox[{"4", " ", "s", " ", 
             SubscriptBox["d", "n"]}], "+", 
            RowBox[{"4", " ", 
             SubsuperscriptBox["d", "n", "2"], " ", 
             SubscriptBox["r", "n"]}]}]], 
          SubscriptBox["d", "n"]]}], ")"}]}]], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox["1", "2"], " ", "z", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           SubscriptBox["d", "n"]], "-", 
          FractionBox[
           SqrtBox[
            RowBox[{"1", "+", 
             RowBox[{"4", " ", "s", " ", 
              SubscriptBox["d", "n"]}], "+", 
             RowBox[{"4", " ", 
              SubsuperscriptBox["d", "n", "2"], " ", 
              SubscriptBox["r", "n"]}]}]], 
           SubscriptBox["d", "n"]]}], ")"}]}]], " ", 
      RowBox[{"C", "[", "1", "]"}]}], "-", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox["1", "2"], " ", "z", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           SubscriptBox["d", "n"]], "+", 
          FractionBox[
           SqrtBox[
            RowBox[{"1", "+", 
             RowBox[{"4", " ", "s", " ", 
              SubscriptBox["d", "n"]}], "+", 
             RowBox[{"4", " ", 
              SubsuperscriptBox["d", "n", "2"], " ", 
              SubscriptBox["r", "n"]}]}]], 
           SubscriptBox["d", "n"]]}], ")"}]}]], " ", 
      RowBox[{"C", "[", "1", "]"}]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.3992806657560563`*^9, 3.479966549640038*^9, 3.479966777747038*^9, 
   3.479967366485038*^9, 3.479968240639038*^9, {3.5135850287984986`*^9, 
   3.513585066705719*^9}, 3.5135851073473845`*^9, 3.5185302380631695`*^9, 
   3.5185309884213257`*^9, 3.518531036906632*^9, 3.518531773998909*^9, 
   3.5922044199747486`*^9, 3.592204858177327*^9, 3.5922051348446007`*^9, 
   3.6427610800709114`*^9},
 CellLabel->"Out[7]="]
}, Open  ]],

Cell[TextData[{
 "  The integration constant C[1] can be calculated using the BC: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["C", "b"], "(", "\[Infinity]", ")"}], " ", "=", "0"}], 
   TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{{3.5185302194221864`*^9, 3.5185302197659435`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"eq26b", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}], "\[Equal]", "0"}], ",", " ", 
    RowBox[{"C", "[", "1", "]"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.513585032236087*^9, 3.5135850333923664`*^9}, {
   3.518530442207714*^9, 3.5185304448327646`*^9}, 3.518530483036623*^9, {
   3.5185306441803417`*^9, 3.5185306600556464`*^9}},
 CellLabel->"In[8]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"C", "[", "1", "]"}], "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"eq26b", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], "\[Equal]", "0"}], ",", " ", 
       RowBox[{"C", "[", "1", "]"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.513585053736637*^9, 3.5135850540335197`*^9}, 
   3.5185306279612803`*^9, {3.518530672071502*^9, 3.518530673821536*^9}, 
   3.5185309821555805`*^9},
 CellLabel->"In[9]:="],

Cell[BoxData[
 FractionBox[
  SuperscriptBox["\[ExponentialE]", 
   FractionBox[
    RowBox[{"z", " ", 
     SqrtBox[
      RowBox[{"1", "+", 
       RowBox[{"4", " ", "s", " ", 
        SubscriptBox["d", "n"]}], "+", 
       RowBox[{"4", " ", 
        SubsuperscriptBox["d", "n", "2"], " ", 
        SubscriptBox["r", "n"]}]}]]}], 
    SubscriptBox["d", "n"]]], 
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   SuperscriptBox["\[ExponentialE]", 
    FractionBox[
     RowBox[{"z", " ", 
      SqrtBox[
       RowBox[{"1", "+", 
        RowBox[{"4", " ", "s", " ", 
         SubscriptBox["d", "n"]}], "+", 
        RowBox[{"4", " ", 
         SubsuperscriptBox["d", "n", "2"], " ", 
         SubscriptBox["r", "n"]}]}]]}], 
     SubscriptBox["d", "n"]]]}]]], "Output",
 CellChangeTimes->{
  3.3992806659593754`*^9, 3.479966549797038*^9, 3.479966777903038*^9, 
   3.4799673669060383`*^9, 3.479968240794038*^9, {3.5135850403925457`*^9, 
   3.513585066783846*^9}, 3.5135851074723873`*^9, 3.5185302383131742`*^9, {
   3.51853063653957*^9, 3.518530674555925*^9}, 3.5185308917163444`*^9, 
   3.5185309884994526`*^9, 3.518531037141011*^9, 3.518531101657875*^9, 
   3.5185316276992245`*^9, 3.518531774217663*^9, 3.5922044203157825`*^9, 
   3.59220485850236*^9, 3.5922051352034073`*^9, 3.6427610801646605`*^9},
 CellLabel->"Out[9]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"eq26b", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"C", "[", "1", "]"}], "\[Rule]", "0"}], "}"}]}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.5135851276291533`*^9, 3.513585128472925*^9}, {
  3.5185308810911407`*^9, 3.5185309111698427`*^9}, {3.5185319457053304`*^9, 
  3.5185319642369366`*^9}},
 CellLabel->"In[10]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"C", "[", "z", "]"}], "\[Rule]", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{"z", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SqrtBox[
          RowBox[{"1", "+", 
           RowBox[{"4", " ", 
            SubscriptBox["d", "n"], " ", 
            RowBox[{"(", 
             RowBox[{"s", "+", 
              RowBox[{
               SubscriptBox["d", "n"], " ", 
               SubscriptBox["r", "n"]}]}], ")"}]}]}]]}], ")"}]}], 
      RowBox[{"2", " ", 
       SubscriptBox["d", "n"]}]]]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.399280666287813*^9, 3.4799665499730377`*^9, 3.479966778082038*^9, 
   3.479967367121038*^9, 3.479968240967038*^9, {3.5135851210508604`*^9, 
   3.5135851325511546`*^9}, 3.5185307228381023`*^9, 3.518530821011862*^9, {
   3.518530886138112*^9, 3.518530906216623*^9}, 3.518531001296573*^9, 
   3.518531037437892*^9, 3.518531101704751*^9, 3.5185316278398523`*^9, 
   3.5185317743582907`*^9, 3.592204420568808*^9, 3.5922048587533846`*^9, 
   3.5922051354530125`*^9, 3.6427610804146633`*^9},
 CellLabel->"Out[10]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cout", "[", "s_", "]"}], "=", 
  RowBox[{
   RowBox[{"C", "[", "z", "]"}], "/.", 
   RowBox[{"%", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellLabel->"In[11]:="],

Cell[BoxData[
 SuperscriptBox["\[ExponentialE]", 
  FractionBox[
   RowBox[{"z", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SqrtBox[
       RowBox[{"1", "+", 
        RowBox[{"4", " ", 
         SubscriptBox["d", "n"], " ", 
         RowBox[{"(", 
          RowBox[{"s", "+", 
           RowBox[{
            SubscriptBox["d", "n"], " ", 
            SubscriptBox["r", "n"]}]}], ")"}]}]}]]}], ")"}]}], 
   RowBox[{"2", " ", 
    SubscriptBox["d", "n"]}]]]], "Output",
 CellChangeTimes->{
  3.3992806663190928`*^9, 3.479966550009038*^9, 3.479966778113038*^9, 
   3.479967367201038*^9, 3.4799682409980383`*^9, {3.518531010140493*^9, 
   3.518531037500393*^9}, {3.5185310954702563`*^9, 3.518531101767252*^9}, 
   3.5185316278867283`*^9, 3.5185317743739157`*^9, 3.592204420598811*^9, 
   3.5922048588003893`*^9, 3.5922051355154133`*^9, 3.6427610804146633`*^9},
 CellLabel->"Out[11]="]
}, Open  ]],

Cell[TextData[{
 "Now it can be evaluated ",
 Cell[BoxData[
  RowBox[{" ", 
   RowBox[{
    SubscriptBox["C", "out"], 
    RowBox[{"(", 
     RowBox[{"z", ",", "t"}], ")"}], " "}]}]]],
 " taken the inverse laplace transform "
}], "Text",
 CellChangeTimes->{{3.5185317048257055`*^9, 3.5185317140290074`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"cOut", "[", 
   RowBox[{"z_", ",", "t_"}], "]"}], "=", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"InverseLaplaceTransform", "[", 
     RowBox[{
      RowBox[{"Cout", "[", "s", "]"}], ",", "s", ",", "t"}], "]"}]}], "//", 
   "FullSimplify"}]}]], "Input",
 CellChangeTimes->{3.5185316019956064`*^9, 3.592204919700479*^9, 
  3.5922049757620845`*^9},
 CellLabel->"In[12]:="],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"t", "-", "z"}], ")"}], "2"], 
         RowBox[{"4", " ", "t", " ", 
          SubscriptBox["d", "n"]}]]}], "-", 
       RowBox[{"t", " ", 
        SubscriptBox["d", "n"], " ", 
        SubscriptBox["r", "n"]}]}]], " ", "z"}], 
    RowBox[{"2", " ", 
     SqrtBox["\[Pi]"], " ", 
     SqrtBox[
      FractionBox[
       SuperscriptBox["t", "3"], 
       SubsuperscriptBox["d", "n", "3"]]], " ", 
     SubsuperscriptBox["d", "n", "2"]}]], ",", 
   RowBox[{
    RowBox[{"z", " ", 
     SubscriptBox["d", "n"]}], "<", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.399280667194927*^9, 3.479966552087038*^9, 3.4799667790060377`*^9, 
   3.4799673680170383`*^9, 3.4799682414060383`*^9, 3.51358514194202*^9, 
   3.5185307235568657`*^9, {3.5185310839075346`*^9, 3.5185311022047606`*^9}, 
   3.518531628308612*^9, 3.5185317747489233`*^9, 3.592204421268878*^9, 
   3.59220485950546*^9, 3.5922049227547846`*^9, 3.59220497701221*^9, 
   3.5922051362174273`*^9, 3.642761080649052*^9},
 CellLabel->"Out[12]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"csol", "[", 
    RowBox[{"z_", ",", "t_"}], "]"}], "=", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"t", "-", "z"}], ")"}], "2"], 
         RowBox[{"4", " ", "t", " ", 
          SubscriptBox["d", "n"]}]]}], "-", 
       RowBox[{"t", " ", 
        SubscriptBox["d", "n"], " ", 
        SubscriptBox["r", "n"]}]}]], " ", "z"}], 
    RowBox[{"2", " ", 
     SqrtBox["\[Pi]"], " ", 
     SqrtBox[
      FractionBox[
       SuperscriptBox["t", "3"], 
       SubsuperscriptBox["d", "n", "3"]]], " ", 
     SubsuperscriptBox["d", "n", "2"]}]]}], ";"}]], "Input",
 CellChangeTimes->{{3.592205170584888*^9, 3.5922051739389524`*^9}},
 CellLabel->"In[13]:="],

Cell[TextData[{
 "This solution has a little difference with  eq.(49) Roberts-Rowland J. \
Pharmacokim.Biopharm 14: 227-260 (1986): ",
 Cell[BoxData[
  SubscriptBox["r", "n"]]],
 " was deleted (maybe an mistake in the printed transcription). This mistake \
has not consequences when ",
 Cell[BoxData[
  SubscriptBox["r", "n"]]],
 "=0. as happen in  Fig 3.(B) of Roberts-Rowland paper"
}], "Text",
 CellChangeTimes->{{3.65059742648358*^9, 3.6505974881686883`*^9}, 
   3.650597519464779*^9, {3.650597601634781*^9, 3.6505976054784317`*^9}}],

Cell[TextData[{
 "Here is shown this Fig 3.(B) obtain with our method ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["d", "n"], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0.01", ",", "0.1", ",", "0.2", ",", "1", ",", "2"}], "}"}]}], 
    ",", 
    RowBox[{
     SubscriptBox["r", "n"], "\[Rule]", "0"}]}]}]]],
 " in z =1"
}], "Text",
 CellChangeTimes->{{3.5922052747766924`*^9, 3.59220527655287*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"csol", "[", 
      RowBox[{"1", ",", "t"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["d", "n"], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0.01", ",", "0.1", ",", "0.2", ",", "1", ",", "2"}], 
         "}"}]}], ",", 
       RowBox[{
        SubscriptBox["r", "n"], "\[Rule]", "0"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0.01", ",", "4"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "4"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.5185312290196953`*^9, 3.51853163655877*^9, 3.5922050273882465`*^9, {
   3.592205206886786*^9, 3.5922052112704706`*^9}, {3.5922052658177967`*^9, 
   3.592205266940909*^9}},
 CellLabel->"In[14]:="],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJxEunc8V//7P/7cpEHKyCsjilBKJOGc62FUQkpGJSurkpQIIZEVkZGtVEJl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     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVl3c41t8bx+09UoiKKJVEpSIZz/tTUUjKTCEiu5ARFaEQX7KJqKSUjMiW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     "]]}, 
   {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVl3k01O8Xx5EtS4O0aJGlUqlvliTbvD/JUpJUiChLkRYhYhSVCEmiJEuW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     "]]}, 
   {RGBColor[0.922526, 0.385626, 0.209179], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVVHc81Y/7RZGVq5LwjahPU4mWZJx3WpIkFGXPRMkHfcje0hC6ZCRbEYWs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     "]]}, 
   {RGBColor[0.528488, 0.470624, 0.701351], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwVVnc41Y37Pk6ydWh4S2U3vC1SkdH9KYqECgnJTkYhlPMW4ptIQziSUUmh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{0., 3.9999999185714286`}, {0, 4}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.399280667460806*^9, 3.479966552325038*^9, 
  3.479966787929038*^9, 3.479967368595038*^9, 3.479968241580038*^9, 
  3.513585187365058*^9, 3.518530728150704*^9, 3.5185312300040894`*^9, 
  3.5185316372150326`*^9, 3.518531774967677*^9, 3.5922044215329046`*^9, 
  3.592204876588168*^9, 3.592205029869495*^9, 3.592205214484132*^9, 
  3.5922052676829834`*^9, 3.6427610807896676`*^9},
 CellLabel->"Out[14]="]
}, Open  ]],

Cell["Here is the 3-D representation as function of z and t", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"csol", "[", 
      RowBox[{"z", ",", "t"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["d", "n"], "\[Rule]", "0.01"}], ",", 
       RowBox[{
        SubscriptBox["r", "n"], "\[Rule]", "0"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0.1", ",", "4"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "4"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.5185312598796625`*^9, 3.5185316403869686`*^9, {3.592205301902405*^9, 
   3.592205303742589*^9}},
 CellLabel->"In[15]:="],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJxknXc819/7/19mSGQkKVG0y4hsXi+SUKmk0kKSFpWGiiYSUpmFJElSZFOR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   "], {{
     {RGBColor[0.880722, 0.611041, 0.142051], EdgeForm[None], Specularity[
       GrayLevel[1], 3], 
      StyleBox[GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxNnXn8DtX7/+975p61hdKqRZZokbRps6WkUEob7dJCi0okSaJF0SftaEFo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          "]], Polygon3DBox[CompressedData["
1:eJxFnAPU9cjShXPOe3KSnLFt27btO7Zt3LFt27Z9x7bnjnnHtvE/z+ys9a/1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          "]], Polygon3DBox[CompressedData["
1:eJwt1wm8z1Uax/F/un/XvbYR2aJkjCGlZImxtUwmhhRDylLZsoylIntqMpEl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          "]], Polygon3DBox[{{2499, 1271, 1136, 1135, 1760, 2475}}]}],
       Lighting->{{"Ambient", 
          RGBColor[0.30100577, 0.22414668499999998`, 0.090484535]}, {
         "Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 0, 2}]}}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0ktIVFEcB+C/j8zMLJB2pjWISJJGiEQo6TIMojZG7WohijTVqlYSEZMb
LYhCEEEhiZB0TLMy2yjRuoevzMfGVSAuXOd3EebMd36/e+ece+feU7fS1+7k
RMSg8SwvIpmXMWWyWxBxTP4mV8nTuREVcjvr5HuHIvodq9WldRd1TeYtusbC
iDb5u/6yroeXdGndTfnswYhONrPFeGh+lU95na94myO8zyk+4jy7rDNqnXH7
/JR7OZvk/Ihfcpa/OcEFvuciJ7nEKS7zA6eNFfOP/MNPXOVn/uUM1/iF65zl
RrLWgYh39szae1Pu41d5wDX+SK6Jc+zmJO/yNTtd+1vn7fg/Xsr/5az5G902
M8l964blf/IVv3ugGzJ/odtik65D91gu8QzWdDfkDLt0Kcdb5eNsZCnPsJjl
PGH9Suc9d81H5Sccly+4txL5PI+wgcWs52GeY1Hy7GjbqKWlooanDctHNb02
UUV/UVTSJ1K+bBMnmZs8AwfHcvbfuT0BD013
       "]]}, 
     {GrayLevel[0.2], 
      Line3DBox[{1781, 2075, 2433, 2769, 1949, 1780, 2586, 1950, 1782, 2587, 
       1951, 1783, 2588, 1952, 1784, 2589, 1953, 1785, 2590, 1954, 1786, 2591,
        2490, 2652, 1787, 2592, 1955, 1788, 2593, 1956, 1789, 2594, 1957, 
       1790, 2595, 1958, 1791, 2596, 1959, 1792, 2597, 1960, 1793, 2712, 2076,
        1961, 2077}], 
      Line3DBox[{695, 492, 797, 757, 2746, 2332, 798, 2078, 916, 2415, 968, 
       2079, 2763, 919, 2416, 2080, 2081, 1962, 1794, 2583, 2598, 2455, 1963, 
       1795, 2599, 1964, 1796, 2600, 2491, 2653, 1797, 2492, 2654, 1798, 2601,
        1965, 1799, 2602, 1966, 1800, 2603, 1967, 1801, 2604, 1968, 1802, 
       2605, 1969, 1803, 2606, 1970, 1804}], Line3DBox[CompressedData["
1:eJwNzLkyg2EUBuDza2yDhJl0doklRGiQ5Coy4wZcAGMpkYjG0pvhEgyVrTBy
BQq9pY4l9+ApnnnPec///eMbW9XNJCLWGeqMeGK5J2JQPrJkTssHiuaUvOe4
O2LRnmHAfsebua6v0W+/sjfNxS7f0qe71L3oCvYFdsyvuj25y7wuT8X8rB+R
Y4wyp2/7x63+3DzLEXW++HO7cTszT1Oj7N2hnOHX/VOekuWAD/a59i4nf3zz
Lk+YouR9gzWG+XZflTkm3Hu9u2DFnjCpa/mmw7zNP463J40=
       "]], 
      Line3DBox[{319, 814, 233, 811, 1401, 318, 812, 234, 815, 320, 816, 235, 
       1646, 817, 322, 625, 236, 447, 1465, 237, 821, 325, 628, 238, 630, 327,
        1404, 822, 239, 971, 1406, 329, 631, 240, 632, 1407, 330, 972, 241, 
       1650, 827, 332, 975, 242, 1466, 448, 1467, 335, 931, 1707, 337, 934, 
       1708, 339, 1812, 2773, 1012, 1813}], Line3DBox[CompressedData["
1:eJwV0DdOnFEYheE7BBFkt2Swh4bQkYNIJmcEGwCxAKZkA6SCnMMeoKOjAdZA
iyVDC2bImYfi1XvOd/47xUTHYyMTkRDCJApTQthNCyE5NYRtTuIdPksPIWob
lkeQ6F6PBFxiyx7w2zdb+gUiqEPAoe0fb+KXbzZ4zu98yrXygT2uD2FdL3Bf
41n9BmP2Gv3DfVBflfPlFR7Q9+3verX+xqVuefzT/QivcpXthfttzciV92y9
ch+e9Sg/8Qz34NSeoy97+xePciU/8DkvIdF3i9zN9+4V8h2feNvltqBn6/Pc
qd/KTRznEs7iRn7FqDcx35VjWu9Apr2N27//C7nM9p+n9D/IkH94d4wW/Vov
4itu5WI0ePMFRx48sg==
       "]], Line3DBox[CompressedData["
1:eJwVzskug2EUBuDPVK0pcQkSa615vgEzK0sptTGPiavAGmFr1prHshOJq7BF
YtpZeCyevOd7z/mbViSnBiZzQgjTJApDWIuFsM4+L5EQ4rqOaAgzjBSF8Kuv
1i3LFWb1KX2BeYF8auy39a/s0MkeEbtdWWu/L9/Y8G0OXeZDCt0cyDo3R/Kd
NN0cE7XPyHr7tO9OzIO6U9nDOTHvM7ll3+Au7p2g6v+/k9WX0WiX9B6mknLd
M0vmEZrsU3KMUeb85qj9pyz2/pDNbsbNq0zwZD+v/6bE+0u2uLmQP2za59Jr
vmLRzaVsdZOnf2RId63r45ZS7xvZ5iZjf2fO0s8D97Tb/QFCljoP
       "]], Line3DBox[CompressedData["
1:eJwVz7kyg2EUxvGjii99SNK5BcRSGeMONJaxJdSU1JbbMCONQkZhGLHH0lBQ
WEbhRmzh9xb/Of/nPOebd76e2sr4ckdETGA0F9GXj2iaI+jnJ+YYDrOIinzK
m3wbA/KZvM8LfBDncl1uY0i+kHt5ixc7Ixr8ANf4sJu0K2FH3sW73aVvpuzu
8YBV/KVed6Wblh/xhDXs2a8nT+/oZ/gzvvGCYf2cuYGu9LabWf6KHxzrMyzw
TXS7uXEzz/P2R/jlb6hhC0U3t26qvK7/NNv4wlL6J30Zd24W5X8KBTSp
       "]], Line3DBox[CompressedData["
1:eJwVzrlKQ2EQBtAR1ESbaBILSwufwKUUEbe4QtxqtUiqWKngO9iIliLi0ipE
wYDgvoALLrWvoTaCJ8VhZr6Z/3LbFpbypZqIWGQyEZFtiFilhZVkREnd4LMx
IsOEm03zAVu0U+TcLs24fZe5mw5Ssis69WN2776Z0X+ocyTtdinI3syjbl7U
tLkiTzBrfuaXJ0bcPKrNbs7s65kxP/DDPTk3dfITmtzdyaa55Zsbht3U2pdJ
ubmWTTGvX6/+Y/UtQ+7y8mUOzX92g7I9dZ81XuVZBuRH5mN22KZfVlG/7Fs5
1ZfpkxfNl/oefUF/oe/V/wPAhDNm
       "]], 
      Line3DBox[{1873, 2498, 2665, 1872, 2618, 1989, 1874, 2619, 1990, 1875, 
       2620, 1991, 1876, 2621, 1992, 1877, 2622, 1993, 1878, 2779, 2475, 2499,
        2778, 2487, 2464, 2500, 2775, 2481, 2139, 2623, 1994, 2451, 2472, 
       2473, 2428, 2772, 2454, 1995, 2170, 2553, 2624, 2486, 1996, 2149, 2554,
        2625, 2430, 2446, 1997, 2150, 2723, 2263, 2264, 2169, 2182, 1998, 
       2151, 2724, 2265, 2304, 2266, 2153, 2183, 2331, 1999, 2303}], 
      Line3DBox[{1880, 2501, 2666, 1879, 2502, 2667, 1881, 2626, 2000, 1882, 
       2627, 2001, 1883, 2628, 2002, 1884, 2629, 2003, 1885, 2630, 2503, 2668,
        1886, 2504, 2669, 1887, 2505, 2670, 1888, 2427, 2631, 2004, 2474, 
       2584, 2632, 2005, 1889, 2767, 2429, 2006, 2470, 2777, 2152, 2007, 2171,
        2729, 2074, 2008, 2154}], 
      Line3DBox[{1891, 2506, 2671, 1890, 2507, 2672, 1892, 2508, 2673, 1893, 
       2633, 2009, 1894, 2634, 2010, 1895, 2635, 2011, 1896, 2636, 2509, 2674,
        1897, 2510, 2675, 1898, 2511, 2676, 1899, 2512, 2677, 1900, 2637, 
       2012, 1901, 2638, 2013, 1902, 2639, 2014, 1903, 2640, 2015, 1904}], 
      Line3DBox[{1906, 2513, 2678, 1905, 2514, 2679, 1907, 2515, 2680, 1908, 
       2516, 2681, 1909, 2641, 2016, 1910, 2642, 2017, 1911, 2643, 2517, 2682,
        1912, 2518, 2683, 1913, 2519, 2684, 1914, 2520, 2685, 1915, 2521, 
       2686, 1916, 2644, 2018, 1917, 2645, 2019, 1918, 2646, 2020, 1919}], 
      Line3DBox[{1921, 2522, 2687, 1920, 2523, 2688, 1922, 2524, 2689, 1923, 
       2525, 2690, 1924, 2526, 2691, 1925, 2647, 2021, 1926, 2648, 2527, 2692,
        1927, 2528, 2693, 1928, 2529, 2694, 1929, 2530, 2695, 1930, 2531, 
       2696, 1931, 2532, 2697, 1932, 2649, 2022, 1933, 2650, 2023, 1934}], 
      Line3DBox[{1948, 2158, 2157, 2725, 1947, 2709, 2544, 1946, 2708, 2543, 
       1945, 2707, 2542, 1944, 2706, 2541, 1943, 2705, 2540, 1942, 2704, 2539,
        1941, 2703, 2538, 2651, 1940, 2702, 2537, 1939, 2701, 2536, 1938, 
       2700, 2535, 1937, 2699, 2534, 1936, 2698, 2533, 1935, 1457, 2155, 
       2156}], Line3DBox[CompressedData["
1:eJwV0LcyhFEYBuCjwS5WppbD4gaMnDsjjjyoKFC4CeEC5JxKV6DDuAwKsWBG
LD1bPPOe873f2Zl/i2YW+xaSQgjL9KSGsEEy9aSwyU40hJKUELacByIhpMoG
IjyxTal+Rz4TpZFp7z7tvzjvUmZnT76SRhPpvLFPuT5uf5Avrrwvlhm6IVlD
hZ1huULMvJlMDqjU3Xkzp2txn5et8p4L8yr9oXMWD2SzaudI7umr9cfOI2Y5
so0Z82/3UU4S3yZP5Tu5tDNr58f8w/mMuN8Zc1/jl9vE/yfzdBNyPPEtdnrl
JH9c2+nQ51PrXqu/Met37jRbootH6nSXunPnKX2B7KaQdfcLGZP//Vc2Uw==

       "]]}, 
     {GrayLevel[0.2], 
      Line3DBox[{1056, 1215, 2586, 1057, 1391, 1697, 916, 917, 496, 970, 2434,
        803, 947, 774, 815, 458, 1104, 835, 2372, 836, 466, 713, 548, 2279, 
       650, 472, 1112, 2660, 1425, 1734, 1257, 1116, 2664, 1261, 2612, 1121, 
       1266, 2618, 1130, 2667, 1275, 1141, 2672, 1286, 1156, 2679, 1301, 1171,
        2688, 1316, 1186, 2698, 1331, 1201}], 
      Line3DBox[{1058, 1216, 2587, 1059, 1392, 1698, 1699, 2763, 1700, 1701, 
       1503, 1345, 1578, 1476, 2730, 1477, 1702, 1599, 1349, 1646, 1478, 1479,
        1706, 1647, 2655, 1402, 1617, 1618, 1619, 1709, 1531, 2657, 1362, 
       1585, 1487, 1488, 1710, 1606, 2661, 1748, 1426, 1470, 1776, 1777, 1117,
        2781, 1779, 1770, 1778, 1262, 2613, 1122, 1267, 2619, 1131, 1276, 
       2626, 1142, 2673, 1287, 1157, 2680, 1302, 1172, 2689, 1317, 1187, 2699,
        1332, 1202}], 
      Line3DBox[{1060, 1217, 2588, 1061, 299, 2081, 300, 230, 2088, 308, 236, 
       627, 324, 820, 2366, 245, 348, 2111, 259, 373, 2123, 268, 1019, 2463, 
       1018, 2614, 1123, 1268, 2620, 1132, 1277, 2627, 1143, 1288, 2633, 1158,
        2681, 1303, 1173, 2690, 1318, 1188, 2700, 1333, 1203}], 
      Line3DBox[{1062, 1218, 2589, 1063, 1739, 1740, 2598, 1741, 1742, 1346, 
       1394, 2732, 1347, 1579, 1504, 1396, 1507, 1350, 1465, 1351, 1508, 1403,
        1515, 1354, 2755, 1653, 1355, 1652, 1620, 1633, 2750, 1363, 1665, 
       1364, 1532, 1427, 2717, 1541, 1371, 1731, 1372, 1730, 1716, 2766, 1714,
        1765, 1715, 2615, 1124, 1269, 2621, 1133, 1278, 2628, 1144, 1289, 
       2634, 1159, 1304, 2641, 1174, 2691, 1319, 1189, 2701, 1334, 1204}], 
      Line3DBox[{1064, 1219, 2590, 1065, 1229, 2599, 1085, 1348, 1395, 2733, 
       503, 622, 514, 628, 516, 1405, 529, 2271, 638, 531, 1419, 866, 2441, 
       987, 557, 657, 2286, 573, 665, 575, 1463, 2726, 1436, 1750, 1437, 2616,
        1125, 1270, 2622, 1134, 1279, 2629, 1145, 1290, 2635, 1160, 1305, 
       2642, 1175, 1320, 2647, 1190, 2702, 1335, 1205}], 
      Line3DBox[{1066, 1220, 2591, 1068, 1230, 2600, 1086, 1397, 1615, 1642, 
       2747, 1641, 1643, 1509, 1510, 1404, 1627, 1626, 1616, 1654, 2756, 1655,
        1418, 1517, 1516, 1733, 1690, 2761, 1691, 1468, 1667, 1666, 1668, 
       1542, 2737, 1543, 1435, 1547, 1546, 1732, 2770, 1681, 1682, 1638, 2752,
        1376, 1761, 1759, 2779, 1760, 1135, 1280, 2630, 1146, 1291, 2636, 
       1161, 1306, 2643, 1176, 1321, 2648, 1191, 1336, 2651, 1206}], 
      Line3DBox[{1070, 1222, 2592, 1071, 2654, 1232, 1088, 1399, 2713, 1241, 
       1097, 1513, 1514, 1407, 1480, 1249, 1106, 1630, 1631, 2749, 1621, 1622,
        1252, 1109, 1533, 2718, 1534, 1428, 1669, 1255, 1114, 2751, 1634, 
       1635, 1439, 1492, 1259, 1119, 2740, 1557, 1558, 1445, 1753, 1264, 2776,
        1127, 1767, 1768, 1766, 2775, 1272, 1137, 2669, 1282, 1148, 2675, 
       1293, 1163, 2683, 1308, 1178, 2693, 1323, 1193, 2704, 1338, 1208}], 
      Line3DBox[{1072, 1223, 2593, 1073, 1233, 2601, 1089, 1400, 2714, 1242, 
       1098, 1649, 1352, 1650, 1481, 1482, 1601, 1518, 1356, 2734, 1658, 1603,
        1604, 1605, 1535, 2658, 1365, 1672, 1670, 1671, 1713, 2765, 1683, 
       1373, 1684, 1493, 1494, 1609, 2744, 1559, 1377, 1591, 1497, 1498, 2727,
        1128, 1446, 1736, 1273, 2623, 1138, 2670, 1283, 1149, 2676, 1294, 
       1164, 2684, 1309, 1179, 2694, 1324, 1194, 2705, 1339, 1209}], 
      Line3DBox[{1074, 1224, 2594, 1075, 1234, 2602, 1090, 1721, 1243, 2768, 
       1099, 1722, 1353, 1466, 1483, 1580, 1484, 1602, 1519, 2656, 1357, 1728,
        1659, 1660, 1110, 1536, 2659, 1366, 1586, 1489, 1490, 1608, 1587, 
       2662, 1429, 1471, 1495, 1496, 1610, 2745, 1560, 1378, 1592, 1499, 2731,
        1500, 1711, 1612, 1749, 1447, 1473, 1737, 2772, 1738, 1139, 1758, 
       1717, 1756, 1284, 2631, 1150, 2677, 1295, 1165, 2685, 1310, 1180, 2695,
        1325, 1195, 2706, 1340, 1210}], 
      Line3DBox[{1076, 1225, 2595, 1077, 1235, 2603, 1091, 1723, 1724, 2607, 
       1725, 1726, 1408, 1467, 1409, 1651, 1410, 1520, 2735, 1358, 1661, 1359,
        1632, 1623, 1673, 2759, 1367, 1729, 1368, 1597, 1537, 1462, 1693, 
       2762, 1694, 1430, 1472, 1431, 1685, 1441, 2721, 1561, 1379, 1593, 1380,
        2617, 1562, 1448, 1566, 1383, 1474, 1384, 2624, 1771, 1772, 1754, 
       1757, 1755, 2632, 1151, 1296, 2637, 1166, 2686, 1311, 1181, 2696, 1326,
        1196, 2707, 1341, 1211}], 
      Line3DBox[{1078, 1226, 2596, 1079, 1236, 2604, 1092, 1244, 2608, 1100, 
       1411, 1707, 1412, 1727, 1413, 1521, 1360, 2742, 1583, 1361, 1522, 1422,
        1662, 2757, 1369, 1674, 1370, 1675, 1538, 1432, 2719, 1548, 1588, 
       1374, 1440, 1375, 1639, 2753, 1640, 1381, 1687, 1382, 1563, 2743, 1450,
        1567, 1385, 1452, 1386, 2625, 1720, 1718, 2767, 1719, 1152, 1297, 
       2638, 1167, 1312, 2644, 1182, 2697, 1327, 1197, 2708, 1342, 1212}], 
      Line3DBox[{1080, 1227, 2597, 1081, 1237, 2605, 1093, 1245, 2609, 1101, 
       1414, 1708, 1415, 1416, 1523, 1524, 2711, 1421, 1526, 1525, 1692, 1663,
        2758, 1664, 1624, 1679, 1678, 1680, 2760, 1549, 1550, 1442, 1637, 
       1636, 1625, 2748, 1688, 1689, 1449, 1565, 1564, 2741, 1594, 1568, 1569,
        1453, 1571, 2723, 1570, 1464, 1455, 1751, 2777, 1456, 1153, 1298, 
       2639, 1168, 1313, 2645, 1183, 1328, 2649, 1198, 2709, 1343, 1213}], 
      Line3DBox[{1082, 1389, 2712, 1390, 1083, 1238, 2606, 1094, 1246, 2610, 
       1102, 1743, 2773, 1744, 1745, 1746, 2774, 1747, 1423, 1528, 1527, 1584,
        1539, 2736, 1540, 1433, 1677, 1676, 1434, 1551, 2738, 1611, 1552, 
       1443, 1554, 1686, 1553, 1735, 2771, 1695, 1696, 1451, 1590, 2722, 1589,
        1595, 1572, 1573, 1454, 1575, 2724, 1574, 1596, 1576, 1577, 1475, 
       2729, 1387, 1154, 1299, 2640, 1169, 1314, 2646, 1184, 1329, 2650, 1199,
        1458, 2725, 1459, 1460}], 
      Line3DBox[{1200, 1330, 1457, 1185, 1315, 2687, 1170, 1300, 2678, 1155, 
       1285, 2671, 1140, 1274, 2666, 1129, 1265, 2665, 1120, 2611, 1260, 2663,
        1115, 1256, 1762, 1764, 1763, 1111, 1253, 1752, 1424, 1530, 2716, 
       1529, 1107, 1250, 1485, 1417, 2754, 1629, 1628, 1103, 1247, 1645, 1644,
        1401, 1506, 1705, 1505, 1095, 1239, 1598, 2710, 1393, 1502, 1501, 
       1084, 1228, 2746, 1614, 1613, 1344, 1055, 2769, 1214, 1388, 1461}], 
      Line3DBox[{1207, 1337, 2703, 1192, 1322, 2692, 1177, 1307, 2682, 1162, 
       1292, 2674, 1147, 1281, 2668, 1136, 1271, 2778, 1773, 1775, 1774, 1126,
        1263, 2780, 1769, 1444, 1556, 1555, 2739, 1118, 1258, 1491, 1438, 
       1545, 2720, 1544, 1113, 1254, 1607, 1469, 1582, 2728, 1581, 1108, 1251,
        1486, 1420, 1657, 2715, 1656, 1105, 1248, 1712, 1648, 1406, 1512, 
       1600, 1511, 1096, 1240, 2764, 1704, 1703, 1398, 1087, 1231, 2653, 1069,
        1221, 2652, 1067}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJyUu3c01v//x2+UKKQoJJuMSGVkP1RoqRASLbuFSFKylcqKSEZZqYzslfW0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    "]],
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGridsStyle->Automatic,
  Method->{"DefaultBoundaryStyle" -> Directive[
      GrayLevel[0.3]], "RotationControl" -> "Globe"},
  PlotRange->{{1, 2}, {0.1, 4}, {0, 4}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], Automatic},
  Ticks->{Automatic, Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.3992806679925623`*^9, 3.4799665569790382`*^9, 
  3.479966789114038*^9, 3.479967370903038*^9, 3.4799682417370377`*^9, 
  3.5185312610203094`*^9, 3.518531640996355*^9, 3.518531775186432*^9, 
  3.5922044216269135`*^9, 3.592205304882703*^9, 3.6427610810553474`*^9},
 CellLabel->"Out[15]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"csol", "[", 
      RowBox[{"z", ",", "t"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["d", "n"], "\[Rule]", "0.1"}], ",", 
       RowBox[{
        SubscriptBox["r", "n"], "\[Rule]", "0"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0.1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0.1", ",", "4"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "4"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.51853127116113*^9, 3.51853164384016*^9, {3.5922053125934734`*^9, 
   3.5922053150867233`*^9}},
 CellLabel->"In[16]:="],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJyUvXc41+/7/2+U0ZCKFg2lIZoaKjyeSoPKSpmpJDTQ0LCSEaXIbpAQEiEj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   "], {{
     {RGBColor[0.880722, 0.611041, 0.142051], EdgeForm[None], Specularity[
       GrayLevel[1], 3], 
      StyleBox[GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJw1nAf4ltMbx9/3eZ9x7F2yIyE7JCsjGkZWEmWTPUKySYVklCQZUVkpIZJN
yIgIIXtFRoi/PfL/fvreXdfvXPf3Pb/zrPOcc+/7aX7kqfudktVqtUfLWq0h
OjOv1Zap12qXia6kjhXVvtPvYzRoW9HVNeadolbbWHSwjhkrXNf/mojeoWP+
p/4TRLdX33ZqW+uYpvrfL+o/Uf2n6PdPwqupjRDeSe1X4akae61wG7W7NH6E
fl8s2kF0N7XO6r9NrZPaXxr/svpGCu+s9pXwMLUz1PbWNZ7V/x/WfW8uPEb4
BuEthG8XvlG4k/DjwvcJdxR+THii8E7Ck4TvEt5Z+EHhu4VbCF/H8wqvIzxM
+ArhbYUnCI8Wbit8j/CtwhsK3yx8rXBr4bHCI4W3ER4vfJvwKN13R7U/9Xtd
9Q8XvVL9GwjfKDxEuJXwTcJDhTcSvkV4mHBXzctuOvZu9a0v3Fb4FuHP1XZh
/kQ/E11fbT21twu/t8v1vjbXHL2vvg3p17gNRG8QfVKtqfBVor/pGkdo/CGi
q+rYf4VPV/8lOnYL4ffU953+t5/wfqLv6ry7C89V//ca019tgX7/oWO20Dlv
FD280nwKbyw6UOOu0pg+og9WPs+PwrnwHsJfC6+tY64VHqTzd9PYA9R66fgp
ooNFN1G7WuPWEh2msW3Uf7LwZmof6PdWojeJrqIx/+g8vYWfEz5V/c8I363x
rdTWZL5El1ZbQ7il6EDR1dQeUWum1kRtVuE1e5me9S3hVYUvFX5c46/S/zdV
21P964hep/O3UH8/4RXUVlT/Nxp/hPr3Vf+6akeq/0H9rkQvEF1C7VzmWc/7
i/7fU/1Lqe2jY48V3Vf0M/VfV/fvKXWfQ4fVFte8rSB6ke5nH3XMEp7W8PGc
52z9fkT9hwiXGtun7rlcSrhr5rVyjNq6vAvRObrWh+o/WPg4HfuR8FC1Lmo3
a8xl6l9T9Bed8yjhLXStT5lXtaO5Jx1/hOjuopXGPV/zdf9S3+Fqh6lNz7xW
19P/vmeNxF4eWpn+pmdZSsffIPwpe1dtI40dK/pAFXxDY04V3lH4l9I8Bty8
Zp6xQ9186nEd86noY6JHaPya+t/+ou9CNeZA/W+O8D7Ce6t9q3FdRJfT9VdS
fzueV2PuVf82ok+rf73Kx34pfL5oV7Xu+t/9GrOdaDP1LyN8ofBZmp+lhS8Q
7iO8kvAA4fOFlxW+SLiv8PLC/YTPEW4iPFD4AuGmwpcKXyi8hvDVwgN5v8Ln
C58pvKTwecJnCDcXHsp+F16BfSt8rvAqwlcI92NfCw8WvkR4deGrhAcIryZ8
pXB/4f/p2ceqXaO2ovr7q/889XcQfpl5Za3que9TO4B3WHkevtKzT6h7Pjvz
Tgrj+3RcZ51r37r3+e9184TuaourHcTaVn+ryvhXHTcv97kfyr1O4PktNeZX
0QfUuqntqv+9iAzT/Xyfu2+y6KE6z4HCDdE9dd09Ml/rt7gm//si8zvfFhmk
YzLhs0RfEb2DPa22is47UOO6wt9FS56X91F4Hd7J9bX+ThJ9KwkXlkU92LNq
u2rsnbqHtTKvPeTrGeofJHya6EbwPvWdo+NfEF5O15vGcWq91f+c+t/X2Imx
zl5Tu7fu9beGxhSi5+Xeu/CTbrre2hp/EWtY7Q21R4NfTFbrH3xpWt38BJm7
De84M998Oresvw05llteHy/6c+n996qeceXCesGSol+qfxWNOVrPeL/OcXnd
fLmbxk5X/5N6nquFvxQ+nH2sMf/WzSvn6X9Hqf9Q0fFZ8Bb+V5gHD9H4pPO+
yX7RddYrzKev5V3pmIZwF9ai+q/Q8aeLfqv+Q9V3kOhL+n0u/Fb0DdGb1HZn
HYn+V/O7mc47ZE3C9wvLrjN1/tax3n7T7xcy86KFOPjV7zWfm3NxnldFb2QO
a5bv1wtvIzoaHiF8TOH/j4wxGedU27RmfQeMrIKOiP7mybIGmfNs7rU6UfSk
wvL4RNaYnnMvjdlb9H39bsf9a86+0e9DhLuLfq3WU/hA0Xkas7fwKjr3w4X3
4wOsec3vaaKPqP8s+KfGzA5djPvivGVmfWBHeKzGvgRf1TnfVv9dsV+G6dq3
8A5Ff9Q522rMscL3qS2psRNFt1C7WWPWFn1BYzarmYdPK/3cuyE3hDcRflf3
MF/HnSh8lOhPaiex3kR/VjtZ+Bj4ldopwr3gS2qncl3RX9VOEz5O9GFkra47
UHSTwjJuivDv+t/p6K6if6n1ET5Z9E+1M4VPEl1O44Yg91l3pXnV6pqrywvL
2kv1/z/0vzPUf6Lo32pnCZ8iemlhHtc/N5+HP1+m/sWFByG7hb+NtcGaaqbf
K3N9lHPR/zKvoS9zr9/xonNzr9kJot/pf8fV/S77aO6O1fU+0L29Uph/vSz6
lu75fI19OlkfmKZTn6q+19V2Fv5YYxohg87WMa+pvy+8XuPn6Hd79e8punVl
/r6+6AWV+z/Vsf/T+O3rtgua6biR6r9a49uwpoTHCz+Cnp9Zf/tev49W/2Gi
P6gdA3/gPRbmYRfr3C117F3CN6n/KZ6TNYBurnO0zqzHThJ9uG5ddgX0OmS4
xj1XWr+YJ7p16IfNuW8dP079t/Cuc+tCT4iumazjoeu9l1unGym6dLL+jB69
tX4/KjxBx66HHil8c8jc0cLXM0/wcXQu4V1inqcIb4eejY4gvKXww8LjhLcS
niJ8j/Bm6DfCdwi3E35G+EHhHYWnCj8kvL3wU8IPCK8pfKvwdcJrCd8mPFx4
E+H70JeENxaeKDyGNSV8g/BVwjuwFoQnCW8qfL/w7cJjcj9vO/S6zPomNsax
mW2w7ZA9mXU95vNrtS15n5rn1pX5f3PRQzRmCHtcbTPh5vFummo+W4jO0fgt
4h0ur+vdl1luLCb8Ye4xezPnai2R0bqfz+se/zV8IvM7Xw5erzGb6PfmonP1
vzXUN0j0oMryprvoaVwrdP65wdvh8c+rPRv4Y+QT96DzHAjfq9um2B+bV3Qn
eIj6J8canqN2Zd2Y9ciY5rr2V3G+73QPT6r/auHN1b6s2+4FX1O3fbSyxrfN
vEaZx+tZc+rbgXUSa5t7ulf38Aw2APaEft8U8z60brndDP0SOz2zTP8RWZxZ
t/iiYZ6/r+ieOv/r6DvIDeGZws8KdxF+g30j3EP4E+GZwueV7l9G720P9b8m
/Iz6dxeeIfy0cGf0AuGn4Fm63qF12xs9Q/d+Q/0HC38s/Lrwo7qvM9mT6Hrq
/0j9r2FTCr8j/KLwvsJvI2+Fuwt/KDxD+LHMx7M/WTMTM9tXrK9lY+8foPP+
Lbyj6J3qv0R4JfiDfk/TuZ7Ts2wnvLr6PsPW0Jgl1b6C77AemTPh5ZNtmcU0
djnOrzZX/d0qr42dRHepvMa/KL0G/xNur76VKu+RJUXbVr63jzTmN/Rw4XdE
79H4cWpf17ymHlK7snI/61SXr+1R+Nrril5aWd+bqfO8V1oH3pDnULuUdSW6
SWV9bzPRD0rr2Njfb5fm2/Dv2aX19g2EV62sE64munxlG/lgnreyv6adrv2D
xrfSvZxVd/+Gwn2Fn9ENXqjnWFK0WWWdc7DoE/r9lt7V4zx3Zd7L+p5fWp/k
2CfRlXOfc63gG/CPl0vrBugI2KLotS0q2xVdQ+5gGxwU9/9byHHmgfvE5zS8
btsMHbllZdvkPfS/yrbbePW3ifcyS3gb0eml9ZZh8e7OFN5BdI2webF9V1Q7
A15UmQdtGPueNbBA+KjK6+pj4e2xP/R8H6AbNmxvr1uz/Y1fDf/aOvr9E+88
83sdqTGLsTZ07rkNy8EDkP+ldftZpe1NbKKktqC0PfKm6AV12z4cv7GOuRC+
JPphaR55QWm7fkhmHSirTAfkfme8u1Uq2/lLsB/0+4rKeE/Wj34PqnsdF5X/
/35pm/1F5LroW3XbHPqr/U/nXQU+h22SmdfjL4Bvs6dWZI0W3pdX5J5bxn+i
c04Wbq1zXCm8jsa/V7fNMrvuvQx+vG4fzcrwbY1bkb0rOqBuv41OvdCXs6pa
iR6m86yf2X74sG4/Etd7I/d+vxyeV7c/B77wqQ5aScf1K62X3Rg2wwEa9x52
g+a2q/Bs4ZcbXnPsEdYgcuT6un2h+CSuD7kwL/g/62BqyAD4P8diY7XSnvgk
9///zr03kY1dg1dxb/Nqto0GxnOtGhj7Cj7APDAfb+XmCdhcrOGm6KWiz9Ut
j76HX2e+H3yw2ILzRZeuLEf4vUHNNiNzPgc5m9mPc6La87n7OmiimyTbqvgA
mXv2CH6zN+vmLXNCpuPj7ZVbPoGxG7E9kWE/1myTDov7wI+H/vA+8qHu98o7
3SLm7Yea+e6QwBvHeZCDLeM8nP+wsD2xQeEzzPfnpf2frOdZot+o7cXa1gXe
yWwP8ntWZpsGG2Z4Zf/zPzr2R9GxartybbXRau3Vzq17fEf2tejtdevo89XG
1K27f5TbLhwl+m3dtiK/X66b/3DOXpn1rJ9K25U3x/ln1G1n4Z/atvCY0bnl
2ul1+wBvrdu3DI/+q7SveGW9n6dizaNDX1t4DcwOPZd1xVo/Ovf6Gqr/P123
bsN6OjJ0b3TwOXEe+pcNnoDMfaJuuYYvcmfd805qHfT769z0QF5e5vtZH/24
8n3+Xdonc7zawervnlmHOKFuewa7Bn/RtsF72ePIDdZI28L+4T6xntGPnla7
qrLvDln8c81roWWsq74x38ii6TH+j5rXTotYh6dUPu4W0SaZ9S9iGx0q02bJ
e+e6zLocvgH0PfwDF+medsD2F/2j9LlXruwzQF/Db3B65bFDRF9S39nxfu+o
vBfvj33Kc3H+ZcVf/gn+0xndRrRHZV9BFvb5yuh6YZ+zP9aOfbFVZl2I+Wmf
2S/K8WdUjqVcJzpA/Ytl9n3MCF7XPtYv767OXlbfpdijsZZZp+B/c6/7V7FN
K/tkZpTeO29l9qmtjm9RbQm1/TXuXR36UsP6Mn7b5qFbILvhn9My6x7YY8sm
6yToJl/GnMAfj858DDwXGQKPasT75Vj0lP3D7msaOjkYfYQ1eGqsQ/QUeEIb
0Xszy330MXyMyNSDaqa9A7PGT4p1vgy6H3265/PUd5pap1hvbYL/9I7zIJdX
zyyXP4e/YRuzppDR2NXCHUVfyT3f/+BzC54CP/kj8/zgD5qRe16nBg/pG/t9
y8prqQnrtO574n5OiTHoXsg7YhOH5NbZllXfm4Vla7+YQ/y66Bn4tF8PjL6B
DxP9GN0YXoY/bTfeZen1zLqer75b0Ilq1i3QMfC7tNP/etQdA1q6MM+ck5uH
YVcujOvF2mJe0G8X6SmsScaz/rHV/tRxjyfr18QdsEPhZ8/FfukTmDU/NLfs
fDf3sdhz2GXEpzj299z7ZWrsGfyEY2Jtw8vxA7cNnsZ+4D1Nj33N/oaHjYr5
nx57hvcH3+PYPthYovfHfKLfwgO2Yu8Hb8cfiL+Q8xATJJaHffdZ7n02Nu5n
mcL4q9z6AfuAuegUc0iMZMfMMmDheqj7PFzv1NxzPC7O/WL0Ey8kFvNy7nui
r0nYEaxx4kvoWOhaTWLtPxbr/9fctsaVoh0L9xNDPCl4+Fs12x/4+uHt6A3o
D8SAsAd4b/gN4LFbBp+lH3sYP/81oUNiKz2RmZfxTrG9iPltFuMZu8jOoJ/9
jr3Dmq1Vvnf0RUTQ4NzP8V9uHQedA7kAD8cXAB8fFv3sYfg2Pl/iUsg95Cj3
hCx6Mubk9LDT16qZD6EzoaP2D4z+80HdcbscnUT3NKlu/blZzC339mNuHrMb
sqPuuWPesOPQt9G7uQ668zel4yPEAi7KbeuAiWdhJ02M9dYh+Ax7Df0GvQZe
3TF4DmuJ9T4/9h3r96dY5+fUreuwBu+umx/Bi4iNoYO8hg1bN6/pFHwSvokd
gjxHri+Ms9Ttu2leM39CZ2of/2dtdA/6Wzwv8uqAeNcPxDmZl6rws7cuHOPh
Oj+ILsj9ri8KWfRK7F30uFfrfmb0phlx/+MC8ww8L/sWPe2f4L3sWXgevI+5
XKKy7YKNzLzOjLnlfRJfIbZCDJVY6nqxtprEviAWg10Ezz84MMvyiMzjlxHe
orD+tXzEE+G/B8T9c2/1uN9xcf/EasGzwlZ+KeYT/fHleI9jAvPu0G95f/h/
u8RcZDE3d8b594x+zr9H9Heo2VeA77pe2deH72mhvy/3XPSD/2S2qVkDSyTH
tI8M38BCOzW3v+GXmLfZDftmd264geF16Jvol+iW8HDkPfx8RGD4HXscWc7e
Z28SF2T/D45j8cXNjTH048uDr6TCdtgXsQ7htchO+OTIOA97vG/0bxPXxWYj
zjcyztsydAkwvGLfyrEwbNU1MvsTeNfsU3jaWqFbYufgp1tR87K27uUl0ZPD
nvpMY1bAjhJtSZ5C5vXPPuidmafB85YRXS/8VMTPiKMtXrPfG12XOHVvdDD9
7ih6e+jckwvz2Hrcz64Nx1zIi/hXfV/G8Z9nPhadhnggx6Ij7VzZrhqAPaFj
N685J4Q4N/Hu7UTXLJwvsLHoZRq/eOaYQj/RCnugZh2VGBLXxj/JmH2E762c
9zC2cuyP52SOyNHA54YfbF4cS+yp3nDMo+B5CtvBW6rvjsLPSPyInA58eoIL
52ypmDf6lg7cMzBjNsjsZ5sr3KJw31YNx4lWy/xc5AJgV2Ab7FM5H+DqMnKg
MtsGWwZmngfiXxP+qPB8Ylvsio6f+Tdz+1+ck3eH3dA0s067QnJ8dSPRIzO/
Y8Z0DZ/AhaX7sL3wNzI3K4f+nwdmnsnJaZbZn7JKvAveH3wI3oS/BjmFnwWZ
hX6HnkecGl2VNc16JieMvjo+uco+JXxLxLQZj06Ir4i5QlZx/tXj2Duy8M/W
HANoHveNX6dFXLdL5bU/Q8+7aeHzoaPi2yAvBxsePkv+DDL0orh/zj+4cP+h
uZ8/xTrZo+F1Rxxr9cKY2O7JufWsqYX9d/AD/HnIKHKkFvr1QtYMyr1/8S+0
iHvfLJ5ln8z+LOZiUmCOeSCzL5hnJL6If3K+6N6Z/WvMD/YtOhJ+cnys6G3w
onZBsV/eaXgd7dhwPzH5DZPneK9F56ns17qkdFwc/xa+YmwFcvCwF4ihgI/N
bTOj7xwbvldy9Rj7bOb11yr2/jaxXrcqTIcTG88cX8AvRAwOnx55Y/iqW8U+
Zb+2in10YPAN+Ac5VxtGf+s47tsycogyr+mTKo/pX5q3owcia9CVyOFYmCvS
8BweX3NuScfMMXF4wq7C27NuKmNs5Ncz273YvKPD3vgi93HILWQWuSnkqHyX
24brGP3kEXWIYz+OdYjvbfnM/IJn2aGw3k2OEvkK/L954ZxFjicHaWach74d
ov/v0PPQa9qL/hm+Gnw26CTYG9jeyDvsWHTljzNj9FvyslhP2FTMC/kt6Frk
jYA5J/oFOV7oGPiHyD87MuZ7v3gHrFnWMT7Z7XXMLpn5+aul7xF/A74c7ged
cKfC+X7kDJA7x9qDl+IHRM9lD+4cYxj7e2n7gnwA5o95ZC9vH35y/Kv414nP
sY72KizbyKdbV/RQ9S9Rc9ywi/oeFD1Gxx6m/oGlZWPvmBN8iodntruPK8wL
yGHEP3Jx5hwGfB3kKO5cs51KHsUuwmfhA8+cO8HauTDW0ucN55jsQ/y68Hl2
bzgnj9joS7l59lGxd+DJ8Gv4HPl79JOfCT06xpwY/ljWOTbiiZltTHxkvPNu
heUS8on9TM5mj9gjxKQa2FrJugM+WfQH3jU6JXmf5OIwB8xP0fDzwv+3bng/
4lPtFPoGegd8CL8b9tonmWOf6FddGtYB70GPEL4gs7zH7scXhO2PrxCf4TG5
9+uNoSMdVti3Q/7vEWpbCh9VOM/hvMw2L/mTxPI4/nZ8YplzLCdq3JLoFQ3z
IuQluhP2P36wXUW/bDgna/+Gz8v5L0AHye3nIHdpTGU+UZTOpbmPNZX8/98z
+5eYQ/QwchPbN5x/cmfheBz5puiTvQrniJEfg59sQKyf/oHxm33VcF5YV9Fz
KueM9RWdnTl3g/1wdJyH85G3TAy0Rc08tU/wVfRG7Eli2/dUziW7iphCw+u3
M7HUwrGjnqJ9M+frkCuDPct5sFvPKXz+nvF+scmJyx5f+b0jL/Azk9vdq3Lu
FvFUYqnE4u4PTB+Y2PygkG3INfzkt2VeHxPjWGL35BNz78Tiyc3luBfwsRTW
VcmDRVdnbhf6ojPH1JnnNRrOiyMneHL085zwqEkxJ8wPeKEdmFkOwccmZPbf
4bs7u3B+Dnk+nOPaOM95hed7mOjllfP5vii8llnTGGaXFH635FadnTt+To5e
v8p5y+SlrNBwzG5f9InCOiw5eGtrbQ1W/yfq6185X5p3x/XZHxskyy7yaVmX
E/DDC3fT+X5U68X8NBwTHBznJ+63cIzwXg3vuens3YbniOdiLifHfJ5aONZP
PmHVcA4A9zeh8tyeH/rCXcFblg4MDyfP4bjMufrYAeC1a/Ytkf+BnGPNgJGj
2CjYKqwneNgJwceQ4XcHPyeH5PhY28dVxuSDcY5ecc5jApN32CRio8TCW8V5
kLPke/OOryocHx8f5yd+PiHeO++UNUk8NCXnCq2fLO9YJ+h1eWk7ZY3k3FZy
XPuyH3LbueRqDdJ5Rqv/l8KyaXycH3pP4CsLr3fuZ1z0o/+gH6LvEhv5QHRM
Zp8MfiFyEZCRZeG43Zu65m2V74f7eqjwmiGXFDmPvMfHid8SvgxPJleJnKXO
zEP4/toJN9WcLd1wPAO9AP2AtfZew3bGLg3nkH8a72JojEF/oI4DG3BMYT2I
fGhydxnLMcg5eMtncezxcR7ygognE1fmGYaHrkiM72piGJnrDkZFzIuYCH5a
fHn4dkZG/GlLbHO1pdALGs7FGqHfLZNlzmuZ5Q6yApmxKGYFnhf7mX1NPAue
xzh+Dw+9tlXw2KnBG7G5eF7sOGx8Yjn4GYjnPBmYczwW56GfMcRm0OV5XnzT
5A8zV3vHnH0R85aF/YIdc2RlO+fCyBdAliPHe8X+Ye/g6yCORR/rBF88fvh+
gbGPyKvnWOwRbJ936rbdmAfi1viP2kQsA5825+4W8wy/JeaNX6V1w/YKcU9s
vXfrjn8Xhf28P6v/lcyxMXzcNxXmQdQr3FL4+chlJbYzK/Z7p4Zt4bPCH/lB
rHnytvFjXabxSxT2k5A7/HYciw/q09Ax0DXwWeF/J7bQM/QwdHnGcgw+qlsL
x1LwO7HXkUP49/BXgTkXfiRyDZEp8HXOCW/Hv/V2XBe/GbFV9BCelWdGTyX2
Rf/C+JeuNTdzrc144R8y60LY09jVyH18GPgykBNnh9xH/u8YttuYOMeC2DvY
WEs1rDNif2KHnpK7rmGZhmN/7GH2MvN/eZwfHv5M4RgaNQisOTD6xGLJ5/g4
uc6FY58V/SvzOdGNkCfIFfJM+sf9oxOullyLc3yyzYo/iP2RGs4/ba8xk4Iv
wZ/ITeW8nPPKOCdyijgtPhl0ZvQ79LxF+dHfxjzfHbo4dTnvh66FzvVG6fsi
vwkfzteZY6/Ugn2TWR9DzwGj6+D34VrEh+8mHpo5x34dPcPyOt8PhXkftiI+
Ce7nxbgH6EuBqRv7Kvb4mYHRt+Bvc+N9kdfCMcRqyfXHF0hNCjUq+AvJYb41
t+xalDv/fOYcSnIG4F3EWLEz8obnkVjWjFhjT8dewweKj5HaNmJprEPGoPNe
WDm//SLRy0RLnecw9X8fuseqyfOBDcz84+/Dd9dG9JPQGdAdHqtcXzApzsdc
HV7zPuNY5hV+C/NBZ/0vMLz3w8I+FWK7Txa2mZ4o3MAPip5Q+DnJTz837vW8
ynZTo+G85EXnRR9+tPAapFYCeY/ch0eckXtvkY+/XOk6muuxI5NrZm4Xbp9c
33KH8K7JNSp3Ck8RPqBwzsPDyXUaA3QP2+p/1yDThCer/92G47Zbql2u/o/V
v13pHO/PhNsLjxD+vHIeBu91ob5SOkeaPO6VS+d7v4tOXTqH/B30vtJ53Z9U
tqOxqa+Hn5XOi54jvH3pPHByh9G/F+lWu5TO0f1CfSsK9xZ+W/gh3fPbjag7
S85dRi8YpOe7XcddITpJ/efmzg+cmJx/WWH3qD2aO4dzQnIuZiF6v9ohhfMZ
Rifnhv6la92bnANaio5PztHMRe9JzsVsiI5Lzm/LRO9Mjuv/x55NzotCGUL3
ICeD3NUh8Y5vE70jOddzAX6h5JyquujtyXmf/6p/bHJO6j/CY5JzVf/G91k6
n38WsevSef5vYe+WztWfXTn/Ex0X3xjxxUV5yieUznnmGY8qnZf+q/CRpXOw
fxE+sXTeNdc6unS+92/oraXzrv+s7P/E70k92Umlc7O5zzNK10bxLKeVzgPn
GfEVw++pfehdul6JuTpW+AnktfDppespmLfDS+eH/6+yD40cZnKZ+6j/lZrn
vFv4yvCZHVc6t/yPynHQRTEK4tzojGBqObAR4Z/E64eLXqOxa5SuU3hfeK3S
uvAHwquVroN4r7I9g/wYhV+9dJ3Fm8JLlq6/eEN4erKvED3r2eT8s+VEN9SY
izXmI435t7RfZYTw4qXrOGYKT0uO7eF/fSE5PsT7ei3Zj3BaZf9s85rH4O/G
BkVerav+c+BPlWtT4UXwIPxp+K3IZaXOYVrN6wr7Dr9Pf9E3qXUpXMdxYHKd
MLXQByXX6z4u3DW5/vZh4f2S63IfEt4/udZ3snC35FrfR4T3Ta7jfVB4n+T6
3knCByTXJE8R3ju5rvgB4S7JdcX3k0uQXO83TrhTcs3ePcKdk2v2xrP2k+tV
Xtaz7JlcEzhR/R2S6wbvxo+YXGd4V2mbF/31fNG9kmtr71P/7sn1fhPgMcm1
K9N1zqHJNQnfCt+cXOfDHrklufaPvXBFcv0DPOrG5JoH1uoNybUKPwnflFyb
x566Prne4Efhkcl1ET8LD0+uZ/hB+LrkGonvhYcl11rME746uT5hrvA1yTUS
XwsPSa6j+Ia9k1yr80pl3wgynDq8a5PrT77Ddk+ui/hK+MrkuogvhQcn14TA
k/dIroe8V3PSPbmu+zHhg5PrvZ8orbegn6CnvKL+WQ3HxV4XPrlwXRX7iv01
IHQD8plG6n/P639vNpyLe1tyPj385OLc+cmjNOaGwvoD419M5u/Yqm+o9S4s
66ltxh9GLcC7+v1Rw3EoeP+oWNu3JufowxM+Sq4FeriynYVdhn2F7wMfyFrJ
+vnnwZ/fS9Z36R+VnN8Pj0JXJw/sRv3viOTasycq2wjU094semJyjdbz6u+R
XFf/JDwjuS7rxcp2xOx43mOTa4Gmqv+E5Fqv59izybVbL8HfkmuEnhV+J9lP
vRLznVz39YL6eyXXEz4jfGhynf8zuu5hyd8FmCp8eHJd4rPwnuT6sWnIguQa
uSeFD0n+LsDTGtMz+VsATwkfk1xb+DRyIbm+7inhI/S/yTWv5z1L1wGxPvco
XY/Dul0peOANokuVrtu9TrQqXfd9regSpWt4h5WuF4JfUae1Quka4RGl5QX8
n+dCf8HvRe3+KaVrJHnGZUrXGg8X3aB0be8Y0R3i3tA3dir9PQT4z46lv1EA
/2kaug11YJ2F762Z76E7jaqZz2xT+lsE7JFWpeuRx5bm8+hX6GbtSn97AT6z
auna4RtF1ytdd3ybaI/QYanZ/K6wj525/aZwPSNz+63wnjW/F2yE+SGD1ixd
H31zaf8JtcqjK9enYa9Q79m3dH0KesvZpetW0HnOKV3/gm5zmPBzNb/fZqVr
pUeKrl+6Dnq0aMvSddO3In9K12LfItqrdH0r6+TQ0t+dYJ2vXrq++ybRddQu
Ex4l2rb0dyHgt1uX/rYD/LxN6W8+wOfxO+EvWiq5rnBs6HUbVY6BkTdEfTS5
ZOTWLSisHw4tXS9ALcCk3DWB5HCwT6n9ISdzw8Lx6Juxi9hn+CZ07JDStX6M
IX+T7xWQV7BS4VyCczLLX77xUQ++R07mdOQX+0PH3lGzjKPeeX/ha0rXG3I/
1ChQk0hshRjLuYXtLuRR08r5QOQtUtOI3f+8+rdp2P8/XH1dSn+XY6HcLP1d
DuTsPmoP1SyvDyz9TQ/kdcfS39lARnco/V0OZPHGpfVt9PZNSn9fAtuhU+nv
eCDHPyhc9wpP27T0tz6wKbqX1tPg/+eWrplCr6Z+gbgz8ee2Dcep+P7DZqW/
GYL8RWd7v2ae063090aQKXw/gXw58uY2L/0NEGR3a7Xra9YBiF+QF0F+BLYe
dt/4yrZVFRhbvFnY6ujaTcMHuEv4/fAD8L+VY29Am4VPAJ9xk/C19gi5ScyB
Wm9qOanpxCZjDH5m7Gpsxocq26QrBN5ec7FY7nW+nXDKvUd2SP62BXuHb8uQ
T/A6vkD1l7n3yIzC/gNq4bdFD8y9rz8vbLcSQ6Eugrx5/HnUKZPHSP4y/nTi
HPjXiYuTE0+cfP/StZnI/a6l6z3RJQ4uXReJHtKjdM3jfOF9S9eZovPsXrqm
Ej1hVnIMgP2yn/rvrFnf6Bz8EP1h4+T6WNZ8z9L1m+g/3YN/os9QQzpC51kv
+VsB+BHJ9cafQ030q6IHla7TRBeiJo2cVfTnsnTt8+vqP61h/Zxa452TvzEB
7z2rdP0ddtmI5NpRnmun5G9PwP/bJX8nAt77d2Heiyz+q3C9PDL0z8I148jE
nwrH15DL82NfI1vrpWt1X2WdFI55IZd/L1xjjtzPSscyZlT2480Mnf/Uhm2N
vvh/kv1KrE18C9Tzj+MdNXw/p6jv7WS/PPywZ/gq+DbCf4W/G4C++k/hfvQE
EoGOrlkPXBD8DT0ZPz7+/FuFj4w4C7XYf6i/R836xla6Rj23nN1M+J+G5fLm
wv82LJdbCy9oWHZvkvwdHPhnG+Est3zfNPkbOvDktsJFbtm3tXCeW77smPz9
DuTLFsL/NSyvX4u9wJ6ghoH8ffY0dZL4ufFJUx/4XezdLVNtYTIMvpGkdoJ+
vqb/31XZJ4ZvjDoLcu+nVPYXrhY+w0cr+x7pH5Rca42vY3ayPkoN2mXJNcb4
TPAjUYcAfyaHCf8SsVlqRvC3kl9N7dCiWAE1Qbto7KPJOYHkiVKLhz1OTgd5
u/jrXteYD5Pr/fHHU3vRI/xC1IFhw7aOGAg17+Q/kwdNjhb5WtRHkoNBjgdx
EL4nQNy5k469PLkuGn8O9eDMJ/NKXg22I3XD5AmQo3Z84bg+8f1xhePLzCG1
8+j4C0ImEpsmTk0smbx9cmSRhXz7BX8k31RYmP+Q+fnJlyMf6/DC+UgprkWM
gLgAsXzqa6groDaU+mt4736F/aXz4n6IL+NbHlC4LpE6BeorqfMkB3vTynmk
5EgTT+G7HORPfFW6Vov8D5KMqXskV5OazW3DR4jtji8O/+RjohsU9nG3Kpwj
RI4D9ZoLv+eg3zdUrquiJosYFrWv5M5T941MJ5f8qeQ6BWoQyBPGp7dKnJP8
K/zg1MpQ70DOLnUkM9F1GpYR1NaS87h35RwM9IcphfMWyE8g/oUtRb4lOWn4
JBdDJy/8nQR8rNQZkGNEnQmxYmKCa9dct0H9Oflc1IbjP4cP840KfJhFzAM5
aeT6cA/UfRFrw+7g+wDEsaij4psVi2qDqPUlXsf3kcjPJu+UeDU551MitoLe
hv5G3jJ+DHzt5IxgO+Ivhe/hk/85+BXfHcLXz/c/0APJI5sKXwyZi6+mX8hc
fDj9k78rgT/kguA5+CQvCpmLf+zikLP4dvALko/P95GocyYPiO8jkYdDjg05
N+TOkffQT/TS5O874Nuknpk4J3Wj5GGSY0nuE9+EIq+LWmt42poN7/OByd8g
wNc6IPmbGviF8NcSOybvpW/wWPxC5wVfxddHDgnxhIXfdAlejd/vnOCB+KPO
Dl6KP6pFcg0q+4LvVBD7JgbeJ3g7fPKM5O99IMsuDF6NL/f8ZBsIv+tZwf+R
v+Rg4D/j23T4Tc8WPlT0zOTvfSDvsMXZI3ybjW9rEBfao3JdP7nh6AF8E406
xsUL12VQr0FOGnm5WZyTb6MtFz57akKpT+CbWOS3UAv0QGF/AH58vn/Dd9iI
i1FDjEx9MGQs31UjL4zvIZFncHXY6eQbkM/A99jINSUnlJxhviFGTiK2J/Xz
5CDvVfnbO+yF7qL3F86f4R6QNas27FvAl0ZMHfmOrxr+gw6Pz478a/x85MAQ
A+C7ONQVE58h75e8aGKY1N1eUjmujE1HTgV7emayT5A5w0f4f3us7As=
          "]], Polygon3DBox[CompressedData["
1:eJwtmwf8V+MXx+/3e8dzlZlRiGyirKxEVsgqe1VKQhQVqYR2yaokhUoppULL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          "]], Polygon3DBox[CompressedData["
1:eJwt1nn8jlUax/HH9vwelaUoKjOKSUqTNbuKDGUNjRJh0qgpWbNElinMUFHZ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          "]]}],
       Lighting->{{"Ambient", 
          RGBColor[0.30100577, 0.22414668499999998`, 0.090484535]}, {
         "Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 0, 2}]}}]}, {}, 
     {GrayLevel[1], EdgeForm[None], 
      StyleBox[
       GraphicsGroup3DBox[{
         Polygon3DBox[{{805, 2, 801}, {800, 2, 805}, {802, 270, 804}, {817, 
          270, 807}, {807, 270, 802}, {803, 2, 800}}], 
         Polygon3DBox[{{804, 270, 436, 806}, {1265, 2, 803, 1489}, {1489, 806,
           436, 1265}}]}],
       Lighting->{{"Ambient", 
          GrayLevel[0.8]}}]}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0stLVGEYB+DX66iZWRAEQZERTFOOQxgUqRCuwhYhLUyjckDI27g1iLZJ
BNGmtm0K3LiqVcvyUnZRs/Ey2WVl+BfMRvA5uHjP8/udc77znTnMqfxEb6Ei
Il6Z/sqIJB92KJqVmohmPed8Rs/zpN4lr7mWldfZyRKvc4cDLHOEdbUR9eaB
fIZTbOdLdvMNe/mOg/zIVCrijj3G7PdD7+OIPlsVsarP8SfnWeQC1/iJ6/zM
DS5yk19Y4lf+4jdu8Tt/c4l/uMy/fF8dcc9+4/b9p9/iqP7Q+63oBX7gXb7l
Db7mVb7gBT7mabaYSfm29TXysPzc8wb0Lr+zzH7nhvnfN+uR78sdfOS+XWuu
6a160fUT3HYu7dyg64f0mxzSO71/k97Bg7zCRl7mAV5iA595zow19fJTeVqu
k5t50T1eKxrldtlWcdyza923lfyG5PvwWJKVEn2ueOJwVLYkpuQjyX/EnHUi
Y86Z82bJmlZmTZvJmXTV/n9vD3PUSko=
       "]], 
      Line3DBox[{801, 2, 1265, 436, 270, 817, 807, 802, 804, 806, 1489, 803, 
       800, 805, 801}]}, 
     {GrayLevel[0.2], Line3DBox[CompressedData["
1:eJwV0LkuRVEUBuCtMIvEFDFeJzF0LipjDD2Say5dFC7hCcxzJJ5A6Q2oUKGQ
iMbQmcfX8Cm+/Gut/+zmRMnFxEJaCCHFXXoIZZkh7FPOc0YIrbKNq6wQluxP
JOyTDJFNoe6UpHlZPywrqCSXS12RXNHlyEaaiFOre3UvNrezan6hytzMhb6A
d7cOeydr5rf/N+7X9Lt1M0KKdd2svNUNyEF6GGWeDf2crOaQGHmU0MUZ595+
+K7G3ELEp71PTnGj37T3mseYYJwvt1LdMTP2Lfu0/JY/nLhvy3v/OjLXcaTf
cXtwi9nrOXDbdXt0y7c3sGf/5Q/KozE2
       "]], 
      Line3DBox[{610, 531, 1859, 558, 1369, 626, 438, 1769, 2245, 482, 1768, 
       562, 1770, 2229, 1674, 1807, 2056, 2088, 1932, 693, 694, 658, 2089, 
       1901, 697, 698, 1426, 398, 451, 373, 1805, 2235, 450, 1771, 486, 1808, 
       567, 1773, 488, 2246, 1772, 1731, 1933, 704, 1453, 757, 532, 1860, 
       2250, 570, 629, 404, 1806, 2237, 374, 1774, 405, 2090, 1776, 375, 1809,
        574, 2091, 1777, 614, 1894, 2252, 1778, 1779, 1675, 1494}], 
      Line3DBox[CompressedData["
1:eJwV0LkyQwEYBeBfIegMYyvR6vAIto6UljGjoUosj0Bp3xtlGgVRkGhUdhmN
Gem8gsYuZny3+Oac/9ybZCbtU9l0pioiJilXR1ymIjI1EQfk3H3yytYv22oj
8mT1N9s1g/qjbVbOMUCju4sRfdk7p3LMdx3KFfeifPL8Rs/peU54d5/Zl/Q1
bt3zcp1NNviwdchu7vRe2UwPLVz4/Ke9U9/iXv+iNfkNz+pp0Ef5tv8kz2wF
ZmzTvNr2Zdm2qg/rRxxTZ3vhXC9Q5Nc7RduDXHBvs0PF3WR/Ztddcg8l/wUT
jLPHn/0ftNA5Rg==
       "]], 
      Line3DBox[{1496, 630, 1408, 663, 252, 1306, 518, 253, 1307, 519, 1308, 
       254, 643, 1388, 642, 1497, 2266, 761, 792, 1480, 634, 665, 255, 1195, 
       330, 721, 256, 1196, 331, 458, 257, 1276, 459, 332, 725, 258, 1217, 
       368, 1218, 335, 739, 1441, 636, 767, 1462, 337, 360}], 
      Line3DBox[CompressedData["
1:eJwVyzsvA2AYhuFXHNpgNtPUYbHyH9gkXSXtD2BRJWF02Mw06eiQmDpImkhY
DXWsYxVF8SvKZbjzPO/9fN9Qbn5mriMiMqh3RxwnIrLJiCd9QV9EHnXuQD7z
1Z6IKf1cnvENbs3dq9cwrV/YXvgNvcxdutf1K1mSr7bUv8eK+xCreOPHuS3v
mvout489HKFhe+cL+jKW8MgN4oPfdF/728YNTvg092kbljXuFzm+DyNcyzYq
J9DPnSL0W+8m5Ri+vNmRRTzY72zb+r38tg1wFXRys+jCD/8Htys2VQ==
       "]], 
      Line3DBox[{1514, 1981, 2147, 1513, 1982, 2148, 1515, 1983, 2149, 1516, 
       2074, 2255, 1915, 1914, 1963, 1517, 2075, 2257, 1919, 1918, 1972, 1518,
        2083, 2268, 1970, 1978, 1971, 1519, 2094, 1680, 1520, 1984, 2150, 
       1521, 1985, 2151, 1522, 1986, 2152, 1523, 1920, 1921, 2153, 2076, 1951,
        1524, 1929, 2061, 2261, 1793, 1752, 1833, 1525, 1834, 1156, 1794, 
       1753, 1835, 1526, 2241, 1836, 1887, 1754, 1797, 1755, 1888, 1837, 
       1854}], Line3DBox[{1528, 1987, 2154, 1527, 1988, 2155, 1529, 1989, 
       2156, 1530, 1990, 2157, 1531, 1991, 2158, 1532, 1992, 2159, 1533, 2095,
        1681, 1534, 1993, 2160, 1535, 1994, 2161, 1536, 1995, 2162, 1537, 
       1996, 2163, 1538, 1997, 2164, 1539, 2077, 2258, 1922, 1953, 1952, 1540,
        2078, 2247, 1930, 1868, 1955, 1965, 1954, 1541}], 
      Line3DBox[{1545, 2096, 1682, 1543, 2097, 1683, 1547, 2098, 1684, 1549, 
       2099, 1685, 1551, 2100, 1686, 1553, 2101, 1687, 1555, 2102, 1688, 1557,
        1027, 1559, 2103, 1689, 1561, 2104, 1690, 1563, 2105, 1691, 1565, 
       2106, 1692, 1567, 2107, 1693, 1569, 2108, 1694, 1571}], 
      Line3DBox[{1570, 2178, 2011, 1568, 2177, 2010, 1566, 2176, 2009, 1564, 
       2175, 2008, 1562, 2174, 2007, 1560, 2173, 2006, 1558, 2172, 2005, 1556,
        2171, 2004, 1554, 2170, 2003, 1552, 2169, 2002, 1550, 2168, 2001, 
       1548, 2167, 2000, 1546, 2166, 1999, 1542, 2165, 1998, 1544}], 
      Line3DBox[{1573, 2012, 2179, 1572, 2109, 1695, 1574, 2110, 1696, 1575, 
       2111, 1697, 1576, 2112, 1698, 1577, 2113, 1699, 1578, 2114, 1700, 1579,
        2013, 2180, 1580, 1042, 1581, 2115, 1701, 1582, 2116, 1702, 1583, 
       2117, 1703, 1584, 2118, 1704, 1585, 2119, 1705, 1586}], 
      Line3DBox[{1588, 2014, 2181, 1587, 2015, 2182, 1589, 2120, 1706, 1590, 
       2121, 1707, 1591, 2122, 1708, 1592, 2123, 1709, 1593, 2124, 1710, 1594,
        2016, 2183, 1595, 2017, 2184, 1596, 1057, 1597, 2125, 1711, 1598, 
       2126, 1712, 1599, 2127, 1713, 1600, 2128, 1714, 1601}], 
      Line3DBox[{1603, 2018, 2185, 1602, 2019, 2186, 1604, 2020, 2187, 1605, 
       2129, 1715, 1606, 2130, 1716, 1607, 2131, 1717, 1608, 2132, 1718, 1609,
        2021, 2188, 1610, 2022, 2189, 1611, 2023, 2190, 1612, 2024, 2191, 
       1613, 2133, 1719, 1614, 2134, 1720, 1615, 2135, 1721, 1616}], 
      Line3DBox[{1618, 2025, 2192, 1617, 2026, 2193, 1619, 2027, 2194, 1620, 
       2028, 2195, 1621, 2136, 1722, 1622, 2137, 1723, 1623, 2138, 1724, 1624,
        2029, 2196, 1625, 2030, 2197, 1626, 2031, 2198, 1627, 2032, 2199, 
       1628, 2033, 2200, 1629, 2139, 1725, 1630, 2140, 1726, 1631}], 
      Line3DBox[{1633, 2034, 2201, 1632, 2035, 2202, 1634, 2036, 2203, 1635, 
       2037, 2204, 1636, 2038, 2205, 1637, 2141, 1727, 1638, 2142, 1728, 1639,
        2039, 2206, 1640, 2040, 2207, 1641, 2041, 2208, 1642, 2042, 2209, 
       1643, 2043, 2210, 1644, 2044, 2211, 1645, 2143, 1729, 1646}], 
      Line3DBox[{1660, 1800, 2223, 2063, 1659, 2222, 2055, 1658, 2221, 2054, 
       1657, 2220, 2053, 1656, 2219, 2052, 1655, 2218, 2051, 1654, 2217, 2050,
        1653, 1730, 2144, 1652, 2216, 2049, 1651, 2215, 2048, 1650, 2214, 
       2047, 1649, 2213, 2046, 1648, 2212, 2045, 1647, 1208, 1798, 1799}]}, 
     {GrayLevel[0.2], 
      Line3DBox[{820, 1312, 1313, 1168, 1315, 1314, 2248, 1298, 1331, 1332, 
       1177, 1241, 1426, 1240, 1427, 1403, 1404, 1402, 2259, 1132, 1460, 1458,
        2266, 1459, 1468, 1469, 1470, 2256, 1395, 1392, 1485, 1486, 1487, 
       2268, 1478, 1477, 860, 2159, 1013, 872, 2170, 1025, 2101, 886, 1039, 
       2113, 900, 1053, 2123, 914, 1067, 2131, 928, 1081, 2137, 942, 1095, 
       2141, 956, 2216, 1109, 970}], 
      Line3DBox[{821, 1316, 1355, 1317, 1170, 1319, 1368, 2253, 1318, 1299, 
       1352, 1353, 1212, 1274, 2235, 1273, 1275, 1247, 1293, 1248, 1190, 1406,
        2230, 1405, 1379, 1377, 1480, 1378, 844, 996, 2093, 850, 1003, 2094, 
       861, 1014, 2095, 873, 2171, 1026, 2102, 887, 1040, 2114, 901, 1054, 
       2124, 915, 1068, 2132, 929, 1082, 2138, 943, 1096, 2142, 957, 1110, 
       2144, 971}], 
      Line3DBox[{8, 287, 624, 1899, 23, 365, 1808, 38, 493, 321, 1782, 712, 
       53, 665, 68, 1505, 83, 1520, 98, 1534, 113, 1556, 1557, 128, 1579, 143,
        1594, 158, 1609, 173, 1624, 188, 1639, 203, 1653, 218}], 
      Line3DBox[{824, 1172, 1356, 1357, 1358, 2227, 1359, 1244, 1126, 1429, 
       1333, 2250, 1334, 1461, 1444, 1192, 1364, 2231, 1365, 1366, 1367, 1256,
        1141, 1276, 1227, 1277, 1228, 1296, 1257, 1148, 2239, 1202, 999, 853, 
       2152, 1006, 864, 2162, 1017, 876, 2174, 1029, 2104, 890, 1043, 2115, 
       904, 1057, 918, 2190, 1071, 932, 2198, 1085, 946, 2208, 1099, 960, 
       2219, 1113, 974}], 
      Line3DBox[{825, 1173, 981, 2228, 826, 1335, 1127, 1336, 1223, 2237, 
       1224, 1361, 1360, 1181, 1320, 989, 2263, 840, 1142, 1217, 1229, 1230, 
       1297, 1258, 2146, 1149, 1203, 1435, 1436, 854, 1452, 2153, 1397, 1413, 
       1007, 865, 2163, 1018, 877, 2175, 1030, 2105, 891, 1044, 2116, 905, 
       1058, 2125, 919, 2191, 1072, 933, 2199, 1086, 947, 2209, 1100, 961, 
       2220, 1114, 975}], 
      Line3DBox[{827, 1454, 1455, 2085, 1456, 1457, 1128, 1180, 1129, 2090, 
       1245, 1182, 1337, 1407, 1133, 1473, 1134, 2270, 1484, 1472, 1471, 1197,
        1218, 1198, 1343, 1199, 1259, 2240, 1150, 1278, 1151, 1260, 1204, 
       1415, 2261, 1154, 1414, 1155, 866, 2164, 1019, 878, 2176, 1031, 2106, 
       892, 1045, 2117, 906, 1059, 2126, 920, 1073, 2133, 934, 2200, 1087, 
       948, 2210, 1101, 962, 2221, 1115, 976}], 
      Line3DBox[{828, 1430, 1431, 2086, 1432, 1433, 1183, 1215, 1184, 2091, 
       1338, 1185, 1251, 1135, 1193, 2232, 1136, 1382, 1380, 1441, 1381, 1437,
        1438, 1152, 2264, 1439, 1153, 1261, 1205, 1262, 1156, 1206, 1157, 
       1400, 2258, 1398, 1399, 879, 2177, 1032, 2107, 893, 1046, 2118, 907, 
       1060, 2127, 921, 1074, 2134, 935, 1088, 2139, 949, 2211, 1102, 963, 
       2222, 1116, 977}], 
      Line3DBox[{829, 1174, 1175, 2087, 830, 1186, 1362, 2252, 1187, 1188, 
       1341, 1342, 1194, 2262, 1340, 1339, 1305, 1200, 1462, 1201, 1344, 1345,
        1346, 2233, 1219, 1348, 1347, 1349, 1263, 2241, 1264, 1207, 1326, 
       1325, 1311, 2247, 1417, 1418, 1416, 1158, 880, 2178, 1033, 2108, 894, 
       1047, 2119, 908, 1061, 2128, 922, 1075, 2135, 936, 1089, 2140, 950, 
       1103, 2143, 964, 2223, 1209, 1210, 1211}], 
      Line3DBox[{965, 1104, 1208, 951, 1090, 2201, 937, 1076, 2192, 923, 1062,
        2185, 909, 1048, 2181, 895, 1034, 2179, 881, 2096, 1020, 2165, 867, 
       1008, 2154, 855, 1000, 2147, 847, 993, 2145, 841, 990, 1408, 1447, 
       1446, 835, 986, 1445, 1302, 1443, 1442, 831, 982, 1369, 1329, 1176, 
       1237, 1236, 818, 2244, 978, 1281, 1159, 1232, 1231, 1488}], 
      Line3DBox[{966, 1105, 2212, 952, 1091, 2202, 938, 1077, 2193, 924, 1063,
        2186, 910, 1049, 2182, 896, 2109, 1035, 882, 2097, 1021, 2166, 868, 
       1009, 2155, 856, 1001, 2148, 848, 994, 1463, 2267, 1383, 1464, 842, 
       1449, 1448, 1306, 1137, 836, 1374, 1373, 2224, 1189, 1130, 1246, 1289, 
       1288, 2245, 1287, 1330, 1161, 1284, 1354, 2234, 1283, 1282, 1327, 1117,
        1233, 1160}], 
      Line3DBox[{967, 1106, 2213, 953, 1092, 2203, 939, 1078, 2194, 925, 1064,
        2187, 911, 2120, 1050, 897, 2110, 1036, 883, 2098, 1022, 2167, 869, 
       1010, 2156, 857, 1002, 2149, 849, 995, 1323, 2249, 1143, 843, 1385, 
       1384, 1307, 1138, 837, 1376, 2254, 1375, 1303, 1131, 1363, 832, 2229, 
       983, 1213, 1165, 1351, 1268, 819, 1221, 2243, 1280, 1220, 1350, 1118, 
       1419, 1328, 1162}], 
      Line3DBox[{968, 1107, 2214, 954, 1093, 2204, 940, 1079, 2195, 926, 2129,
        1065, 912, 2121, 1051, 898, 2111, 1037, 884, 2099, 1023, 2168, 870, 
       1011, 2157, 858, 1390, 1389, 2255, 1391, 1145, 1324, 1144, 2260, 1409, 
       1309, 1140, 1308, 1139, 1322, 1321, 2092, 1292, 1304, 1291, 1440, 1424,
        2088, 1123, 1214, 1122, 1270, 1238, 1167, 1267, 2084, 1269, 1164, 
       1279, 1163, 1266, 1285}], 
      Line3DBox[{969, 1108, 2215, 955, 1094, 2205, 941, 2136, 1080, 927, 2130,
        1066, 913, 2122, 1052, 899, 2112, 1038, 885, 2100, 1024, 2169, 871, 
       1012, 2158, 859, 1394, 1467, 1393, 2257, 1396, 1147, 1310, 2226, 1146, 
       1411, 1410, 1387, 1388, 1386, 1466, 1465, 1371, 1479, 1370, 1372, 1401,
        2089, 1125, 1425, 1124, 1239, 1169, 2242, 1235, 1120, 1166, 1119, 
       1234, 1286}], 
      Line3DBox[{972, 1111, 2217, 958, 1097, 2206, 944, 1083, 2196, 930, 1069,
        2188, 916, 1055, 2183, 902, 1041, 2180, 888, 1027, 2172, 874, 1015, 
       2160, 862, 1004, 2150, 851, 997, 1481, 1483, 2269, 1482, 845, 991, 
       1476, 1195, 1253, 1294, 1252, 838, 987, 2238, 1225, 1191, 1250, 1249, 
       833, 984, 2246, 1290, 1178, 1272, 1271, 822, 979, 2236, 1222, 1171, 
       1422, 1421, 1420}], 
      Line3DBox[{973, 1112, 2218, 959, 1098, 2207, 945, 1084, 2197, 931, 1070,
        2189, 917, 1056, 2184, 903, 1042, 889, 2103, 1028, 2173, 875, 1016, 
       2161, 863, 1005, 2151, 852, 998, 1412, 2265, 1451, 1450, 846, 992, 
       1434, 1196, 1255, 1295, 1254, 839, 988, 1226, 2225, 1216, 1475, 1474, 
       834, 985, 1453, 1428, 1179, 1243, 1242, 823, 2251, 980, 1301, 1300, 
       1121, 1423}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJx0+3c81f//x4+jqDSQSiqS7FEkScY9RWQ2JCtlRUPIiCQrJHtUVjKK0rD3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    "]],
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGridsStyle->Automatic,
  Method->{"DefaultBoundaryStyle" -> Directive[
      GrayLevel[0.3]], "RotationControl" -> "Globe"},
  PlotRange->{{0.1, 2}, {0.1, 4}, {0, 4}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], Automatic},
  Ticks->{Automatic, Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.3992806682897205`*^9, 3.479966557173038*^9, 
  3.4799667912300377`*^9, 3.479967371067038*^9, 3.479968241869038*^9, 
  3.5185312719267693`*^9, 3.5185316444807973`*^9, 3.518531775577064*^9, 
  3.5922044218479357`*^9, 3.5922053165448685`*^9, 3.64276108122717*^9},
 CellLabel->"Out[16]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", "c", "]"}]], "Input",
 CellLabel->"In[17]:="],

Cell[TextData[{
 "Here is shown that the solution obtained with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " is right "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"z_", ",", "t_"}], "]"}], "=", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"t", "-", "z"}], ")"}], "2"], 
         RowBox[{"4", " ", "t", " ", 
          SubscriptBox["d", "n"]}]]}], "-", 
       RowBox[{"t", " ", 
        SubscriptBox["d", "n"], " ", 
        SubscriptBox["r", "n"]}]}]], " ", "z"}], 
    RowBox[{"2", " ", 
     SqrtBox["\[Pi]"], " ", 
     SqrtBox[
      FractionBox[
       SuperscriptBox["t", "3"], 
       SubsuperscriptBox["d", "n", "3"]]], " ", 
     SubsuperscriptBox["d", "n", "2"]}]]}], ";"}]], "Input",
 CellLabel->"In[18]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "t"}], "]"}], ",", "t"}], "]"}], "==", 
   RowBox[{
    RowBox[{
     SubscriptBox["d", "n"], " ", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"z", ",", "t"}], "]"}], ",", "z", ",", "z"}], "]"}]}], "-", 
    " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"z", ",", "t"}], "]"}], ",", "z"}], "]"}], "-", 
    RowBox[{
     SubscriptBox["r", "n"], " ", 
     SubscriptBox["d", "n"], 
     RowBox[{"c", "[", 
      RowBox[{"z", ",", "t"}], "]"}]}]}]}], "//", "Simplify"}]], "Input",
 CellLabel->"In[19]:="],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.3992806686337976`*^9, 3.479966557313038*^9, 3.479966791418038*^9, 
   3.479967371213038*^9, 3.479968242018038*^9, 3.5134112001975007`*^9, 
   3.5134112773713512`*^9, {3.51853128159883*^9, 3.5185312981772733`*^9}, 
   3.518531540353798*^9, 3.518531776061448*^9, 3.5922044220699577`*^9, 
   3.5922053451747313`*^9, 3.6427610814303083`*^9},
 CellLabel->"Out[19]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "SubsectionIcon"],

Cell[TextData[{
 "[1]\[ThickSpace]\[MediumSpace]Sanchez  G, Biokmod. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " in Educacion and Research ",
 StyleBox[". ",
  CharacterEncoding -> "WindowsANSI"],
 "10 (2); 2005."
}], "Text",
 CellChangeTimes->{{3.6502700530532026`*^9, 3.650270069537613*^9}, {
  3.650598315274359*^9, 3.650598385946724*^9}},
 CellTags->"ref 1"],

Cell["\<\
[2]\[ThickSpace]\[MediumSpace]J. A. Jacquez, Compartmental Analysis in \
Biology and Medicine.The University of Michigan Press, 1985.\
\>", "Text",
 CellChangeTimes->{{3.650598392212393*^9, 3.650598425900126*^9}},
 CellTags->"ref 1"],

Cell[TextData[{
 "[3] ",
 StyleBox["Anderson, D.H. ",
  CharacterEncoding -> "WindowsANSI"],
 StyleBox["Compartmental analysis and tracer kinetics",
  FontSlant->"Italic",
  CharacterEncoding -> "WindowsANSI"],
 StyleBox[". Berlin: Springer-Verlag; 1983.",
  CharacterEncoding -> "WindowsANSI"]
}], "Text",
 CellTags->"ref 4"],

Cell[TextData[{
 StyleBox["[4] Godfrey, K. ",
  CharacterEncoding -> "WindowsANSI"],
 StyleBox["Compartmental models and their application",
  FontSlant->"Italic",
  CharacterEncoding -> "WindowsANSI"],
 StyleBox[". London: Academic Press; 1983.",
  CharacterEncoding -> "WindowsANSI"]
}], "Text",
 CellTags->"ref 4"],

Cell["\<\
[5] Juan M. Rodr\[IAcute]guez-D\[IAcute]az;Guillermo S\[AAcute]nchez-Le\
\[OAcute]n:\[CloseCurlyDoubleQuote]Design optimality for models defined by a \
system of ordinary differential equations\[CloseCurlyDoubleQuote] Biometrical \
Journal 56 (5), pag 886\[Dash]900, September 2014
[6] G. S\[AAcute]nchez; J. M. Rodr\[IAcute]guez-D\[IAcute]az . Optimal design \
and mathematical model applied to establish bioassay programs\
\[CloseCurlyDoubleQuote]: Radiation Protection Dosimetry. \
doi:10.1093/rpd/ncl499. 2007. ISSN/ISBN: ISSN 1742-3406
[7] Lopez-Fidalgo J Rodri\[DotlessI]guez-D\[IAcute]az J.M.,S\[AAcute]nchez G; \
G., Santos-Mart\[IAcute]n M.T. Optimal designs for compartmental models with \
correlated observations\[CloseCurlyDoubleQuote] Journal of Applied Statistic. \
32, 2006 ISSN/ISBN: 0266-4763\
\>", "Text",
 CellChangeTimes->{{3.650268278314935*^9, 3.6502683057784147`*^9}, {
  3.6502683433947926`*^9, 3.6502683537263503`*^9}, {3.6502693918226557`*^9, 
  3.6502694314946685`*^9}}]
}, Closed]]
}, Open  ]]
},
ScreenStyleEnvironment->"Brackets",
WindowToolbars->"EditBar",
WindowSize->{1664, 948},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingStartingPageNumber->1,
PageHeaders->{{
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], 
   Cell[
    TextData["Biokmod"], "Header"], None}, {
   Cell[
    TextData[
     StyleBox[
      RowBox[{"Printed", " ", "from", " ", "the", " ", 
        StyleBox["Mathematica", FontSlant -> "Italic"], " ", "Help", " ", 
        "Browser"}], "PageHeader"]], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], 
   Cell[
    TextData[{
     "http", ":", "//", "diarium", ".", "usal", ".", "es", "/", "guillermo"}],
     "Header"], 
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
PageFooters->{{None, 
   Cell[
    TextData[
     StyleBox[
      RowBox[{
       "\[Copyright]2013", " ", "Guillermo", " ", "Sanchez", ".", " ", "All", 
        " ", "rights", " ", "reserved", "."}], "PageFooter"]], "Footer"], 
   None}, {None, 
   Cell[
    TextData[
     StyleBox[
      RowBox[{
       "\[Copyright]2013", " ", "Guillermo", " ", "Sanchez", ".", " ", "All", 
        " ", "rights", " ", "reserved", "."}], "PageFooter"]], "Footer"], 
   None}},
PageHeaderLines->{True, True},
PageFooterLines->{True, True},
PrintingOptions->{"FacingPages"->True,
"FirstPageFace"->Right,
"FirstPageFooter"->True,
"FirstPageHeader"->True},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "fig 2"->{
  Cell[27549, 1009, 68, 1, 32, "Text",
   CellTags->"fig 2"],
  Cell[35163, 1265, 139, 3, 32, "NumberedFigureCaption",
   CellTags->"fig 2"]},
 "eq 1"->{
  Cell[44819, 1611, 1040, 40, 67, "NumberedEquation",
   CellTags->"eq 1"]},
 "Info3257348699-2143584"->{
  Cell[1592803, 31345, 768, 10, 155, "Print",
   CellTags->"Info3257348699-2143584"]},
 "ref 1"->{
  Cell[2498180, 47632, 373, 11, 32, "Text",
   CellTags->"ref 1"],
  Cell[2498556, 47645, 243, 5, 32, "Text",
   CellTags->"ref 1"]},
 "ref 4"->{
  Cell[2498802, 47652, 326, 10, 32, "Text",
   CellTags->"ref 4"],
  Cell[2499131, 47664, 317, 9, 32, "Text",
   CellTags->"ref 4"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"fig 2", 2502523, 47759},
 {"eq 1", 2502677, 47764},
 {"Info3257348699-2143584", 2502783, 47767},
 {"ref 1", 2502882, 47770},
 {"ref 4", 2503028, 47775}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 95, 2, 128, "Chapter"],
Cell[665, 26, 465, 12, 32, "Text"],
Cell[1133, 40, 659, 9, 41, "Commentary"],
Cell[CellGroupData[{
Cell[1817, 53, 57, 1, 37, "Input"],
Cell[1877, 56, 393, 7, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2307, 68, 39, 0, 56, "SubsectionIcon"],
Cell[2349, 70, 227, 5, 33, "Text"],
Cell[2579, 77, 52, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[2656, 81, 105, 2, 37, "Input"],
Cell[2764, 85, 210, 4, 29, "Print"]
}, Open  ]],
Cell[2989, 92, 60, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[3074, 96, 92, 2, 37, "Input"],
Cell[3169, 100, 5261, 144, 177, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[8479, 250, 60, 0, 37, "SubsectionIcon"],
Cell[8542, 252, 602, 9, 75, "Text"],
Cell[9147, 263, 2456, 81, 132, "Text"],
Cell[11606, 346, 1177, 46, 58, "Text"],
Cell[12786, 394, 14760, 613, 306, 12703, 578, "GraphicsData", "PostScript", \
"NumberedFigure"],
Cell[27549, 1009, 68, 1, 32, "Text",
 CellTags->"fig 2"],
Cell[27620, 1012, 1056, 34, 79, "Text"],
Cell[28679, 1048, 1112, 42, 68, "Text"],
Cell[29794, 1092, 37, 0, 32, "Text"],
Cell[29834, 1094, 912, 36, 61, "Text"],
Cell[30749, 1132, 121, 3, 32, "Text"],
Cell[30873, 1137, 1880, 79, 54, "Text"],
Cell[32756, 1218, 119, 4, 37, "Text"],
Cell[32878, 1224, 2282, 39, 511, "Text"],
Cell[35163, 1265, 139, 3, 32, "NumberedFigureCaption",
 CellTags->"fig 2"],
Cell[35305, 1270, 74, 0, 32, "Text"],
Cell[35382, 1272, 2549, 93, 91, "Text"],
Cell[37934, 1367, 35, 0, 32, "Text"],
Cell[37972, 1369, 733, 28, 32, "Text"],
Cell[38708, 1399, 20, 0, 32, "Text"],
Cell[38731, 1401, 942, 36, 93, "Text"],
Cell[39676, 1439, 148, 7, 41, "DisplayFormula"],
Cell[39827, 1448, 442, 17, 70, "Text"],
Cell[40272, 1467, 20, 0, 32, "Text"],
Cell[40295, 1469, 1377, 47, 83, "Text"],
Cell[41675, 1518, 408, 6, 54, "Text"],
Cell[42086, 1526, 1452, 49, 83, "Text"],
Cell[43541, 1577, 895, 18, 101, "Text"],
Cell[44439, 1597, 377, 12, 32, "Text"],
Cell[44819, 1611, 1040, 40, 67, "NumberedEquation",
 CellTags->"eq 1"],
Cell[45862, 1653, 67, 2, 32, "Text"],
Cell[45932, 1657, 741, 28, 34, "Text"],
Cell[46676, 1687, 225, 8, 32, "Text"],
Cell[46904, 1697, 742, 27, 34, "Text"],
Cell[47649, 1726, 1098, 43, 34, "Text"],
Cell[48750, 1771, 340, 6, 54, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[49127, 1782, 51, 0, 37, "SubsectionIcon"],
Cell[CellGroupData[{
Cell[49203, 1786, 58, 0, 33, "SubsubsectionIcon"],
Cell[49264, 1788, 114, 3, 32, "Text"],
Cell[49381, 1793, 5207, 223, 196, "NumberedFigure"],
Cell[54591, 2018, 775, 27, 54, "Text"],
Cell[55369, 2047, 270, 8, 64, "NumberedEquation"],
Cell[55642, 2057, 308, 11, 21, "Caption"],
Cell[CellGroupData[{
Cell[55975, 2072, 524, 16, 37, "Input"],
Cell[56502, 2090, 589, 15, 42, "Output"]
}, Open  ]],
Cell[57106, 2108, 661, 25, 32, "Text"],
Cell[57770, 2135, 287, 10, 21, "Caption"],
Cell[CellGroupData[{
Cell[58082, 2149, 197, 6, 37, "Input"],
Cell[58282, 2157, 599, 15, 42, "Output"]
}, Open  ]],
Cell[58896, 2175, 362, 13, 32, "Text"],
Cell[CellGroupData[{
Cell[59283, 2192, 262, 8, 37, "Input"],
Cell[59548, 2202, 467, 10, 38, "Output"]
}, Open  ]],
Cell[60030, 2215, 404, 17, 32, "Text"],
Cell[CellGroupData[{
Cell[60459, 2236, 114, 3, 37, "Input"],
Cell[60576, 2241, 499, 11, 38, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[61124, 2258, 58, 0, 25, "SubsubsectionIcon"],
Cell[61185, 2260, 771, 20, 56, "Text"],
Cell[61959, 2282, 1338, 49, 58, "Text"],
Cell[63300, 2333, 115, 4, 21, "Caption"],
Cell[CellGroupData[{
Cell[63440, 2341, 370, 11, 37, "Input"],
Cell[63813, 2354, 583, 14, 59, "Output"]
}, Open  ]],
Cell[64411, 2371, 241, 9, 32, "Text"],
Cell[64655, 2382, 201, 7, 33, "Text"],
Cell[64859, 2391, 99, 2, 20, "Caption"],
Cell[CellGroupData[{
Cell[64983, 2397, 238, 6, 37, "Input"],
Cell[65224, 2405, 441, 9, 59, "Output"]
}, Open  ]],
Cell[65680, 2417, 142, 5, 20, "Caption"],
Cell[CellGroupData[{
Cell[65847, 2426, 152, 4, 37, "Input"],
Cell[66002, 2432, 380, 6, 35, "Output"]
}, Open  ]],
Cell[66397, 2441, 400, 14, 34, "Text"],
Cell[66800, 2457, 125, 3, 20, "Caption"],
Cell[CellGroupData[{
Cell[66950, 2464, 238, 7, 37, "Input"],
Cell[67191, 2473, 2966, 60, 350, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[70206, 2539, 47, 0, 25, "SubsubsectionIcon"],
Cell[70256, 2541, 240, 5, 32, "Text"],
Cell[70499, 2548, 825, 29, 34, "Text"],
Cell[71327, 2579, 56, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[71408, 2583, 148, 4, 37, "Input"],
Cell[71559, 2589, 380, 6, 35, "Output"]
}, Open  ]],
Cell[71954, 2598, 255, 12, 20, "Caption"],
Cell[CellGroupData[{
Cell[72234, 2614, 282, 8, 37, "Input"],
Cell[72519, 2624, 456, 10, 35, "Output"]
}, Open  ]],
Cell[72990, 2637, 53, 0, 32, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[73080, 2642, 72, 0, 25, "SubsubsectionIcon"],
Cell[73155, 2644, 639, 24, 34, "Text"],
Cell[73797, 2670, 306, 12, 33, "Text"],
Cell[CellGroupData[{
Cell[74128, 2686, 500, 14, 37, "Input"],
Cell[74631, 2702, 478, 8, 35, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[75158, 2716, 43, 0, 25, "SubsubsectionIcon"],
Cell[75204, 2718, 302, 9, 32, "Text",
 Evaluatable->False],
Cell[75509, 2729, 6768, 300, 121, 5577, 278, "GraphicsData", "PostScript", \
"NumberedFigure"],
Cell[82280, 3031, 1589, 55, 75, "Text"],
Cell[83872, 3088, 318, 11, 41, "NumberedEquation"],
Cell[84193, 3101, 665, 27, 32, "Text"],
Cell[84861, 3130, 322, 11, 37, "Input"],
Cell[85186, 3143, 371, 16, 32, "Text"],
Cell[CellGroupData[{
Cell[85582, 3163, 277, 8, 37, "Input"],
Cell[85862, 3173, 833, 22, 59, "Output"]
}, Open  ]],
Cell[86710, 3198, 79, 0, 20, "Caption"],
Cell[CellGroupData[{
Cell[86814, 3202, 251, 8, 37, "Input"],
Cell[87068, 3212, 577, 15, 47, "Output"]
}, Open  ]],
Cell[87660, 3230, 608, 24, 32, "Text"],
Cell[88271, 3256, 256, 9, 21, "Caption"],
Cell[88530, 3267, 250, 8, 20, "Caption"],
Cell[CellGroupData[{
Cell[88805, 3279, 549, 16, 37, "Input"],
Cell[89357, 3297, 3037, 62, 194, "Output"]
}, Open  ]],
Cell[92409, 3362, 596, 18, 52, "Text"],
Cell[93008, 3382, 136, 6, 20, "Caption"],
Cell[93147, 3390, 253, 9, 37, "Input"],
Cell[93403, 3401, 115, 3, 20, "Caption"],
Cell[CellGroupData[{
Cell[93543, 3408, 277, 8, 37, "Input"],
Cell[93823, 3418, 632, 16, 55, "Output"]
}, Open  ]],
Cell[94470, 3437, 534, 20, 20, "Caption"],
Cell[CellGroupData[{
Cell[95029, 3461, 454, 15, 37, "Input"],
Cell[95486, 3478, 812, 23, 61, "Output"]
}, Open  ]],
Cell[96313, 3504, 607, 23, 32, "Text"],
Cell[96923, 3529, 607, 23, 21, "Caption"],
Cell[97533, 3554, 463, 15, 65, "Input"],
Cell[97999, 3571, 227, 10, 20, "Caption"],
Cell[CellGroupData[{
Cell[98251, 3585, 487, 14, 37, "Input"],
Cell[98741, 3601, 3794, 74, 354, "Output"]
}, Open  ]],
Cell[102550, 3678, 699, 27, 32, "Text"],
Cell[103252, 3707, 128, 3, 20, "Caption"],
Cell[103383, 3712, 732, 23, 37, "Input"],
Cell[104118, 3737, 233, 8, 37, "Input"],
Cell[104354, 3747, 519, 16, 37, "Input"],
Cell[104876, 3765, 485, 16, 37, "Input"],
Cell[105364, 3783, 463, 15, 65, "Input"],
Cell[CellGroupData[{
Cell[105852, 3802, 591, 16, 37, "Input"],
Cell[106446, 3820, 7920, 141, 343, "Output"]
}, Open  ]],
Cell[114381, 3964, 250, 6, 37, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[114680, 3976, 53, 0, 37, "SubsectionIcon"],
Cell[114736, 3978, 496, 13, 33, "Text"],
Cell[CellGroupData[{
Cell[115257, 3995, 72, 0, 33, "SubsubsectionIcon"],
Cell[115332, 3997, 372, 6, 81, "Text"],
Cell[115707, 4005, 11154, 455, 580, "Text"],
Cell[126864, 4462, 595, 22, 48, "Text"],
Cell[127462, 4486, 410, 12, 96, "NumberedEquation"],
Cell[127875, 4500, 388, 12, 96, "NumberedEquation"],
Cell[128266, 4514, 354, 9, 81, "Text"],
Cell[128623, 4525, 346, 11, 96, "NumberedEquation"],
Cell[128972, 4538, 448, 15, 136, "NumberedEquation"],
Cell[129423, 4555, 764, 23, 124, "Text"],
Cell[130190, 4580, 844, 34, 138, "NumberedEquation"],
Cell[131037, 4616, 262, 5, 85, "MathCaption"],
Cell[131302, 4623, 64, 0, 48, "Text"],
Cell[CellGroupData[{
Cell[131391, 4627, 362, 11, 55, "Input"],
Cell[131756, 4640, 962, 24, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132755, 4669, 612, 20, 55, "Input"],
Cell[133370, 4691, 859, 23, 63, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134266, 4719, 1140, 31, 97, "Input"],
Cell[135409, 4752, 32543, 587, 528, "Output"]
}, Open  ]],
Cell[167967, 5342, 122, 3, 55, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[168126, 5350, 46, 0, 25, "SubsubsectionIcon"],
Cell[168175, 5352, 915, 35, 55, "Text"],
Cell[169093, 5389, 13239, 551, 281, 11072, 513, "GraphicsData", "PostScript", \
"NumberedFigure"],
Cell[182335, 5942, 65, 0, 32, "Text"],
Cell[182403, 5944, 1920, 76, 103, "NumberedEquation"],
Cell[184326, 6022, 898, 41, 93, "Text"],
Cell[185227, 6065, 64, 0, 32, "Text"],
Cell[185294, 6067, 446, 14, 37, "Input"],
Cell[185743, 6083, 153, 7, 32, "Text"],
Cell[CellGroupData[{
Cell[185921, 6094, 297, 9, 37, "Input"],
Cell[186221, 6105, 2047, 58, 127, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188305, 6168, 356, 10, 37, "Input"],
Cell[188664, 6180, 1392, 34, 42, "Output"]
}, Open  ]],
Cell[190071, 6217, 163, 7, 32, "Text"],
Cell[CellGroupData[{
Cell[190259, 6228, 400, 11, 37, "Input"],
Cell[190662, 6241, 2142, 61, 127, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[192841, 6307, 309, 9, 37, "Input"],
Cell[193153, 6318, 3766, 95, 74, "Output"]
}, Open  ]],
Cell[196934, 6416, 344, 11, 32, "Text"],
Cell[197281, 6429, 410, 13, 37, "Input"],
Cell[197694, 6444, 62, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[197781, 6448, 385, 13, 37, "Input"],
Cell[198169, 6463, 12765, 314, 533, "Output"]
}, Open  ]],
Cell[210949, 6780, 54, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[211028, 6784, 280, 9, 37, "Input"],
Cell[211311, 6795, 7384, 133, 361, "Output"]
}, Open  ]],
Cell[218710, 6931, 180, 5, 37, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[218927, 6941, 66, 0, 25, "SubsubsectionIcon"],
Cell[218996, 6943, 67, 0, 32, "Text"],
Cell[219066, 6945, 15229, 635, 300, 13080, 597, "GraphicsData", "PostScript", \
"Text"],
Cell[234298, 7582, 110, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[234433, 7587, 529, 15, 37, "Input"],
Cell[234965, 7604, 990, 26, 58, "Output"]
}, Open  ]],
Cell[235970, 7633, 34, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[236029, 7637, 297, 9, 37, "Input"],
Cell[236329, 7648, 2193, 63, 127, "Output"]
}, Open  ]],
Cell[238537, 7714, 56, 0, 32, "Text"],
Cell[238596, 7716, 705, 28, 32, "EquationNumber"],
Cell[239304, 7746, 21, 0, 32, "Text"],
Cell[239328, 7748, 1472, 58, 55, "Text"],
Cell[240803, 7808, 831, 35, 34, "Text"],
Cell[241637, 7845, 1004, 42, 59, "Text"],
Cell[CellGroupData[{
Cell[242666, 7891, 953, 28, 37, "Input"],
Cell[243622, 7921, 1215, 28, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[244874, 7954, 288, 9, 37, "Input"],
Cell[245165, 7965, 4726, 91, 350, "Output"]
}, Open  ]],
Cell[249906, 8059, 141, 4, 37, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[250096, 8069, 50, 0, 37, "SubsectionIcon"],
Cell[250149, 8071, 465, 7, 54, "Text"],
Cell[CellGroupData[{
Cell[250639, 8082, 64, 0, 33, "SubsubsectionIcon"],
Cell[250706, 8084, 517, 14, 83, "Text"],
Cell[251226, 8100, 11081, 474, 120, 9447, 444, "GraphicsData", "PostScript", \
"Text"],
Cell[262310, 8576, 265, 10, 32, "Text"],
Cell[262578, 8588, 952, 52, 109, "NumberedEquation"],
Cell[263533, 8642, 972, 38, 32, "Text"],
Cell[CellGroupData[{
Cell[264530, 8684, 514, 15, 37, "Input"],
Cell[265047, 8701, 1086, 28, 82, "Output"]
}, Open  ]],
Cell[266148, 8732, 88, 1, 32, "Text"],
Cell[266239, 8735, 405, 11, 37, "Input"],
Cell[CellGroupData[{
Cell[266669, 8750, 122, 3, 37, "Input"],
Cell[266794, 8755, 2684, 78, 176, "Output"]
}, Open  ]],
Cell[269493, 8836, 41, 0, 32, "Text"],
Cell[269537, 8838, 874, 29, 37, "Input"],
Cell[270414, 8869, 831, 35, 32, "Text"],
Cell[271248, 8906, 268, 6, 20, "Caption"],
Cell[CellGroupData[{
Cell[271541, 8916, 1654, 43, 92, "Input"],
Cell[273198, 8961, 38120, 695, 350, "Output"]
}, Open  ]],
Cell[311333, 9659, 173, 5, 37, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[311543, 9669, 71, 0, 25, "SubsubsectionIcon"],
Cell[311617, 9671, 432, 10, 54, "Text"],
Cell[312052, 9683, 14498, 620, 175, 12691, 588, "GraphicsData", "PostScript", \
"NumberedFigure"],
Cell[326553, 10305, 52, 0, 32, "Text"],
Cell[326608, 10307, 1739, 65, 103, "NumberedEquation"],
Cell[328350, 10374, 722, 26, 54, "Text"],
Cell[CellGroupData[{
Cell[329097, 10404, 754, 25, 37, "Input"],
Cell[329854, 10431, 456, 10, 35, "Output"],
Cell[330313, 10443, 170, 6, 35, "Output"]
}, Open  ]],
Cell[330498, 10452, 326, 14, 33, "Text"],
Cell[CellGroupData[{
Cell[330849, 10470, 491, 17, 37, "Input"],
Cell[331343, 10489, 2998, 61, 336, "Output"]
}, Open  ]],
Cell[334356, 10553, 665, 24, 32, "Text"],
Cell[335024, 10579, 114, 5, 20, "Caption"],
Cell[CellGroupData[{
Cell[335163, 10588, 220, 8, 37, "Input"],
Cell[335386, 10598, 509, 12, 63, "Output"]
}, Open  ]],
Cell[335910, 10613, 61, 0, 32, "Text"],
Cell[335974, 10615, 290, 11, 32, "Text"],
Cell[336267, 10628, 1504, 55, 83, "NumberedEquation"],
Cell[337774, 10685, 385, 17, 32, "Text"],
Cell[338162, 10704, 292, 14, 32, "Text"],
Cell[338457, 10720, 1669, 63, 83, "NumberedEquation"],
Cell[340129, 10785, 1156, 51, 32, "Text"],
Cell[341288, 10838, 524, 22, 32, "Text"],
Cell[341815, 10862, 790, 28, 41, "Caption"],
Cell[342608, 10892, 485, 15, 37, "Input"],
Cell[343096, 10909, 53, 0, 56, "MathCaption"],
Cell[343152, 10911, 1276, 42, 37, "Input"],
Cell[CellGroupData[{
Cell[344453, 10957, 1237, 38, 65, "Input"],
Cell[345693, 10997, 3250, 97, 165, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[348980, 11099, 377, 11, 37, "Input"],
Cell[349360, 11112, 13219, 233, 347, "Output"]
}, Open  ]],
Cell[362594, 11348, 1199, 49, 60, "Caption"],
Cell[363796, 11399, 1879, 58, 65, "Input"],
Cell[365678, 11459, 1093, 34, 66, "Input"],
Cell[366774, 11495, 1242, 47, 77, "Text"],
Cell[368019, 11544, 261, 6, 21, "Caption"],
Cell[368283, 11552, 464, 15, 66, "Input"],
Cell[368750, 11569, 464, 15, 66, "Input"],
Cell[369217, 11586, 464, 15, 66, "Input"],
Cell[369684, 11603, 73, 0, 56, "MathCaption"],
Cell[CellGroupData[{
Cell[369782, 11607, 459, 14, 37, "Input"],
Cell[370244, 11623, 44173, 739, 347, "Output"]
}, Open  ]],
Cell[414432, 12365, 194, 6, 37, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[414663, 12376, 55, 0, 25, "SubsubsectionIcon"],
Cell[414721, 12378, 490, 8, 54, "Text"],
Cell[415214, 12388, 15902, 683, 183, 14097, 650, "GraphicsData", \
"PostScript", "NumberedFigure"],
Cell[CellGroupData[{
Cell[431141, 13075, 653, 19, 37, "Input"],
Cell[431797, 13096, 1114, 28, 82, "Output"],
Cell[432914, 13126, 487, 17, 35, "Output"]
}, Open  ]],
Cell[433416, 13146, 120, 1, 32, "Text"],
Cell[433539, 13149, 367, 11, 37, "Input"],
Cell[CellGroupData[{
Cell[433931, 13164, 122, 3, 37, "Input"],
Cell[434056, 13169, 2914, 84, 176, "Output"]
}, Open  ]],
Cell[436985, 13256, 756, 29, 32, "Text",
 Evaluatable->False],
Cell[437744, 13287, 76, 0, 32, "Text"],
Cell[437823, 13289, 705, 28, 41, "DisplayFormula"],
Cell[438531, 13319, 20, 0, 32, "Text"],
Cell[438554, 13321, 1555, 65, 88, "DisplayFormula"],
Cell[440112, 13388, 234, 10, 36, "Text"],
Cell[440349, 13400, 963, 33, 41, "DisplayFormula"],
Cell[441315, 13435, 643, 25, 32, "Text"],
Cell[441961, 13462, 1540, 58, 58, "Text"],
Cell[443504, 13522, 411, 11, 34, "Text",
 Evaluatable->False],
Cell[443918, 13535, 782, 24, 58, "Text"],
Cell[444703, 13561, 485, 12, 37, "Input"],
Cell[CellGroupData[{
Cell[445213, 13577, 747, 23, 37, "Input"],
Cell[445963, 13602, 2177, 49, 74, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[448177, 13656, 1176, 32, 92, "Input"],
Cell[449356, 13690, 24335, 465, 366, "Output"]
}, Open  ]],
Cell[473706, 14158, 213, 6, 37, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[473968, 14170, 58, 0, 37, "SubsectionIcon"],
Cell[474029, 14172, 117, 3, 32, "Text"],
Cell[474149, 14177, 2282, 39, 511, "Text"],
Cell[476434, 14218, 67, 0, 32, "Text"],
Cell[476504, 14220, 2537, 91, 84, "NumberedEquation"],
Cell[479044, 14313, 35, 0, 32, "Text"],
Cell[479082, 14315, 750, 30, 41, "DisplayFormula"],
Cell[479835, 14347, 20, 0, 32, "Text"],
Cell[479858, 14349, 1015, 40, 131, "DisplayFormula"],
Cell[480876, 14391, 1279, 37, 65, "Input"],
Cell[CellGroupData[{
Cell[482180, 14432, 87, 2, 37, "Input"],
Cell[482270, 14436, 1667, 46, 101, "Output"]
}, Open  ]],
Cell[483952, 14485, 48, 0, 32, "Text"],
Cell[484003, 14487, 244, 8, 37, "Input"],
Cell[484250, 14497, 28, 0, 32, "Text"],
Cell[484281, 14499, 239, 8, 37, "Input"],
Cell[484523, 14509, 118, 1, 32, "Text"],
Cell[484644, 14512, 217, 7, 37, "Input"],
Cell[CellGroupData[{
Cell[484886, 14523, 122, 3, 37, "Input"],
Cell[485011, 14528, 3870, 113, 176, "Output"]
}, Open  ]],
Cell[488896, 14644, 1261, 51, 32, "Text"],
Cell[490160, 14697, 704, 20, 37, "Input"],
Cell[490867, 14719, 36, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[490928, 14723, 961, 30, 37, "Input"],
Cell[491892, 14755, 3306, 80, 101, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[495235, 14840, 1049, 29, 65, "Input"],
Cell[496287, 14871, 162375, 2730, 360, "Output"]
}, Open  ]],
Cell[658677, 17604, 191, 5, 37, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[658905, 17614, 54, 0, 37, "SubsectionIcon"],
Cell[658962, 17616, 132, 3, 32, "Text"],
Cell[659097, 17621, 835682, 11615, 822, 789209, 10851, "GraphicsData", \
"PostScript", "Text"],
Cell[1494782, 29238, 62, 0, 32, "Text"],
Cell[1494847, 29240, 1131, 34, 435, "Text"],
Cell[1495981, 29276, 152, 3, 32, "Text"],
Cell[1496136, 29281, 2796, 52, 651, "Text"],
Cell[1498935, 29335, 701, 17, 71, "Text"],
Cell[1499639, 29354, 76, 0, 32, "Text"],
Cell[1499718, 29356, 2852, 73, 173, "Input"],
Cell[1502573, 29431, 136, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[1502734, 29438, 765, 23, 37, "Input"],
Cell[1503502, 29463, 5839, 140, 185, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1509378, 29608, 314, 9, 37, "Input"],
Cell[1509695, 29619, 17833, 416, 324, "Output"]
}, Open  ]],
Cell[1527543, 30038, 141, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[1527709, 30045, 908, 26, 65, "Input"],
Cell[1528620, 30073, 5251, 123, 157, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1533908, 30201, 321, 9, 37, "Input"],
Cell[1534232, 30212, 20777, 469, 339, "Output"]
}, Open  ]],
Cell[1555024, 30684, 237, 6, 37, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1555298, 30695, 45, 0, 37, "SubsectionIcon"],
Cell[1555346, 30697, 16066, 204, 433, "Text"],
Cell[1571415, 30903, 208, 6, 35, "Text"],
Cell[1571626, 30911, 759, 28, 37, "Input"],
Cell[CellGroupData[{
Cell[1572410, 30943, 476, 12, 37, "Input"],
Cell[1572889, 30957, 16911, 290, 347, "Output"]
}, Open  ]],
Cell[1589815, 31250, 564, 17, 35, "Text"],
Cell[1590382, 31269, 1402, 39, 67, "Input"],
Cell[1591787, 31310, 47, 0, 32, "Text"],
Cell[1591837, 31312, 166, 5, 37, "Input"],
Cell[1592006, 31319, 169, 5, 37, "Input"],
Cell[1592178, 31326, 622, 17, 38, "Text"],
Cell[1592803, 31345, 768, 10, 155, "Print",
 CellTags->"Info3257348699-2143584"],
Cell[CellGroupData[{
Cell[1593596, 31359, 289, 7, 37, "Input"],
Cell[1593888, 31368, 51096, 977, 204, "Output"]
}, Open  ]],
Cell[1644999, 32348, 53, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[1645077, 32352, 346, 8, 37, "Input"],
Cell[1645426, 32362, 51100, 977, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1696563, 33344, 617, 20, 37, "Input"],
Cell[1697183, 33366, 50528, 965, 204, "Output"]
}, Open  ]],
Cell[1747726, 34334, 115, 1, 32, "Text"],
Cell[CellGroupData[{
Cell[1747866, 34339, 1084, 31, 65, "Input"],
Cell[1748953, 34372, 276421, 4624, 363, "Output"]
}, Open  ]],
Cell[2025389, 38999, 53, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[2025467, 39003, 469, 13, 37, "Input"],
Cell[2025939, 39018, 3231, 61, 525, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2029219, 39085, 109, 1, 37, "SubsectionIcon"],
Cell[CellGroupData[{
Cell[2029353, 39090, 67, 0, 33, "SubsubsectionIcon"],
Cell[2029423, 39092, 155, 3, 32, "Text"],
Cell[2029581, 39097, 533, 24, 59, "NumberedEquation"],
Cell[2030117, 39123, 852, 29, 33, "Text"],
Cell[CellGroupData[{
Cell[2030994, 39156, 1058, 33, 67, "Input"],
Cell[2032055, 39191, 805, 20, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2032897, 39216, 263, 7, 37, "Input"],
Cell[2033163, 39225, 11269, 197, 347, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2044481, 39428, 65, 0, 25, "SubsubsectionIcon"],
Cell[2044549, 39430, 108, 3, 37, "Input"],
Cell[2044660, 39435, 86, 2, 32, "Text"],
Cell[2044749, 39439, 1135, 56, 106, "NumberedEquation"],
Cell[2045887, 39497, 39, 0, 32, "Text"],
Cell[2045929, 39499, 340, 10, 37, "Input"],
Cell[CellGroupData[{
Cell[2046294, 39513, 565, 19, 67, "Input"],
Cell[2046862, 39534, 1030, 25, 61, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2047929, 39564, 362, 12, 37, "Input"],
Cell[2048294, 39578, 906, 21, 35, "Output"]
}, Open  ]],
Cell[2049215, 39602, 46, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[2049286, 39606, 628, 17, 37, "Input"],
Cell[2049917, 39625, 24471, 470, 100, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2074425, 40100, 1194, 29, 37, "Input"],
Cell[2075622, 40131, 27111, 513, 347, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2102794, 40651, 251, 4, 37, "SubsectionIcon"],
Cell[2103048, 40657, 145, 3, 37, "Input"],
Cell[2103196, 40662, 115, 3, 32, "Abstract"],
Cell[2103314, 40667, 790, 29, 69, "NumberedEquation"],
Cell[2104107, 40698, 286, 10, 41, "Commentary"],
Cell[2104396, 40710, 74, 0, 32, "Text"],
Cell[2104473, 40712, 509, 16, 62, "Text"],
Cell[2104985, 40730, 118, 5, 32, "Text"],
Cell[2105106, 40737, 660, 23, 41, "NumberedEquation"],
Cell[2105769, 40762, 34, 0, 32, "Text"],
Cell[2105806, 40764, 145, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[2105976, 40771, 277, 9, 37, "Input"],
Cell[2106256, 40782, 655, 16, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2106948, 40803, 660, 22, 37, "Input"],
Cell[2107611, 40827, 1299, 37, 38, "Output"]
}, Open  ]],
Cell[2108925, 40867, 163, 3, 32, "Text"],
Cell[CellGroupData[{
Cell[2109113, 40874, 376, 12, 37, "Input"],
Cell[2109492, 40888, 576, 13, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2110105, 40906, 1583, 53, 68, "Input"],
Cell[2111691, 40961, 1018, 31, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2112746, 40997, 249, 8, 37, "Input"],
Cell[2112998, 41007, 1150, 35, 38, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2114185, 41047, 166, 5, 37, "Input"],
Cell[2114354, 41054, 407, 6, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2114798, 41065, 756, 24, 37, "Input"],
Cell[2115557, 41091, 2354, 65, 65, "Output"]
}, Open  ]],
Cell[2117926, 41159, 319, 10, 32, "Text"],
Cell[2118248, 41171, 536, 14, 37, "Input"],
Cell[CellGroupData[{
Cell[2118809, 41189, 684, 19, 37, "Input"],
Cell[2119496, 41210, 1319, 34, 117, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2120852, 41249, 376, 10, 37, "Input"],
Cell[2121231, 41261, 1164, 29, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2122432, 41295, 212, 7, 37, "Input"],
Cell[2122647, 41304, 891, 23, 57, "Output"]
}, Open  ]],
Cell[2123553, 41330, 307, 10, 33, "Text"],
Cell[CellGroupData[{
Cell[2123885, 41344, 404, 12, 37, "Input"],
Cell[2124292, 41358, 1258, 34, 115, "Output"]
}, Open  ]],
Cell[2125565, 41395, 846, 27, 124, "Input"],
Cell[2126414, 41424, 537, 12, 56, "Text"],
Cell[2126954, 41438, 433, 14, 33, "Text"],
Cell[CellGroupData[{
Cell[2127412, 41456, 872, 25, 37, "Input"],
Cell[2128287, 41483, 54836, 914, 378, "Output"]
}, Open  ]],
Cell[2183138, 42400, 69, 0, 32, "Text"],
Cell[CellGroupData[{
Cell[2183232, 42404, 764, 23, 37, "Input"],
Cell[2183999, 42429, 168306, 2750, 461, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2352342, 45184, 763, 23, 37, "Input"],
Cell[2353108, 45209, 142825, 2338, 461, "Output"]
}, Open  ]],
Cell[2495948, 47550, 82, 2, 37, "Input"],
Cell[2496033, 47554, 141, 5, 32, "Text"],
Cell[2496177, 47561, 775, 26, 124, "Input"],
Cell[CellGroupData[{
Cell[2496977, 47591, 695, 24, 37, "Input"],
Cell[2497675, 47617, 417, 7, 35, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2498141, 47630, 36, 0, 37, "SubsectionIcon"],
Cell[2498180, 47632, 373, 11, 32, "Text",
 CellTags->"ref 1"],
Cell[2498556, 47645, 243, 5, 32, "Text",
 CellTags->"ref 1"],
Cell[2498802, 47652, 326, 10, 32, "Text",
 CellTags->"ref 4"],
Cell[2499131, 47664, 317, 9, 32, "Text",
 CellTags->"ref 4"],
Cell[2499451, 47675, 1007, 16, 134, "Text"]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
