(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    329352,       8521]
NotebookOptionsPosition[    315126,       8084]
NotebookOutlinePosition[    316438,       8131]
CellTagsIndexPosition[    316314,       8124]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Model Fitting", "Chapter"],

Cell[TextData[{
 StyleBox["Author",
  FontWeight->"Bold"],
 ": Guillermo Sanchez:  ",
 StyleBox["guillermo@usal.es,",
  FontColor->RGBColor[0, 0, 1]],
 ButtonBox[" http://diarium.usal.es/guillermo",
  BaseStyle->"Hyperlink",
  ButtonData->{" http://diarium.usal.es/guillermo", None}]
}], "Text",
 CellChangeTimes->{{3.3992809464453416`*^9, 3.3992809874687996`*^9}, {
  3.587197771507521*^9, 3.5871978067800255`*^9}}],

Cell["Last updated:  2015-09-07", "Commentary",
 CellChangeTimes->{{3.39928025384801*^9, 3.399280259603493*^9}, {
  3.4228525171714554`*^9, 3.4228525382666454`*^9}, {3.422936332120079*^9, 
  3.422936340401223*^9}, {3.442218589593443*^9, 3.4422185944372244`*^9}, {
  3.479816247027495*^9, 3.4798162579804096`*^9}, {3.513395822423673*^9, 
  3.513395880159526*^9}, {3.5194424638825874`*^9, 3.5194424703202105`*^9}, {
  3.5405366769990454`*^9, 3.540536682686655*^9}, {3.5871977532521152`*^9, 
  3.587197763785323*^9}, {3.642762204406968*^9, 3.64276223215701*^9}, {
  3.643526064229377*^9, 3.6435260760419235`*^9}, {3.6506084525061693`*^9, 
  3.6506084569905467`*^9}}],

Cell["The author will appreciate any comments. ", "Text"],

Cell[CellGroupData[{

Cell[BoxData["$Version"], "Input",
 CellLabel->"In[3]:="],

Cell[BoxData[
 FormBox["\<\"10.2.0 for Microsoft Windows (64-bit) (July 28, 2015)\"\>", 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990287919396353`*^9, 3.399029659444124*^9, 
  3.3990297163980336`*^9, 3.479816773251766*^9, 3.4798175061439443`*^9, 
  3.4798259229435167`*^9, 3.4802427664000235`*^9, 3.5194424014438887`*^9, 
  3.539925864973983*^9, 3.540536733015746*^9, 3.5871963391506443`*^9, 
  3.64276230425081*^9, 3.642762396594714*^9, 3.643525980572754*^9, 
  3.650608059865262*^9},
 CellLabel->"Out[3]="]
}, Open  ]],

Cell[TextData[{
 StyleBox["Fitmodel", "Input"],
 StyleBox[" package is applied for fitting ",
  FontFamily->"Times New Roman"],
 ". ",
 StyleBox["Fitmodel", "Input"],
 StyleBox[" ",
  FontWeight->"Bold"],
 "is included in ",
 StyleBox["Biokmod",
  FontSlant->"Italic"],
 ". ",
 StyleBox["Biokmod",
  FontWeight->"Bold",
  FontSlant->"Italic"],
 " is a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Toolbox for solving compartmental and physiological models, for fitting \
parameters, optimal desingn, and convolution-deconvolution. It can be applied \
in Medicine, Pharmacology and Radioprotection. "
}], "Commentary",
 CellChangeTimes->{{3.3990299175917997`*^9, 3.3990299185486703`*^9}, {
  3.399029952133253*^9, 3.399029952572472*^9}}],

Cell[CellGroupData[{

Cell["INICIALIZATION", "SubsubsectionIcon"],

Cell["Load the Biokmod packages ", "Text"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Biokmod`SysModel`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellLabel->"In[4]:="],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Biokmod`Fitmodel`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellLabel->"In[5]:="]
}, Open  ]],

Cell[CellGroupData[{

Cell["The package Fitmodel functions", "SubsectionIcon"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\"\<Biokmod`Fitmodel`*\>\""}]], "Input",
 CellLabel->"In[6]:="],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Biokmod`Fitmodel`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Biokmod`Fitmodel`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["BioassayBestfit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "BioassayBestfit", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["LungBioassayEvaluation",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "LungBioassayEvaluation", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["MLFit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "MLFit", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["Svu",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "Svu", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["UrineBioassayEvaluation",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "UrineBioassayEvaluation", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["X2FitE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "X2FitE", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"]},
        {
         ButtonBox["BioassayFit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "BioassayFit", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["LungUAccidentalIntake",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "LungUAccidentalIntake", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["MLFitLog",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "MLFitLog", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["Uin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "Uin", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], 
         ButtonBox["X2Fit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-395b049a-b194-4c09-8402-2fc72fd9ee22", {
            "X2Fit", "Biokmod`Fitmodel`"}},
          ButtonNote->"Biokmod`Fitmodel`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6506080605527506`*^9}]
}, Open  ]],

Cell[TextData[{
 "In biokinetic model we can find situations where we have two or more \
response functions with some parameters to be fitted using experimental data, \
 that is  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["y", "1"], "(", 
    RowBox[{"a", ",", "b", ",", "c", ",", "..", ",", 
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", "..."}], ")"}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["y", "2"], "(", 
    RowBox[{"a", ",", "b", ",", "c", ",", "..", ",", 
     SubscriptBox["x", "1"], ",", 
     SubscriptBox["x", "2"], ",", "..."}], ")"}], TraditionalForm]]],
 ", .... The package ",
 StyleBox["Fitmodel", "Input"],
 " has some functions for fitting parameters in these cases Multiple Response \
Fit. "
}], "Text"],

Cell[TextData[{
 "The package can also be applied for single response fit problems. If the \
uncertainties of measured is not given  usually is better to apply the \
functions included in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  "
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   StyleBox[
    SubscriptBox["data", "i"],
    FontSlant->"Italic"], " ", "=", 
   RowBox[{Cell[TextData[{
     StyleBox["{{", "MR"],
     Cell[BoxData[
      FormBox[
       SubscriptBox["t", "i1"], TraditionalForm]], "InlineFormula"],
     StyleBox[",", "MR"],
     " ",
     Cell[BoxData[
      FormBox[
       SubscriptBox["Y", "i1"], TraditionalForm]], "InlineFormula"],
     StyleBox["},", "MR"],
     " ",
     StyleBox["{", "MR"],
     Cell[BoxData[
      FormBox[
       SubscriptBox["t", "i2"], TraditionalForm]], "InlineFormula"],
     StyleBox[",", "MR"],
     " ",
     Cell[BoxData[
      FormBox[
       SubscriptBox["Y", "i2"], TraditionalForm]], "InlineFormula"],
     StyleBox["},", "MR"],
     " \[Ellipsis] ",
     StyleBox["}", "MR"],
     " "
    }]], "represents", " ", "the", " ", "experimental", " ", "data", "  ", 
    SubscriptBox["Y", "i"], " ", "taken", " ", "at", " ", "time", " ", 
    RowBox[{
     SubscriptBox["t", "i"], ".", " ", "It"}], " ", "is", " ", "the", " ", 
    "format", " ", "used", " ", "by", " ", "in", " ", 
    RowBox[{
     StyleBox["FX2FitE", "MR"], 
     StyleBox[".", "MR"], " "}]}]}], TraditionalForm]], "Commentary",
 GridBoxOptions->{
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.27999999999999997`], {
      Offset[0.5599999999999999]}, 
     Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.16]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}},
 CellTags->"S3.8.2"],

Cell[BoxData[
 FormBox[
  RowBox[{
   StyleBox[
    SubscriptBox["data", "i"],
    FontSlant->"Italic"], " ", "=", " ", 
   RowBox[{Cell[TextData[{
     StyleBox["{{", "MR"],
     Cell[BoxData[
      FormBox[
       SubscriptBox["t", "i1"], TraditionalForm]], "InlineFormula"],
     StyleBox[",", "MR"],
     " ",
     Cell[BoxData[
      FormBox[
       RowBox[{
        SubscriptBox["Y", "i1"], ",", " ", 
        SubscriptBox["u", "i1"]}], TraditionalForm]], "InlineFormula"],
     StyleBox["},", "MR"],
     " ",
     StyleBox["{", "MR"],
     Cell[BoxData[
      FormBox[
       SubscriptBox["t", "i2"], TraditionalForm]], "InlineFormula"],
     StyleBox[",", "MR"],
     " ",
     Cell[BoxData[
      FormBox[
       SubscriptBox["Y", "i2"], TraditionalForm]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      FormBox[
       RowBox[{" ", 
        SubscriptBox["u", "i2"]}], TraditionalForm]]],
     StyleBox["},", "MR"],
     " \[Ellipsis] ",
     StyleBox["}", "MR"]
    }]], "  ", "represents", " ", "the", " ", "experimental", " ", "data", "  ",
     "the", " ", "experimental", " ", "data", "  ", 
    SubscriptBox["Y", "i"], " ", "with", " ", "uncertainty", " ", 
    SubscriptBox["u", "i"], " ", "taken", " ", "at", " ", "time", " ", 
    SubscriptBox["t", "i"], "  ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "It", " ", "is", " ", "the", " ", "format", " ", "used", " ", "by", 
        " ", 
        StyleBox["X2Fit", "MR"]}], 
       StyleBox[",", "MR"], 
       RowBox[{
        StyleBox["MLFitE", "MR"], "  ", "and", "  ", 
        StyleBox["MLFitELog", "MR"]}]}], 
      StyleBox[")", "MR"]}], "."}]}]}], TraditionalForm]], "Commentary",
 GridBoxOptions->{
 GridBoxDividers->{
  "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
   "RowsIndexed" -> {}},
 GridBoxSpacings->{"Columns" -> {
     Offset[0.27999999999999997`], {
      Offset[0.5599999999999999]}, 
     Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.16]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}},
 CellTags->"S3.8.2"],

Cell[TextData[{
 "The  ",
 StyleBox["X2FitE", "MR"],
 " function minimizes",
 Cell[BoxData[
  FormBox[
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", " ", "1"}], "N"], 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["F", "i"], " ", "-", " ", 
        SubscriptBox["Y", "i"]}], ")"}], "2"], 
     SubsuperscriptBox["s", "i", "2"]]}], TraditionalForm]]],
 "where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "i"], TraditionalForm]]],
 " denotes the values of the  functions",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["F", "i"],
      TraditionalForm], "(", 
     RowBox[{"a", ",", " ", "t"}], ")"}], " "}], TraditionalForm]]],
 " associated with measurement ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["s", "i"], TraditionalForm]]],
 " is the uncertainty (1 s) of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 "."
}], "Text"],

Cell[TextData[{
 StyleBox["X2FitE", "Input"],
 "[",
 StyleBox["pars",
  FontSlant->"Italic"],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ...",
 StyleBox[",", "MR"],
 " ",
 StyleBox["t", "TI"],
 " ] using ",
 StyleBox["FindMinimum", "Input"],
 " or ",
 StyleBox["NMinimize", "Input"],
 " finds numerical values of the parameters ",
 StyleBox["pars", "TI"],
 " that make ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "i"], TraditionalForm]]],
 " give a best fit to ",
 StyleBox["data", "TI"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["", "i"], TraditionalForm]]],
 " as a function of ",
 StyleBox["t, ", "TI"],
 StyleBox["when in data the experimental uncertainty is included.", "TI",
  FontSlant->"Plain",
  FontVariations->{"CompatibilityType"->0}]
}], "DefinitionBox",
 CellChangeTimes->{{3.3990298107046704`*^9, 3.3990298230341806`*^9}}],

Cell[TextData[{
 "The  ",
 StyleBox["X2Fit", "MR"],
 " function minimize",
 Cell[BoxData[
  FormBox[
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", " ", "1"}], "N"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["F", "i"], " ", "-", " ", 
       SubscriptBox["Y", "i"]}], ")"}], "2"]}], TraditionalForm]]],
 " where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "i"], TraditionalForm]]],
 " denotes the values of the  functions",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["F", "i"],
      TraditionalForm], "(", 
     RowBox[{"a", ",", " ", "t"}], ")"}], " "}], TraditionalForm]]],
 " associated with measurement ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 "."
}], "Text"],

Cell[TextData[{
 " ",
 StyleBox["X2Fit", "Input"],
 "[",
 StyleBox["pars",
  FontSlant->"Italic"],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ...",
 StyleBox[",", "MR"],
 " ",
 StyleBox["t", "TI"],
 " ] using ",
 StyleBox["FindMinimum", "Input"],
 " or ",
 StyleBox["NMinimize", "Input"],
 " finds numerical values of the parameters ",
 StyleBox["pars", "TI"],
 " that make ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "i"], TraditionalForm]]],
 " give a best fit to ",
 StyleBox["data", "TI"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["", "i"], TraditionalForm]]],
 " as a function of ",
 StyleBox["t", "TI"],
 ". "
}], "DefinitionBox",
 CellChangeTimes->{{3.3990298318813105`*^9, 3.399029846924568*^9}}],

Cell[TextData[{
 "The  ",
 StyleBox["MLFit", "MR"],
 " function applies the following equations where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["F", "i"], TraditionalForm]]],
 " denotes the values of the  functions",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     FormBox[
      SubscriptBox["F", "i"],
      TraditionalForm], "(", 
     RowBox[{"I", ",", " ", "t"}], ")"}], " "}], TraditionalForm]]],
 " associated with measurement ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["s", "i"], TraditionalForm]]],
 " is the uncertainty (1 s) of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 ".\n"
}], "Text"],

Cell[TextData[{
 " ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["I", "^"], TraditionalForm]]],
 "=",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", " ", "1"}], "N"], 
     FractionBox[
      RowBox[{
       SubscriptBox["F", "i"], " ", 
       SubscriptBox["Y", "i"]}], 
      SubsuperscriptBox["s", "i", "2"]]}], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", " ", "1"}], "N"], 
     FractionBox[
      RowBox[{
       SubsuperscriptBox["F", "i", "2"], " "}], 
      SubsuperscriptBox["s", "i", "2"]]}]], TraditionalForm]]],
 "; ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "^"], "I"], " ", "=", 
    FractionBox["1", 
     SqrtBox[
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"i", "=", " ", "1"}], "N"], 
       FractionBox[
        RowBox[{
         SubsuperscriptBox["F", "i", "2"], " "}], 
        SubsuperscriptBox["s", "i", "2"]]}]]], " "}], TraditionalForm]]]
}], "NumberedEquation"],

Cell[TextData[{
 " ",
 StyleBox["MLFit", "MR"],
 "[",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ... ] finds numerical values of the input of to a ",
 Cell[BoxData[
  FormBox[
   StyleBox["model",
    FontSlant->"Italic"], TraditionalForm]]],
 " that make the best fit to ",
 StyleBox["data", "TI"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["", "i"], TraditionalForm]]],
 ". "
}], "DefinitionBox"],

Cell["\<\
Instead of the eqn (1) other authors recommend  the maximum likelihood method \
which uses the following eqn 
\
\>", "Text"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", " ", 
     RowBox[{"(", 
      OverscriptBox["I", "^"], ")"}]}], " ", "="}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", "1"}], "N"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Log", "(", " ", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"i", " "}]], "/", 
         SubscriptBox["F", "i"]}], ")"}], "/", 
       RowBox[{"(", 
        SuperscriptBox[
         RowBox[{"Log", "(", 
          SubscriptBox["SF", 
           RowBox[{"i", ",", "j"}]], ")"}], "2"], ")"}]}], ")"}]}], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", "1"}], "N"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "/", 
       SuperscriptBox[
        RowBox[{"Log", "(", 
         SubscriptBox["SF", 
          RowBox[{"i", ",", "j"}]], ")"}], "2"]}]}]}]], TraditionalForm]]],
 " \n"
}], "NumberedEquation"],

Cell[TextData[{
 "being ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["SF", "i"], TraditionalForm]]],
 " the scattering factor for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", "i"], TraditionalForm]]],
 ". If the data are log normally distributed then SF is the geometric \
standard deviation (SG) of the log-normal distribution."
}], "Text"],

Cell["Then ", "Text"],

Cell[TextData[{
 "\n",
 Cell[BoxData[
  FormBox[
   OverscriptBox["I", "^"], TraditionalForm]]],
 " ",
 Cell[BoxData[
  RowBox[{"=", " ", 
   SuperscriptBox["\[ExponentialE]", 
    FormBox[
     RowBox[{"Log", " ", 
      RowBox[{"(", 
       OverscriptBox["I", "^"], ")"}]}],
     TraditionalForm]]}]]]
}], "NumberedEquation"],

Cell["These equations are  used by the following function ", "Text"],

Cell[TextData[{
 " ",
 StyleBox["MLFitLog", "MR"],
 "[",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "1"], TraditionalForm]]],
 StyleBox[",", "MR"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["data",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["model",
     FontSlant->"Italic"], "2"], TraditionalForm]]],
 ", ... ] finds numerical values of the input of to a ",
 Cell[BoxData[
  FormBox[
   StyleBox["model",
    FontSlant->"Italic"], TraditionalForm]]],
 " that make the best fit to ",
 StyleBox["data", "TI"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["", "i"], TraditionalForm]]],
 ". using the maximum likelihood method"
}], "DefinitionBox"],

Cell[TextData[{
 "In this notebook are includes some examples for fitting model using the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " functions and the Fitmodel functions."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples about fitting", "SubsectionIcon"],

Cell[CellGroupData[{

Cell["Example 1", "SubsubsectionIcon"],

Cell[TextData[{
 "We have the model of the bellow figure. The rate transfer from compartment \
2 to environment is known and its value is ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "20"], TraditionalForm]]],
 "= 0.05 ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["d", 
    RowBox[{"-", "1"}]], TraditionalForm]]],
 ". The transfer coefficients  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "21"], TraditionalForm]]],
 " are unknown. The experiment consists of an instantaneous injection  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 "= 1 in compartment 1 and  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "2"], TraditionalForm]]],
 "= 0.5 in compartment 2 at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 " of the model. I"
}], "Text"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .66667 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.12963 0.21164 0.333333 0.21164 [
[ 0 0 0 0 ]
[ 1 .66667 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66667 L
0 .66667 L
closepath
clip
newpath
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125  moveto 0 0 lineto 
-0.05 -0.0125  lineto stroke
} ifelse
grestore
} def
/MAarrowhead2 {
gsave
MAtocoords
arrl 0. eq
{ 0 0 Mdot }
{
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto
-0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
} ifelse
grestore
} def
% End of user PostScript
0 g
.5 Mabswid
[ ] 0 setdash
.12963 .65079 m
.12963 .43915 L
s
% Start of user PostScript
0 1.5 0 0.5 MAarrowhead1
% End of user PostScript
gsave
.17196 .54497 -68.3438 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
73.688 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.87037 .65079 m
.87037 .43915 L
s
% Start of user PostScript
3.5 1.5 3.5 0.5 MAarrowhead1
% End of user PostScript
gsave
.9127 .54497 -68.3438 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(b) show
69.000 14.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
73.688 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
newpath
.12963 .33333 .10582 0 365.73 arc
s
gsave
.12963 .33333 -66 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 .41799 -70.4375 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
77.875 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.23545 .37566 m
.76455 .37566 L
s
% Start of user PostScript
0.5 0.2 3. 0.2 MAarrowhead2
% End of user PostScript
gsave
.5 .24868 -70.4375 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(21) show
77.875 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.76455 .29101 m
.23545 .29101 L
s
% Start of user PostScript
3. -0.2 0.5 -0.2 MAarrowhead2
% End of user PostScript
newpath
.87037 .33333 .10582 0 365.73 arc
s
.87037 .22751 m
.87037 .01587 L
s
% Start of user PostScript
3.5 -0.5 3.5 -1.5 MAarrowhead2
% End of user PostScript
gsave
.87037 .33333 -66 -10.2813 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.9127 .12169 -70.4375 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.5625 translate 1 -1 scale
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def
63.000 12.813 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
69.000 14.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
77.875 12.813 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
 ImageSize->{288, 192},
 ImageMargins->{{30, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 
  1}},ImageCache->GraphicsData["CompressedBitmap", "\<\
eJztWktPU0EUvlAoFGiL8hSBtFBi1BBjfP8BTQwYwGgwmpiGmMDCaJD/4HPr
Y2eMbv0FLiRGF0oi4sJ/4muFnTPj3N7hm+mZppcAuYvOTL/z+ObO65457XR5
ZfHW7fLK0kK5cGG5fHdxaeFe4fyd5QqUagqCpkIQBKuFQLQ3K01VbAY/1t8W
RSEQv/ZfqlJB0BJQS3xKNUV/REWSibqB36JqFUCJC/wSVZsAxusGfooqI4Ax
C1DfkCSiPS3KiLJZQM261WdXD5UqAtKqtMSHBKJRpczwlzIw6QHxMvwQlPJ7
oJTRb/U8I/wui88oZ8QKO2PGE9HOFdGyywvJJ91Sy2ZIr/C8bq3qtRViauUO
Rhc/id5prFdjQ1J9APQpdHEd7KmrunVAtwalsz4NjAC3s1oKjxCwewxsLuqe
Wv3SU090s1FrznARHjGt5mlF30P3RUDeI/X2A9GYNpzRw4tOo1mnrSLYB5Qm
ADZN5Zbza55p3i2NuoHoEMCmAIaokG1eUuWB6DDALuoRuca0yEmCHBAdAdgb
pp7D7VGAvWbqZaXbLBBNAuwVU69Luu0ComMAe8nU65RuO4HouG2uafKeMC06
/AhIL10HQQcQnQBYWpQdAnrMtMj4EdB5kKuDIANEpwxM1C/0qWMonwRYO9+3
7nxWQI+YFoqgHYjO2Ia/3UZwGmBtfgS0gFIxEjxn6jncngXYM6ZeWrptA6Jz
AHvK1Evcut1SLERxxUEmAVnQ+3vYjwoReJEaGIrVYqIfAtg2Pj3XNtbBb4lg
/tNPY2gNsq2jbrXYM1uwAW5jOoy38dWB1O+LkiAUyzbglUcE9NJGcYSDgBt2
PBAlhR0oR+QIO+KMmbgB30NR5mydb0BESQQUsqIJcxBwg26KlCjozjItPKN6
IqATCl1/HQQxXXfQY04CzPNyFtNVMqaLL/fCHuZ1wlTHJaatouKmIS5TueUN
OsM0V5kIboplSj9OEE1YyW84i4T64kjAMPJJxlHFzSyNA0w+uT1bRtph0q+o
W73S0J3gmzNmRw3XjahRddrOnX28AqQ3tXRL9hFlPsNk5QJw1qP1VDYU5Vrf
A0zlWh1ZWzTlGwBT+d+S7ud3TTJRJSJgozGicTxN34xFXV2XGmOJVdZjN5e/
g6bNY+N//dV4LAWjcKC4uxyyLNa8nReNIa/uMTL74tBHv6oVtpXGc6sm6ok6
VKfYkc7wj07pgN0FXRBoJ6KrwgenBVrh/XaqVmVu7HrkBfF6mPd5dyIMbNBI
1jRyDDDZEvTZKR2u1ecoZnVmYA63Lbr7a07p6C7ZDYl6op6oJ+qNVPf9L2jQ
9A8/tccs\
\>"],ImageRangeCache->{{{137.875, 424.875}, {415.375, 224.375}} -> {-2.89055, \
2.12547, 0.0164924, 0.0164924}}],

Cell[TextData[{
 "It supposed that in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", "0"}], TraditionalForm]]],
 " the amount of substance in all compartment is \"0\". The amount in \
compartment 2 in different times (in days) was measured. Here are the data ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "x"}], "}"}], TraditionalForm]]],
 " (These data are been obtained by simulation)"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"list1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.30"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "0.26"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"30", ",", "0.24"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"40", ",", "0.21"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "0.19"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"60", ",", "0.17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"70", ",", "0.15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"80", ",", "0.135"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"90", ",", "0.12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "0.11"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[7]:="],

Cell[TextData[{
 "We intend to estimate the parameters ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "21"], TraditionalForm]]],
 " by adjusting our model to the experimental data given in list1. We will \
proceed as follows"
}], "Text"],

Cell["\<\
Step 1:  The compartmental matrix of the model is defined as a function of \
parameters to be fitted\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"modelTwoCompart", "=", " ", 
  RowBox[{"CompartMatrix", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "k21"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0", ",", "0.05"}], "}"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[8]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "k12"}], 
      RowBox[{"k21", "+", "0.`"}]},
     {
      RowBox[{"k12", "+", "0.`"}], 
      RowBox[{
       RowBox[{"-", "k21"}], "-", "0.05`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990287943689766`*^9, 3.3990297322569838`*^9, 
  3.479816834281844*^9, 3.479817629860319*^9, 3.479817745998714*^9, 
  3.4798259289125347`*^9, 3.4802427690052233`*^9, 3.519442403959562*^9, 
  3.539925867020897*^9, 3.5405367335313807`*^9, 3.5871963473764668`*^9, 
  3.642762304297705*^9, 3.6435259809633837`*^9, 3.650608060599629*^9},
 CellLabel->"Out[8]="]
}, Open  ]],

Cell["\<\
Step 2: The model is built by choosing the function of retention in \
compartment 2. In this case, how is a single-impulsive input, AcuteInput is \
used.\
\>", "Text",
 CellChangeTimes->{
  3.399029677746744*^9, {3.399029769465125*^9, 3.399029779629912*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x2", "[", 
    RowBox[{"t_", ",", "k12_", ",", "k21_"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "2"], "[", "t", "]"}], "/.", 
    RowBox[{"AcuteInput", "[", 
     RowBox[{"modelTwoCompart", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0.5"}], "}"}], ",", "t", ",", "x"}], "]"}]}]}], 
  ";"}]], "Input",
 CellLabel->"In[9]:="],

Cell[TextData[{
 "Step 3: Now it is fitted the coefficients  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "21"], TraditionalForm]]],
 " with the experimental dada. Because ",
 StyleBox["x2[t,k12,k21]", "Input"],
 " is an analytic expression ",
 "NonlinearRegress",
 " can used."
}], "Text",
 CellChangeTimes->{{3.3990296400558867`*^9, 3.3990296400558867`*^9}}],

Cell[TextData[{
 "We will need the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " package ",
 "NonlinearFit",
 ". "
}], "Text",
 CellChangeTimes->{{3.399029624782195*^9, 3.3990296247977805`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "=", 
  RowBox[{"NonlinearModelFit", "[", 
   RowBox[{"list1", ",", 
    RowBox[{"x2", "[", 
     RowBox[{"t", ",", "k12", ",", "k21"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k12", ",", "0.01", ",", "0.5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k21", ",", "1", ",", "5"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", "t", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.479817474285181*^9, {3.4798177806074247`*^9, 3.4798177818574004`*^9}},
 CellLabel->"In[10]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   RowBox[{"FittedModel", "[", 
    TagBox[
     PanelBox[
      TagBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "0.23044344952255358`"}], " ", 
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"1.`", " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"-", "0.36308214992449983`"}], " ", "t"}]]}]}], ")"}]}],
         "+", 
        RowBox[{"0.23044344952255358`", " ", 
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"1.`", " ", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}]}], ")"}]}],
         "+", 
        RowBox[{"0.5`", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"0.8012908907046472`", " ", 
            RowBox[{"(", 
             RowBox[{"0.`", "\[VeryThinSpace]", "+", 
              RowBox[{"1.`", " ", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 RowBox[{"-", "0.36308214992449983`"}], " ", "t"}]]}]}], 
             ")"}]}], "+", 
           RowBox[{"0.1987091092953526`", " ", 
            RowBox[{"(", 
             RowBox[{"0.`", "\[VeryThinSpace]", "+", 
              RowBox[{"1.`", " ", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"\[LeftSkeleton]", "20", "\[RightSkeleton]"}]}], 
                 " ", "t"}]]}]}], ")"}]}]}], ")"}]}]}],
       Short[#, 2]& ],
      FrameMargins->5],
     Editable -> False], "]"}],
   InterpretTemplate[
   FittedModel[{
     "Nonlinear", {$CellContext`k12 -> 0.08109636349822527, $CellContext`k21 -> 
       0.24315355706923902`}, {{$CellContext`t}, 
       1. (0. + 1. 
          E^(0.5 (-0.05 - 1. $CellContext`k12 - 1. $CellContext`k21 + 
             1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
                  1. $CellContext`k21)^2)^Rational[1, 2]) $CellContext`t))/(
        0. + 1. $CellContext`k12^(-1) ((-0.2) $CellContext`k12 + (0.05 + 
             1. $CellContext`k12 + 1. $CellContext`k21)^2)^Rational[1, 2]) - 
       1. (0. + 1. 
         E^((-0.5) (0.05 + 1. $CellContext`k12 + 1. $CellContext`k21 + 
            1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
                 1. $CellContext`k21)^2)^Rational[1, 2]) $CellContext`t))/(0. + 
       1. $CellContext`k12^(-1) ((-0.2) $CellContext`k12 + (0.05 + 
            1. $CellContext`k12 + 1. $CellContext`k21)^2)^Rational[1, 2]) + 
       0.5 ((-0.5) (0. + 
           1. E^((-0.5) (0.05 + 1. $CellContext`k12 + 1. $CellContext`k21 + 
               1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
                    1. $CellContext`k21)^2)^
                 Rational[
                  1, 2]) $CellContext`t)) $CellContext`k12^(-1) (-0.05 + 
           1. $CellContext`k12 - 1. $CellContext`k21 - 
           1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
               1. $CellContext`k21)^2)^Rational[1, 2])/(0. + 
          1. $CellContext`k12^(-1) ((-0.2) $CellContext`k12 + (0.05 + 
               1. $CellContext`k12 + 1. $CellContext`k21)^2)^Rational[1, 2]) + 
         0.5 (0. + 1. 
            E^(0.5 (-0.05 - 1. $CellContext`k12 - 1. $CellContext`k21 + 
               1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
                    1. $CellContext`k21)^2)^
                 Rational[
                  1, 2]) $CellContext`t)) $CellContext`k12^(-1) (-0.05 + 
           1. $CellContext`k12 - 1. $CellContext`k21 + 
           1. ((-0.2) $CellContext`k12 + (0.05 + 1. $CellContext`k12 + 
                1. $CellContext`k21)^2)^Rational[1, 2])/(0. + 
          1. $CellContext`k12^(-1) ((-0.2) $CellContext`k12 + (0.05 + 
               1. $CellContext`k12 + 1. $CellContext`k21)^2)^
            Rational[1, 2]))}}, {
     1}, {{0, 0.5}, {10, 0.3}, {20, 0.26}, {30, 0.24}, {40, 0.21}, {
      50, 0.19}, {60, 0.17}, {70, 0.15}, {80, 0.135}, {90, 0.12}, {
      100, 0.11}}, 
     Function[Null, 
      Internal`LocalizedBlock[{$CellContext`k12, $CellContext`k21, \
$CellContext`t}, #], {HoldAll}]]& ],
   Editable->False,
   SelectWithContents->True,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{3.4798177461549606`*^9, 3.4798177857635756`*^9, 
  3.4798259299125795`*^9, 3.480242769410823*^9, 3.519442404178316*^9, 
  3.539925867864663*^9, 3.5405367347657795`*^9, 3.587196348052534*^9, 
  3.642762304344562*^9, 3.643525981197773*^9, 3.6506080608340006`*^9},
 CellLabel->"Out[10]="]
}, Open  ]],

Cell[TextData[{
 "To get the functional form of the ",
 Cell[BoxData[
  ButtonBox["FittedModel",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/FittedModel"]], "InlineFormula"],
 " object, use ",
 Cell[BoxData[
  ButtonBox["Normal",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Normal"]], "InlineFormula"],
 ":"
}], "Text",
 CellID->1038950848],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Normal", "[", "nlm", "]"}], "//", "ExpandAll"}], "//", 
  "Chop"}]], "Input",
 CellChangeTimes->{{3.4798178294033623`*^9, 3.479817841871873*^9}},
 CellLabel->"In[11]:=",
 CellID->155132550],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"0.17020199582977003`", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "0.36308214992449983`"}], " ", "t"}]]}], "+", 
   RowBox[{"0.32979800417022986`", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "0.01116777064296448`"}], " ", "t"}]]}]}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{{3.479817816309864*^9, 3.4798178425906096`*^9}, 
   3.4798259300219593`*^9, 3.4802427695200233`*^9, 3.519442404225192*^9, 
   3.539925868130293*^9, 3.5405367349220324`*^9, 3.5871963481085396`*^9, 
   3.642762304360188*^9, 3.6435259812133694`*^9, 3.650608061005887*^9},
 CellLabel->"Out[11]="]
}, Open  ]],

Cell[TextData[{
 "The result is returned as a ",
 Cell[BoxData[
  ButtonBox["FittedModel",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/FittedModel"]], "InlineFormula"],
 " object, of which properties can be returned:"
}], "Text",
 CellID->897306512],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", "\"\<Properties\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.4798179792911096`*^9, 3.4798180013531857`*^9}},
 CellLabel->"In[12]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"\<\"AdjustedRSquared\"\>", ",", "\<\"AIC\"\>", 
    ",", "\<\"AICc\"\>", ",", "\<\"ANOVATable\"\>", 
    ",", "\<\"ANOVATableDegreesOfFreedom\"\>", 
    ",", "\<\"ANOVATableEntries\"\>", ",", "\<\"ANOVATableMeanSquares\"\>", 
    ",", "\<\"ANOVATableSumsOfSquares\"\>", ",", "\<\"BestFit\"\>", 
    ",", "\<\"BestFitParameters\"\>", ",", "\<\"BIC\"\>", 
    ",", "\<\"CorrelationMatrix\"\>", ",", "\<\"CovarianceMatrix\"\>", 
    ",", "\<\"CurvatureConfidenceRegion\"\>", ",", "\<\"Data\"\>", 
    ",", "\<\"EstimatedVariance\"\>", ",", "\<\"FitCurvatureTable\"\>", 
    ",", "\<\"FitCurvatureTableEntries\"\>", ",", "\<\"FitResiduals\"\>", 
    ",", "\<\"Function\"\>", ",", "\<\"HatDiagonal\"\>", 
    ",", "\<\"MaxIntrinsicCurvature\"\>", 
    ",", "\<\"MaxParameterEffectsCurvature\"\>", 
    ",", "\<\"MeanPredictionBands\"\>", 
    ",", "\<\"MeanPredictionConfidenceIntervals\"\>", 
    ",", "\<\"MeanPredictionConfidenceIntervalTable\"\>", 
    ",", "\<\"MeanPredictionConfidenceIntervalTableEntries\"\>", 
    ",", "\<\"MeanPredictionErrors\"\>", ",", "\<\"ParameterBias\"\>", 
    ",", "\<\"ParameterConfidenceIntervals\"\>", 
    ",", "\<\"ParameterConfidenceIntervalTable\"\>", 
    ",", "\<\"ParameterConfidenceIntervalTableEntries\"\>", 
    ",", "\<\"ParameterConfidenceRegion\"\>", ",", "\<\"ParameterErrors\"\>", 
    ",", "\<\"ParameterPValues\"\>", ",", "\<\"ParameterTable\"\>", 
    ",", "\<\"ParameterTableEntries\"\>", ",", "\<\"ParameterTStatistics\"\>",
     ",", "\<\"PredictedResponse\"\>", ",", "\<\"Properties\"\>", 
    ",", "\<\"Response\"\>", ",", "\<\"RSquared\"\>", 
    ",", "\<\"SingleDeletionVariances\"\>", 
    ",", "\<\"SinglePredictionBands\"\>", 
    ",", "\<\"SinglePredictionConfidenceIntervals\"\>", 
    ",", "\<\"SinglePredictionConfidenceIntervalTable\"\>", 
    ",", "\<\"SinglePredictionConfidenceIntervalTableEntries\"\>", 
    ",", "\<\"SinglePredictionErrors\"\>", 
    ",", "\<\"StandardizedResiduals\"\>", 
    ",", "\<\"StudentizedResiduals\"\>"}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{{3.479817995118931*^9, 3.479818001962549*^9}, 
   3.479825930068836*^9, 3.480242769613623*^9, 3.519442404256442*^9, 
   3.539925868177169*^9, 3.5405367349689083`*^9, 3.587196348138543*^9, 
   3.642762304360188*^9, 3.6435259812133694`*^9, 3.6506080610371256`*^9},
 CellLabel->"Out[12]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<ParameterTable\>\"", ",", "\"\<ANOVATable\>\""}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4798179239484224`*^9, 3.4798179392293787`*^9}, 
   3.4798180691018853`*^9},
 CellLabel->"In[13]:=",
 CellID->1400377950],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    StyleBox[
     TagBox[GridBox[{
        {"\<\"\"\>", "\<\"Estimate\"\>", "\<\"Standard Error\"\>", "\<\"t\
\[Hyphen]Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
        {"k12", "0.08109636349822527`", "0.012226481889066944`", 
         "6.632845346194193`", "0.00009559923375982064`"},
        {"k21", "0.24315355706923902`", "0.042270107850946856`", 
         "5.7523760745217105`", "0.0002754708601775255`"}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
         "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "ColumnsIndexed" -> {2 -> 1}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False], ",", 
    StyleBox[
     TagBox[GridBox[{
        {"\<\"\"\>", "\<\"DF\"\>", "\<\"SS\"\>", "\<\"MS\"\>"},
        {"\<\"Model\"\>", "2", "0.6414829898636382`", "0.3207414949318191`"},
        {"\<\"Error\"\>", "9", "0.00004201013636179392`", 
         "4.667792929088213`*^-6"},
        {"\<\"Uncorrected Total\"\>", "11", "0.641525`", ""},
        {"\<\"Corrected Total\"\>", "10", "0.12441363636363637`", ""}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
         "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "ColumnsIndexed" -> {2 -> 1}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.479817863480833*^9, 3.4798179402449846`*^9, 
  3.479818070554982*^9, 3.4798259302094674`*^9, 3.4802427697384233`*^9, 
  3.5194424043189435`*^9, 3.5399258682552958`*^9, 3.5405367350939107`*^9, 
  3.587196348242553*^9, 3.642762304391449*^9, 3.643525981260296*^9, 
  3.6506080610840006`*^9},
 CellLabel->"Out[13]="]
}, Open  ]],

Cell["\<\
NonlinearRegress[list1, x2[t, k12, k21], {{k12, 0.01, 0.5}, {k21, 1, 5}}, \
{t}](*in version 5 or 6*)\
\>", "Text",
 CellChangeTimes->{{3.39902963198265*^9, 3.3990296384038343`*^9}, {
   3.399029751786552*^9, 3.3990297528375406`*^9}, 3.479817669437684*^9}],

Cell["\<\
Here the fitted function and the experimental data are shown:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"x2", "[", 
    RowBox[{"t", ",", "0.081", ",", "0.2431"}], "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "100"}], "}"}], ",", " ", 
   RowBox[{"Epilog", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Hue", "[", "0", "]"}], ",", " ", 
      RowBox[{"PointSize", "[", "0.02", "]"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"Point", ",", " ", "list1"}], "]"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[14]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVz3s80wsfwHGL5BJpIUXSkL169iTXo+v3m0QJabn81qEWCRXJJcSRUOlK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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0.09},
   DisplayFunction->Identity,
   Epilog->{
     Hue[0], 
     PointSize[0.02], {
      PointBox[{0, 0.5}], 
      PointBox[{10, 0.3}], 
      PointBox[{20, 0.26}], 
      PointBox[{30, 0.24}], 
      PointBox[{40, 0.21}], 
      PointBox[{50, 0.19}], 
      PointBox[{60, 0.17}], 
      PointBox[{70, 0.15}], 
      PointBox[{80, 0.135}], 
      PointBox[{90, 0.12}], 
      PointBox[{100, 0.11}]}},
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 100}, {0.10796042041617765`, 0.4999998662245367}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399028795256621*^9, 3.399029784131909*^9, 
  3.4798168352037015`*^9, 3.4798259303969755`*^9, 3.4802427698788233`*^9, 
  3.519442404428321*^9, 3.5399258685521765`*^9, 3.540536735515794*^9, 
  3.5871963486645956`*^9, 3.6427623044539366`*^9, 3.6435259813227654`*^9, 
  3.6506080611933756`*^9},
 CellLabel->"Out[14]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"list1", ",", "modelTwoCompart", ",", "x2", ",", "nlm"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.479818181834096*^9, 3.4798181836153116`*^9}},
 CellLabel->"In[15]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 2", "SubsubsectionIcon"],

Cell[TextData[{
 "A usual problem in biokinetic modeling consist in fitting parameters in \
differential equations. Here is an example provided by Wolfram support. \nWe \
have the differential equation:  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"f", "'"}], "[", "t", "]"}], "\[Equal]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"t", "<", "p"}], ",", 
       RowBox[{"10", "-", 
        RowBox[{"f", "[", "t", "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "t", "]"}]}]}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"f", "[", "0", "]"}], "\[Equal]", "q"}]}], TraditionalForm]]],
 ", where ",
 StyleBox["p",
  FontSlant->"Italic"],
 " an ",
 StyleBox["q",
  FontSlant->"Italic"],
 " are unknown, but we have the some experimental values (data) of ",
 Cell[BoxData[
  FormBox[
   RowBox[{"f", "[", "t", "]"}], TraditionalForm]]],
 " . "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.5", ",", "6.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.1", ",", "8.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "8.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1", ",", "8.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.3", ",", "6.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.1", ",", "2.9"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[16]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol", "[", 
   RowBox[{
    RowBox[{"p_", "?", "NumericQ"}], ",", 
    RowBox[{"q_", "?", "NumericQ"}]}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"f", "/.", 
    RowBox[{
     RowBox[{"NDSolve", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"f", "'"}], "[", "t", "]"}], "\[Equal]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"t", "<", "p"}], ",", 
            RowBox[{"10", "-", 
             RowBox[{"f", "[", "t", "]"}]}], ",", 
            RowBox[{"-", 
             RowBox[{"f", "[", "t", "]"}]}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"f", "[", "0", "]"}], "\[Equal]", "q"}]}], "}"}], ",", "f", 
       ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "5"}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ")"}], " "}]], "Input",
 CellLabel->"In[17]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myfit", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"data", ",", 
    RowBox[{
     RowBox[{"sol", "[", 
      RowBox[{"p", ",", "q"}], "]"}], "[", "t", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", ",", "2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"q", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", "t"}], 
   "]"}]}]], "Input",
 CellLabel->"In[18]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"p", "\[Rule]", "1.9961350546962173`"}], ",", 
    RowBox[{"q", "\[Rule]", "3.935261583372086`"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399028805207576*^9, 3.4798168580157633`*^9, 
  3.479825939709893*^9, 3.480242774995623*^9, 3.519442414397262*^9, 
  3.539925872224122*^9, 3.540536752547371*^9, 3.5871963581435432`*^9, 
  3.64276230726644*^9, 3.6435259842133904`*^9, 3.650608063662127*^9},
 CellLabel->"Out[18]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fitsol", "=", 
   RowBox[{
    RowBox[{"sol", "[", 
     RowBox[{"p", ",", "q"}], "]"}], "/.", "myfit"}]}], ";", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"fitsol", "[", "tt", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"tt", ",", "0", ",", "5"}], "}"}], ",", 
    RowBox[{"Epilog", "\[RuleDelayed]", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Orange", ",", 
          RowBox[{"PointSize", "[", ".02", "]"}], ",", 
          RowBox[{"Point", "[", "##", "]"}]}], "}"}], "&"}], ",", "data"}], 
      "]"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[19]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVj3k8lYkax1/7nOzerJFz3msqkhhphpk8TySJTtasySGljcnRoNNVJIbB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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Epilog->{{
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.5, 6.2}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.1, 8.1}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.5, 8.8}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.1, 8.3}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.3, 6.8}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{3.1, 2.9}]}},
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 5}, {0., 9.174900826532781}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3990288053010125`*^9, 3.4798168581251364`*^9, 
  3.479825939772396*^9, 3.4802427755728235`*^9, 3.5194424145066395`*^9, 
  3.539925872317874*^9, 3.540536752625498*^9, 3.5871963582355523`*^9, 
  3.642762307391441*^9, 3.643525984322756*^9, 3.6506080638340025`*^9},
 CellLabel->"Out[19]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"data", ",", "sol", ",", "myfit", ",", "fitsol"}], "]"}]], "Input",
 CellLabel->"In[20]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 3", "SubsubsectionIcon"],

Cell[TextData[{
 "We want to estimate the values , ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "off"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "on"], TraditionalForm]]],
 "  for the physiological model given by the system of linear differential \
equations:"
}], "Text",
 CellChangeTimes->{3.4802455217812233`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox[
    OverscriptBox["x", "."], "1"], "[", "t", "]"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["Q", 
        SubscriptBox["V", "p"]], "+", " ", 
       FractionBox["PS", 
        SubscriptBox["V", "p"]]}], ")"}]}], 
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}]}], " ", "+", 
   RowBox[{
    FractionBox["PS", 
     SubscriptBox["V", "p"]], " ", 
    RowBox[{
     SubscriptBox["x", "2"], "[", "t", "]"}]}], "+", 
   RowBox[{
    FractionBox["Q", 
     SubscriptBox["V", "p"]], " ", 
    RowBox[{"b", "[", "t", "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox[
    OverscriptBox["x", "."], "2"], "[", "t", "]"}], " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"+", 
     FractionBox["PS", 
      SubscriptBox["V", "Tu"]]}], 
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}]}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["PS", 
       SubscriptBox["V", "Tu"]], " ", "+", 
      SubscriptBox["k", "on"]}], " ", ")"}], 
    RowBox[{
     SubscriptBox["x", "2"], "[", "t", "]"}]}], "+", 
   RowBox[{
    SubscriptBox["k", "off"], 
    FractionBox[
     SubscriptBox["V", "Tb"], 
     SubscriptBox["V", "Tu"]], 
    RowBox[{
     SubscriptBox["x", "3"], "[", "t", "]"}]}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox[
    OverscriptBox["x", "."], "3"], "[", "t", "]"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"+", " ", 
     SubscriptBox["k", "on"]}], 
    FractionBox[
     SubscriptBox["V", "Tu"], 
     SubscriptBox["V", "Tb"]], 
    RowBox[{
     SubscriptBox["x", "2"], "[", "t", "]"}]}], "-", 
   RowBox[{
    SubscriptBox["k", "off"], 
    RowBox[{
     SubscriptBox["x", "3"], "[", "t", "]"}]}]}]}]}], "NumberedEquation",
 TextAlignment->Left,
 TextJustification->0,
 CellTags->"eq 2"],

Cell[TextData[{
 "It was made an experiment (the model and the experimental data was provided \
by Amparo Sanchez. Pharmacology Dpt. Universidad de Salamanca)  where the \
input function  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", "(", "t", ")"}], TraditionalForm]]],
 " is given by  the best fit of the input function to experimental data {{",
 Cell[BoxData[
  FormBox[
   SubscriptBox["t", "1"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "1"], TraditionalForm]]],
 "}, ..., {",
 Cell[BoxData[
  FormBox[
   SubscriptBox["t", "n"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["b", "n"], TraditionalForm]]],
 "}} obtained via sampling from an arterial catheter. Here are the \
experimental data:"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataCateter", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0", ",", "3.048"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.05", ",", "286.435"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.10", ",", "534.718"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15", ",", "370.241"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.20", ",", "240.302"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.25", ",", "170.005"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.30", ",", "128.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.35", ",", "84.36"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.40", ",", "66.58"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.45", ",", "52.32"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.50", ",", "40.30"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.55", ",", "28.78"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.60", ",", "20.75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65", ",", "16.226"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.70", ",", "14.19"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.75", ",", "13.14"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.80", ",", "10.63"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.85", ",", "7.57"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.90", ",", "7.414"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95", ",", "5.026"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.00", ",", "3.69"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05", ",", "4.39"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.10", ",", "3.17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.15", ",", "3.16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.20", ",", "2.55"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.25", ",", "2.334"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.30", ",", "2.164"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35", ",", "2.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.40", ",", "1.63"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.45", ",", "1.445"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.50", ",", "0.513"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.55", ",", "1.14"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60", ",", "0.852"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.65", ",", "0.761"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.70", ",", "0.734"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.75", ",", "0.775"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.80", ",", "0.473"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85", ",", "0.389"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.90", ",", "0.514"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9767", " ", ",", "0.347"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.077", ",", "0.274"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.177", " ", ",", "0.14"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.277", ",", "0.088"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.377", ",", "0.013"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[21]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"dataCateter", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellLabel->"In[22]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQAWIQDQN/Vn685JvE4TBrJgistNeM6T/09VkhlL/T3nLL
ibJ9WxscjMHgsH3C0wtKt5XLofIn7btznv9eyZnnADHtgj1Iu4ZDKlT9ZXsw
JZzgkAYG1+yvLy6w5RIPheq/ad/6OnCH3NIAh7NnQOAOxH4NL6h5D+zB2tRc
oOof2ns8rBJZd9wGav5je7CyAyZQ/U8g7rM0gNr3zB6k3D1RB2reC4h+dy2o
eS/tD3/ViOl3UoWa9xoqLwc17409n+6mue+Xy0LNe2cPCo75UiJQ8z5A3N/K
C1X/wR7k+ph+Qaj5HyHhEcMJ1f8Jaj4n1L7PEP+lsUDN+2Jf+VLNkGMNE9S8
L/ayUSnW9/0ZoeZ9tYeIM0DN+2YPNAxo4i9IOBt/t5cHO+g7JFwYfthfVLr9
sy7rAVTfD3tbLlAMfLKHmPfT/q4KW+NU59dQd/yyVwfaLhP1Amreb/sNRRkT
39Y8h5r3B2rOCyj9x16o+cCpha73oOb9tfcx73RMeHoDat4/+2WzjyhsKHpg
L837QHfCgv/2INPsTa/Zs4SBQpbB4cPyY97mnReh7mR0eAMKztcH7ee9B0kw
Oezy5GHSbt9mn7WnZLIEC7MDOD3O77IHAI39O44=
       "]]}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0, 2.377}, {0, 534.718}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3990288054255943`*^9, 3.479816871640502*^9, 
  3.479825939803647*^9, 3.480242775838023*^9, 3.519442414584766*^9, 
  3.53992587236475*^9, 3.540536768860184*^9, 3.5871963584765763`*^9, 
  3.5871969568374066`*^9, 3.587197838667243*^9, 3.5871979164820385`*^9, 
  3.6427623074383173`*^9, 3.643525984385269*^9, 3.650608064021502*^9},
 CellLabel->"Out[22]="]
}, Open  ]],

Cell["\<\
The graphic form suggests that the bellow function could be appropriated  to \
fit the data\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"b", "[", "t_", "]"}], "=", 
  RowBox[{
   RowBox[{"a", " ", "t", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"b", " ", "t"}], "]"}]}], " ", "/.", 
   RowBox[{"FindFit", "[", 
    RowBox[{"dataCateter", ",", 
     RowBox[{"a", " ", "t", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"b", " ", "t"}], "]"}]}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", " ", "b"}], "}"}], ",", "t"}], "]"}]}]}]], "Input",
 CellTags->"FindFit",
 CellLabel->"In[23]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"12973.659983634852`", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "11.151767794865503`"}], " ", "t"}]], " ", "t"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990288054878845`*^9, 3.479816871718625*^9, 
  3.47982593986615*^9, 3.4802427759160233`*^9, 3.5194424146160164`*^9, 
  3.539925872396*^9, 3.540536768953936*^9, 3.587196358534582*^9, 
  3.5871969569054136`*^9, 3.587197838745245*^9, 3.5871979165444403`*^9, 
  3.6427623074383173`*^9, 3.6435259844165087`*^9, 3.650608064099629*^9},
 CellTags->"FindFit",
 CellLabel->"Out[23]="]
}, Open  ]],

Cell["\<\
Here they are shown experimental data and the fitted function\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"b", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"Point", "/@", "dataCateter"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "550"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[24]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwUV3c40N8XtveKyFeUFYWsjIrP59zIHiFklL0J2XuWaCmRBiWRyip772RT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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Epilog->{
     PointBox[{0., 3.048}], 
     PointBox[{0.05, 286.435}], 
     PointBox[{0.1, 534.718}], 
     PointBox[{0.15, 370.241}], 
     PointBox[{0.2, 240.302}], 
     PointBox[{0.25, 170.005}], 
     PointBox[{0.3, 128.6}], 
     PointBox[{0.35, 84.36}], 
     PointBox[{0.4, 66.58}], 
     PointBox[{0.45, 52.32}], 
     PointBox[{0.5, 40.3}], 
     PointBox[{0.55, 28.78}], 
     PointBox[{0.6, 20.75}], 
     PointBox[{0.65, 16.226}], 
     PointBox[{0.7, 14.19}], 
     PointBox[{0.75, 13.14}], 
     PointBox[{0.8, 10.63}], 
     PointBox[{0.85, 7.57}], 
     PointBox[{0.9, 7.414}], 
     PointBox[{0.95, 5.026}], 
     PointBox[{1., 3.69}], 
     PointBox[{1.05, 4.39}], 
     PointBox[{1.1, 3.17}], 
     PointBox[{1.15, 3.16}], 
     PointBox[{1.2, 2.55}], 
     PointBox[{1.25, 2.334}], 
     PointBox[{1.3, 2.164}], 
     PointBox[{1.35, 2.1}], 
     PointBox[{1.4, 1.63}], 
     PointBox[{1.45, 1.445}], 
     PointBox[{1.5, 0.513}], 
     PointBox[{1.55, 1.14}], 
     PointBox[{1.6, 0.852}], 
     PointBox[{1.65, 0.761}], 
     PointBox[{1.7, 0.734}], 
     PointBox[{1.75, 0.775}], 
     PointBox[{1.8, 0.473}], 
     PointBox[{1.85, 0.389}], 
     PointBox[{1.9, 0.514}], 
     PointBox[{1.9767, 0.347}], 
     PointBox[{2.077, 0.274}], 
     PointBox[{2.177, 0.14}], 
     PointBox[{2.277, 0.088}], 
     PointBox[{2.377, 0.013}]},
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0., 4.999999897959183}, {0, 550}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {0, 0}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.399028805565748*^9, 3.4798168718123736`*^9, 
  3.4798259399442787`*^9, 3.480242776056423*^9, 3.519442414694143*^9, 
  3.539925872442876*^9, 3.5405367690164375`*^9, 3.587196358603589*^9, 
  3.5871969570284257`*^9, 3.5871978388544483`*^9, 3.5871979166536427`*^9, 
  3.642762307469578*^9, 3.643525984463383*^9, 3.6506080642558823`*^9},
 CellLabel->"Out[24]="]
}, Open  ]],

Cell[TextData[{
 "Also it has been measured the experimental data by measuring ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["x", "1"], "[", "t", "]"}]],
  TextAlignment->Left,
  TextJustification->0],
 ". Here is the list {{",
 Cell[BoxData[
  FormBox[
   SubscriptBox["t", "1"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "[", 
    SubscriptBox["t", "1"], "]"}], TraditionalForm]]],
 "}, ..., {",
 Cell[BoxData[
  FormBox[
   SubscriptBox["t", "n"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "[", 
    SubscriptBox["t", "n"], "]"}], TraditionalForm]]],
 "}}."
}], "Text",
 FontFamily->"Times New Roman"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataPhysio", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03", ",", "27.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.08", ",", "48.61"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28", ",", "133.39"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.33", ",", "106.18"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.38", ",", "92.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.48", ",", "60.47"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.55", ",", "56.54"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65", ",", "27.73"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.75", ",", "23.25"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.85", ",", "15.83"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95", ",", "13.82"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05", ",", "10.58"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.15", ",", "7.83"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.25", ",", "7.35"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35", ",", "6.08"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.45", ",", "5.21"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.6", ",", "4.18"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.8", ",", "3.48"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.", ",", "2.86"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.2", ",", "2.42"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.4", ",", "2.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.6", ",", "2.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.8", ",", "1.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.", ",", "1.58"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.4", ",", "1.58"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.75", ",", "1.44"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4.25", ",", "1.35"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4.75", ",", "1.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.25", ",", "1.29"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6.75", ",", "0.81"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7.25", ",", "0.78"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7.75", ",", "0.73"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8.25", ",", "0.75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11.", ",", "0.68"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[25]:="],

Cell[TextData[{
 "Now we can build the model. It is assumed that in eq.(1) ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "Tb"], TraditionalForm]]],
 " and Q are known"
}], "Text"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Q", " ", "=", " ", "3"}], ";", 
   RowBox[{"VTb", "=", "1"}], ";"}]}]], "Input",
 CellLabel->"In[26]:="],

Cell["\<\
Step 1: It is obtained the coefficients matrix using the package function \
CoefMatrix . \
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"physiomodel", "=", 
   RowBox[{"CoefMatrix", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", " ", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["Q", "Vp"], "+", " ", 
            FractionBox["PS", "Vp"]}], ")"}]}]}], " ", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", " ", 
         FractionBox["PS", "Vp"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", " ", 
         FractionBox["PS", "VTu"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2", ",", " ", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["PS", "VTu"], " ", "+", "kon"}], " ", ")"}]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3", ",", 
         RowBox[{"koff", " ", 
          FractionBox["VTb", "VTu"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", " ", 
         RowBox[{"kon", 
          FractionBox["VTu", "VTb"]}]}], "}"}], " ", ",", "  ", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3", ",", " ", 
         RowBox[{"-", "koff"}]}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[27]:="],

Cell[TextData[{
 "Step 2: The input function ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", "(", "t", ")"}], TraditionalForm]]],
 " in eq. (1) is given by"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"inputcatheter", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["Q", "Vp"], 
      RowBox[{"b", "[", "t", "]"}]}], " ", ",", "0", ",", "0"}], "}"}]}], 
  ";"}]], "Input",
 CellLabel->"In[28]:="],

Cell[TextData[{
 "In this example are given  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "Tu"], TraditionalForm]]],
 "= 6.411,",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "p"], TraditionalForm]]],
 "=0.973,  PS= 2.714. "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"physiomodel1", "=", 
   RowBox[{"physiomodel", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"VTu", "\[Rule]", "6.411"}], ",", 
      RowBox[{"Vp", "\[Rule]", "0.973"}], ",", 
      RowBox[{"PS", "\[Rule]", "2.714"}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[29]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"inputcatheter1", "=", 
   RowBox[{"inputcatheter", "/.", 
    RowBox[{"{", 
     RowBox[{"Vp", "\[Rule]", "0.973"}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[30]:="],

Cell[TextData[{
 "Now we want  obtained  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "off"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "on"], TraditionalForm]]],
 " for fitting ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "t", ")"}], TraditionalForm]]],
 ". Here they are shown some methods."
}], "Text"],

Cell["Method 1", "Text",
 FontWeight->"Bold"],

Cell[TextData[{
 "It is obtained the Laplace transform of { ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["x", "1"], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["x", "2"], "[", "t", "]"}], ",", 
   RowBox[{
    SubscriptBox["x", "3"], "[", "t", "]"}]}]]],
 "} denoted as {",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["X", "1"], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["X", "2"], "[", "s", "]"}], ",", 
   RowBox[{
    SubscriptBox["X", "3"], "[", "s", "]"}]}]]],
 "}. The  initial condition are ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "1"], TraditionalForm]]],
 "(0) =  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "2"], TraditionalForm]]],
 "(0)  = ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["x", "3"], TraditionalForm]]],
 "(0) = 0. We only will need ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["X", "1"], "[", "s", "]"}]]],
 ".  Thus, the model is specified as follows:"
}], "Text",
 CellChangeTimes->{3.4802455479892235`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"X1", "[", "s_", "]"}], "=", 
   RowBox[{
    RowBox[{
     SubscriptBox["X", "1"], "[", "s", "]"}], "/.", 
    RowBox[{"SystemLTSolve", "[", 
     RowBox[{"physiomodel1", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "inputcatheter1", ",", 
      " ", "t", ",", "s", ",", " ", "X"}], "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[31]:="],

Cell[TextData[{
 "Now,   ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["x", "1"], "[", "t", "]"}]], "NumberedEquation",
  TextAlignment->Left,
  TextJustification->0],
 " can be obtained applying the InverseLaplaceTransform as function of  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "off"], TraditionalForm]]],
 " and, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "on"], TraditionalForm]]]
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x1", "[", 
    RowBox[{"t_", ",", " ", "off_", ",", " ", "on_"}], "]"}], "=", 
   RowBox[{
    RowBox[{"InverseLaplaceTransform", "[", 
     RowBox[{
      RowBox[{"X1", "[", "s", "]"}], ",", " ", "s", ",", " ", "t"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"koff", "->", "off"}], " ", ",", " ", 
      RowBox[{"kon", "->", "on"}]}], "}"}]}]}], " ", ";"}]], "Input",
 CellLabel->"In[32]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"x1bestfit", "[", "t_", "]"}], "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"dataPhysio", ",", " ", 
    RowBox[{"x1", "[", 
     RowBox[{"t", ",", " ", "koff", ",", " ", "kon"}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"koff", ",", " ", "kon"}], "}"}], ",", " ", "t"}], "]"}], 
  " "}]], "Input",
 CellLabel->"In[33]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"koff", "\[Rule]", "0.10193607642310018`"}], ",", 
    RowBox[{"kon", "\[Rule]", "0.6870929909177698`"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399028814722496*^9, 3.4798168827965374`*^9, 
  3.479825950741637*^9, 3.480242783076423*^9, 3.5194424256631036`*^9, 
  3.539925878271113*^9, 3.540536775079054*^9, 3.5871963620519342`*^9, 
  3.6427623082664433`*^9, 3.6435259852915115`*^9, 3.6506080652402525`*^9},
 CellLabel->"Out[33]="]
}, Open  ]],

Cell[TextData[{
 "Here they are compared x1[t]",
 StyleBox[" ", "Input"],
 "and the experimental data"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"x1", "[", 
      RowBox[{"t", ",", " ", "koff", ",", " ", "kon"}], "]"}], "/.", 
     RowBox[{"x1bestfit", "[", "t", "]"}]}], "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "11"}], "}"}], ",", " ", 
   RowBox[{"PlotRange", "->", " ", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "140"}], "}"}]}], ",", 
   RowBox[{"Epilog", ":>", " ", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", " ", 
        RowBox[{"Orange", ",", " ", 
         RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", 
         RowBox[{"Point", "[", "##", "]"}]}], "}"}], " ", "&"}], ",", " ", 
      "dataPhysio"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[34]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVlnc4FQ4Xxy+yNxeFZF17ZGQUzlGpyC4j60pLJYR+FSojSVSSigqVFLKT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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Epilog->{{
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.03, 27.5}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.08, 48.61}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.28, 133.39}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.33, 106.18}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.38, 92.11}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.48, 60.47}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.55, 56.54}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.65, 27.73}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.75, 23.25}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.85, 15.83}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{0.95, 13.82}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.05, 10.58}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.15, 7.83}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.25, 7.35}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.35, 6.08}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.45, 5.21}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.6, 4.18}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{1.8, 3.48}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2., 2.86}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.2, 2.42}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.4, 2.11}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.6, 2.01}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{2.8, 1.7}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{3., 1.58}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{3.4, 1.58}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{3.75, 1.44}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{4.25, 1.35}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{4.75, 1.3}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{5.25, 1.29}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{6.75, 0.81}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{7.25, 0.78}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{7.75, 0.73}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{8.25, 0.75}]}, {
      RGBColor[1, 0.5, 0], 
      PointSize[0.02], 
      PointBox[{11., 0.68}]}},
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0., 10.999999775510204`}, {0, 140}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {0, 0}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3990288168248105`*^9, 3.4798168900932727`*^9, 
  3.4798259580857162`*^9, 3.480242787335223*^9, 3.519442432866367*^9, 
  3.53992588200556*^9, 3.5405367788760014`*^9, 3.587196363193048*^9, 
  3.6427623084383183`*^9, 3.6435259855258865`*^9, 3.6506080654121275`*^9},
 CellLabel->"Out[34]="]
}, Open  ]],

Cell["\<\
As it can be seen, the model fits almost exactly with the experimental data.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"X1", ",", " ", "x1", ",", "x1bestfit"}], " ", "]"}]], "Input",
 CellLabel->"In[35]:="],

Cell["Method 2", "Text",
 FontWeight->"Bold"],

Cell[TextData[{
 "Here is solved the same problem but using package  ",
 StyleBox["SystemNDSolve", "Input"],
 ", that apply the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function ",
 StyleBox["DSolve", "Input"],
 ", combined with ",
 ButtonBox["FindMinimum"],
 " It can be made as follow "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"objective", "[", 
    RowBox[{"c1_Real", ",", "c2_Real"}], "]"}], ":=", 
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", "q1", "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"q1", "[", "t3_", "]"}], "=", 
       RowBox[{
        RowBox[{
         RowBox[{"SystemNDSolve", "[", 
          RowBox[{
           RowBox[{"physiomodel1", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"koff", "\[Rule]", " ", "c1"}], ",", " ", 
              RowBox[{"kon", "\[Rule]", " ", "c2"}]}], "}"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "inputcatheter1", 
           ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0.01", ",", "12"}], "}"}], ",", " ", "t", ",", 
           " ", "x"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], "/.", 
        RowBox[{"t", "\[Rule]", "t3"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Plus", "@@", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"q1", "[", "#1", "]"}], "-", "#2"}], ")"}], "^", "2"}], 
          "&"}], ",", "dataPhysio", ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}]}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[36]:="],

Cell[TextData[{
 "We have used [[1,2]] because we only need the concentration for ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], "(", "t", ")"}], TraditionalForm]]]
}], "SmallText"],

Cell[TextData[{
 "Now we use ",
 StyleBox["FindMinimum", "Input"],
 "  "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindMinimum", "[", 
  RowBox[{
   RowBox[{"objective", "[", 
    RowBox[{"koff", ",", "kon"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"koff", ",", "0.1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"kon", ",", "0.1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[37]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"601.2380611824017`", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"koff", "\[Rule]", "0.10197098051295153`"}], ",", 
      RowBox[{"kon", "\[Rule]", "0.6871131747771675`"}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990288193943057`*^9, 3.4798168928432198`*^9, 
  3.4798259607420855`*^9, 3.4802427888328233`*^9, 3.519442434272644*^9, 
  3.539925882880576*^9, 3.5405367797978945`*^9, 3.587196365420271*^9, 
  3.6427623092976933`*^9, 3.643525986260276*^9, 3.6506080661308784`*^9},
 CellLabel->"Out[37]="]
}, Open  ]],

Cell[TextData[{
 "It can be used ",
 StyleBox["NMinimize[objective[koff,kon],{koff,kon}] ", "Input"],
 "but it will take a long time."
}], "Text"],

Cell[BoxData[
 RowBox[{"Clear", "[", "objective", "]"}]], "Input",
 CellLabel->"In[38]:="],

Cell["Method 3", "Text",
 FontWeight->"Bold"],

Cell[TextData[{
 "Here is used",
 " the package function  ",
 StyleBox["X2Fit ", "Input"]
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"X1", "[", 
   RowBox[{"t1_", ",", 
    RowBox[{"c1_", "?", "NumericQ"}], ",", 
    RowBox[{"c2_", "?", "NumericQ"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["x", "1"], "[", "t", "]"}], "/.", 
    RowBox[{"SystemNDSolve", "[", 
     RowBox[{
      RowBox[{"physiomodel1", "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"koff", "\[Rule]", " ", "c1"}], ",", " ", 
         RowBox[{"kon", "\[Rule]", " ", "c2"}]}], "}"}]}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "inputcatheter1", ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0.01", ",", "12"}], "}"}], ",", " ", "t", ",", " ", 
      "x"}], "]"}]}], "/.", 
   RowBox[{"t", "\[Rule]", "t1"}]}]}]], "Input",
 CellLabel->"In[39]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindMinimum", "[", 
  RowBox[{
   RowBox[{"X2Fit", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"koff", ",", "kon"}], "}"}], ",", "dataPhysio", ",", " ", 
     RowBox[{"X1", "[", 
      RowBox[{"t", ",", "koff", ",", "kon"}], "]"}], ",", "   ", "t"}], "]"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"koff", ",", "0.1", ",", "1"}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"kon", ",", "0.1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[40]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"601.2380611824017`", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"koff", "\[Rule]", "0.10197098051295153`"}], ",", 
      RowBox[{"kon", "\[Rule]", "0.6871131747771675`"}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399028824361997*^9, 3.4798168954994187`*^9, 
  3.4798259633359513`*^9, 3.480242790283623*^9, 3.5194424357726727`*^9, 
  3.5399258837087173`*^9, 3.5405367807979136`*^9, 3.5871963677115*^9, 
  3.642762310063319*^9, 3.6435259869790187`*^9, 3.650608066834014*^9},
 CellLabel->"Out[40]="]
}, Open  ]],

Cell["Method 4", "Text",
 CellChangeTimes->{{3.5871966470934353`*^9, 3.5871966479905252`*^9}},
 FontWeight->"Bold"],

Cell[TextData[{
 StyleBox["FindFit", "Input"],
 " and ",
 StyleBox["NonlinearModelFit",
  FontWeight->"Bold"],
 "  are applied "
}], "Text",
 CellChangeTimes->{{3.479816982716494*^9, 3.4798169968724723`*^9}, {
  3.5871971138910456`*^9, 3.587197120379694*^9}, {3.587197588349342*^9, 
  3.5871976541291866`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X1a", " ", "=", 
  RowBox[{
   SubscriptBox["x", "1"], "/.", 
   RowBox[{"ParametricSystemNDSolve", "[", 
    RowBox[{"physiomodel1", ",", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "inputcatheter1", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0.01", ",", "12"}], "}"}], ",", " ", "x", ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{"koff", ",", " ", "kon"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5871967533260574`*^9, 3.5871967725769825`*^9}, 
   3.587196875205244*^9, {3.5871971562572813`*^9, 3.587197160880744*^9}},
 CellLabel->"In[41]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TemplateBox[{RowBox[{
       StyleBox[
        TagBox["ParametricFunction", "SummaryHead"], 
        "NonInterpretableSummary"], 
       StyleBox["[", "NonInterpretableSummary"], 
       DynamicModuleBox[{Typeset`open$$ = False}, 
        PanelBox[
         PaneSelectorBox[{False -> GridBox[{{
               PaneBox[
                ButtonBox[
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "FEBitmaps", "SquarePlusIconMedium"]], 
                 ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                 None, Evaluator -> Automatic, Method -> "Preemptive"], 
                Alignment -> {Center, Center}, ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}]], 
               GraphicsBox[{{}, {}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                   0.0874367476365131, 0.08197166587636243}, {
                   0.18222810297558026`, 0.1358255024317191}, {
                   0.27073779576926765`, 0.13315455086535802`}, {
                   0.3575112797365835, 0.08143316377978886}, {
                   0.4516394623155443, -0.007347854733426912}, {
                   0.5394859823491253, -0.08816932746972758}, {
                   0.6346872009943513, -0.13787329990112937`}, {
                   0.7281522108132057, -0.12816574147938434`}, {
                   0.8153355580866803, -0.07001063326902106}, {
                   0.9098736039718, 0.02121659675083076}, {0.9999999090909091,
                    0.10024804094746914`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                   0.0874367476365131, 0.08090369567458766}, {
                   0.18222810297558026`, 0.12746559200130417`}, {
                   0.27073779576926765`, 0.1116266937044405}, {
                   0.3575112797365835, 0.046963725126600256`}, {
                   0.4516394623155443, -0.04509050859182233}, {
                   0.5394859823491253, -0.11115559892361665`}, {
                   0.6346872009943513, -0.12642564594664163`}, {
                   0.7281522108132057, -0.07740196037964171}, {
                   0.8153355580866803, 0.004179083230780074}, {
                   0.9098736039718, 0.08937493944143977}, {0.9999999090909091,
                    0.12834702174618903`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                   0.0874367476365131, 0.07984396759533968}, {
                   0.18222810297558026`, 0.11939549826670079`}, {
                   0.27073779576926765`, 0.09184904274707059}, {
                   0.3575112797365835, 0.017913117173780694`}, {
                   0.4516394623155443, -0.07109962300031061}, {
                   0.5394859823491253, -0.11717052830989395`}, {
                   0.6346872009943513, -0.09879571259704382}, {
                   0.7281522108132057, -0.022693471356141894`}, {
                   0.8153355580866803, 0.06128703302641453}, {0.9098736039718,
                    0.11605625481609519`}, {0.9999999090909091, 
                   0.10415981267620744`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                   0.0874367476365131, 0.07879243663407876}, {
                   0.18222810297558026`, 0.1116081822210312}, {
                   0.27073779576926765`, 0.07372482040530459}, {
                   0.3575112797365835, -0.006267252216927747}, {
                   0.4516394623155443, -0.08743897872291118}, {
                   0.5394859823491253, -0.11109134853087661`}, {
                   0.6346872009943513, -0.06371549528296311}, {
                   0.7281522108132057, 0.02544576624054603}, {
                   0.8153355580866803, 0.09464282937855747}, {0.9098736039718,
                    0.10731931496853601`}, {0.9999999090909091, 
                   0.0516787429232188}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                   0.0874367476365131, 0.07774905743802465}, {
                   0.18222810297558026`, 0.10409673959866513`}, {
                   0.27073779576926765`, 0.05716133039337165}, {
                   0.3575112797365835, -0.026084496726167965`}, {
                   0.4516394623155443, -0.09591154799603378}, {
                   0.5394859823491253, -0.09685594593277226}, {
                   0.6346872009943513, -0.02730376120671303}, {
                   0.7281522108132057, 0.061646715198529656`}, {
                   0.8153355580866803, 0.1046634148537508}, {0.9098736039718, 
                   0.07509702498429204}, {
                   0.9999999090909091, -0.006536873471333553}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                   0.0874367476365131, 0.07671378556951527}, {
                   0.18222810297558026`, 0.09685439581479163}, {
                   0.27073779576926765`, 0.042069810325321415`}, {
                   0.3575112797365835, -0.042006785469922474`}, {
                   0.4516394623155443, -0.09808544986431629}, {
                   0.5394859823491253, -0.07760167026270944}, {
                   0.6346872009943513, 0.0063643674428021085`}, {
                   0.7281522108132057, 0.08405712128907425}, {
                   0.8153355580866803, 0.09555213349985489}, {0.9098736039718,
                    0.03202960165577907}, {
                   0.9999999090909091, -0.054402034659985464`}}]}}, 
                AspectRatio -> 1, Axes -> {False, False}, 
                AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Background -> 
                GrayLevel[0.93], BaseStyle -> {FontFamily -> "Arial"}, 
                DisplayFunction -> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Thickness[Tiny], 
                  GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}},
                 GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                  Dynamic[
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                Method -> {"ScalingFunctions" -> None}, 
                PlotRange -> {All, All}, PlotRangeClipping -> True, 
                PlotRangePadding -> {Automatic, Automatic}, 
                Ticks -> {Automatic, Automatic}], 
               GridBox[{{
                  RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "1"], HoldForm], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"koff", ",", "kon"}], "}"}], "SummaryItem"]}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {
                 "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                BaseStyle -> {
                 ShowStringCharacters -> False, NumberMarks -> False, 
                  PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
             GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             BaselinePosition -> {1, 1}], True -> GridBox[{{
               PaneBox[
                ButtonBox[
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "FEBitmaps", "SquareMinusIconMedium"]], 
                 ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                 None, Evaluator -> Automatic, Method -> "Preemptive"], 
                Alignment -> {Center, Center}, ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}]], 
               GraphicsBox[{{}, {}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                   0.0874367476365131, 0.08197166587636243}, {
                   0.18222810297558026`, 0.1358255024317191}, {
                   0.27073779576926765`, 0.13315455086535802`}, {
                   0.3575112797365835, 0.08143316377978886}, {
                   0.4516394623155443, -0.007347854733426912}, {
                   0.5394859823491253, -0.08816932746972758}, {
                   0.6346872009943513, -0.13787329990112937`}, {
                   0.7281522108132057, -0.12816574147938434`}, {
                   0.8153355580866803, -0.07001063326902106}, {
                   0.9098736039718, 0.02121659675083076}, {0.9999999090909091,
                    0.10024804094746914`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                   0.0874367476365131, 0.08090369567458766}, {
                   0.18222810297558026`, 0.12746559200130417`}, {
                   0.27073779576926765`, 0.1116266937044405}, {
                   0.3575112797365835, 0.046963725126600256`}, {
                   0.4516394623155443, -0.04509050859182233}, {
                   0.5394859823491253, -0.11115559892361665`}, {
                   0.6346872009943513, -0.12642564594664163`}, {
                   0.7281522108132057, -0.07740196037964171}, {
                   0.8153355580866803, 0.004179083230780074}, {
                   0.9098736039718, 0.08937493944143977}, {0.9999999090909091,
                    0.12834702174618903`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                   0.0874367476365131, 0.07984396759533968}, {
                   0.18222810297558026`, 0.11939549826670079`}, {
                   0.27073779576926765`, 0.09184904274707059}, {
                   0.3575112797365835, 0.017913117173780694`}, {
                   0.4516394623155443, -0.07109962300031061}, {
                   0.5394859823491253, -0.11717052830989395`}, {
                   0.6346872009943513, -0.09879571259704382}, {
                   0.7281522108132057, -0.022693471356141894`}, {
                   0.8153355580866803, 0.06128703302641453}, {0.9098736039718,
                    0.11605625481609519`}, {0.9999999090909091, 
                   0.10415981267620744`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                   0.0874367476365131, 0.07879243663407876}, {
                   0.18222810297558026`, 0.1116081822210312}, {
                   0.27073779576926765`, 0.07372482040530459}, {
                   0.3575112797365835, -0.006267252216927747}, {
                   0.4516394623155443, -0.08743897872291118}, {
                   0.5394859823491253, -0.11109134853087661`}, {
                   0.6346872009943513, -0.06371549528296311}, {
                   0.7281522108132057, 0.02544576624054603}, {
                   0.8153355580866803, 0.09464282937855747}, {0.9098736039718,
                    0.10731931496853601`}, {0.9999999090909091, 
                   0.0516787429232188}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                   0.0874367476365131, 0.07774905743802465}, {
                   0.18222810297558026`, 0.10409673959866513`}, {
                   0.27073779576926765`, 0.05716133039337165}, {
                   0.3575112797365835, -0.026084496726167965`}, {
                   0.4516394623155443, -0.09591154799603378}, {
                   0.5394859823491253, -0.09685594593277226}, {
                   0.6346872009943513, -0.02730376120671303}, {
                   0.7281522108132057, 0.061646715198529656`}, {
                   0.8153355580866803, 0.1046634148537508}, {0.9098736039718, 
                   0.07509702498429204}, {
                   0.9999999090909091, -0.006536873471333553}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                   0.0874367476365131, 0.07671378556951527}, {
                   0.18222810297558026`, 0.09685439581479163}, {
                   0.27073779576926765`, 0.042069810325321415`}, {
                   0.3575112797365835, -0.042006785469922474`}, {
                   0.4516394623155443, -0.09808544986431629}, {
                   0.5394859823491253, -0.07760167026270944}, {
                   0.6346872009943513, 0.0063643674428021085`}, {
                   0.7281522108132057, 0.08405712128907425}, {
                   0.8153355580866803, 0.09555213349985489}, {0.9098736039718,
                    0.03202960165577907}, {
                   0.9999999090909091, -0.054402034659985464`}}]}}, 
                AspectRatio -> 1, Axes -> {False, False}, 
                AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Background -> 
                GrayLevel[0.93], BaseStyle -> {FontFamily -> "Arial"}, 
                DisplayFunction -> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Thickness[Tiny], 
                  GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}},
                 GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                  Dynamic[
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                Method -> {"ScalingFunctions" -> None}, 
                PlotRange -> {All, All}, PlotRangeClipping -> True, 
                PlotRangePadding -> {Automatic, Automatic}, 
                Ticks -> {Automatic, Automatic}], 
               GridBox[{{
                  RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "1"], HoldForm], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"koff", ",", "kon"}], "}"}], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Generator: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["ParametricNDSolve", "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox[
                    "\"Dependent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "TemporaryVariable$65668", ",", "TemporaryVariable$65669",
                     ",", "TemporaryVariable$65670"}], "}"}], 
                    "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox[
                    "\"Independent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", "t", "}"}], "SummaryItem"]}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {
                 "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                BaseStyle -> {
                 ShowStringCharacters -> False, NumberMarks -> False, 
                  PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
             GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             BaselinePosition -> {1, 1}]}, 
          Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
         Baseline], DynamicModuleValues :> {}], 
       StyleBox["]", "NonInterpretableSummary"]}]},
    "CopyTag",
    DisplayFunction->(#& ),
    InterpretationFunction->("ParametricFunction[<>]"& )],
   False,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], TraditionalForm]], "Output",
 CellChangeTimes->{3.5871966132220483`*^9, 3.587196773468072*^9, 
  3.587196965730296*^9, 3.587197171803836*^9, 3.587197858604554*^9, 
  3.5871979347813077`*^9, 3.642762310141456*^9, 3.6435259870415177`*^9, 
  3.6506080669277544`*^9},
 CellLabel->"Out[41]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"FindFit", "[", 
   RowBox[{"dataPhysio", ",", " ", 
    RowBox[{
     RowBox[{"X1a", "[", 
      RowBox[{"koff", ",", "kon"}], "]"}], "[", "t", "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"koff", ",", "0.1", ",", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"kon", ",", "0.1", ",", "1"}], "}"}]}], "}"}], ",", " ", "t"}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.5871970199944286`*^9, 3.587197031312834*^9}, {
  3.587197079348592*^9, 3.5871970998066373`*^9}, {3.587197132106867*^9, 
  3.5871971329919553`*^9}},
 CellLabel->"In[42]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"koff", "\[Rule]", "0.10198874081907837`"}], ",", 
    RowBox[{"kon", "\[Rule]", "0.6871372257656772`"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.399028945767361*^9, 3.479817012184678*^9, 3.479826080794338*^9, 
   3.4802428480972233`*^9, 3.519442501945818*^9, 3.539925921521943*^9, 
   3.5405368223612113`*^9, 3.587196443731101*^9, 3.5871970413437915`*^9, 
   3.587197084818138*^9, {3.587197126619318*^9, 3.5871971344200983`*^9}, 
   3.5871971734490004`*^9, 3.5871978599773893`*^9, 3.587197936232145*^9, 
   3.642762310641457*^9, 3.6435259874946556`*^9, 3.6506080673340054`*^9},
 CellLabel->"Out[42]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{
    RowBox[{"koff_", "?", "NumericQ"}], ",", 
    RowBox[{"kon_", "?", "NumericQ"}], ",", " ", "t_"}], "]"}], "=", 
  RowBox[{
   RowBox[{"X1a", "[", 
    RowBox[{"koff", ",", "kon"}], "]"}], "[", "t", "]"}]}]], "Input",
 CellChangeTimes->{{3.587197969668759*^9, 3.5871980312729187`*^9}},
 CellLabel->"In[43]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["ParametricFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  GraphicsBox[{{}, {}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                    0.0874367476365131, 0.08197166587636243}, {
                    0.18222810297558026`, 0.1358255024317191}, {
                    0.27073779576926765`, 0.13315455086535802`}, {
                    0.3575112797365835, 0.08143316377978886}, {
                    0.4516394623155443, -0.007347854733426912}, {
                    0.5394859823491253, -0.08816932746972758}, {
                    0.6346872009943513, -0.13787329990112937`}, {
                    0.7281522108132057, -0.12816574147938434`}, {
                    0.8153355580866803, -0.07001063326902106}, {
                    0.9098736039718, 0.02121659675083076}, {
                    0.9999999090909091, 0.10024804094746914`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                    0.0874367476365131, 0.08090369567458766}, {
                    0.18222810297558026`, 0.12746559200130417`}, {
                    0.27073779576926765`, 0.1116266937044405}, {
                    0.3575112797365835, 0.046963725126600256`}, {
                    0.4516394623155443, -0.04509050859182233}, {
                    0.5394859823491253, -0.11115559892361665`}, {
                    0.6346872009943513, -0.12642564594664163`}, {
                    0.7281522108132057, -0.07740196037964171}, {
                    0.8153355580866803, 0.004179083230780074}, {
                    0.9098736039718, 0.08937493944143977}, {
                    0.9999999090909091, 0.12834702174618903`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                    0.0874367476365131, 0.07984396759533968}, {
                    0.18222810297558026`, 0.11939549826670079`}, {
                    0.27073779576926765`, 0.09184904274707059}, {
                    0.3575112797365835, 0.017913117173780694`}, {
                    0.4516394623155443, -0.07109962300031061}, {
                    0.5394859823491253, -0.11717052830989395`}, {
                    0.6346872009943513, -0.09879571259704382}, {
                    0.7281522108132057, -0.022693471356141894`}, {
                    0.8153355580866803, 0.06128703302641453}, {
                    0.9098736039718, 0.11605625481609519`}, {
                    0.9999999090909091, 0.10415981267620744`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                    0.0874367476365131, 0.07879243663407876}, {
                    0.18222810297558026`, 0.1116081822210312}, {
                    0.27073779576926765`, 0.07372482040530459}, {
                    0.3575112797365835, -0.006267252216927747}, {
                    0.4516394623155443, -0.08743897872291118}, {
                    0.5394859823491253, -0.11109134853087661`}, {
                    0.6346872009943513, -0.06371549528296311}, {
                    0.7281522108132057, 0.02544576624054603}, {
                    0.8153355580866803, 0.09464282937855747}, {
                    0.9098736039718, 0.10731931496853601`}, {
                    0.9999999090909091, 0.0516787429232188}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                    0.0874367476365131, 0.07774905743802465}, {
                    0.18222810297558026`, 0.10409673959866513`}, {
                    0.27073779576926765`, 0.05716133039337165}, {
                    0.3575112797365835, -0.026084496726167965`}, {
                    0.4516394623155443, -0.09591154799603378}, {
                    0.5394859823491253, -0.09685594593277226}, {
                    0.6346872009943513, -0.02730376120671303}, {
                    0.7281522108132057, 0.061646715198529656`}, {
                    0.8153355580866803, 0.1046634148537508}, {0.9098736039718,
                     0.07509702498429204}, {
                    0.9999999090909091, -0.006536873471333553}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                    0.0874367476365131, 0.07671378556951527}, {
                    0.18222810297558026`, 0.09685439581479163}, {
                    0.27073779576926765`, 0.042069810325321415`}, {
                    0.3575112797365835, -0.042006785469922474`}, {
                    0.4516394623155443, -0.09808544986431629}, {
                    0.5394859823491253, -0.07760167026270944}, {
                    0.6346872009943513, 0.0063643674428021085`}, {
                    0.7281522108132057, 0.08405712128907425}, {
                    0.8153355580866803, 0.09555213349985489}, {
                    0.9098736039718, 0.03202960165577907}, {
                    0.9999999090909091, -0.054402034659985464`}}]}}, 
                   AspectRatio -> 1, Axes -> {False, False}, 
                   AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
                   Background -> GrayLevel[0.93], 
                   BaseStyle -> {FontFamily -> "Arial"}, DisplayFunction -> 
                   Identity, Frame -> {{True, True}, {True, True}}, 
                   FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                   Directive[
                    Thickness[Tiny], 
                    GrayLevel[0.7]], 
                   FrameTicks -> {{None, None}, {None, None}}, 
                   GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                    Dynamic[
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                   Method -> {"ScalingFunctions" -> None}, 
                   PlotRange -> {All, All}, PlotRangeClipping -> True, 
                   PlotRangePadding -> {Automatic, Automatic}, 
                   Ticks -> {Automatic, Automatic}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "1"], HoldForm], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"koff", ",", "kon"}], "}"}], "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  GraphicsBox[{{}, {}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                    0.0874367476365131, 0.08197166587636243}, {
                    0.18222810297558026`, 0.1358255024317191}, {
                    0.27073779576926765`, 0.13315455086535802`}, {
                    0.3575112797365835, 0.08143316377978886}, {
                    0.4516394623155443, -0.007347854733426912}, {
                    0.5394859823491253, -0.08816932746972758}, {
                    0.6346872009943513, -0.13787329990112937`}, {
                    0.7281522108132057, -0.12816574147938434`}, {
                    0.8153355580866803, -0.07001063326902106}, {
                    0.9098736039718, 0.02121659675083076}, {
                    0.9999999090909091, 0.10024804094746914`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                    0.0874367476365131, 0.08090369567458766}, {
                    0.18222810297558026`, 0.12746559200130417`}, {
                    0.27073779576926765`, 0.1116266937044405}, {
                    0.3575112797365835, 0.046963725126600256`}, {
                    0.4516394623155443, -0.04509050859182233}, {
                    0.5394859823491253, -0.11115559892361665`}, {
                    0.6346872009943513, -0.12642564594664163`}, {
                    0.7281522108132057, -0.07740196037964171}, {
                    0.8153355580866803, 0.004179083230780074}, {
                    0.9098736039718, 0.08937493944143977}, {
                    0.9999999090909091, 0.12834702174618903`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                    0.0874367476365131, 0.07984396759533968}, {
                    0.18222810297558026`, 0.11939549826670079`}, {
                    0.27073779576926765`, 0.09184904274707059}, {
                    0.3575112797365835, 0.017913117173780694`}, {
                    0.4516394623155443, -0.07109962300031061}, {
                    0.5394859823491253, -0.11717052830989395`}, {
                    0.6346872009943513, -0.09879571259704382}, {
                    0.7281522108132057, -0.022693471356141894`}, {
                    0.8153355580866803, 0.06128703302641453}, {
                    0.9098736039718, 0.11605625481609519`}, {
                    0.9999999090909091, 0.10415981267620744`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                    0.0874367476365131, 0.07879243663407876}, {
                    0.18222810297558026`, 0.1116081822210312}, {
                    0.27073779576926765`, 0.07372482040530459}, {
                    0.3575112797365835, -0.006267252216927747}, {
                    0.4516394623155443, -0.08743897872291118}, {
                    0.5394859823491253, -0.11109134853087661`}, {
                    0.6346872009943513, -0.06371549528296311}, {
                    0.7281522108132057, 0.02544576624054603}, {
                    0.8153355580866803, 0.09464282937855747}, {
                    0.9098736039718, 0.10731931496853601`}, {
                    0.9999999090909091, 0.0516787429232188}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                    0.0874367476365131, 0.07774905743802465}, {
                    0.18222810297558026`, 0.10409673959866513`}, {
                    0.27073779576926765`, 0.05716133039337165}, {
                    0.3575112797365835, -0.026084496726167965`}, {
                    0.4516394623155443, -0.09591154799603378}, {
                    0.5394859823491253, -0.09685594593277226}, {
                    0.6346872009943513, -0.02730376120671303}, {
                    0.7281522108132057, 0.061646715198529656`}, {
                    0.8153355580866803, 0.1046634148537508}, {0.9098736039718,
                     0.07509702498429204}, {
                    0.9999999090909091, -0.006536873471333553}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                    0.0874367476365131, 0.07671378556951527}, {
                    0.18222810297558026`, 0.09685439581479163}, {
                    0.27073779576926765`, 0.042069810325321415`}, {
                    0.3575112797365835, -0.042006785469922474`}, {
                    0.4516394623155443, -0.09808544986431629}, {
                    0.5394859823491253, -0.07760167026270944}, {
                    0.6346872009943513, 0.0063643674428021085`}, {
                    0.7281522108132057, 0.08405712128907425}, {
                    0.8153355580866803, 0.09555213349985489}, {
                    0.9098736039718, 0.03202960165577907}, {
                    0.9999999090909091, -0.054402034659985464`}}]}}, 
                   AspectRatio -> 1, Axes -> {False, False}, 
                   AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
                   Background -> GrayLevel[0.93], 
                   BaseStyle -> {FontFamily -> "Arial"}, DisplayFunction -> 
                   Identity, Frame -> {{True, True}, {True, True}}, 
                   FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                   Directive[
                    Thickness[Tiny], 
                    GrayLevel[0.7]], 
                   FrameTicks -> {{None, None}, {None, None}}, 
                   GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                    Dynamic[
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                   Method -> {"ScalingFunctions" -> None}, 
                   PlotRange -> {All, All}, PlotRangeClipping -> True, 
                   PlotRangePadding -> {Automatic, Automatic}, 
                   Ticks -> {Automatic, Automatic}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "1"], HoldForm], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"koff", ",", "kon"}], "}"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Generator: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["ParametricNDSolve", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"Dependent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "TemporaryVariable$65668", ",", "TemporaryVariable$65669",
                     ",", "TemporaryVariable$65670"}], "}"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"Independent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", "t", "}"}], "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("ParametricFunction[<>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", 
      RowBox[{"koff", ",", "kon"}], ")"}]}], ")"}], "\[InvisibleApplication]", 
   RowBox[{"(", "t", ")"}]}], TraditionalForm]], "Output",
 CellChangeTimes->{3.5871980581056013`*^9, 3.642762310657073*^9, 
  3.64352598751027*^9, 3.6506080674902534`*^9},
 CellLabel->"Out[43]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "=", " ", 
  RowBox[{"NonlinearModelFit", "[", 
   RowBox[{"dataPhysio", ",", " ", 
    RowBox[{"f", "[", 
     RowBox[{"koff", ",", "kon", ",", " ", "t"}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"koff", ",", "0.1", ",", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"kon", ",", "0.1", ",", "1"}], "}"}]}], "}"}], ",", " ", "t"}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.587197231022916*^9, 3.5871972349594803`*^9}, {
   3.5871972699135265`*^9, 3.5871972971382046`*^9}, {3.587197413683777*^9, 
   3.587197420480571*^9}, 3.5871975290692577`*^9, {3.587197882067556*^9, 
   3.587197886264064*^9}, {3.5871979435955334`*^9, 3.587197950756117*^9}, {
   3.5871980440611973`*^9, 3.587198053639155*^9}, {3.5871980908268733`*^9, 
   3.5871980928900795`*^9}},
 CellLabel->"In[44]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   RowBox[{"FittedModel", "[", 
    TagBox[
     PanelBox[
      TagBox[
       RowBox[{
        TagBox[
         TemplateBox[{RowBox[{
             StyleBox[
              TagBox["InterpolatingFunction", "SummaryHead"], 
              "NonInterpretableSummary"], 
             StyleBox["[", "NonInterpretableSummary"], 
             DynamicModuleBox[{Typeset`open$$ = False}, 
              PanelBox[
               PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{0.010000203220338984`, 1.8209866479862908`}, {
                    0.015499057174104668`, 5.3627744307321175`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAACLHjEFnF9j8hR+8je3MVQOTH6i9Y
3PY/LdOAs69IFUCqbCNLIzT6P7MDGCJ2ihFAwpV6G2pS/T/uai+wrwIOQE9n
KDYEWgBAv8vTOWiwCUDmxSI5Ee4BQMCujzZ8bAZA5H08Yyt6A0AIXDq6IMcD
QMS9lU3xJwVAjmmLm3FoAUDNP34S9bgGQOrQabPxKf8/uEmml6RrCEB5mWza
puT7Pwqt7UNhFgpAAprusxlB+T+FUsTKW6QLQBOLC1GPNvc/4n/aEQJUDUDL
07wbU2D1P2jvfzPm5g5AniDwE0j08z9oc7IKu00QQLrJ2cfTrPI/z5s0jwkk
EUBm9WMxEKPxP0tl/gD36xFABkpn0gvU8D+48udSusQSQM5rxKRNGPA/OSEZ
khyPE0BLAS4g9QrvP2782WSFVRRAJ6KcLSYX7j+Um7oXxCwVQPi1625zN+0/
ztvit6H1FUBhsaGvX4bsP/nfKjhVzxZARss8Ztri6z/YkAJMD6UXQCHL7M33
Wes/y+IhTWhsGEBSvtGRrevqP6/4YC6XRBlAmd6YBrSD6j+or+f8ZA4aQKKF
4BjJLuo/VBP+XjnUGkDfDdo19uTpP/E6NKHjqhtAaxF0OJqd6T+jA7LQLHMc
QN/67WPVYek/RpBP4EtMHUDMYZq4KyfpP/29NN0JFx5Ae14eiSr16D9omKlt
zt0eQAeaTzHbx+g/xDY+3mi1H0AQ57vVKproPxo7DR5RPyBAqadMpjpy6D/L
PAu9WKwgQOi+dkJlSeg/1RTRpWMXIUCpC7d0XSPoP2q9OgU+eyFAIwTuF2wB
6D/3R7RUg+chQFDvPnME3uc/DqPRGphMIkAdLQTvEb7nP3/UtiqwryJARKQN
t6Cf5z/o56sqMxsjQEM+FA5vf+c/3MtEoYV/I0D5Q3SgD2LnP8iR7QdD7CNA
LnL8tdhC5z8OLl64A1ckQNyJlpO+JOc/3ppy35O6JECPZQKSFgnnP6fplvaO
JiVA5zrSEX7r5j/6CF+EWYslQDhe6o8y0OY/RQo3Ao/4JUCwVOsc8bLmP+rh
1snHYyZAmSuywoGW5j8ZihoI0McmQKGalBE2fOY/QRRuNkM0J0CYCQEc71/m
P/NuZduFmSdAHvMQO7tF5j/AWS75//8nQKUwC3JlK+Y/eouPtw==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.2}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0.01, 12.}, {0.6927973964134436, 
                    5.3627744307321175`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.01`", "12.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                   GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                   False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[{{{}, {}, {
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    
                    LineBox[{{0.010000203220338984`, 1.8209866479862908`}, {
                    0.015499057174104668`, 5.3627744307321175`}}], 
                    LineBox[CompressedData["
1:eJwBcQOO/CFib1JlAgAAADYAAAACAAAACLHjEFnF9j8hR+8je3MVQOTH6i9Y
3PY/LdOAs69IFUCqbCNLIzT6P7MDGCJ2ihFAwpV6G2pS/T/uai+wrwIOQE9n
KDYEWgBAv8vTOWiwCUDmxSI5Ee4BQMCujzZ8bAZA5H08Yyt6A0AIXDq6IMcD
QMS9lU3xJwVAjmmLm3FoAUDNP34S9bgGQOrQabPxKf8/uEmml6RrCEB5mWza
puT7Pwqt7UNhFgpAAprusxlB+T+FUsTKW6QLQBOLC1GPNvc/4n/aEQJUDUDL
07wbU2D1P2jvfzPm5g5AniDwE0j08z9oc7IKu00QQLrJ2cfTrPI/z5s0jwkk
EUBm9WMxEKPxP0tl/gD36xFABkpn0gvU8D+48udSusQSQM5rxKRNGPA/OSEZ
khyPE0BLAS4g9QrvP2782WSFVRRAJ6KcLSYX7j+Um7oXxCwVQPi1625zN+0/
ztvit6H1FUBhsaGvX4bsP/nfKjhVzxZARss8Ztri6z/YkAJMD6UXQCHL7M33
Wes/y+IhTWhsGEBSvtGRrevqP6/4YC6XRBlAmd6YBrSD6j+or+f8ZA4aQKKF
4BjJLuo/VBP+XjnUGkDfDdo19uTpP/E6NKHjqhtAaxF0OJqd6T+jA7LQLHMc
QN/67WPVYek/RpBP4EtMHUDMYZq4KyfpP/29NN0JFx5Ae14eiSr16D9omKlt
zt0eQAeaTzHbx+g/xDY+3mi1H0AQ57vVKproPxo7DR5RPyBAqadMpjpy6D/L
PAu9WKwgQOi+dkJlSeg/1RTRpWMXIUCpC7d0XSPoP2q9OgU+eyFAIwTuF2wB
6D/3R7RUg+chQFDvPnME3uc/DqPRGphMIkAdLQTvEb7nP3/UtiqwryJARKQN
t6Cf5z/o56sqMxsjQEM+FA5vf+c/3MtEoYV/I0D5Q3SgD2LnP8iR7QdD7CNA
LnL8tdhC5z8OLl64A1ckQNyJlpO+JOc/3ppy35O6JECPZQKSFgnnP6fplvaO
JiVA5zrSEX7r5j/6CF+EWYslQDhe6o8y0OY/RQo3Ao/4JUCwVOsc8bLmP+rh
1snHYyZAmSuywoGW5j8ZihoI0McmQKGalBE2fOY/QRRuNkM0J0CYCQEc71/m
P/NuZduFmSdAHvMQO7tF5j/AWS75//8nQKUwC3JlK+Y/eouPtw==
                    "]]}}}, {
                    DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.2}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
                    AbsolutePointSize[6], "ScalingFunctions" -> None}, 
                    PlotRange -> {{0.01, 12.}, {0.6927973964134436, 
                    5.3627744307321175`}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.01`", "12.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                   GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                   False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   BaselinePosition -> {1, 1}]}, 
                Dynamic[Typeset`open$$], ImageSize -> Automatic], 
               BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
             StyleBox["]", "NonInterpretableSummary"]}]},
          "CopyTag",
          DisplayFunction->(#& ),
          
          InterpretationFunction->(
           "InterpolatingFunction[{{0.01, 12.}}, <>]"& )],
         False,
         Editable->False,
         SelectWithContents->True,
         Selectable->False], "\[InvisibleApplication]", 
        RowBox[{"(", "t", ")"}]}],
       Short[#, 2]& ],
      FrameMargins->5],
     Editable -> False], "]"}],
   InterpretTemplate[
   FittedModel[{
     "Nonlinear", {$CellContext`koff -> 
       0.10198874081907837`, $CellContext`kon -> 
       0.6871372257656772}, {{$CellContext`t}, 
       Biokmod`Master`f[$CellContext`koff, $CellContext`kon, \
$CellContext`t]}}, {1}, CompressedData["
1:eJxTTMoPSmViYGBQAmIQvUOu9XXgjnn2DCDQYO1QLbLO/WHVFnsQKeLn4fAm
EKTioj1YeE2CgzxIudxVe7B4d5RDENiAG/bXFxfYcrGHO0DMu2cf03/oq4aN
n8OsmSDw0B6szdXH4ewZEHhiD7Znl7UD2F6GFxD7HcwdjMHgtb0myIAV+g5p
YPDOfgnQ+OuLtaH6P0DkNVSh8p/sIe6Qh5r3xR4iLgu1/ytUXgJq/neIe6+L
QOV/2kPcLQA1/w9UnhtqHoMDMDSADmaDqmd0AFsfwww1jxkqzwDVz+IADi8R
Bqj72KDqfkP8ycDh4AHW8NMeIs4N50Pk+Ry4wA74DuULwv0B4QtD7fkC5Ys6
QMIHxpeGxttLKF/W4ZsGyMXQcGaQh7r/OTTeFVDjgUHN4fBXkIan9gDBgNDs

     "], 
     Function[Null, 
      Internal`LocalizedBlock[{$CellContext`koff, $CellContext`kon, \
$CellContext`t}, #], {HoldAll}]]& ],
   Editable->False,
   SelectWithContents->True,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{3.587197299602152*^9, 3.587197541376492*^9, 
  3.587197861069418*^9, 3.5871979366533556`*^9, 3.5871980599127827`*^9, 
  3.5871980953173227`*^9, 3.642762311141449*^9, 3.643525987994697*^9, 
  3.6506080679590044`*^9},
 CellLabel->"Out[44]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", "\"\<ParameterTable\>\"", "]"}]], "Input",
 CellLabel->"In[45]:=",
 CellID->402834626],

Cell[BoxData[
 FormBox[
  StyleBox[
   TagBox[GridBox[{
      {"\<\"\"\>", "\<\"Estimate\"\>", "\<\"Standard Error\"\>", "\<\"t\
\[Hyphen]Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
      {"koff", "0.10198874081907837`", "0.25072706815011314`", 
       "0.4067719595317748`", "0.6868834571188811`"},
      {"kon", "0.6871372257656772`", "0.3819222081977634`", 
       "1.7991549352633354`", "0.08143155320052418`"}
     },
     AutoDelete->False,
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
     GridBoxDividers->{
      "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
       "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
     GridBoxSpacings->{
      "ColumnsIndexed" -> {2 -> 1}, "RowsIndexed" -> {2 -> 0.75}}],
    "Grid"], "DialogStyle",
   StripOnInput->False], TraditionalForm]], "Output",
 CellChangeTimes->{3.5871981069864893`*^9, 3.642762311250822*^9, 
  3.643525988104021*^9, 3.6506080679902544`*^9},
 CellLabel->"Out[45]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"physiomodel1", ",", " ", "inputcatheter1", ",", " ", "X1"}], 
  "]"}]], "Input",
 CellLabel->"In[46]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 4", "SubsubsectionIcon"],

Cell[TextData[{
 "Here are expanded the previous example for fitting ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "Tu"], TraditionalForm]]],
 ",  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "off"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "on"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["V", "p"], TraditionalForm]]],
 ", PS"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"X1", "[", 
    RowBox[{
    "s_", ",", " ", "c1_", ",", "c2_", ",", "c3_", ",", " ", "c4_", ",", " ", 
     "c5_"}], " ", "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["X", "1"], "[", "s", "]"}], "/.", 
     RowBox[{"SystemLTSolve", "[", 
      RowBox[{"physiomodel", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "inputcatheter", ",", 
       " ", "t", ",", "s", ",", " ", "X"}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"VTu", "->", " ", "c1"}], ",", 
      RowBox[{"koff", "->", "c2"}], " ", ",", " ", 
      RowBox[{"kon", "->", "c3"}], ",", " ", 
      RowBox[{"Vp", "->", " ", "c4"}], ",", " ", 
      RowBox[{"PS", "->", " ", "c5"}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[47]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"sse2", "[", 
   RowBox[{
    RowBox[{"VTu_", "?", "NumberQ"}], ",", 
    RowBox[{"koff_", "?", "NumberQ"}], ",", 
    RowBox[{"kon_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"Vp_", "?", "NumberQ"}], ",", 
    RowBox[{"PS_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sol", ",", "q1"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"q1", "[", "t_", "]"}], "=", 
      RowBox[{"InverseLaplaceTransform", "[", 
       RowBox[{
        RowBox[{"X1", "[", 
         RowBox[{
         "s", ",", "VTu", ",", "koff", ",", "kon", ",", " ", "Vp", ",", 
          "PS"}], "]"}], ",", " ", "s", ",", " ", "t"}], "]"}]}], ";", 
     RowBox[{"Plus", "@@", 
      RowBox[{"Apply", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"q1", "[", "#1", "]"}], "-", "#2"}], ")"}], "^", "2"}], 
         "&"}], ",", "dataPhysio", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}]}]}]}], "]"}]}]], "Input",
 CellLabel->"In[48]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindMinimum", "[", 
  RowBox[{
   RowBox[{"sse2", "[", 
    RowBox[{"VTu", ",", "koff", ",", " ", "kon", ",", "Vp", ",", " ", "PS"}], 
    "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"VTu", ",", "10", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"koff", ",", "0.1", ",", "0.3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"kon", ",", "0.4", ",", "0.7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Vp", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"PS", ",", "4", ",", "5"}], "}"}], ",", " ", 
   RowBox[{"MaxIterations", "\[Rule]", "50"}]}], "]"}]], "Input",
 CellLabel->"In[49]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"600.6827205673695`", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"VTu", "\[Rule]", "6.735962533257874`"}], ",", 
      RowBox[{"koff", "\[Rule]", "0.09457847337609512`"}], ",", 
      RowBox[{"kon", "\[Rule]", "0.6420139860530372`"}], ",", 
      RowBox[{"Vp", "\[Rule]", "0.9803261354534213`"}], ",", 
      RowBox[{"PS", "\[Rule]", "2.716948378239213`"}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399028954866782*^9, 3.4798170362310915`*^9, 
  3.4798260913573112`*^9, 3.480242854165623*^9, 3.519442511664755*^9, 
  3.539925927225178*^9, 3.540536828658207*^9, 3.6427623145945873`*^9, 
  3.6435259913696675`*^9, 3.6506080711777563`*^9},
 CellLabel->"Out[49]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{
  "sse2", ",", " ", "dataPhysio", ",", " ", "physiomodel", ",", 
   "inputcatheter", ",", "  ", "X1", ",", " ", "Q", ",", " ", "VTb"}], 
  "]"}]], "Input",
 CellLabel->"In[50]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 5", "SubsubsectionIcon"],

Cell[TextData[{
 "Sometime we need not only the values of fitted parameters but also \
additional statistic information such as confidence intervals, ANOVA table an \
so on. In this case we can apply ",
 Cell[BoxData[
  ButtonBox["NonlinearModelFit",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/NonlinearModelFit"]]],
 "."
}], "Text",
 CellChangeTimes->{{3.399029038210621*^9, 3.399029041046399*^9}, {
  3.5400088250647535`*^9, 3.5400088294085865`*^9}, {3.540536872174668*^9, 
  3.5405368791748023`*^9}}],

Cell[TextData[{
 "This figure represent the model of Iodine ICRP 78, compartment 1 represents \
the blood, compartment 2 the thyroid, 3 rest of body, and 4 the bladder, ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "40"], TraditionalForm]]],
 " means the rate transfer out of system  to urine) and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "30"], TraditionalForm]]],
 "means the rate transfer out of system  to ULI in GI system "
}], "Text"],

Cell[TextData[{
 "The problem is to fit the coeffs. ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "23"], TraditionalForm]]],
 " in the iodine model below figure using experimental data given in list \
dataIodine. "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataIodine", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.002"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "0.106"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "0.077"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"150", ",", "0.056"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"200", ",", "0.041"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"250", ",", "0.032"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "0.023"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"350", ",", "0.018"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"400", ",", "0.011"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"450", ",", "0.011"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"500", ",", "0.007"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[51]:="],

Cell["Also is assumed an input to the compartment 1 given by", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"iodo129h", " ", "=", 
   RowBox[{
    RowBox[{"34.4", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "200."}], " ", "t"}]]}], "+", 
    RowBox[{"1.09", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "110."}], " ", "t"}]]}], "+", 
    RowBox[{"0.808", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "102."}], " ", "t"}]]}], "+", 
    RowBox[{"6.414", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "100."}], " ", "t"}]]}], "+", 
    RowBox[{"5.458", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "24."}], " ", "t"}]]}]}]}], ";"}]], "Input",
 CellLabel->"In[52]:="],

Cell["\<\
This input has been previously obtained using the package function \
SystemNDSolve and it represents the input from respiratory tract (by \
inhalation) to thyroid. \
\>", "Text"],

Cell["The model can be built using SystemNDSolve   ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"model", "[", 
    RowBox[{
     RowBox[{"t1_", "?", "NumberQ"}], ",", 
     RowBox[{"k12_", "?", "NumberQ"}], ",", " ", 
     RowBox[{"k23_", "?", "NumberQ"}]}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{
     SubscriptBox["x", "2"], "[", "t1", "]"}], "/.", 
    RowBox[{"SystemNDSolve", "[", 
     RowBox[{
      RowBox[{"CompartMatrix", "[", 
       RowBox[{"3", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1.9404"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "k23"}], " ", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "0", ",", "0.01155"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "1", ",", "0.0462"}], "}"}]}], " ", "}"}]}], 
       "]"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"iodo129h", ",", " ", "0", ",", " ", "0"}], "}"}], " ", ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", " ", "0", ",", " ", "500"}], "}"}], ",", "t1", ",", 
      "x"}], "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[53]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "=", 
  RowBox[{"NonlinearModelFit", "[", 
   RowBox[{"dataIodine", ",", 
    RowBox[{"model", "[", 
     RowBox[{"t", ",", "a12", ",", "a23"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a12", ",", "0.8"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"a23", ",", "0.007"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", "t", "}"}], ",", 
    RowBox[{"Method", "\[Rule]", "Gradient"}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.479817474285181*^9, {3.4798177806074247`*^9, 3.4798177818574004`*^9}, 
   3.479818252754609*^9},
 CellLabel->"In[54]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   RowBox[{"FittedModel", "[", 
    TagBox[
     PanelBox[
      TagBox[
       RowBox[{"model", "(", 
        RowBox[{
        "t", ",", "0.8646999653139662`", ",", "0.008445926976848648`"}], ")"}],
       Short[#, 2]& ],
      FrameMargins->5],
     Editable -> False], "]"}],
   InterpretTemplate[
   FittedModel[{
     "Nonlinear", {$CellContext`a12 -> 0.8646999653139662, $CellContext`a23 -> 
       0.008445926976848648}, {{$CellContext`t}, 
       $CellContext`model[$CellContext`t, $CellContext`a12, \
$CellContext`a23]}}, {
     1}, {{0, 0.002}, {50, 0.106}, {100, 0.077}, {150, 0.056}, {200, 0.041}, {
      250, 0.032}, {300, 0.023}, {350, 0.018}, {400, 0.011}, {450, 0.011}, {
      500, 0.007}}, 
     Function[Null, 
      Internal`LocalizedBlock[{$CellContext`a12, $CellContext`a23, \
$CellContext`t}, #], {HoldAll}]]& ],
   Editable->False,
   SelectWithContents->True,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{3.539926198058503*^9, 3.539926745069005*^9, 
  3.5399278070268946`*^9, 3.539928734107194*^9, 3.5399303110437202`*^9, 
  3.5400091004450407`*^9, 3.5405369323008223`*^9, 3.5871985551753035`*^9, 
  3.6427623315164785`*^9, 3.6435260085884895`*^9, 3.6506080928183947`*^9},
 CellLabel->"Out[54]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "dataIodine", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlm", "[", "t", "]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", " ", "1", ",", " ", "500"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4798193621551833`*^9, 3.4798193811079445`*^9}, 
   3.479819411216741*^9, {3.479819449372258*^9, 3.479819450481612*^9}, {
   3.4798194881840134`*^9, 3.4798194958713655`*^9}, {3.4798195930101256`*^9, 
   3.4798196124316273`*^9}, {3.4798196631025295`*^9, 3.479819683805257*^9}, {
   3.4798197324761977`*^9, 3.479819755678877*^9}, 3.4798200018616505`*^9, {
   3.4798243993679132`*^9, 3.479824411665654*^9}, {3.479824950728523*^9, 
   3.479824953851483*^9}},
 CellLabel->"In[55]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{{}, {{}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[1.6], 
       PointBox[{{0., 0.002}, {50., 0.106}, {100., 0.077}, {150., 0.056}, {
        200., 0.041}, {250., 0.032}, {300., 0.023}, {350., 0.018}, {400., 
        0.011}, {450., 0.011}, {500., 0.007}}]}, {}}, {}}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVkHs41AkXxzHRKMSWJRWJcRktIq8nGedsoVxWTFQsurzllmtuw28ujNUm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       "]]}}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0, 500.}, {0, 0.106}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{{3.4798193851078672`*^9, 3.4798194134198236`*^9}, 
   3.4798194521222057`*^9, 3.4798195568858194`*^9, {3.479819664696249*^9, 
   3.4798196857270956`*^9}, 3.4798197348667765`*^9, 3.4798197853970566`*^9, 
   3.479820003752239*^9, 3.479823848843608*^9, 3.479824414322091*^9, 
   3.479824955569111*^9, 3.4798262386001263`*^9, 3.4802429264716234`*^9, 
   3.519442608166608*^9, 3.5399259789136705`*^9, 3.5399262072618046`*^9, 
   3.5399267456940174`*^9, 3.539927807714408*^9, 3.539928734779082*^9, 
   3.5399303120749903`*^9, 3.5400091113046246`*^9, 3.5405369328320827`*^9, 
   3.5871985559693832`*^9, 3.6427623319071045`*^9, 3.64352600896348*^9, 
   3.6506080932402697`*^9},
 CellLabel->"Out[55]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", "\"\<ParameterTable\>\"", "]"}]], "Input",
 CellLabel->"In[56]:=",
 CellID->36276479],

Cell[BoxData[
 FormBox[
  StyleBox[
   TagBox[GridBox[{
      {"\<\"\"\>", "\<\"Estimate\"\>", "\<\"Standard Error\"\>", "\<\"t\
\[Hyphen]Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
      {"a12", "0.8646999653139662`", "0.00032233583391285455`", 
       "2682.605761876736`", "7.077126066014754`*^-28"},
      {"a23", "0.008445926976848648`", "0.0000939357636473306`", 
       "89.91172955763435`", "1.3199175552868726`*^-14"}
     },
     AutoDelete->False,
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
     GridBoxDividers->{
      "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
       "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
     GridBoxSpacings->{
      "ColumnsIndexed" -> {2 -> 1}, "RowsIndexed" -> {2 -> 0.75}}],
    "Grid"], "DialogStyle",
   StripOnInput->False], TraditionalForm]], "Output",
 CellChangeTimes->{3.5405369330820875`*^9, 3.5871985565434403`*^9, 
  3.642762332078985*^9, 3.643526009135355*^9, 3.6506080934277697`*^9},
 ImageSize->{297, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[56]="]
}, Open  ]],

Cell[TextData[{
 "Extract the column of ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]], "InlineMath"],
 "-statistic values:"
}], "Text",
 CellID->291349166],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", "\"\<ParameterTStatistics\>\"", "]"}]], "Input",
 CellLabel->"In[57]:=",
 CellID->777746701],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"2682.605761876736`", ",", "89.91172955763435`"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.5400092209317293`*^9, 3.5405369333477173`*^9, 
  3.587198556978484*^9, 3.6427623322508526`*^9, 3.643526009307242*^9, 
  3.6506080936152816`*^9},
 ImageSize->{134, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[57]="]
}, Open  ]],

Cell["Get the unformatted array of values from the table:", "Text",
 CellID->20497461],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vals", "=", 
  RowBox[{"nlm", "[", "\"\<ParameterTableEntries\>\"", "]"}]}]], "Input",
 CellLabel->"In[58]:=",
 CellID->180129011],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.8646999653139662`", "0.00032233583391285455`", "2682.605761876736`", 
      "7.077126066014754`*^-28"},
     {"0.008445926976848648`", "0.0000939357636473306`", "89.91172955763435`",
       "1.3199175552868726`*^-14"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.540009231775687*^9, 3.540536933613347*^9, 
  3.587198557431529*^9, 3.6427623324383545`*^9, 3.643526009479106*^9, 
  3.6506080938027716`*^9},
 ImageSize->{557, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[58]="]
}, Open  ]],

Cell[TextData[{
 "Add formatting using ",
 Cell[BoxData[
  ButtonBox["Grid",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Grid"]], "InlineFormula"],
 ":"
}], "Text",
 CellID->263543578],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"\"\<\>\"", ",", 
         OverscriptBox["\[Beta]", "^"], ",", 
         OverscriptBox["\[Sigma]", "^"], ",", "t", ",", 
         RowBox[{"P", "[", 
          RowBox[{
           RowBox[{"Abs", "[", "T", "]"}], ">", 
           RowBox[{"Abs", "[", "t", "]"}]}], "]"}]}], "}"}], "}"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "a", "}"}], ",", 
          RowBox[{"{", "b", "}"}]}], "}"}], ",", "vals", ",", "2"}], "]"}]}], 
     "]"}], ",", 
    RowBox[{"Dividers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"GrayLevel", "[", ".5", "]"}], ",", 
       RowBox[{"GrayLevel", "[", ".5", "]"}]}], "}"}]}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[59]:=",
 CellID->24106869],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"\<\"\"\>", 
      OverscriptBox["\[Beta]", "^"], 
      OverscriptBox["\[Sigma]", "^"], "t", 
      RowBox[{"P", "(", 
       RowBox[{
        TemplateBox[{"T"},
         "Abs"], ">", 
        TemplateBox[{"t"},
         "Abs"]}], ")"}]},
     {"a", "0.8646999653139662`", "0.00032233583391285455`", 
      "2682.605761876736`", "7.077126066014754`*^-28"},
     {"b", "0.008445926976848648`", "0.0000939357636473306`", 
      "89.91172955763435`", "1.3199175552868726`*^-14"}
    },
    AutoDelete->False,
    GridBoxDividers->{"Columns" -> {{
         GrayLevel[0.5]}}, "Rows" -> {{
         GrayLevel[0.5]}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 CellChangeTimes->{3.54000924469781*^9, 3.5405369337227244`*^9, 
  3.587198557469533*^9, 3.642762332469615*^9, 3.6435260095259924`*^9, 
  3.6506080938496456`*^9},
 ImageSize->{244, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[59]//TraditionalForm="]
}, Open  ]],

Cell[TextData[{
 "Add formatting via ",
 Cell[BoxData[
  ButtonBox["TableForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TableForm"]], "InlineFormula"],
 ":"
}], "Text",
 CellID->89020743],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TableForm", "[", 
   RowBox[{"vals", ",", 
    RowBox[{"TableHeadings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         OverscriptBox["\[Beta]", "^"], ",", 
         OverscriptBox["\[Sigma]", "^"], ",", "t", ",", 
         RowBox[{"P", "[", 
          RowBox[{
           RowBox[{"Abs", "[", "T", "]"}], ">", 
           RowBox[{"Abs", "[", "t", "]"}]}], "]"}]}], "}"}]}], "}"}]}]}], 
   "]"}], "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[60]:=",
 CellID->55686520],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox[
        OverscriptBox["\[Beta]", "^"],
        HoldForm], 
       TagBox[
        OverscriptBox["\[Sigma]", "^"],
        HoldForm], 
       TagBox["t",
        HoldForm], 
       TagBox[
        RowBox[{"P", "(", 
         RowBox[{
          TemplateBox[{"T"},
           "Abs"], ">", 
          TemplateBox[{"t"},
           "Abs"]}], ")"}],
        HoldForm]},
      {
       TagBox["a",
        HoldForm], "0.8646999653139662`", "0.00032233583391285455`", 
       "2682.605761876736`", "7.077126066014754`*^-28"},
      {
       TagBox["b",
        HoldForm], "0.008445926976848648`", "0.0000939357636473306`", 
       "89.91172955763435`", "1.3199175552868726`*^-14"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$, TableHeadings -> {{$CellContext`a, $CellContext`b}, {
        OverHat[$CellContext`\[Beta]], 
        OverHat[$CellContext`\[Sigma]], $CellContext`t, 
        $CellContext`P[Abs[$CellContext`T] > Abs[$CellContext`t]]}}]]], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.540009256713666*^9, 3.5871985575245385`*^9, 
  3.642762332469615*^9, 3.6435260095416064`*^9, 3.6506080939277697`*^9},
 ImageSize->{230, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[60]//TraditionalForm="]
}, Open  ]],

Cell["\<\
Obtain tabular results for mean and single-prediction confidence intervals:\
\>", "Text",
 CellID->49202953],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", 
  RowBox[{"{", 
   RowBox[{
   "\"\<MeanPredictionConfidenceIntervalTable\>\"", ",", 
    "\"\<SinglePredictionConfidenceIntervalTable\>\""}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[61]:=",
 CellID->491356887],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    StyleBox[
     TagBox[GridBox[{
        {"\<\"Observed\"\>", "\<\"Predicted\"\>", "\<\"Standard Error\"\>", "\
\<\"Confidence Interval\"\>"},
        {"0.002`", "0.`", "0.`", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "0.`"}], "}"}]},
        {"0.106`", "0.10508268969819852`", "0.00041058929881092966`", 
         RowBox[{"{", 
          RowBox[{"0.10415387217492508`", ",", "0.10601150722147196`"}], 
          "}"}]},
        {"0.077`", "0.07718706144194329`", "0.0005865464659119485`", 
         RowBox[{"{", 
          RowBox[{"0.07586020115276661`", ",", "0.07851392173111997`"}], 
          "}"}]},
        {"0.056`", "0.056852432531798495`", "0.0007152860840160525`", 
         RowBox[{"{", 
          RowBox[{"0.0552343429933917`", ",", "0.05847052207020529`"}], "}"}]},
        {"0.041`", "0.04188260558375302`", "0.0005208221022306476`", 
         RowBox[{"{", 
          RowBox[{"0.040704424134648344`", ",", "0.0430607870328577`"}], 
          "}"}]},
        {"0.032`", "0.030854873909644975`", "0.0004100459067027747`", 
         RowBox[{"{", 
          RowBox[{"0.02992728562472121`", ",", "0.03178246219456874`"}], 
          "}"}]},
        {"0.023`", "0.022730774141149733`", "0.000461226480628813`", 
         RowBox[{"{", 
          RowBox[{"0.021687407354323056`", ",", "0.02377414092797641`"}], 
          "}"}]},
        {"0.018`", "0.016745757167593304`", "0.00010799749219297112`", 
         RowBox[{"{", 
          RowBox[{"0.01650144986706473`", ",", "0.016990064468121877`"}], 
          "}"}]},
        {"0.011`", "0.012336598251096429`", "0.00007139063226924406`", 
         RowBox[{"{", 
          RowBox[{"0.012175101420951866`", ",", "0.012498095081240992`"}], 
          "}"}]},
        {"0.011`", "0.009088439522930397`", "0.0011005127309604633`", 
         RowBox[{"{", 
          RowBox[{"0.006598906765837571`", ",", "0.011577972280023222`"}], 
          "}"}]},
        {"0.007`", "0.006695450803822755`", "0.000633002862628263`", 
         RowBox[{"{", 
          RowBox[{"0.005263498844056462`", ",", "0.008127402763589048`"}], 
          "}"}]}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "Columns" -> {{False}}, "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "Columns" -> {{Automatic}}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False], ",", 
    StyleBox[
     TagBox[GridBox[{
        {"\<\"Observed\"\>", "\<\"Predicted\"\>", "\<\"Standard Error\"\>", "\
\<\"Confidence Interval\"\>"},
        {"0.002`", "0.`", "0.0012854879736825943`", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.002907975827357031`"}], ",", 
           "0.002907975827357031`"}], "}"}]},
        {"0.106`", "0.10508268969819852`", "0.001349467636803726`", 
         RowBox[{"{", 
          RowBox[{"0.1020299818176386`", ",", "0.10813539757875844`"}], "}"}]},
        {"0.077`", "0.07718706144194329`", "0.0014129812762936312`", 
         RowBox[{"{", 
          RowBox[{"0.0739906757268759`", ",", "0.08038344715701068`"}], "}"}]},
        {"0.056`", "0.056852432531798495`", "0.0014710926253875389`", 
         RowBox[{"{", 
          RowBox[{"0.05352458981213846`", ",", "0.06018027525145853`"}], 
          "}"}]},
        {"0.041`", "0.04188260558375302`", "0.001386987740628782`", 
         RowBox[{"{", 
          RowBox[{"0.038745021331576326`", ",", "0.045020189835929716`"}], 
          "}"}]},
        {"0.032`", "0.030854873909644975`", "0.0013493024034982978`", 
         RowBox[{"{", 
          RowBox[{"0.027802539812790468`", ",", "0.03390720800649948`"}], 
          "}"}]},
        {"0.023`", "0.022730774141149733`", "0.0013657266186597606`", 
         RowBox[{"{", 
          RowBox[{"0.019641285888324384`", ",", "0.025820262393975082`"}], 
          "}"}]},
        {"0.018`", "0.016745757167593304`", "0.0012900165847005817`", 
         RowBox[{"{", 
          RowBox[{"0.013827536910384405`", ",", "0.019663977424802203`"}], 
          "}"}]},
        {"0.011`", "0.012336598251096429`", "0.001287468816266392`", 
         RowBox[{"{", 
          RowBox[{"0.009424141446500084`", ",", "0.015249055055692774`"}], 
          "}"}]},
        {"0.011`", "0.009088439522930397`", "0.0016922197261256115`", 
         RowBox[{"{", 
          RowBox[{"0.005260372548446929`", ",", "0.012916506497413865`"}], 
          "}"}]},
        {"0.007`", "0.006695450803822755`", "0.0014328893727633542`", 
         RowBox[{"{", 
          RowBox[{"0.0034540298457287066`", ",", "0.009936871761916804`"}], 
          "}"}]}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "Columns" -> {{False}}, "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "Columns" -> {{Automatic}}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.540009360715663*^9, 3.5405370014740252`*^9, 
  3.5871985580635924`*^9, 3.642762332657117*^9, 3.643526009729106*^9, 
  3.6506080941308956`*^9},
 ImageSize->{326, 433},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[61]="]
}, Open  ]],

Cell["Get the single-prediction intervals from the table:", "Text",
 CellID->44936140],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", "\"\<SinglePredictionConfidenceIntervals\>\"", 
  "]"}]], "Input",
 CellLabel->"In[62]:=",
 CellID->314491289],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "0.002907975827357031`"}], "0.002907975827357031`"},
     {"0.1020299818176386`", "0.10813539757875844`"},
     {"0.0739906757268759`", "0.08038344715701068`"},
     {"0.05352458981213846`", "0.06018027525145853`"},
     {"0.038745021331576326`", "0.045020189835929716`"},
     {"0.027802539812790468`", "0.03390720800649948`"},
     {"0.019641285888324384`", "0.025820262393975082`"},
     {"0.013827536910384405`", "0.019663977424802203`"},
     {"0.009424141446500084`", "0.015249055055692774`"},
     {"0.005260372548446929`", "0.012916506497413865`"},
     {"0.0034540298457287066`", "0.009936871761916804`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.5400093811691804`*^9, 3.587198558989685*^9, 
  3.6427623329227304`*^9, 3.64352600997911*^9, 3.6506080943496447`*^9},
 ImageSize->{529, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[62]="]
}, Open  ]],

Cell["\<\
If the model to be fitted it doesn't have an analytic expression, what it \
happen in this case, for some properties we need supply to Mathematica the \
derivatives for each coeffs. to be fitted.  In this case it can be used the \
numeric derivatives applying the package \
\[OpenCurlyDoubleQuote]NumericalCalculus`\[CloseCurlyDoubleQuote] \
\>", "Text",
 CellChangeTimes->{{3.399029038210621*^9, 3.399029041046399*^9}, {
  3.5400088658624115`*^9, 3.5400090139121294`*^9}, {3.540538031790682*^9, 
  3.5405380481816216`*^9}, {3.5405380909011917`*^9, 3.540538091807459*^9}, {
  3.5405381332457547`*^9, 3.540538177371602*^9}}],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<NumericalCalculus`\>\"", "]"}]], "Input",
 CellLabel->"In[63]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Derivative", "[", 
     RowBox[{"1", ",", "0", ",", "0"}], "]"}], "[", "model", "]"}], "[", 
   RowBox[{"n_", ",", "a2_", ",", "a3_"}], "]"}], ":=", 
  RowBox[{"ND", "[", 
   RowBox[{
    RowBox[{"model", "[", 
     RowBox[{"a1", ",", "a2", ",", "a3"}], "]"}], ",", "a1", ",", "n"}], 
   "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"In", " ", "this", " ", "example", " ", "we", " ", 
     RowBox[{"don", "'"}], "t", " ", "need", " ", "this", " ", "derivative"}],
     ",", 
    RowBox[{
    "but", " ", "it", " ", "is", " ", "included", " ", "to", " ", "show", " ",
      "the", " ", "pattern"}]}], "*)"}]}]], "Input",
 CellLabel->"In[64]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Derivative", "[", 
     RowBox[{"0", ",", "1", ",", "0"}], "]"}], "[", "model", "]"}], "[", 
   RowBox[{"a1_", ",", "n_", ",", "a3_"}], "]"}], ":=", 
  RowBox[{"ND", "[", 
   RowBox[{
    RowBox[{"model", "[", 
     RowBox[{"a1", ",", "a2", ",", "a3"}], "]"}], ",", "a2", ",", "n"}], 
   "]"}]}]], "Input",
 CellLabel->"In[65]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Derivative", "[", 
     RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", "model", "]"}], "[", 
   RowBox[{"a1_", ",", "a2_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"ND", "[", 
   RowBox[{
    RowBox[{"model", "[", 
     RowBox[{"a1", ",", "a2", ",", "a3"}], "]"}], ",", "a3", ",", "n"}], 
   "]"}]}]], "Input",
 CellLabel->"In[66]:="],

Cell["Obtaining the 90% and 95% confidence bands:", "Text",
 CellChangeTimes->{{3.4798195228552227`*^9, 3.479819525480172*^9}, {
  3.539926008054855*^9, 3.5399260133987074`*^9}},
 CellID->253370914],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bands90", "[", "t_", "]"}], ",", 
     RowBox[{"bands95", "[", "t_", "]"}]}], "}"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"nlm", "[", 
      RowBox[{"\"\<MeanPredictionBands\>\"", ",", 
       RowBox[{"ConfidenceLevel", "\[Rule]", "cl"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"cl", ",", 
       RowBox[{"{", 
        RowBox[{".9", ",", ".95"}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4798190269741187`*^9, 3.4798190337552385`*^9}, {
  3.4798190644109*^9, 3.479819067207721*^9}},
 CellLabel->"In[67]:=",
 CellID->427663384],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"uL90", ",", " ", "lL90"}], "}"}], " ", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bands90", "[", "#", "]"}], "&"}], ",", 
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "500", ",", " ", "10"}], "]"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.479819915707055*^9, 3.479819987783796*^9}, {
  3.479824192740759*^9, 3.47982425070464*^9}, {3.479824573184981*^9, 
  3.479824606883789*^9}},
 CellLabel->"In[68]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "500", ",", " ", "10"}], "]"}], ",", "uL90"}], 
         "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "500", ",", " ", "10"}], "]"}], ",", "lL90"}], 
         "}"}], "]"}]}], "}"}], ",", " ", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}]}], "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nlm", "[", "t", "]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", " ", "1", ",", " ", "500"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.3992743533360176`*^9, 3.399274365926137*^9}, {
   3.3992744349606557`*^9, 3.3992744355862513`*^9}, {3.3992748682015257`*^9, 
   3.3992748779451833`*^9}, {3.399274966779815*^9, 3.3992749904273443`*^9}, {
   3.3992750211128273`*^9, 3.399275034172144*^9}, {3.3992750934786453`*^9, 
   3.399275129935252*^9}, {3.479824646885522*^9, 3.4798247006944056`*^9}, {
   3.479824888003871*^9, 3.479824919046094*^9}, {3.4798252151444664`*^9, 
   3.4798252248598576`*^9}, 3.4798252636120853`*^9, {3.479825326965183*^9, 
   3.4798253344938297`*^9}, {3.4798253936313057`*^9, 3.479825411892722*^9}, {
   3.4798256142825346`*^9, 3.479825706046852*^9}},
 CellLabel->"In[69]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{{}, GraphicsComplexBox[CompressedData["
1:eJzt1nlM02cYB/BCG2WLmYMQZDJREIhhHiBmHI3s4ZBBURzOIQwUV2mBgdzY
Aj04ZOUUukodFl1buSnHhFEEkbItQ111ILCNbTBEs8ESGGpAHJnOpU/fJsuW
LPu7v6Rpvnl+T79Jk0/e146ZfIhlSqFQnj3//PX9z48D2OztHJv6UfOGLu+B
s0ObwxMlA5i9IZB+a7yvpR+zP6SX9j0I+K0PcxDYxWmrJYd6MYeA4zdFTXW3
e3Q5NxQG16/UWUercX4YGpxtmrxMunEeBqvFH5drO7twHgGZvaaTrac6cR4J
PVFCS3fGZZwfg1SToYfSnZ/oMhyHES8uX7a1A99/D6RxlO95oW26rGHCzZPa
2DPZKtyPATP77V43NM24z4JfsroTcuybcJ8NZxa/dl++0ID7sSCSTvrIXOtx
Px6ksQkpP/1Qi/vvA40+Os+QXcL9BMiPjJjKTVLifiJsaqWzPA8rcD8JAkBb
DsFy3E+GyLS6bUu1FzGnQOWiRfCVkRpdnk6Bves/ODC1UYa/nwrFY+vuVguq
dXlLGtC/ZH9OXz2HfWnAVgkbd1RIdfl4OkT4REWvelRhfwbM/hovZzyW6LI8
AwJtAtyGr3+I/Znw8sDCU7ZKjP2ZwDw7ajcnr8T+U8C3NndqYVRgPwc4k7HU
qNRy7OeAuCZqZUNXKfZzofvEPHeXeQn2Z8E431ZBExVhfxb88SLFb6ulCPuz
gRtuv2yrLsT+bLgs6hOokk5jfw60alx7xZ4F2M+D4R1TVxVW+djPA2bzu/IJ
Wh7286H97lrBNmou9gug6gFT5mEnwH4BWLGeaRXhPOwXQs10W+N0cza+//fH
Ad72TR7ihH5GvMxw6dyYRb0fb/A+aCJRC/V+/MGcV65xPKH3EwRzM5lH72Tr
/YSAudPvou39V4iX8caO/b4OPcSLYulJ8WyLwcuGJ28G8976lHjhjG52YL7U
Rbxcc/r5NfcZg5dbtJvdu28YvMR3lUk8Bg1evCWmnGRxO/HSdefe4OOrrcRL
W+dS2StUFfHi56pRujCbiRfrLT2qr75rJF4enXwh7DyrgXgJcf6olr22nnhJ
7OWct+ivJV4eLjpblBZeIl6O7N6z63a0knhRtvs9mmUoiBeqo/3S4j69nxQo
qY/RWsgvEi9B8wtu14ZriBcqj/fOwVdlxMsRq6ZWRl418bKm7b5b8NNzxIuY
b9m/LJYSL2Fql31UehXxYrZ/Qu2zIiFe8u+tMRfq/Tz3Ip/2jOhoFhMvR11M
rn9xoZJ4iTi26UClTwXxwpInj8lY5cQLe/B13mxdKfFSQWUPfEspIV6GVtZZ
jmYUES/2cS3OsRQR8WKRN0BzVRYSL0Ka2HIy/LTBi1LQErS1gHgxs73vZU7J
J15y/H3TAxcMXhrmNuaqJ4TEC6OsIKd2iU+8dDBGbHN38v7Vi/F8MZ4vxvPl
v58vRi9GL0YvxvuY7v8z3seM97H/dx/7E8/Hsy4=
      "], {{{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
        {RGBColor[0.368417, 0.506779, 0.709798], Opacity[0.3], 
         LineBox[{1, 103}], LineBox[{53, 104}], LineBox[{54, 105}], 
         LineBox[{55, 106}], LineBox[{56, 107}], LineBox[{57, 108}], 
         LineBox[{58, 109}], LineBox[{59, 110}], LineBox[{60, 111}], 
         LineBox[{61, 112}], LineBox[{62, 113}], LineBox[{63, 114}], 
         LineBox[{64, 115}], LineBox[{65, 116}], LineBox[{66, 117}], 
         LineBox[{67, 118}], LineBox[{68, 119}], LineBox[{69, 120}], 
         LineBox[{70, 121}], LineBox[{71, 122}], LineBox[{72, 123}], 
         LineBox[{73, 124}], LineBox[{74, 125}], LineBox[{75, 126}], 
         LineBox[{76, 127}], LineBox[{77, 128}], LineBox[{78, 129}], 
         LineBox[{79, 130}], LineBox[{80, 131}], LineBox[{81, 132}], 
         LineBox[{82, 133}], LineBox[{83, 134}], LineBox[{84, 135}], 
         LineBox[{85, 136}], LineBox[{86, 137}], LineBox[{87, 138}], 
         LineBox[{88, 139}], LineBox[{89, 140}], LineBox[{90, 141}], 
         LineBox[{91, 142}], LineBox[{92, 143}], LineBox[{93, 144}], 
         LineBox[{94, 145}], LineBox[{95, 146}], LineBox[{96, 147}], 
         LineBox[{97, 148}], LineBox[{98, 149}], LineBox[{99, 150}], 
         LineBox[{100, 151}], LineBox[{101, 152}], LineBox[{102, 153}]}}, {{}, 
        {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
         0.009166666666666668], AbsoluteThickness[1.6], 
         PointBox[{154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165,
           166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 
          179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 
          192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204}]}, 
        {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
         0.009166666666666668], AbsoluteThickness[1.6], 
         PointBox[{205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216,
           217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 
          230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 
          243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 
          255}]}, {}}}], {}}, {{}, {}, 
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVkHs41AkXxzHRKMSWJRWJcRktIq8nGedsoVxWTFQsurzllmtuw28ujNUm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       "]]}}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0, 500.}, {0, 0.1431112026025568}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.5399301177275085`*^9, 3.5399303169500837`*^9, 
  3.5400096862687883`*^9, 3.587198667330518*^9, 3.6427623675165443`*^9, 
  3.643526044947994*^9, 3.6506081280215425`*^9},
 CellLabel->"Out[69]="]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 6", "SubsubsectionIcon",
 CellChangeTimes->{{3.587198305704359*^9, 3.5871983065904474`*^9}}],

Cell["Here it is shown other way for solving the before problem", "Text",
 CellChangeTimes->{{3.5871986608488703`*^9, 3.587198788819666*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dataIodine", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.002"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "0.106"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "0.077"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"150", ",", "0.056"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"200", ",", "0.041"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"250", ",", "0.032"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "0.023"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"350", ",", "0.018"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"400", ",", "0.011"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"450", ",", "0.011"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"500", ",", "0.007"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[70]:="],

Cell["Also is assumed an input to the compartment 1 given by", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"iodo129h", " ", "=", 
   RowBox[{
    RowBox[{"34.4", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "200."}], " ", "t"}]]}], "+", 
    RowBox[{"1.09", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "110."}], " ", "t"}]]}], "+", 
    RowBox[{"0.808", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "102."}], " ", "t"}]]}], "+", 
    RowBox[{"6.414", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "100."}], " ", "t"}]]}], "+", 
    RowBox[{"5.458", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "24."}], " ", "t"}]]}]}]}], ";"}]], "Input",
 CellLabel->"In[71]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X2a", "=", " ", 
  RowBox[{
   SubscriptBox["x", "2"], "/.", 
   RowBox[{"ParametricSystemNDSolve", "[", 
    RowBox[{
     RowBox[{"CompartMatrix", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "1.9404"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "3", ",", "k23"}], " ", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "0", ",", "0.01155"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "1", ",", "0.0462"}], "}"}]}], " ", "}"}]}], 
      "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"iodo129h", ",", " ", "0", ",", " ", "0"}], "}"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", " ", "0", ",", " ", "500"}], "}"}], ",", "x", ",", 
     " ", 
     RowBox[{"{", 
      RowBox[{"k12", ",", " ", "k23"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.587198806646448*^9, 3.587198923166099*^9}},
 CellLabel->"In[72]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   TemplateBox[{RowBox[{
       StyleBox[
        TagBox["ParametricFunction", "SummaryHead"], 
        "NonInterpretableSummary"], 
       StyleBox["[", "NonInterpretableSummary"], 
       DynamicModuleBox[{Typeset`open$$ = False}, 
        PanelBox[
         PaneSelectorBox[{False -> GridBox[{{
               PaneBox[
                ButtonBox[
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "FEBitmaps", "SquarePlusIconMedium"]], 
                 ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                 None, Evaluator -> Automatic, Method -> "Preemptive"], 
                Alignment -> {Center, Center}, ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}]], 
               GraphicsBox[{{}, {}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                   0.0874367476365131, 0.08197166587636243}, {
                   0.18222810297558026`, 0.1358255024317191}, {
                   0.27073779576926765`, 0.13315455086535802`}, {
                   0.3575112797365835, 0.08143316377978886}, {
                   0.4516394623155443, -0.007347854733426912}, {
                   0.5394859823491253, -0.08816932746972758}, {
                   0.6346872009943513, -0.13787329990112937`}, {
                   0.7281522108132057, -0.12816574147938434`}, {
                   0.8153355580866803, -0.07001063326902106}, {
                   0.9098736039718, 0.02121659675083076}, {0.9999999090909091,
                    0.10024804094746914`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                   0.0874367476365131, 0.08090369567458766}, {
                   0.18222810297558026`, 0.12746559200130417`}, {
                   0.27073779576926765`, 0.1116266937044405}, {
                   0.3575112797365835, 0.046963725126600256`}, {
                   0.4516394623155443, -0.04509050859182233}, {
                   0.5394859823491253, -0.11115559892361665`}, {
                   0.6346872009943513, -0.12642564594664163`}, {
                   0.7281522108132057, -0.07740196037964171}, {
                   0.8153355580866803, 0.004179083230780074}, {
                   0.9098736039718, 0.08937493944143977}, {0.9999999090909091,
                    0.12834702174618903`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                   0.0874367476365131, 0.07984396759533968}, {
                   0.18222810297558026`, 0.11939549826670079`}, {
                   0.27073779576926765`, 0.09184904274707059}, {
                   0.3575112797365835, 0.017913117173780694`}, {
                   0.4516394623155443, -0.07109962300031061}, {
                   0.5394859823491253, -0.11717052830989395`}, {
                   0.6346872009943513, -0.09879571259704382}, {
                   0.7281522108132057, -0.022693471356141894`}, {
                   0.8153355580866803, 0.06128703302641453}, {0.9098736039718,
                    0.11605625481609519`}, {0.9999999090909091, 
                   0.10415981267620744`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                   0.0874367476365131, 0.07879243663407876}, {
                   0.18222810297558026`, 0.1116081822210312}, {
                   0.27073779576926765`, 0.07372482040530459}, {
                   0.3575112797365835, -0.006267252216927747}, {
                   0.4516394623155443, -0.08743897872291118}, {
                   0.5394859823491253, -0.11109134853087661`}, {
                   0.6346872009943513, -0.06371549528296311}, {
                   0.7281522108132057, 0.02544576624054603}, {
                   0.8153355580866803, 0.09464282937855747}, {0.9098736039718,
                    0.10731931496853601`}, {0.9999999090909091, 
                   0.0516787429232188}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                   0.0874367476365131, 0.07774905743802465}, {
                   0.18222810297558026`, 0.10409673959866513`}, {
                   0.27073779576926765`, 0.05716133039337165}, {
                   0.3575112797365835, -0.026084496726167965`}, {
                   0.4516394623155443, -0.09591154799603378}, {
                   0.5394859823491253, -0.09685594593277226}, {
                   0.6346872009943513, -0.02730376120671303}, {
                   0.7281522108132057, 0.061646715198529656`}, {
                   0.8153355580866803, 0.1046634148537508}, {0.9098736039718, 
                   0.07509702498429204}, {
                   0.9999999090909091, -0.006536873471333553}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                   0.0874367476365131, 0.07671378556951527}, {
                   0.18222810297558026`, 0.09685439581479163}, {
                   0.27073779576926765`, 0.042069810325321415`}, {
                   0.3575112797365835, -0.042006785469922474`}, {
                   0.4516394623155443, -0.09808544986431629}, {
                   0.5394859823491253, -0.07760167026270944}, {
                   0.6346872009943513, 0.0063643674428021085`}, {
                   0.7281522108132057, 0.08405712128907425}, {
                   0.8153355580866803, 0.09555213349985489}, {0.9098736039718,
                    0.03202960165577907}, {
                   0.9999999090909091, -0.054402034659985464`}}]}}, 
                AspectRatio -> 1, Axes -> {False, False}, 
                AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Background -> 
                GrayLevel[0.93], BaseStyle -> {FontFamily -> "Arial"}, 
                DisplayFunction -> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Thickness[Tiny], 
                  GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}},
                 GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                  Dynamic[
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                Method -> {"ScalingFunctions" -> None}, 
                PlotRange -> {All, All}, PlotRangeClipping -> True, 
                PlotRangePadding -> {Automatic, Automatic}, 
                Ticks -> {Automatic, Automatic}], 
               GridBox[{{
                  RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "2"], HoldForm], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"k12", ",", "k23"}], "}"}], "SummaryItem"]}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {
                 "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                BaseStyle -> {
                 ShowStringCharacters -> False, NumberMarks -> False, 
                  PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
             GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             BaselinePosition -> {1, 1}], True -> GridBox[{{
               PaneBox[
                ButtonBox[
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "FEBitmaps", "SquareMinusIconMedium"]], 
                 ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                 None, Evaluator -> Automatic, Method -> "Preemptive"], 
                Alignment -> {Center, Center}, ImageSize -> 
                Dynamic[{
                  Automatic, 3.5 CurrentValue["FontCapHeight"]/
                   AbsoluteCurrentValue[Magnification]}]], 
               GraphicsBox[{{}, {}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                   0.0874367476365131, 0.08197166587636243}, {
                   0.18222810297558026`, 0.1358255024317191}, {
                   0.27073779576926765`, 0.13315455086535802`}, {
                   0.3575112797365835, 0.08143316377978886}, {
                   0.4516394623155443, -0.007347854733426912}, {
                   0.5394859823491253, -0.08816932746972758}, {
                   0.6346872009943513, -0.13787329990112937`}, {
                   0.7281522108132057, -0.12816574147938434`}, {
                   0.8153355580866803, -0.07001063326902106}, {
                   0.9098736039718, 0.02121659675083076}, {0.9999999090909091,
                    0.10024804094746914`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                   0.0874367476365131, 0.08090369567458766}, {
                   0.18222810297558026`, 0.12746559200130417`}, {
                   0.27073779576926765`, 0.1116266937044405}, {
                   0.3575112797365835, 0.046963725126600256`}, {
                   0.4516394623155443, -0.04509050859182233}, {
                   0.5394859823491253, -0.11115559892361665`}, {
                   0.6346872009943513, -0.12642564594664163`}, {
                   0.7281522108132057, -0.07740196037964171}, {
                   0.8153355580866803, 0.004179083230780074}, {
                   0.9098736039718, 0.08937493944143977}, {0.9999999090909091,
                    0.12834702174618903`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                   0.0874367476365131, 0.07984396759533968}, {
                   0.18222810297558026`, 0.11939549826670079`}, {
                   0.27073779576926765`, 0.09184904274707059}, {
                   0.3575112797365835, 0.017913117173780694`}, {
                   0.4516394623155443, -0.07109962300031061}, {
                   0.5394859823491253, -0.11717052830989395`}, {
                   0.6346872009943513, -0.09879571259704382}, {
                   0.7281522108132057, -0.022693471356141894`}, {
                   0.8153355580866803, 0.06128703302641453}, {0.9098736039718,
                    0.11605625481609519`}, {0.9999999090909091, 
                   0.10415981267620744`}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                   0.0874367476365131, 0.07879243663407876}, {
                   0.18222810297558026`, 0.1116081822210312}, {
                   0.27073779576926765`, 0.07372482040530459}, {
                   0.3575112797365835, -0.006267252216927747}, {
                   0.4516394623155443, -0.08743897872291118}, {
                   0.5394859823491253, -0.11109134853087661`}, {
                   0.6346872009943513, -0.06371549528296311}, {
                   0.7281522108132057, 0.02544576624054603}, {
                   0.8153355580866803, 0.09464282937855747}, {0.9098736039718,
                    0.10731931496853601`}, {0.9999999090909091, 
                   0.0516787429232188}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                   0.0874367476365131, 0.07774905743802465}, {
                   0.18222810297558026`, 0.10409673959866513`}, {
                   0.27073779576926765`, 0.05716133039337165}, {
                   0.3575112797365835, -0.026084496726167965`}, {
                   0.4516394623155443, -0.09591154799603378}, {
                   0.5394859823491253, -0.09685594593277226}, {
                   0.6346872009943513, -0.02730376120671303}, {
                   0.7281522108132057, 0.061646715198529656`}, {
                   0.8153355580866803, 0.1046634148537508}, {0.9098736039718, 
                   0.07509702498429204}, {
                   0.9999999090909091, -0.006536873471333553}}]}, {
                  GrayLevel[0.55], 
                  AbsoluteThickness[1.5], 
                  Opacity[1.], 
                  
                  LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                   0.0874367476365131, 0.07671378556951527}, {
                   0.18222810297558026`, 0.09685439581479163}, {
                   0.27073779576926765`, 0.042069810325321415`}, {
                   0.3575112797365835, -0.042006785469922474`}, {
                   0.4516394623155443, -0.09808544986431629}, {
                   0.5394859823491253, -0.07760167026270944}, {
                   0.6346872009943513, 0.0063643674428021085`}, {
                   0.7281522108132057, 0.08405712128907425}, {
                   0.8153355580866803, 0.09555213349985489}, {0.9098736039718,
                    0.03202960165577907}, {
                   0.9999999090909091, -0.054402034659985464`}}]}}, 
                AspectRatio -> 1, Axes -> {False, False}, 
                AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, Background -> 
                GrayLevel[0.93], BaseStyle -> {FontFamily -> "Arial"}, 
                DisplayFunction -> Identity, 
                Frame -> {{True, True}, {True, True}}, 
                FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                Directive[
                  Thickness[Tiny], 
                  GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}},
                 GridLines -> {None, None}, GridLinesStyle -> Directive[
                  GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                  Dynamic[
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                Method -> {"ScalingFunctions" -> None}, 
                PlotRange -> {All, All}, PlotRangeClipping -> True, 
                PlotRangePadding -> {Automatic, Automatic}, 
                Ticks -> {Automatic, Automatic}], 
               GridBox[{{
                  RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "2"], HoldForm], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"k12", ",", "k23"}], "}"}], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox["\"Generator: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["ParametricNDSolve", "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox[
                    "\"Dependent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "TemporaryVariable$505017", ",", 
                    "TemporaryVariable$505018", ",", 
                    "TemporaryVariable$505019"}], "}"}], "SummaryItem"]}]}, {
                  RowBox[{
                    TagBox[
                    "\"Independent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", "t", "}"}], "SummaryItem"]}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {
                 "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                BaseStyle -> {
                 ShowStringCharacters -> False, NumberMarks -> False, 
                  PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
             GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             BaselinePosition -> {1, 1}]}, 
          Dynamic[Typeset`open$$], ImageSize -> Automatic], BaselinePosition -> 
         Baseline], DynamicModuleValues :> {}], 
       StyleBox["]", "NonInterpretableSummary"]}]},
    "CopyTag",
    DisplayFunction->(#& ),
    InterpretationFunction->("ParametricFunction[<>]"& )],
   False,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], TraditionalForm]], "Output",
 CellChangeTimes->{{3.587198899614744*^9, 3.5871989243512173`*^9}, 
   3.5872004675853295`*^9, 3.587200954696483*^9, 3.6427623675477834`*^9, 
   3.643526044979244*^9, 3.6506081280684285`*^9},
 CellLabel->"Out[72]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"model", "[", " ", 
   RowBox[{
    RowBox[{"t_", "?", "NumericQ"}], ",", 
    RowBox[{"k12_", "?", "NumericQ"}], ",", 
    RowBox[{"k23_", "?", "NumericQ"}]}], "]"}], "=", 
  RowBox[{
   RowBox[{"X2a", "[", 
    RowBox[{"k12", ",", "k23"}], "]"}], "[", "t", "]"}]}]], "Input",
 CellChangeTimes->{{3.587197969668759*^9, 3.5871980312729187`*^9}, {
   3.5871989485175447`*^9, 3.5871989837386017`*^9}, 3.5871993382244263`*^9, {
   3.5872004504648485`*^9, 3.587200460225117*^9}},
 CellLabel->"In[73]:="],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     TagBox[
      TemplateBox[{RowBox[{
          StyleBox[
           TagBox["ParametricFunction", "SummaryHead"], 
           "NonInterpretableSummary"], 
          StyleBox["[", "NonInterpretableSummary"], 
          DynamicModuleBox[{Typeset`open$$ = False}, 
           PanelBox[
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  GraphicsBox[{{}, {}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                    0.0874367476365131, 0.08197166587636243}, {
                    0.18222810297558026`, 0.1358255024317191}, {
                    0.27073779576926765`, 0.13315455086535802`}, {
                    0.3575112797365835, 0.08143316377978886}, {
                    0.4516394623155443, -0.007347854733426912}, {
                    0.5394859823491253, -0.08816932746972758}, {
                    0.6346872009943513, -0.13787329990112937`}, {
                    0.7281522108132057, -0.12816574147938434`}, {
                    0.8153355580866803, -0.07001063326902106}, {
                    0.9098736039718, 0.02121659675083076}, {
                    0.9999999090909091, 0.10024804094746914`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                    0.0874367476365131, 0.08090369567458766}, {
                    0.18222810297558026`, 0.12746559200130417`}, {
                    0.27073779576926765`, 0.1116266937044405}, {
                    0.3575112797365835, 0.046963725126600256`}, {
                    0.4516394623155443, -0.04509050859182233}, {
                    0.5394859823491253, -0.11115559892361665`}, {
                    0.6346872009943513, -0.12642564594664163`}, {
                    0.7281522108132057, -0.07740196037964171}, {
                    0.8153355580866803, 0.004179083230780074}, {
                    0.9098736039718, 0.08937493944143977}, {
                    0.9999999090909091, 0.12834702174618903`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                    0.0874367476365131, 0.07984396759533968}, {
                    0.18222810297558026`, 0.11939549826670079`}, {
                    0.27073779576926765`, 0.09184904274707059}, {
                    0.3575112797365835, 0.017913117173780694`}, {
                    0.4516394623155443, -0.07109962300031061}, {
                    0.5394859823491253, -0.11717052830989395`}, {
                    0.6346872009943513, -0.09879571259704382}, {
                    0.7281522108132057, -0.022693471356141894`}, {
                    0.8153355580866803, 0.06128703302641453}, {
                    0.9098736039718, 0.11605625481609519`}, {
                    0.9999999090909091, 0.10415981267620744`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                    0.0874367476365131, 0.07879243663407876}, {
                    0.18222810297558026`, 0.1116081822210312}, {
                    0.27073779576926765`, 0.07372482040530459}, {
                    0.3575112797365835, -0.006267252216927747}, {
                    0.4516394623155443, -0.08743897872291118}, {
                    0.5394859823491253, -0.11109134853087661`}, {
                    0.6346872009943513, -0.06371549528296311}, {
                    0.7281522108132057, 0.02544576624054603}, {
                    0.8153355580866803, 0.09464282937855747}, {
                    0.9098736039718, 0.10731931496853601`}, {
                    0.9999999090909091, 0.0516787429232188}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                    0.0874367476365131, 0.07774905743802465}, {
                    0.18222810297558026`, 0.10409673959866513`}, {
                    0.27073779576926765`, 0.05716133039337165}, {
                    0.3575112797365835, -0.026084496726167965`}, {
                    0.4516394623155443, -0.09591154799603378}, {
                    0.5394859823491253, -0.09685594593277226}, {
                    0.6346872009943513, -0.02730376120671303}, {
                    0.7281522108132057, 0.061646715198529656`}, {
                    0.8153355580866803, 0.1046634148537508}, {0.9098736039718,
                     0.07509702498429204}, {
                    0.9999999090909091, -0.006536873471333553}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                    0.0874367476365131, 0.07671378556951527}, {
                    0.18222810297558026`, 0.09685439581479163}, {
                    0.27073779576926765`, 0.042069810325321415`}, {
                    0.3575112797365835, -0.042006785469922474`}, {
                    0.4516394623155443, -0.09808544986431629}, {
                    0.5394859823491253, -0.07760167026270944}, {
                    0.6346872009943513, 0.0063643674428021085`}, {
                    0.7281522108132057, 0.08405712128907425}, {
                    0.8153355580866803, 0.09555213349985489}, {
                    0.9098736039718, 0.03202960165577907}, {
                    0.9999999090909091, -0.054402034659985464`}}]}}, 
                   AspectRatio -> 1, Axes -> {False, False}, 
                   AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
                   Background -> GrayLevel[0.93], 
                   BaseStyle -> {FontFamily -> "Arial"}, DisplayFunction -> 
                   Identity, Frame -> {{True, True}, {True, True}}, 
                   FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                   Directive[
                    Thickness[Tiny], 
                    GrayLevel[0.7]], 
                   FrameTicks -> {{None, None}, {None, None}}, 
                   GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                    Dynamic[
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                   Method -> {"ScalingFunctions" -> None}, 
                   PlotRange -> {All, All}, PlotRangeClipping -> True, 
                   PlotRangePadding -> {Automatic, Automatic}, 
                   Ticks -> {Automatic, Automatic}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "2"], HoldForm], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"k12", ",", "k23"}], "}"}], "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                   Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                  GraphicsBox[{{}, {}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090884856*^-8}, {
                    0.0874367476365131, 0.08197166587636243}, {
                    0.18222810297558026`, 0.1358255024317191}, {
                    0.27073779576926765`, 0.13315455086535802`}, {
                    0.3575112797365835, 0.08143316377978886}, {
                    0.4516394623155443, -0.007347854733426912}, {
                    0.5394859823491253, -0.08816932746972758}, {
                    0.6346872009943513, -0.13787329990112937`}, {
                    0.7281522108132057, -0.12816574147938434`}, {
                    0.8153355580866803, -0.07001063326902106}, {
                    0.9098736039718, 0.02121659675083076}, {
                    0.9999999090909091, 0.10024804094746914`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090880112*^-8}, {
                    0.0874367476365131, 0.08090369567458766}, {
                    0.18222810297558026`, 0.12746559200130417`}, {
                    0.27073779576926765`, 0.1116266937044405}, {
                    0.3575112797365835, 0.046963725126600256`}, {
                    0.4516394623155443, -0.04509050859182233}, {
                    0.5394859823491253, -0.11115559892361665`}, {
                    0.6346872009943513, -0.12642564594664163`}, {
                    0.7281522108132057, -0.07740196037964171}, {
                    0.8153355580866803, 0.004179083230780074}, {
                    0.9098736039718, 0.08937493944143977}, {
                    0.9999999090909091, 0.12834702174618903`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090875369*^-8}, {
                    0.0874367476365131, 0.07984396759533968}, {
                    0.18222810297558026`, 0.11939549826670079`}, {
                    0.27073779576926765`, 0.09184904274707059}, {
                    0.3575112797365835, 0.017913117173780694`}, {
                    0.4516394623155443, -0.07109962300031061}, {
                    0.5394859823491253, -0.11717052830989395`}, {
                    0.6346872009943513, -0.09879571259704382}, {
                    0.7281522108132057, -0.022693471356141894`}, {
                    0.8153355580866803, 0.06128703302641453}, {
                    0.9098736039718, 0.11605625481609519`}, {
                    0.9999999090909091, 0.10415981267620744`}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090870287*^-8}, {
                    0.0874367476365131, 0.07879243663407876}, {
                    0.18222810297558026`, 0.1116081822210312}, {
                    0.27073779576926765`, 0.07372482040530459}, {
                    0.3575112797365835, -0.006267252216927747}, {
                    0.4516394623155443, -0.08743897872291118}, {
                    0.5394859823491253, -0.11109134853087661`}, {
                    0.6346872009943513, -0.06371549528296311}, {
                    0.7281522108132057, 0.02544576624054603}, {
                    0.8153355580866803, 0.09464282937855747}, {
                    0.9098736039718, 0.10731931496853601`}, {
                    0.9999999090909091, 0.0516787429232188}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.090909090865543*^-8}, {
                    0.0874367476365131, 0.07774905743802465}, {
                    0.18222810297558026`, 0.10409673959866513`}, {
                    0.27073779576926765`, 0.05716133039337165}, {
                    0.3575112797365835, -0.026084496726167965`}, {
                    0.4516394623155443, -0.09591154799603378}, {
                    0.5394859823491253, -0.09685594593277226}, {
                    0.6346872009943513, -0.02730376120671303}, {
                    0.7281522108132057, 0.061646715198529656`}, {
                    0.8153355580866803, 0.1046634148537508}, {0.9098736039718,
                     0.07509702498429204}, {
                    0.9999999090909091, -0.006536873471333553}}]}, {
                    GrayLevel[0.55], 
                    AbsoluteThickness[1.5], 
                    Opacity[1.], 
                    
                    LineBox[{{9.09090909090909*^-8, 9.0909090908608*^-8}, {
                    0.0874367476365131, 0.07671378556951527}, {
                    0.18222810297558026`, 0.09685439581479163}, {
                    0.27073779576926765`, 0.042069810325321415`}, {
                    0.3575112797365835, -0.042006785469922474`}, {
                    0.4516394623155443, -0.09808544986431629}, {
                    0.5394859823491253, -0.07760167026270944}, {
                    0.6346872009943513, 0.0063643674428021085`}, {
                    0.7281522108132057, 0.08405712128907425}, {
                    0.8153355580866803, 0.09555213349985489}, {
                    0.9098736039718, 0.03202960165577907}, {
                    0.9999999090909091, -0.054402034659985464`}}]}}, 
                   AspectRatio -> 1, Axes -> {False, False}, 
                   AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
                   Background -> GrayLevel[0.93], 
                   BaseStyle -> {FontFamily -> "Arial"}, DisplayFunction -> 
                   Identity, Frame -> {{True, True}, {True, True}}, 
                   FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                   Directive[
                    Thickness[Tiny], 
                    GrayLevel[0.7]], 
                   FrameTicks -> {{None, None}, {None, None}}, 
                   GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> {Automatic, 
                    Dynamic[
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])]}, LabelStyle -> {FontFamily -> "Arial"}, 
                   Method -> {"ScalingFunctions" -> None}, 
                   PlotRange -> {All, All}, PlotRangeClipping -> True, 
                   PlotRangePadding -> {Automatic, Automatic}, 
                   Ticks -> {Automatic, Automatic}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    SubscriptBox["x", "2"], HoldForm], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Parameters: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    RowBox[{"k12", ",", "k23"}], "}"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Generator: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["ParametricNDSolve", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"Dependent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "TemporaryVariable$505017", ",", 
                    "TemporaryVariable$505018", ",", 
                    "TemporaryVariable$505019"}], "}"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"Independent variables: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"{", "t", "}"}], "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic], 
            BaselinePosition -> Baseline], DynamicModuleValues :> {}], 
          StyleBox["]", "NonInterpretableSummary"]}]},
       "CopyTag",
       DisplayFunction->(#& ),
       InterpretationFunction->("ParametricFunction[<>]"& )],
      False,
      Editable->False,
      SelectWithContents->True,
      Selectable->False], "\[InvisibleApplication]", 
     RowBox[{"(", 
      RowBox[{"k12", ",", "k23"}], ")"}]}], ")"}], "\[InvisibleApplication]", 
   RowBox[{"(", "t", ")"}]}], TraditionalForm]], "Output",
 CellChangeTimes->{3.5871980581056013`*^9, 3.587198990138794*^9, 
  3.5871991216527386`*^9, 3.5872004677277336`*^9, 3.5872009547484884`*^9, 
  3.6427623675634103`*^9, 3.643526045010494*^9, 3.6506081280996785`*^9},
 CellLabel->"Out[73]="]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Derivative", "[", 
     RowBox[{"0", ",", "1", ",", "0"}], "]"}], "[", "model", "]"}], "[", 
   RowBox[{"t_", ",", "a1_", ",", "b_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"X2a", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "a"}], "]"}], "[", "t", "]"}], "/.", 
   RowBox[{"a", "\[Rule]", "a1"}]}]}]], "Input",
 CellChangeTimes->{{3.5454970322092934`*^9, 3.545497039822107*^9}, {
   3.545497075249769*^9, 3.545497169832735*^9}, {3.5454974210711765`*^9, 
   3.545497486310491*^9}, {3.5454978827227874`*^9, 3.5454978853435917`*^9}, {
   3.5455723871899233`*^9, 3.5455724137879705`*^9}, {3.5455724820068903`*^9, 
   3.545572492302908*^9}, {3.545572597665493*^9, 3.545572625963943*^9}, {
   3.545572657990799*^9, 3.545572665603613*^9}, {3.545572717083703*^9, 
   3.5455727340253325`*^9}, {3.545572839497118*^9, 3.545572935827287*^9}, {
   3.569512543787388*^9, 3.5695125686392317`*^9}, 3.5695129461452947`*^9, 
   3.5695131845449133`*^9, {3.586442124927493*^9, 3.5864421278135*^9}, 
   3.586442592808028*^9, {3.5864426424634037`*^9, 3.586442644663031*^9}, {
   3.5865219147340097`*^9, 3.5865219168868947`*^9}, {3.5865223715356126`*^9, 
   3.5865223770736446`*^9}, {3.586611792967874*^9, 3.586611793279882*^9}, {
   3.586619614257415*^9, 3.5866196501661215`*^9}, {3.5866197260707116`*^9, 
   3.5866197306531696`*^9}, 3.5866207291903534`*^9, 3.586660164246765*^9, {
   3.5866602354248824`*^9, 3.586660255283868*^9}, {3.586765484222849*^9, 
   3.5867655014144897`*^9}, {3.5867656412328157`*^9, 
   3.5867656716223946`*^9}, {3.5867657580018096`*^9, 
   3.5867657584386206`*^9}, {3.5871997769388747`*^9, 
   3.5871997833818398`*^9}, {3.5871998436617856`*^9, 3.5871998470470724`*^9}, 
   3.587199941413892*^9, {3.5872000538355303`*^9, 3.587200097581188*^9}, {
   3.5872003186456375`*^9, 3.5872003278674946`*^9}},
 CellLabel->"In[74]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Derivative", "[", 
     RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", "model", "]"}], "[", 
   RowBox[{"t_", ",", "a_", ",", "b1_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"X2a", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", "b"}], "]"}], "[", "t", "]"}], "/.", 
   RowBox[{"b", "\[Rule]", "b1"}]}]}]], "Input",
 CellChangeTimes->{{3.587200121293796*^9, 3.58720015460065*^9}, {
  3.587200336299333*^9, 3.58720034285791*^9}},
 CellLabel->"In[75]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "=", " ", 
  RowBox[{"NonlinearModelFit", "[", 
   RowBox[{"dataIodine", ",", " ", 
    RowBox[{"model", "[", 
     RowBox[{"t", ",", "k12", ",", "k23"}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k12", ",", "0.8"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"k23", ",", "0.007"}], "}"}]}], "}"}], ",", " ", "t", ",", " ", 
    RowBox[{"Method", "->", "Gradient"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.587197231022916*^9, 3.5871972349594803`*^9}, {
   3.5871972699135265`*^9, 3.5871972971382046`*^9}, {3.587197413683777*^9, 
   3.587197420480571*^9}, 3.5871975290692577`*^9, {3.587197882067556*^9, 
   3.587197886264064*^9}, {3.5871979435955334`*^9, 3.587197950756117*^9}, {
   3.5871980440611973`*^9, 3.587198053639155*^9}, {3.5871980908268733`*^9, 
   3.5871980928900795`*^9}, {3.587199033850105*^9, 3.587199103922207*^9}, 
   3.5871992144040513`*^9, {3.5871994004856224`*^9, 3.587199409159445*^9}, {
   3.5871994474584265`*^9, 3.587199453090171*^9}, {3.58720064078399*^9, 
   3.587200643997672*^9}},
 CellLabel->"In[76]:="],

Cell[BoxData[
 FormBox[
  TagBox[
   RowBox[{"FittedModel", "[", 
    TagBox[
     PanelBox[
      TagBox[
       RowBox[{"model", "(", 
        RowBox[{
        "t", ",", "0.8656394548271342`", ",", "0.008425346222049672`"}], ")"}],
       Short[#, 2]& ],
      FrameMargins->5],
     Editable -> False], "]"}],
   InterpretTemplate[
   FittedModel[{
     "Nonlinear", {$CellContext`k12 -> 0.8656394548271342, $CellContext`k23 -> 
       0.008425346222049672}, {{$CellContext`t}, 
       $CellContext`model[$CellContext`t, $CellContext`k12, \
$CellContext`k23]}}, {
     1}, {{0, 0.002}, {50, 0.106}, {100, 0.077}, {150, 0.056}, {200, 0.041}, {
      250, 0.032}, {300, 0.023}, {350, 0.018}, {400, 0.011}, {450, 0.011}, {
      500, 0.007}}, 
     Function[Null, 
      Internal`LocalizedBlock[{$CellContext`k12, $CellContext`k23, \
$CellContext`t}, #], {HoldAll}]]& ],
   Editable->False,
   SelectWithContents->True,
   Selectable->True], TraditionalForm]], "Output",
 CellChangeTimes->{3.5872006690831156`*^9, 3.587200957080722*^9, 
  3.642762374313429*^9, 3.643526052323023*^9, 3.6506081335996685`*^9},
 CellLabel->"Out[76]="]
}, Open  ]],

Cell["Get the unformatted array of values from the table:", "Text",
 CellID->535944438],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vals", "=", 
  RowBox[{"nlm", "[", "\"\<ParameterTableEntries\>\"", "]"}]}]], "Input",
 CellLabel->"In[77]:=",
 CellID->361997482],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.8656394548271342`", "0.0008841174527270859`", "979.1000643150344`", 
      "6.1575853410996614`*^-24"},
     {"0.008425346222049672`", "0.00010444801235999972`", 
      "80.66545290503117`", "3.501280791817839`*^-14"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.540009231775687*^9, 3.540536933613347*^9, 
  3.5872010129833117`*^9, 3.6427623745477924`*^9, 3.6435260526355276`*^9, 
  3.6506081338496885`*^9},
 ImageSize->{557, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[77]="]
}, Open  ]],

Cell[TextData[{
 "Add formatting using ",
 Cell[BoxData[
  ButtonBox["Grid",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Grid"]], "InlineFormula"],
 ":"
}], "Text",
 CellID->451302564],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"\"\<\>\"", ",", 
         OverscriptBox["\[Beta]", "^"], ",", 
         OverscriptBox["\[Sigma]", "^"], ",", "t", ",", 
         RowBox[{"P", "[", 
          RowBox[{
           RowBox[{"Abs", "[", "T", "]"}], ">", 
           RowBox[{"Abs", "[", "t", "]"}]}], "]"}]}], "}"}], "}"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "a", "}"}], ",", 
          RowBox[{"{", "b", "}"}]}], "}"}], ",", "vals", ",", "2"}], "]"}]}], 
     "]"}], ",", 
    RowBox[{"Dividers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"GrayLevel", "[", ".5", "]"}], ",", 
       RowBox[{"GrayLevel", "[", ".5", "]"}]}], "}"}]}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[78]:=",
 CellID->577829150],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"\<\"\"\>", 
      OverscriptBox["\[Beta]", "^"], 
      OverscriptBox["\[Sigma]", "^"], "t", 
      RowBox[{"P", "(", 
       RowBox[{
        TemplateBox[{"T"},
         "Abs"], ">", 
        TemplateBox[{"t"},
         "Abs"]}], ")"}]},
     {"a", "0.8656394548271342`", "0.0008841174527270859`", 
      "979.1000643150344`", "6.1575853410996614`*^-24"},
     {"b", "0.008425346222049672`", "0.00010444801235999972`", 
      "80.66545290503117`", "3.501280791817839`*^-14"}
    },
    AutoDelete->False,
    GridBoxDividers->{"Columns" -> {{
         GrayLevel[0.5]}}, "Rows" -> {{
         GrayLevel[0.5]}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 CellChangeTimes->{3.54000924469781*^9, 3.5405369337227244`*^9, 
  3.58720101316533*^9, 3.6427623745634203`*^9, 3.6435260526667747`*^9, 
  3.6506081338652964`*^9},
 ImageSize->{244, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[78]//TraditionalForm="]
}, Open  ]],

Cell["\<\
Obtain tabular results for mean and single-prediction confidence intervals:\
\>", "Text",
 CellID->940638944],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nlm", "[", 
  RowBox[{"{", 
   RowBox[{
   "\"\<MeanPredictionConfidenceIntervalTable\>\"", ",", 
    "\"\<SinglePredictionConfidenceIntervalTable\>\""}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[79]:=",
 CellID->555829438],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    StyleBox[
     TagBox[GridBox[{
        {"\<\"Observed\"\>", "\<\"Predicted\"\>", "\<\"Standard Error\"\>", "\
\<\"Confidence Interval\"\>"},
        {"0.002`", "0.`", "0.`", 
         RowBox[{"{", 
          RowBox[{"0.`", ",", "0.`"}], "}"}]},
        {"0.106`", "0.10525436140631268`", "0.0004915527717239466`", 
         RowBox[{"{", 
          RowBox[{"0.10414239178286405`", ",", "0.10636633102976131`"}], 
          "}"}]},
        {"0.077`", "0.0773753333091796`", "0.0008222422421424726`", 
         RowBox[{"{", 
          RowBox[{"0.07551529213156176`", ",", "0.07923537448679745`"}], 
          "}"}]},
        {"0.056`", "0.057036494306726956`", "0.0006132488154197165`", 
         RowBox[{"{", 
          RowBox[{"0.05564922910634773`", ",", "0.05842375950710618`"}], 
          "}"}]},
        {"0.041`", "0.04205163907410693`", "0.0005113879806893482`", 
         RowBox[{"{", 
          RowBox[{"0.04089479909062161`", ",", "0.04320847905759225`"}], 
          "}"}]},
        {"0.032`", "0.031004056393936035`", "0.0007038845482910739`", 
         RowBox[{"{", 
          RowBox[{"0.029411758921236403`", ",", "0.03259635386663567`"}], 
          "}"}]},
        {"0.023`", "0.022858853365957835`", "0.0005288693843786959`", 
         RowBox[{"{", 
          RowBox[{"0.021662467699900892`", ",", "0.02405523903201478`"}], 
          "}"}]},
        {"0.018`", "0.016853512250224644`", "0.00031726820463410794`", 
         RowBox[{"{", 
          RowBox[{"0.01613580170858347`", ",", "0.017571222791865817`"}], 
          "}"}]},
        {"0.011`", "0.012425860875024529`", "0.00025966746986852407`", 
         RowBox[{"{", 
          RowBox[{"0.01183845224811576`", ",", "0.013013269501933298`"}], 
          "}"}]},
        {"0.011`", "0.009161436413861825`", "0.0004135283828551483`", 
         RowBox[{"{", 
          RowBox[{"0.008225970220565693`", ",", "0.010096902607157957`"}], 
          "}"}]},
        {"0.007`", "0.006754613223281421`", "0.0007694194064607539`", 
         RowBox[{"{", 
          RowBox[{"0.005014065601760283`", ",", "0.00849516084480256`"}], 
          "}"}]}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "Columns" -> {{False}}, "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "Columns" -> {{Automatic}}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False], ",", 
    StyleBox[
     TagBox[GridBox[{
        {"\<\"Observed\"\>", "\<\"Predicted\"\>", "\<\"Standard Error\"\>", "\
\<\"Confidence Interval\"\>"},
        {"0.002`", "0.`", "0.0012770185485460079`", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.002888816656619519`"}], ",", 
           "0.002888816656619519`"}], "}"}]},
        {"0.106`", "0.10525436140631268`", "0.0013683568616117826`", 
         RowBox[{"{", 
          RowBox[{"0.10215892313055351`", ",", "0.10834979968207185`"}], 
          "}"}]},
        {"0.077`", "0.0773753333091796`", "0.0015188346447503867`", 
         RowBox[{"{", 
          RowBox[{"0.07393949063845145`", ",", "0.08081117597990775`"}], 
          "}"}]},
        {"0.056`", "0.057036494306726956`", "0.0014166335033960755`", 
         RowBox[{"{", 
          RowBox[{"0.05383184667995961`", ",", "0.0602411419334943`"}], "}"}]},
        {"0.041`", "0.04205163907410693`", "0.0013756067897928107`", 
         RowBox[{"{", 
          RowBox[{"0.03893980032138328`", ",", "0.045163477826830584`"}], 
          "}"}]},
        {"0.032`", "0.031004056393936035`", "0.0014581597411304022`", 
         RowBox[{"{", 
          RowBox[{"0.02770546989103392`", ",", "0.034302642896838154`"}], 
          "}"}]},
        {"0.023`", "0.022858853365957835`", "0.001382200853372495`", 
         RowBox[{"{", 
          RowBox[{"0.019732097805075455`", ",", "0.025985608926840216`"}], 
          "}"}]},
        {"0.018`", "0.016853512250224644`", "0.0013158402209243732`", 
         RowBox[{"{", 
          RowBox[{"0.0138768748693626`", ",", "0.019830149631086688`"}], 
          "}"}]},
        {"0.011`", "0.012425860875024529`", "0.0013031513988169116`", 
         RowBox[{"{", 
          RowBox[{"0.009477927603980352`", ",", "0.015373794146068705`"}], 
          "}"}]},
        {"0.011`", "0.009161436413861825`", "0.0013423047704442337`", 
         RowBox[{"{", 
          RowBox[{"0.006124932062743202`", ",", "0.012197940764980448`"}], 
          "}"}]},
        {"0.007`", "0.006754613223281421`", "0.0014908999283550091`", 
         RowBox[{"{", 
          RowBox[{"0.0033819632713378064`", ",", "0.010127263175225035`"}], 
          "}"}]}
       },
       AutoDelete->False,
       GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
       GridBoxDividers->{
        "Columns" -> {{False}}, "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       GridBoxSpacings->{
        "Columns" -> {{Automatic}}, "RowsIndexed" -> {2 -> 0.75}}],
      "Grid"], "DialogStyle",
     StripOnInput->False]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.540009360715663*^9, 3.5405370014740252`*^9, 
  3.5872010531233253`*^9, 3.64276237478218*^9, 3.643526052932401*^9, 
  3.650608134084058*^9},
 ImageSize->{326, 433},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[79]="]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.587198282733062*^9},
 CellLabel->"In[80]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 7", "SubsubsectionIcon",
 CellChangeTimes->{{3.4798257578293734`*^9, 3.479825761830679*^9}, {
  3.587198291864975*^9, 3.5871982928490734`*^9}}],

Cell[BoxData[
 RowBox[{"ClearAll", "[", 
  RowBox[{
  "iodine", ",", " ", "x1", ",", " ", "x2", ",", "x3", ",", " ", "nlm"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4798257556724195`*^9, 3.479825764284604*^9}},
 CellLabel->"In[81]:="],

Cell["\<\
In the iodine model it is supposed a constant rate input = 0.1 uds/day  in \
compartment 1  \
\>", "Text"],

Cell["The retention in each compartment can be obtained as usual ", \
"MathCaption"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x1", "[", "t1_", "]"}], ",", 
     RowBox[{"x2", "[", "t1_", "]"}], ",", " ", 
     RowBox[{"x3", "[", "t1_", "]"}]}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{"Last", ",", 
     RowBox[{"SystemDSolve", "[", 
      RowBox[{
       RowBox[{"CompartMatrix", "[", 
        RowBox[{"3", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", " ", "0.8316"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "1.9404"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3", ",", "0.0086625"}], "}"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "0", ",", "0.01155"}], "}"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "0.0462"}], "}"}]}], "}"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.1", ",", " ", "0", ",", " ", "0"}], "}"}], ",", "t", ",", 
       "t1", ",", " ", "x"}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[82]:="],

Cell["\<\
Now we simulate the experimental measured for different times in compartment \
2 and 3. An random noise it is included\
\>", "MathCaption"],

Cell["\<\
sample1=Table[{t,1./100 \
Round[100*(x2[t]+Random[NormalDistribution[0,0.1]])]},{t,10,300,10}];\
\>", "SmallText"],

Cell["\<\
sample2=Table[{t,  1./100 Round[100*(x3[t]+Random[NormalDistribution[0, \
0.1]])]},{t, 6, 300, 14}];\
\>", "SmallText"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"10", ",", "0.22"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "0.58"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"30", ",", "0.92"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"40", ",", "1.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "1.38"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"60", ",", "1.65"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"70", ",", "1.69"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"80", ",", "1.76"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"90", ",", "2.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "2.15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"110", ",", "2.25"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"120", ",", "2.44"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"130", ",", "2.75"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"140", ",", "2.81"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"150", ",", "2.86"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"160", ",", "2.84"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"170", ",", "3.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"180", ",", "2.99"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"190", ",", "3.18"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"200", ",", "3.36"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"210", ",", "3.34"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"220", ",", "3.39"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230", ",", "3.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"240", ",", "3.51"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"250", ",", "3.64"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"260", ",", "3.55"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"270", ",", "3.87"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"280", ",", "3.81"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"290", ",", "3.77"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "3.85"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[83]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "0.09"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "0.04"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"34", ",", "0.07"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"48", ",", "0.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"62", ",", "0.04"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"76", ",", "0.16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"90", ",", "0.17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"104", ",", "0.24"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"118", ",", "0.33"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"132", ",", "0.47"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"146", ",", "0.39"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"160", ",", "0.39"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"174", ",", "0.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"188", ",", "0.33"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"202", ",", "0.32"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"216", ",", "0.26"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230", ",", "0.76"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"244", ",", "0.52"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"258", ",", "0.46"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"272", ",", "0.47"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"286", ",", "0.47"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "0.43"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[84]:="],

Cell["\<\
Now we suppose that rate transfer coeffs k12 and k23 are unknown. Its can be  \
estimated  using experimental data of x2(t) and x3(t) \
\>", "MathCaption"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"modelIodine", "[", 
    RowBox[{"t1_", ",", 
     RowBox[{"k12_", "?", "NumberQ"}], ",", " ", 
     RowBox[{"k23_", "?", "NumberQ"}]}], "]"}], ":=", " ", "\n", " ", 
   RowBox[{
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{
       SubscriptBox["x", "2"], "[", "t1", "]"}], ",", " ", 
      RowBox[{
       SubscriptBox["x", "3"], "[", "t1", "]"}]}], "}"}], "/.", 
    RowBox[{"SystemDSolve", "[", 
     RowBox[{
      RowBox[{"CompartMatrix", "[", 
       RowBox[{"3", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "k12"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "1.9404"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "k23"}], " ", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "0", ",", "0.01155"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "1", ",", "0.0462"}], "}"}]}], " ", "}"}]}], 
       "]"}], " ", ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0.1", ",", " ", "0", ",", " ", "0"}], "}"}], " ", ",", "t", 
      ",", "t1", ",", "x"}], "]"}]}]}], ";"}]], "Input",
 CellLabel->"In[85]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"X2", "[", 
   RowBox[{"t1_", ",", 
    RowBox[{"k12_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"k23_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"modelIodine", "[", 
    RowBox[{"t1", ",", "k12", ",", " ", "k23"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellLabel->"In[86]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"X3", "[", 
   RowBox[{"t1_", ",", 
    RowBox[{"k12_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"k23_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"modelIodine", "[", 
    RowBox[{"t1", ",", "k12", ",", " ", "k23"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellLabel->"In[87]:="],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fittedparameters", " ", "=", "  ", 
  RowBox[{"FindMinimum", "[", 
   RowBox[{
    RowBox[{"X2Fit", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k12", ",", " ", "k23"}], "}"}], ",", "sample1", ",", 
      RowBox[{"X2", "[", 
       RowBox[{"t1", ",", "k12", ",", "k23"}], "]"}], ",", "  ", "sample2", 
      ",", 
      RowBox[{"X3", "[", 
       RowBox[{"t1", ",", "k12", ",", "k23"}], "]"}], ",", " ", "t1"}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{"k12", ",", "0.5", ",", "1"}], " ", "}"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"k23", ",", "0.02", ",", "0.3"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[88]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"0.5080068971962683`", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k12", "\[Rule]", "0.8308214733833567`"}], ",", 
      RowBox[{"k23", "\[Rule]", "0.008558329510403969`"}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990289663501263`*^9, 3.4798172290242653`*^9, 
  3.479825800687107*^9, 3.4798264106837063`*^9, 3.480243015079623*^9, 
  3.519442702262164*^9, 3.5399260443368015`*^9, 3.540538647896261*^9, 
  3.6427623764071817`*^9, 3.6435260546042824`*^9, 3.6506081356777954`*^9},
 CellLabel->"Out[88]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{
     RowBox[{"modelIodine", "[", 
      RowBox[{"t", ",", "k12", ",", " ", "k23"}], "]"}], "/.", 
     RowBox[{"fittedparameters", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"t", ",", " ", "0", ",", " ", "300"}], "}"}], ",", " ", 
   RowBox[{"Epilog", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", "0.3", "]"}], ",", " ", 
        RowBox[{"PointSize", "[", "0.02", "]"}], ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Point", ",", " ", "sample1"}], " ", "]"}]}], " ", "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", "0", "]"}], ",", " ", 
        RowBox[{"PointSize", "[", "0.02", "]"}], ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Point", ",", " ", "sample2"}], " ", "]"}]}], " ", "}"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[89]:="],

Cell[BoxData[
 FormBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVkns0lHkAhj+3lMt8Nh3bZkmXjZNu65bcfu8hJV2WMGQiuRWaZnxmlShq
KRpmGbdqaopZl4YuUrmVlEhbJLtEJSopijYpTaKt95z3POf94/nvnRPI2xii
TFGU97d+Zzn7y4ehM10O1PcEx9qPZdnfchdVEKquZaerhSWZLN4aYSi6RSg3
A45E7EHqnMSKFPn9b7uI3xUcTJTLo66qih4QytpXk+7kE6e5XvvjI7sJVdrZ
V3hoN7nhIpm7V/6UUAHmahEHEohqZVz/WNpLQu1r8C57lEIKeFyXS/GDhHrc
z7boEJFVxv5yJnKIUAOclOTPGWTlndkV0fJ3hGqIaqaQS5JslGLfpY0Rqnfk
rrlOHmHnKExbpyhIwqYU/2Z+Plkw8u7x2fjPJOFUj8S7TUYaTz9z2BE5QRIe
FxyzzC0kiVqB+6PkSqBOm4xL55WShlgn5+E0dVAXivXaJeUk5Hiw/E3aj6hb
v7pntOomiVmhPJEkNIFRmQYtbmwnro0V9VdtzdBr49F2YKSHvA7bk3hb1xrn
h73WnqvrI8OZTl754Q4wmekeqqgcIMOVZzRzFzoC9uaz1ywaJnqvrwictjgj
YVt0dk/oO+IyS8z5lOiCyTR+hl32e8KTsWoOCtZCb5/2mxmHP5BbPFF+rGwD
jqe1cAKzxojGHV+lX1rccLPJ6MO6MAW5tNmdr+O0EW3VWRmW88eJ4s818849
8IBVpp1n9cgXYs3PFtu4e+HYDKGjuniS0CPPnGMG2VDTueGQPYdCBKNrbRfn
gz55rt3AEIUbJ3P7X49sgtXuZw2bC5RQttOga0MKB30Bfk96g5UhGfx4SKrq
B62YsOwXOiowmNq2J++kP4K6Vo7b3FTB9Oku7KyfAsAvepLB5aoi86Pb+pb2
AKimeZT4q6mht8S3/2neVgwLz9QMyNRQslzUHREQiJaeqDG22RRUOJqPLtcP
Qm/O4ajByilIN+wq7X4RhIC30tBoZ3W8bC2uV+QHY1cAv6OsXh3TPGPi3vJC
oCSRJHuvnoqd7BpP4xWh4HT29Ijqp8J9qbGwfTQUbbFOX2eaT8PXzswgv7pt
OPWD/pukomkw3bTwGGffdpg1rlDR19HAUR+z/yTWYVD5W3BliNHAPya2ry4p
h6P2Uuq/pg81ILzHdVh1LRy7y03pPitN0KvzrM4LIyAd/3hNmqsJnezJ1HTX
HSBJsuSkYU14BTYrl6txcZdDC/OghRDqxKxzrVwUap6Q++VoYUSQkz5HtBOf
7Gfu3/JcC+ur04u5HB4+2Xb0ys21ISCTb/dO50NMwn/jxmtDSfu2TQKfD/XW
Q4Lf67Ux6pjF5nXwER0jbRJosLAgWJB31DISU1NbjOxcWVCs1P7SJ45E4b34
p/EHWTATFRobfIrEZb6uDdPAgvyG54F0NoOmqMSBzxMsXLj+K6x8GHzZfEI2
MslCVR1r8tEmBpLGlxaDX1loqm2KMfZjsGzCtLtTicaLarvI2iAGS14tdr6o
RsOofH7AGz6DI0ff7w7SppEjG7V3ETJwbDaVyn6mIc2/Pz6UykDKhKzNMaBR
kHe2KlPEYEZ6QWuyIY2LJ7db9mQw0ErxCOIa0bgvebwo+giDLpGh3GI+Da2s
m/p/FTBYarOkvsaUxozMvK41RQx8lj1/X7KIhr54X+7bYubbf9UnJItpLEy3
1rUtZVCnXXkkdikNl9RSjbYLDJqTeR+tzWm4CVOadl1k8HSd12tjCxreh0MP
GlxmsGD7k0o9SxqhyUbKYVXffPFo93srGtxDE9dYNQyO5Ygsny2nITj4cO/F
KwxqHr4IabWmEZdUYetby+B6B8WrXUHjj8QsxddrDCyU+t1KbWj8D2JzfXI=

      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwtzQk01I8WB/BfipCsLeLYK0kbf5WouTdKwz89PKZBpLH8JRp+PLLEWCqF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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Epilog->{{
      Hue[0.3], 
      PointSize[0.02], {
       PointBox[{10, 0.22}], 
       PointBox[{20, 0.58}], 
       PointBox[{30, 0.92}], 
       PointBox[{40, 1.01}], 
       PointBox[{50, 1.38}], 
       PointBox[{60, 1.65}], 
       PointBox[{70, 1.69}], 
       PointBox[{80, 1.76}], 
       PointBox[{90, 2.11}], 
       PointBox[{100, 2.15}], 
       PointBox[{110, 2.25}], 
       PointBox[{120, 2.44}], 
       PointBox[{130, 2.75}], 
       PointBox[{140, 2.81}], 
       PointBox[{150, 2.86}], 
       PointBox[{160, 2.84}], 
       PointBox[{170, 3.01}], 
       PointBox[{180, 2.99}], 
       PointBox[{190, 3.18}], 
       PointBox[{200, 3.36}], 
       PointBox[{210, 3.34}], 
       PointBox[{220, 3.39}], 
       PointBox[{230, 3.7}], 
       PointBox[{240, 3.51}], 
       PointBox[{250, 3.64}], 
       PointBox[{260, 3.55}], 
       PointBox[{270, 3.87}], 
       PointBox[{280, 3.81}], 
       PointBox[{290, 3.77}], 
       PointBox[{300, 3.85}]}}, {
      Hue[0], 
      PointSize[0.02], {
       PointBox[{6, 0.09}], 
       PointBox[{20, 0.04}], 
       PointBox[{34, 0.07}], 
       PointBox[{48, 0.11}], 
       PointBox[{62, 0.04}], 
       PointBox[{76, 0.16}], 
       PointBox[{90, 0.17}], 
       PointBox[{104, 0.24}], 
       PointBox[{118, 0.33}], 
       PointBox[{132, 0.47}], 
       PointBox[{146, 0.39}], 
       PointBox[{160, 0.39}], 
       PointBox[{174, 0.4}], 
       PointBox[{188, 0.33}], 
       PointBox[{202, 0.32}], 
       PointBox[{216, 0.26}], 
       PointBox[{230, 0.76}], 
       PointBox[{244, 0.52}], 
       PointBox[{258, 0.46}], 
       PointBox[{272, 0.47}], 
       PointBox[{286, 0.47}], 
       PointBox[{300, 0.43}]}}},
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 300}, {0., 3.9036489792053093`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}], TraditionalForm]], "Output",
 CellChangeTimes->{3.3990289665059385`*^9, 3.4798172291492624`*^9, 
  3.4798258008590384`*^9, 3.479826410824318*^9, 3.480243015204423*^9, 
  3.519442702418417*^9, 3.539926044477429*^9, 3.540538648021263*^9, 
  3.6427623764540567`*^9, 3.6435260546511574`*^9, 3.6506081357402954`*^9},
 CellLabel->"Out[89]="]
}, Open  ]],

Cell["\<\
Here is the same example considering the experimental uncertainties\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample1a", " ", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Append", "[", 
       RowBox[{"#", ",", "0.03"}], "]"}], "&"}], ",", "sample1"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[90]:="],

Cell["Here it  is assumed a random uncertainty", "Text"],

Cell["\<\
sample2a =Map[Append[#,Abs[Round[100 Random[NormalDistribution[0, \
0.1]]]]/100.]&,sample2]\
\>", "SmallText"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample2a", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "0.09", ",", "0.13"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "0.04", ",", "0.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"34", ",", "0.07", ",", "0.04"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"48", ",", "0.11", ",", "0.05"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"62", ",", "0.04", ",", "0.09"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"76", ",", "0.16", ",", "0.13"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"90", ",", "0.17", ",", "0.09"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"104", ",", "0.24", ",", "0.15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"118", ",", "0.33", ",", "0.07"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"132", ",", "0.47", ",", "0.04"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"146", ",", "0.39", ",", "0.08"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"160", ",", "0.39", ",", "0.06"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"174", ",", "0.4", ",", "0.12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"188", ",", "0.33", ",", "0.13"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"202", ",", "0.32", ",", "0.02"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"216", ",", "0.26", ",", "0.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230", ",", "0.76", ",", "0.03"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"244", ",", "0.52", ",", "0.04"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"258", ",", "0.46", ",", "0.08"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"272", ",", "0.47", ",", "0.16"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"286", ",", "0.47", ",", "0.09"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "0.43", ",", "0.15"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellLabel->"In[91]:="],

Cell["\<\
We simulate the experimental measured in compartment 2 and 3 for different \
times  A random noise it is included\
\>", "MathCaption"],

Cell[TextData[{
 "Now, it is obtained the best fit for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "12"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["k", "23"], TraditionalForm]]],
 "  "
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fittedparameters", " ", "=", "  ", 
  RowBox[{"FindMinimum", "[", 
   RowBox[{
    RowBox[{"X2FitE", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k12", ",", " ", "k23"}], "}"}], ",", "sample1a", ",", 
      RowBox[{"X2", "[", 
       RowBox[{"t1", ",", "k12", ",", "k23"}], "]"}], ",", "  ", "sample2a", 
      ",", 
      RowBox[{"X3", "[", 
       RowBox[{"t1", ",", "k12", ",", "k23"}], "]"}], ",", " ", "t1"}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{"k12", ",", "0.5", ",", "1"}], " ", "}"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"k23", ",", "0.02", ",", "0.3"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[92]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"424.0422236859326`", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k12", "\[Rule]", "0.8725751227506218`"}], ",", 
      RowBox[{"k23", "\[Rule]", "0.009191831469369756`"}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.399028980108326*^9, 3.479817237195983*^9, 
  3.479825822189003*^9, 3.479826418542327*^9, 3.480243019634823*^9, 
  3.5194427085435348`*^9, 3.539926048180625*^9, 3.5405386514588294`*^9, 
  3.6427623783759236`*^9, 3.643526056651165*^9, 3.6506081375684214`*^9},
 CellLabel->"Out[92]="]
}, Open  ]],

Cell[TextData[{
 " ",
 StyleBox["NMinimize", "Input"],
 " can be used to establish some restrictions in the parameters, ex: ",
 StyleBox["NMinimize[{X2FitE[{k12, k23},sample1a,X2[t1,k12,k23],  \
sample2a,X3[t1,k12,k23], t1], 0<k12\[LessEqual]1},{k12,k23}]", "Input"],
 " , but it  will usually take a long time."
}], "Text"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", 
  RowBox[{
  "iodine", ",", " ", "x1", ",", " ", "x2", ",", "x3", ",", " ", "tt", ",", 
   " ", "X1", ",", "X2", " ", ",", "sample1", ",", "sample2", ",", "sample1a",
    ",", "sample2b", ",", " ", "fittedparameters"}], "]"}]], "Input",
 CellLabel->"In[93]:="]
}, Closed]],

Cell[CellGroupData[{

Cell["Example 8", "SubsubsectionIcon",
 CellChangeTimes->{{3.5871982965684457`*^9, 3.5871982976555543`*^9}}],

Cell[TextData[{
 "Here it is supposed an  input (unknown), ",
 StyleBox["inp",
  FontSlant->"Italic"],
 ",   in the compartment 1 in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"t", "=", " ", "0"}], TraditionalForm]]],
 " in the iodine model. Experimental measured for different times are taken \
in compartment 2 and 3. "
}], "Text"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"{", " ", 
     RowBox[{
      RowBox[{"x2", "[", 
       RowBox[{"inp_", ",", "t1_"}], "]"}], ",", " ", 
      RowBox[{"x3", "[", 
       RowBox[{"inp_", ",", "t1_"}], "]"}]}], "}"}], "=", " ", "\n", " ", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        SubscriptBox["x", "2"], "[", "t1", "]"}], ",", " ", 
       RowBox[{
        SubscriptBox["x", "3"], "[", "t1", "]"}]}], "}"}], "/.", 
     RowBox[{"SystemDSolve", "[", 
      RowBox[{
       RowBox[{"CompartMatrix", "[", 
        RowBox[{"3", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", " ", "0.8316"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "1.9404"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3", ",", "0.0086625"}], "}"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "0", ",", "0.01155"}], "}"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "0.0462"}], "}"}]}], "}"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"inp", ",", " ", "0", ",", " ", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", "t", ",", 
       "t1", ",", " ", "x"}], "]"}]}]}], ";"}]}]], "Input",
 CellLabel->"In[94]:="],

Cell["\<\
The  \"experimental\" measured for different times in compartment 2 and 3 \
including their uncertainties are. It has already simulated assuming an input \
of 13500 including a normal \"noise\" N(0, 100).  \
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "4092", ",", "64"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "3701", ",", "95"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "3529", ",", "90"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "2762", ",", "63"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"90", ",", "2123", ",", "61"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"120", ",", "1736", ",", "61"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"180", ",", "1304", ",", "74"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"300", ",", "736", ",", "88"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"360", ",", "418", ",", "99"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"420", ",", "358", ",", "70"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"600", ",", "132", ",", "58"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellLabel->"In[95]:="],

Cell[BoxData[
 RowBox[{
  RowBox[{"sample3", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "123", ",", "52"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"27", ",", "418", ",", "66"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"48", ",", "333", ",", "66"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"72", ",", "272", ",", "68"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"180", ",", "193", ",", "80"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"360", ",", "147", ",", "65"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"450", ",", "145", ",", "98"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"520", ",", "142", ",", "68"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellLabel->"In[96]:="],

Cell["Finally we obtain the input fitting the data", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MLFit", "[", 
  RowBox[{"sample2", ",", 
   RowBox[{"x2", "[", 
    RowBox[{"1", ",", "t"}], "]"}], ",", "sample3", ",", 
   RowBox[{"x3", "[", 
    RowBox[{"1", ",", "t"}], "]"}], ",", "t"}], "]"}]], "Input",
 CellLabel->"In[97]:="],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\<\"Mean\"\>", "\[Rule]", "13422.503068066031`"}], ",", 
    RowBox[{"\<\"s\"\>", "\[Rule]", "124.66508787074285`"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.3990289802173944`*^9, 3.479817237305356*^9, 
  3.4798258223452606`*^9, 3.4798264186516914`*^9, 3.480243019853223*^9, 
  3.519442710840454*^9, 3.539926048321253*^9, 3.540538676178054*^9, 
  3.642762378422797*^9, 3.643526056698053*^9, 3.650608137646547*^9},
 CellLabel->"Out[97]="]
}, Open  ]],

Cell[TextData[{
 "We can used",
 StyleBox[" MLFitLog", "Input"],
 ", however in this case the solution is not so good because the experimental \
data has been generated assuming a Normal distribution"
}], "Text"],

Cell["\<\
Map[{#,x2[13500,#]+Random[NormalDistribution[0,100]],Random[Integer,{50,100}]}\
&,{2,7,18,50,90,120,180,300,360,420,600}] has been the expression used to \
obtain sample2 data. \
\>", "SmallText"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"Brackets",
WindowToolbars->"EditBar",
WindowSize->{1672, 934},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PageFooters->{{Inherited, 
   Cell[
    TextData[{"\[Copyright]2003 Guillermo Sanchez. All rights reserved."}], 
    "PageFooter"], Inherited}, {Inherited, 
   Cell[
    TextData[{"\[Copyright]2003 Guillermo Sanchez. All rights reserved."}], 
    "PageFooter"], Inherited}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "S3.8.2"->{
  Cell[8425, 256, 1628, 50, 34, "Commentary",
   CellTags->"S3.8.2"],
  Cell[10056, 308, 2110, 65, 34, "Commentary",
   CellTags->"S3.8.2"]},
 "eq 2"->{
  Cell[67001, 2195, 1857, 70, 140, "NumberedEquation",
   CellTags->"eq 2"]},
 "FindFit"->{
  Cell[75143, 2450, 496, 15, 30, "Input",
   CellTags->"FindFit"],
  Cell[75642, 2467, 609, 13, 32, "Output",
   CellTags->"FindFit"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"S3.8.2", 315910, 8108},
 {"eq 2", 316063, 8113},
 {"FindFit", 316155, 8116}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 32, 0, 108, "Chapter"],
Cell[602, 24, 416, 11, 28, "Text"],
Cell[1021, 37, 663, 9, 34, "Commentary"],
Cell[1687, 48, 57, 0, 27, "Text"],
Cell[CellGroupData[{
Cell[1769, 52, 57, 1, 30, "Input"],
Cell[1829, 55, 520, 9, 29, "Output"]
}, Open  ]],
Cell[2364, 67, 746, 23, 57, "Commentary"],
Cell[CellGroupData[{
Cell[3135, 94, 43, 0, 28, "SubsubsectionIcon"],
Cell[3181, 96, 42, 0, 27, "Text"],
Cell[3226, 98, 132, 3, 30, "Input",
 InitializationCell->True],
Cell[3361, 103, 132, 3, 30, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3530, 111, 56, 0, 46, "SubsectionIcon"],
Cell[CellGroupData[{
Cell[3611, 115, 92, 2, 30, "Input"],
Cell[3706, 119, 3635, 100, 91, "Print"]
}, Open  ]],
Cell[7356, 222, 805, 23, 47, "Text"],
Cell[8164, 247, 258, 7, 27, "Text"],
Cell[8425, 256, 1628, 50, 34, "Commentary",
 CellTags->"S3.8.2"],
Cell[10056, 308, 2110, 65, 34, "Commentary",
 CellTags->"S3.8.2"],
Cell[12169, 375, 1058, 42, 47, "Text"],
Cell[13230, 419, 1378, 56, 49, "DefinitionBox"],
Cell[14611, 477, 807, 32, 32, "Text"],
Cell[15421, 511, 1245, 55, 49, "DefinitionBox"],
Cell[16669, 568, 731, 29, 54, "Text"],
Cell[17403, 599, 1054, 39, 103, "NumberedEquation"],
Cell[18460, 640, 880, 38, 48, "DefinitionBox"],
Cell[19343, 680, 134, 4, 54, "Text"],
Cell[19480, 686, 997, 36, 77, "NumberedEquation"],
Cell[20480, 724, 346, 11, 27, "Text"],
Cell[20829, 737, 21, 0, 27, "Text"],
Cell[20853, 739, 327, 14, 58, "NumberedEquation"],
Cell[21183, 755, 68, 0, 27, "Text"],
Cell[21254, 757, 918, 38, 48, "DefinitionBox"],
Cell[22175, 797, 195, 5, 27, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[22407, 807, 48, 0, 32, "SubsectionIcon"],
Cell[CellGroupData[{
Cell[22480, 811, 38, 0, 28, "SubsubsectionIcon"],
Cell[22521, 813, 902, 32, 48, "Text"],
Cell[23426, 847, 12184, 500, 247, 10577, 471, "GraphicsData", "PostScript", \
"Graphics"],
Cell[35613, 1349, 429, 12, 27, "Text"],
Cell[36045, 1363, 860, 27, 30, "Input"],
Cell[36908, 1392, 325, 11, 27, "Text"],
Cell[37236, 1405, 124, 3, 27, "Text"],
Cell[CellGroupData[{
Cell[37385, 1412, 422, 13, 30, "Input"],
Cell[37810, 1427, 1073, 27, 48, "Output"]
}, Open  ]],
Cell[38898, 1457, 268, 6, 27, "Text"],
Cell[39169, 1465, 401, 13, 30, "Input"],
Cell[39573, 1480, 449, 15, 28, "Text"],
Cell[40025, 1497, 203, 8, 27, "Text"],
Cell[CellGroupData[{
Cell[40253, 1509, 548, 15, 30, "Input"],
Cell[40804, 1526, 4586, 98, 55, "Output"]
}, Open  ]],
Cell[45405, 1627, 350, 13, 27, "Text",
 CellID->1038950848],
Cell[CellGroupData[{
Cell[45780, 1644, 236, 7, 30, "Input",
 CellID->155132550],
Cell[46019, 1653, 694, 16, 32, "Output"]
}, Open  ]],
Cell[46728, 1672, 254, 8, 27, "Text",
 CellID->897306512],
Cell[CellGroupData[{
Cell[47007, 1684, 167, 3, 30, "Input"],
Cell[47177, 1689, 2397, 41, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49611, 1735, 287, 8, 30, "Input",
 CellID->1400377950],
Cell[49901, 1745, 2189, 47, 116, "Output"]
}, Open  ]],
Cell[52105, 1795, 266, 5, 27, "Text"],
Cell[52374, 1802, 85, 2, 27, "Text"],
Cell[CellGroupData[{
Cell[52484, 1808, 520, 15, 30, "Input"],
Cell[53007, 1825, 4660, 96, 301, "Output"]
}, Open  ]],
Cell[57682, 1924, 217, 5, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[57936, 1934, 38, 0, 22, "SubsubsectionIcon"],
Cell[57977, 1936, 913, 30, 54, "Text"],
Cell[58893, 1968, 525, 17, 30, "Input"],
Cell[59421, 1987, 934, 29, 30, "Input"],
Cell[CellGroupData[{
Cell[60380, 2020, 433, 14, 30, "Input"],
Cell[60816, 2036, 503, 11, 29, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61356, 2052, 648, 20, 30, "Input"],
Cell[62007, 2074, 4402, 94, 295, "Output"]
}, Open  ]],
Cell[66424, 2171, 139, 3, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[66600, 2179, 38, 0, 22, "SubsubsectionIcon"],
Cell[66641, 2181, 357, 12, 27, "Text"],
Cell[67001, 2195, 1857, 70, 140, "NumberedEquation",
 CellTags->"eq 2"],
Cell[68861, 2267, 767, 25, 46, "Text"],
Cell[69631, 2294, 3225, 93, 97, "Input"],
Cell[CellGroupData[{
Cell[72881, 2391, 206, 5, 30, "Input"],
Cell[73090, 2398, 1898, 42, 296, "Output"]
}, Open  ]],
Cell[75003, 2443, 115, 3, 27, "Text"],
Cell[CellGroupData[{
Cell[75143, 2450, 496, 15, 30, "Input",
 CellTags->"FindFit"],
Cell[75642, 2467, 609, 13, 32, "Output",
 CellTags->"FindFit"]
}, Open  ]],
Cell[76266, 2483, 85, 2, 27, "Text"],
Cell[CellGroupData[{
Cell[76376, 2489, 378, 11, 30, "Input"],
Cell[76757, 2502, 24597, 436, 301, "Output"]
}, Open  ]],
Cell[101369, 2941, 705, 29, 27, "Text"],
Cell[102077, 2972, 2479, 73, 75, "Input"],
Cell[104559, 3047, 183, 6, 27, "Text"],
Cell[104745, 3055, 156, 5, 30, "Input"],
Cell[104904, 3062, 113, 3, 27, "Text"],
Cell[105020, 3067, 1298, 38, 51, "Input"],
Cell[106321, 3107, 165, 6, 27, "Text"],
Cell[106489, 3115, 249, 9, 50, "Input"],
Cell[106741, 3126, 243, 10, 29, "Text"],
Cell[106987, 3138, 313, 9, 30, "Input"],
Cell[107303, 3149, 203, 6, 30, "Input"],
Cell[107509, 3157, 374, 15, 27, "Text"],
Cell[107886, 3174, 45, 1, 27, "Text"],
Cell[107934, 3177, 992, 37, 27, "Text"],
Cell[108929, 3216, 416, 12, 30, "Input"],
Cell[109348, 3230, 412, 15, 27, "Text"],
Cell[109763, 3247, 458, 13, 30, "Input"],
Cell[CellGroupData[{
Cell[110246, 3264, 363, 10, 30, "Input"],
Cell[110612, 3276, 517, 11, 29, "Output"]
}, Open  ]],
Cell[111144, 3290, 114, 4, 28, "Text"],
Cell[CellGroupData[{
Cell[111283, 3298, 788, 22, 30, "Input"],
Cell[112074, 3322, 11516, 254, 308, "Output"]
}, Open  ]],
Cell[123605, 3579, 100, 2, 27, "Text"],
Cell[123708, 3583, 135, 3, 30, "Input"],
Cell[123846, 3588, 45, 1, 27, "Text"],
Cell[123894, 3591, 314, 11, 31, "Text"],
Cell[124211, 3604, 1382, 39, 53, "Input"],
Cell[125596, 3645, 203, 6, 26, "SmallText"],
Cell[125802, 3653, 84, 4, 28, "Text"],
Cell[CellGroupData[{
Cell[125911, 3661, 315, 9, 30, "Input"],
Cell[126229, 3672, 591, 13, 29, "Output"]
}, Open  ]],
Cell[126835, 3688, 146, 4, 28, "Text"],
Cell[126984, 3694, 90, 2, 30, "Input"],
Cell[127077, 3698, 45, 1, 27, "Text"],
Cell[127125, 3701, 101, 4, 28, "Text"],
Cell[127229, 3707, 809, 23, 30, "Input"],
Cell[CellGroupData[{
Cell[128063, 3734, 488, 14, 30, "Input"],
Cell[128554, 3750, 587, 13, 29, "Output"]
}, Open  ]],
Cell[129156, 3766, 115, 2, 27, "Text"],
Cell[129274, 3770, 310, 9, 29, "Text"],
Cell[CellGroupData[{
Cell[129609, 3783, 624, 14, 30, "Input"],
Cell[130236, 3799, 18872, 350, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[149145, 4154, 634, 17, 30, "Input"],
Cell[149782, 4173, 691, 14, 29, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150510, 4192, 369, 10, 30, "Input"],
Cell[150882, 4204, 19567, 357, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[170486, 4566, 867, 19, 30, "Input"],
Cell[171356, 4587, 13295, 261, 101, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184688, 4853, 121, 3, 30, "Input",
 CellID->402834626],
Cell[184812, 4858, 1031, 23, 74, "Output"]
}, Open  ]],
Cell[185858, 4884, 153, 4, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[186048, 4893, 38, 0, 22, "SubsubsectionIcon"],
Cell[186089, 4895, 409, 18, 29, "Text"],
Cell[186501, 4915, 823, 23, 30, "Input"],
Cell[187327, 4940, 1080, 32, 53, "Input"],
Cell[CellGroupData[{
Cell[188432, 4976, 634, 17, 30, "Input"],
Cell[189069, 4995, 750, 16, 29, "Output"]
}, Open  ]],
Cell[189834, 5014, 228, 6, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[190099, 5025, 38, 0, 22, "SubsubsectionIcon"],
Cell[190140, 5027, 509, 12, 27, "Text"],
Cell[190652, 5041, 453, 11, 46, "Text"],
Cell[191108, 5054, 314, 11, 27, "Text"],
Cell[191425, 5067, 885, 27, 30, "Input"],
Cell[192313, 5096, 70, 0, 27, "Text"],
Cell[192386, 5098, 769, 24, 32, "Input"],
Cell[193158, 5124, 188, 4, 27, "Text"],
Cell[193349, 5130, 61, 0, 27, "Text"],
Cell[193413, 5132, 1289, 35, 53, "Input"],
Cell[CellGroupData[{
Cell[194727, 5171, 616, 17, 30, "Input"],
Cell[195346, 5190, 1281, 32, 54, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[196664, 5227, 820, 18, 30, "Input"],
Cell[197487, 5247, 4107, 78, 294, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[201631, 5330, 120, 3, 30, "Input",
 CellID->36276479],
Cell[201754, 5335, 1155, 26, 76, "Output"]
}, Open  ]],
Cell[202924, 5364, 160, 6, 27, "Text",
 CellID->291349166],
Cell[CellGroupData[{
Cell[203109, 5374, 127, 3, 30, "Input",
 CellID->777746701],
Cell[203239, 5379, 418, 11, 29, "Output"]
}, Open  ]],
Cell[203672, 5393, 86, 1, 27, "Text",
 CellID->20497461],
Cell[CellGroupData[{
Cell[203783, 5398, 154, 4, 30, "Input",
 CellID->180129011],
Cell[203940, 5404, 1022, 25, 54, "Output"]
}, Open  ]],
Cell[204977, 5432, 189, 8, 27, "Text",
 CellID->263543578],
Cell[CellGroupData[{
Cell[205191, 5444, 940, 29, 37, "Input",
 CellID->24106869],
Cell[206134, 5475, 1071, 29, 107, "Output"]
}, Open  ]],
Cell[207220, 5507, 196, 8, 27, "Text",
 CellID->89020743],
Cell[CellGroupData[{
Cell[207441, 5519, 621, 19, 37, "Input",
 CellID->55686520],
Cell[208065, 5540, 2055, 57, 97, "Output"]
}, Open  ]],
Cell[210135, 5600, 118, 3, 27, "Text",
 CellID->49202953],
Cell[CellGroupData[{
Cell[210278, 5607, 249, 8, 30, "Input",
 CellID->491356887],
Cell[210530, 5617, 5542, 123, 287, "Output"]
}, Open  ]],
Cell[216087, 5743, 86, 1, 27, "Text",
 CellID->44936140],
Cell[CellGroupData[{
Cell[216198, 5748, 145, 4, 30, "Input",
 CellID->314491289],
Cell[216346, 5754, 1411, 32, 228, "Output"]
}, Open  ]],
Cell[217772, 5789, 633, 10, 46, "Text"],
Cell[218408, 5801, 107, 2, 30, "Input"],
Cell[218518, 5805, 712, 20, 30, "Input"],
Cell[219233, 5827, 390, 12, 30, "Input"],
Cell[219626, 5841, 390, 12, 30, "Input"],
Cell[220019, 5855, 198, 3, 27, "Text",
 CellID->253370914],
Cell[220220, 5860, 660, 19, 30, "Input",
 CellID->427663384],
Cell[220883, 5881, 560, 16, 30, "Input"],
Cell[CellGroupData[{
Cell[221468, 5901, 1608, 39, 30, "Input"],
Cell[223079, 5942, 7028, 123, 294, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[230156, 6071, 106, 1, 22, "SubsubsectionIcon"],
Cell[230265, 6074, 141, 1, 27, "Text"],
Cell[230409, 6077, 885, 27, 30, "Input"],
Cell[231297, 6106, 70, 0, 27, "Text"],
Cell[231370, 6108, 769, 24, 32, "Input"],
Cell[CellGroupData[{
Cell[232164, 6136, 1174, 31, 53, "Input"],
Cell[233341, 6169, 18830, 349, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252208, 6523, 533, 13, 30, "Input"],
Cell[252744, 6538, 19667, 358, 81, "Output"]
}, Open  ]],
Cell[272426, 6899, 1942, 35, 30, "Input"],
Cell[274371, 6936, 563, 16, 30, "Input"],
Cell[CellGroupData[{
Cell[274959, 6956, 1118, 22, 30, "Input"],
Cell[276080, 6980, 1131, 30, 54, "Output"]
}, Open  ]],
Cell[277226, 7013, 87, 1, 27, "Text",
 CellID->535944438],
Cell[CellGroupData[{
Cell[277338, 7018, 154, 4, 30, "Input",
 CellID->361997482],
Cell[277495, 7024, 1026, 25, 54, "Output"]
}, Open  ]],
Cell[278536, 7052, 189, 8, 27, "Text",
 CellID->451302564],
Cell[CellGroupData[{
Cell[278750, 7064, 941, 29, 37, "Input",
 CellID->577829150],
Cell[279694, 7095, 1072, 29, 107, "Output"]
}, Open  ]],
Cell[280781, 7127, 119, 3, 27, "Text",
 CellID->940638944],
Cell[CellGroupData[{
Cell[280925, 7134, 249, 8, 30, "Input",
 CellID->555829438],
Cell[281177, 7144, 5560, 125, 287, "Output"]
}, Open  ]],
Cell[286752, 7272, 111, 2, 53, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[286900, 7279, 157, 2, 22, "SubsubsectionIcon"],
Cell[287060, 7283, 237, 6, 30, "Input"],
Cell[287300, 7291, 116, 3, 27, "Text"],
Cell[287419, 7296, 84, 1, 47, "MathCaption"],
Cell[287506, 7299, 1187, 32, 53, "Input"],
Cell[288696, 7333, 149, 3, 47, "MathCaption"],
Cell[288848, 7338, 124, 3, 24, "SmallText"],
Cell[288975, 7343, 129, 3, 24, "SmallText"],
Cell[289107, 7348, 2156, 65, 75, "Input"],
Cell[291266, 7415, 1613, 49, 53, "Input"],
Cell[292882, 7466, 165, 3, 47, "MathCaption"],
Cell[293050, 7471, 1316, 36, 53, "Input"],
Cell[294369, 7509, 348, 10, 30, "Input"],
Cell[294720, 7521, 348, 10, 30, "Input"],
Cell[CellGroupData[{
Cell[295093, 7535, 666, 18, 30, "Input"],
Cell[295762, 7555, 592, 13, 29, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[296391, 7573, 1012, 28, 53, "Input"],
Cell[297406, 7603, 7740, 170, 295, "Output"]
}, Open  ]],
Cell[305161, 7776, 91, 2, 27, "Text"],
Cell[305255, 7780, 257, 9, 30, "Input"],
Cell[305515, 7791, 56, 0, 27, "Text"],
Cell[305574, 7793, 120, 3, 24, "SmallText"],
Cell[305697, 7798, 1908, 50, 75, "Input"],
Cell[307608, 7850, 144, 3, 47, "MathCaption"],
Cell[307755, 7855, 240, 10, 47, "MathCaption"],
Cell[CellGroupData[{
Cell[308020, 7869, 669, 18, 30, "Input"],
Cell[308692, 7889, 585, 13, 29, "Output"]
}, Open  ]],
Cell[309292, 7905, 324, 7, 47, "Text"],
Cell[309619, 7914, 301, 6, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[309957, 7925, 108, 1, 22, "SubsubsectionIcon"],
Cell[310068, 7928, 330, 10, 27, "Text"],
Cell[310401, 7940, 1403, 39, 53, "Input"],
Cell[311807, 7981, 230, 4, 27, "Text"],
Cell[312040, 7987, 987, 28, 53, "Input"],
Cell[313030, 8017, 748, 22, 30, "Input"],
Cell[313781, 8041, 60, 0, 27, "Text"],
Cell[CellGroupData[{
Cell[313866, 8045, 257, 7, 30, "Input"],
Cell[314126, 8054, 524, 11, 29, "Output"]
}, Open  ]],
Cell[314665, 8068, 212, 5, 28, "Text"],
Cell[314880, 8075, 206, 4, 24, "SmallText"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
